/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/arrays","vs/base/common/uri","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/color","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(X){for(var t=[],v=0,i=X.length;v<i;v++)t[v]=me[X[v]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function _t(X){if(Array.isArray(X)){for(var t=0,v=Array(X.length);t<X.length;t++)v[t]=X[t];return v}else return Array.from(X)}var $t=Object.hasOwnProperty,Lt=Object.setPrototypeOf,jt=Object.isFrozen,Kt=Object.getPrototypeOf,Vt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,qt=Object.create,It=typeof Reflect<"u"&&Reflect,vt=It.apply,Et=It.construct;vt||(vt=function(t,v,i){return t.apply(v,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,v){return new(Function.prototype.bind.apply(t,[null].concat(_t(v))))});var Gt=nt(Array.prototype.forEach),Mt=nt(Array.prototype.pop),bt=nt(Array.prototype.push),ht=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Yt=nt(String.prototype.indexOf),Xt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Zt(TypeError);function nt(X){return function(t){for(var v=arguments.length,i=Array(v>1?v-1:0),U=1;U<v;U++)i[U-1]=arguments[U];return vt(X,t,i)}}function Zt(X){return function(){for(var t=arguments.length,v=Array(t),i=0;i<t;i++)v[i]=arguments[i];return Et(X,v)}}function He(X,t){Lt&&Lt(X,null);for(var v=t.length;v--;){var i=t[v];if(typeof i=="string"){var U=ht(i);U!==i&&(jt(t)||(t[v]=U),i=U)}X[i]=!0}return X}function ut(X){var t=qt(null),v=void 0;for(v in X)vt($t,X,[v])&&(t[v]=X[v]);return t}function Dt(X,t){for(;X!==null;){var v=Vt(X,t);if(v){if(v.get)return nt(v.get);if(typeof v.value=="function")return nt(v.value)}X=Kt(X)}function i(U){return console.warn("fallback value for",U),null}return i}var Ot=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ct=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),At=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Qt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Jt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=et(["#text"]),Ht=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),kt=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ut=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),xt=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ei=ot(/<%[\s\S]*|[\s\S]*%>/gm),ti=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ii=ot(/^aria-[\-\w]+$/),ni=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),si=ot(/^(?:\w+script|data):/i),ri=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(X){return typeof X}:function(X){return X&&typeof Symbol=="function"&&X.constructor===Symbol&&X!==Symbol.prototype?"symbol":typeof X};function rt(X){if(Array.isArray(X)){for(var t=0,v=Array(X.length);t<X.length;t++)v[t]=X[t];return v}else return Array.from(X)}var oi=function(){return typeof window>"u"?null:window},ai=function(t,v){if((typeof t>"u"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,U="data-tt-policy-suffix";v.currentScript&&v.currentScript.hasAttribute(U)&&(i=v.currentScript.getAttribute(U));var H="dompurify"+(i?"#"+i:"");try{return t.createPolicy(H,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Wt(){var X=arguments.length>0&&arguments[0]!==void 0?arguments[0]:oi(),t=function(ne){return Wt(ne)};if(t.version="2.3.1",t.removed=[],!X||!X.document||X.document.nodeType!==9)return t.isSupported=!1,t;var v=X.document,i=X.document,U=X.DocumentFragment,H=X.HTMLTemplateElement,y=X.Node,w=X.Element,f=X.NodeFilter,g=X.NamedNodeMap,d=g===void 0?X.NamedNodeMap||X.MozNamedAttrMap:g,M=X.Text,o=X.Comment,n=X.DOMParser,e=X.trustedTypes,s=w.prototype,l=Dt(s,"cloneNode"),a=Dt(s,"nextSibling"),c=Dt(s,"childNodes"),r=Dt(s,"parentNode");if(typeof H=="function"){var h=i.createElement("template");h.content&&h.content.ownerDocument&&(i=h.content.ownerDocument)}var b=ai(e,v),A=b&&G?b.createHTML(""):"",L=i,N=L.implementation,F=L.createNodeIterator,u=L.createDocumentFragment,C=L.getElementsByTagName,p=v.importNode,D={};try{D=ut(i).documentMode?i.documentMode:{}}catch{}var _={};t.isSupported=typeof r=="function"&&N&&typeof N.createHTMLDocument<"u"&&D!==9;var V=xt,ee=ei,Z=ti,pe=ii,oe=si,ce=ri,ae=ni,de=null,Se=He({},[].concat(rt(Ot),rt(Ct),rt(At),rt(St),rt(Bt))),x=null,ye=He({},[].concat(rt(Ht),rt(kt),rt(Ut),rt(yt))),ie=null,J=null,he=!0,fe=!0,le=!1,te=!1,T=!1,E=!1,m=!1,B=!1,z=!1,$=!0,G=!1,k=!0,O=!0,W=!1,S={},I=null,P=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),R=null,j=He({},["audio","video","img","source","image","track"]),Q=null,re=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ue="http://www.w3.org/1998/Math/MathML",De="http://www.w3.org/2000/svg",Ee="http://www.w3.org/1999/xhtml",Ie=Ee,ke=!1,ve=null,Pe=i.createElement("form"),Re=function(ne){ve&&ve===ne||((!ne||(typeof ne>"u"?"undefined":pt(ne))!=="object")&&(ne={}),ne=ut(ne),de="ALLOWED_TAGS"in ne?He({},ne.ALLOWED_TAGS):Se,x="ALLOWED_ATTR"in ne?He({},ne.ALLOWED_ATTR):ye,Q="ADD_URI_SAFE_ATTR"in ne?He(ut(re),ne.ADD_URI_SAFE_ATTR):re,R="ADD_DATA_URI_TAGS"in ne?He(ut(j),ne.ADD_DATA_URI_TAGS):j,I="FORBID_CONTENTS"in ne?He({},ne.FORBID_CONTENTS):P,ie="FORBID_TAGS"in ne?He({},ne.FORBID_TAGS):{},J="FORBID_ATTR"in ne?He({},ne.FORBID_ATTR):{},S="USE_PROFILES"in ne?ne.USE_PROFILES:!1,he=ne.ALLOW_ARIA_ATTR!==!1,fe=ne.ALLOW_DATA_ATTR!==!1,le=ne.ALLOW_UNKNOWN_PROTOCOLS||!1,te=ne.SAFE_FOR_TEMPLATES||!1,T=ne.WHOLE_DOCUMENT||!1,B=ne.RETURN_DOM||!1,z=ne.RETURN_DOM_FRAGMENT||!1,$=ne.RETURN_DOM_IMPORT!==!1,G=ne.RETURN_TRUSTED_TYPE||!1,m=ne.FORCE_BODY||!1,k=ne.SANITIZE_DOM!==!1,O=ne.KEEP_CONTENT!==!1,W=ne.IN_PLACE||!1,ae=ne.ALLOWED_URI_REGEXP||ae,Ie=ne.NAMESPACE||Ee,te&&(fe=!1),z&&(B=!0),S&&(de=He({},[].concat(rt(Bt))),x=[],S.html===!0&&(He(de,Ot),He(x,Ht)),S.svg===!0&&(He(de,Ct),He(x,kt),He(x,yt)),S.svgFilters===!0&&(He(de,At),He(x,kt),He(x,yt)),S.mathMl===!0&&(He(de,St),He(x,Ut),He(x,yt))),ne.ADD_TAGS&&(de===Se&&(de=ut(de)),He(de,ne.ADD_TAGS)),ne.ADD_ATTR&&(x===ye&&(x=ut(x)),He(x,ne.ADD_ATTR)),ne.ADD_URI_SAFE_ATTR&&He(Q,ne.ADD_URI_SAFE_ATTR),ne.FORBID_CONTENTS&&(I===P&&(I=ut(I)),He(I,ne.FORBID_CONTENTS)),O&&(de["#text"]=!0),T&&He(de,["html","head","body"]),de.table&&(He(de,["tbody"]),delete ie.tbody),et&&et(ne),ve=ne)},je=He({},["mi","mo","mn","ms","mtext"]),Ue=He({},["foreignobject","desc","title","annotation-xml"]),ze=He({},Ct);He(ze,At),He(ze,Qt);var xe=He({},St);He(xe,Jt);var it=function(ne){var Ae=r(ne);(!Ae||!Ae.tagName)&&(Ae={namespaceURI:Ee,tagName:"template"});var Le=ht(ne.tagName),We=ht(Ae.tagName);if(ne.namespaceURI===De)return Ae.namespaceURI===Ee?Le==="svg":Ae.namespaceURI===ue?Le==="svg"&&(We==="annotation-xml"||je[We]):Boolean(ze[Le]);if(ne.namespaceURI===ue)return Ae.namespaceURI===Ee?Le==="math":Ae.namespaceURI===De?Le==="math"&&Ue[We]:Boolean(xe[Le]);if(ne.namespaceURI===Ee){if(Ae.namespaceURI===De&&!Ue[We]||Ae.namespaceURI===ue&&!je[We])return!1;var Ge=He({},["title","style","font","a","script"]);return!xe[Le]&&(Ge[Le]||!ze[Le])}return!1},Be=function(ne){bt(t.removed,{element:ne});try{ne.parentNode.removeChild(ne)}catch{try{ne.outerHTML=A}catch{ne.remove()}}},Ve=function(ne,Ae){try{bt(t.removed,{attribute:Ae.getAttributeNode(ne),from:Ae})}catch{bt(t.removed,{attribute:null,from:Ae})}if(Ae.removeAttribute(ne),ne==="is"&&!x[ne])if(B||z)try{Be(Ae)}catch{}else try{Ae.setAttribute(ne,"")}catch{}},Ye=function(ne){var Ae=void 0,Le=void 0;if(m)ne="<remove></remove>"+ne;else{var We=Pt(ne,/^[\r\n\t ]+/);Le=We&&We[0]}var Ge=b?b.createHTML(ne):ne;if(Ie===Ee)try{Ae=new n().parseFromString(Ge,"text/html")}catch{}if(!Ae||!Ae.documentElement){Ae=N.createDocument(Ie,"template",null);try{Ae.documentElement.innerHTML=ke?"":Ge}catch{}}var Ze=Ae.body||Ae.documentElement;return ne&&Le&&Ze.insertBefore(i.createTextNode(Le),Ze.childNodes[0]||null),Ie===Ee?C.call(Ae,T?"html":"body")[0]:T?Ae.documentElement:Ze},K=function(ne){return F.call(ne.ownerDocument||ne,ne,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},se=function(ne){return ne instanceof M||ne instanceof o?!1:typeof ne.nodeName!="string"||typeof ne.textContent!="string"||typeof ne.removeChild!="function"||!(ne.attributes instanceof d)||typeof ne.removeAttribute!="function"||typeof ne.setAttribute!="function"||typeof ne.namespaceURI!="string"||typeof ne.insertBefore!="function"},we=function(ne){return(typeof y>"u"?"undefined":pt(y))==="object"?ne instanceof y:ne&&(typeof ne>"u"?"undefined":pt(ne))==="object"&&typeof ne.nodeType=="number"&&typeof ne.nodeName=="string"},Ce=function(ne,Ae,Le){!_[ne]||Gt(_[ne],function(We){We.call(t,Ae,Le,ve)})},Fe=function(ne){var Ae=void 0;if(Ce("beforeSanitizeElements",ne,null),se(ne)||Pt(ne.nodeName,/[\u0080-\uFFFF]/))return Be(ne),!0;var Le=ht(ne.nodeName);if(Ce("uponSanitizeElement",ne,{tagName:Le,allowedTags:de}),!we(ne.firstElementChild)&&(!we(ne.content)||!we(ne.content.firstElementChild))&&at(/<[/\w]/g,ne.innerHTML)&&at(/<[/\w]/g,ne.textContent)||Le==="select"&&at(/<template/i,ne.innerHTML))return Be(ne),!0;if(!de[Le]||ie[Le]){if(O&&!I[Le]){var We=r(ne)||ne.parentNode,Ge=c(ne)||ne.childNodes;if(Ge&&We)for(var Ze=Ge.length,Qe=Ze-1;Qe>=0;--Qe)We.insertBefore(l(Ge[Qe],!0),a(ne))}return Be(ne),!0}return ne instanceof w&&!it(ne)||(Le==="noscript"||Le==="noembed")&&at(/<\/no(script|embed)/i,ne.innerHTML)?(Be(ne),!0):(te&&ne.nodeType===3&&(Ae=ne.textContent,Ae=lt(Ae,V," "),Ae=lt(Ae,ee," "),ne.textContent!==Ae&&(bt(t.removed,{element:ne.cloneNode()}),ne.textContent=Ae)),Ce("afterSanitizeElements",ne,null),!1)},Oe=function(ne,Ae,Le){if(k&&(Ae==="id"||Ae==="name")&&(Le in i||Le in Pe))return!1;if(!(fe&&!J[Ae]&&at(Z,Ae))){if(!(he&&at(pe,Ae))){if(!x[Ae]||J[Ae])return!1;if(!Q[Ae]){if(!at(ae,lt(Le,ce,""))){if(!((Ae==="src"||Ae==="xlink:href"||Ae==="href")&&ne!=="script"&&Yt(Le,"data:")===0&&R[ne])){if(!(le&&!at(oe,lt(Le,ce,"")))){if(Le)return!1}}}}}}return!0},$e=function(ne){var Ae=void 0,Le=void 0,We=void 0,Ge=void 0;Ce("beforeSanitizeAttributes",ne,null);var Ze=ne.attributes;if(!!Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:x};for(Ge=Ze.length;Ge--;){Ae=Ze[Ge];var st=Ae,ct=st.name,dt=st.namespaceURI;if(Le=Xt(Ae.value),We=ht(ct),Qe.attrName=We,Qe.attrValue=Le,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ce("uponSanitizeAttribute",ne,Qe),Le=Qe.attrValue,!Qe.forceKeepAttr&&(Ve(ct,ne),!!Qe.keepAttr)){if(at(/\/>/i,Le)){Ve(ct,ne);continue}te&&(Le=lt(Le,V," "),Le=lt(Le,ee," "));var Ft=ne.nodeName.toLowerCase();if(!!Oe(Ft,We,Le))try{dt?ne.setAttributeNS(dt,ct,Le):ne.setAttribute(ct,Le),Mt(t.removed)}catch{}}}Ce("afterSanitizeAttributes",ne,null)}},tt=function Me(ne){var Ae=void 0,Le=K(ne);for(Ce("beforeSanitizeShadowDOM",ne,null);Ae=Le.nextNode();)Ce("uponSanitizeShadowNode",Ae,null),!Fe(Ae)&&(Ae.content instanceof U&&Me(Ae.content),$e(Ae));Ce("afterSanitizeShadowDOM",ne,null)};return t.sanitize=function(Me,ne){var Ae=void 0,Le=void 0,We=void 0,Ge=void 0,Ze=void 0;if(ke=!Me,ke&&(Me="<!-->"),typeof Me!="string"&&!we(Me)){if(typeof Me.toString!="function")throw Rt("toString is not a function");if(Me=Me.toString(),typeof Me!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(X.toStaticHTML)==="object"||typeof X.toStaticHTML=="function"){if(typeof Me=="string")return X.toStaticHTML(Me);if(we(Me))return X.toStaticHTML(Me.outerHTML)}return Me}if(E||Re(ne),t.removed=[],typeof Me=="string"&&(W=!1),!W)if(Me instanceof y)Ae=Ye("<!---->"),Le=Ae.ownerDocument.importNode(Me,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?Ae=Le:Ae.appendChild(Le);else{if(!B&&!te&&!T&&Me.indexOf("<")===-1)return b&&G?b.createHTML(Me):Me;if(Ae=Ye(Me),!Ae)return B?null:A}Ae&&m&&Be(Ae.firstChild);for(var Qe=K(W?Me:Ae);We=Qe.nextNode();)We.nodeType===3&&We===Ge||Fe(We)||(We.content instanceof U&&tt(We.content),$e(We),Ge=We);if(Ge=null,W)return Me;if(B){if(z)for(Ze=u.call(Ae.ownerDocument);Ae.firstChild;)Ze.appendChild(Ae.firstChild);else Ze=Ae;return $&&(Ze=p.call(v,Ze,!0)),Ze}var st=T?Ae.outerHTML:Ae.innerHTML;return te&&(st=lt(st,V," "),st=lt(st,ee," ")),b&&G?b.createHTML(st):st},t.setConfig=function(Me){Re(Me),E=!0},t.clearConfig=function(){ve=null,E=!1},t.isValidAttribute=function(Me,ne,Ae){ve||Re({});var Le=ht(Me),We=ht(ne);return Oe(Le,We,Ae)},t.addHook=function(Me,ne){typeof ne=="function"&&(_[Me]=_[Me]||[],bt(_[Me],ne))},t.removeHook=function(Me){_[Me]&&Mt(_[Me])},t.removeHooks=function(Me){_[Me]&&(_[Me]=[])},t.removeAllHooks=function(){_={}},t}var li=Wt();define("vs/base/browser/dompurify/dompurify",function(){return li}),define(me[39],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class v{constructor(y){this.domNode=y,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.A="",this.B=!1,this.C="none",this.D=""}setMaxWidth(y){const w=i(y);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(y){const w=i(y);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(y){const w=i(y);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(y){const w=i(y);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(y){const w=i(y);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(y){const w=i(y);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(y){const w=i(y);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(y){const w=i(y);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(y){const w=i(y);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(y){const w=i(y);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(y){const w=i(y);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(y){this.l!==y&&(this.l=y,this.domNode.style.fontFamily=this.l)}setFontWeight(y){this.m!==y&&(this.m=y,this.domNode.style.fontWeight=this.m)}setFontSize(y){const w=i(y);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(y){this.o!==y&&(this.o=y,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(y){this.p!==y&&(this.p=y,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(y){this.q!==y&&(this.q=y,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(y){this.r!==y&&(this.r=y,this.domNode.style.textDecoration=this.r)}setLineHeight(y){const w=i(y);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(y){const w=i(y);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(y){this.u!==y&&(this.u=y,this.domNode.className=this.u)}toggleClassName(y,w){this.domNode.classList.toggle(y,w),this.u=this.domNode.className}setDisplay(y){this.v!==y&&(this.v=y,this.domNode.style.display=this.v)}setPosition(y){this.w!==y&&(this.w=y,this.domNode.style.position=this.w)}setVisibility(y){this.x!==y&&(this.x=y,this.domNode.style.visibility=this.x)}setColor(y){this.y!==y&&(this.y=y,this.domNode.style.color=this.y)}setBackgroundColor(y){this.A!==y&&(this.A=y,this.domNode.style.backgroundColor=this.A)}setLayerHinting(y){this.B!==y&&(this.B=y,this.domNode.style.transform=this.B?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this.D!==y&&(this.D=y,this.domNode.style.boxShadow=y)}setContain(y){this.C!==y&&(this.C=y,this.domNode.style.contain=this.C)}setAttribute(y,w){this.domNode.setAttribute(y,w)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=v;function i(H){return typeof H=="number"?`${H}px`:H}function U(H){return new v(H)}t.createFastDomNode=U}),define(me[67],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let v=!1,i=null;function U(y){if(!y.parent||y.parent===y)return null;try{const w=y.location,f=y.parent.location;if(w.origin!=="null"&&f.origin!=="null"&&w.origin!==f.origin)return v=!0,null}catch{return v=!0,null}return y.parent}class H{static getSameOriginWindowChain(){if(!i){i=[];let w=window,f;do f=U(w),f?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=f;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(w,f){if(!f||w===f)return{top:0,left:0};let g=0,d=0;const M=this.getSameOriginWindowChain();for(const o of M){if(g+=o.window.scrollY,d+=o.window.scrollX,o.window===f||!o.iframeElement)break;const n=o.iframeElement.getBoundingClientRect();g+=n.top,d+=n.left}return{top:g,left:d}}}t.IframeUtils=H}),define(me[68],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var v;(function(H){H[H.Copy=0]="Copy",H[H.Move=1]="Move"})(v=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,w){super(`ListError [${y}] ${w}`)}}t.ListError=i;class U{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,w){w>0&&this.c.set(y,w)}}t.CachedListVirtualDelegate=U}),define(me[69],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class v{constructor(U){this.a=U}splice(U,H,y){this.a.forEach(w=>w.splice(U,H,y))}}t.CombinedSpliceable=v}),define(me[40],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const v=20;class i{constructor(H,y,w,f,g,d){this.a=Math.round(y),this.b=Math.round(w),this.c=Math.round(H),this.d=f,this.e=g,this.f=d,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new i(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const y=Math.round(H);return this.d!==y?(this.d=y,this.m(),!0):!1}setScrollSize(H){const y=Math.round(H);return this.e!==y?(this.e=y,this.m(),!0):!1}setScrollPosition(H){const y=Math.round(H);return this.f!==y?(this.f=y,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,y,w,f,g){const d=Math.max(0,w-H),M=Math.max(0,d-2*y),o=f>0&&f>w;if(!o)return{computedAvailableSize:Math.round(d),computedIsNeeded:o,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(v,Math.floor(w*M/f))),e=(M-n)/(f-w),s=g*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:o,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=i.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const y=H-this.c-this.i/2;return Math.round(y/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const y=H-this.c;let w=this.f;return y<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const y=this.k+H;return Math.round(y/this.j)}}t.ScrollbarState=i}),define(me[23],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var v;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(v=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var U;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(U=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class H extends Error{constructor(f,g){super(`TreeError [${f}] ${g}`)}}t.TreeError=H;class y{constructor(f){this.a=f,this.b=new WeakMap}map(f){let g=this.b.get(f);return g||(g=this.a(f),this.b.set(f,g)),g}}t.WeakMapper=y}),define(me[12],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.Codicon=t.getCodiconAriaLabel=void 0;function v(H){return H?H.replace(/\$\((.*?)\)/g,(y,w)=>` ${w} `).trim():""}t.getCodiconAriaLabel=v;class i{constructor(y,w,f){this.id=y,this.definition=w,this.description=f,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}t.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var U;(function(H){H.iconNameSegment="[A-Za-z0-9]+",H.iconNameExpression="[A-Za-z0-9-]+",H.iconModifierExpression="~[A-Za-z]+",H.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${H.iconNameExpression})(${H.iconModifierExpression})?$`);function w(d){if(d instanceof i)return["codicon","codicon-"+d.id];const M=y.exec(d.id);if(!M)return w(i.error);const[,o,n]=M,e=["codicon","codicon-"+o];return n&&e.push("codicon-modifier-"+n.substring(1)),e}H.asClassNameArray=w;function f(d){return w(d).join(" ")}H.asClassName=f;function g(d){return"."+w(d).join(".")}H.asCSSSelector=g})(U=t.CSSIcon||(t.CSSIcon={}))}),define(me[70],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function v(y,w){const f=Object.create(null);for(const g of y){const d=w(g);let M=f[d];M||(M=f[d]=[]),M.push(g)}return f}t.groupBy=v;function i(y,w){const f=[],g=[];for(const d of y)w.has(d)||f.push(d);for(const d of w)y.has(d)||g.push(d);return{removed:f,added:g}}t.diffSets=i;function U(y,w){const f=[],g=[];for(const[d,M]of y)w.has(d)||f.push(M);for(const[d,M]of w)y.has(d)||g.push(M);return{removed:f,added:g}}t.diffMaps=U;class H{constructor(){this.a=new Map}add(w,f){let g=this.a.get(w);g||(g=new Set,this.a.set(w,g)),g.add(f)}delete(w,f){const g=this.a.get(w);!g||(g.delete(f),g.size===0&&this.a.delete(w))}forEach(w,f){const g=this.a.get(w);!g||g.forEach(f)}}t.SetMap=H}),define(me[41],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function v(w,f){const g=Math.pow(10,f);return Math.round(w*g)/g}class i{constructor(f,g,d,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=v(Math.max(Math.min(1,M),0),3)}static equals(f,g){return f.r===g.r&&f.g===g.g&&f.b===g.b&&f.a===g.a}}t.RGBA=i;class U{constructor(f,g,d,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.l=v(Math.max(Math.min(1,d),0),3),this.a=v(Math.max(Math.min(1,M),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.l===g.l&&f.a===g.a}static fromRGBA(f){const g=f.r/255,d=f.g/255,M=f.b/255,o=f.a,n=Math.max(g,d,M),e=Math.min(g,d,M);let s=0,l=0;const a=(e+n)/2,c=n-e;if(c>0){switch(l=Math.min(a<=.5?c/(2*a):c/(2-2*a),1),n){case g:s=(d-M)/c+(d<M?6:0);break;case d:s=(M-g)/c+2;break;case M:s=(g-d)/c+4;break}s*=60,s=Math.round(s)}return new U(s,l,a,o)}static i(f,g,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?f+(g-f)*6*d:d<1/2?g:d<2/3?f+(g-f)*(2/3-d)*6:f}static toRGBA(f){const g=f.h/360,{s:d,l:M,a:o}=f;let n,e,s;if(d===0)n=e=s=M;else{const l=M<.5?M*(1+d):M+d-M*d,a=2*M-l;n=U.i(a,l,g+1/3),e=U.i(a,l,g),s=U.i(a,l,g-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(s*255),o)}}t.HSLA=U;class H{constructor(f,g,d,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.v=v(Math.max(Math.min(1,d),0),3),this.a=v(Math.max(Math.min(1,M),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.v===g.v&&f.a===g.a}static fromRGBA(f){const g=f.r/255,d=f.g/255,M=f.b/255,o=Math.max(g,d,M),n=Math.min(g,d,M),e=o-n,s=o===0?0:e/o;let l;return e===0?l=0:o===g?l=((d-M)/e%6+6)%6:o===d?l=(M-g)/e+2:l=(g-d)/e+4,new H(Math.round(l*60),s,o,f.a)}static toRGBA(f){const{h:g,s:d,v:M,a:o}=f,n=M*d,e=n*(1-Math.abs(g/60%2-1)),s=M-n;let[l,a,c]=[0,0,0];return g<60?(l=n,a=e):g<120?(l=e,a=n):g<180?(a=n,c=e):g<240?(a=e,c=n):g<300?(l=e,c=n):g<=360&&(l=n,c=e),l=Math.round((l+s)*255),a=Math.round((a+s)*255),c=Math.round((c+s)*255),new i(l,a,c,o)}}t.HSVA=H;class y{static fromHex(f){return y.Format.CSS.parseHex(f)||y.red}static equals(f,g){return!f&&!g?!0:!f||!g?!1:f.equals(g)}get hsla(){return this.i?this.i:U.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof i)this.rgba=f;else if(f instanceof U)this.i=f,this.rgba=U.toRGBA(f);else if(f instanceof H)this.j=f,this.rgba=H.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&i.equals(this.rgba,f.rgba)&&U.equals(this.hsla,f.hsla)&&H.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=y.k(this.rgba.r),g=y.k(this.rgba.g),d=y.k(this.rgba.b),M=.2126*f+.7152*g+.0722*d;return v(M,4)}static k(f){const g=f/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(f){const g=this.getRelativeLuminance(),d=f.getRelativeLuminance();return g>d?(g+.05)/(d+.05):(d+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const g=this.getRelativeLuminance(),d=f.getRelativeLuminance();return g>d}isDarkerThan(f){const g=this.getRelativeLuminance(),d=f.getRelativeLuminance();return g<d}lighten(f){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:g,g:d,b:M,a:o}=this.rgba;return new y(new i(g,d,M,o*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const g=f.rgba,d=this.rgba.a,M=g.a,o=d+M*(1-d);if(o<1e-6)return y.transparent;const n=this.rgba.r*d/o+g.r*M*(1-d)/o,e=this.rgba.g*d/o+g.g*M*(1-d)/o,s=this.rgba.b*d/o+g.b*M*(1-d)/o;return new y(new i(n,e,s,o))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:g,g:d,b:M,a:o}=this.rgba;return new y(new i(f.rgba.r-o*(f.rgba.r-g),f.rgba.g-o*(f.rgba.g-d),f.rgba.b-o*(f.rgba.b-M),1))}flatten(...f){const g=f.reduceRight((d,M)=>y.o(M,d));return y.o(this,g)}static o(f,g){const d=1-f.rgba.a;return new y(new i(d*g.rgba.r+f.rgba.a*f.rgba.r,d*g.rgba.g+f.rgba.a*f.rgba.g,d*g.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=y.Format.CSS.format(this)),this.u}static getLighterColor(f,g,d){if(f.isLighterThan(g))return f;d=d||.5;const M=f.getRelativeLuminance(),o=g.getRelativeLuminance();return d=d*(o-M)/o,f.lighten(d)}static getDarkerColor(f,g,d){if(f.isDarkerThan(g))return f;d=d||.5;const M=f.getRelativeLuminance(),o=g.getRelativeLuminance();return d=d*(M-o)/M,f.darken(d)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(w){let f;(function(g){let d;(function(M){function o(A){return A.rgba.a===1?`rgb(${A.rgba.r}, ${A.rgba.g}, ${A.rgba.b})`:w.Format.CSS.formatRGBA(A)}M.formatRGB=o;function n(A){return`rgba(${A.rgba.r}, ${A.rgba.g}, ${A.rgba.b}, ${+A.rgba.a.toFixed(2)})`}M.formatRGBA=n;function e(A){return A.hsla.a===1?`hsl(${A.hsla.h}, ${(A.hsla.s*100).toFixed(2)}%, ${(A.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(A)}M.formatHSL=e;function s(A){return`hsla(${A.hsla.h}, ${(A.hsla.s*100).toFixed(2)}%, ${(A.hsla.l*100).toFixed(2)}%, ${A.hsla.a.toFixed(2)})`}M.formatHSLA=s;function l(A){const L=A.toString(16);return L.length!==2?"0"+L:L}function a(A){return`#${l(A.rgba.r)}${l(A.rgba.g)}${l(A.rgba.b)}`}M.formatHex=a;function c(A,L=!1){return L&&A.rgba.a===1?w.Format.CSS.formatHex(A):`#${l(A.rgba.r)}${l(A.rgba.g)}${l(A.rgba.b)}${l(Math.round(A.rgba.a*255))}`}M.formatHexA=c;function r(A){return A.isOpaque()?w.Format.CSS.formatHex(A):w.Format.CSS.formatRGBA(A)}M.format=r;function h(A){const L=A.length;if(L===0||A.charCodeAt(0)!==35)return null;if(L===7){const N=16*b(A.charCodeAt(1))+b(A.charCodeAt(2)),F=16*b(A.charCodeAt(3))+b(A.charCodeAt(4)),u=16*b(A.charCodeAt(5))+b(A.charCodeAt(6));return new w(new i(N,F,u,1))}if(L===9){const N=16*b(A.charCodeAt(1))+b(A.charCodeAt(2)),F=16*b(A.charCodeAt(3))+b(A.charCodeAt(4)),u=16*b(A.charCodeAt(5))+b(A.charCodeAt(6)),C=16*b(A.charCodeAt(7))+b(A.charCodeAt(8));return new w(new i(N,F,u,C/255))}if(L===4){const N=b(A.charCodeAt(1)),F=b(A.charCodeAt(2)),u=b(A.charCodeAt(3));return new w(new i(16*N+N,16*F+F,16*u+u))}if(L===5){const N=b(A.charCodeAt(1)),F=b(A.charCodeAt(2)),u=b(A.charCodeAt(3)),C=b(A.charCodeAt(4));return new w(new i(16*N+N,16*F+F,16*u+u,(16*C+C)/255))}return null}M.parseHex=h;function b(A){switch(A){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=g.CSS||(g.CSS={}))})(f=w.Format||(w.Format={}))}(y=t.Color||(t.Color={}))}),define(me[24],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function v(y){return(w,f,g)=>{let d=null,M=null;if(typeof g.value=="function"?(d="value",M=g.value):typeof g.get=="function"&&(d="get",M=g.get),!M)throw new Error("not supported");g[d]=y(M,f)}}function i(y,w,f){let g=null,d=null;if(typeof f.value=="function"?(g="value",d=f.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(g="get",d=f.get),!d)throw new Error("not supported");const M=`$memoize$${w}`;f[g]=function(...o){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,o)}),this[M]}}t.memoize=i;function U(y,w,f){return v((g,d)=>{const M=`$debounce$${d}`,o=`$debounce$result$${d}`;return function(...n){this[o]||(this[o]=f?f():void 0),clearTimeout(this[M]),w&&(this[o]=w(this[o],...n),n=[this[o]]),this[M]=setTimeout(()=>{g.apply(this,n),this[o]=f?f():void 0},y)}})}t.debounce=U;function H(y,w,f){return v((g,d)=>{const M=`$throttle$timer$${d}`,o=`$throttle$result$${d}`,n=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...s){if(this[o]||(this[o]=f?f():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),w&&(this[o]=w(this[o],...s)),this[e])return;const l=this[n]+y;l<=Date.now()?(this[n]=Date.now(),g.apply(this,[this[o]]),this[o]=f?f():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),g.apply(this,[this[o]]),this[o]=f?f():void 0},l-Date.now()))}})}t.throttle=H}),define(me[71],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class v{constructor(U,H,y,w){this.originalStart=U,this.originalLength=H,this.modifiedStart=y,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=v}),define(me[9],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class v{constructor(){this.b=[],this.a=function(A){setTimeout(()=>{throw A.stack?r.isErrorNoTelemetry(A)?new r(A.message+`

`+A.stack):new Error(A.message+`

`+A.stack):A},0)}}addListener(A){return this.b.push(A),()=>{this.d(A)}}c(A){this.b.forEach(L=>{L(A)})}d(A){this.b.splice(this.b.indexOf(A),1)}setUnexpectedErrorHandler(A){this.a=A}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(A){this.a(A),this.c(A)}onUnexpectedExternalError(A){this.a(A)}}t.ErrorHandler=v,t.errorHandler=new v;function i(b){t.errorHandler.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=i;function U(b){f(b)||t.errorHandler.onUnexpectedError(b)}t.onUnexpectedError=U;function H(b){f(b)||t.errorHandler.onUnexpectedExternalError(b)}t.onUnexpectedExternalError=H;function y(b){if(b instanceof Error){const{name:A,message:L}=b,N=b.stacktrace||b.stack;return{$isError:!0,name:A,message:L,stack:N,noTelemetry:r.isErrorNoTelemetry(b)}}return b}t.transformErrorForSerialization=y;const w="Canceled";function f(b){return b instanceof g?!0:b instanceof Error&&b.name===w&&b.message===w}t.isCancellationError=f;class g extends Error{constructor(){super(w),this.name=this.message}}t.CancellationError=g;function d(){const b=new Error(w);return b.name=b.message,b}t.canceled=d;function M(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.illegalArgument=M;function o(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.illegalState=o;function n(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(b){const A=new Error(`${b} has been disposed`);return A.name="DISPOSED",A}t.disposed=e;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.getErrorMessage=s;class l extends Error{constructor(A){super("NotImplemented"),A&&(this.message=A)}}t.NotImplementedError=l;class a extends Error{constructor(A){super("NotSupported"),A&&(this.message=A)}}t.NotSupportedError=a;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=c;class r extends Error{constructor(A){super(A),this.name="CodeExpectedError"}static fromError(A){if(A instanceof r)return A;const L=new r;return L.message=A.message,L.stack=A.stack,L}static isErrorNoTelemetry(A){return A.name==="CodeExpectedError"}}t.ErrorNoTelemetry=r;class h extends Error{constructor(A){super(A||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}t.BugIndicatingError=h}),define(me[14],be([1,0,9]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(k,O=0){return k[k.length-(1+O)]}t.tail=i;function U(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=U;function H(k,O,W=(S,I)=>S===I){if(k===O)return!0;if(!k||!O||k.length!==O.length)return!1;for(let S=0,I=k.length;S<I;S++)if(!W(k[S],O[S]))return!1;return!0}t.equals=H;function y(k,O){const W=k.length-1;O<W&&(k[O]=k[W]),k.pop()}t.removeFastWithoutKeepingOrder=y;function w(k,O,W){return f(k.length,S=>W(k[S],O))}t.binarySearch=w;function f(k,O){let W=0,S=k-1;for(;W<=S;){const I=(W+S)/2|0,P=O(I);if(P<0)W=I+1;else if(P>0)S=I-1;else return I}return-(W+1)}t.binarySearch2=f;function g(k,O){let W=0,S=k.length;if(S===0)return 0;for(;W<S;){const I=Math.floor((W+S)/2);O(k[I])?S=I:W=I+1}return W}t.findFirstInSorted=g;function d(k,O,W){if(k=k|0,k>=O.length)throw new TypeError("invalid index");const S=O[Math.floor(O.length*Math.random())],I=[],P=[],R=[];for(const j of O){const Q=W(j,S);Q<0?I.push(j):Q>0?P.push(j):R.push(j)}return k<I.length?d(k,I,W):k<I.length+R.length?R[0]:d(k-(I.length+R.length),P,W)}t.quickSelect=d;function M(k,O){const W=[];let S;for(const I of k.slice(0).sort(O))!S||O(S[0],I)!==0?(S=[I],W.push(S)):S.push(I);return W}t.groupBy=M;function o(k,O,W){const S=[];function I(j,Q,re){if(Q===0&&re.length===0)return;const ue=S[S.length-1];ue&&ue.start+ue.deleteCount===j?(ue.deleteCount+=Q,ue.toInsert.push(...re)):S.push({start:j,deleteCount:Q,toInsert:re})}let P=0,R=0;for(;;){if(P===k.length){I(P,0,O.slice(R));break}if(R===O.length){I(P,k.length-P,[]);break}const j=k[P],Q=O[R],re=W(j,Q);re===0?(P+=1,R+=1):re<0?(I(P,1,[]),P+=1):re>0&&(I(P,0,[Q]),R+=1)}return S}t.sortedDiff=o;function n(k,O,W){const S=o(k,O,W),I=[],P=[];for(const R of S)I.push(...k.slice(R.start,R.start+R.deleteCount)),P.push(...R.toInsert);return{removed:I,added:P}}t.delta=n;function e(k,O,W){if(W===0)return[];const S=k.slice(0,W).sort(O);return l(k,O,S,W,k.length),S}t.top=e;function s(k,O,W,S,I){return W===0?Promise.resolve([]):new Promise((P,R)=>{(async()=>{const j=k.length,Q=k.slice(0,W).sort(O);for(let re=W,ue=Math.min(W+S,j);re<j;re=ue,ue=Math.min(ue+S,j)){if(re>W&&await new Promise(De=>setTimeout(De)),I&&I.isCancellationRequested)throw new v.CancellationError;l(k,O,Q,re,ue)}return Q})().then(P,R)})}t.topAsync=s;function l(k,O,W,S,I){for(const P=W.length;S<I;S++){const R=k[S];if(O(R,W[P-1])<0){W.pop();const j=g(W,Q=>O(R,Q)<0);W.splice(j,0,R)}}}function a(k){return k.filter(O=>!!O)}t.coalesce=a;function c(k){let O=0;for(let W=0;W<k.length;W++)k[W]&&(k[O]=k[W],O+=1);k.length=O}t.coalesceInPlace=c;function r(k,O,W){k.splice(W,0,k.splice(O,1)[0])}t.move=r;function h(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=h;function b(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=b;function A(k,O=W=>W){const W=new Set;return k.filter(S=>{const I=O(S);return W.has(I)?!1:(W.add(I),!0)})}t.distinct=A;function L(k){const O=new Set;return W=>{const S=k(W);return O.has(S)?!1:(O.add(S),!0)}}t.uniqueFilter=L;function N(k,O){const W=F(k,O);if(W!==-1)return k[W]}t.findLast=N;function F(k,O){for(let W=k.length-1;W>=0;W--){const S=k[W];if(O(S))return W}return-1}t.lastIndex=F;function u(k,O){return k.length>0?k[0]:O}t.firstOrDefault=u;function C(k,O){return k.length>0?k[k.length-1]:O}t.lastOrDefault=C;function p(k,O,W=(S,I)=>S===I){let S=0;for(let I=0,P=Math.min(k.length,O.length);I<P&&W(k[I],O[I]);I++)S++;return S}t.commonPrefixLength=p;function D(k){return[].concat(...k)}t.flatten=D;function _(k,O){let W=typeof O=="number"?k:0;typeof O=="number"?W=k:(W=0,O=k);const S=[];if(W<=O)for(let I=W;I<O;I++)S.push(I);else for(let I=W;I>O;I--)S.push(I);return S}t.range=_;function V(k,O,W){return k.reduce((S,I)=>(S[O(I)]=W?W(I):I,S),Object.create(null))}t.index=V;function ee(k,O){return k.push(O),()=>Z(k,O)}t.insert=ee;function Z(k,O){const W=k.indexOf(O);if(W>-1)return k.splice(W,1),O}t.remove=Z;function pe(k,O,W){const S=k.slice(0,O),I=k.slice(O);return S.concat(W,I)}t.arrayInsert=pe;function oe(k,O){let W;if(typeof O=="number"){let S=O;W=()=>{const I=Math.sin(S++)*179426549;return I-Math.floor(I)}}else W=Math.random;for(let S=k.length-1;S>0;S-=1){const I=Math.floor(W()*(S+1)),P=k[S];k[S]=k[I],k[I]=P}}t.shuffle=oe;function ce(k,O){const W=k.indexOf(O);W>-1&&(k.splice(W,1),k.unshift(O))}t.pushToStart=ce;function ae(k,O){const W=k.indexOf(O);W>-1&&(k.splice(W,1),k.push(O))}t.pushToEnd=ae;function de(k,O){for(const W of O)k.push(W)}t.pushMany=de;function Se(k,O){return Array.isArray(k)?k.map(O):O(k)}t.mapArrayOrNot=Se;function x(k){return Array.isArray(k)?k:[k]}t.asArray=x;function ye(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=ye;function ie(k,O){for(const W of k){const S=O(W);if(S!==void 0)return S}}t.mapFind=ie;function J(k,O,W){const S=fe(k,O),I=k.length,P=W.length;k.length=I+P;for(let R=I-1;R>=S;R--)k[R+P]=k[R];for(let R=0;R<P;R++)k[R+S]=W[R]}t.insertInto=J;function he(k,O,W,S){const I=fe(k,O),P=k.splice(I,W);return J(k,I,S),P}t.splice=he;function fe(k,O){return O<0?Math.max(O+k.length,0):Math.min(O,k.length)}var le;(function(k){function O(I){return I<0}k.isLessThan=O;function W(I){return I>0}k.isGreaterThan=W;function S(I){return I===0}k.isNeitherLessOrGreaterThan=S,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(le=t.CompareResult||(t.CompareResult={}));function te(k,O){return(W,S)=>O(k(W),k(S))}t.compareBy=te;function T(...k){return(O,W)=>{for(const S of k){const I=S(O,W);if(!le.isNeitherLessOrGreaterThan(I))return I}return le.neitherLessOrGreaterThan}}t.tieBreakComparators=T;const E=(k,O)=>k-O;t.numberComparator=E;function m(k,O){if(k.length===0)return;let W=k[0];for(let S=1;S<k.length;S++){const I=k[S];O(I,W)>0&&(W=I)}return W}t.findMaxBy=m;function B(k,O){if(k.length===0)return;let W=k[0];for(let S=1;S<k.length;S++){const I=k[S];O(I,W)>=0&&(W=I)}return W}t.findLastMaxBy=B;function z(k,O){return m(k,(W,S)=>-O(W,S))}t.findMinBy=z;class ${constructor(O){this.f=O,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(O){let W=this.c;for(;W<this.f.length&&O(this.f[W]);)W++;const S=W===this.c?null:this.f.slice(this.c,W);return this.c=W,S}takeFromEndWhile(O){let W=this.d;for(;W>=0&&O(this.f[W]);)W--;const S=W===this.d?null:this.f.slice(W+1,this.d+1);return this.d=W,S}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const O=this.f[this.c];return this.c++,O}removeLast(){const O=this.f[this.d];return this.d--,O}takeCount(O){const W=this.f.slice(this.c,this.c+O);return this.c+=O,W}}t.ArrayQueue=$;class G{constructor(O){this.iterate=O}forEach(O){this.iterate(W=>(O(W),!0))}toArray(){const O=[];return this.iterate(W=>(O.push(W),!0)),O}filter(O){return new G(W=>this.iterate(S=>O(S)?W(S):!0))}map(O){return new G(W=>this.iterate(S=>W(O(S))))}some(O){let W=!1;return this.iterate(S=>(W=O(S),!W)),W}findFirst(O){let W;return this.iterate(S=>O(S)?(W=S,!1):!0),W}findLast(O){let W;return this.iterate(S=>(O(S)&&(W=S),!0)),W}findLastMaxBy(O){let W,S=!0;return this.iterate(I=>((S||le.isGreaterThan(O(I,W)))&&(S=!1,W=I),!0)),W}}t.CallbackIterable=G,G.empty=new G(k=>{})}),define(me[72],be([1,0,9]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(f,g){if(!f)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}t.ok=i;function U(f,g="Unreachable"){throw new Error(g)}t.assertNever=U;function H(f){if(!f)throw new v.BugIndicatingError("Assertion Failed")}t.assert=H;function y(f){if(!f()){debugger;f(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function w(f,g){let d=0;for(;d<f.length-1;){const M=f[d],o=f[d+1];if(!g(M,o))return!1;d++}return!0}t.checkAdjacentItems=w}),define(me[42],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function v(i){const U=this;let H=!1,y;return function(){return H||(H=!0,y=i.apply(U,arguments)),y}}t.once=v}),define(me[73],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class v{constructor(U){this.a=U,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=v,t.defaultGenerator=new v("id#")}),define(me[25],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(i){function U(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=U;const H=Object.freeze([]);function y(){return H}i.empty=y;function*w(h){yield h}i.single=w;function f(h){return U(h)?h:w(h)}i.wrap=f;function g(h){return h||H}i.from=g;function d(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=d;function M(h){return h[Symbol.iterator]().next().value}i.first=M;function o(h,b){for(const A of h)if(b(A))return!0;return!1}i.some=o;function n(h,b){for(const A of h)if(b(A))return A}i.find=n;function*e(h,b){for(const A of h)b(A)&&(yield A)}i.filter=e;function*s(h,b){let A=0;for(const L of h)yield b(L,A++)}i.map=s;function*l(...h){for(const b of h)for(const A of b)yield A}i.concat=l;function a(h,b,A){let L=A;for(const N of h)L=b(L,N);return L}i.reduce=a;function*c(h,b,A=h.length){for(b<0&&(b+=h.length),A<0?A+=h.length:A>h.length&&(A=h.length);b<A;b++)yield h[b]}i.slice=c;function r(h,b=Number.POSITIVE_INFINITY){const A=[];if(b===0)return[A,h];const L=h[Symbol.iterator]();for(let N=0;N<b;N++){const F=L.next();if(F.done)return[A,i.empty()];A.push(F.value)}return[A,{[Symbol.iterator](){return L}}]}i.consume=r})(v=t.Iterable||(t.Iterable={}))}),define(me[43],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(v=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class U{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,l){this._keyCodeToStr[s]=l,this._strToKeyCode[l.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new U,y=new U,w=new U;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],g=Object.create(null),d=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>g[e]||0,toString:e=>f[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],a=[];for(const c of s){const[r,h,b,A,L,N,F,u,C,p]=c;if(a[b]||(a[b]=!0,f[b]=A,g[A]=b,d[A.toLowerCase()]=b,h&&(t.IMMUTABLE_CODE_TO_KEY_CODE[b]=L,L!==0&&L!==3&&L!==5&&L!==4&&L!==6&&L!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[L]=b))),!l[L]){if(l[L]=!0,!N)throw new Error(`String representation missing for key code ${L} around scan code ${A}`);H.define(L,N),y.define(L,C||N),w.define(L,p||C||N)}F&&(t.EVENT_KEY_CODE_MAP[F]=L),u&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[u]=L)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function s(b){return H.keyCodeToStr(b)}e.toString=s;function l(b){return H.strToKeyCode(b)}e.fromString=l;function a(b){return y.keyCodeToStr(b)}e.toUserSettingsUS=a;function c(b){return w.keyCodeToStr(b)}e.toUserSettingsGeneral=c;function r(b){return y.strToKeyCode(b)||w.strToKeyCode(b)}e.fromUserSettings=r;function h(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(b)}e.toElectronAccelerator=h})(M=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function n(e,s){const l=(s&65535)<<16>>>0;return(e|l)>>>0}t.KeyChord=n}),define(me[74],be([1,0,9]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(i||(i={}));function U(M,o){if(M===0)return null;const n=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new w([H(n,o),H(e,o)]):new w([H(n,o)])}t.createKeybinding=U;function H(M,o){const n=!!(M&2048),e=!!(M&256),s=o===2?e:n,l=!!(M&1024),a=!!(M&512),c=o===2?n:e,r=M&255;return new y(s,l,a,c,r)}t.createSimpleKeybinding=H;class y{constructor(o,n,e,s,l){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyCode=l}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`${o}${n}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class w{constructor(o){if(o.length===0)throw(0,v.illegalArgument)("parts");this.parts=o}getHashCode(){let o="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(o+=";"),o+=this.parts[n].getHashCode();return o}equals(o){if(o===null||this.parts.length!==o.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(o.parts[n]))return!1;return!0}}t.ChordKeybinding=w;class f{constructor(o,n,e,s,l){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.scanCode=l}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=f;class g{constructor(o,n,e,s,l,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyLabel=l,this.keyAriaLabel=a}}t.ResolvedKeybindingPart=g;class d{}t.ResolvedKeybinding=d}),define(me[44],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class v{constructor(U){this.d=U,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(U){this.c=U}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(U){return new v(()=>U(this.getValue()))}}t.Lazy=v}),define(me[2],be([1,0,42,25]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const U=!1;let H=null;function y(C){H=C}if(t.setDisposableTracker=y,U){const C="__is_disposable_tracked__";y(new class{trackDisposable(p){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[C]||console.log(D)},3e3)}setParent(p,D){if(p&&p!==c.None)try{p[C]=!0}catch{}}markAsDisposed(p){if(p&&p!==c.None)try{p[C]=!0}catch{}}markAsSingleton(p){}})}function w(C){return H?.trackDisposable(C),C}function f(C){H?.markAsDisposed(C)}function g(C,p){H?.setParent(C,p)}function d(C,p){if(!!H)for(const D of C)H.setParent(D,p)}function M(C){return H?.markAsSingleton(C),C}t.markAsSingleton=M;function o(C){return typeof C.dispose=="function"&&C.dispose.length===0}t.isDisposable=o;function n(C){if(i.Iterable.is(C)){const p=[];for(const D of C)if(D)try{D.dispose()}catch(_){p.push(_)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}t.dispose=n;function e(C){for(const p of C)o(p)&&p.dispose();return[]}t.disposeIfDisposable=e;function s(...C){const p=l(()=>n(C));return d(C,p),p}t.combinedDisposable=s;function l(C){const p=w({dispose:(0,v.once)(()=>{f(p),C()})});return p}t.toDisposable=l;class a{constructor(){this.c=new Set,this.f=!1,w(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{n(this.c)}finally{this.c.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return g(p,this),this.f?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(p),p}}t.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this.q=new a,w(this),g(this.q,this)}dispose(){f(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}t.Disposable=c,c.None=Object.freeze({dispose(){}});class r{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&g(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&g(p,null),p}}t.MutableDisposable=r;class h{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=h;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(p){let D=p;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,f(this))},this}}t.SafeDisposable=b;class A{constructor(){this.a=new Map}acquire(p,...D){let _=this.a.get(p);_||(_={counter:0,object:this.b(p,...D)},this.a.set(p,_));const{object:V}=_,ee=(0,v.once)(()=>{--_.counter===0&&(this.c(p,_.object),this.a.delete(p))});return _.counter++,{object:V,dispose:ee}}}t.ReferenceCollection=A;class L{constructor(p){this.a=p}async acquire(p,...D){const _=this.a.acquire(p,...D);try{return{object:await _.object,dispose:()=>_.dispose()}}catch(V){throw _.dispose(),V}}}t.AsyncReferenceCollection=L;class N{constructor(p){this.object=p}dispose(){}}t.ImmortalReference=N;function F(C){const p=new a;try{C(p)}finally{p.dispose()}}t.disposeOnReturn=F;class u{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get(p){return this.a.get(p)}set(p,D,_=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),_||this.a.get(p)?.dispose(),this.a.set(p,D)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=u}),define(me[45],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class v{constructor(H){this.element=H,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class i{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let H=this.a;for(;H!==v.Undefined;){const y=H.next;H.prev=v.Undefined,H.next=v.Undefined,H=y}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,y){const w=new v(H);if(this.a===v.Undefined)this.a=w,this.b=w;else if(y){const g=this.b;this.b=w,w.prev=g,g.next=w}else{const g=this.a;this.a=w,w.next=g,g.prev=w}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(w))}}shift(){if(this.a!==v.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==v.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==v.Undefined&&H.next!==v.Undefined){const y=H.prev;y.next=H.next,H.next.prev=y}else H.prev===v.Undefined&&H.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):H.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):H.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==v.Undefined;)yield H.element,H=H.next}}t.LinkedList=i}),define(me[75],be([1,0]),function(X,t){"use strict";var v,i,U;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function H(e,s,l){let a=e.get(s);return a===void 0&&(a=l,e.set(s,a)),a}t.getOrSet=H;function y(e){const s=[];return e.forEach((l,a)=>{s.push(`${a} => ${l}`)}),`Map(${e.size}) {${s.join(", ")}}`}t.mapToString=y;function w(e){const s=[];return e.forEach(l=>{s.push(l)}),`Set(${e.size}) {${s.join(", ")}}`}t.setToString=w;class f{constructor(s,l){this.uri=s,this.value=l}}class g{constructor(s,l){this[v]="ResourceMap",s instanceof g?(this.b=new Map(s.b),this.c=l??g.a):(this.b=new Map,this.c=s??g.a)}set(s,l){return this.b.set(this.c(s),new f(s,l)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,l){typeof l<"u"&&(s=s.bind(l));for(const[a,c]of this.b)s(c.value,c.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.ResourceMap=g,g.a=e=>e.toString();class d{constructor(s,l){this[i]="ResourceSet",!s||typeof s=="function"?this.a=new g(s):(this.a=new g(l),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,l){this.a.forEach((a,c)=>s.call(l,c,c,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=d;var M;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(M=t.Touch||(t.Touch={}));class o{constructor(){this[U]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,l=0){const a=this.a.get(s);if(!!a)return l!==0&&this.j(a,l),a.value}set(s,l,a=0){let c=this.a.get(s);if(c)c.value=l,a!==0&&this.j(c,a);else{switch(c={key:s,value:l,next:void 0,previous:void 0},a){case 0:this.h(c);break;case 1:this.g(c);break;case 2:this.h(c);break;default:this.h(c);break}this.a.set(s,c),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const l=this.a.get(s);if(!!l)return this.a.delete(s),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,l){const a=this.e;let c=this.b;for(;c;){if(l?s.bind(l)(c.value,c.key,this):s(c.value,c.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const s=this,l=this.e;let a=this.b;const c={[Symbol.iterator](){return c},next(){if(s.e!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return c}values(){const s=this,l=this.e;let a=this.b;const c={[Symbol.iterator](){return c},next(){if(s.e!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return c}entries(){const s=this,l=this.e;let a=this.b;const c={[Symbol.iterator](){return c},next(){if(s.e!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return c}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let l=this.b,a=this.size;for(;l&&a>s;)this.a.delete(l.key),l=l.next,a--;this.b=l,this.d=a,l&&(l.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const l=s.next,a=s.previous;if(!l||!a)throw new Error("Invalid list");l.previous=a,a.next=l}s.next=void 0,s.previous=void 0,this.e++}j(s,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(s===this.b)return;const a=s.next,c=s.previous;s===this.c?(c.next=void 0,this.c=c):(a.previous=c,c.next=a),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(l===2){if(s===this.c)return;const a=s.next,c=s.previous;s===this.b?(a.previous=void 0,this.b=a):(a.previous=c,c.next=a),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((l,a)=>{s.push([a,l])}),s}fromJSON(s){this.clear();for(const[l,a]of s)this.set(l,a)}}t.LinkedMap=o;class n extends o{constructor(s,l=1){super(),this.k=s,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,l=2){return super.get(s,l)}peek(s){return super.get(s,0)}set(s,l){return super.set(s,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=n}),function(X,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(me[76],be([0]),t):(X=typeof globalThis<"u"?globalThis:X||self,t(X.marked={}))}(this,function(X){"use strict";function t(k,O){for(var W=0;W<O.length;W++){var S=O[W];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(k,S.key,S)}}function v(k,O,W){return O&&t(k.prototype,O),W&&t(k,W),Object.defineProperty(k,"prototype",{writable:!1}),k}function i(k,O){if(!!k){if(typeof k=="string")return U(k,O);var W=Object.prototype.toString.call(k).slice(8,-1);if(W==="Object"&&k.constructor&&(W=k.constructor.name),W==="Map"||W==="Set")return Array.from(k);if(W==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(W))return U(k,O)}}function U(k,O){(O==null||O>k.length)&&(O=k.length);for(var W=0,S=new Array(O);W<O;W++)S[W]=k[W];return S}function H(k,O){var W=typeof Symbol<"u"&&k[Symbol.iterator]||k["@@iterator"];if(W)return(W=W.call(k)).next.bind(W);if(Array.isArray(k)||(W=i(k))||O&&k&&typeof k.length=="number"){W&&(k=W);var S=0;return function(){return S>=k.length?{done:!0}:{done:!1,value:k[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}X.defaults=y();function w(k){X.defaults=k}var f=/[&<>"']/,g=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(O){return o[O]};function e(k,O){if(O){if(f.test(k))return k.replace(g,n)}else if(d.test(k))return k.replace(M,n);return k}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(k){return k.replace(s,function(O,W){return W=W.toLowerCase(),W==="colon"?":":W.charAt(0)==="#"?W.charAt(1)==="x"?String.fromCharCode(parseInt(W.substring(2),16)):String.fromCharCode(+W.substring(1)):""})}var a=/(^|[^\[])\^/g;function c(k,O){k=typeof k=="string"?k:k.source,O=O||"";var W={replace:function(I,P){return P=P.source||P,P=P.replace(a,"$1"),k=k.replace(I,P),W},getRegex:function(){return new RegExp(k,O)}};return W}var r=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(k,O,W){if(k){var S;try{S=decodeURIComponent(l(W)).replace(r,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}O&&!h.test(W)&&(W=u(O,W));try{W=encodeURI(W).replace(/%25/g,"%")}catch{return null}return W}var A={},L=/^[^:]+:\/*[^/]*$/,N=/^([^:]+:)[\s\S]*$/,F=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(k,O){A[" "+k]||(L.test(k)?A[" "+k]=k+"/":A[" "+k]=_(k,"/",!0)),k=A[" "+k];var W=k.indexOf(":")===-1;return O.substring(0,2)==="//"?W?O:k.replace(N,"$1")+O:O.charAt(0)==="/"?W?O:k.replace(F,"$1")+O:k+O}var C={exec:function(){}};function p(k){for(var O=1,W,S;O<arguments.length;O++){W=arguments[O];for(S in W)Object.prototype.hasOwnProperty.call(W,S)&&(k[S]=W[S])}return k}function D(k,O){var W=k.replace(/\|/g,function(P,R,j){for(var Q=!1,re=R;--re>=0&&j[re]==="\\";)Q=!Q;return Q?"|":" |"}),S=W.split(/ \|/),I=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>O)S.splice(O);else for(;S.length<O;)S.push("");for(;I<S.length;I++)S[I]=S[I].trim().replace(/\\\|/g,"|");return S}function _(k,O,W){var S=k.length;if(S===0)return"";for(var I=0;I<S;){var P=k.charAt(S-I-1);if(P===O&&!W)I++;else if(P!==O&&W)I++;else break}return k.slice(0,S-I)}function V(k,O){if(k.indexOf(O[1])===-1)return-1;for(var W=k.length,S=0,I=0;I<W;I++)if(k[I]==="\\")I++;else if(k[I]===O[0])S++;else if(k[I]===O[1]&&(S--,S<0))return I;return-1}function ee(k){k&&k.sanitize&&!k.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Z(k,O){if(O<1)return"";for(var W="";O>1;)O&1&&(W+=k),O>>=1,k+=k;return W+k}function pe(k,O,W,S){var I=O.href,P=O.title?e(O.title):null,R=k[1].replace(/\\([\[\]])/g,"$1");if(k[0].charAt(0)!=="!"){S.state.inLink=!0;var j={type:"link",raw:W,href:I,title:P,text:R,tokens:S.inlineTokens(R)};return S.state.inLink=!1,j}return{type:"image",raw:W,href:I,title:P,text:e(R)}}function oe(k,O){var W=k.match(/^(\s+)(?:```)/);if(W===null)return O;var S=W[1];return O.split(`
`).map(function(I){var P=I.match(/^\s+/);if(P===null)return I;var R=P[0];return R.length>=S.length?I.slice(S.length):I}).join(`
`)}var ce=function(){function k(W){this.options=W||X.defaults}var O=k.prototype;return O.space=function(S){var I=this.rules.block.newline.exec(S);if(I&&I[0].length>0)return{type:"space",raw:I[0]}},O.code=function(S){var I=this.rules.block.code.exec(S);if(I){var P=I[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:I[0],codeBlockStyle:"indented",text:this.options.pedantic?P:_(P,`
`)}}},O.fences=function(S){var I=this.rules.block.fences.exec(S);if(I){var P=I[0],R=oe(P,I[3]||"");return{type:"code",raw:P,lang:I[2]?I[2].trim():I[2],text:R}}},O.heading=function(S){var I=this.rules.block.heading.exec(S);if(I){var P=I[2].trim();if(/#$/.test(P)){var R=_(P,"#");(this.options.pedantic||!R||/ $/.test(R))&&(P=R.trim())}return{type:"heading",raw:I[0],depth:I[1].length,text:P,tokens:this.lexer.inline(P)}}},O.hr=function(S){var I=this.rules.block.hr.exec(S);if(I)return{type:"hr",raw:I[0]}},O.blockquote=function(S){var I=this.rules.block.blockquote.exec(S);if(I){var P=I[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:I[0],tokens:this.lexer.blockTokens(P,[]),text:P}}},O.list=function(S){var I=this.rules.block.list.exec(S);if(I){var P,R,j,Q,re,ue,De,Ee,Ie,ke,ve,Pe,Re=I[1].trim(),je=Re.length>1,Ue={type:"list",raw:"",ordered:je,start:je?+Re.slice(0,-1):"",loose:!1,items:[]};Re=je?"\\d{1,9}\\"+Re.slice(-1):"\\"+Re,this.options.pedantic&&(Re=je?Re:"[*+-]");for(var ze=new RegExp("^( {0,3}"+Re+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Pe=!1,!(!(I=ze.exec(S))||this.rules.block.hr.test(S)));){if(P=I[0],S=S.substring(P.length),Ee=I[2].split(`
`,1)[0],Ie=S.split(`
`,1)[0],this.options.pedantic?(Q=2,ve=Ee.trimLeft()):(Q=I[2].search(/[^ ]/),Q=Q>4?1:Q,ve=Ee.slice(Q),Q+=I[1].length),ue=!1,!Ee&&/^ *$/.test(Ie)&&(P+=Ie+`
`,S=S.substring(Ie.length+1),Pe=!0),!Pe)for(var xe=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Q-1)+"}#");S&&(ke=S.split(`
`,1)[0],Ee=ke,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(Ee)||Ve.test(Ee)||xe.test(Ee)||it.test(S)));){if(Ee.search(/[^ ]/)>=Q||!Ee.trim())ve+=`
`+Ee.slice(Q);else if(!ue)ve+=`
`+Ee;else break;!ue&&!Ee.trim()&&(ue=!0),P+=ke+`
`,S=S.substring(ke.length+1)}Ue.loose||(De?Ue.loose=!0:/\n *\n *$/.test(P)&&(De=!0)),this.options.gfm&&(R=/^\[[ xX]\] /.exec(ve),R&&(j=R[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:P,task:!!R,checked:j,loose:!1,text:ve}),Ue.raw+=P}Ue.items[Ue.items.length-1].raw=P.trimRight(),Ue.items[Ue.items.length-1].text=ve.trimRight(),Ue.raw=Ue.raw.trimRight();var Ye=Ue.items.length;for(re=0;re<Ye;re++){this.lexer.state.top=!1,Ue.items[re].tokens=this.lexer.blockTokens(Ue.items[re].text,[]);var K=Ue.items[re].tokens.filter(function(we){return we.type==="space"}),se=K.every(function(we){for(var Ce=we.raw.split(""),Fe=0,Oe=H(Ce),$e;!($e=Oe()).done;){var tt=$e.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!Ue.loose&&K.length&&se&&(Ue.loose=!0,Ue.items[re].loose=!0)}return Ue}},O.html=function(S){var I=this.rules.block.html.exec(S);if(I){var P={type:"html",raw:I[0],pre:!this.options.sanitizer&&(I[1]==="pre"||I[1]==="script"||I[1]==="style"),text:I[0]};if(this.options.sanitize){var R=this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]);P.type="paragraph",P.text=R,P.tokens=this.lexer.inline(R)}return P}},O.def=function(S){var I=this.rules.block.def.exec(S);if(I){I[3]&&(I[3]=I[3].substring(1,I[3].length-1));var P=I[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:P,raw:I[0],href:I[2],title:I[3]}}},O.table=function(S){var I=this.rules.block.table.exec(S);if(I){var P={type:"table",header:D(I[1]).map(function(De){return{text:De}}),align:I[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:I[3]&&I[3].trim()?I[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(P.header.length===P.align.length){P.raw=I[0];var R=P.align.length,j,Q,re,ue;for(j=0;j<R;j++)/^ *-+: *$/.test(P.align[j])?P.align[j]="right":/^ *:-+: *$/.test(P.align[j])?P.align[j]="center":/^ *:-+ *$/.test(P.align[j])?P.align[j]="left":P.align[j]=null;for(R=P.rows.length,j=0;j<R;j++)P.rows[j]=D(P.rows[j],P.header.length).map(function(De){return{text:De}});for(R=P.header.length,Q=0;Q<R;Q++)P.header[Q].tokens=this.lexer.inline(P.header[Q].text);for(R=P.rows.length,Q=0;Q<R;Q++)for(ue=P.rows[Q],re=0;re<ue.length;re++)ue[re].tokens=this.lexer.inline(ue[re].text);return P}}},O.lheading=function(S){var I=this.rules.block.lheading.exec(S);if(I)return{type:"heading",raw:I[0],depth:I[2].charAt(0)==="="?1:2,text:I[1],tokens:this.lexer.inline(I[1])}},O.paragraph=function(S){var I=this.rules.block.paragraph.exec(S);if(I){var P=I[1].charAt(I[1].length-1)===`
`?I[1].slice(0,-1):I[1];return{type:"paragraph",raw:I[0],text:P,tokens:this.lexer.inline(P)}}},O.text=function(S){var I=this.rules.block.text.exec(S);if(I)return{type:"text",raw:I[0],text:I[0],tokens:this.lexer.inline(I[0])}},O.escape=function(S){var I=this.rules.inline.escape.exec(S);if(I)return{type:"escape",raw:I[0],text:e(I[1])}},O.tag=function(S){var I=this.rules.inline.tag.exec(S);if(I)return!this.lexer.state.inLink&&/^<a /i.test(I[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(I[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(I[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(I[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:I[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]):I[0]}},O.link=function(S){var I=this.rules.inline.link.exec(S);if(I){var P=I[2].trim();if(!this.options.pedantic&&/^</.test(P)){if(!/>$/.test(P))return;var R=_(P.slice(0,-1),"\\");if((P.length-R.length)%2===0)return}else{var j=V(I[2],"()");if(j>-1){var Q=I[0].indexOf("!")===0?5:4,re=Q+I[1].length+j;I[2]=I[2].substring(0,j),I[0]=I[0].substring(0,re).trim(),I[3]=""}}var ue=I[2],De="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ue);Ee&&(ue=Ee[1],De=Ee[3])}else De=I[3]?I[3].slice(1,-1):"";return ue=ue.trim(),/^</.test(ue)&&(this.options.pedantic&&!/>$/.test(P)?ue=ue.slice(1):ue=ue.slice(1,-1)),pe(I,{href:ue&&ue.replace(this.rules.inline._escapes,"$1"),title:De&&De.replace(this.rules.inline._escapes,"$1")},I[0],this.lexer)}},O.reflink=function(S,I){var P;if((P=this.rules.inline.reflink.exec(S))||(P=this.rules.inline.nolink.exec(S))){var R=(P[2]||P[1]).replace(/\s+/g," ");if(R=I[R.toLowerCase()],!R||!R.href){var j=P[0].charAt(0);return{type:"text",raw:j,text:j}}return pe(P,R,P[0],this.lexer)}},O.emStrong=function(S,I,P){P===void 0&&(P="");var R=this.rules.inline.emStrong.lDelim.exec(S);if(!!R&&!(R[3]&&P.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=R[1]||R[2]||"";if(!j||j&&(P===""||this.rules.inline.punctuation.exec(P))){var Q=R[0].length-1,re,ue,De=Q,Ee=0,Ie=R[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ie.lastIndex=0,I=I.slice(-1*S.length+Q);(R=Ie.exec(I))!=null;)if(re=R[1]||R[2]||R[3]||R[4]||R[5]||R[6],!!re){if(ue=re.length,R[3]||R[4]){De+=ue;continue}else if((R[5]||R[6])&&Q%3&&!((Q+ue)%3)){Ee+=ue;continue}if(De-=ue,!(De>0)){if(ue=Math.min(ue,ue+De+Ee),Math.min(Q,ue)%2){var ke=S.slice(1,Q+R.index+ue);return{type:"em",raw:S.slice(0,Q+R.index+ue+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ve=S.slice(2,Q+R.index+ue-1);return{type:"strong",raw:S.slice(0,Q+R.index+ue+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},O.codespan=function(S){var I=this.rules.inline.code.exec(S);if(I){var P=I[2].replace(/\n/g," "),R=/[^ ]/.test(P),j=/^ /.test(P)&&/ $/.test(P);return R&&j&&(P=P.substring(1,P.length-1)),P=e(P,!0),{type:"codespan",raw:I[0],text:P}}},O.br=function(S){var I=this.rules.inline.br.exec(S);if(I)return{type:"br",raw:I[0]}},O.del=function(S){var I=this.rules.inline.del.exec(S);if(I)return{type:"del",raw:I[0],text:I[2],tokens:this.lexer.inlineTokens(I[2])}},O.autolink=function(S,I){var P=this.rules.inline.autolink.exec(S);if(P){var R,j;return P[2]==="@"?(R=e(this.options.mangle?I(P[1]):P[1]),j="mailto:"+R):(R=e(P[1]),j=R),{type:"link",raw:P[0],text:R,href:j,tokens:[{type:"text",raw:R,text:R}]}}},O.url=function(S,I){var P;if(P=this.rules.inline.url.exec(S)){var R,j;if(P[2]==="@")R=e(this.options.mangle?I(P[0]):P[0]),j="mailto:"+R;else{var Q;do Q=P[0],P[0]=this.rules.inline._backpedal.exec(P[0])[0];while(Q!==P[0]);R=e(P[0]),P[1]==="www."?j="http://"+R:j=R}return{type:"link",raw:P[0],text:R,href:j,tokens:[{type:"text",raw:R,text:R}]}}},O.inlineText=function(S,I){var P=this.rules.inline.text.exec(S);if(P){var R;return this.lexer.state.inRawBlock?R=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]):P[0]:R=e(this.options.smartypants?I(P[0]):P[0]),{type:"text",raw:P[0],text:R}}},k}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=c(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=c(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=c(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=c(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=c(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=c(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=p({},ae),ae.gfm=p({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=c(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=c(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=p({},ae.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:c(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var de={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};de._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",de.punctuation=c(de.punctuation).replace(/punctuation/g,de._punctuation).getRegex(),de.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,de.escapedEmSt=/\\\*|\\_/g,de._comment=c(ae._comment).replace("(?:-->|$)","-->").getRegex(),de.emStrong.lDelim=c(de.emStrong.lDelim).replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimAst=c(de.emStrong.rDelimAst,"g").replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimUnd=c(de.emStrong.rDelimUnd,"g").replace(/punct/g,de._punctuation).getRegex(),de._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,de._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,de._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,de.autolink=c(de.autolink).replace("scheme",de._scheme).replace("email",de._email).getRegex(),de._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,de.tag=c(de.tag).replace("comment",de._comment).replace("attribute",de._attribute).getRegex(),de._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,de._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,de._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,de.link=c(de.link).replace("label",de._label).replace("href",de._href).replace("title",de._title).getRegex(),de.reflink=c(de.reflink).replace("label",de._label).replace("ref",ae._label).getRegex(),de.nolink=c(de.nolink).replace("ref",ae._label).getRegex(),de.reflinkSearch=c(de.reflinkSearch,"g").replace("reflink",de.reflink).replace("nolink",de.nolink).getRegex(),de.normal=p({},de),de.pedantic=p({},de.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",de._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",de._label).getRegex()}),de.gfm=p({},de.normal,{escape:c(de.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),de.gfm.url=c(de.gfm.url,"i").replace("email",de.gfm._extended_email).getRegex(),de.breaks=p({},de.gfm,{br:c(de.br).replace("{2,}","*").getRegex(),text:c(de.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(k){return k.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(k){var O="",W,S,I=k.length;for(W=0;W<I;W++)S=k.charCodeAt(W),Math.random()>.5&&(S="x"+S.toString(16)),O+="&#"+S+";";return O}var ye=function(){function k(W){this.tokens=[],this.tokens.links=Object.create(null),this.options=W||X.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:ae.normal,inline:de.normal};this.options.pedantic?(S.block=ae.pedantic,S.inline=de.pedantic):this.options.gfm&&(S.block=ae.gfm,this.options.breaks?S.inline=de.breaks:S.inline=de.gfm),this.tokenizer.rules=S}k.lex=function(S,I){var P=new k(I);return P.lex(S)},k.lexInline=function(S,I){var P=new k(I);return P.inlineTokens(S)};var O=k.prototype;return O.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var I;I=this.inlineQueue.shift();)this.inlineTokens(I.src,I.tokens);return this.tokens},O.blockTokens=function(S,I){var P=this;I===void 0&&(I=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(De,Ee,Ie){return Ee+"    ".repeat(Ie.length)});for(var R,j,Q,re;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(De){return(R=De.call({lexer:P},S,I))?(S=S.substring(R.raw.length),I.push(R),!0):!1}))){if(R=this.tokenizer.space(S)){S=S.substring(R.raw.length),R.raw.length===1&&I.length>0?I[I.length-1].raw+=`
`:I.push(R);continue}if(R=this.tokenizer.code(S)){S=S.substring(R.raw.length),j=I[I.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+R.raw,j.text+=`
`+R.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(R);continue}if(R=this.tokenizer.fences(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.heading(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.hr(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.blockquote(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.list(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.html(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.def(S)){S=S.substring(R.raw.length),j=I[I.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+R.raw,j.text+=`
`+R.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[R.tag]||(this.tokens.links[R.tag]={href:R.href,title:R.title});continue}if(R=this.tokenizer.table(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.lheading(S)){S=S.substring(R.raw.length),I.push(R);continue}if(Q=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var De=1/0,Ee=S.slice(1),Ie=void 0;P.options.extensions.startBlock.forEach(function(ke){Ie=ke.call({lexer:this},Ee),typeof Ie=="number"&&Ie>=0&&(De=Math.min(De,Ie))}),De<1/0&&De>=0&&(Q=S.substring(0,De+1))}(),this.state.top&&(R=this.tokenizer.paragraph(Q))){j=I[I.length-1],re&&j.type==="paragraph"?(j.raw+=`
`+R.raw,j.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(R),re=Q.length!==S.length,S=S.substring(R.raw.length);continue}if(R=this.tokenizer.text(S)){S=S.substring(R.raw.length),j=I[I.length-1],j&&j.type==="text"?(j.raw+=`
`+R.raw,j.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(R);continue}if(S){var ue="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return this.state.top=!0,I},O.inline=function(S,I){return I===void 0&&(I=[]),this.inlineQueue.push({src:S,tokens:I}),I},O.inlineTokens=function(S,I){var P=this;I===void 0&&(I=[]);var R,j,Q,re=S,ue,De,Ee;if(this.tokens.links){var Ie=Object.keys(this.tokens.links);if(Ie.length>0)for(;(ue=this.tokenizer.rules.inline.reflinkSearch.exec(re))!=null;)Ie.includes(ue[0].slice(ue[0].lastIndexOf("[")+1,-1))&&(re=re.slice(0,ue.index)+"["+Z("a",ue[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ue=this.tokenizer.rules.inline.blockSkip.exec(re))!=null;)re=re.slice(0,ue.index)+"["+Z("a",ue[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ue=this.tokenizer.rules.inline.escapedEmSt.exec(re))!=null;)re=re.slice(0,ue.index)+"++"+re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(De||(Ee=""),De=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(R=ve.call({lexer:P},S,I))?(S=S.substring(R.raw.length),I.push(R),!0):!1}))){if(R=this.tokenizer.escape(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.tag(S)){S=S.substring(R.raw.length),j=I[I.length-1],j&&R.type==="text"&&j.type==="text"?(j.raw+=R.raw,j.text+=R.text):I.push(R);continue}if(R=this.tokenizer.link(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(R.raw.length),j=I[I.length-1],j&&R.type==="text"&&j.type==="text"?(j.raw+=R.raw,j.text+=R.text):I.push(R);continue}if(R=this.tokenizer.emStrong(S,re,Ee)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.codespan(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.br(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.del(S)){S=S.substring(R.raw.length),I.push(R);continue}if(R=this.tokenizer.autolink(S,x)){S=S.substring(R.raw.length),I.push(R);continue}if(!this.state.inLink&&(R=this.tokenizer.url(S,x))){S=S.substring(R.raw.length),I.push(R);continue}if(Q=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=S.slice(1),Re=void 0;P.options.extensions.startInline.forEach(function(je){Re=je.call({lexer:this},Pe),typeof Re=="number"&&Re>=0&&(ve=Math.min(ve,Re))}),ve<1/0&&ve>=0&&(Q=S.substring(0,ve+1))}(),R=this.tokenizer.inlineText(Q,Se)){S=S.substring(R.raw.length),R.raw.slice(-1)!=="_"&&(Ee=R.raw.slice(-1)),De=!0,j=I[I.length-1],j&&j.type==="text"?(j.raw+=R.raw,j.text+=R.text):I.push(R);continue}if(S){var ke="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return I},v(k,null,[{key:"rules",get:function(){return{block:ae,inline:de}}}]),k}(),ie=function(){function k(W){this.options=W||X.defaults}var O=k.prototype;return O.code=function(S,I,P){var R=(I||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(S,R);j!=null&&j!==S&&(P=!0,S=j)}return S=S.replace(/\n$/,"")+`
`,R?'<pre><code class="'+this.options.langPrefix+e(R,!0)+'">'+(P?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(P?S:e(S,!0))+`</code></pre>
`},O.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},O.html=function(S){return S},O.heading=function(S,I,P,R){if(this.options.headerIds){var j=this.options.headerPrefix+R.slug(P);return"<h"+I+' id="'+j+'">'+S+"</h"+I+`>
`}return"<h"+I+">"+S+"</h"+I+`>
`},O.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},O.list=function(S,I,P){var R=I?"ol":"ul",j=I&&P!==1?' start="'+P+'"':"";return"<"+R+j+`>
`+S+"</"+R+`>
`},O.listitem=function(S){return"<li>"+S+`</li>
`},O.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},O.paragraph=function(S){return"<p>"+S+`</p>
`},O.table=function(S,I){return I&&(I="<tbody>"+I+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+I+`</table>
`},O.tablerow=function(S){return`<tr>
`+S+`</tr>
`},O.tablecell=function(S,I){var P=I.header?"th":"td",R=I.align?"<"+P+' align="'+I.align+'">':"<"+P+">";return R+S+("</"+P+`>
`)},O.strong=function(S){return"<strong>"+S+"</strong>"},O.em=function(S){return"<em>"+S+"</em>"},O.codespan=function(S){return"<code>"+S+"</code>"},O.br=function(){return this.options.xhtml?"<br/>":"<br>"},O.del=function(S){return"<del>"+S+"</del>"},O.link=function(S,I,P){if(S=b(this.options.sanitize,this.options.baseUrl,S),S===null)return P;var R='<a href="'+e(S)+'"';return I&&(R+=' title="'+I+'"'),R+=">"+P+"</a>",R},O.image=function(S,I,P){if(S=b(this.options.sanitize,this.options.baseUrl,S),S===null)return P;var R='<img src="'+S+'" alt="'+P+'"';return I&&(R+=' title="'+I+'"'),R+=this.options.xhtml?"/>":">",R},O.text=function(S){return S},k}(),J=function(){function k(){}var O=k.prototype;return O.strong=function(S){return S},O.em=function(S){return S},O.codespan=function(S){return S},O.del=function(S){return S},O.html=function(S){return S},O.text=function(S){return S},O.link=function(S,I,P){return""+P},O.image=function(S,I,P){return""+P},O.br=function(){return""},k}(),he=function(){function k(){this.seen={}}var O=k.prototype;return O.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},O.getNextSafeSlug=function(S,I){var P=S,R=0;if(this.seen.hasOwnProperty(P)){R=this.seen[S];do R++,P=S+"-"+R;while(this.seen.hasOwnProperty(P))}return I||(this.seen[S]=R,this.seen[P]=0),P},O.slug=function(S,I){I===void 0&&(I={});var P=this.serialize(S);return this.getNextSafeSlug(P,I.dryrun)},k}(),fe=function(){function k(W){this.options=W||X.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new he}k.parse=function(S,I){var P=new k(I);return P.parse(S)},k.parseInline=function(S,I){var P=new k(I);return P.parseInline(S)};var O=k.prototype;return O.parse=function(S,I){I===void 0&&(I=!0);var P="",R,j,Q,re,ue,De,Ee,Ie,ke,ve,Pe,Re,je,Ue,ze,xe,it,Be,Ve,Ye=S.length;for(R=0;R<Ye;R++){if(ve=S[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Ve=this.options.extensions.renderers[ve.type].call({parser:this},ve),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){P+=Ve||"";continue}switch(ve.type){case"space":continue;case"hr":{P+=this.renderer.hr();continue}case"heading":{P+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{P+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ie="",Ee="",re=ve.header.length,j=0;j<re;j++)Ee+=this.renderer.tablecell(this.parseInline(ve.header[j].tokens),{header:!0,align:ve.align[j]});for(Ie+=this.renderer.tablerow(Ee),ke="",re=ve.rows.length,j=0;j<re;j++){for(De=ve.rows[j],Ee="",ue=De.length,Q=0;Q<ue;Q++)Ee+=this.renderer.tablecell(this.parseInline(De[Q].tokens),{header:!1,align:ve.align[Q]});ke+=this.renderer.tablerow(Ee)}P+=this.renderer.table(Ie,ke);continue}case"blockquote":{ke=this.parse(ve.tokens),P+=this.renderer.blockquote(ke);continue}case"list":{for(Pe=ve.ordered,Re=ve.start,je=ve.loose,re=ve.items.length,ke="",j=0;j<re;j++)ze=ve.items[j],xe=ze.checked,it=ze.task,Ue="",ze.task&&(Be=this.renderer.checkbox(xe),je?ze.tokens.length>0&&ze.tokens[0].type==="paragraph"?(ze.tokens[0].text=Be+" "+ze.tokens[0].text,ze.tokens[0].tokens&&ze.tokens[0].tokens.length>0&&ze.tokens[0].tokens[0].type==="text"&&(ze.tokens[0].tokens[0].text=Be+" "+ze.tokens[0].tokens[0].text)):ze.tokens.unshift({type:"text",text:Be}):Ue+=Be),Ue+=this.parse(ze.tokens,je),ke+=this.renderer.listitem(Ue,it,xe);P+=this.renderer.list(ke,Pe,Re);continue}case"html":{P+=this.renderer.html(ve.text);continue}case"paragraph":{P+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ke=ve.tokens?this.parseInline(ve.tokens):ve.text;R+1<Ye&&S[R+1].type==="text";)ve=S[++R],ke+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);P+=I?this.renderer.paragraph(ke):ke;continue}default:{var K='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return P},O.parseInline=function(S,I){I=I||this.renderer;var P="",R,j,Q,re=S.length;for(R=0;R<re;R++){if(j=S[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(Q=this.options.extensions.renderers[j.type].call({parser:this},j),Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){P+=Q||"";continue}switch(j.type){case"escape":{P+=I.text(j.text);break}case"html":{P+=I.html(j.text);break}case"link":{P+=I.link(j.href,j.title,this.parseInline(j.tokens,I));break}case"image":{P+=I.image(j.href,j.title,j.text);break}case"strong":{P+=I.strong(this.parseInline(j.tokens,I));break}case"em":{P+=I.em(this.parseInline(j.tokens,I));break}case"codespan":{P+=I.codespan(j.text);break}case"br":{P+=I.br();break}case"del":{P+=I.del(this.parseInline(j.tokens,I));break}case"text":{P+=I.text(j.text);break}default:{var ue='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return P},k}();function le(k,O,W){if(typeof k>"u"||k===null)throw new Error("marked(): input parameter is undefined or null");if(typeof k!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(k)+", string expected");if(typeof O=="function"&&(W=O,O=null),O=p({},le.defaults,O||{}),ee(O),W){var S=O.highlight,I;try{I=ye.lex(k,O)}catch(re){return W(re)}var P=function(ue){var De;if(!ue)try{O.walkTokens&&le.walkTokens(I,O.walkTokens),De=fe.parse(I,O)}catch(Ee){ue=Ee}return O.highlight=S,ue?W(ue):W(null,De)};if(!S||S.length<3||(delete O.highlight,!I.length))return P();var R=0;le.walkTokens(I,function(re){re.type==="code"&&(R++,setTimeout(function(){S(re.text,re.lang,function(ue,De){if(ue)return P(ue);De!=null&&De!==re.text&&(re.text=De,re.escaped=!0),R--,R===0&&P()})},0))}),R===0&&P();return}function j(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(re.message+"",!0)+"</pre>";throw re}try{var Q=ye.lex(k,O);if(O.walkTokens){if(O.async)return Promise.all(le.walkTokens(Q,O.walkTokens)).then(function(){return fe.parse(Q,O)}).catch(j);le.walkTokens(Q,O.walkTokens)}return fe.parse(Q,O)}catch(re){j(re)}}le.options=le.setOptions=function(k){return p(le.defaults,k),w(le.defaults),le},le.getDefaults=y,le.defaults=X.defaults,le.use=function(){for(var k=arguments.length,O=new Array(k),W=0;W<k;W++)O[W]=arguments[W];var S=p.apply(void 0,[{}].concat(O)),I=le.defaults.extensions||{renderers:{},childTokens:{}},P;O.forEach(function(R){if(R.extensions&&(P=!0,R.extensions.forEach(function(Q){if(!Q.name)throw new Error("extension name required");if(Q.renderer){var re=I.renderers?I.renderers[Q.name]:null;re?I.renderers[Q.name]=function(){for(var ue=arguments.length,De=new Array(ue),Ee=0;Ee<ue;Ee++)De[Ee]=arguments[Ee];var Ie=Q.renderer.apply(this,De);return Ie===!1&&(Ie=re.apply(this,De)),Ie}:I.renderers[Q.name]=Q.renderer}if(Q.tokenizer){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");I[Q.level]?I[Q.level].unshift(Q.tokenizer):I[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?I.startBlock?I.startBlock.push(Q.start):I.startBlock=[Q.start]:Q.level==="inline"&&(I.startInline?I.startInline.push(Q.start):I.startInline=[Q.start]))}Q.childTokens&&(I.childTokens[Q.name]=Q.childTokens)})),R.renderer&&function(){var Q=le.defaults.renderer||new ie,re=function(Ee){var Ie=Q[Ee];Q[Ee]=function(){for(var ke=arguments.length,ve=new Array(ke),Pe=0;Pe<ke;Pe++)ve[Pe]=arguments[Pe];var Re=R.renderer[Ee].apply(Q,ve);return Re===!1&&(Re=Ie.apply(Q,ve)),Re}};for(var ue in R.renderer)re(ue);S.renderer=Q}(),R.tokenizer&&function(){var Q=le.defaults.tokenizer||new ce,re=function(Ee){var Ie=Q[Ee];Q[Ee]=function(){for(var ke=arguments.length,ve=new Array(ke),Pe=0;Pe<ke;Pe++)ve[Pe]=arguments[Pe];var Re=R.tokenizer[Ee].apply(Q,ve);return Re===!1&&(Re=Ie.apply(Q,ve)),Re}};for(var ue in R.tokenizer)re(ue);S.tokenizer=Q}(),R.walkTokens){var j=le.defaults.walkTokens;S.walkTokens=function(Q){var re=[];return re.push(R.walkTokens.call(this,Q)),j&&(re=re.concat(j.call(this,Q))),re}}P&&(S.extensions=I),le.setOptions(S)})},le.walkTokens=function(k,O){for(var W=[],S=function(){var j=P.value;switch(W=W.concat(O.call(le,j)),j.type){case"table":{for(var Q=H(j.header),re;!(re=Q()).done;){var ue=re.value;W=W.concat(le.walkTokens(ue.tokens,O))}for(var De=H(j.rows),Ee;!(Ee=De()).done;)for(var Ie=Ee.value,ke=H(Ie),ve;!(ve=ke()).done;){var Pe=ve.value;W=W.concat(le.walkTokens(Pe.tokens,O))}break}case"list":{W=W.concat(le.walkTokens(j.items,O));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[j.type]?le.defaults.extensions.childTokens[j.type].forEach(function(Re){W=W.concat(le.walkTokens(j[Re],O))}):j.tokens&&(W=W.concat(le.walkTokens(j.tokens,O)))}},I=H(k),P;!(P=I()).done;)S();return W},le.parseInline=function(k,O){if(typeof k>"u"||k===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof k!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(k)+", string expected");O=p({},le.defaults,O||{}),ee(O);try{var W=ye.lexInline(k,O);return O.walkTokens&&le.walkTokens(W,O.walkTokens),fe.parseInline(W,O)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},le.Parser=fe,le.parser=fe.parse,le.Renderer=ie,le.TextRenderer=J,le.Lexer=ye,le.lexer=ye.lex,le.Tokenizer=ce,le.Slugger=he,le.parse=le;var te=le.options,T=le.setOptions,E=le.use,m=le.walkTokens,B=le.parseInline,z=le,$=fe.parse,G=ye.lex;X.Lexer=ye,X.Parser=fe,X.Renderer=ie,X.Slugger=he,X.TextRenderer=J,X.Tokenizer=ce,X.getDefaults=y,X.lexer=G,X.marked=le,X.options=te,X.parse=z,X.parseInline=B,X.parser=$,X.setOptions=T,X.use=E,X.walkTokens=m,Object.defineProperty(X,"__esModule",{value:!0})}),define(me[77],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class v{constructor(U,H=0,y=U.length,w=H-1){this.a=U,this.b=H,this.c=y,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=v}),define(me[78],be([1,0,77]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],w=10){this.h(y),this.b=w,this.d()}getHistory(){return this.j}add(y){this.a.delete(y),this.a.add(y),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}has(y){return this.a.has(y)}clear(){this.h([]),this.d()}d(){this.f();const y=this.j;this.c=new v.ArrayNavigator(y,0,y.length,y.length)}f(){const y=this.j;y.length>this.b&&this.h(y.slice(y.length-this.b))}g(){const y=this.c.current();return y?this.j.indexOf(y):-1}h(y){this.a=new Set;for(const w of y)this.a.add(w)}get j(){const y=[];return this.a.forEach(w=>y.push(w)),y}}t.HistoryNavigator=i;class U{constructor(y,w=10){if(this.f=w,y.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:y[0],previous:void 0,next:void 0};for(let f=1;f<y.length;f++)this.add(y[f])}add(y){const w={value:y,previous:this.b,next:void 0};for(this.b.next=w,this.b=w,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(y){const w=this.b.value;return this.b.value=y,w}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(y){let w=this.a;for(;w;){if(w.value===y)return!0;w=w.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let y=this.a;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=U}),define(me[46],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function v(w,f,g){return Math.min(Math.max(w,f),g)}t.clamp=v;function i(w,f){return(f+w%f)%f}t.rot=i;class U{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=U;class H{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=H;class y{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const g=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=y}),define(me[47],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(i){function U(f,g){if(f.start>=g.end||g.start>=f.end)return{start:0,end:0};const d=Math.max(f.start,g.start),M=Math.min(f.end,g.end);return M-d<=0?{start:0,end:0}:{start:d,end:M}}i.intersect=U;function H(f){return f.end-f.start<=0}i.isEmpty=H;function y(f,g){return!H(U(f,g))}i.intersects=y;function w(f,g){const d=[],M={start:f.start,end:Math.min(g.start,f.end)},o={start:Math.max(g.end,f.start),end:f.end};return H(M)||d.push(M),H(o)||d.push(o),d}i.relativeComplement=w})(v=t.Range||(t.Range={}))}),define(me[79],be([1,0,47]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(f,g){const d=[];for(const M of g){if(f.start>=M.range.end)continue;if(f.end<M.range.start)break;const o=v.Range.intersect(f,M.range);v.Range.isEmpty(o)||d.push({range:o,size:M.size})}return d}t.groupIntersect=i;function U({start:f,end:g},d){return{start:f+d,end:g+d}}t.shift=U;function H(f){const g=[];let d=null;for(const M of f){const o=M.range.start,n=M.range.end,e=M.size;if(d&&e===d.size){d.range.end=n;continue}d={range:{start:o,end:n},size:e},g.push(d)}return g}t.consolidate=H;function y(...f){return H(f.reduce((g,d)=>g.concat(d),[]))}class w{constructor(){this.a=[],this.b=0}splice(g,d,M=[]){const o=M.length-d,n=i({start:0,end:g},this.a),e=i({start:g+d,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:U(l.range,o),size:l.size})),s=M.map((l,a)=>({range:{start:g+a,end:g+a+1},size:l.size}));this.a=y(n,s,e),this.b=this.a.reduce((l,a)=>l+a.size*(a.range.end-a.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;let d=0,M=0;for(const o of this.a){const n=o.range.end-o.range.start,e=M+n*o.size;if(g<e)return d+Math.floor((g-M)/o.size);d+=n,M=e}return d}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let d=0,M=0;for(const o of this.a){const n=o.range.end-o.range.start,e=M+n;if(g<e)return d+(g-M)*o.size;d+=n*o.size,M=e}return-1}}t.RangeMap=w}),define(me[80],be([1,0,9,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function U(h){const b=h;return b?typeof b.read=="function":!1}t.isReadable=U;function H(h){const b=h;return b?[b.on,b.pause,b.resume,b.destroy].every(A=>typeof A=="function"):!1}t.isReadableStream=H;function y(h){const b=h;return b?H(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.isReadableBufferedStream=y;function w(h,b){return new f(h,b)}t.newWriteableStream=w;class f{constructor(b,A){this.e=b,this.f=A,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(A=>this.d.push(A))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(A=>A(b))}h(b){this.c.error.length===0?(0,v.onUnexpectedError)(b):this.c.error.slice(0).forEach(A=>A(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,A){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(A),this.resume();break;case"end":this.c.end.push(A),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(A),this.a.flowing&&this.k();break}}removeListener(b,A){if(this.a.destroyed)return;let L;switch(b){case"data":L=this.c.data;break;case"end":L=this.c.end;break;case"error":L=this.c.error;break}if(L){const N=L.indexOf(A);N>=0&&L.splice(N,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const A=[...this.d];this.d.length=0,A.forEach(L=>L())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(h,b){const A=[];let L;for(;(L=h.read())!==null;)A.push(L);return b(A)}t.consumeReadable=g;function d(h,b,A){const L=[];let N;for(;(N=h.read())!==null&&L.length<A;)L.push(N);return N===null&&L.length>0?b(L):{read:()=>{if(L.length>0)return L.shift();if(typeof N<"u"){const F=N;return N=void 0,F}return h.read()}}}t.peekReadable=d;function M(h,b){return new Promise((A,L)=>{const N=[];o(h,{onData:F=>{b&&N.push(F)},onError:F=>{b?L(F):A(void 0)},onEnd:()=>{A(b?b(N):void 0)}})})}t.consumeStream=M;function o(h,b){let A=!1;return h.on("error",L=>{A||b.onError(L)}),h.on("end",()=>{A||b.onEnd()}),h.on("data",L=>{A||b.onData(L)}),(0,i.toDisposable)(()=>A=!0)}t.listenStream=o;function n(h,b){return new Promise((A,L)=>{const N=new i.DisposableStore,F=[],u=D=>{if(F.push(D),F.length>b)return N.dispose(),h.pause(),A({stream:h,buffer:F,ended:!1})},C=D=>L(D),p=()=>A({stream:h,buffer:F,ended:!0});N.add((0,i.toDisposable)(()=>h.removeListener("error",C))),h.on("error",C),N.add((0,i.toDisposable)(()=>h.removeListener("end",p))),h.on("end",p),N.add((0,i.toDisposable)(()=>h.removeListener("data",u))),h.on("data",u)})}t.peekStream=n;function e(h,b){const A=w(b);return A.end(h),A}t.toStream=e;function s(){const h=w(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=s;function l(h){let b=!1;return{read:()=>b?null:(b=!0,h)}}t.toReadable=l;function a(h,b,A){const L=w(A);return o(h,{onData:N=>L.write(b.data(N)),onError:N=>L.error(b.error?b.error(N):N),onEnd:()=>L.end()}),L}t.transform=a;function c(h,b,A){let L=!1;return{read:()=>{const N=b.read();return L?N:(L=!0,N!==null?A([h,N]):h)}}}t.prefixedReadable=c;function r(h,b,A){let L=!1;const N=w(A);return o(b,{onData:F=>L?N.write(F):(L=!0,N.write(A([h,F]))),onError:F=>N.error(F),onEnd:()=>{L||(L=!0,N.write(h)),N.end()}}),N}t.prefixedStream=r}),define(me[29],be([1,0,80]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let U,H;class y{static alloc(D){return i?new y(Buffer.allocUnsafe(D)):new y(new Uint8Array(D))}static wrap(D){return i&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new y(D)}static fromString(D,_){return!(_?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(D)):(U||(U=new TextEncoder),new y(U.encode(D)))}static fromByteArray(D){const _=y.alloc(D.length);for(let V=0,ee=D.length;V<ee;V++)_.buffer[V]=D[V];return _}static concat(D,_){if(typeof _>"u"){_=0;for(let Z=0,pe=D.length;Z<pe;Z++)_+=D[Z].byteLength}const V=y.alloc(_);let ee=0;for(let Z=0,pe=D.length;Z<pe;Z++){const oe=D[Z];V.set(oe,ee),ee+=oe.byteLength}return V}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=y.alloc(this.byteLength);return D.set(this),D}toString(){return i?this.buffer.toString():(H||(H=new TextDecoder),H.decode(this.buffer))}slice(D,_){return new y(this.buffer.subarray(D,_))}set(D,_){if(D instanceof y)this.buffer.set(D.buffer,_);else if(D instanceof Uint8Array)this.buffer.set(D,_);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),_);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return g(this.buffer,D)}writeUInt32BE(D,_){d(this.buffer,D,_)}readUInt32LE(D){return M(this.buffer,D)}writeUInt32LE(D,_){o(this.buffer,D,_)}readUInt8(D){return n(this.buffer,D)}writeUInt8(D,_){e(this.buffer,D,_)}}t.VSBuffer=y;function w(p,D){return p[D+0]<<0>>>0|p[D+1]<<8>>>0}t.readUInt16LE=w;function f(p,D,_){p[_+0]=D&255,D=D>>>8,p[_+1]=D&255}t.writeUInt16LE=f;function g(p,D){return p[D]*2**24+p[D+1]*2**16+p[D+2]*2**8+p[D+3]}t.readUInt32BE=g;function d(p,D,_){p[_+3]=D,D=D>>>8,p[_+2]=D,D=D>>>8,p[_+1]=D,D=D>>>8,p[_]=D}t.writeUInt32BE=d;function M(p,D){return p[D+0]<<0>>>0|p[D+1]<<8>>>0|p[D+2]<<16>>>0|p[D+3]<<24>>>0}t.readUInt32LE=M;function o(p,D,_){p[_+0]=D&255,D=D>>>8,p[_+1]=D&255,D=D>>>8,p[_+2]=D&255,D=D>>>8,p[_+3]=D&255}t.writeUInt32LE=o;function n(p,D){return p[D]}t.readUInt8=n;function e(p,D,_){p[_]=D}t.writeUInt8=e;function s(p){return v.consumeReadable(p,D=>y.concat(D))}t.readableToBuffer=s;function l(p){return v.toReadable(p)}t.bufferToReadable=l;function a(p){return v.consumeStream(p,D=>y.concat(D))}t.streamToBuffer=a;async function c(p){return p.ended?y.concat(p.buffer):y.concat([...p.buffer,await a(p.stream)])}t.bufferedStreamToBuffer=c;function r(p){return v.toStream(p,D=>y.concat(D))}t.bufferToStream=r;function h(p){return v.transform(p,{data:D=>typeof D=="string"?y.fromString(D):y.wrap(D)},D=>y.concat(D))}t.streamToBufferReadableStream=h;function b(p){return v.newWriteableStream(D=>y.concat(D),p)}t.newWriteableBufferStream=b;function A(p,D){return v.prefixedReadable(p,D,_=>y.concat(_))}t.prefixedBufferReadable=A;function L(p,D){return v.prefixedStream(p,D,_=>y.concat(_))}t.prefixedBufferStream=L;function N(p){let D=0,_=0,V=0;const ee=new Uint8Array(Math.floor(p.length/4*3)),Z=oe=>{switch(_){case 3:ee[V++]=D|oe,_=0;break;case 2:ee[V++]=D|oe>>>2,D=oe<<6,_=3;break;case 1:ee[V++]=D|oe>>>4,D=oe<<4,_=2;break;default:D=oe<<2,_=1}};for(let oe=0;oe<p.length;oe++){const ce=p.charCodeAt(oe);if(ce>=65&&ce<=90)Z(ce-65);else if(ce>=97&&ce<=122)Z(ce-97+26);else if(ce>=48&&ce<=57)Z(ce-48+52);else if(ce===43||ce===45)Z(62);else if(ce===47||ce===95)Z(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${p[oe]}`)}}const pe=V;for(;_>0;)Z(0);return y.wrap(ee).slice(0,pe)}t.decodeBase64=N;const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:p},D=!0,_=!1){const V=_?u:F;let ee="";const Z=p.byteLength%3;let pe=0;for(;pe<p.byteLength-Z;pe+=3){const oe=p[pe+0],ce=p[pe+1],ae=p[pe+2];ee+=V[oe>>>2],ee+=V[(oe<<4|ce>>>4)&63],ee+=V[(ce<<2|ae>>>6)&63],ee+=V[ae&63]}if(Z===1){const oe=p[pe+0];ee+=V[oe>>>2],ee+=V[oe<<4&63],D&&(ee+="==")}else if(Z===2){const oe=p[pe+0],ce=p[pe+1];ee+=V[oe>>>2],ee+=V[(oe<<4|ce>>>4)&63],ee+=V[ce<<2&63],D&&(ee+="=")}return ee}t.encodeBase64=C}),define(me[6],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function v(L){return typeof L=="string"}t.isString=v;function i(L){return Array.isArray(L)&&L.every(N=>v(N))}t.isStringArray=i;function U(L){return typeof L=="object"&&L!==null&&!Array.isArray(L)&&!(L instanceof RegExp)&&!(L instanceof Date)}t.isObject=U;function H(L){const N=Object.getPrototypeOf(Uint8Array);return typeof L=="object"&&L instanceof N}t.isTypedArray=H;function y(L){return typeof L=="number"&&!isNaN(L)}t.isNumber=y;function w(L){return!!L&&typeof L[Symbol.iterator]=="function"}t.isIterable=w;function f(L){return L===!0||L===!1}t.isBoolean=f;function g(L){return typeof L>"u"}t.isUndefined=g;function d(L){return!M(L)}t.isDefined=d;function M(L){return g(L)||L===null}t.isUndefinedOrNull=M;function o(L,N){if(!L)throw new Error(N?`Unexpected type, expected '${N}'`:"Unexpected type")}t.assertType=o;function n(L){if(M(L))throw new Error("Assertion Failed: argument is undefined or null");return L}t.assertIsDefined=n;function e(...L){const N=[];for(let F=0;F<L.length;F++){const u=L[F];if(M(u))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);N.push(u)}return N}t.assertAllDefined=e;const s=Object.prototype.hasOwnProperty;function l(L){if(!U(L))return!1;for(const N in L)if(s.call(L,N))return!1;return!0}t.isEmptyObject=l;function a(L){return typeof L=="function"}t.isFunction=a;function c(...L){return L.length>0&&L.every(a)}t.areFunctions=c;function r(L,N){const F=Math.min(L.length,N.length);for(let u=0;u<F;u++)h(L[u],N[u])}t.validateConstraints=r;function h(L,N){if(v(N)){if(typeof L!==N)throw new Error(`argument does not match constraint: typeof ${N}`)}else if(a(N)){try{if(L instanceof N)return}catch{}if(!M(L)&&L.constructor===N||N.length===1&&N.call(void 0,L)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=h;function b(L){return L===null?void 0:L}t.withNullAsUndefined=b;function A(L){return typeof L>"u"?null:L}t.withUndefinedAsNull=A}),define(me[30],be([1,0,6]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const c=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([r,h])=>{c[r]=h&&typeof h=="object"?i(h):h}),c}t.deepClone=i;function U(a){if(!a||typeof a!="object")return a;const c=[a];for(;c.length>0;){const r=c.shift();Object.freeze(r);for(const h in r)if(H.call(r,h)){const b=r[h];typeof b=="object"&&!Object.isFrozen(b)&&!(0,v.isTypedArray)(b)&&c.push(b)}}return a}t.deepFreeze=U;const H=Object.prototype.hasOwnProperty;function y(a,c){return w(a,c,new Set)}t.cloneAndChange=y;function w(a,c,r){if((0,v.isUndefinedOrNull)(a))return a;const h=c(a);if(typeof h<"u")return h;if(Array.isArray(a)){const b=[];for(const A of a)b.push(w(A,c,r));return b}if((0,v.isObject)(a)){if(r.has(a))throw new Error("Cannot clone recursive data-structure");r.add(a);const b={};for(const A in a)H.call(a,A)&&(b[A]=w(a[A],c,r));return r.delete(a),b}return a}function f(a,c,r=!0){return(0,v.isObject)(a)?((0,v.isObject)(c)&&Object.keys(c).forEach(h=>{h in a?r&&((0,v.isObject)(a[h])&&(0,v.isObject)(c[h])?f(a[h],c[h],r):a[h]=c[h]):a[h]=c[h]}),a):c}t.mixin=f;function g(a,c){if(a===c)return!0;if(a==null||c===null||c===void 0||typeof a!=typeof c||typeof a!="object"||Array.isArray(a)!==Array.isArray(c))return!1;let r,h;if(Array.isArray(a)){if(a.length!==c.length)return!1;for(r=0;r<a.length;r++)if(!g(a[r],c[r]))return!1}else{const b=[];for(h in a)b.push(h);b.sort();const A=[];for(h in c)A.push(h);if(A.sort(),!g(b,A))return!1;for(r=0;r<b.length;r++)if(!g(a[b[r]],c[b[r]]))return!1}return!0}t.equals=g;function d(a){const c=new Set;return JSON.stringify(a,(r,h)=>{if((0,v.isObject)(h)||Array.isArray(h)){if(c.has(h))return"[Circular]";c.add(h)}return h})}t.safeStringify=d;function M(a,c){const r=Object.create(null);return!a||!c||Object.keys(c).forEach(b=>{const A=a[b],L=c[b];g(A,L)||(r[b]=L)}),r}t.distinct=M;function o(a,c){const r=c.toLowerCase(),h=Object.keys(a).find(b=>b.toLowerCase()===r);return h?a[h]:a[c]}t.getCaseInsensitive=o;function n(a,c){const r=Object.create(null);for(const[h,b]of Object.entries(a))c(h,b)&&(r[h]=b);return r}t.filter=n;function e(a){let c=[],r=Object.getPrototypeOf(a);for(;Object.prototype!==r;)c=c.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return c}t.getAllPropertyNames=e;function s(a){const c=[];for(const r of e(a))typeof a[r]=="function"&&c.push(r);return c}t.getAllMethodNames=s;function l(a,c){const r=b=>function(){const A=Array.prototype.slice.call(arguments,0);return c(b,A)},h={};for(const b of a)h[b]=r(b);return h}t.createProxyObject=l}),define(me[81],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[82],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class v{constructor(U,H){this.a=U,this.onMessage=H}send(U){try{this.a.send("vscode:message",U.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=v}),define(me[48],be([7]),{}),define(me[83],be([7]),{}),define(me[84],be([7]),{}),define(me[85],be([7]),{}),define(me[86],be([1,0,12,84,85]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(U){let H=U.definition;for(;H instanceof v.Codicon;)H=H.definition;return`.codicon-${U.id}:before { content: '${H.fontCharacter}'; }`}t.formatRule=i}),define(me[87],be([7]),{}),define(me[88],be([7]),{}),define(me[89],be([7]),{}),define(me[90],be([7]),{}),define(me[91],be([7]),{}),define(me[92],be([7]),{}),define(me[93],be([7]),{}),define(me[94],be([7]),{}),define(me[95],be([7]),{}),define(me[96],be([13,10]),function(X,t){return X.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[97],be([13,10]),function(X,t){return X.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[98],be([13,10]),function(X,t){return X.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[99],be([13,10]),function(X,t){return X.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[100],be([13,10]),function(X,t){return X.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[101],be([13,10]),function(X,t){return X.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[102],be([13,10]),function(X,t){return X.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[103],be([13,10]),function(X,t){return X.create("vs/base/common/actions",t)}),define(me[104],be([13,10]),function(X,t){return X.create("vs/base/common/platform",t)}),define(me[5],be([1,0,104]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,U=!1,H=!1,y=!1,w=!1,f=!1,g=!1,d=!1,M=!1,o=!1,n,e=t.LANGUAGE_DEFAULT,s,l;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?a=t.globals.vscode.process:typeof process<"u"&&(a=process);const c=typeof a?.versions?.electron=="string",r=c&&a?.type==="renderer";if(typeof navigator=="object"&&!r)l=navigator.userAgent,i=l.indexOf("Windows")>=0,U=l.indexOf("Macintosh")>=0,d=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=l.indexOf("Linux")>=0,o=l?.indexOf("Mobi")>=0,f=!0,n=v.getConfiguredDefaultLocale(v.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof a=="object"){i=a.platform==="win32",U=a.platform==="darwin",H=a.platform==="linux",y=H&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,g=c,M=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const p=a.env.VSCODE_NLS_CONFIG;if(p)try{const D=JSON.parse(p),_=D.availableLanguages["*"];n=D.locale,e=_||t.LANGUAGE_DEFAULT,s=D._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var h;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(h=t.Platform||(t.Platform={}));function b(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=b;let A=0;U?A=1:i?A=3:H&&(A=2),t.isWindows=i,t.isMacintosh=U,t.isLinux=H,t.isLinuxSnap=y,t.isNative=w,t.isElectron=g,t.isWeb=f,t.isWebWorker=f&&typeof t.globals.importScripts=="function",t.isIOS=d,t.isMobile=o,t.isCI=M,t.platform=A,t.userAgent=l,t.language=e;var L;(function(p){function D(){return t.language}p.value=D;function _(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}p.isDefaultVariant=_;function V(){return t.language==="en"}p.isDefault=V})(L=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];t.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let V=0,ee=p.length;V<ee;V++){const Z=p[V];if(Z.id===_.data.vscodeScheduleAsyncWork){p.splice(V,1),Z.callback();return}}});let D=0;return _=>{const V=++D;p.push({id:V,callback:_}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return p=>setTimeout(p)})();var N;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(N=t.OperatingSystem||(t.OperatingSystem={})),t.OS=U||d?2:i?1:3;let F=!0,u=!1;function C(){if(!u){u=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,F=new Uint16Array(p.buffer)[0]===(2<<8)+1}return F}t.isLittleEndian=C,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[105],be([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const U=v.globals.vscode.process;i={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],be([1,0,105]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,U=97,H=90,y=122,w=46,f=47,g=92,d=58,M=63;class o extends Error{constructor(h,b,A){let L;typeof b=="string"&&b.indexOf("not ")===0?(L="must not be",b=b.replace(/^not /,"")):L="must be";const N=h.indexOf(".")!==-1?"property":"argument";let F=`The "${h}" ${N} ${L} of type ${b}`;F+=`. Received type ${typeof A}`,super(F),this.code="ERR_INVALID_ARG_TYPE"}}function n(r,h){if(typeof r!="string")throw new o(h,"string",r)}function e(r){return r===f||r===g}function s(r){return r===f}function l(r){return r>=i&&r<=H||r>=U&&r<=y}function a(r,h,b,A){let L="",N=0,F=-1,u=0,C=0;for(let p=0;p<=r.length;++p){if(p<r.length)C=r.charCodeAt(p);else{if(A(C))break;C=f}if(A(C)){if(!(F===p-1||u===1))if(u===2){if(L.length<2||N!==2||L.charCodeAt(L.length-1)!==w||L.charCodeAt(L.length-2)!==w){if(L.length>2){const D=L.lastIndexOf(b);D===-1?(L="",N=0):(L=L.slice(0,D),N=L.length-1-L.lastIndexOf(b)),F=p,u=0;continue}else if(L.length!==0){L="",N=0,F=p,u=0;continue}}h&&(L+=L.length>0?`${b}..`:"..",N=2)}else L.length>0?L+=`${b}${r.slice(F+1,p)}`:L=r.slice(F+1,p),N=p-F-1;F=p,u=0}else C===w&&u!==-1?++u:u=-1}return L}function c(r,h){if(h===null||typeof h!="object")throw new o("pathObject","Object",h);const b=h.dir||h.root,A=h.base||`${h.name||""}${h.ext||""}`;return b?b===h.root?`${b}${A}`:`${b}${r}${A}`:A}t.win32={resolve(...r){let h="",b="",A=!1;for(let L=r.length-1;L>=-1;L--){let N;if(L>=0){if(N=r[L],n(N,"path"),N.length===0)continue}else h.length===0?N=v.cwd():(N=v.env[`=${h}`]||v.cwd(),(N===void 0||N.slice(0,2).toLowerCase()!==h.toLowerCase()&&N.charCodeAt(2)===g)&&(N=`${h}\\`));const F=N.length;let u=0,C="",p=!1;const D=N.charCodeAt(0);if(F===1)e(D)&&(u=1,p=!0);else if(e(D))if(p=!0,e(N.charCodeAt(1))){let _=2,V=_;for(;_<F&&!e(N.charCodeAt(_));)_++;if(_<F&&_!==V){const ee=N.slice(V,_);for(V=_;_<F&&e(N.charCodeAt(_));)_++;if(_<F&&_!==V){for(V=_;_<F&&!e(N.charCodeAt(_));)_++;(_===F||_!==V)&&(C=`\\\\${ee}\\${N.slice(V,_)}`,u=_)}}}else u=1;else l(D)&&N.charCodeAt(1)===d&&(C=N.slice(0,2),u=2,F>2&&e(N.charCodeAt(2))&&(p=!0,u=3));if(C.length>0)if(h.length>0){if(C.toLowerCase()!==h.toLowerCase())continue}else h=C;if(A){if(h.length>0)break}else if(b=`${N.slice(u)}\\${b}`,A=p,p&&h.length>0)break}return b=a(b,!A,"\\",e),A?`${h}\\${b}`:`${h}${b}`||"."},normalize(r){n(r,"path");const h=r.length;if(h===0)return".";let b=0,A,L=!1;const N=r.charCodeAt(0);if(h===1)return s(N)?"\\":r;if(e(N))if(L=!0,e(r.charCodeAt(1))){let u=2,C=u;for(;u<h&&!e(r.charCodeAt(u));)u++;if(u<h&&u!==C){const p=r.slice(C,u);for(C=u;u<h&&e(r.charCodeAt(u));)u++;if(u<h&&u!==C){for(C=u;u<h&&!e(r.charCodeAt(u));)u++;if(u===h)return`\\\\${p}\\${r.slice(C)}\\`;u!==C&&(A=`\\\\${p}\\${r.slice(C,u)}`,b=u)}}}else b=1;else l(N)&&r.charCodeAt(1)===d&&(A=r.slice(0,2),b=2,h>2&&e(r.charCodeAt(2))&&(L=!0,b=3));let F=b<h?a(r.slice(b),!L,"\\",e):"";return F.length===0&&!L&&(F="."),F.length>0&&e(r.charCodeAt(h-1))&&(F+="\\"),A===void 0?L?`\\${F}`:F:L?`${A}\\${F}`:`${A}${F}`},isAbsolute(r){n(r,"path");const h=r.length;if(h===0)return!1;const b=r.charCodeAt(0);return e(b)||h>2&&l(b)&&r.charCodeAt(1)===d&&e(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let h,b;for(let N=0;N<r.length;++N){const F=r[N];n(F,"path"),F.length>0&&(h===void 0?h=b=F:h+=`\\${F}`)}if(h===void 0)return".";let A=!0,L=0;if(typeof b=="string"&&e(b.charCodeAt(0))){++L;const N=b.length;N>1&&e(b.charCodeAt(1))&&(++L,N>2&&(e(b.charCodeAt(2))?++L:A=!1))}if(A){for(;L<h.length&&e(h.charCodeAt(L));)L++;L>=2&&(h=`\\${h.slice(L)}`)}return t.win32.normalize(h)},relative(r,h){if(n(r,"from"),n(h,"to"),r===h)return"";const b=t.win32.resolve(r),A=t.win32.resolve(h);if(b===A||(r=b.toLowerCase(),h=A.toLowerCase(),r===h))return"";let L=0;for(;L<r.length&&r.charCodeAt(L)===g;)L++;let N=r.length;for(;N-1>L&&r.charCodeAt(N-1)===g;)N--;const F=N-L;let u=0;for(;u<h.length&&h.charCodeAt(u)===g;)u++;let C=h.length;for(;C-1>u&&h.charCodeAt(C-1)===g;)C--;const p=C-u,D=F<p?F:p;let _=-1,V=0;for(;V<D;V++){const Z=r.charCodeAt(L+V);if(Z!==h.charCodeAt(u+V))break;Z===g&&(_=V)}if(V!==D){if(_===-1)return A}else{if(p>D){if(h.charCodeAt(u+V)===g)return A.slice(u+V+1);if(V===2)return A.slice(u+V)}F>D&&(r.charCodeAt(L+V)===g?_=V:V===2&&(_=3)),_===-1&&(_=0)}let ee="";for(V=L+_+1;V<=N;++V)(V===N||r.charCodeAt(V)===g)&&(ee+=ee.length===0?"..":"\\..");return u+=_,ee.length>0?`${ee}${A.slice(u,C)}`:(A.charCodeAt(u)===g&&++u,A.slice(u,C))},toNamespacedPath(r){if(typeof r!="string")return r;if(r.length===0)return"";const h=t.win32.resolve(r);if(h.length<=2)return r;if(h.charCodeAt(0)===g){if(h.charCodeAt(1)===g){const b=h.charCodeAt(2);if(b!==M&&b!==w)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(l(h.charCodeAt(0))&&h.charCodeAt(1)===d&&h.charCodeAt(2)===g)return`\\\\?\\${h}`;return r},dirname(r){n(r,"path");const h=r.length;if(h===0)return".";let b=-1,A=0;const L=r.charCodeAt(0);if(h===1)return e(L)?r:".";if(e(L)){if(b=A=1,e(r.charCodeAt(1))){let u=2,C=u;for(;u<h&&!e(r.charCodeAt(u));)u++;if(u<h&&u!==C){for(C=u;u<h&&e(r.charCodeAt(u));)u++;if(u<h&&u!==C){for(C=u;u<h&&!e(r.charCodeAt(u));)u++;if(u===h)return r;u!==C&&(b=A=u+1)}}}}else l(L)&&r.charCodeAt(1)===d&&(b=h>2&&e(r.charCodeAt(2))?3:2,A=b);let N=-1,F=!0;for(let u=h-1;u>=A;--u)if(e(r.charCodeAt(u))){if(!F){N=u;break}}else F=!1;if(N===-1){if(b===-1)return".";N=b}return r.slice(0,N)},basename(r,h){h!==void 0&&n(h,"ext"),n(r,"path");let b=0,A=-1,L=!0,N;if(r.length>=2&&l(r.charCodeAt(0))&&r.charCodeAt(1)===d&&(b=2),h!==void 0&&h.length>0&&h.length<=r.length){if(h===r)return"";let F=h.length-1,u=-1;for(N=r.length-1;N>=b;--N){const C=r.charCodeAt(N);if(e(C)){if(!L){b=N+1;break}}else u===-1&&(L=!1,u=N+1),F>=0&&(C===h.charCodeAt(F)?--F===-1&&(A=N):(F=-1,A=u))}return b===A?A=u:A===-1&&(A=r.length),r.slice(b,A)}for(N=r.length-1;N>=b;--N)if(e(r.charCodeAt(N))){if(!L){b=N+1;break}}else A===-1&&(L=!1,A=N+1);return A===-1?"":r.slice(b,A)},extname(r){n(r,"path");let h=0,b=-1,A=0,L=-1,N=!0,F=0;r.length>=2&&r.charCodeAt(1)===d&&l(r.charCodeAt(0))&&(h=A=2);for(let u=r.length-1;u>=h;--u){const C=r.charCodeAt(u);if(e(C)){if(!N){A=u+1;break}continue}L===-1&&(N=!1,L=u+1),C===w?b===-1?b=u:F!==1&&(F=1):b!==-1&&(F=-1)}return b===-1||L===-1||F===0||F===1&&b===L-1&&b===A+1?"":r.slice(b,L)},format:c.bind(null,"\\"),parse(r){n(r,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return h;const b=r.length;let A=0,L=r.charCodeAt(0);if(b===1)return e(L)?(h.root=h.dir=r,h):(h.base=h.name=r,h);if(e(L)){if(A=1,e(r.charCodeAt(1))){let _=2,V=_;for(;_<b&&!e(r.charCodeAt(_));)_++;if(_<b&&_!==V){for(V=_;_<b&&e(r.charCodeAt(_));)_++;if(_<b&&_!==V){for(V=_;_<b&&!e(r.charCodeAt(_));)_++;_===b?A=_:_!==V&&(A=_+1)}}}}else if(l(L)&&r.charCodeAt(1)===d){if(b<=2)return h.root=h.dir=r,h;if(A=2,e(r.charCodeAt(2))){if(b===3)return h.root=h.dir=r,h;A=3}}A>0&&(h.root=r.slice(0,A));let N=-1,F=A,u=-1,C=!0,p=r.length-1,D=0;for(;p>=A;--p){if(L=r.charCodeAt(p),e(L)){if(!C){F=p+1;break}continue}u===-1&&(C=!1,u=p+1),L===w?N===-1?N=p:D!==1&&(D=1):N!==-1&&(D=-1)}return u!==-1&&(N===-1||D===0||D===1&&N===u-1&&N===F+1?h.base=h.name=r.slice(F,u):(h.name=r.slice(F,N),h.base=r.slice(F,u),h.ext=r.slice(N,u))),F>0&&F!==A?h.dir=r.slice(0,F-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...r){let h="",b=!1;for(let A=r.length-1;A>=-1&&!b;A--){const L=A>=0?r[A]:v.cwd();n(L,"path"),L.length!==0&&(h=`${L}/${h}`,b=L.charCodeAt(0)===f)}return h=a(h,!b,"/",s),b?`/${h}`:h.length>0?h:"."},normalize(r){if(n(r,"path"),r.length===0)return".";const h=r.charCodeAt(0)===f,b=r.charCodeAt(r.length-1)===f;return r=a(r,!h,"/",s),r.length===0?h?"/":b?"./":".":(b&&(r+="/"),h?`/${r}`:r)},isAbsolute(r){return n(r,"path"),r.length>0&&r.charCodeAt(0)===f},join(...r){if(r.length===0)return".";let h;for(let b=0;b<r.length;++b){const A=r[b];n(A,"path"),A.length>0&&(h===void 0?h=A:h+=`/${A}`)}return h===void 0?".":t.posix.normalize(h)},relative(r,h){if(n(r,"from"),n(h,"to"),r===h||(r=t.posix.resolve(r),h=t.posix.resolve(h),r===h))return"";const b=1,A=r.length,L=A-b,N=1,F=h.length-N,u=L<F?L:F;let C=-1,p=0;for(;p<u;p++){const _=r.charCodeAt(b+p);if(_!==h.charCodeAt(N+p))break;_===f&&(C=p)}if(p===u)if(F>u){if(h.charCodeAt(N+p)===f)return h.slice(N+p+1);if(p===0)return h.slice(N+p)}else L>u&&(r.charCodeAt(b+p)===f?C=p:p===0&&(C=0));let D="";for(p=b+C+1;p<=A;++p)(p===A||r.charCodeAt(p)===f)&&(D+=D.length===0?"..":"/..");return`${D}${h.slice(N+C)}`},toNamespacedPath(r){return r},dirname(r){if(n(r,"path"),r.length===0)return".";const h=r.charCodeAt(0)===f;let b=-1,A=!0;for(let L=r.length-1;L>=1;--L)if(r.charCodeAt(L)===f){if(!A){b=L;break}}else A=!1;return b===-1?h?"/":".":h&&b===1?"//":r.slice(0,b)},basename(r,h){h!==void 0&&n(h,"ext"),n(r,"path");let b=0,A=-1,L=!0,N;if(h!==void 0&&h.length>0&&h.length<=r.length){if(h===r)return"";let F=h.length-1,u=-1;for(N=r.length-1;N>=0;--N){const C=r.charCodeAt(N);if(C===f){if(!L){b=N+1;break}}else u===-1&&(L=!1,u=N+1),F>=0&&(C===h.charCodeAt(F)?--F===-1&&(A=N):(F=-1,A=u))}return b===A?A=u:A===-1&&(A=r.length),r.slice(b,A)}for(N=r.length-1;N>=0;--N)if(r.charCodeAt(N)===f){if(!L){b=N+1;break}}else A===-1&&(L=!1,A=N+1);return A===-1?"":r.slice(b,A)},extname(r){n(r,"path");let h=-1,b=0,A=-1,L=!0,N=0;for(let F=r.length-1;F>=0;--F){const u=r.charCodeAt(F);if(u===f){if(!L){b=F+1;break}continue}A===-1&&(L=!1,A=F+1),u===w?h===-1?h=F:N!==1&&(N=1):h!==-1&&(N=-1)}return h===-1||A===-1||N===0||N===1&&h===A-1&&h===b+1?"":r.slice(h,A)},format:c.bind(null,"/"),parse(r){n(r,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return h;const b=r.charCodeAt(0)===f;let A;b?(h.root="/",A=1):A=0;let L=-1,N=0,F=-1,u=!0,C=r.length-1,p=0;for(;C>=A;--C){const D=r.charCodeAt(C);if(D===f){if(!u){N=C+1;break}continue}F===-1&&(u=!1,F=C+1),D===w?L===-1?L=C:p!==1&&(p=1):L!==-1&&(p=-1)}if(F!==-1){const D=N===0&&b?1:N;L===-1||p===0||p===1&&L===F-1&&L===N+1?h.base=h.name=r.slice(D,F):(h.name=r.slice(D,L),h.base=r.slice(D,F),h.ext=r.slice(L,F))}return N>0?h.dir=r.slice(0,N-1):b&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=v.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v.platform==="win32"?t.win32.join:t.posix.join,t.resolve=v.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=v.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=v.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=v.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=v.platform==="win32"?t.win32.extname:t.posix.extname,t.format=v.platform==="win32"?t.win32.format:t.posix.format,t.parse=v.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=v.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=v.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(me[106],be([1,0,21]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},U={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(d){const M=(0,v.extname)(d),o=i[M.toLowerCase()];return o!==void 0?o:y(d)}t.getMediaOrTextMime=H;function y(d){const M=(0,v.extname)(d);return U[M.toLowerCase()]}t.getMediaMime=y;function w(d){for(const M in U)if(U[M]===d)return M}t.getExtensionForMimeType=w;const f=/^(.+)\/(.+?)(;.+)?$/;function g(d,M){const o=f.exec(d);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:M?void 0:d}t.normalizeMimeType=g}),define(me[107],be([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=v.globals.performance&&typeof v.globals.performance.now=="function";class U{static create(y=!0){return new U(y)}constructor(y){this.a=i&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?v.globals.performance.now():Date.now()}}t.StopWatch=U}),define(me[3],be([1,0,9,42,2,45,107]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const w=!1,f=!1;var g;(function(C){C.None=()=>U.Disposable.None;function p(z){if(f){const{onDidAddListener:$}=z,G=e.create();let k=0;z.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),$?.()}}}function D(z,$){return de(z,()=>{},0,void 0,void 0,$)}C.defer=D;function _(z){return($,G=null,k)=>{let O=!1,W;return W=z(S=>{if(!O)return W?W.dispose():O=!0,$.call(G,S)},null,k),O&&W.dispose(),W}}C.once=_;function V(z,$,G){return ae((k,O=null,W)=>z(S=>k.call(O,$(S)),null,W),G)}C.map=V;function ee(z,$,G){return ae((k,O=null,W)=>z(S=>{$(S),k.call(O,S)},null,W),G)}C.forEach=ee;function Z(z,$,G){return ae((k,O=null,W)=>z(S=>$(S)&&k.call(O,S),null,W),G)}C.filter=Z;function pe(z){return z}C.signal=pe;function oe(...z){return($,G=null,k)=>(0,U.combinedDisposable)(...z.map(O=>O(W=>$.call(G,W),null,k)))}C.any=oe;function ce(z,$,G,k){let O=G;return V(z,W=>(O=$(O,W),O),k)}C.reduce=ce;function ae(z,$){let G;const k={onWillAddFirstListener(){G=z(O.fire,O)},onDidRemoveLastListener(){G?.dispose()}};$||p(k);const O=new l(k);return $?.add(O),O.event}function de(z,$,G=100,k=!1,O,W){let S,I,P,R=0;const j={leakWarningThreshold:O,onWillAddFirstListener(){S=z(re=>{R++,I=$(I,re),k&&!P&&(Q.fire(I),I=void 0),clearTimeout(P),P=setTimeout(()=>{const ue=I;I=void 0,P=void 0,(!k||R>1)&&Q.fire(ue),R=0},G)})},onDidRemoveLastListener(){S.dispose()}};W||p(j);const Q=new l(j);return W?.add(Q),Q.event}C.debounce=de;function Se(z,$=0,G){return C.debounce(z,(k,O)=>k?(k.push(O),k):[O],$,void 0,void 0,G)}C.accumulate=Se;function x(z,$=(k,O)=>k===O,G){let k=!0,O;return Z(z,W=>{const S=k||!$(W,O);return k=!1,O=W,S},G)}C.latch=x;function ye(z,$,G){return[C.filter(z,$,G),C.filter(z,k=>!$(k),G)]}C.split=ye;function ie(z,$=!1,G=[]){let k=G.slice(),O=z(I=>{k?k.push(I):S.fire(I)});const W=()=>{k?.forEach(I=>S.fire(I)),k=null},S=new l({onWillAddFirstListener(){O||(O=z(I=>S.fire(I)))},onDidAddFirstListener(){k&&($?setTimeout(W):W())},onDidRemoveLastListener(){O&&O.dispose(),O=null}});return S.event}C.buffer=ie;class J{constructor($){this.event=$,this.c=new U.DisposableStore}map($){return new J(V(this.event,$,this.c))}forEach($){return new J(ee(this.event,$,this.c))}filter($){return new J(Z(this.event,$,this.c))}reduce($,G){return new J(ce(this.event,$,G,this.c))}latch(){return new J(x(this.event,void 0,this.c))}debounce($,G=100,k=!1,O){return new J(de(this.event,$,G,k,O,this.c))}on($,G,k){return this.event($,G,k)}once($,G,k){return _(this.event)($,G,k)}dispose(){this.c.dispose()}}function he(z){return new J(z)}C.chain=he;function fe(z,$,G=k=>k){const k=(...I)=>S.fire(G(...I)),O=()=>z.on($,k),W=()=>z.removeListener($,k),S=new l({onWillAddFirstListener:O,onDidRemoveLastListener:W});return S.event}C.fromNodeEventEmitter=fe;function le(z,$,G=k=>k){const k=(...I)=>S.fire(G(...I)),O=()=>z.addEventListener($,k),W=()=>z.removeEventListener($,k),S=new l({onWillAddFirstListener:O,onDidRemoveLastListener:W});return S.event}C.fromDOMEventEmitter=le;function te(z){return new Promise($=>_(z)($))}C.toPromise=te;function T(z,$){return $(void 0),z(G=>$(G))}C.runAndSubscribe=T;function E(z,$){let G=null;function k(W){G?.dispose(),G=new U.DisposableStore,$(W,G)}k(void 0);const O=z(W=>k(W));return(0,U.toDisposable)(()=>{O.dispose(),G?.dispose()})}C.runAndSubscribeWithStore=E;class m{constructor($,G){this.obs=$,this.c=0,this.d=!1;const k={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};G||p(k),this.emitter=new l(k),G&&G.add(this.emitter)}beginUpdate($){this.c++}handleChange($,G){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function B(z,$){return new m(z,$).emitter.event}C.fromObservable=B})(g=t.Event||(t.Event={}));class d{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${d.c++}`,d.all.add(this)}start(p){this.d=new y.StopWatch(!0),this.listenerCount=p}stop(){if(this.d){const p=this.d.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=d,d.all=new Set,d.c=0;let M=-1;function o(C){const p=M;return M=C,{dispose(){M=p}}}t.setGlobalLeakWarningThreshold=o;class n{constructor(p,D=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=D,this.d=0}dispose(){this.c?.clear()}check(p,D){const _=this.threshold;if(_<=0||D<_)return;this.c||(this.c=new Map);const V=this.c.get(p.value)||0;if(this.c.set(p.value,V+1),this.d-=1,this.d<=0){this.d=_*.5;let ee,Z=0;for(const[pe,oe]of this.c)(!ee||Z<oe)&&(ee=pe,Z=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${Z}):`),console.warn(ee)}return()=>{const ee=this.c.get(p.value)||0;this.c.set(p.value,ee-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class s{constructor(p,D,_){this.callback=p,this.callbackThis=D,this.stack=_,this.subscription=new U.SafeDisposable}invoke(p){this.callback.call(this.callbackThis,p)}}class l{constructor(p){this.j=!1,this.d=p,this.f=M>0||this.d?.leakWarningThreshold?new n(this.d?.leakWarningThreshold??M):void 0,this.g=this.d?._profName?new d(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(w){const p=Array.from(this.q);queueMicrotask(()=>{for(const D of p)D.subscription.isset()&&(D.subscription.unset(),D.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(p,D,_)=>{if(this.q||(this.q=new H.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),U.Disposable.None;const V=this.q.isEmpty();V&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let ee,Z;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(Z=e.create(),ee=this.f.check(Z,this.q.size+1)),w&&(Z=Z??e.create());const pe=new s(p,D,Z),oe=this.q.push(pe);V&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,p,D);const ce=pe.subscription.set(()=>{ee?.(),this.j||(oe(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return _ instanceof U.DisposableStore?_.add(ce):Array.isArray(_)&&_.push(ce),ce}),this.l}fire(p){if(this.q){this.m||(this.m=new c);for(const D of this.q)this.m.push(this,D,p);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=l;class a{constructor(){this.c=new H.LinkedList}get size(){return this.c.size}push(p,D,_){this.c.push(new r(p,D,_))}clear(p){const D=new H.LinkedList;for(const _ of this.c)_.emitter!==p&&D.push(_);this.c=D}deliver(){for(;this.c.size>0;){const p=this.c.shift();try{p.listener.invoke(p.event)}catch(D){(0,v.onUnexpectedError)(D)}}}}t.EventDeliveryQueue=a;class c extends a{clear(p){this.c.clear()}}class r{constructor(p,D,_){this.emitter=p,this.listener=D,this.event=_}}class h extends l{async fireAsync(p,D,_){if(!!this.q){this.c||(this.c=new H.LinkedList);for(const V of this.q)this.c.push([V,p]);for(;this.c.size>0&&!D.isCancellationRequested;){const[V,ee]=this.c.shift(),Z=[],pe={...ee,token:D,waitUntil:oe=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");_&&(oe=_(oe,V.callback)),Z.push(oe)}};try{V.invoke(pe)}catch(oe){(0,v.onUnexpectedError)(oe);continue}Object.freeze(Z),await Promise.allSettled(Z).then(oe=>{for(const ce of oe)ce.status==="rejected"&&(0,v.onUnexpectedError)(ce.reason)})}}}}t.AsyncEmitter=h;class b extends l{constructor(p){super(p),this.h=0,this.s=new H.LinkedList,this.t=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.t(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.q&&(this.h!==0?this.s.push(p):super.fire(p))}}t.PauseableEmitter=b;class A extends b{constructor(p){super(p),this.c=p.delay??100}fire(p){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(p)}}t.DebounceEmitter=A;class L extends l{constructor(p){super(p),this.c=[],this.h=p?.merge}fire(p){!this.hasListeners()||(this.c.push(p),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(D=>super.fire(D)),this.c=[]}))}}t.MicrotaskEmitter=L;class N{constructor(){this.d=!1,this.f=[],this.c=new l({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(p){const D={event:p,listener:null};this.f.push(D),this.d&&this.j(D);const _=()=>{this.d&&this.k(D);const V=this.f.indexOf(D);this.f.splice(V,1)};return(0,U.toDisposable)((0,i.once)(_))}g(){this.d=!0,this.f.forEach(p=>this.j(p))}h(){this.d=!1,this.f.forEach(p=>this.k(p))}j(p){p.listener=p.event(D=>this.c.fire(D))}k(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=N;class F{constructor(){this.c=[]}wrapEvent(p){return(D,_,V)=>p(ee=>{const Z=this.c[this.c.length-1];Z?Z.push(()=>D.call(_,ee)):D.call(_,ee)},void 0,V)}bufferEvents(p){const D=[];this.c.push(D);const _=p();return this.c.pop(),D.forEach(V=>V()),_}}t.EventBufferer=F;class u{constructor(){this.c=!1,this.d=g.None,this.f=U.Disposable.None,this.g=new l({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(p){this.d=p,this.c&&(this.f.dispose(),this.f=p(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=u}),define(me[16],be([1,0,3,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOVisible=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new v.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(h,b){this.a!==h&&(this.a=h)}getZoomFactor(){return this.b}setZoomFactor(h){this.b=h}setFullscreen(h){this.c!==h&&(this.c=h,this.d.fire())}isFullscreen(){return this.c}}U.INSTANCE=new U;class H extends i.Disposable{constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(h){this.c?.removeEventListener("change",this.b),this.c=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),h&&this.a.fire()}}class y extends i.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=this.c();const h=this.B(new H);this.B(h.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const h=document.createElement("canvas").getContext("2d"),b=window.devicePixelRatio||1,A=h.webkitBackingStorePixelRatio||h.mozBackingStorePixelRatio||h.msBackingStorePixelRatio||h.oBackingStorePixelRatio||h.backingStorePixelRatio||1;return b/A}}class w{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.markAsSingleton)(new y)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function f(r,h){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",h)}t.addMatchMediaChangeListener=f,t.PixelRatio=new w;function g(r,h){U.INSTANCE.setZoomLevel(r,h)}t.setZoomLevel=g;function d(){return U.INSTANCE.getZoomLevel()}t.getZoomLevel=d;function M(){return U.INSTANCE.getZoomFactor()}t.getZoomFactor=M;function o(r){U.INSTANCE.setZoomFactor(r)}t.setZoomFactor=o;function n(r){U.INSTANCE.setFullscreen(r)}t.setFullscreen=n;function e(){return U.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=U.INSTANCE.onDidChangeFullscreen;const s=navigator.userAgent;t.isFirefox=s.indexOf("Firefox")>=0,t.isWebKit=s.indexOf("AppleWebKit")>=0,t.isChrome=s.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&s.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=s.indexOf("Electron/")>=0,t.isAndroid=s.indexOf("Android")>=0;let l=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=window.matchMedia("(display-mode: fullscreen)");l=r.matches,f(r,({matches:b})=>{l&&h.matches||(l=b)})}function a(){return l}t.isStandalone=a;function c(){return navigator?.windowControlsOverlay?.visible}t.isWCOVisible=c}),define(me[108],be([1,0,16,5]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var U;(function(H){H[H.Always=0]="Always",H[H.FullScreen=1]="FullScreen",H[H.None=2]="None"})(U=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||v.isStandalone()?0:navigator.keyboard||v.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[18],be([1,0,3]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.a.event}constructor(H,y,w){const f=g=>this.a.fire(g);this.a=new v.Emitter({onWillAddFirstListener:()=>H.addEventListener(y,f,w),onDidRemoveLastListener:()=>H.removeEventListener(y,f,w)})}dispose(){this.a.dispose()}}t.DomEmitter=i}),define(me[19],be([1,0,16,43,74,5]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(l)}const s=e.keyCode;if(s===3)return 7;if(v.isFirefox){if(s===59)return 80;if(s===107)return 81;if(s===109)return 83;if(H.isMacintosh&&s===224)return 57}else if(v.isWebKit){if(s===91)return 57;if(H.isMacintosh&&s===93)return 57;if(!H.isMacintosh&&s===92)return 57}return i.EVENT_KEY_CODE_MAP[s]||0}const w=H.isMacintosh?256:2048,f=512,g=1024,d=H.isMacintosh?2048:256;function M(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=M;function o(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class n{constructor(s){this._standardKeyboardEventBrand=!0;const l=s;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.keyCode=y(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let l=0;return this.ctrlKey&&(l|=w),this.altKey&&(l|=f),this.shiftKey&&(l|=g),this.metaKey&&(l|=d),l|=s,l}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new U.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=n}),define(me[20],be([1,0,16,67,5]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class H{constructor(g){this.timestamp=Date.now(),this.browserEvent=g,this.leftButton=g.button===0,this.middleButton=g.button===1,this.rightButton=g.button===2,this.buttons=g.buttons,this.target=g.target,this.detail=g.detail||1,g.type==="dblclick"&&(this.detail=2),this.ctrlKey=g.ctrlKey,this.shiftKey=g.shiftKey,this.altKey=g.altKey,this.metaKey=g.metaKey,typeof g.pageX=="number"?(this.posx=g.pageX,this.posy=g.pageY):(this.posx=g.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=g.clientY+document.body.scrollTop+document.documentElement.scrollTop);const d=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,g.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=H;class y extends H{constructor(g){super(g),this.dataTransfer=g.dataTransfer}}t.DragMouseEvent=y;class w{constructor(g,d=0,M=0){if(this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=M,this.deltaX=d,g){const o=g,n=g;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(g.type==="wheel"){const e=g;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!U.isMacintosh?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof o.wheelDeltaX<"u")v.isSafari&&U.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const e=g;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!U.isMacintosh?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(me[31],be([1,0,3,2,103]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class H extends i.Disposable{constructor(o,n="",e="",s=!0,l){super(),this.h=this.B(new v.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=n,this.u=e,this.w=s,this.D=l}get id(){return this.j}get label(){return this.m}set label(o){this.F(o)}F(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.G(o)}G(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.H(o)}H(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.I(o)}I(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.C}set checked(o){this.J(o)}J(o){this.C!==o&&(this.C=o,this.h.fire({checked:o}))}async run(o,n){this.D&&await this.D(o)}}t.Action=H;class y extends i.Disposable{constructor(){super(...arguments),this.f=this.B(new v.Emitter),this.onWillRun=this.f.event,this.h=this.B(new v.Emitter),this.onDidRun=this.h.event}async run(o,n){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.runAction(o,n)}catch(s){e=s}this.h.fire({action:o,error:e})}async runAction(o,n){await o.run(n)}}t.ActionRunner=y;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let n=[];for(const e of o)e.length&&(n.length?n=[...n,new w,...e]:n=e);return n}async run(){}}t.Separator=w,w.ID="vs.actions.separator";class f{get actions(){return this.a}constructor(o,n,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=n,this.class=s,this.a=e}async run(){}}t.SubmenuAction=f;class g extends H{constructor(){super(g.ID,U.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=g,g.ID="vs.actions.empty";function d(M){return{id:M.id,label:M.label,class:void 0,enabled:M.enabled??!0,checked:M.checked??!1,run:async()=>M.run(),tooltip:M.label}}t.toAction=d}),define(me[26],be([1,0,3]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,f){const g=setTimeout(w.bind(f),0);return{dispose(){clearTimeout(g)}}});var U;(function(w){function f(g){return g===w.None||g===w.Cancelled||g instanceof H?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}w.isCancellationToken=f,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(U=t.CancellationToken||(t.CancellationToken={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new v.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new H),this.a}cancel(){this.a?this.a instanceof H&&this.a.cancel():this.a=U.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof H&&this.a.dispose():this.a=U.None}}t.CancellationTokenSource=y}),define(me[109],be([1,0,26]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new v.CancellationTokenSource,f=this.b(w.token);return this.a={promise:f,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.Cache=i;class U{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const f=JSON.stringify(w);return this.b!==f&&(this.b=f,this.a=this.c(w)),this.a}}t.LRUCachedFunction=U;class H{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const f=this.b(w);return this.a.set(w,f),f}}t.CachedFunction=H}),define(me[49],be([1,0,3,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var U;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(U=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class H{constructor(e,s,l,a,c,r,h){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,l=l|0,a=a|0,c=c|0,r=r|0,h=h|0),this.rawScrollLeft=a,this.rawScrollTop=h,s<0&&(s=0),a+s>l&&(a=l-s),a<0&&(a=0),c<0&&(c=0),h+c>r&&(h=r-c),h<0&&(h=0),this.width=s,this.scrollWidth=l,this.scrollLeft=a,this.height=c,this.scrollHeight=r,this.scrollTop=h}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const l=this.width!==e.width,a=this.scrollWidth!==e.scrollWidth,c=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,h=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:a,scrollLeftChanged:c,heightChanged:r,scrollHeightChanged:h,scrollTopChanged:b}}}t.ScrollState=H;class y extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new v.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const l=this.g.withScrollDimensions(e,s);this.k(l,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let a;s?a=new d(this.h.from,l,this.h.startTime,this.h.duration):a=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=a}else{const l=this.g.withScrollPosition(e);this.h=d.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.k(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,s){const l=this.g;l.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(l,s)))}}t.Scrollable=y;class w{constructor(e,s,l){this.scrollLeft=e,this.scrollTop=s,this.isDone=l}}t.SmoothScrollingUpdate=w;function f(n,e){const s=e-n;return function(l){return n+s*o(l)}}function g(n,e,s){return function(l){return l<s?n(l/s):e((l-s)/(1-s))}}class d{constructor(e,s,l,a){this.from=e,this.to=s,this.duration=a,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,l){if(Math.abs(e-s)>2.5*l){let c,r;return e<s?(c=e+.75*l,r=s-.75*l):(c=e-.75*l,r=s+.75*l),g(f(e,c),f(r,s),.33)}return f(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const l=this.c(s),a=this.d(s);return new w(l,a,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,l){return d.start(e,s,l)}static start(e,s,l){l=l+10;const a=Date.now()-10;return new d(e,s,a,l)}}t.SmoothScrollingOperation=d;function M(n){return Math.pow(n,3)}function o(n){return 1-M(1-n)}}),define(me[11],be([1,0,109,44]),function(X,t,v,i){"use strict";var U;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function H(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.isFalsyOrWhitespace=H;const y=/{(\d+)}/g;function w(K,...se){return se.length===0?K:K.replace(y,function(we,Ce){const Fe=parseInt(Ce,10);return isNaN(Fe)||Fe<0||Fe>=se.length?we:se[Fe]})}t.format=w;const f=/{([^}]+)}/g;function g(K,se){return K.replace(f,(we,Ce)=>se[Ce]??we)}t.format2=g;function d(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}t.escape=d;function M(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=M;function o(K,se){let we=0;const Ce=se.charCodeAt(0);for(let Fe=K.length-1;Fe>=0;Fe--)K.charCodeAt(Fe)===Ce&&we++;return we}t.count=o;function n(K,se,we="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${we}`}t.truncate=n;function e(K,se=" "){const we=s(K,se);return l(we,se)}t.trim=e;function s(K,se){if(!K||!se)return K;const we=se.length;if(we===0||K.length===0)return K;let Ce=0;for(;K.indexOf(se,Ce)===Ce;)Ce=Ce+we;return K.substring(Ce)}t.ltrim=s;function l(K,se){if(!K||!se)return K;const we=se.length,Ce=K.length;if(we===0||Ce===0)return K;let Fe=Ce,Oe=-1;for(;Oe=K.lastIndexOf(se,Fe-1),!(Oe===-1||Oe+we!==Fe);){if(Oe===0)return"";Fe=Oe}return K.substring(0,Fe)}t.rtrim=l;function a(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=a;function c(K){return K.replace(/\*/g,"")}t.stripWildcards=c;function r(K,se,we={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=M(K)),we.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ce="";return we.global&&(Ce+="g"),we.matchCase||(Ce+="i"),we.multiline&&(Ce+="m"),we.unicode&&(Ce+="u"),new RegExp(K,Ce)}t.createRegExp=r;function h(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.regExpLeadsToEndlessLoop=h;function b(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=b;function A(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}t.regExpFlags=A;function L(K){return K.split(/\r\n|\r|\n/)}t.splitLines=L;function N(K){for(let se=0,we=K.length;se<we;se++){const Ce=K.charCodeAt(se);if(Ce!==32&&Ce!==9)return se}return-1}t.firstNonWhitespaceIndex=N;function F(K,se=0,we=K.length){for(let Ce=se;Ce<we;Ce++){const Fe=K.charCodeAt(Ce);if(Fe!==32&&Fe!==9)return K.substring(se,Ce)}return K.substring(se,we)}t.getLeadingWhitespace=F;function u(K,se=K.length-1){for(let we=se;we>=0;we--){const Ce=K.charCodeAt(we);if(Ce!==32&&Ce!==9)return we}return-1}t.lastNonWhitespaceIndex=u;function C(K,se,we){const Ce=[];let Fe=0;for(const Oe of K.matchAll(se)){if(Ce.push(K.slice(Fe,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Fe=Oe.index+Oe[0].length,Ce.push(we(Oe[0],...Oe.slice(1),Oe.index,K,Oe.groups))}return Ce.push(K.slice(Fe)),Promise.all(Ce).then(Oe=>Oe.join(""))}t.replaceAsync=C;function p(K,se){return K<se?-1:K>se?1:0}t.compare=p;function D(K,se,we=0,Ce=K.length,Fe=0,Oe=se.length){for(;we<Ce&&Fe<Oe;we++,Fe++){const Me=K.charCodeAt(we),ne=se.charCodeAt(Fe);if(Me<ne)return-1;if(Me>ne)return 1}const $e=Ce-we,tt=Oe-Fe;return $e<tt?-1:$e>tt?1:0}t.compareSubstring=D;function _(K,se){return V(K,se,0,K.length,0,se.length)}t.compareIgnoreCase=_;function V(K,se,we=0,Ce=K.length,Fe=0,Oe=se.length){for(;we<Ce&&Fe<Oe;we++,Fe++){let Me=K.charCodeAt(we),ne=se.charCodeAt(Fe);if(Me===ne)continue;if(Me>=128||ne>=128)return D(K.toLowerCase(),se.toLowerCase(),we,Ce,Fe,Oe);Z(Me)&&(Me-=32),Z(ne)&&(ne-=32);const Ae=Me-ne;if(Ae!==0)return Ae}const $e=Ce-we,tt=Oe-Fe;return $e<tt?-1:$e>tt?1:0}t.compareSubstringIgnoreCase=V;function ee(K){return K>=48&&K<=57}t.isAsciiDigit=ee;function Z(K){return K>=97&&K<=122}t.isLowerAsciiLetter=Z;function pe(K){return K>=65&&K<=90}t.isUpperAsciiLetter=pe;function oe(K,se){return K.length===se.length&&V(K,se)===0}t.equalsIgnoreCase=oe;function ce(K,se){const we=se.length;return se.length>K.length?!1:V(K,se,0,we)===0}t.startsWithIgnoreCase=ce;function ae(K,se){const we=Math.min(K.length,se.length);let Ce;for(Ce=0;Ce<we;Ce++)if(K.charCodeAt(Ce)!==se.charCodeAt(Ce))return Ce;return we}t.commonPrefixLength=ae;function de(K,se){const we=Math.min(K.length,se.length);let Ce;const Fe=K.length-1,Oe=se.length-1;for(Ce=0;Ce<we;Ce++)if(K.charCodeAt(Fe-Ce)!==se.charCodeAt(Oe-Ce))return Ce;return we}t.commonSuffixLength=de;function Se(K){return 55296<=K&&K<=56319}t.isHighSurrogate=Se;function x(K){return 56320<=K&&K<=57343}t.isLowSurrogate=x;function ye(K,se){return(K-55296<<10)+(se-56320)+65536}t.computeCodePoint=ye;function ie(K,se,we){const Ce=K.charCodeAt(we);if(Se(Ce)&&we+1<se){const Fe=K.charCodeAt(we+1);if(x(Fe))return ye(Ce,Fe)}return Ce}t.getNextCodePoint=ie;function J(K,se){const we=K.charCodeAt(se-1);if(x(we)&&se>1){const Ce=K.charCodeAt(se-2);if(Se(Ce))return ye(Ce,we)}return we}class he{get offset(){return this.e}constructor(se,we=0){this.c=se,this.d=se.length,this.e=we}setOffset(se){this.e=se}prevCodePoint(){const se=J(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=ie(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}t.CodePointIterator=he;class fe{get offset(){return this.c.offset}constructor(se,we=0){this.c=new he(se,we)}nextGraphemeLength(){const se=je.getInstance(),we=this.c,Ce=we.offset;let Fe=se.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Oe=we.offset,$e=se.getGraphemeBreakType(we.nextCodePoint());if(Pe(Fe,$e)){we.setOffset(Oe);break}Fe=$e}return we.offset-Ce}prevGraphemeLength(){const se=je.getInstance(),we=this.c,Ce=we.offset;let Fe=se.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Oe=we.offset,$e=se.getGraphemeBreakType(we.prevCodePoint());if(Pe($e,Fe)){we.setOffset(Oe);break}Fe=$e}return Ce-we.offset}eol(){return this.c.eol()}}t.GraphemeIterator=fe;function le(K,se){return new fe(K,se).nextGraphemeLength()}t.nextCharLength=le;function te(K,se){return new fe(K,se).prevGraphemeLength()}t.prevCharLength=te;function T(K,se){se>0&&x(K.charCodeAt(se))&&se--;const we=se+le(K,se);return[we-te(K,we),we]}t.getCharContainingOffset=T;function E(K){const se=new fe(K);let we=0;for(;!se.eol();)we++,se.nextGraphemeLength();return we}t.charCount=E;let m;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(K){return m||(m=B()),m.test(K)}t.containsRTL=z;const $=/^[\t\n\r\x20-\x7E]*$/;function G(K){return $.test(K)}t.isBasicASCII=G,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(K){return t.UNUSUAL_LINE_TERMINATORS.test(K)}t.containsUnusualLineTerminators=k;function O(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.isFullWidthCharacter=O;function W(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.isEmojiImprecise=W;function S(K,se){if(K.length<se)return K;const we=/\b/g;let Ce=0;for(;we.test(K)&&!(K.length-we.lastIndex<se);)Ce=we.lastIndex,we.lastIndex+=1;return K.substring(Ce).replace(/^\s/,"")}t.lcut=S;const I=/\x1B\x5B[12]?K/g,P=/\x1b\[\d+m/g,R=/\x1b\[0?m/g;function j(K){return K&&(K=K.replace(I,""),K=K.replace(P,""),K=K.replace(R,"")),K}t.removeAnsiEscapeCodes=j,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.startsWithUTF8BOM=Q;function re(K){return Q(K)?K.substr(1):K}t.stripUTF8BOM=re;function ue(K,se){if(!K||!se||K.length<se.length)return!1;const we=se.length,Ce=K.toLowerCase();let Fe=0,Oe=-1;for(;Fe<we;){const $e=Ce.indexOf(se[Fe],Oe+1);if($e<0)return!1;Oe=$e,Fe++}return!0}t.fuzzyContains=ue;function De(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.containsUppercaseCharacter=De;function Ee(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.uppercaseFirstLetter=Ee;function Ie(K,se=1){if(se===0)return"";let we=-1;do we=K.indexOf(`
`,we+1),se--;while(se>0&&we>=0);return we===-1?K:(K[we-1]==="\r"&&we--,K.substr(0,we))}t.getNLines=Ie;function ke(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.singleLetterHash=ke;function ve(K){return je.getInstance().getGraphemeBreakType(K)}t.getGraphemeBreakType=ve;function Pe(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}var Re;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Re=t.GraphemeBreakType||(t.GraphemeBreakType={}));class je{static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=Ue()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const we=this.d,Ce=we.length/3;let Fe=1;for(;Fe<=Ce;)if(se<we[3*Fe])Fe=2*Fe;else if(se>we[3*Fe+1])Fe=2*Fe+1;else return we[3*Fe+2];return 0}}je.c=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(K,se){if(K===0)return 0;const we=xe(K,se);if(we!==void 0)return we;const Ce=new he(se,K);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=ze;function xe(K,se){const we=new he(se,K);let Ce=we.prevCodePoint();for(;it(Ce)||Ce===65039||Ce===8419;){if(we.offset===0)return;Ce=we.prevCodePoint()}if(!W(Ce))return;let Fe=we.offset;return Fe>0&&we.prevCodePoint()===8205&&(Fe=we.offset),Fe}function it(K){return 127995<=K&&K<=127999}var Be;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class Ve{static getInstance(se){return Ve.d.get(Array.from(se))}static getLocales(){return Ve.e.getValue()}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Ve,U=Ve,Ve.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.d=new v.LRUCachedFunction(K=>{function se(ne){const Ae=new Map;for(let Le=0;Le<ne.length;Le+=2)Ae.set(ne[Le],ne[Le+1]);return Ae}function we(ne,Ae){const Le=new Map(ne);for(const[We,Ge]of Ae)Le.set(We,Ge);return Le}function Ce(ne,Ae){if(!ne)return Ae;const Le=new Map;for(const[We,Ge]of ne)Ae.has(We)&&Le.set(We,Ge);return Le}const Fe=U.c.getValue();let Oe=K.filter(ne=>!ne.startsWith("_")&&ne in Fe);Oe.length===0&&(Oe=["_default"]);let $e;for(const ne of Oe){const Ae=se(Fe[ne]);$e=Ce($e,Ae)}const tt=se(Fe._common),Me=we(tt,$e);return new Ve(Me)}),Ve.e=new i.Lazy(()=>Object.keys(Ve.c.getValue()).filter(K=>!K.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(se){return Ye.e().has(se)}static get codePoints(){return Ye.e()}}t.InvisibleCharacters=Ye,Ye.d=void 0}),define(me[110],be([1,0,21,5,11,6]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(u){return u===47||u===92}t.isPathSeparator=y;function w(u){return u.replace(/[\\/]/g,v.posix.sep)}t.toSlashes=w;function f(u){return u.indexOf("/")===-1&&(u=w(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}t.toPosixPath=f;function g(u,C=v.posix.sep){if(!u)return"";const p=u.length,D=u.charCodeAt(0);if(y(D)){if(y(u.charCodeAt(1))&&!y(u.charCodeAt(2))){let V=3;const ee=V;for(;V<p&&!y(u.charCodeAt(V));V++);if(ee!==V&&!y(u.charCodeAt(V+1))){for(V+=1;V<p;V++)if(y(u.charCodeAt(V)))return u.slice(0,V+1).replace(/[\\/]/g,C)}}return C}else if(a(D)&&u.charCodeAt(1)===58)return y(u.charCodeAt(2))?u.slice(0,2)+C:u.slice(0,2);let _=u.indexOf("://");if(_!==-1){for(_+=3;_<p;_++)if(y(u.charCodeAt(_)))return u.slice(0,_+1)}return""}t.getRoot=g;function d(u){if(!i.isWindows||!u||u.length<5)return!1;let C=u.charCodeAt(0);if(C!==92||(C=u.charCodeAt(1),C!==92))return!1;let p=2;const D=p;for(;p<u.length&&(C=u.charCodeAt(p),C!==92);p++);return!(D===p||(C=u.charCodeAt(p+1),isNaN(C)||C===92))}t.isUNC=d;const M=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(u,C=i.isWindows){const p=C?M:o;return!(!u||u.length===0||/^\s+$/.test(u)||(p.lastIndex=0,p.test(u))||C&&n.test(u)||u==="."||u===".."||C&&u[u.length-1]==="."||C&&u.length!==u.trim().length||u.length>255)}t.isValidBasename=e;function s(u,C,p){const D=u===C;return!p||D?D:!u||!C?!1:(0,U.equalsIgnoreCase)(u,C)}t.isEqual=s;function l(u,C,p,D=v.sep){if(u===C)return!0;if(!u||!C||C.length>u.length)return!1;if(p){if(!(0,U.startsWithIgnoreCase)(u,C))return!1;if(C.length===u.length)return!0;let V=C.length;return C.charAt(C.length-1)===D&&V--,u.charAt(V)===D}return C.charAt(C.length-1)!==D&&(C+=D),u.indexOf(C)===0}t.isEqualOrParent=l;function a(u){return u>=65&&u<=90||u>=97&&u<=122}t.isWindowsDriveLetter=a;function c(u,C){return i.isWindows&&u.endsWith(":")&&(u+=v.sep),(0,v.isAbsolute)(u)||(u=(0,v.join)(C,u)),u=(0,v.normalize)(u),i.isWindows?(u=(0,U.rtrim)(u,v.sep),u.endsWith(":")&&(u+=v.sep)):(u=(0,U.rtrim)(u,v.sep),u||(u=v.sep)),u}t.sanitizeFilePath=c;function r(u){const C=(0,v.normalize)(u);return i.isWindows?u.length>3?!1:h(C)&&(u.length===2||C.charCodeAt(2)===92):C===v.posix.sep}t.isRootOrDriveLetter=r;function h(u,C=i.isWindows){return C?a(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}t.hasDriveLetter=h;function b(u){return h(u)?u[0]:void 0}t.getDriveLetter=b;function A(u,C,p){return C.length>u.length?-1:u===C?0:(p&&(u=u.toLowerCase(),C=C.toLowerCase()),u.indexOf(C))}t.indexOfPath=A;function L(u){const C=u.split(":");let p,D,_;for(const V of C){const ee=Number(V);(0,H.isNumber)(ee)?D===void 0?D=ee:_===void 0&&(_=ee):p=p?[p,V].join(":"):V}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:D!==void 0?D:void 0,column:_!==void 0?_:D!==void 0?1:void 0}}t.parseLineAndColumnAware=L;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function F(u,C,p=8){let D="";for(let V=0;V<p;V++)D+=N.charAt(Math.floor(Math.random()*N.length));let _;return C?_=`${C}-${D}`:_=D,u?(0,v.join)(u,_):_}t.randomPath=F}),define(me[32],be([1,0,75,11]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function U(...P){return function(R,j){for(let Q=0,re=P.length;Q<re;Q++){const ue=P[Q](R,j);if(ue)return ue}return null}}t.or=U,t.matchesStrictPrefix=H.bind(void 0,!1),t.matchesPrefix=H.bind(void 0,!0);function H(P,R,j){if(!j||j.length<R.length)return null;let Q;return P?Q=i.startsWithIgnoreCase(j,R):Q=j.indexOf(R)===0,Q?R.length>0?[{start:0,end:R.length}]:[]:null}function y(P,R){const j=R.toLowerCase().indexOf(P.toLowerCase());return j===-1?null:[{start:j,end:j+P.length}]}t.matchesContiguousSubString=y;function w(P,R){return f(P.toLowerCase(),R.toLowerCase(),0,0)}t.matchesSubString=w;function f(P,R,j,Q){if(j===P.length)return[];if(Q===R.length)return null;if(P[j]===R[Q]){let re=null;return(re=f(P,R,j+1,Q+1))?a({start:Q,end:Q+1},re):null}return f(P,R,j,Q+1)}function g(P){return 97<=P&&P<=122}function d(P){return 65<=P&&P<=90}t.isUpper=d;function M(P){return 48<=P&&P<=57}function o(P){return P===32||P===9||P===10||P===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(P=>n.add(P.charCodeAt(0)));function e(P){return o(P)||n.has(P)}function s(P,R){return P===R||e(P)&&e(R)}function l(P){return g(P)||d(P)||M(P)}function a(P,R){return R.length===0?R=[P]:P.end===R[0].start?R[0].start=P.start:R.unshift(P),R}function c(P,R){for(let j=R;j<P.length;j++){const Q=P.charCodeAt(j);if(d(Q)||M(Q)||j>0&&!l(P.charCodeAt(j-1)))return j}return P.length}function r(P,R,j,Q){if(j===P.length)return[];if(Q===R.length)return null;if(P[j]!==R[Q].toLowerCase())return null;{let re=null,ue=Q+1;for(re=r(P,R,j+1,Q+1);!re&&(ue=c(R,ue))<R.length;)re=r(P,R,j+1,ue),ue++;return re===null?null:a({start:Q,end:Q+1},re)}}function h(P){let R=0,j=0,Q=0,re=0,ue=0;for(let ve=0;ve<P.length;ve++)ue=P.charCodeAt(ve),d(ue)&&R++,g(ue)&&j++,l(ue)&&Q++,M(ue)&&re++;const De=R/P.length,Ee=j/P.length,Ie=Q/P.length,ke=re/P.length;return{upperPercent:De,lowerPercent:Ee,alphaPercent:Ie,numericPercent:ke}}function b(P){const{upperPercent:R,lowerPercent:j}=P;return j===0&&R>.6}function A(P){const{upperPercent:R,lowerPercent:j,alphaPercent:Q,numericPercent:re}=P;return j>.2&&R<.8&&Q>.6&&re<.2}function L(P){let R=0,j=0,Q=0,re=0;for(let ue=0;ue<P.length;ue++)Q=P.charCodeAt(ue),d(Q)&&R++,g(Q)&&j++,o(Q)&&re++;return(R===0||j===0)&&re===0?P.length<=30:R<=5}function N(P,R){if(!R||(R=R.trim(),R.length===0)||!L(P)||R.length>60)return null;const j=h(R);if(!A(j)){if(!b(j))return null;R=R.toLowerCase()}let Q=null,re=0;for(P=P.toLowerCase();re<R.length&&(Q=r(P,R,0,re))===null;)re=c(R,re+1);return Q}t.matchesCamelCase=N;function F(P,R,j=!1){if(!R||R.length===0)return null;let Q=null,re=0;for(P=P.toLowerCase(),R=R.toLowerCase();re<R.length&&(Q=u(P,R,0,re,j))===null;)re=C(R,re+1);return Q}t.matchesWords=F;function u(P,R,j,Q,re){if(j===P.length)return[];if(Q===R.length)return null;if(s(P.charCodeAt(j),R.charCodeAt(Q))){let ue=null,De=Q+1;if(ue=u(P,R,j+1,Q+1,re),!re)for(;!ue&&(De=C(R,De))<R.length;)ue=u(P,R,j+1,De,re),De++;return ue?P.charCodeAt(j)!==R.charCodeAt(Q)?ue:a({start:Q,end:Q+1},ue):null}else return null}function C(P,R){for(let j=R;j<P.length;j++)if(e(P.charCodeAt(j))||j>0&&e(P.charCodeAt(j-1)))return j;return P.length}const p=U(t.matchesPrefix,N,y),D=U(t.matchesPrefix,N,w),_=new v.LRUCache(1e4);function V(P,R,j=!1){if(typeof P!="string"||typeof R!="string")return null;let Q=_.get(P);Q||(Q=new RegExp(i.convertSimple2RegExpPattern(P),"i"),_.set(P,Q));const re=Q.exec(R);return re?[{start:re.index,end:re.index+re[0].length}]:j?D(P,R):p(P,R)}t.matchesFuzzy=V;function ee(P,R){const j=$(P,P.toLowerCase(),0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?pe(j):null}t.matchesFuzzy2=ee;function Z(P,R,j,Q,re,ue){const De=Math.min(13,P.length);for(;j<De;j++){const Ee=$(P,R,j,Q,re,ue,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,ue]}t.anyScore=Z;function pe(P){if(typeof P>"u")return[];const R=[],j=P[1];for(let Q=P.length-1;Q>1;Q--){const re=P[Q]+j,ue=R[R.length-1];ue&&ue.end===re?ue.end=re+1:R.push({start:re,end:re+1})}return R}t.createMatches=pe;const oe=128;function ce(){const P=[],R=[];for(let j=0;j<=oe;j++)R[j]=0;for(let j=0;j<=oe;j++)P.push(R.slice(0));return P}function ae(P){const R=[];for(let j=0;j<=P;j++)R[j]=0;return R}const de=ae(2*oe),Se=ae(2*oe),x=ce(),ye=ce(),ie=ce(),J=!1;function he(P,R,j,Q,re){function ue(Ee,Ie,ke=" "){for(;Ee.length<Ie;)Ee=ke+Ee;return Ee}let De=` |   |${Q.split("").map(Ee=>ue(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=j;Ee++)Ee===0?De+=" |":De+=`${R[Ee-1]}|`,De+=P[Ee].slice(0,re+1).map(Ie=>ue(Ie.toString(),3)).join("|")+`
`;return De}function fe(P,R,j,Q){P=P.substr(R),j=j.substr(Q),console.log(he(ye,P,P.length,j,j.length)),console.log(he(ie,P,P.length,j,j.length)),console.log(he(x,P,P.length,j,j.length))}function le(P,R){if(R<0||R>=P.length)return!1;const j=P.codePointAt(R);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function te(P,R){if(R<0||R>=P.length)return!1;switch(P.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function T(P,R,j){return R[P]!==j[P]}function E(P,R,j,Q,re,ue,De=!1){for(;R<j&&re<ue;)P[R]===Q[re]&&(De&&(de[R]=re),R+=1),re+=1;return R===j}t.isPatternInWord=E;var m;(function(P){P[P.Diag=1]="Diag",P[P.Left=2]="Left",P[P.LeftLeft=3]="LeftLeft"})(m||(m={}));var B;(function(P){P.Default=[-100,0];function R(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}P.isDefault=R})(B=t.FuzzyScore||(t.FuzzyScore={}));class z{constructor(R,j){this.firstMatchCanBeWeak=R,this.boostFullMatch=j}}t.FuzzyScoreOptions=z,z.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(P,R,j,Q,re,ue,De=z.default){const Ee=P.length>oe?oe:P.length,Ie=Q.length>oe?oe:Q.length;if(j>=Ee||ue>=Ie||Ee-j>Ie-ue||!E(R,j,Ee,re,ue,Ie,!0))return;G(Ee,Ie,j,ue,R,re);let ke=1,ve=1,Pe=j,Re=ue;const je=[!1];for(ke=1,Pe=j;Pe<Ee;ke++,Pe++){const Be=de[Pe],Ve=Se[Pe],Ye=Pe+1<Ee?Se[Pe+1]:Ie;for(ve=Be-ue+1,Re=Be;Re<Ye;ve++,Re++){let K=Number.MIN_SAFE_INTEGER,se=!1;Re<=Ve&&(K=k(P,R,Pe,j,Q,re,Re,Ie,ue,x[ke-1][ve-1]===0,je));let we=0;K!==Number.MAX_SAFE_INTEGER&&(se=!0,we=K+ye[ke-1][ve-1]);const Ce=Re>Be,Fe=Ce?ye[ke][ve-1]+(x[ke][ve-1]>0?-5:0):0,Oe=Re>Be+1&&x[ke][ve-1]>0,$e=Oe?ye[ke][ve-2]+(x[ke][ve-2]>0?-5:0):0;if(Oe&&(!Ce||$e>=Fe)&&(!se||$e>=we))ye[ke][ve]=$e,ie[ke][ve]=3,x[ke][ve]=0;else if(Ce&&(!se||Fe>=we))ye[ke][ve]=Fe,ie[ke][ve]=2,x[ke][ve]=0;else if(se)ye[ke][ve]=we,ie[ke][ve]=1,x[ke][ve]=x[ke-1][ve-1]+1;else throw new Error("not possible")}}if(J&&fe(P,j,Q,ue),!je[0]&&!De.firstMatchCanBeWeak)return;ke--,ve--;const Ue=[ye[ke][ve],ue];let ze=0,xe=0;for(;ke>=1;){let Be=ve;do{const Ve=ie[ke][Be];if(Ve===3)Be=Be-2;else if(Ve===2)Be=Be-1;else break}while(Be>=1);ze>1&&R[j+ke-1]===re[ue+ve-1]&&!T(Be+ue-1,Q,re)&&ze+1>x[ke][Be]&&(Be=ve),Be===ve?ze++:ze=1,xe||(xe=Be),ke--,ve=Be-1,Ue.push(ve)}Ie===Ee&&De.boostFullMatch&&(Ue[0]+=2);const it=xe-Ee;return Ue[0]-=it,Ue}t.fuzzyScore=$;function G(P,R,j,Q,re,ue){let De=P-1,Ee=R-1;for(;De>=j&&Ee>=Q;)re[De]===ue[Ee]&&(Se[De]=Ee,De--),Ee--}function k(P,R,j,Q,re,ue,De,Ee,Ie,ke,ve){if(R[j]!==ue[De])return Number.MIN_SAFE_INTEGER;let Pe=1,Re=!1;return De===j-Q?Pe=P[j]===re[De]?7:5:T(De,re,ue)&&(De===0||!T(De-1,re,ue))?(Pe=P[j]===re[De]?7:5,Re=!0):le(ue,De)&&(De===0||!le(ue,De-1))?Pe=5:(le(ue,De-1)||te(ue,De-1))&&(Pe=5,Re=!0),Pe>1&&j===Q&&(ve[0]=!0),Re||(Re=T(De,re,ue)||le(ue,De-1)||te(ue,De-1)),j===Q?De>Ie&&(Pe-=Re?3:5):ke?Pe+=Re?2:0:Pe+=Re?0:1,De+1===Ee&&(Pe-=Re?3:5),Pe}function O(P,R,j,Q,re,ue,De){return S(P,R,j,Q,re,ue,!0,De)}t.fuzzyScoreGracefulAggressive=O;function W(P,R,j,Q,re,ue,De){return S(P,R,j,Q,re,ue,!1,De)}t.fuzzyScoreGraceful=W;function S(P,R,j,Q,re,ue,De,Ee){let Ie=$(P,R,j,Q,re,ue,Ee);if(Ie&&!De)return Ie;if(P.length>=3){const ke=Math.min(7,P.length-1);for(let ve=j+1;ve<ke;ve++){const Pe=I(P,ve);if(Pe){const Re=$(Pe,Pe.toLowerCase(),j,Q,re,ue,Ee);Re&&(Re[0]-=3,(!Ie||Re[0]>Ie[0])&&(Ie=Re))}}}return Ie}function I(P,R){if(R+1>=P.length)return;const j=P[R],Q=P[R+1];if(j!==Q)return P.slice(0,R)+Q+j+P.slice(R+2)}}),define(me[111],be([1,0,11]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(a){return U(a,0)}t.hash=i;function U(a,c){switch(typeof a){case"object":return a===null?H(349,c):Array.isArray(a)?f(a,c):g(a,c);case"string":return w(a,c);case"boolean":return y(a,c);case"number":return H(a,c);case"undefined":return H(937,c);default:return H(617,c)}}t.doHash=U;function H(a,c){return(c<<5)-c+a|0}t.numberHash=H;function y(a,c){return H(a?433:863,c)}function w(a,c){c=H(149417,c);for(let r=0,h=a.length;r<h;r++)c=H(a.charCodeAt(r),c);return c}t.stringHash=w;function f(a,c){return c=H(104579,c),a.reduce((r,h)=>U(h,r),c)}function g(a,c){return c=H(181387,c),Object.keys(a).sort().reduce((r,h)=>(r=w(h,r),U(a[h],r)),c)}class d{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=U(c,this.g),this.g}}t.Hasher=d;var M;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function o(a,c,r=32){const h=r-c,b=~((1<<h)-1);return(a<<c|(b&a)>>>h)>>>0}function n(a,c=0,r=a.byteLength,h=0){for(let b=0;b<r;b++)a[c+b]=h}function e(a,c,r="0"){for(;a.length<c;)a=r+a;return a}function s(a,c=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((a>>>0).toString(16),c/4)}t.toHexString=s;class l{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const r=c.length;if(r===0)return;const h=this.p;let b=this.r,A=this.u,L,N;for(A!==0?(L=A,N=-1,A=0):(L=c.charCodeAt(0),N=0);;){let F=L;if(v.isHighSurrogate(L))if(N+1<r){const u=c.charCodeAt(N+1);v.isLowSurrogate(u)?(N++,F=v.computeCodePoint(L,u)):F=65533}else{A=L;break}else v.isLowSurrogate(L)&&(F=65533);if(b=this.w(h,b,F),N++,N<r)L=c.charCodeAt(N);else break}this.r=b,this.u=A}w(c,r,h){return h<128?c[r++]=h:h<2048?(c[r++]=192|(h&1984)>>>6,c[r++]=128|(h&63)>>>0):h<65536?(c[r++]=224|(h&61440)>>>12,c[r++]=128|(h&4032)>>>6,c[r++]=128|(h&63)>>>0):(c[r++]=240|(h&1835008)>>>18,c[r++]=128|(h&258048)>>>12,c[r++]=128|(h&4032)>>>6,c[r++]=128|(h&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,n(this.p,this.r),this.r>56&&(this.y(),n(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=l.g,r=this.q;for(let p=0;p<64;p+=4)c.setUint32(p,r.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)c.setUint32(p,o(c.getUint32(p-12,!1)^c.getUint32(p-32,!1)^c.getUint32(p-56,!1)^c.getUint32(p-64,!1),1),!1);let h=this.h,b=this.l,A=this.m,L=this.n,N=this.o,F,u,C;for(let p=0;p<80;p++)p<20?(F=b&A|~b&L,u=1518500249):p<40?(F=b^A^L,u=1859775393):p<60?(F=b&A|b&L|A&L,u=2400959708):(F=b^A^L,u=3395469782),C=o(h,5)+F+N+u+c.getUint32(p*4,!1)&4294967295,N=L,L=A,A=o(b,30),b=h,h=C;this.h=this.h+h&4294967295,this.l=this.l+b&4294967295,this.m=this.m+A&4294967295,this.n=this.n+L&4294967295,this.o=this.o+N&4294967295}}t.StringSHA1=l,l.g=new DataView(new ArrayBuffer(320))}),define(me[112],be([1,0,71,111]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class U{constructor(o){this.a=o}getElements(){const o=this.a,n=new Int32Array(o.length);for(let e=0,s=o.length;e<s;e++)n[e]=o.charCodeAt(e);return n}}t.StringDiffSequence=U;function H(M,o,n){return new d(new U(M),new U(o)).ComputeDiff(n).changes}t.stringDiff=H;class y{static Assert(o,n){if(!o)throw new Error(n)}}class w{static Copy(o,n,e,s,l){for(let a=0;a<l;a++)e[s+a]=o[n+a]}static Copy2(o,n,e,s,l){for(let a=0;a<l;a++)e[s+a]=o[n+a]}}var f;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.d++}AddModifiedElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(o,n,e=null){this.a=e,this.b=o,this.c=n;const[s,l,a]=d.o(o),[c,r,h]=d.o(n);this.d=a&&h,this.e=s,this.f=l,this.g=c,this.h=r,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const n=o.getElements();if(d.n(n)){const e=new Int32Array(n.length);for(let s=0,l=n.length;s<l;s++)e[s]=(0,i.stringHash)(n[s],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}p(o,n){return this.f[o]!==this.h[n]?!1:this.d?this.e[o]===this.g[n]:!0}q(o,n){if(!this.p(o,n))return!1;const e=d.r(this.b,o),s=d.r(this.c,n);return e===s}static r(o,n){return typeof o.getStrictElement=="function"?o.getStrictElement(n):null}s(o,n){return this.f[o]!==this.f[n]?!1:this.d?this.e[o]===this.e[n]:!0}u(o,n){return this.h[o]!==this.h[n]?!1:this.d?this.g[o]===this.g[n]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,n,e,s,l){const a=[!1];let c=this.w(o,n,e,s,a);return l&&(c=this.A(c)),{quitEarly:a[0],changes:c}}w(o,n,e,s,l){for(l[0]=!1;o<=n&&e<=s&&this.p(o,e);)o++,e++;for(;n>=o&&s>=e&&this.p(n,s);)n--,s--;if(o>n||e>s){let A;return e<=s?(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),A=[new v.DiffChange(o,0,e,s-e+1)]):o<=n?(y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),A=[new v.DiffChange(o,n-o+1,e,0)]):(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),A=[]),A}const a=[0],c=[0],r=this.y(o,n,e,s,a,c,l),h=a[0],b=c[0];if(r!==null)return r;if(!l[0]){const A=this.w(o,h,e,b,l);let L=[];return l[0]?L=[new v.DiffChange(h+1,n-(h+1)+1,b+1,s-(b+1)+1)]:L=this.w(h+1,n,b+1,s,l),this.I(A,L)}return[new v.DiffChange(o,n-o+1,e,s-e+1)]}x(o,n,e,s,l,a,c,r,h,b,A,L,N,F,u,C,p,D){let _=null,V=null,ee=new g,Z=n,pe=e,oe=N[0]-C[0]-s,ce=-1073741824,ae=this.k.length-1;do{const de=oe+o;de===Z||de<pe&&h[de-1]<h[de+1]?(A=h[de+1],F=A-oe-s,A<ce&&ee.MarkNextChange(),ce=A,ee.AddModifiedElement(A+1,F),oe=de+1-o):(A=h[de-1]+1,F=A-oe-s,A<ce&&ee.MarkNextChange(),ce=A-1,ee.AddOriginalElement(A,F+1),oe=de-1-o),ae>=0&&(h=this.k[ae],o=h[0],Z=1,pe=h.length-1)}while(--ae>=-1);if(_=ee.getReverseChanges(),D[0]){let de=N[0]+1,Se=C[0]+1;if(_!==null&&_.length>0){const x=_[_.length-1];de=Math.max(de,x.getOriginalEnd()),Se=Math.max(Se,x.getModifiedEnd())}V=[new v.DiffChange(de,L-de+1,Se,u-Se+1)]}else{ee=new g,Z=a,pe=c,oe=N[0]-C[0]-r,ce=1073741824,ae=p?this.m.length-1:this.m.length-2;do{const de=oe+l;de===Z||de<pe&&b[de-1]>=b[de+1]?(A=b[de+1]-1,F=A-oe-r,A>ce&&ee.MarkNextChange(),ce=A+1,ee.AddOriginalElement(A+1,F+1),oe=de+1-l):(A=b[de-1],F=A-oe-r,A>ce&&ee.MarkNextChange(),ce=A,ee.AddModifiedElement(A+1,F+1),oe=de-1-l),ae>=0&&(b=this.m[ae],l=b[0],Z=1,pe=b.length-1)}while(--ae>=-1);V=ee.getChanges()}return this.I(_,V)}y(o,n,e,s,l,a,c){let r=0,h=0,b=0,A=0,L=0,N=0;o--,e--,l[0]=0,a[0]=0,this.k=[],this.m=[];const F=n-o+(s-e),u=F+1,C=new Int32Array(u),p=new Int32Array(u),D=s-e,_=n-o,V=o-e,ee=n-s,pe=(_-D)%2===0;C[D]=o,p[_]=n,c[0]=!1;for(let oe=1;oe<=F/2+1;oe++){let ce=0,ae=0;b=this.K(D-oe,oe,D,u),A=this.K(D+oe,oe,D,u);for(let Se=b;Se<=A;Se+=2){Se===b||Se<A&&C[Se-1]<C[Se+1]?r=C[Se+1]:r=C[Se-1]+1,h=r-(Se-D)-V;const x=r;for(;r<n&&h<s&&this.p(r+1,h+1);)r++,h++;if(C[Se]=r,r+h>ce+ae&&(ce=r,ae=h),!pe&&Math.abs(Se-_)<=oe-1&&r>=p[Se])return l[0]=r,a[0]=h,x<=p[Se]&&1447>0&&oe<=1447+1?this.x(D,b,A,V,_,L,N,ee,C,p,r,n,l,h,s,a,pe,c):null}const de=(ce-o+(ae-e)-oe)/2;if(this.a!==null&&!this.a(ce,de))return c[0]=!0,l[0]=ce,a[0]=ae,de>0&&1447>0&&oe<=1447+1?this.x(D,b,A,V,_,L,N,ee,C,p,r,n,l,h,s,a,pe,c):(o++,e++,[new v.DiffChange(o,n-o+1,e,s-e+1)]);L=this.K(_-oe,oe,_,u),N=this.K(_+oe,oe,_,u);for(let Se=L;Se<=N;Se+=2){Se===L||Se<N&&p[Se-1]>=p[Se+1]?r=p[Se+1]-1:r=p[Se-1],h=r-(Se-_)-ee;const x=r;for(;r>o&&h>e&&this.p(r,h);)r--,h--;if(p[Se]=r,pe&&Math.abs(Se-D)<=oe&&r<=C[Se])return l[0]=r,a[0]=h,x>=C[Se]&&1447>0&&oe<=1447+1?this.x(D,b,A,V,_,L,N,ee,C,p,r,n,l,h,s,a,pe,c):null}if(oe<=1447){let Se=new Int32Array(A-b+2);Se[0]=D-b+1,w.Copy2(C,b,Se,1,A-b+1),this.k.push(Se),Se=new Int32Array(N-L+2),Se[0]=_-L+1,w.Copy2(p,L,Se,1,N-L+1),this.m.push(Se)}}return this.x(D,b,A,V,_,L,N,ee,C,p,r,n,l,h,s,a,pe,c)}A(o){for(let n=0;n<o.length;n++){const e=o[n],s=n<o.length-1?o[n+1].originalStart:this.f.length,l=n<o.length-1?o[n+1].modifiedStart:this.h.length,a=e.originalLength>0,c=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<l&&(!a||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!c||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const h=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!h)break;e.originalStart++,e.modifiedStart++}const r=[null];if(n<o.length-1&&this.J(o[n],o[n+1],r)){o[n]=r[0],o.splice(n+1,1),n--;continue}}for(let n=o.length-1;n>=0;n--){const e=o[n];let s=0,l=0;if(n>0){const A=o[n-1];s=A.originalStart+A.originalLength,l=A.modifiedStart+A.modifiedLength}const a=e.originalLength>0,c=e.modifiedLength>0;let r=0,h=this.H(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let A=1;;A++){const L=e.originalStart-A,N=e.modifiedStart-A;if(L<s||N<l||a&&!this.s(L,L+e.originalLength)||c&&!this.u(N,N+e.modifiedLength))break;const u=(L===s&&N===l?5:0)+this.H(L,e.originalLength,N,e.modifiedLength);u>h&&(h=u,r=A)}e.originalStart-=r,e.modifiedStart-=r;const b=[null];if(n>0&&this.J(o[n-1],o[n],b)){o[n-1]=b[0],o.splice(n,1),n++;continue}}if(this.d)for(let n=1,e=o.length;n<e;n++){const s=o[n-1],l=o[n],a=l.originalStart-s.originalStart-s.originalLength,c=s.originalStart,r=l.originalStart+l.originalLength,h=r-c,b=s.modifiedStart,A=l.modifiedStart+l.modifiedLength,L=A-b;if(a<5&&h<20&&L<20){const N=this.B(c,h,b,L,a);if(N){const[F,u]=N;(F!==s.originalStart+s.originalLength||u!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=F-s.originalStart,s.modifiedLength=u-s.modifiedStart,l.originalStart=F+a,l.modifiedStart=u+a,l.originalLength=r-l.originalStart,l.modifiedLength=A-l.modifiedStart)}}}return o}B(o,n,e,s,l){if(n<l||s<l)return null;const a=o+n-l+1,c=e+s-l+1;let r=0,h=0,b=0;for(let A=o;A<a;A++)for(let L=e;L<c;L++){const N=this.C(A,L,l);N>0&&N>r&&(r=N,h=A,b=L)}return r>0?[h,b]:null}C(o,n,e){let s=0;for(let l=0;l<e;l++){if(!this.p(o+l,n+l))return 0;s+=this.e[o+l].length}return s}D(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}E(o,n){if(this.D(o)||this.D(o-1))return!0;if(n>0){const e=o+n;if(this.D(e-1)||this.D(e))return!0}return!1}F(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}G(o,n){if(this.F(o)||this.F(o-1))return!0;if(n>0){const e=o+n;if(this.F(e-1)||this.F(e))return!0}return!1}H(o,n,e,s){const l=this.E(o,n)?1:0,a=this.G(e,s)?1:0;return l+a}I(o,n){const e=[];if(o.length===0||n.length===0)return n.length>0?n:o;if(this.J(o[o.length-1],n[0],e)){const s=new Array(o.length+n.length-1);return w.Copy(o,0,s,0,o.length-1),s[o.length-1]=e[0],w.Copy(n,1,s,o.length,n.length-1),s}else{const s=new Array(o.length+n.length);return w.Copy(o,0,s,0,o.length),w.Copy(n,0,s,o.length,n.length),s}}J(o,n,e){if(y.Assert(o.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),y.Assert(o.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=n.originalStart||o.modifiedStart+o.modifiedLength>=n.modifiedStart){const s=o.originalStart;let l=o.originalLength;const a=o.modifiedStart;let c=o.modifiedLength;return o.originalStart+o.originalLength>=n.originalStart&&(l=n.originalStart+n.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=n.modifiedStart&&(c=n.modifiedStart+n.modifiedLength-o.modifiedStart),e[0]=new v.DiffChange(s,l,a,c),!0}else return e[0]=null,!1}K(o,n,e,s){if(o>=0&&o<s)return o;const l=e,a=s-e-1,c=n%2===0;if(o<0){const r=l%2===0;return c===r?0:1}else{const r=a%2===0;return c===r?s-1:s-2}}}t.LcsDiff=d}),define(me[33],be([1,0,12,32,11]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const H="$(",y=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(v.CSSIcon.iconNameCharacter),f=new RegExp(`(\\\\)?${y.source}`,"g");function g(a){return a.replace(f,(c,r)=>r?c:`\\${c}`)}t.escapeIcons=g;const d=new RegExp(`\\\\${y.source}`,"g");function M(a){return a.replace(d,c=>`\\${c}`)}t.markdownEscapeEscapedIcons=M;const o=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function n(a){return a.indexOf(H)===-1?a:a.replace(o,(c,r,h,b)=>h?c:r||b||"")}t.stripIcons=n;function e(a){const c=a.indexOf(H);return c===-1?{text:a}:s(a,c)}t.parseLabelWithIcons=e;function s(a,c){const r=[];let h="";function b(D){if(D){h+=D;for(const _ of D)r.push(N)}}let A=-1,L="",N=0,F,u,C=c;const p=a.length;for(b(a.substr(0,c));C<p;)F=a[C],u=a[C+1],F===H[0]&&u===H[1]?(A=C,b(L),L=H,C++):F===")"&&A!==-1?(N+=C-A+1,A=-1,L=""):A!==-1?w.test(F)?L+=F:(b(L),A=-1,L=""):b(F),C++;return b(L),{text:h,iconOffsets:r}}function l(a,c,r=!1){const{text:h,iconOffsets:b}=c;if(!b||b.length===0)return(0,i.matchesFuzzy)(a,h,r);const A=(0,U.ltrim)(h," "),L=h.length-A.length,N=(0,i.matchesFuzzy)(a,A,r);if(N)for(const F of N){const u=b[F.start+L]+L;F.start+=u,F.end+=u}return N}t.matchesFuzzyIconAware=l}),define(me[113],be([1,0,14,11]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class U{constructor(){this.b="",this.c=0}reset(n){return this.b=n,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(n){const e=n.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.StringIterator=U;class H{constructor(n=!0){this.e=n}reset(n){return this.b=n,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let n=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(n)this.c++;else break;else n=!1;return this}cmp(n){return this.e?(0,i.compareSubstring)(n,this.b,0,n.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=H;class y{constructor(n=!0,e=!0){this.f=n,this.g=e}reset(n){this.d=0,this.e=0,this.b=n,this.c=n.length;for(let e=n.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let n=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(n)this.d++;else break;else n=!1}return this}cmp(n){return this.g?(0,i.compareSubstring)(n,this.b,0,n.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=y;var w;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(w||(w={}));class f{constructor(n,e){this.f=n,this.g=e,this.d=[],this.e=0}reset(n){return this.c=n,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(n)),this.b.reset(n.path),this.b.value()&&this.d.push(3)),this.g(n)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(n){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(n,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(n,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(n);if(this.d[this.e]===4)return(0,i.compare)(n,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(n,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=f;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(d||(d={}));class M{static forUris(n=()=>!1,e=()=>!1){return new M(new f(n,e))}static forPaths(n=!1){return new M(new y(void 0,!n))}static forStrings(){return new M(new U)}static forConfigKeys(){return new M(new H)}constructor(n){this.b=n}clear(){this.c=void 0}fill(n,e){if(e){const s=e.slice(0);(0,v.shuffle)(s);for(const l of s)this.set(l,n)}else{const s=n.slice(0);(0,v.shuffle)(s);for(const l of s)this.set(l[0],l[1])}}set(n,e){const s=this.b.reset(n);let l;this.c||(this.c=new g,this.c.segment=s.value());const a=[];for(l=this.c;;){const r=s.cmp(l.segment);if(r>0)l.left||(l.left=new g,l.left.segment=s.value()),a.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new g,l.right.segment=s.value()),a.push([1,l]),l=l.right;else if(s.hasNext())s.next(),l.mid||(l.mid=new g,l.mid.segment=s.value()),a.push([0,l]),l=l.mid;else break}const c=l.value;l.value=e,l.key=n;for(let r=a.length-1;r>=0;r--){const h=a[r][1];h.updateHeight();const b=h.balanceFactor();if(b<-1||b>1){const A=a[r][0],L=a[r+1][0];if(A===1&&L===1)a[r][1]=h.rotateLeft();else if(A===-1&&L===-1)a[r][1]=h.rotateRight();else if(A===1&&L===-1)h.right=a[r+1][1]=a[r+1][1].rotateRight(),a[r][1]=h.rotateLeft();else if(A===-1&&L===1)h.left=a[r+1][1]=a[r+1][1].rotateLeft(),a[r][1]=h.rotateRight();else throw new Error;if(r>0)switch(a[r-1][0]){case-1:a[r-1][1].left=a[r][1];break;case 1:a[r-1][1].right=a[r][1];break;case 0:a[r-1][1].mid=a[r][1];break}else this.c=a[0][1]}}return c}get(n){return this.d(n)?.value}d(n){const e=this.b.reset(n);let s=this.c;for(;s;){const l=e.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(n){const e=this.d(n);return!(e?.value===void 0&&e?.mid===void 0)}delete(n){return this.e(n,!1)}deleteSuperstr(n){return this.e(n,!0)}e(n,e){const s=this.b.reset(n),l=[];let a=this.c;for(;a;){const c=s.cmp(a.segment);if(c>0)l.push([-1,a]),a=a.left;else if(c<0)l.push([1,a]),a=a.right;else if(s.hasNext())s.next(),l.push([0,a]),a=a.mid;else break}if(!!a){if(e?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const c=this.f(a.right);if(c.key){const{key:r,value:h,segment:b}=c;this.e(c.key,!1),a.key=r,a.value=h,a.segment=b}}else{const c=a.left??a.right;if(l.length>0){const[r,h]=l[l.length-1];switch(r){case-1:h.left=c;break;case 0:h.mid=c;break;case 1:h.right=c;break}}else this.c=c}for(let c=l.length-1;c>=0;c--){const r=l[c][1];r.updateHeight();const h=r.balanceFactor();if(h>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[c][1]=r.rotateLeft()):h<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[c][1]=r.rotateRight()),c>0)switch(l[c-1][0]){case-1:l[c-1][1].left=l[c][1];break;case 1:l[c-1][1].right=l[c][1];break;case 0:l[c-1][1].mid=l[c][1];break}else this.c=l[0][1]}}}f(n){for(;n.left;)n=n.left;return n}findSubstr(n){const e=this.b.reset(n);let s=this.c,l;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),l=s.value||l,s=s.mid;else break}return s&&s.value||l}findSuperstr(n){const e=this.b.reset(n);let s=this.c;for(;s;){const l=e.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else return s.mid?this.g(s.mid):void 0}}forEach(n){for(const[e,s]of this)n(s,e)}*[Symbol.iterator](){yield*this.g(this.c)}g(n){const e=[];return this.h(n,e),e[Symbol.iterator]()}h(n,e){!n||(n.left&&this.h(n.left,e),n.value&&e.push([n.key,n.value]),n.mid&&this.h(n.mid,e),n.right&&this.h(n.right,e))}_isBalanced(){const n=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:n(e.left)&&n(e.right)};return n(this.c)}}t.TernarySearchTree=M}),define(me[15],be([1,0,21,5]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const U=/^\w[\w\d+.-]*$/,H=/^\//,y=/^\/\//;function w(N,F){if(!N.scheme&&F)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${N.authority}", path: "${N.path}", query: "${N.query}", fragment: "${N.fragment}"}`);if(N.scheme&&!U.test(N.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(N.path){if(N.authority){if(!H.test(N.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(N.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(N,F){return!N&&!F?"file":N}function g(N,F){switch(N){case"https":case"http":case"file":F?F[0]!==M&&(F=M+F):F=M;break}return F}const d="",M="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(F){return F instanceof n?!0:F?typeof F.authority=="string"&&typeof F.fragment=="string"&&typeof F.path=="string"&&typeof F.query=="string"&&typeof F.scheme=="string"&&typeof F.fsPath=="string"&&typeof F.with=="function"&&typeof F.toString=="function":!1}constructor(F,u,C,p,D,_=!1){typeof F=="object"?(this.scheme=F.scheme||d,this.authority=F.authority||d,this.path=F.path||d,this.query=F.query||d,this.fragment=F.fragment||d):(this.scheme=f(F,_),this.authority=u||d,this.path=g(this.scheme,C||d),this.query=p||d,this.fragment=D||d,w(this,_))}get fsPath(){return r(this,!1)}with(F){if(!F)return this;let{scheme:u,authority:C,path:p,query:D,fragment:_}=F;return u===void 0?u=this.scheme:u===null&&(u=d),C===void 0?C=this.authority:C===null&&(C=d),p===void 0?p=this.path:p===null&&(p=d),D===void 0?D=this.query:D===null&&(D=d),_===void 0?_=this.fragment:_===null&&(_=d),u===this.scheme&&C===this.authority&&p===this.path&&D===this.query&&_===this.fragment?this:new s(u,C,p,D,_)}static parse(F,u=!1){const C=o.exec(F);return C?new s(C[2]||d,L(C[4]||d),L(C[5]||d),L(C[7]||d),L(C[9]||d),u):new s(d,d,d,d,d)}static file(F){let u=d;if(i.isWindows&&(F=F.replace(/\\/g,M)),F[0]===M&&F[1]===M){const C=F.indexOf(M,2);C===-1?(u=F.substring(2),F=M):(u=F.substring(2,C),F=F.substring(C)||M)}return new s("file",u,F,d,d)}static from(F){const u=new s(F.scheme,F.authority,F.path,F.query,F.fragment);return w(u,!0),u}static joinPath(F,...u){if(!F.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return i.isWindows&&F.scheme==="file"?C=n.file(v.win32.join(r(F,!0),...u)).path:C=v.posix.join(F.path,...u),F.with({path:C})}toString(F=!1){return h(this,F)}toJSON(){return this}static revive(F){if(F){if(F instanceof n)return F;{const u=new s(F);return u._formatted=F.external,u._fsPath=F._sep===e?F.fsPath:null,u}}else return F}}t.URI=n;const e=i.isWindows?1:void 0;class s extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(F=!1){return F?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const F={$mid:1};return this._fsPath&&(F.fsPath=this._fsPath,F._sep=e),this._formatted&&(F.external=this._formatted),this.path&&(F.path=this.path),this.scheme&&(F.scheme=this.scheme),this.authority&&(F.authority=this.authority),this.query&&(F.query=this.query),this.fragment&&(F.fragment=this.fragment),F}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(N,F){let u,C=-1;for(let p=0;p<N.length;p++){const D=N.charCodeAt(p);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||F&&D===47)C!==-1&&(u+=encodeURIComponent(N.substring(C,p)),C=-1),u!==void 0&&(u+=N.charAt(p));else{u===void 0&&(u=N.substr(0,p));const _=l[D];_!==void 0?(C!==-1&&(u+=encodeURIComponent(N.substring(C,p)),C=-1),u+=_):C===-1&&(C=p)}}return C!==-1&&(u+=encodeURIComponent(N.substring(C))),u!==void 0?u:N}function c(N){let F;for(let u=0;u<N.length;u++){const C=N.charCodeAt(u);C===35||C===63?(F===void 0&&(F=N.substr(0,u)),F+=l[C]):F!==void 0&&(F+=N[u])}return F!==void 0?F:N}function r(N,F){let u;return N.authority&&N.path.length>1&&N.scheme==="file"?u=`//${N.authority}${N.path}`:N.path.charCodeAt(0)===47&&(N.path.charCodeAt(1)>=65&&N.path.charCodeAt(1)<=90||N.path.charCodeAt(1)>=97&&N.path.charCodeAt(1)<=122)&&N.path.charCodeAt(2)===58?F?u=N.path.substr(1):u=N.path[1].toLowerCase()+N.path.substr(2):u=N.path,i.isWindows&&(u=u.replace(/\//g,"\\")),u}t.uriToFsPath=r;function h(N,F){const u=F?c:a;let C="",{scheme:p,authority:D,path:_,query:V,fragment:ee}=N;if(p&&(C+=p,C+=":"),(D||p==="file")&&(C+=M,C+=M),D){let Z=D.indexOf("@");if(Z!==-1){const pe=D.substr(0,Z);D=D.substr(Z+1),Z=pe.indexOf(":"),Z===-1?C+=u(pe,!1):(C+=u(pe.substr(0,Z),!1),C+=":",C+=u(pe.substr(Z+1),!1)),C+="@"}D=D.toLowerCase(),Z=D.indexOf(":"),Z===-1?C+=u(D,!1):(C+=u(D.substr(0,Z),!1),C+=D.substr(Z))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const Z=_.charCodeAt(1);Z>=65&&Z<=90&&(_=`/${String.fromCharCode(Z+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const Z=_.charCodeAt(0);Z>=65&&Z<=90&&(_=`${String.fromCharCode(Z+32)}:${_.substr(2)}`)}C+=u(_,!0)}return V&&(C+="?",C+=u(V,!1)),ee&&(C+="#",C+=F?ee:a(ee,!1)),C}function b(N){try{return decodeURIComponent(N)}catch{return N.length>3?N.substr(0,3)+b(N.substr(3)):N}}const A=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(N){return N.match(A)?N.replace(A,F=>b(F)):N}}),define(me[50],be([1,0,29,11,15]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function H(g){return JSON.stringify(g,w)}t.stringify=H;function y(g){let d=JSON.parse(g);return d=f(d),d}t.parse=y;function w(g,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:(0,i.regExpFlags)(d)}:d}function f(g,d=0){if(!g||d>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return U.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof v.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let M=0;M<g.length;++M)g[M]=f(g[M],d+1);else for(const M in g)Object.hasOwnProperty.call(g,M)&&(g[M]=f(g[M],d+1))}return g}t.revive=f}),define(me[34],be([1,0,5,15]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var U;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebook="vscode-notebook",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractive="vscode-interactive",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(U=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class H{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${U.vscodeRemoteResource}`}set(g,d,M){this.a[g]=d,this.b[g]=M}setConnectionToken(g,d){this.c[g]=d}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)return this.e(g);const d=g.authority;let M=this.a[d];M&&M.indexOf(":")!==-1&&M.indexOf("[")===-1&&(M=`[${M}]`);const o=this.b[d],n=this.c[d];let e=`path=${encodeURIComponent(g.path)}`;return typeof n=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(n)}`),i.URI.from({scheme:v.isWeb?this.d:U.vscodeRemoteResource,authority:`${M}:${o}`,path:this.f,query:e})}}t.RemoteAuthorities=new H,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(g){const d=this.b(g,X);return this.uriToBrowserUri(d)}uriToBrowserUri(g){return g.scheme===U.vscodeRemote?t.RemoteAuthorities.rewrite(g):g.scheme===U.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${U.vscodeFileResource}://${y.a}`)?g.with({scheme:U.vscodeFileResource,authority:g.authority||y.a,query:null,fragment:null}):g}asFileUri(g){const d=this.b(g,X);return this.uriToFileUri(d)}uriToFileUri(g){return g.scheme===U.vscodeFileResource?g.with({scheme:U.file,authority:g.authority!==y.a?g.authority:null,query:null,fragment:null}):g}b(g,d){return i.URI.isUri(g)?g:i.URI.parse(d.toUrl(g))}}y.a="vscode-app",t.FileAccess=new y;var w;(function(f){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(g.get("3"));const d="vscode-coi";function M(n){let e;typeof n=="string"?e=new URL(n).searchParams:n instanceof URL?e=n.searchParams:i.URI.isUri(n)&&(e=new URL(n.toString(!0)).searchParams);const s=e?.get(d);if(!!s)return g.get(s)}f.getHeadersFromQuery=M;function o(n,e,s){if(!globalThis.crossOriginIsolated)return;const l=e&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(d,l):n[d]=l}f.addSearchParam=o})(w=t.COI||(t.COI={}))}),define(me[35],be([1,0,110,34,21,5,11,15]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function f(n){return(0,w.uriToFsPath)(n,!0)}t.originalFSPath=f;class g{constructor(e){this.a=e}compare(e,s,l=!1){return e===s?0:(0,y.compare)(this.getComparisonKey(e,l),this.getComparisonKey(s,l))}isEqual(e,s,l=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,l)===this.getComparisonKey(s,l)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,l=!1){if(e.scheme===s.scheme){if(e.scheme===i.Schemas.file)return v.isEqualOrParent(f(e),f(s),this.a(e))&&e.query===s.query&&(l||e.fragment===s.fragment);if((0,t.isEqualAuthority)(e.authority,s.authority))return v.isEqualOrParent(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(l||e.fragment===s.fragment)}return!1}joinPath(e,...s){return w.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return U.posix.basename(e.path)}extname(e){return U.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(U.dirname(f(e))).path:(s=U.posix.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(U.normalize(f(e))).path:s=U.posix.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.isEqualAuthority)(e.authority,s.authority))return;if(e.scheme===i.Schemas.file){const c=U.relative(f(e),f(s));return H.isWindows?v.toSlashes(c):c}let l=e.path||"/";const a=s.path||"/";if(this.a(e)){let c=0;for(const r=Math.min(l.length,a.length);c<r&&!(l.charCodeAt(c)!==a.charCodeAt(c)&&l.charAt(c).toLowerCase()!==a.charAt(c).toLowerCase());c++);l=a.substr(0,c)+l.substr(c)}return U.posix.relative(l,a)}resolvePath(e,s){if(e.scheme===i.Schemas.file){const l=w.URI.file(U.resolve(f(e),s));return e.with({authority:l.authority,path:l.path})}return s=v.toPosixPath(s),e.with({path:U.posix.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,y.equalsIgnoreCase)(e,s)}hasTrailingPathSeparator(e,s=U.sep){if(e.scheme===i.Schemas.file){const l=f(e);return l.length>v.getRoot(l).length&&l[l.length-1]===s}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=U.sep){return(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=U.sep){let l=!1;if(e.scheme===i.Schemas.file){const a=f(e);l=a!==void 0&&a.length===v.getRoot(a).length&&a[a.length-1]===s}else{s="/";const a=e.path;l=a.length===1&&a.charCodeAt(a.length-1)===47}return!l&&!(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path+"/"}):e}}t.ExtUri=g,t.extUri=new g(()=>!1),t.extUriBiasedIgnorePathCase=new g(n=>n.scheme===i.Schemas.file?!H.isLinux:!0),t.extUriIgnorePathCase=new g(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function d(n,e){const s=[];for(let l=0;l<n.length;l++){const a=e(n[l]);n.some((c,r)=>r===l?!1:(0,t.isEqualOrParent)(a,e(c)))||s.push(n[l])}return s}t.distinctParents=d;var M;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(s){const l=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[h,b]=r.split(":");h&&b&&l.set(h,b)});const c=s.path.substring(0,s.path.indexOf(";"));return c&&l.set(n.META_DATA_MIME,c),l}n.parseMetaData=e})(M=t.DataUri||(t.DataUri={}));function o(n,e,s){if(e){let l=n.path;return l&&l[0]!==U.posix.sep&&(l=U.posix.sep+l),n.with({scheme:s,authority:e,path:l})}return n.with({scheme:s})}t.toLocalResource=o}),define(me[8],be([1,0,26,9,3,2,35,5]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function f(T){return!!T&&typeof T.then=="function"}t.isThenable=f;function g(T){const E=new v.CancellationTokenSource,m=T(E.token),B=new Promise((z,$)=>{const G=E.token.onCancellationRequested(()=>{G.dispose(),E.dispose(),$(new i.CancellationError)});Promise.resolve(m).then(k=>{G.dispose(),E.dispose(),z(k)},k=>{G.dispose(),E.dispose(),$(k)})});return new class{cancel(){E.cancel()}then(z,$){return B.then(z,$)}catch(z){return this.then(void 0,z)}finally(z){return B.finally(z)}}}t.createCancelablePromise=g;function d(T,E,m){return new Promise((B,z)=>{const $=E.onCancellationRequested(()=>{$.dispose(),B(m)});T.then(B,z).finally(()=>$.dispose())})}t.raceCancellation=d;function M(T,E){return new Promise((m,B)=>{const z=E.onCancellationRequested(()=>{z.dispose(),B(new i.CancellationError)});T.then(m,B).finally(()=>z.dispose())})}t.raceCancellationError=M;async function o(T){let E=-1;const m=T.map((z,$)=>z.then(G=>(E=$,G))),B=await Promise.race(m);return T.forEach((z,$)=>{$!==E&&z.cancel()}),B}t.raceCancellablePromises=o;function n(T,E,m){let B;const z=setTimeout(()=>{B?.(void 0),m?.()},E);return Promise.race([T.finally(()=>clearTimeout(z)),new Promise($=>B=$)])}t.raceTimeout=n;function e(T){return new Promise((E,m)=>{const B=T();f(B)?B.then(E,m):E(B)})}t.asPromise=e;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(E){if(this.a){if(this.d=E,!this.b){const m=()=>{this.b=null;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(m,m).then(B)})}return new Promise((m,B)=>{this.b.then(m,B)})}return this.a=E(),new Promise((m,B)=>{this.a.then(z=>{this.a=null,m(z)},z=>{this.a=null,B(z)})})}}t.Throttler=s;class l{constructor(){this.a=Promise.resolve(null)}queue(E){return this.a=this.a.then(()=>E(),()=>E())}}t.Sequencer=l;class a{constructor(){this.a=new Map}queue(E,m){const z=(this.a.get(E)??Promise.resolve()).catch(()=>{}).then(m).finally(()=>{this.a.get(E)===z&&this.a.delete(E)});return this.a.set(E,z),z}}t.SequencerByKey=a;const c=(T,E)=>{let m=!0;const B=setTimeout(()=>{m=!1,E()},T);return{isTriggered:()=>m,dispose:()=>{clearTimeout(B),m=!1}}},r=T=>{let E=!0;return queueMicrotask(()=>{E&&(E=!1,T())}),{isTriggered:()=>E,dispose:()=>{E=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(E){this.defaultDelay=E,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(E,m=this.defaultDelay){this.g=E,this.h(),this.b||(this.b=new Promise((z,$)=>{this.d=z,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=m===t.MicrotaskDelay?r(B):c(m,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=h;class b{constructor(E){this.a=new h(E),this.b=new s}trigger(E,m){return this.a.trigger(()=>this.b.queue(E),m)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=b;class A{constructor(){this.a=!1,this.b=new Promise((E,m)=>{this.d=E})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=A;class L extends A{constructor(E){super(),this.f=setTimeout(()=>this.open(),E)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=L;function N(T,E){return E?new Promise((m,B)=>{const z=setTimeout(()=>{$.dispose(),m()},T),$=E.onCancellationRequested(()=>{clearTimeout(z),$.dispose(),B(new i.CancellationError)})}):g(m=>N(T,m))}t.timeout=N;function F(T,E=0){const m=setTimeout(T,E);return(0,H.toDisposable)(()=>clearTimeout(m))}t.disposableTimeout=F;function u(T){const E=[];let m=0;const B=T.length;function z(){return m<B?T[m++]():null}function $(G){G!=null&&E.push(G);const k=z();return k?k.then($):Promise.resolve(E)}return Promise.resolve(null).then($)}t.sequence=u;function C(T,E=B=>!!B,m=null){let B=0;const z=T.length,$=()=>{if(B>=z)return Promise.resolve(m);const G=T[B++];return Promise.resolve(G()).then(O=>E(O)?Promise.resolve(O):$())};return $()}t.first=C;function p(T,E=B=>!!B,m=null){if(T.length===0)return Promise.resolve(m);let B=T.length;const z=()=>{B=-1;for(const $ of T)$.cancel?.()};return new Promise(($,G)=>{for(const k of T)k.then(O=>{--B>=0&&E(O)?(z(),$(O)):B===0&&$(m)}).catch(O=>{--B>=0&&(z(),G(O))})})}t.firstParallel=p;class D{constructor(E){this.a=0,this.d=E,this.f=[],this.b=0,this.g=new U.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(E){return this.a++,new Promise((m,B)=>{this.f.push({factory:E,c:m,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const E=this.f.shift();this.b++;const m=E.factory();m.then(E.c,E.e),m.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=D;class _ extends D{constructor(){super(1)}}t.Queue=_;class V{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const E=new ie;return this.b.add(E),E.p}d(){for(const[,E]of this.a)if(E.size>0)return!1;return!0}queueFor(E,m=y.extUri){const B=m.getComparisonKey(E);let z=this.a.get(B);return z||(z=new _,U.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(B),this.f()}),this.a.set(B,z)),z}f(){!this.d()||this.g()}g(){for(const E of this.b)E.complete();this.b.clear()}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),this.g()}}t.ResourceQueue=V;class ee{constructor(E,m){this.a=-1,typeof E=="function"&&typeof m=="number"&&this.setIfNotSet(E,m)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(E,m){this.cancel(),this.a=setTimeout(()=>{this.a=-1,E()},m)}setIfNotSet(E,m){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,E()},m))}}t.TimeoutTimer=ee;class Z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(E,m){this.cancel(),this.a=setInterval(()=>{E()},m)}}t.IntervalTimer=Z;class pe{constructor(E,m){this.b=-1,this.a=E,this.d=m,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(E=this.d){this.cancel(),this.b=setTimeout(this.f,E)}get delay(){return this.d}set delay(E){this.d=E}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=pe;class oe{constructor(E,m){m%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${m}ms is not a multiple of 1000ms.`),this.a=E,this.b=m,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(E=this.b){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(E/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=oe;class ce extends pe{constructor(E,m){super(E,m),this.j=[]}work(E){this.j.push(E),this.isScheduled()||this.schedule()}h(){const E=this.j;this.j=[],this.a?.(E)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=ce;class ae extends H.Disposable{constructor(E,m){super(),this.g=E,this.h=m,this.a=[],this.b=this.B(new H.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(E){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+E.length>this.g.maxBufferedWork)return!1}else if(this.pending+E.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...E),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new pe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=T=>{(0,w.setTimeout0)(()=>{if(E)return;const m=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,m-Date.now())}}))});let E=!1;return{dispose(){E||(E=!0)}}}:t.runWhenIdle=(T,E)=>{const m=requestIdleCallback(T,typeof E=="number"?{timeout:E}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(m))}}}}();class de{constructor(E){this.d=!1,this.a=()=>{try{this.f=E()}catch(m){this.g=m}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=de;async function Se(T,E,m){let B;for(let z=0;z<m;z++)try{return await T()}catch($){B=$,await N(E)}throw B}t.retry=Se;class x{hasPending(E){return this.a?typeof E=="number"?this.a.taskId===E:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(E,m,B){return this.a={taskId:E,cancel:()=>B?.(),promise:m},m.then(()=>this.d(E),()=>this.d(E)),m}d(E){this.a&&E===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const E=this.b;this.b=void 0,E.run().then(E.promiseResolve,E.promiseReject)}}setNext(E){if(this.b)this.b.run=E;else{let m,B;const z=new Promise(($,G)=>{m=$,B=G});this.b={run:E,promise:z,promiseResolve:m,promiseReject:B}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=x;class ye{constructor(E,m=()=>Date.now()){this.d=E,this.f=m,this.a=0,this.b=0}increment(){const E=this.f();return E-this.a>this.d&&(this.a=E,this.b=0),this.b++,this.b}}t.IntervalCounter=ye;class ie{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((E,m)=>{this.a=E,this.b=m})}complete(E){return new Promise(m=>{this.a(E),this.f=!0,m()})}error(E){return new Promise(m=>{this.b(E),this.d=!0,m()})}cancel(){new Promise(E=>{this.b(new i.CancellationError),this.d=!0,E()})}}t.DeferredPromise=ie;var J;(function(T){async function E(B){let z;const $=await Promise.all(B.map(G=>G.then(k=>k,k=>{z||(z=k)})));if(typeof z<"u")throw z;return $}T.settled=E;function m(B){return new Promise(async(z,$)=>{try{await B(z,$)}catch(G){$(G)}})}T.withAsyncBody=m})(J=t.Promises||(t.Promises={}));var he;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(he||(he={}));class fe{static fromArray(E){return new fe(m=>{m.emitMany(E)})}static fromPromise(E){return new fe(async m=>{m.emitMany(await E)})}static fromPromises(E){return new fe(async m=>{await Promise.all(E.map(async B=>m.emitOne(await B)))})}static merge(E){return new fe(async m=>{await Promise.all(E.map(async B=>{for await(const z of B)m.emitOne(z)}))})}constructor(E){this.a=0,this.b=[],this.d=null,this.f=new U.Emitter,queueMicrotask(async()=>{const m={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(E(m)),this.j()}catch(B){this.k(B)}finally{m.emitOne=void 0,m.emitMany=void 0,m.reject=void 0}})}[Symbol.asyncIterator](){let E=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(E<this.b.length)return{done:!1,value:this.b[E++]};if(this.a===1)return{done:!0,value:void 0};await U.Event.toPromise(this.f.event)}while(!0)}}}static map(E,m){return new fe(async B=>{for await(const z of E)B.emitOne(m(z))})}map(E){return fe.map(this,E)}static filter(E,m){return new fe(async B=>{for await(const z of E)m(z)&&B.emitOne(z)})}filter(E){return fe.filter(this,E)}static coalesce(E){return fe.filter(E,m=>!!m)}coalesce(){return fe.coalesce(this)}static async toPromise(E){const m=[];for await(const B of E)m.push(B);return m}toPromise(){return fe.toPromise(this)}g(E){this.a===0&&(this.b.push(E),this.f.fire())}h(E){this.a===0&&(this.b=this.b.concat(E),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(E){this.a===0&&(this.a=2,this.d=E,this.f.fire())}}t.AsyncIterableObject=fe,fe.EMPTY=fe.fromArray([]);class le extends fe{constructor(E,m){super(m),this.l=E}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=le;function te(T){const E=new v.CancellationTokenSource,m=T(E.token);return new le(E,async B=>{const z=E.token.onCancellationRequested(()=>{z.dispose(),E.dispose(),B.reject(new i.CancellationError)});try{for await(const $ of m){if(E.token.isCancellationRequested)return;B.emitOne($)}z.dispose(),E.dispose()}catch($){z.dispose(),E.dispose(),B.reject($)}})}t.createCancelableAsyncIterable=te}),define(me[4],be([1,0,16,108,19,20,8,9,3,114,2,34,5,6,15]),function(X,t,v,i,U,H,y,w,f,g,d,M,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function s(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.clearNode=s;function l(Y){return Y?.isConnected??!1}t.isInDOM=l;class a{constructor(q,ge,Te,Ne){this.f=q,this.g=ge,this.d=Te,this.j=Ne||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function c(Y,q,ge,Te){return new a(Y,q,ge,Te)}t.addDisposableListener=c;function r(Y){return function(q){return Y(new H.StandardMouseEvent(q))}}function h(Y){return function(q){return Y(new U.StandardKeyboardEvent(q))}}const b=function(q,ge,Te,Ne){let Ke=Te;return ge==="click"||ge==="mousedown"?Ke=r(Te):(ge==="keydown"||ge==="keypress"||ge==="keyup")&&(Ke=h(Te)),c(q,ge,Ke,Ne)};t.addStandardDisposableListener=b;const A=function(q,ge,Te){const Ne=r(ge);return N(q,Ne,Te)};t.addStandardDisposableGenericMouseDownListener=A;const L=function(q,ge,Te){const Ne=r(ge);return u(q,Ne,Te)};t.addStandardDisposableGenericMouseUpListener=L;function N(Y,q,ge){return c(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,q,ge)}t.addDisposableGenericMouseDownListener=N;function F(Y,q,ge){return c(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,q,ge)}t.addDisposableGenericMouseMoveListener=F;function u(Y,q,ge){return c(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,q,ge)}t.addDisposableGenericMouseUpListener=u;class C{constructor(q,ge=0){this.d=q,this.priority=ge,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(q){(0,w.onUnexpectedError)(q)}}static sort(q,ge){return ge.priority-q.priority}}(function(){let Y=[],q=null,ge=!1,Te=!1;const Ne=()=>{for(ge=!1,q=Y,Y=[],Te=!0;q.length>0;)q.sort(C.sort),q.shift().execute();Te=!1};t.scheduleAtNextAnimationFrame=(Ke,_e=0)=>{const Xe=new C(Ke,_e);return Y.push(Xe),ge||(ge=!0,requestAnimationFrame(Ne)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(Ke,_e)=>{if(Te){const Xe=new C(Ke,_e);return q.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(Ke,_e)}})();function p(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=p;function D(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=D;const _=8,V=function(Y,q){return q};class ee extends d.Disposable{constructor(q,ge,Te,Ne=V,Ke=_){super();let _e=null,Xe=0;const Je=this.B(new y.TimeoutTimer),gt=()=>{Xe=new Date().getTime(),Te(_e),_e=null};this.B(c(q,ge,Nt=>{_e=Ne(_e,Nt);const mt=new Date().getTime()-Xe;mt>=Ke?(Je.cancel(),gt()):Je.setIfNotSet(gt,Ke-mt)}))}}function Z(Y,q,ge,Te,Ne){return new ee(Y,q,ge,Te,Ne)}t.addDisposableThrottledListener=Z;function pe(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=pe;function oe(Y){if(Y!==document.body)return new ae(Y.clientWidth,Y.clientHeight);if(o.isIOS&&window.visualViewport)return new ae(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ae(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ae(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ae(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=oe;class ce{static d(q,ge){return parseFloat(ge)||0}static f(q,ge,Te){const Ne=pe(q),Ke=Ne?Ne.getPropertyValue(ge):"0";return ce.d(q,Ke)}static getBorderLeftWidth(q){return ce.f(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return ce.f(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return ce.f(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return ce.f(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return ce.f(q,"padding-left","paddingLeft")}static getPaddingRight(q){return ce.f(q,"padding-right","paddingRight")}static getPaddingTop(q){return ce.f(q,"padding-top","paddingTop")}static getPaddingBottom(q){return ce.f(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return ce.f(q,"margin-left","marginLeft")}static getMarginTop(q){return ce.f(q,"margin-top","marginTop")}static getMarginRight(q){return ce.f(q,"margin-right","marginRight")}static getMarginBottom(q){return ce.f(q,"margin-bottom","marginBottom")}}class ae{constructor(q,ge){this.width=q,this.height=ge}with(q=this.width,ge=this.height){return q!==this.width||ge!==this.height?new ae(q,ge):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof ae?q:new ae(q.width,q.height)}static equals(q,ge){return q===ge?!0:!q||!ge?!1:q.width===ge.width&&q.height===ge.height}}t.Dimension=ae,ae.None=new ae(0,0);function de(Y){let q=Y.offsetParent,ge=Y.offsetTop,Te=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){ge-=Y.scrollTop;const Ne=W(Y)?null:pe(Y);Ne&&(Te-=Ne.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===q&&(Te+=ce.getBorderLeftWidth(Y),ge+=ce.getBorderTopWidth(Y),ge+=Y.offsetTop,Te+=Y.offsetLeft,q=Y.offsetParent)}return{left:Te,top:ge}}t.getTopLeftOffset=de;function Se(Y,q,ge){typeof q=="number"&&(Y.style.width=`${q}px`),typeof ge=="number"&&(Y.style.height=`${ge}px`)}t.size=Se;function x(Y,q,ge,Te,Ne,Ke="absolute"){typeof q=="number"&&(Y.style.top=`${q}px`),typeof ge=="number"&&(Y.style.right=`${ge}px`),typeof Te=="number"&&(Y.style.bottom=`${Te}px`),typeof Ne=="number"&&(Y.style.left=`${Ne}px`),Y.style.position=Ke}t.position=x;function ye(Y){const q=Y.getBoundingClientRect();return{left:q.left+window.scrollX,top:q.top+window.scrollY,width:q.width,height:q.height}}t.getDomNodePagePosition=ye;function ie(Y){let q=Y,ge=1;do{const Te=pe(q).zoom;Te!=null&&Te!=="1"&&(ge*=Te),q=q.parentElement}while(q!==null&&q!==document.documentElement);return ge}t.getDomNodeZoomLevel=ie;function J(Y){const q=ce.getMarginLeft(Y)+ce.getMarginRight(Y);return Y.offsetWidth+q}t.getTotalWidth=J;function he(Y){const q=ce.getBorderLeftWidth(Y)+ce.getBorderRightWidth(Y),ge=ce.getPaddingLeft(Y)+ce.getPaddingRight(Y);return Y.offsetWidth-q-ge}t.getContentWidth=he;function fe(Y){const q=ce.getMarginLeft(Y)+ce.getMarginRight(Y);return Y.scrollWidth+q}t.getTotalScrollWidth=fe;function le(Y){const q=ce.getBorderTopWidth(Y)+ce.getBorderBottomWidth(Y),ge=ce.getPaddingTop(Y)+ce.getPaddingBottom(Y);return Y.offsetHeight-q-ge}t.getContentHeight=le;function te(Y){const q=ce.getMarginTop(Y)+ce.getMarginBottom(Y);return Y.offsetHeight+q}t.getTotalHeight=te;function T(Y,q){if(Y===null)return 0;const ge=de(Y),Te=de(q);return ge.left-Te.left}function E(Y,q){const ge=q.map(Ne=>Math.max(fe(Ne),J(Ne))+T(Ne,Y)||0);return Math.max(...ge)}t.getLargestChildWidth=E;function m(Y,q){for(;Y;){if(Y===q)return!0;Y=Y.parentNode}return!1}t.isAncestor=m;const B="parentFlowToElementId";function z(Y,q){Y.dataset[B]=q.id}t.setParentFlowTo=z;function $(Y){const q=Y.dataset[B];return typeof q=="string"?document.getElementById(q):null}function G(Y,q){let ge=Y;for(;ge;){if(ge===q)return!0;if(ge instanceof HTMLElement){const Te=$(ge);if(Te){ge=Te;continue}}ge=ge.parentNode}return!1}t.isAncestorUsingFlowTo=G;function k(Y,q,ge){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(q))return Y;if(ge){if(typeof ge=="string"){if(Y.classList.contains(ge))return null}else if(Y===ge)return null}Y=Y.parentNode}return null}t.findParentWithClass=k;function O(Y,q,ge){return!!k(Y,q,ge)}t.hasParentWithClass=O;function W(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=W;function S(Y){return!!I(Y)}t.isInShadowDOM=S;function I(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return W(Y)?Y:null}t.getShadowRoot=I;function P(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=P;function R(Y=document.getElementsByTagName("head")[0]){const q=document.createElement("style");return q.type="text/css",q.media="screen",Y.appendChild(q),q}t.createStyleSheet=R;function j(Y=document.getElementsByTagName("head")[0]){const q=document.createElement("meta");return Y.appendChild(q),q}t.createMetaElement=j;let Q=null;function re(){return Q||(Q=R()),Q}function ue(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function De(Y,q,ge=re()){!ge||!q||ge.sheet.insertRule(Y+"{"+q+"}",0)}t.createCSSRule=De;function Ee(Y,q=re()){if(!q)return;const ge=ue(q),Te=[];for(let Ne=0;Ne<ge.length;Ne++)ge[Ne].selectorText.indexOf(Y)!==-1&&Te.push(Ne);for(let Ne=Te.length-1;Ne>=0;Ne--)q.sheet.deleteRule(Te[Ne])}t.removeCSSRulesContainingSelector=Ee;function Ie(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Ie,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:v.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(Y,q)=>(Y.preventDefault(),q&&Y.stopPropagation(),Y)};function ke(Y){const q=[];for(let ge=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ge++)q[ge]=Y.scrollTop,Y=Y.parentNode;return q}t.saveParentsScrollTop=ke;function ve(Y,q){for(let ge=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ge++)Y.scrollTop!==q[ge]&&(Y.scrollTop=q[ge]),Y=Y.parentNode}t.restoreParentsScrollTop=ve;class Pe extends d.Disposable{static l(q){const ge=I(q),Te=ge?ge.activeElement:document.activeElement;return m(Te,q)}constructor(q){super(),this.f=this.B(new f.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new f.Emitter),this.onDidBlur=this.g.event;let ge=Pe.l(q),Te=!1;const Ne=()=>{Te=!1,ge||(ge=!0,this.f.fire())},Ke=()=>{ge&&(Te=!0,window.setTimeout(()=>{Te&&(Te=!1,ge=!1,this.g.fire())},0))};this.j=()=>{Pe.l(q)!==ge&&(ge?Ke():Ne())},this.B(c(q,t.EventType.FOCUS,Ne,!0)),this.B(c(q,t.EventType.BLUR,Ke,!0)),this.B(c(q,t.EventType.FOCUS_IN,()=>this.j())),this.B(c(q,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Re(Y){return new Pe(Y)}t.trackFocus=Re;function je(Y,q){return Y.after(q),q}t.after=je;function Ue(Y,...q){if(Y.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}t.append=Ue;function ze(Y,q){return Y.insertBefore(q,Y.firstChild),q}t.prepend=ze;function xe(Y,...q){Y.innerText="",Ue(Y,...q)}t.reset=xe;const it=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Be;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(Be=t.Namespace||(t.Namespace={}));function Ve(Y,q,ge,...Te){const Ne=it.exec(q);if(!Ne)throw new Error("Bad use of emmet");const Ke=Ne[1]||"div";let _e;return Y!==Be.HTML?_e=document.createElementNS(Y,Ke):_e=document.createElement(Ke),Ne[3]&&(_e.id=Ne[3]),Ne[4]&&(_e.className=Ne[4].replace(/\./g," ").trim()),ge&&Object.entries(ge).forEach(([Xe,Je])=>{typeof Je>"u"||(/^on\w+$/.test(Xe)?_e[Xe]=Je:Xe==="selected"?Je&&_e.setAttribute(Xe,"true"):_e.setAttribute(Xe,Je))}),_e.append(...Te),_e}function Ye(Y,q,...ge){return Ve(Be.HTML,Y,q,...ge)}t.$=Ye,Ye.SVG=function(Y,q,...ge){return Ve(Be.SVG,Y,q,...ge)};function K(Y,q){const ge=[];return Y.forEach((Te,Ne)=>{Ne>0&&(q instanceof Node?ge.push(q.cloneNode()):ge.push(document.createTextNode(q))),ge.push(Te)}),ge}t.join=K;function se(...Y){for(const q of Y)q.style.display="",q.removeAttribute("aria-hidden")}t.show=se;function we(...Y){for(const q of Y)q.style.display="none",q.setAttribute("aria-hidden","true")}t.hide=we;function Ce(Y,q){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(q))return Y;Y=Y.parentNode}return null}function Fe(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&Ce(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Fe;function Oe(Y){return q=>{q.preventDefault(),q.stopPropagation(),Y(q)}}t.finalHandler=Oe;function $e(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=$e;function tt(Y){const q=window.devicePixelRatio*Y;return Math.max(1,Math.floor(q))/window.devicePixelRatio}t.computeScreenAwareSize=tt;function Me(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=Me;const ne=780,Ae=640;function Le(Y){const q=Math.floor(window.screenLeft+window.innerWidth/2-ne/2),ge=Math.floor(window.screenTop+window.innerHeight/2-Ae/2);window.open(Y,"_blank",`width=${ne},height=${Ae},top=${ge},left=${q}`)}t.windowOpenPopup=Le;function We(Y,q=!0){const ge=window.open();return ge?(q&&(ge.opener=null),ge.location.href=Y,!0):!1}t.windowOpenWithSuccess=We;function Ge(Y){const q=()=>{Y(),ge=(0,t.scheduleAtNextAnimationFrame)(q)};let ge=(0,t.scheduleAtNextAnimationFrame)(q);return(0,d.toDisposable)(()=>ge.dispose())}t.animate=Ge,M.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Ze(Y){return Y?`url('${M.FileAccess.uriToBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Ze;function Qe(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Qe;function st(Y,q){let ge;if(e.URI.isUri(Y))ge=Y.toString(!0);else{const Ne=new Blob([Y]);ge=URL.createObjectURL(Ne),setTimeout(()=>URL.revokeObjectURL(ge))}const Te=document.createElement("a");document.body.appendChild(Te),Te.download=q,Te.href=ge,Te.click(),setTimeout(()=>document.body.removeChild(Te))}t.triggerDownload=st;function ct(){return new Promise(Y=>{const q=document.createElement("input");document.body.appendChild(q),q.type="file",q.multiple=!0,f.Event.once(f.Event.fromDOMEventEmitter(q,"input"))(()=>{Y((0,n.withNullAsUndefined)(q.files))}),q.click(),setTimeout(()=>document.body.removeChild(q))})}t.triggerUpload=ct;var dt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(dt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function Ft(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.detectFullscreen=Ft;function Tt(Y,q=!1){const ge=document.createElement("a");return g.addHook("afterSanitizeAttributes",Te=>{for(const Ne of["href","src"])if(Te.hasAttribute(Ne)){const Ke=Te.getAttribute(Ne);if(Ne==="href"&&Ke.startsWith("#"))continue;if(ge.href=Ke,!Y.includes(ge.protocol.replace(/:$/,""))){if(q&&Ne==="src"&&ge.href.startsWith("data:"))continue;Te.removeAttribute(Ne)}}}),(0,d.toDisposable)(()=>{g.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Tt;const hi=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const ui=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function ci(Y,q){const ge=Tt(hi);try{const Te=g.sanitize(q,ui);Y.innerHTML=Te}finally{ge.dispose()}}t.safeInnerHtml=ci;function di(Y){const q=new Uint16Array(Y.length);for(let Ne=0;Ne<q.length;Ne++)q[Ne]=Y.charCodeAt(Ne);let ge="";const Te=new Uint8Array(q.buffer);for(let Ne=0;Ne<Te.length;Ne++)ge+=String.fromCharCode(Te[Ne]);return ge}function fi(Y){return btoa(di(Y))}t.multibyteAwareBtoa=fi;class ft extends f.Emitter{constructor(){super(),this.s=new d.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(c(window,"keydown",q=>{if(q.defaultPrevented)return;const ge=new U.StandardKeyboardEvent(q);if(!(ge.keyCode===6&&q.repeat)){if(q.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(q.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(q.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(q.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(ge.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyPressed&&(this.t.event=q,this.fire(this.t))}},!0)),this.s.add(c(window,"keyup",q=>{q.defaultPrevented||(!q.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!q.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!q.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!q.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyReleased&&(this.t.event=q,this.fire(this.t)))},!0)),this.s.add(c(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(c(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(c(document.body,"mousemove",q=>{q.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(c(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.u||(ft.u=new ft),ft.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=ft;function gi(Y){const q=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}t.getCookieValue=gi;class mi extends d.Disposable{constructor(q,ge){super(),this.j=q,this.l=ge,this.f=0,this.g=0,this.m()}m(){this.B(c(this.j,t.EventType.DRAG_ENTER,q=>{this.f++,this.g=q.timeStamp,this.l.onDragEnter(q)})),this.B(c(this.j,t.EventType.DRAG_OVER,q=>{q.preventDefault(),this.l.onDragOver?.(q,q.timeStamp-this.g)})),this.B(c(this.j,t.EventType.DRAG_LEAVE,q=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(q))})),this.B(c(this.j,t.EventType.DRAG_END,q=>{this.f=0,this.g=0,this.l.onDragEnd(q)})),this.B(c(this.j,t.EventType.DROP,q=>{this.f=0,this.g=0,this.l.onDrop(q)}))}}t.DragAndDropObserver=mi;const bi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function pi(Y,...q){let ge,Te;Array.isArray(q[0])?(ge={},Te=q[0]):(ge=q[0]||{},Te=q[1]);const Ne=bi.exec(Y);if(!Ne||!Ne.groups)throw new Error("Bad use of h");const Ke=Ne.groups.tag||"div",_e=document.createElement(Ke);Ne.groups.id&&(_e.id=Ne.groups.id),Ne.groups.class&&(_e.className=Ne.groups.class.replace(/\./g," ").trim());const Xe={};if(Ne.groups.name&&(Xe[Ne.groups.name]=_e),Te)for(const Je of Te)Je instanceof HTMLElement?_e.appendChild(Je):typeof Je=="string"?_e.append(Je):(Object.assign(Xe,Je),_e.appendChild(Je.root));for(const[Je,gt]of Object.entries(ge))if(Je==="style")for(const[Nt,mt]of Object.entries(gt))_e.style.setProperty(zt(Nt),typeof mt=="number"?mt+"px":""+mt);else Je==="tabIndex"?_e.tabIndex=gt:_e.setAttribute(zt(Je),gt.toString());return Xe.root=_e,Xe}t.h=pi;function zt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[51],be([1,0,4,2,106]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class H extends i.Disposable{constructor(f,g){super(),this.B((0,v.addDisposableListener)(f,"dragover",d=>{d.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this.B((0,v.addDisposableListener)(f,d,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=H,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:U.Mimes.text};function y(w,f,g){const d=document.createElement("div");d.className=g,d.textContent=f,w.dataTransfer&&(document.body.appendChild(d),w.dataTransfer.setDragImage(d,-10,-10),setTimeout(()=>document.body.removeChild(d),0))}t.applyDragImage=y}),define(me[52],be([1,0,4]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(o,n={}){const e=H(n);return e.textContent=o,e}t.renderText=i;function U(o,n={}){const e=H(n);return f(e,g(o,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=U;function H(o){const n=o.inline?"span":"div",e=document.createElement(n);return o.className&&(e.className=o.className),e}t.createElement=H;class y{constructor(n){this.b=n,this.c=0}eos(){return this.c>=this.b.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(w||(w={}));function f(o,n,e,s){let l;if(n.type===2)l=document.createTextNode(n.content||"");else if(n.type===3)l=document.createElement("b");else if(n.type===4)l=document.createElement("i");else if(n.type===7&&s)l=document.createElement("code");else if(n.type===5&&e){const a=document.createElement("a");e.disposables.add(v.addStandardDisposableListener(a,"click",c=>{e.callback(String(n.index),c)})),l=a}else n.type===8?l=document.createElement("br"):n.type===1&&(l=o);l&&o!==l&&o.appendChild(l),l&&Array.isArray(n.children)&&n.children.forEach(a=>{f(l,a,e,s)})}function g(o,n){const e={type:1,children:[]};let s=0,l=e;const a=[],c=new y(o);for(;!c.eos();){let r=c.next();const h=r==="\\"&&M(c.peek(),n)!==0;if(h&&(r=c.next()),!h&&d(r,n)&&r===c.peek()){c.advance(),l.type===2&&(l=a.pop());const b=M(r,n);if(l.type===b||l.type===5&&b===6)l=a.pop();else{const A={type:b,children:[]};b===5&&(A.index=s,s++),l.children.push(A),a.push(l),l=A}}else if(r===`
`)l.type===2&&(l=a.pop()),l.children.push({type:8});else if(l.type!==2){const b={type:2,content:r};l.children.push(b),a.push(l),l=b}else l.content+=r}return l.type===2&&(l=a.pop()),a.length,e}function d(o,n){return M(o,n)!==0}function M(o,n){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(me[53],be([1,0,4,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class U{constructor(){this.a=new i.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(y,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const f=this.c;this.c=null,y&&f&&f(w)}isMonitoring(){return!!this.b}startMonitoring(y,w,f,g,d){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=d;let M=y;try{y.setPointerCapture(w),this.a.add((0,i.toDisposable)(()=>{try{y.releasePointerCapture(w)}catch{}}))}catch{M=window}this.a.add(v.addDisposableListener(M,v.EventType.POINTER_MOVE,o=>{if(o.buttons!==f){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(v.addDisposableListener(M,v.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=U});var qe=this&&this.__decorate||function(X,t,v,i){var U=arguments.length,H=U<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,v):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(X,t,v,i);else for(var w=X.length-1;w>=0;w--)(y=X[w])&&(H=(U<3?y(H):U>3?y(t,v,H):y(t,v))||H);return U>3&&H&&Object.defineProperty(t,v,H),H};define(me[22],be([1,0,4,14,24,2,45]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var w;(function(g){g.Tap="-monaco-gesturetap",g.Change="-monaco-gesturechange",g.Start="-monaco-gesturestart",g.End="-monaco-gesturesend",g.Contextmenu="-monaco-gesturecontextmenu"})(w=t.EventType||(t.EventType={}));class f extends H.Disposable{constructor(){super(),this.f=!1,this.g=new y.LinkedList,this.h=new y.LinkedList,this.k={},this.j=null,this.l=0,this.B(v.addDisposableListener(document,"touchstart",d=>this.n(d),{passive:!1})),this.B(v.addDisposableListener(document,"touchend",d=>this.p(d))),this.B(v.addDisposableListener(document,"touchmove",d=>this.v(d),{passive:!1}))}static addTarget(d){if(!f.isTouchDevice())return H.Disposable.None;f.b||(f.b=new f);const M=f.b.g.push(d);return(0,H.toDisposable)(M)}static ignoreTarget(d){if(!f.isTouchDevice())return H.Disposable.None;f.b||(f.b=new f);const M=f.b.h.push(d);return(0,H.toDisposable)(M)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(d){const M=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let o=0,n=d.targetTouches.length;o<n;o++){const e=d.targetTouches.item(o);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:M,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[M],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const s=this.r(w.Start,e.target);s.pageX=e.pageX,s.pageY=e.pageY,this.s(s)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}p(d){const M=Date.now(),o=Object.keys(this.k).length;for(let n=0,e=d.changedTouches.length;n<e;n++){const s=d.changedTouches.item(n);if(!this.k.hasOwnProperty(String(s.identifier))){console.warn("move of an UNKNOWN touch",s);continue}const l=this.k[s.identifier],a=Date.now()-l.initialTimeStamp;if(a<f.c&&Math.abs(l.initialPageX-i.tail(l.rollingPageX))<30&&Math.abs(l.initialPageY-i.tail(l.rollingPageY))<30){const c=this.r(w.Tap,l.initialTarget);c.pageX=i.tail(l.rollingPageX),c.pageY=i.tail(l.rollingPageY),this.s(c)}else if(a>=f.c&&Math.abs(l.initialPageX-i.tail(l.rollingPageX))<30&&Math.abs(l.initialPageY-i.tail(l.rollingPageY))<30){const c=this.r(w.Contextmenu,l.initialTarget);c.pageX=i.tail(l.rollingPageX),c.pageY=i.tail(l.rollingPageY),this.s(c)}else if(o===1){const c=i.tail(l.rollingPageX),r=i.tail(l.rollingPageY),h=i.tail(l.rollingTimestamps)-l.rollingTimestamps[0],b=c-l.rollingPageX[0],A=r-l.rollingPageY[0],L=[...this.g].filter(N=>l.initialTarget instanceof Node&&N.contains(l.initialTarget));this.u(L,M,Math.abs(b)/h,b>0?1:-1,c,Math.abs(A)/h,A>0?1:-1,r)}this.s(this.r(w.End,l.initialTarget)),delete this.k[s.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}r(d,M){const o=document.createEvent("CustomEvent");return o.initEvent(d,!1,!0),o.initialTarget=M,o.tapCount=0,o}s(d){if(d.type===w.Tap){const M=new Date().getTime();let o=0;M-this.l>f.m?o=1:o=2,this.l=M,d.tapCount=o}else(d.type===w.Change||d.type===w.Contextmenu)&&(this.l=0);if(d.initialTarget instanceof Node){for(const M of this.h)if(M.contains(d.initialTarget))return;for(const M of this.g)M.contains(d.initialTarget)&&(M.dispatchEvent(d),this.f=!0)}}u(d,M,o,n,e,s,l,a){this.j=v.scheduleAtNextAnimationFrame(()=>{const c=Date.now(),r=c-M;let h=0,b=0,A=!0;o+=f.a*r,s+=f.a*r,o>0&&(A=!1,h=n*o*r),s>0&&(A=!1,b=l*s*r);const L=this.r(w.Change);L.translationX=h,L.translationY=b,d.forEach(N=>N.dispatchEvent(L)),A||this.u(d,c,o,n,e+h,s,l,a+b)})}v(d){const M=Date.now();for(let o=0,n=d.changedTouches.length;o<n;o++){const e=d.changedTouches.item(o);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const s=this.k[e.identifier],l=this.r(w.Change,s.initialTarget);l.translationX=e.pageX-i.tail(s.rollingPageX),l.translationY=e.pageY-i.tail(s.rollingPageY),l.pageX=e.pageX,l.pageY=e.pageY,this.s(l),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),s.rollingTimestamps.shift()),s.rollingPageX.push(e.pageX),s.rollingPageY.push(e.pageY),s.rollingTimestamps.push(M)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}}f.a=-.005,f.c=700,f.m=400,qe([U.memoize],f,"isTouchDevice",null),t.Gesture=f}),define(me[54],be([1,0,4,5,83]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const U=2e4;let H,y,w,f,g;function d(e){H=document.createElement("div"),H.className="monaco-aria-container";const s=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),H.appendChild(a),a};y=s(),w=s();const l=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("role","complementary"),a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),H.appendChild(a),a};f=l(),g=l(),e.appendChild(H)}t.setARIAContainer=d;function M(e){!H||(y.textContent!==e?(v.clearNode(w),n(y,e)):(v.clearNode(y),n(w,e)))}t.alert=M;function o(e){!H||(i.isMacintosh?M(e):f.textContent!==e?(v.clearNode(g),n(f,e)):(v.clearNode(f),n(g,e)))}t.status=o;function n(e,s){v.clearNode(e),s.length>U&&(s=s.substr(0,U)),e.textContent=s,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[115],be([1,0,4,12]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const U=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function H(w){const f=new Array;let g,d=0,M=0;for(;(g=U.exec(w))!==null;){M=g.index||0,d<M&&f.push(w.substring(d,M)),d=(g.index||0)+g[0].length;const[,o,n]=g;f.push(o?`$(${n})`:y({id:n}))}return d<w.length&&f.push(w.substring(d)),f}t.renderLabelWithIcons=H;function y(w){const f=v.$("span");return f.classList.add(...i.CSSIcon.asClassNameArray(w)),f}t.renderIcon=y}),define(me[116],be([1,0,4]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(H){try{H.parentElement?.removeChild(H)}catch{}}class U{constructor(y){this.b=y,this.a=new Map}alloc(y){let w=this.d(y).pop();if(!w){const f=(0,v.$)(".monaco-list-row"),d=this.f(y).renderTemplate(f);w={domNode:f,templateId:y,templateData:d}}return w}release(y){!y||this.c(y)}c(y){const{domNode:w,templateId:f}=y;w&&(w.classList.remove("scrolling"),i(w)),this.d(f).push(y)}d(y){let w=this.a.get(y);return w||(w=[],this.a.set(y,w)),w}dispose(){this.a.forEach((y,w)=>{for(const f of y)this.f(w).disposeTemplate(f.templateData),f.templateData=null}),this.a.clear()}f(y){const w=this.b.get(y);if(!w)throw new Error(`No renderer found for ${y}`);return w}}t.RowCache=U}),define(me[117],be([1,0,8,2]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class U extends i.Disposable{constructor(y,w,f){super(),this.a=y,this.b=w,this.c=f,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new v.TimeoutTimer)}setVisibility(y){this.a!==y&&(this.a=y,this.m())}setShouldBeVisible(y){this.g=y,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const y=this.l();this.h!==y&&(this.h=y,this.ensureVisibility())}setIsNeeded(y){this.i!==y&&(this.i=y,this.ensureVisibility())}setDomNode(y){this.f=y,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(y){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(y?" fade":"")))}}t.ScrollbarVisibilityController=U}),define(me[118],be([1,0,4,22,14,3,2,5]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class f extends y.Disposable{constructor(d,M,o,n){super(),this.f=0,this.b=n||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.Emitter),this.h=o,this.i(),this.setOptions(d,M)}i(){this.B(i.Gesture.addTarget(this.a)),[i.EventType.Tap].forEach(d=>{this.B(v.addDisposableListener(this.a,d,M=>{this.a.focus()}))}),this.B(v.addStandardDisposableListener(this.a,"click",d=>{v.EventHelper.stop(d,!0)})),this.B(v.addStandardDisposableListener(this.a,"change",d=>{this.a.title=d.target.value,this.g.fire({index:d.target.selectedIndex,selected:d.target.value})})),this.B(v.addStandardDisposableListener(this.a,"keydown",d=>{let M=!1;w.isMacintosh?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(M=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(M=!0),M&&d.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(d,M){(!this.c||!U.equals(this.c,d))&&(this.c=d,this.a.options.length=0,this.c.forEach((o,n)=>{this.a.add(this.j(o.text,n,o.isDisabled))})),M!==void 0&&this.select(M)}select(d){this.c.length===0?this.f=0:d>=0&&d<this.c.length?this.f=d:d>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(d){this.b.ariaLabel=d,this.a.setAttribute("aria-label",d)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(d){this.a.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(d){this.h=d,this.applyStyles()}applyStyles(){if(this.a){const d=this.h.selectBackground?this.h.selectBackground.toString():"",M=this.h.selectForeground?this.h.selectForeground.toString():"",o=this.h.selectBorder?this.h.selectBorder.toString():"";this.a.style.backgroundColor=d,this.a.style.color=M,this.a.style.borderColor=o}}j(d,M,o){const n=document.createElement("option");return n.value=d,n.text=d,n.disabled=!!o,n}}t.SelectBoxNative=f}),define(me[55],be([1,0,23,14,8,112,3,25]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function f(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=f;function g(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=g;function d(o){return typeof o.collapsible=="boolean"}class M{constructor(n,e,s,l={}){this.o=n,this.p=e,this.rootRef=[],this.d=new y.EventBufferer,this.f=new y.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.Emitter,this.onDidSplice=this.l.event,this.m=new U.Delayer(U.MicrotaskDelay),this.h=typeof l.collapseByDefault>"u"?!1:l.collapseByDefault,this.j=l.filter,this.k=typeof l.autoExpandSingleChildren>"u"?!1:l.autoExpandSingleChildren,this.c={parent:void 0,element:s,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,s=w.Iterable.empty(),l={}){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");l.diffIdentityProvider?this.q(l.diffIdentityProvider,n,e,s,l):this.s(n,e,s,l)}q(n,e,s,l=w.Iterable.empty(),a,c=a.diffDepth??0){const{parentNode:r}=this.H(e);if(!r.lastDiffIds)return this.s(e,s,l,a);const h=[...l],b=e[e.length-1],A=new H.LcsDiff({getElements:()=>r.lastDiffIds},{getElements:()=>[...r.children.slice(0,b),...h,...r.children.slice(b+s)].map(C=>n.getId(C.element).toString())}).ComputeDiff(!1);if(A.quitEarly)return r.lastDiffIds=void 0,this.s(e,s,h,a);const L=e.slice(0,-1),N=(C,p,D)=>{if(c>0)for(let _=0;_<D;_++)C--,p--,this.q(n,[...L,C,0],Number.MAX_SAFE_INTEGER,h[p].children,a,c-1)};let F=Math.min(r.children.length,b+s),u=h.length;for(const C of A.changes.sort((p,D)=>D.originalStart-p.originalStart))N(F,u,F-(C.originalStart+C.originalLength)),F=C.originalStart,u=C.modifiedStart-b,this.s([...L,F],C.originalLength,w.Iterable.slice(h,u,u+C.modifiedLength),a);N(F,u,F)}s(n,e,s=w.Iterable.empty(),{onDidCreateNode:l,onDidDeleteNode:a,diffIdentityProvider:c}){const{parentNode:r,listIndex:h,revealed:b,visible:A}=this.H(n),L=[],N=w.Iterable.map(s,oe=>this.w(oe,r,r.visible?1:0,b,L,l)),F=n[n.length-1],u=r.children.length>0;let C=0;for(let oe=F;oe>=0&&oe<r.children.length;oe--){const ce=r.children[oe];if(ce.visible){C=ce.visibleChildIndex;break}}const p=[];let D=0,_=0;for(const oe of N)p.push(oe),_+=oe.renderNodeCount,oe.visible&&(oe.visibleChildIndex=C+D++);const V=(0,i.splice)(r.children,F,e,p);c?r.lastDiffIds?(0,i.splice)(r.lastDiffIds,F,e,p.map(oe=>c.getId(oe.element).toString())):r.lastDiffIds=r.children.map(oe=>c.getId(oe.element).toString()):r.lastDiffIds=void 0;let ee=0;for(const oe of V)oe.visible&&ee++;if(ee!==0)for(let oe=F+p.length;oe<r.children.length;oe++){const ce=r.children[oe];ce.visible&&(ce.visibleChildIndex-=ee)}if(r.visibleChildrenCount+=D-ee,b&&A){const oe=V.reduce((ce,ae)=>ce+(ae.visible?ae.renderNodeCount:0),0);this.C(r,_-oe),this.p.splice(h,oe,L)}if(V.length>0&&a){const oe=ce=>{a(ce),ce.children.forEach(oe)};V.forEach(oe)}this.l.fire({insertedNodes:p,deletedNodes:V});const Z=r.children.length>0;u!==Z&&this.setCollapsible(n.slice(0,-1),Z);let pe=r;for(;pe;){if(pe.visibility===2){this.m.trigger(()=>this.refilter());break}pe=pe.parent}}rerender(n){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{node:e,listIndex:s,revealed:l}=this.G(n);e.visible&&l&&this.p.splice(s,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{listIndex:s}=this.G(n);this.p.updateElementHeight(s,e)}has(n){return this.E(n)}getListIndex(n){const{listIndex:e,visible:s,revealed:l}=this.G(n);return s&&l?e:-1}getListRenderCount(n){return this.F(n).renderNodeCount}isCollapsible(n){return this.F(n).collapsible}setCollapsible(n,e){const s=this.F(n);typeof e>"u"&&(e=!s.collapsible);const l={collapsible:e};return this.d.bufferEvents(()=>this.t(n,l))}isCollapsed(n){return this.F(n).collapsed}setCollapsed(n,e,s){const l=this.F(n);typeof e>"u"&&(e=!l.collapsed);const a={collapsed:e,recursive:s||!1};return this.d.bufferEvents(()=>this.t(n,a))}t(n,e){const{node:s,listIndex:l,revealed:a}=this.G(n),c=this.u(s,l,a,e);if(s!==this.c&&this.k&&c&&!d(e)&&s.collapsible&&!s.collapsed&&!e.recursive){let r=-1;for(let h=0;h<s.children.length;h++)if(s.children[h].visible)if(r>-1){r=-1;break}else r=h;r>-1&&this.t([...n,r],e)}return c}u(n,e,s,l){const a=this.v(n,l,!1);if(!s||!n.visible||!a)return a;const c=n.renderNodeCount,r=this.x(n),h=c-(e===-1?0:1);return this.p.splice(e+1,h,r.slice(1)),a}v(n,e,s){let l;if(n===this.c?l=!1:(d(e)?(l=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(l=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):l=!1,l&&this.f.fire({node:n,deep:s})),!d(e)&&e.recursive)for(const a of n.children)l=this.v(a,e,!0)||l;return l}expandTo(n){this.d.bufferEvents(()=>{let e=this.F(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this.t(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.c.renderNodeCount,e=this.A(this.c);this.p.splice(0,n,e),this.m.cancel()}w(n,e,s,l,a,c){const r={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.h:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},h=this.D(r,s);r.visibility=h,l&&a.push(r);const b=n.children||w.Iterable.empty(),A=l&&h!==0&&!r.collapsed;let L=0,N=1;for(const F of b){const u=this.w(F,r,h,A,a,c);r.children.push(u),N+=u.renderNodeCount,u.visible&&(u.visibleChildIndex=L++)}return r.collapsible=r.collapsible||r.children.length>0,r.visibleChildrenCount=L,r.visible=h===2?L>0:h===1,r.visible?r.collapsed||(r.renderNodeCount=N):(r.renderNodeCount=0,l&&a.pop()),c?.(r),r}x(n){const e=n.renderNodeCount,s=[];return this.y(n,s),this.C(n.parent,s.length-e),s}y(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const s of n.children)n.renderNodeCount+=this.y(s,e);return this.g.fire(n),n.renderNodeCount}A(n){const e=n.renderNodeCount,s=[];return this.B(n,n.visible?1:0,s),this.C(n.parent,s.length-e),s}B(n,e,s,l=!0){let a;if(n!==this.c){if(a=this.D(n,e),a===0)return n.visible=!1,n.renderNodeCount=0,!1;l&&s.push(n)}const c=s.length;n.renderNodeCount=n===this.c?0:1;let r=!1;if(!n.collapsed||a!==0){let h=0;for(const b of n.children)r=this.B(b,a,s,l&&!n.collapsed)||r,b.visible&&(b.visibleChildIndex=h++);n.visibleChildrenCount=h}else n.visibleChildrenCount=0;return n!==this.c&&(n.visible=a===2?r:a===1,n.visibility=a),n.visible?n.collapsed||(n.renderNodeCount+=s.length-c):(n.renderNodeCount=0,l&&s.pop()),this.g.fire(n),n.visible}C(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this.g.fire(n),n=n.parent}D(n,e){const s=this.j?this.j.filter(n.element,e):1;return typeof s=="boolean"?(n.filterData=void 0,s?1:0):f(s)?(n.filterData=s.data,g(s.visibility)):(n.filterData=void 0,g(s))}E(n,e=this.c){if(!n||n.length===0)return!0;const[s,...l]=n;return s<0||s>e.children.length?!1:this.E(l,e.children[s])}F(n,e=this.c){if(!n||n.length===0)return e;const[s,...l]=n;if(s<0||s>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");return this.F(l,e.children[s])}G(n){if(n.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:s,revealed:l,visible:a}=this.H(n),c=n[n.length-1];if(c<0||c>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");const r=e.children[c];return{node:r,listIndex:s,revealed:l,visible:a&&r.visible}}H(n,e=this.c,s=0,l=!0,a=!0){const[c,...r]=n;if(c<0||c>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");for(let h=0;h<c;h++)s+=e.children[h].renderNodeCount;return l=l&&!e.collapsed,a=a&&e.visible,r.length===0?{parentNode:e,listIndex:s,revealed:l,visible:a}:this.H(r,e.children[c],s+1,l,a)}getNode(n=[]){return this.F(n)}getNodeLocation(n){const e=[];let s=n;for(;s.parent;)e.push(s.parent.children.indexOf(s)),s=s.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.F(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.F(n);if(e.children.length!==0)return this.I(e)}I(n){return n.children.length===0?n.element:this.I(n.children[n.children.length-1])}}t.IndexTreeModel=M}),define(me[119],be([1,0,55,23,25]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class H{get size(){return this.d.size}constructor(w,f,g={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.IndexTreeModel(w,f,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare(d,M){return g.sorter.compare(d.element,M.element)}}),this.h=g.identityProvider}setChildren(w,f=U.Iterable.empty(),g={}){const d=this.o(w);this.l(d,this.m(f),g)}l(w,f=U.Iterable.empty(),g){const d=new Set,M=new Set,o=e=>{if(e.element===null)return;const s=e;if(d.add(s.element),this.d.set(s.element,s),this.h){const l=this.h.getId(s.element).toString();M.add(l),this.f.set(l,s)}g.onDidCreateNode?.(s)},n=e=>{if(e.element===null)return;const s=e;if(d.has(s.element)||this.d.delete(s.element),this.h){const l=this.h.getId(s.element).toString();M.has(l)||this.f.delete(l)}g.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,f,{...g,onDidCreateNode:o,onDidDeleteNode:n})}m(w=U.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),U.Iterable.map(w,f=>{let g=this.d.get(f.element);if(!g&&this.h){const o=this.h.getId(f.element).toString();g=this.f.get(o)}if(!g)return{...f,children:this.m(f.children)};const d=typeof f.collapsible=="boolean"?f.collapsible:g.collapsible,M=typeof f.collapsed<"u"?f.collapsed:g.collapsed;return{...f,collapsible:d,collapsed:M,children:this.m(f.children)}})}rerender(w){const f=this.o(w);this.c.rerender(f)}updateElementHeight(w,f){const g=this.o(w);this.c.updateElementHeight(g,f)}resort(w=null,f=!0){if(!this.j)return;const g=this.o(w),d=this.c.getNode(g);this.l(g,this.n(d,f),{})}n(w,f,g=!0){let d=[...w.children];return(f||g)&&(d=d.sort(this.j.compare.bind(this.j))),U.Iterable.map(d,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,f,!1)}))}getFirstElementChild(w=null){const f=this.o(w);return this.c.getFirstElementChild(f)}getLastElementAncestor(w=null){const f=this.o(w);return this.c.getLastElementAncestor(f)}has(w){return this.d.has(w)}getListIndex(w){const f=this.o(w);return this.c.getListIndex(f)}getListRenderCount(w){const f=this.o(w);return this.c.getListRenderCount(f)}isCollapsible(w){const f=this.o(w);return this.c.isCollapsible(f)}setCollapsible(w,f){const g=this.o(w);return this.c.setCollapsible(g,f)}isCollapsed(w){const f=this.o(w);return this.c.isCollapsed(f)}setCollapsed(w,f,g){const d=this.o(w);return this.c.setCollapsed(d,f,g)}expandTo(w){const f=this.o(w);this.c.expandTo(f)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const f=this.d.get(w);if(!f)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return f}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.k,"Invalid getParentNodeLocation call");const f=this.d.get(w);if(!f)throw new i.TreeError(this.k,`Tree element not found: ${w}`);const g=this.c.getNodeLocation(f),d=this.c.getParentNodeLocation(g);return this.c.getNode(d).element}o(w){if(w===null)return[];const f=this.d.get(w);if(!f)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(f)}}t.ObjectTreeModel=H}),define(me[17],be([1,0,4,19,20,22,2]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends y.Disposable{f(g,d){this.B(v.addDisposableListener(g,v.EventType.CLICK,M=>d(new U.StandardMouseEvent(M))))}j(g,d){this.B(v.addDisposableListener(g,v.EventType.MOUSE_DOWN,M=>d(new U.StandardMouseEvent(M))))}k(g,d){this.B(v.addDisposableListener(g,v.EventType.MOUSE_OVER,M=>d(new U.StandardMouseEvent(M))))}m(g,d){this.B(v.addDisposableListener(g,v.EventType.MOUSE_LEAVE,M=>d(new U.StandardMouseEvent(M))))}p(g,d){this.B(v.addDisposableListener(g,v.EventType.KEY_DOWN,M=>d(new i.StandardKeyboardEvent(M))))}u(g,d){this.B(v.addDisposableListener(g,v.EventType.KEY_UP,M=>d(new i.StandardKeyboardEvent(M))))}C(g,d){this.B(v.addDisposableListener(g,v.EventType.INPUT,d))}D(g,d){this.B(v.addDisposableListener(g,v.EventType.BLUR,d))}F(g,d){this.B(v.addDisposableListener(g,v.EventType.FOCUS,d))}G(g,d){this.B(v.addDisposableListener(g,v.EventType.CHANGE,d))}H(g){return H.Gesture.ignoreTarget(g)}}t.Widget=w}),define(me[36],be([1,0,53,17,8,4]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...f.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new v.GlobalPointerMoveMonitor),this.B(H.addStandardDisposableListener(this.bgDomNode,H.EventType.POINTER_DOWN,g=>this.h(g))),this.B(H.addStandardDisposableListener(this.domNode,H.EventType.POINTER_DOWN,g=>this.h(g))),this.b=this.B(new U.IntervalTimer),this.c=this.B(new U.TimeoutTimer)}h(f){if(!f.target||!(f.target instanceof Element))return;const g=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(g,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,d=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.ScrollbarArrow=y}),define(me[56],be([1,0,4,39,53,36,117,17,5]),function(X,t,v,i,U,H,y,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const g=140;class d extends w.Widget{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.i=this.B(new y.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new U.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.addDisposableListener(this.domNode.domNode,v.EventType.POINTER_DOWN,n=>this.y(n)))}r(o){const n=this.B(new H.ScrollbarArrow(o));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}s(o,n,e,s){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.addDisposableListener(this.slider.domNode,v.EventType.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.J(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}t(o){return this.h.setVisibleSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(o){return this.h.setScrollSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(o){return this.h.setScrollPosition(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.M(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.N(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(o){o.target===this.domNode.domNode&&this.I(o)}delegatePointerDown(o){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this.h.getSliderPosition(),s=n+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.P(o);e<=l&&l<=s?o.button===0&&(o.preventDefault(),this.J(o)):this.I(o)}I(o){let n,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")n=o.offsetX,e=o.offsetY;else{const l=v.getDomNodePagePosition(this.domNode.domNode);n=o.pageX-l.left,e=o.pageY-l.top}const s=this.O(n,e);this.L(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),o.button===0&&(o.preventDefault(),this.J(o))}J(o){if(!o.target||!(o.target instanceof Element))return;const n=this.P(o),e=this.Q(o),s=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(o.target,o.pointerId,o.buttons,l=>{const a=this.Q(l),c=Math.abs(a-e);if(f.isWindows&&c>g){this.L(s.getScrollPosition());return}const h=this.P(l)-n;this.L(s.getDesiredScrollPositionFromDelta(h))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}L(o){const n={};this.writeScrollPosition(n,o),this.b.setScrollPositionNow(n)}updateScrollbarSize(o){this.R(o),this.h.setScrollbarSize(o),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=d}),define(me[120],be([1,0,20,56,36,40,12]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(g,d,M){const o=g.getScrollDimensions(),n=g.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:M,scrollbarState:new H.ScrollbarState(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,o.width,o.scrollWidth,n.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-U.ARROW_IMG_SIZE)/2,s=(d.horizontalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}N(g,d){this.slider.setWidth(g),this.slider.setLeft(d)}M(g,d){this.domNode.setWidth(g),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.n=this.v(g.scrollWidth)||this.n,this.n=this.w(g.scrollLeft)||this.n,this.n=this.t(g.width)||this.n,this.n}O(g,d){return g}P(g){return g.pageX}Q(g){return g.pageY}R(g){this.slider.setHeight(g)}writeScrollPosition(g,d){g.scrollLeft=d}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.i.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.HorizontalScrollbar=w}),define(me[121],be([1,0,20,56,36,40,12]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(g,d,M){const o=g.getScrollDimensions(),n=g.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:M,scrollbarState:new H.ScrollbarState(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,o.height,o.scrollHeight,n.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-U.ARROW_IMG_SIZE)/2,s=(d.verticalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}N(g,d){this.slider.setHeight(g),this.slider.setTop(d)}M(g,d){this.domNode.setWidth(d),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.n=this.v(g.scrollHeight)||this.n,this.n=this.w(g.scrollTop)||this.n,this.n=this.t(g.height)||this.n,this.n}O(g,d){return d}P(g){return g.pageY}Q(g){return g.pageX}R(g){this.slider.setWidth(g)}writeScrollPosition(g,d){g.scrollTop=d}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(g.vertical),this.c=g.scrollByPage}}t.VerticalScrollbar=w}),define(me[57],be([1,0,16,4,39,20,120,121,17,8,3,2,5,49,90]),function(X,t,v,i,U,H,y,w,f,g,d,M,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,l=!0;class a{constructor(F,u,C){this.timestamp=F,this.deltaX=u,this.deltaY=C,this.score=0}}class c{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let F=1,u=0,C=1,p=this.d;do{const D=p===this.c?F:Math.pow(2,-C);if(F-=D,u+=this.b[p].score*D,p===this.c)break;p=(this.a+p-1)%this.a,C++}while(!0);return u<=.5}accept(F,u,C){const p=new a(F,u,C);p.score=this.f(p),this.c===-1&&this.d===-1?(this.b[0]=p,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=p)}f(F){if(Math.abs(F.deltaX)>0&&Math.abs(F.deltaY)>0)return 1;let u=.5;const C=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(F.deltaX)||!this.g(F.deltaY))&&(u+=.25),Math.min(Math.max(u,0),1)}g(F){return Math.abs(Math.round(F)-F)<.01}}t.MouseWheelClassifier=c,c.INSTANCE=new c;class r extends f.Widget{get options(){return this.a}constructor(F,u,C){super(),this.J=this.B(new d.Emitter),this.onScroll=this.J.event,this.L=this.B(new d.Emitter),this.onWillScroll=this.L.event,F.style.overflow="hidden",this.a=L(u),this.b=C,this.B(this.b.onScroll(D=>{this.L.fire(D),this.O(D),this.J.fire(D)}));const p={onMouseWheel:D=>this.N(D),onDragStart:()=>this.Q(),onDragEnd:()=>this.R()};this.c=this.B(new w.VerticalScrollbar(this.b,this.a,p)),this.g=this.B(new y.HorizontalScrollbar(this.b,this.a,p)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(F),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,U.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,U.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,U.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.M(this.a.handleMouseWheel),this.k(this.r,D=>this.U(D)),this.m(this.r,D=>this.S(D)),this.w=this.B(new g.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.I=!0}dispose(){this.s=(0,M.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(F){this.c.delegatePointerDown(F)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(F){this.b.setScrollDimensions(F,!1)}updateClassName(F){this.a.className=F,o.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(F){typeof F.handleMouseWheel<"u"&&(this.a.handleMouseWheel=F.handleMouseWheel,this.M(this.a.handleMouseWheel)),typeof F.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=F.mouseWheelScrollSensitivity),typeof F.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=F.fastScrollSensitivity),typeof F.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=F.scrollPredominantAxis),typeof F.horizontal<"u"&&(this.a.horizontal=F.horizontal),typeof F.vertical<"u"&&(this.a.vertical=F.vertical),typeof F.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=F.horizontalScrollbarSize),typeof F.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=F.verticalScrollbarSize),typeof F.scrollByPage<"u"&&(this.a.scrollByPage=F.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.P()}setRevealOnScroll(F){this.I=F}delegateScrollFromMouseWheelEvent(F){this.N(new H.StandardWheelEvent(F))}M(F){if(this.s.length>0!==F&&(this.s=(0,M.dispose)(this.s),F)){const C=p=>{this.N(new H.StandardWheelEvent(p))};this.s.push(i.addDisposableListener(this.r,i.EventType.MOUSE_WHEEL,C,{passive:!1}))}}N(F){const u=c.INSTANCE;if(l){const D=window.devicePixelRatio/(0,v.getZoomFactor)();o.isWindows||o.isLinux?u.accept(Date.now(),F.deltaX/D,F.deltaY/D):u.accept(Date.now(),F.deltaX,F.deltaY)}let C=!1;if(F.deltaY||F.deltaX){let D=F.deltaY*this.a.mouseWheelScrollSensitivity,_=F.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(D)>=Math.abs(_)?_=0:D=0),this.a.flipAxes&&([D,_]=[_,D]);const V=!o.isMacintosh&&F.browserEvent&&F.browserEvent.shiftKey;(this.a.scrollYToX||V)&&!_&&(_=D,D=0),F.browserEvent&&F.browserEvent.altKey&&(_=_*this.a.fastScrollSensitivity,D=D*this.a.fastScrollSensitivity);const ee=this.b.getFutureScrollPosition();let Z={};if(D){const pe=s*D,oe=ee.scrollTop-(pe<0?Math.floor(pe):Math.ceil(pe));this.c.writeScrollPosition(Z,oe)}if(_){const pe=s*_,oe=ee.scrollLeft-(pe<0?Math.floor(pe):Math.ceil(pe));this.g.writeScrollPosition(Z,oe)}Z=this.b.validateScrollPosition(Z),(ee.scrollLeft!==Z.scrollLeft||ee.scrollTop!==Z.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&u.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Z):this.b.setScrollPositionNow(Z),C=!0)}let p=C;!p&&this.a.alwaysConsumeMouseWheel&&(p=!0),!p&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(p=!0),p&&(F.preventDefault(),F.stopPropagation())}O(F){this.y=this.g.onDidScroll(F)||this.y,this.y=this.c.onDidScroll(F)||this.y,this.a.useShadows&&(this.y=!0),this.I&&this.W(),this.a.lazyRender||this.P()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.P()}P(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const F=this.b.getCurrentScrollPosition(),u=F.scrollTop>0,C=F.scrollLeft>0,p=C?" left":"",D=u?" top":"",_=C||u?" top-left-corner":"";this.i.setClassName(`shadow${p}`),this.l.setClassName(`shadow${D}`),this.n.setClassName(`shadow${_}${D}${p}`)}}Q(){this.t=!0,this.W()}R(){this.t=!1,this.X()}S(F){this.v=!1,this.X()}U(F){this.v=!0,this.W()}W(){this.c.beginReveal(),this.g.beginReveal(),this.Y()}X(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}Y(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.X(),e)}}t.AbstractScrollableElement=r;class h extends r{constructor(F,u){u=u||{},u.mouseWheelSmoothScroll=!1;const C=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(F,u,C),this.B(C)}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=h;class b extends r{constructor(F,u,C){super(F,u,C)}setScrollPosition(F){F.reuseAnimation?this.b.setScrollPositionSmooth(F,F.reuseAnimation):this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=b;class A extends r{constructor(F,u){u=u||{},u.mouseWheelSmoothScroll=!1;const C=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(F,u,C),this.B(C),this.ab=F,this.onScroll(p=>{p.scrollTopChanged&&(this.ab.scrollTop=p.scrollTop),p.scrollLeftChanged&&(this.ab.scrollLeft=p.scrollLeft)}),this.scanDomNode()}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.ab.clientWidth,scrollWidth:this.ab.scrollWidth,height:this.ab.clientHeight,scrollHeight:this.ab.scrollHeight}),this.setScrollPosition({scrollLeft:this.ab.scrollLeft,scrollTop:this.ab.scrollTop})}}t.DomScrollableElement=A;function L(N){const F={lazyRender:typeof N.lazyRender<"u"?N.lazyRender:!1,className:typeof N.className<"u"?N.className:"",useShadows:typeof N.useShadows<"u"?N.useShadows:!0,handleMouseWheel:typeof N.handleMouseWheel<"u"?N.handleMouseWheel:!0,flipAxes:typeof N.flipAxes<"u"?N.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof N.consumeMouseWheelIfScrollbarIsNeeded<"u"?N.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof N.alwaysConsumeMouseWheel<"u"?N.alwaysConsumeMouseWheel:!1,scrollYToX:typeof N.scrollYToX<"u"?N.scrollYToX:!1,mouseWheelScrollSensitivity:typeof N.mouseWheelScrollSensitivity<"u"?N.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof N.fastScrollSensitivity<"u"?N.fastScrollSensitivity:5,scrollPredominantAxis:typeof N.scrollPredominantAxis<"u"?N.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof N.mouseWheelSmoothScroll<"u"?N.mouseWheelSmoothScroll:!0,arrowSize:typeof N.arrowSize<"u"?N.arrowSize:11,listenOnDomNode:typeof N.listenOnDomNode<"u"?N.listenOnDomNode:null,horizontal:typeof N.horizontal<"u"?N.horizontal:1,horizontalScrollbarSize:typeof N.horizontalScrollbarSize<"u"?N.horizontalScrollbarSize:10,horizontalSliderSize:typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:0,horizontalHasArrows:typeof N.horizontalHasArrows<"u"?N.horizontalHasArrows:!1,vertical:typeof N.vertical<"u"?N.vertical:1,verticalScrollbarSize:typeof N.verticalScrollbarSize<"u"?N.verticalScrollbarSize:10,verticalHasArrows:typeof N.verticalHasArrows<"u"?N.verticalHasArrows:!1,verticalSliderSize:typeof N.verticalSliderSize<"u"?N.verticalSliderSize:0,scrollByPage:typeof N.scrollByPage<"u"?N.scrollByPage:!1};return F.horizontalSliderSize=typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:F.horizontalScrollbarSize,F.verticalSliderSize=typeof N.verticalSliderSize<"u"?N.verticalSliderSize:F.verticalScrollbarSize,o.isMacintosh&&(F.className+=" mac"),F}}),define(me[58],be([1,0,51,4,18,22,57,14,8,24,3,2,47,49,79,116,9]),function(X,t,v,i,U,H,y,w,f,g,d,M,o,n,e,s,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const a={CurrentDragAndDropData:void 0},c={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(F){return[F]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(u){this.d=u}constructor(u){this.elements=u}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=r;class h{constructor(u){this.elements=u}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=h;class b{constructor(){this.types=[],this.files=[]}update(u){if(u.types&&this.types.splice(0,this.types.length,...u.types),u.files){this.files.splice(0,this.files.length);for(let C=0;C<u.files.length;C++){const p=u.files.item(C);p&&(p.size||p.type)&&this.files.push(p)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=b;function A(F,u){return Array.isArray(F)&&Array.isArray(u)?(0,w.equals)(F,u):F===u}class L{constructor(u){u?.getSetSize?this.getSetSize=u.getSetSize.bind(u):this.getSetSize=(C,p,D)=>D,u?.getPosInSet?this.getPosInSet=u.getPosInSet.bind(u):this.getPosInSet=(C,p)=>p+1,u?.getRole?this.getRole=u.getRole.bind(u):this.getRole=C=>"listitem",u?.isChecked?this.isChecked=u.isChecked.bind(u):this.isChecked=C=>{}}}class N{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(u){if(u!==this.O){if(u&&this.C)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=u,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const C of this.d)this.Y(C);this.V(),this.q.setScrollDimensions({width:(0,i.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.F||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(u,C,p,D=c){if(this.Q=C,this.domId=`list_id_${++N.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new f.Delayer(50),this.v=!1,this.x=M.Disposable.None,this.y=0,this.H=!1,this.K=M.Disposable.None,this.L=M.Disposable.None,this.M=new M.DisposableStore,this.N=new d.Emitter,this.onDidChangeContentHeight=d.Event.latch(this.N.event,void 0,this.M),this.O=!1,D.horizontalScrolling&&D.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const V of p)this.j.set(V.templateId,V);this.h=this.M.add(new s.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof D.mouseSupport=="boolean"?D.mouseSupport:!0),this.O=D.horizontalScrolling??c.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.D=typeof D.additionalScrollHeight>"u"?0:D.additionalScrollHeight,this.E=new L(D.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(D.transformOptimization??c.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.Gesture.addTarget(this.o)),this.p=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:D.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,i.scheduleAtNextAnimationFrame)(V)}),this.q=this.M.add(new y.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:D.alwaysConsumeMouseWheel??c.alwaysConsumeMouseWheel,horizontal:1,vertical:D.verticalScrollMode??c.verticalScrollMode,useShadows:D.useShadows??c.useShadows,mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity,fastScrollSensitivity:D.fastScrollSensitivity},this.p)),this.domNode.appendChild(this.q.getDomNode()),u.appendChild(this.domNode),this.q.onScroll(this.hb,this,this.M),this.M.add((0,i.addDisposableListener)(this.o,H.EventType.Change,V=>this.ib(V))),this.M.add((0,i.addDisposableListener)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.M.add((0,i.addDisposableListener)(this.domNode,"dragover",V=>this.kb(this.gb(V)))),this.M.add((0,i.addDisposableListener)(this.domNode,"drop",V=>this.mb(this.gb(V)))),this.M.add((0,i.addDisposableListener)(this.domNode,"dragleave",V=>this.lb(this.gb(V)))),this.M.add((0,i.addDisposableListener)(this.domNode,"dragend",V=>this.nb(V))),this.A=D.setRowLineHeight??c.setRowLineHeight,this.B=D.setRowHeight??c.setRowHeight,this.C=D.supportDynamicHeights??c.supportDynamicHeights,this.G=D.dnd??c.dnd,this.layout(D.initialSize?.height,D.initialSize?.width)}updateOptions(u){u.additionalScrollHeight!==void 0&&(this.D=u.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),u.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(u.smoothScrolling?125:0),u.horizontalScrolling!==void 0&&(this.P=u.horizontalScrolling),u.mouseWheelScrollSensitivity!==void 0&&this.q.updateOptions({mouseWheelScrollSensitivity:u.mouseWheelScrollSensitivity}),u.fastScrollSensitivity!==void 0&&this.q.updateOptions({fastScrollSensitivity:u.fastScrollSensitivity})}delegateScrollFromMouseWheelEvent(u){this.q.delegateScrollFromMouseWheelEvent(u)}delegateVerticalScrollbarPointerDown(u){this.q.delegateVerticalScrollbarPointerDown(u)}updateElementHeight(u,C,p){if(u<0||u>=this.d.length)return;const D=this.d[u].size;if(typeof C>"u"){if(!this.C){console.warn("Dynamic heights not supported");return}this.d[u].lastDynamicHeightWidth=void 0,C=D+this.vb(u)}if(D===C)return;const _=this.tb(this.k,this.m);let V=0;u<_.start||p!==null&&p>u&&p<=_.end?V=C-D:V=0,this.g.splice(u,1,[{size:C}]),this.d[u].size=C,this.W(_,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.C&&this.ub(this.k,this.m)}splice(u,C,p=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(u,C,p)}finally{this.v=!1,this.N.fire(this.contentHeight)}}R(u,C,p=[]){const D=this.tb(this.k,this.m),_={start:u,end:u+C},V=o.Range.intersect(D,_),ee=new Map;for(let te=V.end-1;te>=V.start;te--){const T=this.d[te];if(T.dragStartDisposable.dispose(),T.checkedDisposable.dispose(),T.row){let E=ee.get(T.templateId);E||(E=[],ee.set(T.templateId,E));const m=this.j.get(T.templateId);m&&m.disposeElement&&m.disposeElement(T.element,te,T.row.templateData,T.size),E.push(T.row)}T.row=null}const Z={start:u+C,end:this.d.length},pe=o.Range.intersect(Z,D),oe=o.Range.relativeComplement(Z,D),ce=p.map(te=>({id:String(this.f++),element:te,templateId:this.Q.getTemplateId(te),size:this.Q.getHeight(te),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(te),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.Disposable.None,checkedDisposable:M.Disposable.None}));let ae;u===0&&C>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,ce),ae=this.d,this.d=ce):(this.g.splice(u,C,ce),ae=this.d.splice(u,C,...ce));const de=p.length-C,Se=this.tb(this.k,this.m),x=(0,e.shift)(pe,de),ye=o.Range.intersect(Se,x);for(let te=ye.start;te<ye.end;te++)this.ab(this.d[te],te);const ie=o.Range.relativeComplement(x,Se);for(const te of ie)for(let T=te.start;T<te.end;T++)this.bb(T);const J=oe.map(te=>(0,e.shift)(te,de)),fe=[{start:u,end:u+p.length},...J].map(te=>o.Range.intersect(Se,te)),le=this.wb(fe);for(const te of fe)for(let T=te.start;T<te.end;T++){const E=this.d[T],B=ee.get(E.templateId)?.pop();this.X(T,le,B)}for(const te of ee.values())for(const T of te)this.h.release(T);return this.S(),this.C&&this.ub(this.scrollTop,this.renderHeight),ae.map(te=>te.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,i.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let u=0;for(const C of this.d)typeof C.width<"u"&&(u=Math.max(u,C.width));this.F=u,this.q.setScrollDimensions({scrollWidth:u===0?0:u+10})}updateWidth(u){if(!this.P||typeof this.F>"u")return;const C=this.d[u];this.Y(C),typeof C.width<"u"&&C.width>this.F&&(this.F=C.width,this.q.setScrollDimensions({scrollWidth:this.F+10}))}rerender(){if(!!this.C){for(const u of this.d)u.lastDynamicHeightWidth=void 0;this.ub(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const u=this.tb(this.k,this.m),C=this.g.positionAt(u.start),p=this.g.positionAt(u.start+1);return p!==-1&&(p-C)/2+C<this.scrollTop?u.start+1:u.start}get lastVisibleIndex(){return this.tb(this.k,this.m).end-1}element(u){return this.d[u].element}indexOf(u){return this.d.findIndex(C=>C.element===u)}domElement(u){const C=this.d[u].row;return C&&C.domNode}elementHeight(u){return this.d[u].size}elementTop(u){return this.g.positionAt(u)}indexAt(u){return this.g.indexAt(u)}indexAfter(u){return this.g.indexAfter(u)}layout(u,C){const p={height:typeof u=="number"?u:(0,i.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,p.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(p),typeof C<"u"&&(this.n=C,this.C&&this.ub(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof C=="number"?C:(0,i.getContentWidth)(this.domNode)})}W(u,C,p,D,_,V=!1){const ee=this.tb(C,p),Z=o.Range.relativeComplement(ee,u),pe=o.Range.relativeComplement(u,ee),oe=this.wb(Z);if(V){const ce=o.Range.intersect(u,ee);for(let ae=ce.start;ae<ce.end;ae++)this.ab(this.d[ae],ae)}for(const ce of Z)for(let ae=ce.start;ae<ce.end;ae++)this.X(ae,oe);for(const ce of pe)for(let ae=ce.start;ae<ce.end;ae++)this.bb(ae);D!==void 0&&(this.o.style.left=`-${D}px`),this.o.style.top=`-${C}px`,this.P&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=C,this.m=p}X(u,C,p){const D=this.d[u];D.row||(D.row=p??this.h.alloc(D.templateId));const _=this.E.getRole(D.element)||"listitem";D.row.domNode.setAttribute("role",_);const V=this.E.isChecked(D.element);if(typeof V=="boolean")D.row.domNode.setAttribute("aria-checked",String(!!V));else if(V){const pe=oe=>D.row.domNode.setAttribute("aria-checked",String(!!oe));pe(V.value),D.checkedDisposable=V.onDidChange(pe)}D.row.domNode.parentElement||(C?this.o.insertBefore(D.row.domNode,C):this.o.appendChild(D.row.domNode)),this.ab(D,u);const ee=this.j.get(D.templateId);if(!ee)throw new Error(`No renderer found for template id ${D.templateId}`);ee?.renderElement(D.element,u,D.row.templateData,D.size);const Z=this.G.getDragURI(D.element);D.dragStartDisposable.dispose(),D.row.domNode.draggable=!!Z,Z&&(D.dragStartDisposable=(0,i.addDisposableListener)(D.row.domNode,"dragstart",pe=>this.jb(D.element,Z,pe))),this.P&&(this.Y(D),this.U())}Y(u){if(!u.row||!u.row.domNode)return;u.row.domNode.style.width="fit-content",u.width=(0,i.getContentWidth)(u.row.domNode);const C=window.getComputedStyle(u.row.domNode);C.paddingLeft&&(u.width+=parseFloat(C.paddingLeft)),C.paddingRight&&(u.width+=parseFloat(C.paddingRight)),u.row.domNode.style.width=""}ab(u,C){u.row.domNode.style.top=`${this.elementTop(C)}px`,this.B&&(u.row.domNode.style.height=`${u.size}px`),this.A&&(u.row.domNode.style.lineHeight=`${u.size}px`),u.row.domNode.setAttribute("data-index",`${C}`),u.row.domNode.setAttribute("data-last-element",C===this.length-1?"true":"false"),u.row.domNode.setAttribute("data-parity",C%2===0?"even":"odd"),u.row.domNode.setAttribute("aria-setsize",String(this.E.getSetSize(u.element,C,this.length))),u.row.domNode.setAttribute("aria-posinset",String(this.E.getPosInSet(u.element,C))),u.row.domNode.setAttribute("id",this.getElementDomId(C)),u.row.domNode.classList.toggle("drop-target",u.dropTarget)}bb(u){const C=this.d[u];if(C.dragStartDisposable.dispose(),C.checkedDisposable.dispose(),C.row){const p=this.j.get(C.templateId);p&&p.disposeElement&&p.disposeElement(C.element,u,C.row.templateData,C.size),this.h.release(C.row),C.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(u,C){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:u,reuseAnimation:C})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(u){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.F})),this.q.setScrollPosition({scrollLeft:u})}get scrollTop(){return this.getScrollTop()}set scrollTop(u){this.setScrollTop(u)}get scrollHeight(){return this.s+(this.P?10:0)+this.D}get onMouseClick(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"click")).event,u=>this.db(u),this.M)}get onMouseDblClick(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"dblclick")).event,u=>this.db(u),this.M)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"auxclick")).event,u=>this.db(u),this.M),u=>u.browserEvent.button===1,this.M)}get onMouseUp(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mouseup")).event,u=>this.db(u),this.M)}get onMouseDown(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mousedown")).event,u=>this.db(u),this.M)}get onMouseOver(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mouseover")).event,u=>this.db(u),this.M)}get onMouseMove(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mousemove")).event,u=>this.db(u),this.M)}get onMouseOut(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"mouseout")).event,u=>this.db(u),this.M)}get onContextMenu(){return d.Event.any(d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"contextmenu")).event,u=>this.db(u),this.M),d.Event.map(this.M.add(new U.DomEmitter(this.domNode,H.EventType.Contextmenu)).event,u=>this.fb(u),this.M))}get onTouchStart(){return d.Event.map(this.M.add(new U.DomEmitter(this.domNode,"touchstart")).event,u=>this.eb(u),this.M)}get onTap(){return d.Event.map(this.M.add(new U.DomEmitter(this.o,H.EventType.Tap)).event,u=>this.fb(u),this.M)}db(u){const C=this.sb(u.target||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:u,index:C,element:D}}eb(u){const C=this.sb(u.target||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:u,index:C,element:D}}fb(u){const C=this.sb(u.initialTarget||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:u,index:C,element:D}}gb(u){const C=this.sb(u.target||null),p=typeof C>"u"?void 0:this.d[C],D=p&&p.element;return{browserEvent:u,index:C,element:D}}hb(u){try{const C=this.tb(this.k,this.m);this.W(C,u.scrollTop,u.height,u.scrollLeft,u.scrollWidth),this.C&&this.ub(u.scrollTop,u.height,u.inSmoothScrolling)}catch(C){throw console.error("Got bad scroll event:",u),C}}ib(u){u.preventDefault(),u.stopPropagation(),this.scrollTop-=u.translationY}jb(u,C,p){if(!p.dataTransfer)return;const D=this.G.getDragElements(u);if(p.dataTransfer.effectAllowed="copyMove",p.dataTransfer.setData(v.DataTransfers.TEXT,C),p.dataTransfer.setDragImage){let _;this.G.getDragLabel&&(_=this.G.getDragLabel(D,p)),typeof _>"u"&&(_=String(D.length));const V=(0,i.$)(".monaco-drag-image");V.textContent=_,document.body.appendChild(V),p.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.domNode.classList.add("dragging"),this.I=new r(D),a.CurrentDragAndDropData=new h(D),this.G.onDragStart?.(this.I,p)}kb(u){if(u.browserEvent.preventDefault(),this.L.dispose(),a.CurrentDragAndDropData&&a.CurrentDragAndDropData.getData()==="vscode-ui"||(this.pb(u.browserEvent),!u.browserEvent.dataTransfer))return!1;if(!this.I)if(a.CurrentDragAndDropData)this.I=a.CurrentDragAndDropData;else{if(!u.browserEvent.dataTransfer.types)return!1;this.I=new b}const C=this.G.onDragOver(this.I,u.element,u.index,u.browserEvent);if(this.H=typeof C=="boolean"?C:C.accept,!this.H)return this.J=void 0,this.K.dispose(),!1;u.browserEvent.dataTransfer.dropEffect=typeof C!="boolean"&&C.effect===0?"copy":"move";let p;if(typeof C!="boolean"&&C.feedback?p=C.feedback:typeof u.index>"u"?p=[-1]:p=[u.index],p=(0,w.distinct)(p).filter(D=>D>=-1&&D<this.length).sort((D,_)=>D-_),p=p[0]===-1?[-1]:p,A(this.J,p))return!0;if(this.J=p,this.K.dispose(),p[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.K=(0,M.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const D of p){const _=this.d[D];_.dropTarget=!0,_.row?.domNode.classList.add("drop-target")}this.K=(0,M.toDisposable)(()=>{for(const D of p){const _=this.d[D];_.dropTarget=!1,_.row?.domNode.classList.remove("drop-target")}})}return!0}lb(u){this.L.dispose(),this.L=(0,f.disposableTimeout)(()=>this.ob(),100),this.I&&this.G.onDragLeave?.(this.I,u.element,u.index,u.browserEvent)}mb(u){if(!this.H)return;const C=this.I;this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.I=void 0,a.CurrentDragAndDropData=void 0,!(!C||!u.browserEvent.dataTransfer)&&(u.browserEvent.preventDefault(),C.update(u.browserEvent.dataTransfer),this.G.drop(C,u.element,u.index,u.browserEvent))}nb(u){this.H=!1,this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.I=void 0,a.CurrentDragAndDropData=void 0,this.G.onDragEnd?.(u)}ob(){this.J=void 0,this.K.dispose(),this.K=M.Disposable.None}pb(u){if(!this.w){const C=(0,i.getTopLeftOffset)(this.domNode).top;this.w=(0,i.animate)(this.qb.bind(this,C))}this.x.dispose(),this.x=(0,f.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=u.pageY}qb(u){if(this.y===void 0)return;const C=this.y-u,p=this.renderHeight-35;C<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(C-35))):C>p&&(this.scrollTop+=Math.min(14,Math.floor(.3*(C-p))))}rb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}sb(u){const C=this.q.getDomNode();let p=u;for(;p instanceof HTMLElement&&p!==this.o&&C.contains(p);){const D=p.getAttribute("data-index");if(D){const _=Number(D);if(!isNaN(_))return _}p=p.parentElement}}tb(u,C){return{start:this.g.indexAt(u),end:this.g.indexAfter(u+C-1)}}ub(u,C,p){const D=this.tb(u,C);let _,V;u===this.elementTop(D.start)?(_=D.start,V=0):D.end-D.start>1&&(_=D.start+1,V=this.elementTop(_)-u);let ee=0;for(;;){const Z=this.tb(u,C);let pe=!1;for(let oe=Z.start;oe<Z.end;oe++){const ce=this.vb(oe);ce!==0&&this.g.splice(oe,1,[this.d[oe]]),ee+=ce,pe=pe||ce!==0}if(!pe){ee!==0&&this.S();const oe=o.Range.relativeComplement(D,Z);for(const ae of oe)for(let de=ae.start;de<ae.end;de++)this.d[de].row&&this.bb(de);const ce=o.Range.relativeComplement(Z,D);for(const ae of ce)for(let de=ae.start;de<ae.end;de++){const Se=de+1,x=Se<this.d.length?this.d[Se].row:null,ye=x?x.domNode:null;this.X(de,ye)}for(let ae=Z.start;ae<Z.end;ae++)this.d[ae].row&&this.ab(this.d[ae],ae);if(typeof _=="number"){const ae=this.p.getFutureScrollPosition().scrollTop-u,de=this.elementTop(_)-V+ae;this.setScrollTop(de,p)}this.N.fire(this.contentHeight);return}}}vb(u){const C=this.d[u];if(this.Q.getDynamicHeight){const V=this.Q.getDynamicHeight(C.element);if(V!==null){const ee=C.size;return C.size=V,C.lastDynamicHeightWidth=this.n,V-ee}}if(!C.hasDynamicHeight||C.lastDynamicHeightWidth===this.n||!!this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(C.element))return 0;const p=C.size;if(C.row)return C.row.domNode.style.height="",C.size=C.row.domNode.offsetHeight,C.lastDynamicHeightWidth=this.n,C.size-p;const D=this.h.alloc(C.templateId);D.domNode.style.height="",this.o.appendChild(D.domNode);const _=this.j.get(C.templateId);if(!_)throw new l.BugIndicatingError("Missing renderer for templateId: "+C.templateId);return _.renderElement(C.element,u,D.templateData,void 0),C.size=D.domNode.offsetHeight,_.disposeElement?.(C.element,u,D.templateData,void 0),this.Q.setDynamicHeight?.(C.element,C.size),C.lastDynamicHeightWidth=this.n,this.o.removeChild(D.domNode),this.h.release(D),C.size-p}wb(u){const C=u[u.length-1];if(!C)return null;const p=this.d[C.end];return!p||!p.row?null:p.row.domNode}getElementDomId(u){return`${this.domId}_${u}`}dispose(){if(this.d){for(const u of this.d)if(u.row){const C=this.j.get(u.row.templateId);C&&(C.disposeElement?.(u.element,-1,u.row.templateData,void 0),C.disposeTemplate(u.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,M.dispose)(this.M)}}N.c=0,qe([g.memoize],N.prototype,"onMouseClick",null),qe([g.memoize],N.prototype,"onMouseDblClick",null),qe([g.memoize],N.prototype,"onMouseMiddleClick",null),qe([g.memoize],N.prototype,"onMouseUp",null),qe([g.memoize],N.prototype,"onMouseDown",null),qe([g.memoize],N.prototype,"onMouseOver",null),qe([g.memoize],N.prototype,"onMouseMove",null),qe([g.memoize],N.prototype,"onMouseOut",null),qe([g.memoize],N.prototype,"onContextMenu",null),qe([g.memoize],N.prototype,"onTouchStart",null),qe([g.memoize],N.prototype,"onTap",null),t.ListView=N}),define(me[59],be([1,0,4,18,19,22,54,69,14,8,41,24,3,32,2,46,30,5,6,68,58,89]),function(X,t,v,i,U,H,y,w,f,g,d,M,o,n,e,s,l,a,c,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class b{constructor(m){this.d=m,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(m){return m}renderElement(m,B,z){const $=this.c.findIndex(G=>G.templateData===z);if($>=0){const G=this.c[$];this.d.unrender(z),G.index=B}else{const G={index:B,templateData:z};this.c.push(G)}this.d.renderIndex(B,z)}splice(m,B,z){const $=[];for(const G of this.c)G.index<m?$.push(G):G.index>=m+B&&$.push({index:G.index+z-B,templateData:G.templateData});this.c=$}renderIndexes(m){for(const{index:B,templateData:z}of this.c)m.indexOf(B)>-1&&this.d.renderIndex(B,z)}disposeTemplate(m){const B=this.c.findIndex(z=>z.templateData===m);B<0||this.c.splice(B,1)}}class A{get name(){return this.h}get renderer(){return new b(this)}constructor(m){this.h=m,this.c=0,this.d=[],this.f=[],this.g=new o.Emitter,this.onChange=this.g.event}splice(m,B,z){B=Math.max(0,Math.min(B,this.c-m));const $=z.length-B,G=m+B,k=[...this.f.filter(W=>W<m),...z.map((W,S)=>W?S+m:-1).filter(W=>W!==-1),...this.f.filter(W=>W>=G).map(W=>W+$)],O=this.c+$;if(this.f.length>0&&k.length===0&&O>0){const W=this.f.find(S=>S>=m)??O-1;k.push(Math.min(W,O-1))}this.renderer.splice(m,B,z.length),this.k(k,k),this.c=O}renderIndex(m,B){B.classList.toggle(this.h,this.contains(m))}unrender(m){m.classList.remove(this.h)}set(m,B){return this.k(m,[...m].sort(he),B)}k(m,B,z){const $=this.d,G=this.f;this.d=m,this.f=B;const k=ie(G,m);return this.renderer.renderIndexes(k),this.g.fire({indexes:m,browserEvent:z}),$}get(){return this.d}contains(m){return(0,f.binarySearch)(this.f,m,he)>=0}dispose(){(0,e.dispose)(this.g)}}qe([M.memoize],A.prototype,"renderer",null);class L extends A{constructor(m){super("selected"),this.l=m}renderIndex(m,B){super.renderIndex(m,B),this.l&&(this.contains(m)?B.setAttribute("aria-selected","true"):B.setAttribute("aria-selected","false"))}}class N{constructor(m,B,z){this.c=m,this.d=B,this.f=z}splice(m,B,z){if(!this.f)return this.c.splice(m,B,z.map(()=>!1));const $=this.c.get().map(k=>this.f.getId(this.d.element(k)).toString()),G=z.map(k=>$.indexOf(this.f.getId(k).toString())>-1);this.c.splice(m,B,G)}}function F(E){return E.tagName==="INPUT"||E.tagName==="TEXTAREA"}t.isInputElement=F;function u(E){return E.classList.contains("monaco-editor")?!0:E.classList.contains("monaco-list")||!E.parentElement?!1:u(E.parentElement)}t.isMonacoEditor=u;function C(E){return E.tagName==="A"&&E.classList.contains("monaco-button")||E.tagName==="DIV"&&E.classList.contains("monaco-button-dropdown")?!0:E.classList.contains("monaco-list")||!E.parentElement?!1:C(E.parentElement)}t.isButton=C;class p{get f(){return this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(this.h.domNode,"keydown")).event).filter(m=>!F(m.target)).map(m=>new U.StandardKeyboardEvent(m)))}constructor(m,B,z){this.g=m,this.h=B,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter($=>$.keyCode===3).on(this.k,this,this.c),this.f.filter($=>$.keyCode===16).on(this.l,this,this.c),this.f.filter($=>$.keyCode===18).on(this.o,this,this.c),this.f.filter($=>$.keyCode===11).on(this.p,this,this.c),this.f.filter($=>$.keyCode===12).on(this.q,this,this.c),this.f.filter($=>$.keyCode===9).on(this.t,this,this.c),z.multipleSelectionSupport!==!1&&this.f.filter($=>(a.isMacintosh?$.metaKey:$.ctrlKey)&&$.keyCode===31).on(this.s,this,this.d)}updateOptions(m){m.multipleSelectionSupport!==void 0&&(this.d.clear(),m.multipleSelectionSupport&&this.f.filter(B=>(a.isMacintosh?B.metaKey:B.ctrlKey)&&B.keyCode===31).on(this.s,this,this.d))}k(m){m.preventDefault(),m.stopPropagation(),this.g.setSelection(this.g.getFocus(),m.browserEvent)}l(m){m.preventDefault(),m.stopPropagation(),this.g.focusPrevious(1,!1,m.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}o(m){m.preventDefault(),m.stopPropagation(),this.g.focusNext(1,!1,m.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}p(m){m.preventDefault(),m.stopPropagation(),this.g.focusPreviousPage(m.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}q(m){m.preventDefault(),m.stopPropagation(),this.g.focusNextPage(m.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}s(m){m.preventDefault(),m.stopPropagation(),this.g.setSelection((0,f.range)(this.g.length),m.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(m){this.g.getSelection().length&&(m.preventDefault(),m.stopPropagation(),this.g.setSelection([],m.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([M.memoize],p.prototype,"f",null);var D;(function(E){E[E.Automatic=0]="Automatic",E[E.Trigger=1]="Trigger"})(D=t.TypeNavigationMode||(t.TypeNavigationMode={}));var _;(function(E){E[E.Idle=0]="Idle",E[E.Typing=1]="Typing"})(_||(_={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(E){return E.ctrlKey||E.metaKey||E.altKey?!1:E.keyCode>=31&&E.keyCode<=56||E.keyCode>=21&&E.keyCode<=30||E.keyCode>=93&&E.keyCode<=102||E.keyCode>=80&&E.keyCode<=90}};class V{constructor(m,B,z,$,G){this.o=m,this.p=B,this.q=z,this.s=$,this.t=G,this.c=!1,this.d=_.Idle,this.f=D.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(m.options)}updateOptions(m){m.typeNavigationEnabled??!0?this.u():this.v(),this.f=m.typeNavigationMode??D.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let m=!1;const B=this.k.add(o.Event.chain(this.k.add(new i.DomEmitter(this.p.domNode,"keydown")).event)).filter(G=>!F(G.target)).filter(()=>this.f===D.Automatic||this.g).map(G=>new U.StandardKeyboardEvent(G)).filter(G=>m||this.s(G)).filter(G=>this.t.mightProducePrintableCharacter(G)).forEach(G=>v.EventHelper.stop(G,!0)).map(G=>G.browserEvent.key).event,z=o.Event.debounce(B,()=>null,800,void 0,void 0,this.k);o.Event.reduce(o.Event.any(B,z),(G,k)=>k===null?null:(G||"")+k,void 0,this.k)(this.A,this,this.k),z(this.w,this,this.k),B(()=>m=!0,void 0,this.k),z(()=>m=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const m=this.o.getFocus();if(m.length>0&&m[0]===this.h){const B=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(m[0]));B&&(0,y.alert)(B)}this.h=-1}A(m){if(!m){this.d=_.Idle,this.g=!1;return}const B=this.o.getFocus(),z=B.length>0?B[0]:0,$=this.d===_.Idle?1:0;this.d=_.Typing;for(let G=0;G<this.o.length;G++){const k=(z+G+$)%this.o.length,O=this.q.getKeyboardNavigationLabel(this.p.element(k)),W=O&&O.toString();if(typeof W>"u"||(0,n.matchesPrefix)(m,W)){this.h=z,this.o.setFocus([k]),this.o.reveal(k);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ee{constructor(m,B){this.d=m,this.f=B,this.c=new e.DisposableStore,this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(B.domNode,"keydown")).event)).filter($=>!F($.target)).map($=>new U.StandardKeyboardEvent($)).filter($=>$.keyCode===2&&!$.ctrlKey&&!$.metaKey&&!$.shiftKey&&!$.altKey).on(this.g,this,this.c)}g(m){if(m.target!==this.f.domNode)return;const B=this.d.getFocus();if(B.length===0)return;const z=this.f.domElement(B[0]);if(!z)return;const $=z.querySelector("[tabIndex]");if(!$||!($ instanceof HTMLElement)||$.tabIndex===-1)return;const G=window.getComputedStyle($);G.visibility==="hidden"||G.display==="none"||(m.preventDefault(),m.stopPropagation(),$.focus())}dispose(){this.c.dispose()}}function Z(E){return a.isMacintosh?E.browserEvent.metaKey:E.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function pe(E){return E.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=pe;function oe(E){return E instanceof MouseEvent&&E.button===2}const ce={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:pe};class ae{constructor(m){this.k=m,this.f=new e.DisposableStore,this.g=new o.Emitter,this.onPointer=this.g.event,m.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ce),this.d=typeof m.options.mouseSupport>"u"||!!m.options.mouseSupport,this.d&&(m.onMouseDown(this.s,this,this.f),m.onContextMenu(this.t,this,this.f),m.onMouseDblClick(this.v,this,this.f),m.onTouchStart(this.s,this,this.f),this.f.add(H.Gesture.addTarget(m.getHTMLElement()))),o.Event.any(m.onMouseClick,m.onMouseMiddleClick,m.onTap)(this.u,this,this.f)}updateOptions(m){m.multipleSelectionSupport!==void 0&&(this.c=void 0,m.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ce))}o(m){return this.c?this.c.isSelectionSingleChangeEvent(m):!1}p(m){return this.c?this.c.isSelectionRangeChangeEvent(m):!1}q(m){return this.o(m)||this.p(m)}s(m){u(m.browserEvent.target)||document.activeElement!==m.browserEvent.target&&this.k.domFocus()}t(m){if(u(m.browserEvent.target))return;const B=typeof m.index>"u"?[]:[m.index];this.k.setFocus(B,m.browserEvent)}u(m){if(!this.d||F(m.browserEvent.target)||u(m.browserEvent.target))return;const B=m.index;if(typeof B>"u"){this.k.setFocus([],m.browserEvent),this.k.setSelection([],m.browserEvent),this.k.setAnchor(void 0);return}if(this.p(m))return this.w(m);if(this.q(m))return this.w(m);this.k.setFocus([B],m.browserEvent),this.k.setAnchor(B),oe(m.browserEvent)||this.k.setSelection([B],m.browserEvent),this.g.fire(m)}v(m){if(F(m.browserEvent.target)||u(m.browserEvent.target)||this.q(m))return;const B=this.k.getFocus();this.k.setSelection(B,m.browserEvent)}w(m){const B=m.index;let z=this.k.getAnchor();if(this.p(m)){typeof z>"u"&&(z=this.k.getFocus()[0]??B,this.k.setAnchor(z));const $=Math.min(z,B),G=Math.max(z,B),k=(0,f.range)($,G+1),O=this.k.getSelection(),W=ye(ie(O,[z]),z);if(W.length===0)return;const S=ie(k,J(O,W));this.k.setSelection(S,m.browserEvent),this.k.setFocus([B],m.browserEvent)}else if(this.o(m)){const $=this.k.getSelection(),G=$.filter(k=>k!==B);this.k.setFocus([B]),this.k.setAnchor(B),$.length===G.length?this.k.setSelection([...G,B],m.browserEvent):this.k.setSelection(G,m.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=ae;class de{constructor(m,B){this.c=m,this.d=B}style(m){const B=this.d&&`.${this.d}`,z=[];m.listBackground&&(m.listBackground.isOpaque()?z.push(`.monaco-list${B} .monaco-list-rows { background: ${m.listBackground}; }`):a.isMacintosh||console.warn(`List with id '${this.d}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),m.listFocusBackground&&(z.push(`.monaco-list${B}:focus .monaco-list-row.focused { background-color: ${m.listFocusBackground}; }`),z.push(`.monaco-list${B}:focus .monaco-list-row.focused:hover { background-color: ${m.listFocusBackground}; }`)),m.listFocusForeground&&z.push(`.monaco-list${B}:focus .monaco-list-row.focused { color: ${m.listFocusForeground}; }`),m.listActiveSelectionBackground&&(z.push(`.monaco-list${B}:focus .monaco-list-row.selected { background-color: ${m.listActiveSelectionBackground}; }`),z.push(`.monaco-list${B}:focus .monaco-list-row.selected:hover { background-color: ${m.listActiveSelectionBackground}; }`)),m.listActiveSelectionForeground&&z.push(`.monaco-list${B}:focus .monaco-list-row.selected { color: ${m.listActiveSelectionForeground}; }`),m.listActiveSelectionIconForeground&&z.push(`.monaco-list${B}:focus .monaco-list-row.selected .codicon { color: ${m.listActiveSelectionIconForeground}; }`),m.listFocusAndSelectionOutline&&z.push(`.monaco-list${B}:focus .monaco-list-row.selected { outline-color: ${m.listFocusAndSelectionOutline} !important; }`),m.listFocusAndSelectionBackground&&z.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { background-color: ${m.listFocusAndSelectionBackground}; }
			`),m.listFocusAndSelectionForeground&&z.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { color: ${m.listFocusAndSelectionForeground}; }
			`),m.listInactiveFocusForeground&&(z.push(`.monaco-list${B} .monaco-list-row.focused { color:  ${m.listInactiveFocusForeground}; }`),z.push(`.monaco-list${B} .monaco-list-row.focused:hover { color:  ${m.listInactiveFocusForeground}; }`)),m.listInactiveSelectionIconForeground&&z.push(`.monaco-list${B} .monaco-list-row.focused .codicon { color:  ${m.listInactiveSelectionIconForeground}; }`),m.listInactiveFocusBackground&&(z.push(`.monaco-list${B} .monaco-list-row.focused { background-color:  ${m.listInactiveFocusBackground}; }`),z.push(`.monaco-list${B} .monaco-list-row.focused:hover { background-color:  ${m.listInactiveFocusBackground}; }`)),m.listInactiveSelectionBackground&&(z.push(`.monaco-list${B} .monaco-list-row.selected { background-color:  ${m.listInactiveSelectionBackground}; }`),z.push(`.monaco-list${B} .monaco-list-row.selected:hover { background-color:  ${m.listInactiveSelectionBackground}; }`)),m.listInactiveSelectionForeground&&z.push(`.monaco-list${B} .monaco-list-row.selected { color: ${m.listInactiveSelectionForeground}; }`),m.listHoverBackground&&z.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${m.listHoverBackground}; }`),m.listHoverForeground&&z.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${m.listHoverForeground}; }`),m.listSelectionOutline&&z.push(`.monaco-list${B} .monaco-list-row.selected { outline: 1px dotted ${m.listSelectionOutline}; outline-offset: -1px; }`),m.listFocusOutline&&z.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.focused { outline: 1px solid ${m.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${B}.last-focused .monaco-list-row.focused { outline: 1px solid ${m.listFocusOutline}; outline-offset: -1px; }
			`),m.listInactiveFocusOutline&&z.push(`.monaco-list${B} .monaco-list-row.focused { outline: 1px dotted ${m.listInactiveFocusOutline}; outline-offset: -1px; }`),m.listHoverOutline&&z.push(`.monaco-list${B} .monaco-list-row:hover { outline: 1px dashed ${m.listHoverOutline}; outline-offset: -1px; }`),m.listDropBackground&&z.push(`
				.monaco-list${B}.drop-target,
				.monaco-list${B} .monaco-list-rows.drop-target,
				.monaco-list${B} .monaco-list-row.drop-target { background-color: ${m.listDropBackground} !important; color: inherit !important; }
			`),m.tableColumnsBorder&&z.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${m.tableColumnsBorder};
			}`),m.tableOddRowsBackgroundColor&&z.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${m.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=z.join(`
`)}}t.DefaultStyleController=de;const Se={listFocusBackground:d.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:d.Color.fromHex("#0E639C"),listActiveSelectionForeground:d.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:d.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:d.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:d.Color.fromHex("#094771"),listFocusAndSelectionForeground:d.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:d.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:d.Color.fromHex("#FFFFFF"),listHoverBackground:d.Color.fromHex("#2A2D2E"),listDropBackground:d.Color.fromHex("#383B3D"),treeIndentGuidesStroke:d.Color.fromHex("#a9a9a9"),tableColumnsBorder:d.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:d.Color.fromHex("#cccccc").transparent(.04)},x={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ye(E,m){const B=E.indexOf(m);if(B===-1)return[];const z=[];let $=B-1;for(;$>=0&&E[$]===m-(B-$);)z.push(E[$--]);for(z.reverse(),$=B;$<E.length&&E[$]===m+($-B);)z.push(E[$++]);return z}function ie(E,m){const B=[];let z=0,$=0;for(;z<E.length||$<m.length;)if(z>=E.length)B.push(m[$++]);else if($>=m.length)B.push(E[z++]);else if(E[z]===m[$]){B.push(E[z]),z++,$++;continue}else E[z]<m[$]?B.push(E[z++]):B.push(m[$++]);return B}function J(E,m){const B=[];let z=0,$=0;for(;z<E.length||$<m.length;)if(z>=E.length)B.push(m[$++]);else if($>=m.length)B.push(E[z++]);else if(E[z]===m[$]){z++,$++;continue}else E[z]<m[$]?B.push(E[z++]):$++;return B}const he=(E,m)=>E-m;class fe{constructor(m,B){this.c=m,this.d=B}get templateId(){return this.c}renderTemplate(m){return this.d.map(B=>B.renderTemplate(m))}renderElement(m,B,z,$){let G=0;for(const k of this.d)k.renderElement(m,B,z[G++],$)}disposeElement(m,B,z,$){let G=0;for(const k of this.d)k.disposeElement?.(m,B,z[G],$),G+=1}disposeTemplate(m){let B=0;for(const z of this.d)z.disposeTemplate(m[B++])}}class le{constructor(m){this.c=m,this.templateId="a18n"}renderTemplate(m){return m}renderElement(m,B,z){const $=this.c.getAriaLabel(m);$?z.setAttribute("aria-label",$):z.removeAttribute("aria-label");const G=this.c.getAriaLevel&&this.c.getAriaLevel(m);typeof G=="number"?z.setAttribute("aria-level",`${G}`):z.removeAttribute("aria-level")}disposeTemplate(m){}}class te{constructor(m,B){this.c=m,this.d=B}getDragElements(m){const B=this.c.getSelectedElements();return B.indexOf(m)>-1?B:[m]}getDragURI(m){return this.d.getDragURI(m)}getDragLabel(m,B){if(this.d.getDragLabel)return this.d.getDragLabel(m,B)}onDragStart(m,B){this.d.onDragStart?.(m,B)}onDragOver(m,B,z,$){return this.d.onDragOver(m,B,z,$)}onDragLeave(m,B,z,$){this.d.onDragLeave?.(m,B,z,$)}onDragEnd(m){this.d.onDragEnd?.(m)}drop(m,B,z,$){this.d.drop(m,B,z,$)}}class T{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),m=>this.I(m),this.B)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),m=>this.I(m),this.B)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let m=!1;const B=this.B.add(o.Event.chain(this.B.add(new i.DomEmitter(this.k.domNode,"keydown")).event)).map(G=>new U.StandardKeyboardEvent(G)).filter(G=>m=G.keyCode===58||G.shiftKey&&G.keyCode===68).map(G=>v.EventHelper.stop(G,!0)).filter(()=>!1).event,z=this.B.add(o.Event.chain(this.B.add(new i.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>m=!1).map(G=>new U.StandardKeyboardEvent(G)).filter(G=>G.keyCode===58||G.shiftKey&&G.keyCode===68).map(G=>v.EventHelper.stop(G,!0)).map(({browserEvent:G})=>{const k=this.getFocus(),O=k.length?k[0]:void 0,W=typeof O<"u"?this.k.element(O):void 0,S=typeof O<"u"?this.k.domElement(O):this.k.domNode;return{index:O,element:W,anchor:S,browserEvent:G}}).event,$=this.B.add(o.Event.chain(this.k.onContextMenu)).filter(G=>!m).map(({element:G,index:k,browserEvent:O})=>({element:G,index:k,anchor:{x:O.pageX+1,y:O.pageY},browserEvent:O})).event;return o.Event.any(B,z,$)}get onKeyDown(){return this.B.add(new i.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.B.add(new i.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.B.add(new i.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.B.add(new i.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.B.add(new i.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(m,B,z,$,G=x){this.D=m,this.E=G,this.c=new A("focused"),this.f=new A("anchor"),this.g=new o.EventBufferer,this.A="",this.B=new e.DisposableStore,this.C=new o.Emitter,this.onDidDispose=this.C.event;const k=this.E.accessibilityProvider&&this.E.accessibilityProvider.getWidgetRole?this.E.accessibilityProvider?.getWidgetRole():"list";this.d=new L(k!=="listbox"),(0,l.mixin)(G,Se,!1);const O=[this.c.renderer,this.d.renderer];this.u=G.accessibilityProvider,this.u&&(O.push(new le(this.u)),this.u.onDidChangeActiveDescendant?.(this.K,this,this.B)),$=$.map(S=>new fe(S.templateId,[...O,S]));const W={...G,dnd:G.dnd&&new te(this,G.dnd)};if(this.k=new h.ListView(B,z,$,W),this.k.domNode.setAttribute("role",k),G.styleController)this.q=G.styleController(this.k.domId);else{const S=(0,v.createStyleSheet)(this.k.domNode);this.q=new de(S,this.k.domId)}if(this.o=new w.CombinedSpliceable([new N(this.c,this.k,G.identityProvider),new N(this.d,this.k,G.identityProvider),new N(this.f,this.k,G.identityProvider),this.k]),this.B.add(this.c),this.B.add(this.d),this.B.add(this.f),this.B.add(this.k),this.B.add(this.C),this.B.add(new ee(this,this.k)),(typeof G.keyboardSupport!="boolean"||G.keyboardSupport)&&(this.v=new p(this,this.k,G),this.B.add(this.v)),G.keyboardNavigationLabelProvider){const S=G.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new V(this,this.k,G.keyboardNavigationLabelProvider,G.keyboardNavigationEventFilter??(()=>!0),S),this.B.add(this.t)}this.w=this.F(G),this.B.add(this.w),this.onDidChangeFocus(this.J,this,this.B),this.onDidChangeSelection(this.L,this,this.B),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.E.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}F(m){return new ae(this)}updateOptions(m={}){this.E={...this.E,...m},this.t?.updateOptions(this.E),this.E.multipleSelectionController!==void 0&&(this.E.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(m),this.v?.updateOptions(m),this.k.updateOptions(m)}get options(){return this.E}splice(m,B,z=[]){if(m<0||m>this.k.length)throw new r.ListError(this.D,`Invalid start index: ${m}`);if(B<0)throw new r.ListError(this.D,`Invalid delete count: ${B}`);B===0&&z.length===0||this.g.bufferEvents(()=>this.o.splice(m,B,z))}updateWidth(m){this.k.updateWidth(m)}updateElementHeight(m,B){this.k.updateElementHeight(m,B,null)}rerender(){this.k.rerender()}element(m){return this.k.element(m)}indexOf(m){return this.k.indexOf(m)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(m){this.k.setScrollTop(m)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(m){this.k.setScrollLeft(m)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.A}set ariaLabel(m){this.A=m,this.k.domNode.setAttribute("aria-label",m)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(m,B){this.k.layout(m,B)}triggerTypeNavigation(){this.t?.trigger()}setSelection(m,B){for(const z of m)if(z<0||z>=this.length)throw new r.ListError(this.D,`Invalid index ${z}`);this.d.set(m,B)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(m=>this.k.element(m))}setAnchor(m){if(typeof m>"u"){this.f.set([]);return}if(m<0||m>=this.length)throw new r.ListError(this.D,`Invalid index ${m}`);this.f.set([m])}getAnchor(){return(0,f.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const m=this.getAnchor();return typeof m>"u"?void 0:this.element(m)}setFocus(m,B){for(const z of m)if(z<0||z>=this.length)throw new r.ListError(this.D,`Invalid index ${z}`);this.c.set(m,B)}focusNext(m=1,B=!1,z,$){if(this.length===0)return;const G=this.c.get(),k=this.G(G.length>0?G[0]+m:0,B,$);k>-1&&this.setFocus([k],z)}focusPrevious(m=1,B=!1,z,$){if(this.length===0)return;const G=this.c.get(),k=this.H(G.length>0?G[0]-m:0,B,$);k>-1&&this.setFocus([k],z)}async focusNextPage(m,B){let z=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);z=z===0?0:z-1;const $=this.getFocus()[0];if($!==z&&($===void 0||z>$)){const G=this.H(z,!1,B);G>-1&&$!==G?this.setFocus([G],m):this.setFocus([z],m)}else{const G=this.k.getScrollTop();let k=G+this.k.renderHeight;z>$&&(k-=this.k.elementHeight(z)),this.k.setScrollTop(k),this.k.getScrollTop()!==G&&(this.setFocus([]),await(0,g.timeout)(0),await this.focusNextPage(m,B))}}async focusPreviousPage(m,B){let z;const $=this.k.getScrollTop();$===0?z=this.k.indexAt($):z=this.k.indexAfter($-1);const G=this.getFocus()[0];if(G!==z&&(G===void 0||G>=z)){const k=this.G(z,!1,B);k>-1&&G!==k?this.setFocus([k],m):this.setFocus([z],m)}else{const k=$;this.k.setScrollTop($-this.k.renderHeight),this.k.getScrollTop()!==k&&(this.setFocus([]),await(0,g.timeout)(0),await this.focusPreviousPage(m,B))}}focusLast(m,B){if(this.length===0)return;const z=this.H(this.length-1,!1,B);z>-1&&this.setFocus([z],m)}focusFirst(m,B){this.focusNth(0,m,B)}focusNth(m,B,z){if(this.length===0)return;const $=this.G(m,!1,z);$>-1&&this.setFocus([$],B)}G(m,B=!1,z){for(let $=0;$<this.length;$++){if(m>=this.length&&!B)return-1;if(m=m%this.length,!z||z(this.element(m)))return m;m++}return-1}H(m,B=!1,z){for(let $=0;$<this.length;$++){if(m<0&&!B)return-1;if(m=(this.length+m%this.length)%this.length,!z||z(this.element(m)))return m;m--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(m=>this.k.element(m))}reveal(m,B){if(m<0||m>=this.length)throw new r.ListError(this.D,`Invalid index ${m}`);const z=this.k.getScrollTop(),$=this.k.elementTop(m),G=this.k.elementHeight(m);if((0,c.isNumber)(B)){const k=G-this.k.renderHeight;this.k.setScrollTop(k*(0,s.clamp)(B,0,1)+$)}else{const k=$+G,O=z+this.k.renderHeight;$<z&&k>=O||($<z||k>=O&&G>=this.k.renderHeight?this.k.setScrollTop($):k>=O&&this.k.setScrollTop(k-this.k.renderHeight))}}getRelativeTop(m){if(m<0||m>=this.length)throw new r.ListError(this.D,`Invalid index ${m}`);const B=this.k.getScrollTop(),z=this.k.elementTop(m),$=this.k.elementHeight(m);if(z<B||z+$>B+this.k.renderHeight)return null;const G=$-this.k.renderHeight;return Math.abs((B-z)/G)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(m){return this.k.getElementDomId(m)}style(m){this.q.style(m)}I({indexes:m,browserEvent:B}){return{indexes:m,elements:m.map(z=>this.k.element(z)),browserEvent:B}}J(){const m=this.c.get();this.k.domNode.classList.toggle("element-focused",m.length>0),this.K()}K(){const m=this.c.get();if(m.length>0){let B;this.u?.getActiveDescendantId&&(B=this.u.getActiveDescendantId(this.k.element(m[0]))),this.k.domNode.setAttribute("aria-activedescendant",B||this.k.getElementDomId(m[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}L(){const m=this.d.get();this.k.domNode.classList.toggle("selection-none",m.length===0),this.k.domNode.classList.toggle("selection-single",m.length===1),this.k.domNode.classList.toggle("selection-multiple",m.length>1)}dispose(){this.C.fire(),this.B.dispose(),this.C.dispose()}}qe([M.memoize],T.prototype,"onDidChangeFocus",null),qe([M.memoize],T.prototype,"onDidChangeSelection",null),qe([M.memoize],T.prototype,"onContextMenu",null),qe([M.memoize],T.prototype,"onKeyDown",null),qe([M.memoize],T.prototype,"onKeyUp",null),qe([M.memoize],T.prototype,"onKeyPress",null),qe([M.memoize],T.prototype,"onDidFocus",null),qe([M.memoize],T.prototype,"onDidBlur",null),t.List=T}),define(me[60],be([1,0,9,33,35,11,15]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class f{constructor(a="",c=!1){if(this.value=a,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(a,c=0){return this.value+=o(this.supportThemeIcons?(0,i.escapeIcons)(a):a).replace(/([ \t]+)/g,(r,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,c){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(a,c,r){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(a),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(a,c){const r=new RegExp((0,H.escapeRegExpCharacters)(c),"g");return a.replace(r,(h,b)=>a.charAt(b-1)!=="\\"?`\\${h}`:h)}}t.MarkdownString=f;function g(l){return d(l)?!l.value:Array.isArray(l)?l.every(g):!0}t.isEmptyMarkdownString=g;function d(l){return l instanceof f?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.isMarkdownString=d;function M(l,a){return l===a?!0:!l||!a?!1:l.value===a.value&&l.isTrusted===a.isTrusted&&l.supportThemeIcons===a.supportThemeIcons&&l.supportHtml===a.supportHtml&&(l.baseUri===a.baseUri||!!l.baseUri&&!!a.baseUri&&(0,U.isEqual)(y.URI.from(l.baseUri),y.URI.from(a.baseUri)))}t.markdownStringEqual=M;function o(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function n(l){return l.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function s(l){const a=[],c=l.split("|").map(h=>h.trim());l=c[0];const r=c[1];if(r){const h=/height=(\d+)/.exec(r),b=/width=(\d+)/.exec(r),A=h?h[1]:"",L=b?b[1]:"",N=isFinite(parseInt(L)),F=isFinite(parseInt(A));N&&a.push(`width="${L}"`),F&&a.push(`height="${A}"`)}return{href:l,dimensions:a}}t.parseHrefAndDimensions=s}),define(me[122],be([1,0,4,114,18,52,20,115,9,3,60,33,73,44,2,76,50,34,30,35,11,15]),function(X,t,v,i,U,H,y,w,f,g,d,M,o,n,e,s,l,a,c,r,h,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const A=Object.freeze({image:(ee,Z,pe)=>{let oe=[],ce=[];return ee&&({href:ee,dimensions:oe}=(0,d.parseHrefAndDimensions)(ee),ce.push(`src="${(0,d.escapeDoubleQuotes)(ee)}"`)),pe&&ce.push(`alt="${(0,d.escapeDoubleQuotes)(pe)}"`),Z&&ce.push(`title="${(0,d.escapeDoubleQuotes)(Z)}"`),oe.length&&(ce=ce.concat(oe)),"<img "+ce.join(" ")+">"},paragraph:ee=>`<p>${ee}</p>`,link:(ee,Z,pe)=>typeof ee!="string"?"":(ee===pe&&(pe=(0,d.removeMarkdownEscapes)(pe)),Z=typeof Z=="string"?(0,d.escapeDoubleQuotes)((0,d.removeMarkdownEscapes)(Z)):"",ee=(0,d.removeMarkdownEscapes)(ee),ee=ee.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${ee}" title="${Z||ee}">${pe}</a>`)});function L(ee,Z={},pe={}){const oe=new e.DisposableStore;let ce=!1;const ae=(0,H.createElement)(Z),de=function(le){let te;try{te=(0,l.parse)(decodeURIComponent(le))}catch{}return te?(te=(0,c.cloneAndChange)(te,T=>{if(ee.uris&&ee.uris[T])return b.URI.revive(ee.uris[T])}),encodeURIComponent(JSON.stringify(te))):le},Se=function(le,te){const T=ee.uris&&ee.uris[le];let E=b.URI.revive(T);return te?le.startsWith(a.Schemas.data+":")?le:(E||(E=b.URI.parse(le)),a.FileAccess.uriToBrowserUri(E).toString(!0)):!E||b.URI.parse(le).toString()===E.toString()?le:(E.query&&(E=E.with({query:de(E.query)})),E.toString())},x=new s.marked.Renderer;x.image=A.image,x.link=A.link,x.paragraph=A.paragraph;const ye=[];if(Z.codeBlockRenderer&&(x.code=(le,te)=>{const T=o.defaultGenerator.nextId(),E=Z.codeBlockRenderer(N(te),le);return ye.push(E.then(m=>[T,m])),`<div class="code" data-code="${T}">${(0,h.escape)(le)}</div>`}),Z.actionHandler){const le=Z.actionHandler.disposables.add(new U.DomEmitter(ae,"click")),te=Z.actionHandler.disposables.add(new U.DomEmitter(ae,"auxclick"));Z.actionHandler.disposables.add(g.Event.any(le.event,te.event)(T=>{const E=new y.StandardMouseEvent(T);if(!E.leftButton&&!E.middleButton)return;let m=E.target;if(!(m.tagName!=="A"&&(m=m.parentElement,!m||m.tagName!=="A")))try{let B=m.dataset.href;B&&(ee.baseUri&&(B=F(b.URI.from(ee.baseUri),B)),Z.actionHandler.callback(B,E))}catch(B){(0,f.onUnexpectedError)(B)}finally{E.preventDefault()}}))}ee.supportHtml||(pe.sanitizer=le=>(ee.isTrusted?le.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?le:"",pe.sanitize=!0,pe.silent=!0),pe.renderer=x;let ie=ee.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`),ee.supportThemeIcons&&(ie=(0,M.markdownEscapeEscapedIcons)(ie));let J=s.marked.parse(ie,pe);ee.supportThemeIcons&&(J=(0,w.renderLabelWithIcons)(J).map(te=>typeof te=="string"?te:te.outerHTML).join(""));const fe=new DOMParser().parseFromString(u(ee,J),"text/html");if(fe.body.querySelectorAll("img").forEach(le=>{const te=le.getAttribute("src");if(te){let T=te;try{ee.baseUri&&(T=F(b.URI.from(ee.baseUri),T))}catch{}le.src=Se(T,!0)}}),fe.body.querySelectorAll("a").forEach(le=>{const te=le.getAttribute("href");if(le.setAttribute("href",""),!te||/^data:|javascript:/i.test(te)||/^command:/i.test(te)&&!ee.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(te))le.replaceWith(...le.childNodes);else{let T=Se(te,!1);ee.baseUri&&(T=F(b.URI.from(ee.baseUri),te)),le.dataset.href=T}}),ae.innerHTML=u(ee,fe.body.innerHTML),ye.length>0&&Promise.all(ye).then(le=>{if(ce)return;const te=new Map(le),T=ae.querySelectorAll("div[data-code]");for(const E of T){const m=te.get(E.dataset.code??"");m&&v.reset(E,m)}Z.asyncRenderCallback?.()}),Z.asyncRenderCallback)for(const le of ae.getElementsByTagName("img")){const te=oe.add(v.addDisposableListener(le,"load",()=>{te.dispose(),Z.asyncRenderCallback()}))}return{element:ae,dispose:()=>{ce=!0,oe.dispose()}}}t.renderMarkdown=L;function N(ee){if(!ee)return"";const Z=ee.split(/[\s+|:|,|\{|\?]/,1);return Z.length?Z[0]:ee}function F(ee,Z){return/^\w[\w\d+.-]*:/.test(Z)?Z:ee.path.endsWith("/")?(0,r.resolvePath)(ee,Z).toString():(0,r.resolvePath)((0,r.dirname)(ee),Z).toString()}function u(ee,Z){const{config:pe,allowedSchemes:oe}=C(ee);i.addHook("uponSanitizeAttribute",(ae,de)=>{if(de.attrName==="style"||de.attrName==="class"){if(ae.tagName==="SPAN"){if(de.attrName==="style"){de.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(de.attrValue);return}else if(de.attrName==="class"){de.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(de.attrValue);return}}de.keepAttr=!1;return}});const ce=v.hookDomPurifyHrefAndSrcSanitizer(oe);try{return i.sanitize(Z,{...pe,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),ce.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function C(ee){const Z=[a.Schemas.http,a.Schemas.https,a.Schemas.mailto,a.Schemas.data,a.Schemas.file,a.Schemas.vscodeFileResource,a.Schemas.vscodeRemote,a.Schemas.vscodeRemoteResource];return ee.isTrusted&&Z.push(a.Schemas.command),{config:{ALLOWED_TAGS:[...v.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Z}}function p(ee){return typeof ee=="string"?ee:D(ee)}t.renderStringAsPlaintext=p;function D(ee){let Z=ee.value??"";Z.length>1e5&&(Z=`${Z.substr(0,1e5)}\u2026`);const pe=s.marked.parse(Z,{renderer:V.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,oe=>_.get(oe)??oe);return u({isTrusted:!1},pe).toString()}t.renderMarkdownAsPlaintext=D;const _=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),V=new n.Lazy(()=>{const ee=new s.marked.Renderer;return ee.code=Z=>Z,ee.blockquote=Z=>Z,ee.html=Z=>"",ee.heading=(Z,pe,oe)=>Z+`
`,ee.hr=()=>"",ee.list=(Z,pe)=>Z,ee.listitem=Z=>Z+`
`,ee.paragraph=Z=>Z+`
`,ee.table=(Z,pe)=>Z+pe+`
`,ee.tablerow=Z=>Z,ee.tablecell=(Z,pe)=>Z+" ",ee.strong=Z=>Z,ee.em=Z=>Z,ee.codespan=Z=>Z,ee.br=()=>`
`,ee.del=Z=>Z,ee.image=(Z,pe,oe)=>"",ee.text=Z=>Z,ee.link=(Z,pe,oe)=>oe,ee})}),define(me[123],be([1,0,4,8,26,60,33,2,6,99]),function(X,t,v,i,U,H,y,w,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function d(n,e){(0,f.isString)(e)?n.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=d;class M{constructor(e,s,l){this.c=e,this.d=s,this.f=l}async update(e,s,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let a;if(e===void 0||(0,f.isString)(e)||e instanceof HTMLElement)a=e;else if(!(0,f.isFunction)(e.markdown))a=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,g.localize)(0,null),s),this.b=new U.CancellationTokenSource;const c=this.b.token;if(a=await e.markdown(c),a===void 0&&(a=e.markdownNotSupportedFallback),this.isDisposed||c.isCancellationRequested)return}this.g(a,s,l)}g(e,s,l){const a=this.a;if(this.h(e)){const c={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!a,...l};this.a=this.c.showHover(c,s)}a?.dispose()}h(e){return e?(0,H.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(n,e,s,l){let a,c;const r=(N,F)=>{N&&(c?.dispose(),c=void 0),F&&(a?.dispose(),a=void 0),n.onDidHideHover?.()},h=(N,F,u)=>new i.TimeoutTimer(async()=>{(!c||c.isDisposed)&&(c=new M(n,u||e,N>0),await c.update(s,F,l))},N),b=()=>{if(a)return;const N=new w.DisposableStore,F=p=>r(!1,p.fromElement===e);N.add(v.addDisposableListener(e,v.EventType.MOUSE_LEAVE,F,!0));const u=()=>r(!0,!0);N.add(v.addDisposableListener(e,v.EventType.MOUSE_DOWN,u,!0));const C={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const p=D=>{C.x=D.x+10,D.target instanceof HTMLElement&&D.target.classList.contains("action-label")&&r(!0,!0)};N.add(v.addDisposableListener(e,v.EventType.MOUSE_MOVE,p,!0))}N.add(h(n.delay,!1,C)),a=N},A=v.addDisposableListener(e,v.EventType.MOUSE_OVER,b,!0);return{show:N=>{r(!1,!0),h(0,N)},hide:()=>{r(!0,!0)},update:async(N,F)=>{s=N,await c?.update(s,void 0,F)},dispose:()=>{A.dispose(),r(!0,!0)}}}t.setupCustomHover=o}),define(me[124],be([1,0,4,18,19,122,59,14,3,43,2,5,101,92]),function(X,t,v,i,U,H,y,w,f,g,d,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=v.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(c){const r=Object.create(null);return r.root=c,r.text=v.append(c,n(".option-text")),r.detail=v.append(c,n(".option-detail")),r.decoratorRight=v.append(c,n(".option-decorator-right")),r}renderElement(c,r,h){const b=h,A=c.text,L=c.detail,N=c.decoratorRight,F=c.isDisabled;b.text.textContent=A,b.detail.textContent=L||"",b.decoratorRight.innerText=N||"",F?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(c){}}class l extends d.Disposable{constructor(c,r,h,b,A){super(),this.k=[],this.y=0,this.D=!1,this.G=!1,this.H=!1,this.f=!1,this.g=A||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new f.Emitter,this.B(this.m),this.n=b,this.J(),this.I(h),this.l=r||0,c&&this.setOptions(c,r)}getHeight(){return 18}getTemplateId(){return e}I(c){this.r=c,this.s=v.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.F=v.append(this.s,n(".select-box-details-pane"));const r=v.append(this.s,n(".select-box-dropdown-container-width-control")),h=v.append(r,n(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",v.append(h,this.w),this.C=0,this.t=v.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(v.addDisposableListener(this.s,v.EventType.DRAG_START,b=>{v.EventHelper.stop(b,!0)}))}J(){this.B(v.addStandardDisposableListener(this.h,"change",r=>{this.l=r.target.selectedIndex,this.m.fire({index:r.target.selectedIndex,selected:r.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(v.addDisposableListener(this.h,v.EventType.CLICK,r=>{v.EventHelper.stop(r),this.f?this.P(!0):this.O()})),this.B(v.addDisposableListener(this.h,v.EventType.MOUSE_DOWN,r=>{v.EventHelper.stop(r)}));let c;this.B(v.addDisposableListener(this.h,"touchstart",r=>{c=this.f})),this.B(v.addDisposableListener(this.h,"touchend",r=>{v.EventHelper.stop(r),c?this.P(!0):this.O()})),this.B(v.addDisposableListener(this.h,v.EventType.KEY_DOWN,r=>{const h=new U.StandardKeyboardEvent(r);let b=!1;M.isMacintosh?(h.keyCode===18||h.keyCode===16||h.keyCode===10||h.keyCode===3)&&(b=!0):(h.keyCode===18&&h.altKey||h.keyCode===16&&h.altKey||h.keyCode===10||h.keyCode===3)&&(b=!0),b&&(this.O(),v.EventHelper.stop(r,!0))}))}get onDidSelect(){return this.m.event}setOptions(c,r){w.equals(this.k,c)||(this.k=c,this.h.options.length=0,this.D=!1,this.k.forEach((h,b)=>{this.h.add(this.N(h.text,b,h.isDisabled)),typeof h.description=="string"&&(this.D=!0)})),r!==void 0&&(this.select(r),this.y=this.l)}L(){this.u?.splice(0,this.u.length,this.k)}select(c){c>=0&&c<this.k.length?this.l=c:c>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(c){this.g.ariaLabel=c,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(c){this.h.tabIndex=c?0:-1}render(c){this.j=c,c.classList.add("select-container"),c.appendChild(this.h),this.applyStyles()}style(c){const r=[];this.n=c,this.n.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&!this.n.selectBorder.equals(this.n.selectBackground)?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=r.join(`
`),this.applyStyles()}applyStyles(){if(this.h){const c=this.n.selectBackground?this.n.selectBackground.toString():"",r=this.n.selectForeground?this.n.selectForeground.toString():"",h=this.n.selectBorder?this.n.selectBorder.toString():"";this.h.style.backgroundColor=c,this.h.style.color=r,this.h.style.borderColor=h}this.u&&this.M()}M(){if(this.u){const c=this.n.selectBackground?this.n.selectBackground.toString():"";this.u.style({});const r=this.n.selectListBackground?this.n.selectListBackground.toString():c;this.v.style.backgroundColor=r,this.F.style.backgroundColor=r;const h=this.n.focusBorder?this.n.focusBorder.toString():"";this.s.style.outlineColor=h,this.s.style.outlineOffset="-1px"}}N(c,r,h){const b=document.createElement("option");return b.value=c,b.text=c,b.disabled=!!h,b}O(){this.F.innerText="",!(!this.r||this.f)&&(this.W(this.s),this.L(),this.r.showContextView({getAnchor:()=>this.h,render:c=>this.Q(c,!0),layout:()=>{this.S()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.C},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.P(!1),this.r.showContextView({getAnchor:()=>this.h,render:c=>this.Q(c),layout:()=>this.S(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.C},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}P(c){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),c&&this.h.focus(),this.r.hideContextView())}Q(c,r){return c.appendChild(this.s),this.S(r),{dispose:()=>{try{c.removeChild(this.s)}catch{}}}}R(){let c=0;return this.k.forEach((r,h)=>{this.cb(h),this.F.offsetHeight>c&&(c=this.F.offsetHeight)}),c}S(c){if(this.G)return!1;if(this.u){this.s.classList.add("visible");const r=v.getDomNodePagePosition(this.h),h=getComputedStyle(this.h),b=parseFloat(h.getPropertyValue("--dropdown-padding-top"))+parseFloat(h.getPropertyValue("--dropdown-padding-bottom")),A=window.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),L=r.top-l.b,N=this.h.offsetWidth,F=this.U(this.w),u=Math.max(F,Math.round(N)).toString()+"px";this.s.style.width=u,this.u.getHTMLElement().style.height="",this.u.layout();let C=this.u.contentHeight;const p=this.D?this.R():0,D=C+b+p,_=Math.floor((A-b-p)/this.getHeight()),V=Math.floor((L-b-p)/this.getHeight());if(c)return r.top+r.height>window.innerHeight-22||r.top<l.b||_<1&&V<1?!1:(_<l.c&&V>_&&this.k.length>_?(this.C=1,this.s.removeChild(this.v),this.s.removeChild(this.F),this.s.appendChild(this.F),this.s.appendChild(this.v),this.F.classList.remove("border-top"),this.F.classList.add("border-bottom")):(this.C=0,this.s.removeChild(this.v),this.s.removeChild(this.F),this.s.appendChild(this.v),this.s.appendChild(this.F),this.F.classList.remove("border-bottom"),this.F.classList.add("border-top")),!0);if(r.top+r.height>window.innerHeight-22||r.top<l.b||this.C===0&&_<1||this.C===1&&V<1)return this.P(!0),!1;if(this.C===0){if(this.f&&_+V<1)return this.P(!0),!1;D>A&&(C=_*this.getHeight())}else D>L&&(C=V*this.getHeight());return this.u.layout(C),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.D?(this.u.getHTMLElement().style.height=C+b+"px",this.s.style.height=""):this.s.style.height=C+b+"px",this.cb(this.l),this.s.style.width=u,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}U(c){let r=0;if(c){let h=0,b=0;this.k.forEach((A,L)=>{const N=A.detail?A.detail.length:0,F=A.decoratorRight?A.decoratorRight.length:0,u=A.text.length+N+F;u>b&&(h=L,b=u)}),c.textContent=this.k[h].text+(this.k[h].decoratorRight?this.k[h].decoratorRight+" ":""),r=v.getTotalWidth(c)}return r}W(c){if(this.u)return;this.v=v.append(c,n(".select-box-dropdown-list-container")),this.p=new s,this.u=new y.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let A=b.text;return b.detail&&(A+=`. ${b.detail}`),b.decoratorRight&&(A+=`. ${b.decoratorRight}`),b.description&&(A+=`. ${b.description}`),A},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const r=this.B(new i.DomEmitter(this.v,"keydown")),h=f.Event.chain(r.event).filter(()=>this.u.length>0).map(b=>new U.StandardKeyboardEvent(b));this.B(h.filter(b=>b.keyCode===3).on(b=>this.eb(b),this)),this.B(h.filter(b=>b.keyCode===2).on(b=>this.eb(b),this)),this.B(h.filter(b=>b.keyCode===9).on(b=>this.db(b),this)),this.B(h.filter(b=>b.keyCode===16).on(b=>this.gb(b),this)),this.B(h.filter(b=>b.keyCode===18).on(b=>this.fb(b),this)),this.B(h.filter(b=>b.keyCode===12).on(this.ib,this)),this.B(h.filter(b=>b.keyCode===11).on(this.hb,this)),this.B(h.filter(b=>b.keyCode===14).on(this.jb,this)),this.B(h.filter(b=>b.keyCode===13).on(this.kb,this)),this.B(h.filter(b=>b.keyCode>=21&&b.keyCode<=56||b.keyCode>=80&&b.keyCode<=108).on(this.lb,this)),this.B(v.addDisposableListener(this.u.getHTMLElement(),v.EventType.POINTER_UP,b=>this.X(b))),this.B(this.u.onMouseOver(b=>typeof b.index<"u"&&this.u.setFocus([b.index]))),this.B(this.u.onDidChangeFocus(b=>this.bb(b))),this.B(v.addDisposableListener(this.s,v.EventType.FOCUS_OUT,b=>{!this.f||v.isAncestor(b.relatedTarget,this.s)||this.Y()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.M()}X(c){if(!this.u.length)return;v.EventHelper.stop(c);const r=c.target;if(!r||r.classList.contains("slider"))return;const h=r.closest(".monaco-list-row");if(!h)return;const b=Number(h.getAttribute("data-index")),A=h.classList.contains("option-disabled");b>=0&&b<this.k.length&&!A&&(this.l=b,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.P(!0))}Y(){this.H||(this.l!==this.y&&this.select(this.y),this.P(!1))}ab(c,r){const h=A=>{for(let L=0;L<A.childNodes.length;L++){const N=A.childNodes.item(L);(N.tagName&&N.tagName.toLowerCase())==="img"?A.removeChild(N):h(N)}},b=(0,H.renderMarkdown)({value:c,supportThemeIcons:!0},{actionHandler:r});return b.element.classList.add("select-box-description-markdown"),h(b.element),b.element}bb(c){!this.f||!this.D||this.cb(c.indexes[0])}cb(c){this.F.innerText="";const r=this.k[c],h=r?.description??"",b=r?.descriptionIsMarkdown??!1;if(h){if(b){const A=r.descriptionMarkdownActionHandler;this.F.appendChild(this.ab(h,A))}else this.F.innerText=h;this.F.style.display="block"}else this.F.style.display="none";this.G=!0,this.r.layout(),this.G=!1}db(c){v.EventHelper.stop(c),this.select(this.y),this.P(!0)}eb(c){v.EventHelper.stop(c),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.P(!0)}fb(c){if(this.l<this.k.length-1){v.EventHelper.stop(c,!0);const r=this.k[this.l+1].isDisabled;if(r&&this.k.length>this.l+2)this.l+=2;else{if(r)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}gb(c){this.l>0&&(v.EventHelper.stop(c,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}hb(c){v.EventHelper.stop(c),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}ib(c){v.EventHelper.stop(c),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}jb(c){v.EventHelper.stop(c),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}kb(c){v.EventHelper.stop(c),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}lb(c){const r=g.KeyCodeUtils.toString(c.keyCode);let h=-1;for(let b=0;b<this.k.length-1;b++)if(h=(b+this.l+1)%this.k.length,this.k[h].text.charAt(0).toUpperCase()===r&&!this.k[h].isDisabled){this.select(h),this.u.setFocus([h]),this.u.reveal(this.u.getFocus()[0]),v.EventHelper.stop(c);break}}dispose(){this.P(!1),super.dispose()}}t.SelectBoxList=l,l.a=32,l.b=2,l.c=3}),define(me[125],be([1,0,124,118,17,41,30,5,91]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:H.Color.fromHex("#3C3C3C"),selectForeground:H.Color.fromHex("#F0F0F0"),selectBorder:H.Color.fromHex("#3C3C3C")};class f extends U.Widget{constructor(d,M,o,n=(0,y.deepClone)(t.defaultStyles),e){super(),w.isMacintosh&&!e?.useCustomDrawn?this.a=new i.SelectBoxNative(d,M,n,e):this.a=new v.SelectBoxList(d,M,o,n,e),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(d,M){this.a.setOptions(d,M)}select(d){this.a.select(d)}setAriaLabel(d){this.a.setAriaLabel(d)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(d){this.a.setFocusable(d)}render(d){this.a.render(d)}style(d){this.a.style(d)}applyStyles(){this.a.applyStyles()}}t.SelectBox=f}),define(me[61],be([1,0,16,51,4,22,123,125,31,2,5,6,96,48]),function(X,t,v,i,U,H,y,w,f,g,d,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends g.Disposable{get action(){return this._action}constructor(a,c,r={}){super(),this.k=r,this._context=a||this,this._action=c,c instanceof f.Action&&this.B(c.onDidChange(h=>{!this.element||this.m(h)}))}m(a){a.enabled!==void 0&&this.t(),a.checked!==void 0&&this.updateChecked(),a.class!==void 0&&this.updateClass(),a.label!==void 0&&(this.updateLabel(),this.w()),a.tooltip!==void 0&&this.w()}get actionRunner(){return this.j||(this.j=this.B(new f.ActionRunner)),this.j}set actionRunner(a){this.j=a}isEnabled(){return this._action.enabled}setActionContext(a){this._context=a}render(a){const c=this.element=a;this.B(H.Gesture.addTarget(a));const r=this.k&&this.k.draggable;r&&(a.draggable=!0,v.isFirefox&&this.B((0,U.addDisposableListener)(a,U.EventType.DRAG_START,h=>h.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this.B((0,U.addDisposableListener)(c,H.EventType.Tap,h=>this.onClick(h,!0))),this.B((0,U.addDisposableListener)(c,U.EventType.MOUSE_DOWN,h=>{r||U.EventHelper.stop(h,!0),this._action.enabled&&h.button===0&&c.classList.add("active")})),d.isMacintosh&&this.B((0,U.addDisposableListener)(c,U.EventType.CONTEXT_MENU,h=>{h.button===0&&h.ctrlKey===!0&&this.onClick(h)})),this.B((0,U.addDisposableListener)(c,U.EventType.CLICK,h=>{U.EventHelper.stop(h,!0),this.k&&this.k.isMenu||this.onClick(h)})),this.B((0,U.addDisposableListener)(c,U.EventType.DBLCLICK,h=>{U.EventHelper.stop(h,!0)})),[U.EventType.MOUSE_UP,U.EventType.MOUSE_OUT].forEach(h=>{this.B((0,U.addDisposableListener)(c,h,b=>{U.EventHelper.stop(b),c.classList.remove("active")}))})}onClick(a,c=!1){U.EventHelper.stop(a,!0);const r=M.isUndefinedOrNull(this._context)?this.k?.useEventAsContext?a:{preserveFocus:c}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(a){this.element&&(this.element.tabIndex=a?0:-1)}get trapsArrowNavigation(){return!1}t(){}updateLabel(){}u(){return this.action.tooltip}w(){if(!this.element)return;const a=this.u()??"";this.C(),this.k.hoverDelegate?(this.element.title="",this.f?this.f.update(a):(this.f=(0,y.setupCustomHover)(this.k.hoverDelegate,this.element,a),this.q.add(this.f))):this.element.title=a}C(){if(this.element){const a=this.u()??"";this.element.setAttribute("aria-label",a)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(a,c,r){super(a,c,r),this.k=r,this.k.icon=r.icon!==void 0?r.icon:!1,this.k.label=r.label!==void 0?r.label:!0,this.D=""}render(a){super.render(a),this.element&&(this.g=(0,U.append)(this.element,(0,U.$)("a.action-label"))),this.g&&(this._action.id===f.Separator.ID?this.g.setAttribute("role","presentation"):this.k.isMenu?this.g.setAttribute("role","menuitem"):this.g.setAttribute("role","button")),this.k.label&&this.k.keybinding&&this.element&&((0,U.append)(this.element,(0,U.$)("span.keybinding")).textContent=this.k.keybinding),this.updateClass(),this.updateLabel(),this.w(),this.t(),this.updateChecked()}focus(){this.g&&(this.g.tabIndex=0,this.g.focus())}isFocused(){return!!this.g&&this.g?.tabIndex===0}blur(){this.g&&(this.g.tabIndex=-1)}setFocusable(a){this.g&&(this.g.tabIndex=a?0:-1)}updateLabel(){this.k.label&&this.g&&(this.g.textContent=this.action.label)}u(){let a=null;return this.action.tooltip?a=this.action.tooltip:!this.k.label&&this.action.label&&this.k.icon&&(a=this.action.label,this.k.keybinding&&(a=o.localize(0,null,a,this.k.keybinding))),a??void 0}updateClass(){this.D&&this.g&&this.g.classList.remove(...this.D.split(" ")),this.k.icon?(this.D=this.action.class,this.g&&(this.g.classList.add("codicon"),this.D&&this.g.classList.add(...this.D.split(" "))),this.t()):this.g?.classList.remove("codicon")}t(){this.action.enabled?(this.g&&(this.g.removeAttribute("aria-disabled"),this.g.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.g&&(this.g.setAttribute("aria-disabled","true"),this.g.classList.add("disabled")),this.element?.classList.add("disabled"))}C(){if(this.g){const a=this.u()??"";this.g.setAttribute("aria-label",a)}}updateChecked(){this.g&&(this.action.checked?this.g.classList.add("checked"):this.g.classList.remove("checked"))}}t.ActionViewItem=e;class s extends n{constructor(a,c,r,h,b,A){super(a,c),this.b=new w.SelectBox(r,h,b,void 0,A),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(a,c){this.b.setOptions(a,c)}select(a){this.b.select(a)}g(){this.B(this.b.onDidSelect(a=>this.n(a.selected,a.index)))}n(a,c){this.actionRunner.run(this._action,this.r(a,c))}r(a,c){return a}setFocusable(a){this.b.setFocusable(a)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(a){this.b.render(a)}}t.SelectActionViewItem=s}),define(me[62],be([1,0,4,19,61,31,3,2,6,48]),function(X,t,v,i,U,H,y,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var g;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(g=t.ActionsOrientation||(t.ActionsOrientation={}));class d extends w.Disposable{constructor(n,e={}){super(),this.f=this.B(new w.DisposableStore),this.m=this.B(new w.DisposableMap),this.s=!1,this.t=!0,this.v=this.B(new y.Emitter),this.onDidBlur=this.v.event,this.w=this.B(new y.Emitter({onWillAddFirstListener:()=>this.y=!0})),this.onDidCancel=this.w.event,this.y=!1,this.C=this.B(new y.Emitter),this.onDidRun=this.C.event,this.D=this.B(new y.Emitter),this.onWillRun=this.D.event,this.b=e,this.g=e.context??null,this.j=this.b.orientation??0,this.l={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.c=this.b.actionRunner:(this.c=new H.ActionRunner,this.f.add(this.c)),this.f.add(this.c.onDidRun(a=>this.C.fire(a))),this.f.add(this.c.onWillRun(a=>this.D.fire(a))),this.viewItems=[],this.p=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,l;switch(this.j){case 0:s=[15],l=[17];break;case 1:s=[16],l=[18],this.domNode.className+=" vertical";break}this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_DOWN,a=>{const c=new i.StandardKeyboardEvent(a);let r=!0;const h=typeof this.p=="number"?this.viewItems[this.p]:void 0;s&&(c.equals(s[0])||c.equals(s[1]))?r=this.M():l&&(c.equals(l[0])||c.equals(l[1]))?r=this.L():c.equals(9)&&this.y?this.w.fire():c.equals(14)?r=this.I():c.equals(13)?r=this.J():c.equals(2)&&h instanceof U.BaseActionViewItem&&h.trapsArrowNavigation?r=this.L():this.G(c)?this.l.keyDown?this.O(c):this.s=!0:r=!1,r&&(c.preventDefault(),c.stopPropagation())})),this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_UP,a=>{const c=new i.StandardKeyboardEvent(a);this.G(c)?(!this.l.keyDown&&this.s&&(this.s=!1,this.O(c)),c.preventDefault(),c.stopPropagation()):(c.equals(2)||c.equals(1026))&&this.H()})),this.r=this.B(v.trackFocus(this.domNode)),this.B(this.r.onDidBlur(()=>{(v.getActiveElement()===this.domNode||!v.isAncestor(v.getActiveElement(),this.domNode))&&(this.v.fire(),this.p=void 0,this.n=void 0,this.s=!1)})),this.B(this.r.onDidFocus(()=>this.H())),this.u=document.createElement("ul"),this.u.className="actions-container",this.u.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.u.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.u),n.appendChild(this.domNode)}F(){this.length()>=2?this.u.setAttribute("role",this.b.ariaRole||"toolbar"):this.u.setAttribute("role","presentation")}setAriaLabel(n){n?this.u.setAttribute("aria-label",n):this.u.removeAttribute("aria-label")}setFocusable(n){if(this.t=n,this.t){const e=this.viewItems.find(s=>s instanceof U.BaseActionViewItem&&s.isEnabled());e instanceof U.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof U.BaseActionViewItem&&e.setFocusable(!1)})}G(n){let e=!1;return this.l.keys.forEach(s=>{e=e||n.equals(s)}),e}H(){for(let n=0;n<this.u.children.length;n++){const e=this.u.children[n];if(v.isAncestor(v.getActiveElement(),e)){this.p=n;break}}}get context(){return this.g}set context(n){this.g=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this.c}set actionRunner(n){this.c=n,this.f.clear(),this.f.add(this.c.onDidRun(e=>this.C.fire(e))),this.f.add(this.c.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.u;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.u.childNodes.length;e++)if(this.u.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const s=Array.isArray(n)?n:[n];let l=f.isNumber(e.index)?e.index:null;s.forEach(a=>{const c=document.createElement("li");c.className="action-item",c.setAttribute("role","presentation");let r;this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(a)),r||(r=new U.ActionViewItem(this.context,a,{hoverDelegate:this.b.hoverDelegate,...e})),this.b.allowContextMenu||this.m.set(r,v.addDisposableListener(c,v.EventType.CONTEXT_MENU,h=>{v.EventHelper.stop(h,!0)})),r.actionRunner=this.c,r.setActionContext(this.context),r.render(c),this.t&&r instanceof U.BaseActionViewItem&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.u.children.length?(this.u.appendChild(c),this.viewItems.push(r)):(this.u.insertBefore(c,this.u.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.p=="number"&&this.focus(this.p),this.F()}getWidth(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.u.removeChild(this.u.childNodes[n]),this.m.deleteAndDispose(this.viewItems[n]),(0,w.dispose)(this.viewItems.splice(n,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,w.dispose)(this.viewItems),this.m.clearAndDisposeAll(),v.clearNode(this.u),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,s;if(n===void 0?e=!0:typeof n=="number"?s=n:typeof n=="boolean"&&(e=n),e&&typeof this.p>"u"){const l=this.viewItems.findIndex(a=>a.isEnabled());this.p=l===-1?void 0:l,this.N(void 0,void 0,!0)}else s!==void 0&&(this.p=s),this.N(void 0,void 0,!0)}I(){return this.p=this.length()-1,this.L(!0)}J(){return this.p=0,this.M(!0)}L(n){if(typeof this.p>"u")this.p=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(!n&&this.b.preventLoopNavigation&&this.p+1>=this.viewItems.length)return this.p=e,!1;this.p=(this.p+1)%this.viewItems.length,s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.Separator.ID));return this.N(),!0}M(n){if(typeof this.p>"u")this.p=0;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(this.p=this.p-1,this.p<0){if(!n&&this.b.preventLoopNavigation)return this.p=e,!1;this.p=this.viewItems.length-1}s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.Separator.ID));return this.N(!0),!0}N(n,e,s=!1){typeof this.p>"u"&&this.u.focus({preventScroll:e}),this.n!==void 0&&this.n!==this.p&&this.viewItems[this.n]?.blur();const l=this.p!==void 0&&this.viewItems[this.p];if(l){let a=!0;f.isFunction(l.focus)||(a=!1),this.b.focusOnlyEnabledItems&&f.isFunction(l.isEnabled)&&!l.isEnabled()&&(a=!1),l.action.id===H.Separator.ID&&(a=!1),a?(s||this.n!==this.p)&&(l.focus(n),this.n=this.p):(this.u.focus({preventScroll:e}),this.n=void 0)}}O(n){if(typeof this.p>"u")return;const e=this.viewItems[this.p];if(e instanceof U.BaseActionViewItem){const s=e._context===null||e._context===void 0?n:e._context;this.run(e._action,s)}}async run(n,e){await this.c.run(n,e)}dispose(){this.viewItems=(0,w.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=d;function M(o){if(!o.length)return o;let n=-1;for(let s=0;s<o.length;s++)if(o[s].id!==H.Separator.ID){n=s;break}if(n===-1)return[];o=o.slice(n);for(let s=o.length-1;s>=0&&o[s].id===H.Separator.ID;s--)o.splice(s,1);let e=!1;for(let s=o.length-1;s>=0;s--){const l=o[s].id===H.Separator.ID;l&&!e?o.splice(s,1):l?l&&(e=!1):e=!0}return o}t.prepareActions=M}),define(me[63],be([1,0,4,18,52,62,54,57,17,3,78,100,88]),function(X,t,v,i,U,H,y,w,f,g,d,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const o=v.$;var n;(function(l){l[l.INFO=1]="INFO",l[l.WARNING=2]="WARNING",l[l.ERROR=3]="ERROR"})(n=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class e extends f.Widget{constructor(a,c,r){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.J=this.B(new g.Emitter),this.onDidChange=this.J.event,this.L=this.B(new g.Emitter),this.onDidHeightChange=this.L.event,this.a=c,this.g=r,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=v.append(a,o(".monaco-inputbox.idle"));const h=this.g.flexibleHeight?"textarea":"input",b=v.append(this.element,o(".ibwrapper"));if(this.b=v.append(b,o(h+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.F(this.b,()=>this.element.classList.add("synthetic-focus")),this.D(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=v.append(b,o("div.mirror")),this.t.innerText="\xA0",this.I=new w.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),v.append(a,this.I.getDomNode()),this.B(this.I),this.B(this.I.onScroll(N=>this.b.scrollTop=N.scrollTop));const A=this.B(new i.DomEmitter(document,"selectionchange")),L=g.Event.filter(A.event,()=>document.getSelection()?.anchorNode===b);this.B(L(this.O,this)),this.B(this.onDidHeightChange(this.O,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.C(this.b,()=>this.S()),this.D(this.b,()=>this.M()),this.F(this.b,()=>this.N()),this.B(this.H(this.b)),setTimeout(()=>this.U(),0),this.g.actions&&(this.c=this.B(new H.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.W()}M(){this.R(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}N(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(a){this.i=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.l=a,this.b.title=a}setAriaLabel(a){this.n=a,a?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.S())}get height(){return typeof this.v=="number"?this.v:v.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.R()}setEnabled(a){a?this.enable():this.disable()}get width(){return v.getTotalWidth(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let c=0;if(this.t){const r=parseFloat(this.t.style.paddingLeft||"")||0,h=parseFloat(this.t.style.paddingRight||"")||0;c=r+h}this.b.style.width=a-c+"px"}else this.b.style.width=a+"px";this.t&&(this.t.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.t&&(this.t.style.paddingRight=a+"px")}O(){if(typeof this.w!="number"||typeof this.v!="number"||!this.I)return;const a=this.w,c=this.v,r=this.b.scrollTop;this.I.setScrollDimensions({scrollHeight:a,height:c}),this.I.setScrollPosition({scrollTop:r})}showMessage(a,c){this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.P(a.type));const r=this.stylesForType(this.h.type);this.element.style.border=r.border?`1px solid ${r.border}`:"",this.h.content&&(this.hasFocus()||c)&&this.Q()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.R(),this.W()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let a=null;return this.r&&(a=this.r(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const c=this.g.inputBoxStyles;switch(a){case 1:return{border:c.inputValidationInfoBorder,background:c.inputValidationInfoBackground,foreground:c.inputValidationInfoForeground};case 2:return{border:c.inputValidationWarningBorder,background:c.inputValidationWarningBackground,foreground:c.inputValidationWarningForeground};default:return{border:c.inputValidationErrorBorder,background:c.inputValidationErrorBackground,foreground:c.inputValidationErrorForeground}}}P(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}Q(){if(!this.a||!this.h)return;let a;const c=()=>a.style.width=v.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:h=>{if(!this.h)return null;a=v.append(h,o(".monaco-inputbox-container")),c();const b={inline:!0,className:"monaco-inputbox-message"},A=this.h.formatContent?(0,U.renderFormattedText)(this.h.content,b):(0,U.renderText)(this.h.content,b);A.classList.add(this.P(this.h.type));const L=this.stylesForType(this.h.type);return A.style.backgroundColor=L.background?L.background.toString():"",A.style.color=L.foreground?L.foreground.toString():"",A.style.border=L.border?`1px solid ${L.border}`:"",v.append(a,A),null},onHide:()=>{this.s="closed"},layout:c});let r;this.h.type===3?r=M.localize(0,null,this.h.content):this.h.type===2?r=M.localize(1,null,this.h.content):r=M.localize(2,null,this.h.content),y.alert(r),this.s="open"}R(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}S(){this.J.fire(this.value),this.validate(),this.U(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}U(){if(!this.t)return;const a=this.value,r=a.charCodeAt(a.length-1)===10?" ":"";(a+r).replace(/\u000c/g,"")?this.t.textContent=a+r:this.t.innerText="\xA0",this.layout()}W(){const a=this.g.inputBoxStyles,c=a.inputBackground??"",r=a.inputForeground??"",h=a.inputBorder??"";this.element.style.backgroundColor=c,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,h&&(this.element.style.border="1px solid "+h)}layout(){if(!this.t)return;const a=this.w;this.w=v.getTotalHeight(this.t),a!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.L.fire(this.w))}insertAtCursor(a){const c=this.inputElement,r=c.selectionStart,h=c.selectionEnd,b=c.value;r!==null&&h!==null&&(this.value=b.substr(0,r)+a+b.substr(h),c.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.R(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=e;class s extends e{constructor(a,c,r){const h=M.localize(3,null),b=` or \u21C5 ${h}`,A=` (\u21C5 ${h})`;super(a,c,r),this.ab=this.B(new g.Emitter),this.onDidFocus=this.ab.event,this.bb=this.B(new g.Emitter),this.onDidBlur=this.bb.event,this.X=new d.HistoryNavigator(r.history,100);const L=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.i.endsWith(b)&&!this.i.endsWith(A)&&this.X.getHistory().length){const N=this.i.endsWith(")")?b:A,F=this.i+N;r.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=F:this.setPlaceHolder(F)}};this.Y=new MutationObserver((N,F)=>{N.forEach(u=>{u.target.textContent||L()})}),this.Y.observe(this.b,{attributeFilter:["class"]}),this.F(this.b,()=>L()),this.D(this.b,()=>{const N=F=>{if(this.i.endsWith(F)){const u=this.i.slice(0,this.i.length-F.length);return r.showPlaceholderOnFocus?this.i=u:this.setPlaceHolder(u),!0}else return!1};N(A)||N(b)})}dispose(){super.dispose(),this.Y&&(this.Y.disconnect(),this.Y=void 0)}addToHistory(){this.value&&this.value!==this.eb()&&this.X.add(this.value)}getHistory(){return this.X.getHistory()}showNextValue(){this.X.has(this.value)||this.addToHistory();let a=this.gb();a&&(a=a===this.value?this.gb():a),a&&(this.value=a,y.status(this.value))}showPreviousValue(){this.X.has(this.value)||this.addToHistory();let a=this.fb();a&&(a=a===this.value?this.fb():a),a&&(this.value=a,y.status(this.value))}clearHistory(){this.X.clear()}M(){super.M(),this.bb.fire()}N(){super.N(),this.ab.fire()}eb(){let a=this.X.current();return a||(a=this.X.last(),this.X.next()),a}fb(){return this.X.previous()||this.X.first()}gb(){return this.X.next()||this.X.last()}}t.HistoryInputBox=s}),define(me[64],be([1,0,61,17,12,3,93]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends v.BaseActionViewItem{constructor(d,M,o){super(d,M,o),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.k.keybinding?`${this._action.label} (${this.k.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:o.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:o.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:o.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(d){this.element=d,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}updateChecked(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(d){this.a.domNode.tabIndex=d?0:-1}}t.ToggleActionViewItem=y;class w extends i.Widget{constructor(d){super(),this.a=this.B(new H.Emitter),this.onChange=this.a.event,this.b=this.B(new H.Emitter),this.onKeyDown=this.b.event,this.c=d,this.s=this.c.isChecked;const M=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,M.push(...U.CSSIcon.asClassNameArray(this.g))),this.c.actionClassName&&M.push(...this.c.actionClassName.split(" ")),this.s&&M.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...M),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,o=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),o.preventDefault())}),this.B(this.H(this.domNode)),this.p(this.domNode,o=>{if(o.keyCode===10||o.keyCode===3){this.checked=!this.s,this.a.fire(!0),o.preventDefault(),o.stopPropagation();return}this.b.fire(o)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(d){this.s=d,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(d){this.g&&this.domNode.classList.remove(...U.CSSIcon.asClassNameArray(this.g)),this.g=d,this.g&&this.domNode.classList.add(...U.CSSIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(d){this.domNode.title=d,this.domNode.setAttribute("aria-label",d)}}t.Toggle=w;class f extends i.Widget{constructor(d,M,o){super(),this.c=d,this.g=M,this.a=new w({title:this.c,isChecked:this.g,icon:U.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=o,this.h()}get checked(){return this.a.checked}set checked(d){this.a.checked=d}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=f}),define(me[126],be([1,0,64,12,98]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const H=U.localize(0,null),y=U.localize(1,null),w=U.localize(2,null);class f extends v.Toggle{constructor(o){super({icon:i.Codicon.caseSensitive,title:H+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=f;class g extends v.Toggle{constructor(o){super({icon:i.Codicon.wholeWord,title:y+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=g;class d extends v.Toggle{constructor(o){super({icon:i.Codicon.regex,title:w+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=d}),define(me[127],be([1,0,4,126,63,17,3,97,2,87]),function(X,t,v,i,U,H,y,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const g=w.localize(0,null);class d extends H.Widget{constructor(o,n,e){super(),this.i=!0,this.l=!1,this.n=new f.DisposableStore,this.I=[],this.J=this.B(new y.Emitter),this.onDidOptionChange=this.J.event,this.L=this.B(new y.Emitter),this.onKeyDown=this.L.event,this.M=this.B(new y.Emitter),this.onMouseDown=this.M.event,this.N=this.B(new y.Emitter),this.onInput=this.N.event,this.O=this.B(new y.Emitter),this.onKeyUp=this.O.event,this.P=this.B(new y.Emitter),this.onCaseSensitiveKeyDown=this.P.event,this.Q=this.B(new y.Emitter),this.onRegexKeyDown=this.Q.event,this.R=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||g,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",a=e.appendRegexLabel||"",c=e.history||[],r=!!e.flexibleHeight,h=!!e.flexibleWidth,b=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new U.HistoryInputBox(this.domNode,n,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:c,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:h,flexibleMaxHeight:b,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new i.RegexToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(L=>{this.J.fire(L),!L&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(L=>{this.Q.fire(L)})),this.w=this.B(new i.WholeWordsToggle({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(L=>{this.J.fire(L),!L&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new i.CaseSensitiveToggle({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(L=>{this.J.fire(L),!L&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(L=>{this.P.fire(L)}));const A=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,L=>{if(L.equals(15)||L.equals(17)||L.equals(9)){const N=A.indexOf(document.activeElement);if(N>=0){let F=-1;L.equals(17)?F=(N+1)%A.length:L.equals(15)&&(N===0?F=A.length-1:F=N-1),L.equals(9)?(A[N].blur(),this.inputBox.focus()):F>=0&&A[F].focus(),v.EventHelper.stop(L,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"block":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),o?.appendChild(this.domNode),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionstart",A=>{this.l=!0})),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionend",A=>{this.l=!1,this.N.fire()})),this.p(this.inputBox.inputElement,A=>this.L.fire(A)),this.u(this.inputBox.inputElement,A=>this.O.fire(A)),this.C(this.inputBox.inputElement,A=>this.N.fire()),this.j(this.inputBox.inputElement,A=>this.M.fire(A))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const o of this.I)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const o of this.I)o.disable()}setFocusInputOnOptionClick(o){this.i=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const n of this.I)n.domNode.remove();this.I=[],this.n.dispose(),this.n=new f.DisposableStore;for(const n of o??[])this.n.add(n),this.s.appendChild(n.domNode),this.n.add(n.onChange(e=>{this.J.fire(e),!e&&this.i&&this.inputBox.focus()})),this.I.push(n);this.I.length>0&&(this.s.style.display="block"),this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.I.reduce((n,e)=>n+e.width(),0)}clear(){this.S(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(o){this.y&&(this.y.checked=o)}getWholeWords(){return this.w?.checked??!1}setWholeWords(o){this.w&&(this.w.checked=o)}getRegex(){return this.v?.checked??!1}setRegex(o){this.v&&(this.v.checked=o,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.R),this.R=1-this.R,this.domNode.classList.add("highlight-"+this.R)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}S(){this.inputBox.hideMessage()}}t.FindInput=d,d.OPTION_CHANGE="optionChange"}),define(me[128],be([1,0,4,18,19,62,127,63,58,59,64,55,23,31,14,8,12,70,3,32,2,46,6,102,94]),function(X,t,v,i,U,H,y,w,f,g,d,M,o,n,e,s,l,a,c,r,h,b,A,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class N extends f.ElementsDragAndDropData{set context(T){this.c.context=T}get context(){return this.c.context}constructor(T){super(T.elements.map(E=>E.element)),this.c=T}}function F(te){return te instanceof f.ElementsDragAndDropData?new N(te):te}class u{constructor(T,E){this.c=T,this.d=E,this.b=h.Disposable.None}getDragURI(T){return this.d.getDragURI(T.element)}getDragLabel(T,E){if(this.d.getDragLabel)return this.d.getDragLabel(T.map(m=>m.element),E)}onDragStart(T,E){this.d.onDragStart?.(F(T),E)}onDragOver(T,E,m,B,z=!0){const $=this.d.onDragOver(F(T),E&&E.element,m,B),G=this.a!==E;if(G&&(this.b.dispose(),this.a=E),typeof E>"u")return $;if(G&&typeof $!="boolean"&&$.autoExpand&&(this.b=(0,s.disposableTimeout)(()=>{const I=this.c(),P=I.getNodeLocation(E);I.isCollapsed(P)&&I.setCollapsed(P,!1),this.a=void 0},500)),typeof $=="boolean"||!$.accept||typeof $.bubble>"u"||$.feedback){if(!z){const I=typeof $=="boolean"?$:$.accept,P=typeof $=="boolean"?void 0:$.effect;return{accept:I,effect:P,feedback:[m]}}return $}if($.bubble===1){const I=this.c(),P=I.getNodeLocation(E),R=I.getParentNodeLocation(P),j=I.getNode(R),Q=R&&I.getListIndex(R);return this.onDragOver(T,j,Q,B,!1)}const k=this.c(),O=k.getNodeLocation(E),W=k.getListIndex(O),S=k.getListRenderCount(O);return{...$,feedback:(0,e.range)(W,W+S)}}drop(T,E,m,B){this.b.dispose(),this.a=void 0,this.d.drop(F(T),E&&E.element,m,B)}onDragEnd(T){this.d.onDragEnd?.(T)}}function C(te,T){return T&&{...T,identityProvider:T.identityProvider&&{getId(E){return T.identityProvider.getId(E.element)}},dnd:T.dnd&&new u(te,T.dnd),multipleSelectionController:T.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return T.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return T.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:T.accessibilityProvider&&{...T.accessibilityProvider,getSetSize(E){const m=te(),B=m.getNodeLocation(E),z=m.getParentNodeLocation(B);return m.getNode(z).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:T.accessibilityProvider&&T.accessibilityProvider.isChecked?E=>T.accessibilityProvider.isChecked(E.element):void 0,getRole:T.accessibilityProvider&&T.accessibilityProvider.getRole?E=>T.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return T.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return T.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:T.accessibilityProvider&&T.accessibilityProvider.getWidgetRole?()=>T.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:T.accessibilityProvider&&T.accessibilityProvider.getAriaLevel?E=>T.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:T.accessibilityProvider.getActiveDescendantId&&(E=>T.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:T.keyboardNavigationLabelProvider&&{...T.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return T.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class p{constructor(T){this.a=T}getHeight(T){return this.a.getHeight(T.element)}getTemplateId(T){return this.a.getTemplateId(T.element)}hasDynamicHeight(T){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(T.element)}setDynamicHeight(T,E){this.a.setDynamicHeight?.(T.element,E)}}t.ComposedTreeDelegate=p;class D{static lift(T){return T instanceof D?T:new D(T)}static empty(T=0){return new D({focus:[],selection:[],expanded:Object.create(null),scrollTop:T})}constructor(T){if(this.focus=new Set(T.focus),this.selection=new Set(T.selection),T.expanded instanceof Array){this.expanded=Object.create(null);for(const E of T.expanded)this.expanded[E]=1}else this.expanded=T.expanded;this.expanded=T.expanded,this.scrollTop=T.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=D;var _;(function(te){te.None="none",te.OnHover="onHover",te.Always="always"})(_=t.RenderIndentGuides||(t.RenderIndentGuides={}));class V{get elements(){return this.b}constructor(T,E=[]){this.b=E,this.a=new h.DisposableStore,this.onDidChange=c.Event.forEach(T,m=>this.b=m,this.a)}dispose(){this.a.dispose()}}class ee{constructor(T,E,m,B,z,$={}){this.o=T,this.p=E,this.q=B,this.s=z,this.b=new Map,this.c=new Map,this.d=ee.a,this.f=!1,this.g=!1,this.j=new Set,this.k=h.Disposable.None,this.m=new h.DisposableStore,this.templateId=T.templateId,this.updateOptions($),c.Event.map(m,G=>G.node)(this.u,this,this.m),T.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(T={}){if(typeof T.indent<"u"){const E=(0,b.clamp)(T.indent,0,40);if(E!==this.d){this.d=E;for(const[m,B]of this.c)this.v(m,B)}}if(typeof T.renderIndentGuides<"u"){const E=T.renderIndentGuides!==_.None;if(E!==this.g&&(this.g=E,this.k.dispose(),E)){const m=new h.DisposableStore;this.q.onDidChange(this.w,this,m),this.k=m,this.w(this.q.elements)}}typeof T.hideTwistiesOfChildlessElements<"u"&&(this.f=T.hideTwistiesOfChildlessElements)}renderTemplate(T){const E=(0,v.append)(T,(0,v.$)(".monaco-tl-row")),m=(0,v.append)(E,(0,v.$)(".monaco-tl-indent")),B=(0,v.append)(E,(0,v.$)(".monaco-tl-twistie")),z=(0,v.append)(E,(0,v.$)(".monaco-tl-contents")),$=this.o.renderTemplate(z);return{container:T,indent:m,twistie:B,indentGuidesDisposable:h.Disposable.None,templateData:$}}renderElement(T,E,m,B){this.c.set(T,m),this.b.set(T.element,T),this.v(T,m),this.o.renderElement(T,E,m.templateData,B)}disposeElement(T,E,m,B){m.indentGuidesDisposable.dispose(),this.o.disposeElement?.(T,E,m.templateData,B),typeof B=="number"&&(this.c.delete(T),this.b.delete(T.element))}disposeTemplate(T){this.o.disposeTemplate(T.templateData)}t(T){const E=this.b.get(T);!E||this.u(E)}u(T){const E=this.c.get(T);!E||(this.w(this.q.elements),this.v(T,E))}v(T,E){const m=ee.a+(T.depth-1)*this.d;E.twistie.style.paddingLeft=`${m}px`,E.indent.style.width=`${m+this.d-16}px`,T.collapsible?E.container.setAttribute("aria-expanded",String(!T.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...l.Codicon.treeItemExpanded.classNamesArray);let B=!1;if(this.o.renderTwistie&&(B=this.o.renderTwistie(T.element,E.twistie)),T.collapsible&&(!this.f||T.visibleChildrenCount>0)?(B||E.twistie.classList.add(...l.Codicon.treeItemExpanded.classNamesArray),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",T.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),(0,v.clearNode)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const z=new h.DisposableStore,$=this.p();for(;;){const G=$.getNodeLocation(T),k=$.getParentNodeLocation(G);if(!k)break;const O=$.getNode(k),W=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(O)&&W.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(W):E.indent.insertBefore(W,E.indent.firstElementChild),this.s.add(O,W),z.add((0,h.toDisposable)(()=>this.s.delete(O,W))),T=O}E.indentGuidesDisposable=z}w(T){if(!this.g)return;const E=new Set,m=this.p();T.forEach(B=>{const z=m.getNodeLocation(B);try{const $=m.getParentNodeLocation(z);B.collapsible&&B.children.length>0&&!B.collapsed?E.add(B):$&&E.add(m.getNode($))}catch{}}),this.j.forEach(B=>{E.has(B)||this.s.forEach(B,z=>z.classList.remove("active"))}),E.forEach(B=>{this.j.has(B)||this.s.forEach(B,z=>z.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,h.dispose)(this.m)}}ee.a=8;class Z{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(T){this.c=T,this.d=T.toLowerCase()}constructor(T,E,m){this.g=T,this.j=E,this.k=m,this.a=0,this.b=0,this.c="",this.d="",this.f=new h.DisposableStore,T.onWillRefilter(this.m,this,this.f)}filter(T,E){let m=1;if(this.k){const $=this.k.filter(T,E);if(typeof $=="boolean"?m=$?1:0:(0,M.isFilterResult)($)?m=(0,M.getVisibleState)($.visibility):m=$,m===0)return!1}if(this.a++,!this.c)return this.b++,{data:r.FuzzyScore.Default,visibility:m};const B=this.j.getKeyboardNavigationLabel(T),z=Array.isArray(B)?B:[B];for(const $ of z){const G=$&&$.toString();if(typeof G>"u")return{data:r.FuzzyScore.Default,visibility:m};const k=(0,r.fuzzyScore)(this.c,this.d,0,G,G.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,z.length===1?{data:k,visibility:m}:{data:{label:G,score:k},visibility:m}}return this.g.findMode===ce.Filter?2:{data:r.FuzzyScore.Default,visibility:m}}m(){this.a=0,this.b=0}dispose(){(0,h.dispose)(this.f)}}class pe extends d.Toggle{constructor(T){super({icon:l.Codicon.listFilter,title:(0,L.localize)(0,null),isChecked:T.isChecked??!1,inputActiveOptionBorder:T.inputActiveOptionBorder,inputActiveOptionForeground:T.inputActiveOptionForeground,inputActiveOptionBackground:T.inputActiveOptionBackground})}}t.ModeToggle=pe;const oe={inputBoxStyles:w.unthemedInboxStyles,toggleStyles:d.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ce;(function(te){te[te.Highlight=0]="Highlight",te[te.Filter=1]="Filter"})(ce=t.TreeFindMode||(t.TreeFindMode={}));class ae extends h.Disposable{set mode(T){this.b.checked=T===ce.Filter,this.c.inputBox.setPlaceHolder(T===ce.Filter?(0,L.localize)(1,null):(0,L.localize)(2,null))}get value(){return this.c.inputBox.value}set value(T){this.c.inputBox.value=T}constructor(T,E,m,B,z){super(),this.m=E,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.g=0,this.j=0,this.k=0,this._onDidDisable=new c.Emitter,this.onDidDisable=this._onDidDisable.event,T.appendChild(this.a.root),this.B((0,h.toDisposable)(()=>T.removeChild(this.a.root)));const $=z?.styles??oe;$.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=$.listFilterWidgetBackground),$.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${$.listFilterWidgetShadow}`),this.b=this.B(new pe({...$.toggleStyles,isChecked:B===ce.Filter})),this.onDidChangeMode=c.Event.map(this.b.onChange,()=>this.b.checked?ce.Filter:ce.Highlight,this.q),this.c=this.B(new y.FindInput(this.a.findInput,m,{label:(0,L.localize)(3,null),additionalToggles:[this.b],showCommonFindToggles:!1,inputBoxStyles:$.inputBoxStyles,toggleStyles:$.toggleStyles})),this.f=this.B(new H.ActionBar(this.a.actionbar)),this.mode=B;const G=this.B(new i.DomEmitter(this.c.inputBox.inputElement,"keydown")),k=this.B(c.Event.chain(G.event)).map(I=>new U.StandardKeyboardEvent(I)).event;this.B(k(I=>{switch(I.keyCode){case 18:I.preventDefault(),I.stopPropagation(),this.m.domFocus();return}}));const O=this.B(new n.Action("close",(0,L.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.f.push(O,{icon:!0,label:!1});const W=this.B(new i.DomEmitter(this.a.grab,"mousedown"));this.B(W.event(I=>{const P=new h.DisposableStore,R=P.add(new i.DomEmitter(window,"mousemove")),j=P.add(new i.DomEmitter(window,"mouseup")),Q=this.j,re=I.pageX,ue=this.k,De=I.pageY;this.a.grab.classList.add("grabbing");const Ee=this.a.root.style.transition;this.a.root.style.transition="unset";const Ie=ke=>{const ve=ke.pageX-re;this.j=Q-ve;const Pe=ke.pageY-De;this.k=ue+Pe,this.layout()};P.add(R.event(Ie)),P.add(j.event(ke=>{Ie(ke),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ee,P.dispose()}))}));const S=this.B(c.Event.chain(this.B(new i.DomEmitter(this.a.grab,"keydown")).event)).map(I=>new U.StandardKeyboardEvent(I)).event;this.B(S(I=>{let P,R;if(I.keyCode===15?P=Number.POSITIVE_INFINITY:I.keyCode===17?P=0:I.keyCode===10&&(P=this.j===0?Number.POSITIVE_INFINITY:0),I.keyCode===16?R=0:I.keyCode===18&&(R=Number.POSITIVE_INFINITY),P!==void 0&&(I.preventDefault(),I.stopPropagation(),this.j=P,this.layout()),R!==void 0){I.preventDefault(),I.stopPropagation(),this.k=R;const j=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=j},0)}})),this.onDidChangeValue=this.c.onDidChange}focus(){this.c.focus()}select(){this.c.select()}layout(T=this.g){this.g=T,this.j=(0,b.clamp)(this.j,0,Math.max(0,T-212)),this.a.root.style.right=`${this.j}px`,this.k=(0,b.clamp)(this.k,0,24),this.a.root.style.top=`${this.k}px`}showMessage(T){this.c.showMessage(T)}clearMessage(){this.c.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class de{get pattern(){return this.a}get mode(){return this.c}set mode(T){T!==this.c&&(this.c=T,this.d&&(this.d.mode=this.c),this.p.refilter(),this.x(),this.g.fire(T))}constructor(T,E,m,B,z,$={}){this.p=T,this.q=m,this.s=B,this.t=z,this.u=$,this.a="",this.b="",this.f=0,this.g=new c.Emitter,this.onDidChangeMode=this.g.event,this.j=new c.Emitter,this.onDidChangePattern=this.j.event,this.k=new c.Emitter,this.onDidChangeOpenState=this.k.event,this.m=new h.DisposableStore,this.o=new h.DisposableStore,this.c=T.options.defaultFindMode??ce.Highlight,E.onDidSplice(this.w,this,this.o)}open(){if(this.d){this.d.focus(),this.d.select();return}this.mode=this.p.options.defaultFindMode??ce.Highlight,this.d=new ae(this.q.getHTMLElement(),this.p,this.t,this.mode,this.u),this.m.add(this.d),this.d.onDidChangeValue(this.v,this,this.m),this.d.onDidChangeMode(T=>this.mode=T,void 0,this.m),this.d.onDidDisable(this.close,this,this.m),this.d.layout(this.f),this.d.focus(),this.d.value=this.b,this.d.select(),this.k.fire(!0)}close(){!this.d||(this.d=void 0,this.m.dispose(),this.m=new h.DisposableStore,this.b=this.pattern,this.v(""),this.p.domFocus(),this.k.fire(!1))}v(T){this.a=T,this.j.fire(T),this.s.pattern=T,this.p.refilter(),T&&this.p.focusNext(0,!0,void 0,m=>!r.FuzzyScore.isDefault(m.filterData));const E=this.p.getFocus();if(E.length>0){const m=E[0];this.p.getRelativeTop(m)===null&&this.p.reveal(m,.5)}this.x()}w(){!this.d||this.pattern.length===0||(this.p.refilter(),this.x())}x(){const T=this.s.totalCount>0&&this.s.matchCount===0;this.pattern&&T?this.p.options.showNotFoundMessage??!0?this.d?.showMessage({type:2,content:(0,L.localize)(5,null)}):this.d?.showMessage({type:2}):this.d?.clearMessage()}shouldAllowFocus(T){return!this.d||!this.pattern||this.c===ce.Filter||this.s.totalCount>0&&this.s.matchCount<=1?!0:!r.FuzzyScore.isDefault(T.filterData)}layout(T){this.f=T,this.d?.layout(T)}dispose(){this.j.dispose(),this.m.dispose(),this.o.dispose()}}function Se(te){let T=o.TreeMouseEventTarget.Unknown;return(0,v.hasParentWithClass)(te.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?T=o.TreeMouseEventTarget.Twistie:(0,v.hasParentWithClass)(te.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?T=o.TreeMouseEventTarget.Element:(0,v.hasParentWithClass)(te.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(T=o.TreeMouseEventTarget.Filter),{browserEvent:te.browserEvent,element:te.element?te.element.element:null,target:T}}function x(te){return{element:te.element?te.element.element:null,browserEvent:te.browserEvent,anchor:te.anchor}}function ye(te,T){T(te),te.children.forEach(E=>ye(E,T))}class ie{get f(){return this.d||(this.d=this.m()),this.d}constructor(T,E){this.g=T,this.j=E,this.a=[],this.c=new c.Emitter,this.onDidChange=this.c.event}set(T,E){!E?.__forceEvent&&(0,e.equals)(this.a,T)||this.k(T,!1,E)}k(T,E,m){if(this.a=[...T],this.b=void 0,this.d=void 0,!E){const B=this;this.c.fire({get elements(){return B.get()},browserEvent:m})}}get(){return this.b||(this.b=this.a.map(T=>T.element)),[...this.b]}getNodes(){return this.a}has(T){return this.f.has(T)}onDidModelSplice({insertedNodes:T,deletedNodes:E}){if(!this.j){const k=this.m(),O=W=>k.delete(W);E.forEach(W=>ye(W,O)),this.set([...k.values()]);return}const m=new Set,B=k=>m.add(this.j.getId(k.element).toString());E.forEach(k=>ye(k,B));const z=new Map,$=k=>z.set(this.j.getId(k.element).toString(),k);T.forEach(k=>ye(k,$));const G=[];for(const k of this.a){const O=this.j.getId(k.element).toString();if(!m.has(O))G.push(k);else{const S=z.get(O);S&&G.push(S)}}if(this.a.length>0&&G.length===0){const k=this.g();k&&G.push(k)}this.k(G,!0)}m(){const T=new Set;for(const E of this.a)T.add(E);return T}}class J extends g.MouseController{constructor(T,E){super(T),this.A=E}u(T){if((0,g.isButton)(T.browserEvent.target)||(0,g.isInputElement)(T.browserEvent.target)||(0,g.isMonacoEditor)(T.browserEvent.target))return;const E=T.element;if(!E)return super.u(T);if(this.p(T)||this.o(T))return super.u(T);const m=T.browserEvent.target,B=m.classList.contains("monaco-tl-twistie")||m.classList.contains("monaco-icon-label")&&m.classList.contains("folder-icon")&&T.browserEvent.offsetX<16;let z=!1;if(typeof this.A.expandOnlyOnTwistieClick=="function"?z=this.A.expandOnlyOnTwistieClick(E.element):z=!!this.A.expandOnlyOnTwistieClick,z&&!B&&T.browserEvent.detail!==2)return super.u(T);if(!this.A.expandOnDoubleClick&&T.browserEvent.detail===2)return super.u(T);if(E.collapsible){const $=this.A.getNodeLocation(E),G=T.browserEvent.altKey;if(this.A.setFocus([$]),this.A.toggleCollapsed($,G),z&&B)return}super.u(T)}v(T){T.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.A.expandOnDoubleClick||super.v(T)}}class he extends g.List{constructor(T,E,m,B,z,$,G,k){super(T,E,m,B,k),this.p=z,this.s=$,this.M=G}F(T){return new J(this,T.tree)}splice(T,E,m=[]){if(super.splice(T,E,m),m.length===0)return;const B=[],z=[];let $;m.forEach((G,k)=>{this.p.has(G)&&B.push(T+k),this.s.has(G)&&z.push(T+k),this.M.has(G)&&($=T+k)}),B.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...B])),z.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...z])),typeof $=="number"&&super.setAnchor($)}setFocus(T,E,m=!1){super.setFocus(T,E),m||this.p.set(T.map(B=>this.element(B)),E)}setSelection(T,E,m=!1){super.setSelection(T,E),m||this.s.set(T.map(B=>this.element(B)),E)}setAnchor(T,E=!1){super.setAnchor(T),E||(typeof T>"u"?this.M.set([]):this.M.set([this.element(T)]))}}class fe{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return c.Event.map(this.j.onMouseClick,Se)}get onMouseDblClick(){return c.Event.filter(c.Event.map(this.j.onMouseDblClick,Se),T=>T.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return c.Event.map(this.j.onContextMenu,x)}get onTap(){return c.Event.map(this.j.onTap,Se)}get onPointer(){return c.Event.map(this.j.onPointer,Se)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return c.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ce.Highlight}set findMode(T){this.x&&(this.x.mode=T)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:c.Event.None}get expandOnDoubleClick(){return typeof this.F.expandOnDoubleClick>"u"?!0:this.F.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.F.expandOnlyOnTwistieClick>"u"?!0:this.F.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(T,E,m,B,z={}){this.E=T,this.F=z,this.w=new c.EventBufferer,this.onDidChangeFindOpenState=c.Event.None,this.B=new h.DisposableStore,this.C=new c.Emitter,this.onWillRefilter=this.C.event,this.D=new c.Emitter,this.onDidUpdateOptions=this.D.event;const $=new p(m),G=new c.Relay,k=new c.Relay,O=this.B.add(new V(k.event)),W=new a.SetMap;this.k=B.map(P=>new ee(P,()=>this.o,G.event,O,W,z));for(const P of this.k)this.B.add(P);let S;z.keyboardNavigationLabelProvider&&(S=new Z(this,z.keyboardNavigationLabelProvider,z.filter),z={...z,filter:S},this.B.add(S)),this.p=new ie(()=>this.j.getFocusedElements()[0],z.identityProvider),this.q=new ie(()=>this.j.getSelectedElements()[0],z.identityProvider),this.u=new ie(()=>this.j.getAnchorElement(),z.identityProvider),this.j=new he(T,E,$,this.k,this.p,this.q,this.u,{...C(()=>this.o,z),tree:this}),this.o=this.J(T,this.j,z),G.input=this.o.onDidChangeCollapseState;const I=c.Event.forEach(this.o.onDidSplice,P=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(P),this.q.onDidModelSplice(P)})},this.B);if(I(()=>null,null,this.B),k.input=c.Event.chain(c.Event.any(I,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const P=new Set;for(const R of this.p.getNodes())P.add(R);for(const R of this.q.getNodes())P.add(R);return[...P.values()]}).event,z.keyboardSupport!==!1){const P=c.Event.chain(this.j.onKeyDown).filter(R=>!(0,g.isInputElement)(R.target)).map(R=>new U.StandardKeyboardEvent(R));P.filter(R=>R.keyCode===15).on(this.G,this,this.B),P.filter(R=>R.keyCode===17).on(this.H,this,this.B),P.filter(R=>R.keyCode===10).on(this.I,this,this.B)}if((z.findWidgetEnabled??!0)&&z.keyboardNavigationLabelProvider&&z.contextViewProvider){const P=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new de(this,this.o,this.j,S,z.contextViewProvider,P),this.y=R=>this.x.shouldAllowFocus(R),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.B.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode}else this.onDidChangeFindMode=c.Event.None;this.A=(0,v.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.F.renderIndentGuides===_.Always)}updateOptions(T={}){this.F={...this.F,...T};for(const E of this.k)E.updateOptions(T);this.j.updateOptions(this.F),this.D.fire(this.F),this.getHTMLElement().classList.toggle("always",this.F.renderIndentGuides===_.Always)}get options(){return this.F}updateWidth(T){const E=this.o.getListIndex(T);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(T){this.j.scrollTop=T}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(T){this.j.scrollLeft=T}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const T=this.j.firstVisibleIndex;return T<0||T>=this.j.length?void 0:this.j.element(T).element}get lastVisibleElement(){const T=this.j.lastVisibleIndex;return this.j.element(T).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(T){this.j.ariaLabel=T}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(T,E){this.j.layout(T,E),(0,A.isNumber)(E)&&this.x?.layout(E)}style(T){const E=`.${this.j.domId}`,m=[];T.treeIndentGuidesStroke&&(m.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${T.treeIndentGuidesStroke.transparent(.4)}; }`),m.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${T.treeIndentGuidesStroke}; }`)),this.A.textContent=m.join(`
`),this.j.style(T)}getParentElement(T){const E=this.o.getParentNodeLocation(T);return this.o.getNode(E).element}getFirstElementChild(T){return this.o.getFirstElementChild(T)}getNode(T){return this.o.getNode(T)}getNodeLocation(T){return this.o.getNodeLocation(T)}collapse(T,E=!1){return this.o.setCollapsed(T,!0,E)}expand(T,E=!1){return this.o.setCollapsed(T,!1,E)}toggleCollapsed(T,E=!1){return this.o.setCollapsed(T,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(T){return this.o.isCollapsible(T)}setCollapsible(T,E){return this.o.setCollapsible(T,E)}isCollapsed(T){return this.o.isCollapsed(T)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.C.fire(void 0),this.o.refilter()}setAnchor(T){if(typeof T>"u")return this.j.setAnchor(void 0);const E=this.o.getNode(T);this.u.set([E]);const m=this.o.getListIndex(T);m>-1&&this.j.setAnchor(m,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(T,E){const m=T.map(z=>this.o.getNode(z));this.q.set(m,E);const B=T.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setSelection(B,E,!0)}getSelection(){return this.q.get()}setFocus(T,E){const m=T.map(z=>this.o.getNode(z));this.p.set(m,E);const B=T.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setFocus(B,E,!0)}focusNext(T=1,E=!1,m,B=this.y){this.j.focusNext(T,E,m,B)}focusPrevious(T=1,E=!1,m,B=this.y){this.j.focusPrevious(T,E,m,B)}focusNextPage(T,E=this.y){return this.j.focusNextPage(T,E)}focusPreviousPage(T,E=this.y){return this.j.focusPreviousPage(T,E)}focusLast(T,E=this.y){this.j.focusLast(T,E)}focusFirst(T,E=this.y){this.j.focusFirst(T,E)}getFocus(){return this.p.get()}reveal(T,E){this.o.expandTo(T);const m=this.o.getListIndex(T);m!==-1&&this.j.reveal(m,E)}getRelativeTop(T){const E=this.o.getListIndex(T);return E===-1?null:this.j.getRelativeTop(E)}getViewState(T=this.options.identityProvider){if(!T)throw new o.TreeError(this.E,"Can't get tree view state without an identity provider");const E=$=>T.getId($).toString(),m=D.empty(this.scrollTop);for(const $ of this.getFocus())m.focus.add(E($));for(const $ of this.getSelection())m.selection.add(E($));const B=this.o.getNode(),z=[B];for(;z.length>0;){const $=z.shift();$!==B&&$.collapsible&&(m.expanded[E($.element)]=$.collapsed?0:1),z.push(...$.children)}return m}G(T){T.preventDefault(),T.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const m=E[0],B=this.o.getNodeLocation(m);if(!this.o.setCollapsed(B,!0)){const $=this.o.getParentNodeLocation(B);if(!$)return;const G=this.o.getListIndex($);this.j.reveal(G),this.j.setFocus([G])}}H(T){T.preventDefault(),T.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const m=E[0],B=this.o.getNodeLocation(m);if(!this.o.setCollapsed(B,!1)){if(!m.children.some(k=>k.visible))return;const[$]=this.j.getFocus(),G=$+1;this.j.reveal(G),this.j.setFocus([G])}}I(T){T.preventDefault(),T.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const m=E[0],B=this.o.getNodeLocation(m),z=T.browserEvent.altKey;this.o.setCollapsed(B,void 0,z)}navigate(T){return new le(this.j,this.o,T)}dispose(){(0,h.dispose)(this.B),this.j.dispose()}}t.AbstractTree=fe;class le{constructor(T,E,m){this.b=T,this.c=E,m?this.a=this.c.getListIndex(m):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[129],be([1,0,128,119,23,25]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends v.AbstractTree{constructor(f,g,d,M,o,n={}){super(f,g,d,M,n),this.f=f,this.g=o,this.d=new Map,this.c=n.identityProvider}getInput(){return this.b}setInput(f,g){if(g&&!this.c)throw new U.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=f,!f){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!g){this.m(f);return}const d=[],M=[],o=e=>{const s=this.c.getId(e).toString();return!g.expanded[s]},n=e=>{const s=this.c.getId(e.element).toString();g.focus.has(s)&&d.push(e.element),g.selection.has(s)&&M.push(e.element)};this.m(f,o,n),this.setFocus(d),this.setSelection(M),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(f=this.b){if(typeof this.b>"u")throw new U.TreeError(this.f,"Tree input not set");let g;this.c&&(g=d=>{const M=this.c.getId(d).toString(),o=this.d.get(M);if(!!o)return o.collapsed}),this.m(f,g)}resort(f=this.b,g=!0){this.o.resort(f===this.b?null:f,g)}refresh(f){if(f===void 0){this.j.rerender();return}this.o.rerender(f)}m(f,g,d){let M;if(this.c){const o=new Set,n=d;d=e=>{const s=this.c.getId(e.element).toString();o.add(s),this.d.set(s,e),n?.(e)},M=e=>{const s=this.c.getId(e.element).toString();o.has(s)||this.d.delete(s)}}this.o.setChildren(f===this.b?null:f,this.s(f,g).elements,{onDidCreateNode:d,onDidDeleteNode:M})}s(f,g){const d=[...this.g.getChildren(f)];return{elements:H.Iterable.map(d,o=>{const{elements:n,size:e}=this.s(o,g),s=this.g.hasChildren?this.g.hasChildren(o):void 0,l=e===0?void 0:g&&g(o);return{element:o,children:n,collapsible:s,collapsed:l}}),size:d.length}}J(f,g,d){return new i.ObjectTreeModel(f,g,d)}}t.DataTree=y}),define(me[37],be([1,0,14,8,29,26,24,9,3,2,50,11,6]),function(X,t,v,i,U,H,y,w,f,g,d,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=void 0;var n;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(n||(n={}));function e(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(s||(s={}));function l(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(a||(a={}));class c{constructor(J){this.b=J,this.a=0}read(J){const he=this.b.slice(this.a,this.a+J);return this.a+=he.byteLength,he}}class r{constructor(){this.a=[]}get buffer(){return U.VSBuffer.concat(this.a)}write(J){this.a.push(J)}}var h;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object"})(h||(h={}));function b(ie){const J=U.VSBuffer.alloc(4);return J.writeUInt32BE(ie,0),J}function A(ie){return ie.read(4).readUInt32BE(0)}function L(ie){const J=U.VSBuffer.alloc(1);return J.writeUInt8(ie,0),J}const N={Undefined:L(h.Undefined),String:L(h.String),Buffer:L(h.Buffer),VSBuffer:L(h.VSBuffer),Array:L(h.Array),Object:L(h.Object)},F=typeof Buffer<"u";function u(ie,J){if(typeof J>"u")ie.write(N.Undefined);else if(typeof J=="string"){const he=U.VSBuffer.fromString(J);ie.write(N.String),ie.write(b(he.byteLength)),ie.write(he)}else if(F&&Buffer.isBuffer(J)){const he=U.VSBuffer.wrap(J);ie.write(N.Buffer),ie.write(b(he.byteLength)),ie.write(he)}else if(J instanceof U.VSBuffer)ie.write(N.VSBuffer),ie.write(b(J.byteLength)),ie.write(J);else if(Array.isArray(J)){ie.write(N.Array),ie.write(b(J.length));for(const he of J)u(ie,he)}else{const he=U.VSBuffer.fromString(JSON.stringify(J));ie.write(N.Object),ie.write(b(he.byteLength)),ie.write(he)}}function C(ie){switch(ie.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return ie.read(A(ie)).toString();case h.Buffer:return ie.read(A(ie)).buffer;case h.VSBuffer:return ie.read(A(ie));case h.Array:{const he=A(ie),fe=[];for(let le=0;le<he;le++)fe.push(C(ie));return fe}case h.Object:return JSON.parse(ie.read(A(ie)).toString())}}class p{constructor(J,he,fe=null,le=1e3){this.h=J,this.j=he,this.k=fe,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.p(te)),this.m({type:200})}registerChannel(J,he){this.b.set(J,he),setTimeout(()=>this.v(J),0)}m(J){switch(J.type){case 200:{const he=this.n([J.type]);this.k?.logOutgoing(he,0,1,l(J.type));return}case 201:case 202:case 204:case 203:{const he=this.n([J.type,J.id],J.data);this.k?.logOutgoing(he,J.id,1,l(J.type),J.data);return}}}n(J,he=void 0){const fe=new r;return u(fe,J),u(fe,he),this.o(fe.buffer)}o(J){try{return this.h.send(J),J.byteLength}catch{return 0}}p(J){const he=new c(J),fe=C(he),le=C(he),te=fe[0];switch(te){case 100:return this.k?.logIncoming(J.byteLength,fe[1],1,`${e(te)}: ${fe[2]}.${fe[3]}`,le),this.q({type:te,id:fe[1],channelName:fe[2],name:fe[3],arg:le});case 102:return this.k?.logIncoming(J.byteLength,fe[1],1,`${e(te)}: ${fe[2]}.${fe[3]}`,le),this.s({type:te,id:fe[1],channelName:fe[2],name:fe[3],arg:le});case 101:return this.k?.logIncoming(J.byteLength,fe[1],1,`${e(te)}`),this.t({type:te,id:fe[1]});case 103:return this.k?.logIncoming(J.byteLength,fe[1],1,`${e(te)}`),this.t({type:te,id:fe[1]})}}q(J){const he=this.b.get(J.channelName);if(!he){this.u(J);return}const fe=new H.CancellationTokenSource;let le;try{le=he.call(this.j,J.name,J.arg,fe.token)}catch(E){le=Promise.reject(E)}const te=J.id;le.then(E=>{this.m({id:te,data:E,type:201}),this.d.delete(J.id)},E=>{E instanceof Error?this.m({id:te,data:{message:E.message,name:E.name,stack:E.stack?E.stack.split?E.stack.split(`
`):E.stack:void 0},type:202}):this.m({id:te,data:E,type:203}),this.d.delete(J.id)});const T=(0,g.toDisposable)(()=>fe.cancel());this.d.set(J.id,T)}s(J){const he=this.b.get(J.channelName);if(!he){this.u(J);return}const fe=J.id,te=he.listen(this.j,J.name,J.arg)(T=>this.m({id:fe,data:T,type:204}));this.d.set(J.id,te)}t(J){const he=this.d.get(J.id);he&&(he.dispose(),this.d.delete(J.id))}u(J){let he=this.g.get(J.channelName);he||(he=[],this.g.set(J.channelName,he));const fe=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);he.push({request:J,timeoutTimer:fe})}v(J){const he=this.g.get(J);if(he){for(const fe of he)switch(clearTimeout(fe.timeoutTimer),fe.request.type){case 100:this.q(fe.request);break;case 102:this.s(fe.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=p;var D;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(D=t.RequestInitiator||(t.RequestInitiator={}));class _{constructor(J,he=null){this.l=J,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(fe=>this.r(fe)),this.j=he}getChannel(J){const he=this;return{call(fe,le,te){return he.a?Promise.reject(new w.CancellationError):he.m(J,fe,le,te)},listen(fe,le){return he.a?f.Event.None:he.n(J,fe,le)}}}m(J,he,fe,le=H.CancellationToken.None){const te=this.g++,E={id:te,type:100,channelName:J,name:he,arg:fe};if(le.isCancellationRequested)return Promise.reject(new w.CancellationError);let m;return new Promise((z,$)=>{if(le.isCancellationRequested)return $(new w.CancellationError);const G=()=>{const S=I=>{switch(I.type){case 201:this.f.delete(te),z(I.data);break;case 202:{this.f.delete(te);const P=new Error(I.data.message);P.stack=Array.isArray(I.data.stack)?I.data.stack.join(`
`):I.data.stack,P.name=I.data.name,$(P);break}case 203:this.f.delete(te),$(I.data);break}};this.f.set(te,S),this.o(E)};let k=null;this.b===a.Idle?G():(k=(0,i.createCancelablePromise)(S=>this.t()),k.then(()=>{k=null,G()}));const O=()=>{k?(k.cancel(),k=null):this.o({id:te,type:101}),$(new w.CancellationError)},W=le.onCancellationRequested(O);m=(0,g.combinedDisposable)((0,g.toDisposable)(O),W),this.d.add(m)}).finally(()=>{this.d.delete(m)})}n(J,he,fe){const le=this.g++,T={id:le,type:102,channelName:J,name:he,arg:fe};let E=null;const m=new f.Emitter({onWillAddFirstListener:()=>{E=(0,i.createCancelablePromise)(z=>this.t()),E.then(()=>{E=null,this.d.add(m),this.o(T)})},onDidRemoveLastListener:()=>{E?(E.cancel(),E=null):(this.d.delete(m),this.o({id:le,type:103}))}}),B=z=>m.fire(z.data);return this.f.set(le,B),m.event}o(J){switch(J.type){case 100:case 102:{const he=this.p([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(he,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const he=this.p([J.type,J.id]);this.j?.logOutgoing(he,J.id,0,e(J.type));return}}}p(J,he=void 0){const fe=new r;return u(fe,J),u(fe,he),this.q(fe.buffer)}q(J){try{return this.l.send(J),J.byteLength}catch{return 0}}r(J){const he=new c(J),fe=C(he),le=C(he),te=fe[0];switch(te){case 200:return this.j?.logIncoming(J.byteLength,0,0,l(te)),this.s({type:fe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,fe[1],0,l(te),le),this.s({type:fe[0],id:fe[1],data:le})}}s(J){if(J.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}t(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.dispose)(this.d.values()),this.d.clear()}}qe([y.memoize],_.prototype,"onDidInitializePromise",null),t.ChannelClient=_;class V{get connections(){const J=[];return this.f.forEach(he=>J.push(he)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,J(({protocol:he,onDidClientDisconnect:fe})=>{f.Event.once(he.onMessage)(te=>{const T=new c(te),E=C(T),m=new p(he,E),B=new _(he);this.a.forEach(($,G)=>m.registerChannel(G,$));const z={channelServer:m,channelClient:B,ctx:E};this.f.add(z),this.g.fire(z),fe(()=>{m.dispose(),B.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(J,he){const fe=this;return{call(le,te,T){let E;if((0,o.isFunction)(he)){const B=(0,v.getRandomElement)(fe.connections.filter(he));E=B?Promise.resolve(B):f.Event.toPromise(f.Event.filter(fe.onDidAddConnection,he))}else E=he.routeCall(fe,le,te);const m=E.then(B=>B.channelClient.getChannel(J));return Z(m).call(le,te,T)},listen(le,te){if((0,o.isFunction)(he))return fe.j(J,he,le,te);const T=he.routeEvent(fe,le,te).then(E=>E.channelClient.getChannel(J));return Z(T).listen(le,te)}}}j(J,he,fe,le){const te=this;let T=new g.DisposableStore;const E=new f.Emitter({onWillAddFirstListener:()=>{T=new g.DisposableStore;const m=new f.EventMultiplexer,B=new Map,z=G=>{const O=G.channelClient.getChannel(J).listen(fe,le),W=m.add(O);B.set(G,W)},$=G=>{const k=B.get(G);!k||(k.dispose(),B.delete(G))};te.connections.filter(he).forEach(z),f.Event.filter(te.onDidAddConnection,he)(z,void 0,T),te.onDidRemoveConnection($,void 0,T),m.event(E.fire,E,T),T.add(m)},onDidRemoveLastListener:()=>{T.dispose()}});return E.event}registerChannel(J,he){this.a.set(J,he),this.f.forEach(fe=>{fe.channelServer.registerChannel(J,he)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=V;class ee{constructor(J,he,fe=null){const le=new r;u(le,he),J.send(le.buffer),this.a=new _(J,fe),this.d=new p(J,he,fe)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,he){this.d.registerChannel(J,he)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=ee;function Z(ie){return{call(J,he,fe){return ie.then(le=>le.call(J,he,fe))},listen(J,he){const fe=new f.Relay;return ie.then(le=>fe.input=le.listen(J,he)),fe.event}}}t.getDelayedChannel=Z;function pe(ie){let J=!1;return{call(he,fe,le){return J?ie.call(he,fe,le):(0,i.timeout)(0).then(()=>J=!0).then(()=>ie.call(he,fe,le))},listen(he,fe){if(J)return ie.listen(he,fe);const le=new f.Relay;return(0,i.timeout)(0).then(()=>J=!0).then(()=>le.input=ie.listen(he,fe)),le.event}}}t.getNextTickChannel=pe;class oe{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const he of J.connections)if(await Promise.resolve(this.a(he.ctx)))return Promise.resolve(he);return await f.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.StaticRouter=oe;var ce;(function(ie){function J(te,T){const E=te,m=T&&T.disableMarshalling,B=new Map;for(const z in E)fe(z)&&B.set(z,f.Event.buffer(E[z],!0));return new class{listen(z,$,G){const k=B.get($);if(k)return k;if(le($)){const O=E[$];if(typeof O=="function")return O.call(E,G)}throw new Error(`Event not found: ${$}`)}call(z,$,G){const k=E[$];if(typeof k=="function"){if(!m&&Array.isArray(G))for(let O=0;O<G.length;O++)G[O]=(0,d.revive)(G[O]);return k.apply(E,G)}throw new Error(`Method not found: ${$}`)}}}ie.fromService=J;function he(te,T){const E=T&&T.disableMarshalling;return new Proxy({},{get(m,B){if(typeof B=="string")return T?.properties?.has(B)?T.properties.get(B):le(B)?function(z){return te.listen(B,z)}:fe(B)?te.listen(B):async function(...z){let $;T&&!(0,o.isUndefinedOrNull)(T.context)?$=[T.context,...z]:$=z;const G=await te.call(B,$);return E?G:(0,d.revive)(G)};throw new Error(`Property not found: ${String(B)}`)}})}ie.toService=he;function fe(te){return te[0]==="o"&&te[1]==="n"&&M.isUpperAsciiLetter(te.charCodeAt(2))}function le(te){return/^onDynamic/.test(te)&&M.isUpperAsciiLetter(te.charCodeAt(9))}})(ce=t.ProxyChannel||(t.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const J=ie.toString();if(J!=="[object Object]")return J}return ie}function Se(ie){return Array.isArray(ie)?ie.map(de):de(ie)}function x(ie,J,he,fe,le,te,T){T=Se(T);const E=ae[le],m=E[fe%E.length];let B=[`%c[${ie}]%c[${String(J).padStart(7," ")}]%c[len: ${String(he).padStart(5," ")}]%c${String(fe).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${m}`];/\($/.test(te)?(B=B.concat(T),B.push(")")):B.push(T),console.log.apply(console,B)}class ye{constructor(J,he){this.d=J,this.f=he,this.a=0,this.b=0}logOutgoing(J,he,fe,le,te){this.b+=J,x(this.d,this.b,J,he,fe,le,te)}logIncoming(J,he,fe,le,te){this.a+=J,x(this.f,this.a,J,he,fe,le,te)}}t.IPCLogger=ye}),define(me[27],be([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=v.globals.vscode.ipcRenderer,t.ipcMessagePort=v.globals.vscode.ipcMessagePort,t.webFrame=v.globals.vscode.webFrame,t.process=v.globals.vscode.process,t.context=v.globals.vscode.context}),define(me[130],be([1,0,81,27]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let U=0;function H(w,f,g){const d=[],M=U++,o=`vscode:onContextMenu${M}`,n=(e,s,l)=>{d[s].click?.(l)};i.ipcRenderer.once(o,n),i.ipcRenderer.once(v.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===M&&(i.ipcRenderer.removeListener(o,n),g?.())}),i.ipcRenderer.send(v.CONTEXT_MENU_CHANNEL,M,w.map(e=>y(e,d)),o,f)}t.popup=H;function y(w,f){const g={id:f.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return f.push(w),Array.isArray(w.submenu)&&(g.submenu=w.submenu.map(d=>y(d,f))),g}}),define(me[131],be([1,0,29,3,37,82,27]),function(X,t,v,i,U,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends U.IPCClient{static f(){const g=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(d,M)=>v.VSBuffer.wrap(M));return y.ipcRenderer.send("vscode:hello"),new H.Protocol(y.ipcRenderer,g)}constructor(g){const d=w.f();super(d,g),this.b=d}dispose(){this.b.disconnect()}}t.Client=w}),define(me[132],be([13,10]),function(X,t){return X.create("vs/platform/files/common/files",t)}),define(me[133],be([13,10]),function(X,t){return X.create("vs/platform/theme/common/iconRegistry",t)}),define(me[65],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class v{constructor(U,H=[],y=!1){this.ctor=U,this.staticArguments=H,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=v}),define(me[134],be([1,0,65]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var U;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(U=t.InstantiationType||(t.InstantiationType={}));function H(w,f,g){f instanceof v.SyncDescriptor||(f=new v.SyncDescriptor(f,[],Boolean(g))),i.push([w,f])}t.registerSingleton=H;function y(){return i}t.getSingletonServiceDescriptors=y}),define(me[28],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var v;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function w(f){return f[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=w})(v=t._util||(t._util={})),t.IInstantiationService=U("instantiationService");function i(y,w,f){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:y,index:f}):(w[v.DI_DEPENDENCIES]=[{id:y,index:f}],w[v.DI_TARGET]=w)}function U(y){if(v.serviceIds.has(y))return v.serviceIds.get(y);const w=function(f,g,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,f,d)};return w.toString=()=>y,v.serviceIds.set(y,w),w}t.createDecorator=U;function H(y){return y}t.refineServiceDecorator=H}),define(me[135],be([1,0,28]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,v.createDecorator)(t.ID);function i(H){return!!H.hostName&&!!H.errorMessage}t.isRemoteDiagnosticError=i;class U{async getPerformanceInfo(y,w){return{}}async getSystemInfo(y,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,w){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=U}),define(me[136],be([1,0,113,21,11,6,15,132,28]),function(X,t,v,i,U,H,y,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,f.createDecorator)("fileService");function g(x){return x.create===!0}t.isFileOpenForWriteOptions=g;var d;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(d=t.FileType||(t.FileType={}));var M;(function(x){x[x.Readonly=1]="Readonly"})(M=t.FilePermission||(t.FilePermission={}));var o;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(o=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(x){return!!(x.capabilities&2)}t.hasReadWriteCapability=n;function e(x){return!!(x.capabilities&8)}t.hasFileFolderCopyCapability=e;function s(x){return!!(x.capabilities&32768)}t.hasFileCloneCapability=s;function l(x){return!!(x.capabilities&4)}t.hasOpenReadWriteCloseCapability=l;function a(x){return!!(x.capabilities&16)}t.hasFileReadStreamCapability=a;function c(x){return n(x)?!!(x.capabilities&16384):!1}t.hasFileAtomicReadCapability=c;var r;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(r=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class h extends Error{constructor(ye,ie){super(ye),this.code=ie}}t.FileSystemProviderError=h;function b(x,ye){const ie=new h(x.toString(),ye);return L(ie,ye),ie}t.createFileSystemProviderError=b;function A(x){return x||b((0,w.localize)(0,null),r.Unknown)}t.ensureFileSystemProviderError=A;function L(x,ye){return x.name=ye?`${ye} (FileSystemError)`:"FileSystemError",x}t.markAsFileSystemProviderError=L;function N(x){if(!x)return r.Unknown;if(x instanceof h)return x.code;const ye=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ye)return r.Unknown;switch(ye[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileExceedsMemoryLimit:return r.FileExceedsMemoryLimit;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}t.toFileSystemProviderErrorCode=N;function F(x){if(x instanceof V)return x.fileOperationResult;switch(N(x)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 10;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileExceedsMemoryLimit:return 9;case r.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=F;var u;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(u=t.FileOperation||(t.FileOperation={}));class C{constructor(ye,ie,J){this.resource=ye,this.operation=ie,this.target=J}isOperation(ye){return this.operation===ye}}t.FileOperationEvent=C;var p;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(p=t.FileChangeType||(t.FileChangeType={}));class D{constructor(ye,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ye;const J=new Map;for(const he of ye){const fe=J.get(he.type);switch(fe?fe.push([he.resource,he]):J.set(he.type,[[he.resource,he]]),he.type){case 1:this.rawAdded.push(he.resource);break;case 0:this.rawUpdated.push(he.resource);break;case 2:this.rawDeleted.push(he.resource);break}}for(const[he,fe]of J)switch(he){case 1:this.a=v.TernarySearchTree.forUris(()=>ie),this.a.fill(fe);break;case 0:this.b=v.TernarySearchTree.forUris(()=>ie),this.b.fill(fe);break;case 2:this.c=v.TernarySearchTree.forUris(()=>ie),this.c.fill(fe);break}}contains(ye,...ie){return this.d(ye,{includeChildren:!1},...ie)}affects(ye,...ie){return this.d(ye,{includeChildren:!0},...ie)}d(ye,ie,...J){if(!ye)return!1;const he=J.length>0;return!!((!he||J.includes(1))&&(this.a?.get(ye)||ie.includeChildren&&this.a?.findSuperstr(ye))||(!he||J.includes(0))&&(this.b?.get(ye)||ie.includeChildren&&this.b?.findSuperstr(ye))||(!he||J.includes(2))&&(this.c?.findSubstr(ye)||ie.includeChildren&&this.c?.findSuperstr(ye)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=D;function _(x,ye,ie){return!x||!ye||x===ye||ye.length>x.length?!1:(ye.charAt(ye.length-1)!==i.sep&&(ye+=i.sep),ie?(0,U.startsWithIgnoreCase)(x,ye):x.indexOf(ye)===0)}t.isParent=_;class V extends Error{constructor(ye,ie,J){super(ye),this.fileOperationResult=ie,this.options=J}}t.FileOperationError=V;class ee extends V{constructor(ye,ie,J){super(ye,2,J),this.stat=ie}}t.NotModifiedSinceFileOperationError=ee;var Z;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Z=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var pe;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(pe=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function oe(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}t.etag=oe;async function ce(x,ye){if(!ye.hasProvider(y.URI.from({scheme:x.scheme})))return new Promise(ie=>{const J=ye.onDidChangeFileSystemProviderRegistrations(he=>{he.scheme===x.scheme&&he.added&&(J.dispose(),ie())})})}t.whenProviderRegistered=ce,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(ye){return(0,H.isNumber)(ye)||(ye=0),ye<ae.KB?(0,w.localize)(1,null,ye.toFixed(0)):ye<ae.MB?(0,w.localize)(2,null,(ye/ae.KB).toFixed(2)):ye<ae.GB?(0,w.localize)(3,null,(ye/ae.MB).toFixed(2)):ye<ae.TB?(0,w.localize)(4,null,(ye/ae.GB).toFixed(2)):(0,w.localize)(5,null,(ye/ae.TB).toFixed(2))}}t.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var de;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(de=t.Arch||(t.Arch={}));function Se(x){return{maxFileSize:x===0?300*ae.MB:16*ae.GB,maxHeapSize:x===0?700*ae.MB:2*700*ae.MB}}t.getPlatformLimits=Se}),define(me[137],be([1,0,2,131]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class U extends v.Disposable{constructor(y){super(),this.a=this.B(new i.Client(`window:${y}`))}getChannel(y){return this.a.getChannel(y)}registerChannel(y,w){this.a.registerChannel(y,w)}}t.ElectronIPCMainProcessService=U});var wt=this&&this.__param||function(X,t){return function(v,i){t(v,i,X)}};define(me[138],be([1,0,37,65,134,28]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(n,e,s,l){const a=s.getChannel(n);return w(e)?l.createInstance(new i.SyncDescriptor(e.channelClientCtor,[a])):v.ProxyChannel.toService(a,e?.proxyOptions)}}function w(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,H.createDecorator)("mainProcessService");let f=class extends y{constructor(n,e,s,l){super(n,e,s,l)}};f=qe([wt(2,t.IMainProcessService),wt(3,H.IInstantiationService)],f);function g(o,n,e){(0,U.registerSingleton)(o,new i.SyncDescriptor(f,[n,e],!0))}t.registerMainProcessRemoteService=g,t.ISharedProcessService=(0,H.createDecorator)("sharedProcessService");let d=class extends y{constructor(n,e,s,l){super(n,e,s,l)}};d=qe([wt(2,t.ISharedProcessService),wt(3,H.IInstantiationService)],d);function M(o,n,e){(0,U.registerSingleton)(o,new i.SyncDescriptor(d,[n,e],!0))}t.registerSharedProcessRemoteService=M}),define(me[139],be([1,0,37,138]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let U=class{constructor(y,w){return this.windowId=y,v.ProxyChannel.toService(w.getChannel("nativeHost"),{context:y,properties:(()=>{const f=new Map;return f.set("windowId",y),f})()})}};U=qe([wt(1,i.IMainProcessService)],U),t.NativeHostService=U}),define(me[38],be([1,0,72,6]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class U{constructor(){this.a=new Map}add(y,w){v.ok(i.isString(y)),v.ok(i.isObject(w)),v.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,w)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}t.Registry=new U}),define(me[140],be([1,0,3,38]),function(X,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function U(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class H{constructor(){this.b=new v.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,g){this.a[U(f)]=g,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const y=new H;i.Registry.add(t.Extensions.JSONContribution,y)}),define(me[141],be([1,0]),function(X,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var v;(function(H){H.DARK="dark",H.LIGHT="light",H.HIGH_CONTRAST_DARK="hcDark",H.HIGH_CONTRAST_LIGHT="hcLight"})(v=t.ColorScheme||(t.ColorScheme={}));function i(H){return H===v.HIGH_CONTRAST_DARK||H===v.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function U(H){return H===v.DARK||H===v.HIGH_CONTRAST_DARK}t.isDark=U}),define(me[66],be([1,0,12,3,2,28,38,141]),function(X,t,v,i,U,H,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,H.createDecorator)("themeService");var f;(function(l){function a(c){return c&&typeof c=="object"&&typeof c.id=="string"}l.isThemeColor=a})(f=t.ThemeColor||(t.ThemeColor={}));function g(l){return{id:l}}t.themeColorFromId=g;var d;(function(l){function a(F){return F&&typeof F=="object"&&typeof F.id=="string"&&(typeof F.color>"u"||f.isThemeColor(F.color))}l.isThemeIcon=a;const c=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function r(F){const u=c.exec(F);if(!u)return;const[,C]=u;return{id:C}}l.fromString=r;function h(F){return{id:F}}l.fromId=h;function b(F,u){let C=F.id;const p=C.lastIndexOf("~");return p!==-1&&(C=C.substring(0,p)),u&&(C=`${C}~${u}`),{id:C}}l.modify=b;function A(F){const u=F.id.lastIndexOf("~");if(u!==-1)return F.id.substring(u+1)}l.getModifier=A;function L(F,u){return F.id===u.id&&F.color?.id===u.color?.id}l.isEqual=L;function N(F,u){return{id:F.id,color:u?g(u):void 0}}l.asThemeIcon=N,l.asClassNameArray=v.CSSIcon.asClassNameArray,l.asClassName=v.CSSIcon.asClassName,l.asCSSSelector=v.CSSIcon.asCSSSelector})(d=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=v.Codicon.file,t.FolderThemeIcon=v.Codicon.folder;function M(l){switch(l){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=M,t.Extensions={ThemingContribution:"base.contributions.theming"};class o{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(a){return this.a.push(a),this.b.fire(a),(0,U.toDisposable)(()=>{const c=this.a.indexOf(a);this.a.splice(c,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const n=new o;y.Registry.add(t.Extensions.ThemingContribution,n);function e(l){return n.onColorThemeChange(l)}t.registerThemingParticipant=e;class s extends U.Disposable{constructor(a){super(),this.k=a,this.h=a.getColorTheme(),this.B(this.k.onDidColorThemeChange(c=>this.n(c)))}n(a){this.h=a,this.updateStyles()}updateStyles(){}w(a,c){let r=this.h.getColor(a);return r&&c&&(r=c(r,this.h)),r?r.toString():null}}t.Themable=s}),define(me[142],be([1,0,8,12,3,6,15,133,140,38,66]),function(X,t,v,i,U,H,y,w,f,g,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var M;(function(h){function b(A,L){let N=A.defaults;for(;d.ThemeIcon.isThemeIcon(N);){const F=e.getIcon(N.id);if(!F)return;N=F.defaults}return N}h.getDefinition=b})(M=t.IconContribution||(t.IconContribution={}));var o;(function(h){function b(L){return{weight:L.weight,style:L.style,src:L.src.map(N=>({format:N.format,location:N.location.toString()}))}}h.toJSONObject=b;function A(L){const N=F=>(0,H.isString)(F)?F:void 0;if(L&&Array.isArray(L.src)&&L.src.every(F=>(0,H.isString)(F.format)&&(0,H.isString)(F.location)))return{weight:N(L.weight),style:N(L.style),src:L.src.map(F=>({format:F.format,location:y.URI.parse(F.location)}))}}h.fromJSONObject=A})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this.a=new U.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,A,L,N){const F=this.b[b];if(F){if(L&&!F.description){F.description=L,this.d.properties[b].markdownDescription=`${L} $(${b})`;const p=this.e.enum.indexOf(b);p!==-1&&(this.e.enumDescriptions[p]=L),this.a.fire()}return F}const u={id:b,description:L,defaults:A,deprecationMessage:N};this.b[b]=u;const C={$ref:"#/definitions/icons"};return N&&(C.deprecationMessage=N),L&&(C.markdownDescription=`${L}: $(${b})`),this.d.properties[b]=C,this.e.enum.push(b),this.e.enumDescriptions.push(L||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const A=this.e.enum.indexOf(b);A!==-1&&(this.e.enum.splice(A,1),this.e.enumDescriptions.splice(A,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,A){const L=this.f[b];return L||(this.f[b]=A,this.a.fire(),A)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(F,u)=>F.id.localeCompare(u.id),A=F=>{for(;d.ThemeIcon.isThemeIcon(F.defaults);)F=this.b[F.defaults.id];return`codicon codicon-${F?F.id:""}`},L=[];L.push("| preview     | identifier                        | default codicon ID                | description"),L.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const N=Object.keys(this.b).map(F=>this.b[F]);for(const F of N.filter(u=>!!u.description).sort(b))L.push(`|<i class="${A(F)}"></i>|${F.id}|${d.ThemeIcon.isThemeIcon(F.defaults)?F.defaults.id:F.id}|${F.description||""}|`);L.push("| preview     | identifier                        "),L.push("| ----------- | --------------------------------- |");for(const F of N.filter(u=>!d.ThemeIcon.isThemeIcon(u.defaults)).sort(b))L.push(`|<i class="${A(F)}"></i>|${F.id}|`);return L.join(`
`)}}const e=new n;g.Registry.add(t.Extensions.IconContribution,e);function s(h,b,A,L){return e.registerIcon(h,b,A,L)}t.registerIcon=s;function l(){return e}t.getIconRegistry=l;function a(){for(const h of i.Codicon.getAll())e.registerIcon(h.id,h.definition,h.description)}a(),t.iconsSchemaId="vscode://schemas/icons";const c=g.Registry.as(f.Extensions.JSONContribution);c.registerSchema(t.iconsSchemaId,e.getIconSchema());const r=new v.RunOnceScheduler(()=>c.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.widgetClose=s("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=s("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=s("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=d.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=d.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[143],be([1,0,4,3,142,66]),function(X,t,v,i,U,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(f){const g=new i.Emitter,d=(0,U.getIconRegistry)();return d.onDidChange(()=>g.fire()),f?.onDidProductIconThemeChange(()=>g.fire()),{onDidChange:g.event,getCSS(){const M=f?f.getProductIconTheme():new w,o={},n=s=>{const l=M.getIcon(s);if(!l)return;const a=l.font;return a?(o[a.id]=a.definition,`.codicon-${s.id}:before { content: '${l.fontCharacter}'; font-family: ${(0,v.asCSSPropertyValue)(a.id)}; }`):`.codicon-${s.id}:before { content: '${l.fontCharacter}'; }`},e=[];for(const s of d.getIcons()){const l=n(s);l&&e.push(l)}for(const s in o){const l=o[s],a=l.weight?`font-weight: ${l.weight};`:"",c=l.style?`font-style: ${l.style};`:"",r=l.src.map(h=>`${(0,v.asCSSUrl)(h.location)} format('${h.format}')`).join(", ");e.push(`@font-face { src: ${r}; font-family: ${(0,v.asCSSPropertyValue)(s)};${a}${c} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class w{getIcon(g){const d=(0,U.getIconRegistry)();let M=g.defaults;for(;H.ThemeIcon.isThemeIcon(M);){const o=d.getIcon(M.id);if(!o)return;M=o.defaults}return M}}t.UnthemedProductIconTheme=w}),define(me[144],be([1,0,5]),function(X,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(d){return!!d.workspaceUri}t.isWorkspaceToOpen=i;function U(d){return!!d.folderUri}t.isFolderToOpen=U;function H(d){return!!d.fileUri}t.isFileToOpen=H;function y(d){const M=w(d),o=d.getValue("window.menuBarVisibility");return o==="default"||M==="native"&&o==="compact"||v.isMacintosh&&v.isNative?"classic":o}t.getMenuBarVisibility=y;function w(d){if(v.isWeb)return"custom";const M=d.getValue("window");if(M){if(v.isMacintosh&&M.nativeTabs===!0||v.isMacintosh&&M.nativeFullScreen===!1)return"native";const e=M.titleBarStyle;if(e==="native"||e==="custom")return e}return v.isLinux?"native":"custom"}t.getTitleBarStyle=w;function f(d,M){if(!v.isWindows||v.isWeb||w(d)==="native")return!1;const o=d.getValue("window.experimental.windowControlsOverlay.enabled");return typeof o=="boolean"?o:M.quality==="insider"||M.quality==="exploration"}t.useWindowControlsOverlay=f;function g(d=0){return Math.pow(1.2,d)}t.zoomLevelToZoomFactor=g}),define(me[145],be([1,0,16,27,144]),function(X,t,v,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function H(f){i.webFrame.setZoomLevel(f),(0,v.setZoomFactor)((0,U.zoomLevelToZoomFactor)(f)),(0,v.setZoomLevel)(f,!1)}t.applyZoom=H;function y(){H((0,v.getZoomLevel)()+1)}t.zoomIn=y;function w(){H((0,v.getZoomLevel)()-1)}t.zoomOut=w}),define(me[146],be([1,0,10,4,129,8,130,27,135,136,137,139,143,145,95,86]),function(X,t,v,i,U,H,y,w,f,g,d,M,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,s=/\s--(inspect|debug)-port=(\d+)/;class l{getHeight(D){return 22}getTemplateId(D){return N(D)?"process":A(D)?"machine":(0,f.isRemoteDiagnosticError)(D)?"error":L(D)?"header":""}}class a{hasChildren(D){return(0,f.isRemoteDiagnosticError)(D)?!1:N(D)?!!D.children?.length:!0}getChildren(D){return N(D)?D.children?D.children:[]:(0,f.isRemoteDiagnosticError)(D)?[]:L(D)?D.processRoots.length>1?D.processRoots:[D.processRoots[0].rootProcess]:A(D)?[D.rootProcess]:[D.processes]}}class c{constructor(){this.templateId="header"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_.CPU=(0,i.append)(V,(0,i.$)(".cpu")),_.memory=(0,i.append)(V,(0,i.$)(".memory")),_.PID=(0,i.append)(V,(0,i.$)(".pid")),_}renderElement(D,_,V,ee){V.name.textContent=(0,v.localize)(0,null),V.CPU.textContent=(0,v.localize)(1,null),V.PID.textContent=(0,v.localize)(2,null),V.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(D){}}class r{constructor(){this.templateId="machine"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_}renderElement(D,_,V,ee){V.name.textContent=D.element.name}disposeTemplate(D){}}class h{constructor(){this.templateId="error"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_}renderElement(D,_,V,ee){V.name.textContent=D.element.errorMessage}disposeTemplate(D){}}class b{constructor(D,_,V){this.a=D,this.b=_,this.c=V,this.templateId="process"}renderTemplate(D){const _=Object.create(null),V=(0,i.append)(D,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_.CPU=(0,i.append)(V,(0,i.$)(".cpu")),_.memory=(0,i.append)(V,(0,i.$)(".memory")),_.PID=(0,i.append)(V,(0,i.$)(".pid")),_}renderElement(D,_,V,ee){const{element:Z}=D;let pe=Z.name;pe==="window"&&(pe=this.c.get(Z.pid)!==void 0?`${pe} (${this.c.get(Z.pid)})`:pe);const oe=Z.pid.toFixed(0);V.name.textContent=pe,V.name.title=Z.cmd,V.CPU.textContent=Z.load.toFixed(0),V.PID.textContent=oe,V.PID.parentElement.id=`pid-${oe}`;const ce=this.a==="win32"?Z.mem:this.b*(Z.mem/100);V.memory.textContent=(ce/g.ByteSize.MB).toFixed(0)}disposeTemplate(D){}}function A(p){return!!p.name&&!!p.rootProcess}function L(p){return!!p.processRoots}function N(p){return!!p.pid}class F{constructor(D,_){this.f=_,this.b=new Map;const V=new d.ElectronIPCMainProcessService(D);this.c=new M.NativeHostService(D,V),this.k(_.styles),this.g(_),w.ipcRenderer.on("vscode:windowsInfoResponse",(ee,Z)=>{this.b=new Map,Z.forEach(pe=>this.b.set(pe.pid,pe.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ee,Z)=>{Z.forEach((pe,oe)=>{N(pe.rootProcess)&&(pe.rootProcess.name=oe===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}g(D){document.onkeydown=_=>{const V=D.platform==="darwin"?_.metaKey:_.ctrlKey;V&&_.keyCode===87&&(_.stopPropagation(),_.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),V&&_.keyCode===187&&(0,n.zoomIn)(),V&&_.keyCode===189&&(0,n.zoomOut)()}}async h(D){const _=document.getElementById("process-list");if(!_)return;const{totalmem:V}=await this.c.getOSStatistics(),ee=[new b(this.f.platform,V,this.b),new c,new r,new h];this.d=new U.DataTree("processExplorer",_,new l,ee,new a,{identityProvider:{getId:Z=>N(Z)?Z.pid.toString():(0,f.isRemoteDiagnosticError)(Z)?Z.hostName:L(Z)?"processes":A(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:D}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onContextMenu(Z=>{N(Z.element)&&this.l(Z.element,!0)}),_.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{_.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(D){const _=e.exec(D);return _&&_.length>=2||D.indexOf("node ")>=0||D.indexOf("node.exe")>=0}j(D){const _={type:"node",request:"attach",name:`process ${D.pid}`};let V=e.exec(D.cmd);V&&V.length>=2?(V.length===4&&V[3]&&(_.port=parseInt(V[3])),_.protocol=V[1]==="debug"?"legacy":"inspector"):_.processId=String(D.pid),V=s.exec(D.cmd),V&&V.length===3&&(_.port=parseInt(V[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[_]})}k(D){const _=(0,i.createStyleSheet)(),V=[];D.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${D.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${D.listFocusBackground}; }`)),D.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${D.listFocusForeground}; }`),D.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${D.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${D.listActiveSelectionBackground}; }`)),D.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${D.listActiveSelectionForeground}; }`),D.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${D.listHoverBackground}; }`),D.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${D.listHoverForeground}; }`),D.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }`),D.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${D.listHoverOutline}; outline-offset: -1px; }`),D.scrollbarShadowColor&&V.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${D.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${D.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),D.scrollbarSliderBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${D.scrollbarSliderBackgroundColor};
				}
			`),D.scrollbarSliderHoverBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${D.scrollbarSliderHoverBackgroundColor};
				}
			`),D.scrollbarSliderActiveBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${D.scrollbarSliderActiveBackgroundColor};
				}
			`),_.textContent=V.join(`
`),D.color&&(document.body.style.color=D.color)}l(D,_){const V=[],ee=Number(D.pid);_&&(V.push({label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(ee,"SIGTERM")}}),V.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(ee,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,v.localize)(6,null),click:()=>{const Z=this.d?.getSelection()?.map(oe=>{if(!(!oe||!("pid"in oe)))return oe.pid}).filter(oe=>!!oe);Z?.includes(ee)||(Z.length=0,Z.push(ee));const pe=Z?.map(oe=>document.getElementById(`pid-${oe}`)).filter(oe=>!!oe);if(pe){const oe=pe.map(ce=>ce.innerText).filter(ce=>!!ce);this.c.writeClipboardText(oe.join(`
`))}}}),V.push({label:(0,v.localize)(7,null),click:()=>{const Z=document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),D&&_&&this.i(D.cmd)&&(V.push({type:"separator"}),V.push({label:(0,v.localize)(8,null),click:()=>{this.j(D)}})),(0,y.popup)(V)}m(D){setTimeout(()=>{const _=Date.now(),V=D+_-this.a;this.a=_,V>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.m(V)},200)}}function u(){const p=(0,i.createStyleSheet)();p.id="codiconStyles";const D=(0,o.getIconsStyleSheet)(void 0);function _(){p.textContent=D.getCSS()}const V=new H.RunOnceScheduler(_,0);D.onDidChange(()=>V.schedule()),V.schedule()}function C(p){const D=p.data.platform==="win32"?"windows":p.data.platform==="linux"?"linux":"mac";document.body.classList.add(D),u(),(0,n.applyZoom)(p.data.zoomLevel),new F(p.windowId,p.data)}t.startup=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58e7c7b8865e3c3ea77055461ffb5d656a7a46af/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
