/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function($){for(var e=[],T=0,R=$.length;T<R;T++)e[T]=Y[$[T]];return e};define(Y[49],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(b,g,l)=>{let m=null,w=null;if(typeof l.value=="function"?(m="value",w=l.value):typeof l.get=="function"&&(m="get",w=l.get),!w)throw new Error("not supported");l[m]=N(w,g)}}function R(N,b,g){let l=null,m=null;if(typeof g.value=="function"?(l="value",m=g.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",m=g.get),!m)throw new Error("not supported");const w=`$memoize$${b}`;g[l]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[w]}}e.memoize=R;function k(N,b,g){return T((l,m)=>{const w=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...I){this[p]||(this[p]=g?g():void 0),clearTimeout(this[w]),b&&(this[p]=b(this[p],...I),I=[this[p]]),this[w]=setTimeout(()=>{l.apply(this,I),this[p]=g?g():void 0},N)}})}e.debounce=k;function L(N,b,g){return T((l,m)=>{const w=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,I=`$throttle$lastRun$${m}`,y=`$throttle$pending$${m}`;return function(...S){if(this[p]||(this[p]=g?g():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...S)),this[y])return;const E=this[I]+N;E<=Date.now()?(this[I]=Date.now(),l.apply(this,[this[p]]),this[p]=g?g():void 0):(this[y]=!0,this[w]=setTimeout(()=>{this[y]=!1,this[I]=Date.now(),l.apply(this,[this[p]]),this[p]=g?g():void 0},E-Date.now()))}})}e.throttle=L}),define(Y[69],Q([0,1,11]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(g,l){if(!g)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=R;function k(g,l="Unreachable"){throw new Error(l)}e.assertNever=k;function L(g){if(!g)throw new T.BugIndicatingError("Assertion Failed")}e.assert=L;function N(g){if(!g()){debugger;g(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function b(g,l){let m=0;for(;m<g.length-1;){const w=g[m],p=g[m+1];if(!l(w,p))return!1;m++}return!0}e.checkAdjacentItems=b}),define(Y[50],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function N(i,n=!1){let t=0;const r=i.length;let o="",c=0,a=16,h=0;function O(Z){let he=0,ce=0;for(;he<Z;){const se=i.charCodeAt(t);if(se>=48&&se<=57)ce=ce*16+se-48;else if(se>=65&&se<=70)ce=ce*16+se-65+10;else if(se>=97&&se<=102)ce=ce*16+se-97+10;else break;t++,he++}return he<Z&&(ce=-1),ce}function C(Z){t=Z,o="",c=0,a=16,h=0}function W(){const Z=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&l(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&l(i.charCodeAt(t)))for(t++;t<i.length&&l(i.charCodeAt(t));)t++;else return h=3,i.substring(Z,t);let he=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&l(i.charCodeAt(t))){for(t++;t<i.length&&l(i.charCodeAt(t));)t++;he=t}else h=3;return i.substring(Z,he)}function X(){let Z="",he=t;for(;;){if(t>=r){Z+=i.substring(he,t),h=2;break}const ce=i.charCodeAt(t);if(ce===34){Z+=i.substring(he,t),t++;break}if(ce===92){if(Z+=i.substring(he,t),t++,t>=r){h=2;break}switch(i.charCodeAt(t++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const ge=O(4);ge>=0?Z+=String.fromCharCode(ge):h=4;break}default:h=5}he=t;continue}if(ce>=0&&ce<=31)if(g(ce)){Z+=i.substring(he,t),h=2;break}else h=6;t++}return Z}function J(){if(o="",h=0,c=t,t>=r)return c=r,a=17;let Z=i.charCodeAt(t);if(b(Z)){do t++,o+=String.fromCharCode(Z),Z=i.charCodeAt(t);while(b(Z));return a=15}if(g(Z))return t++,o+=String.fromCharCode(Z),Z===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(Z){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=X(),a=10;case 47:{const he=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!g(i.charCodeAt(t));)t++;return o=i.substring(he,t),a=12}if(i.charCodeAt(t+1)===42){t+=2;const ce=r-1;let se=!1;for(;t<ce;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,se=!0;break}t++}return se||(t++,h=1),o=i.substring(he,t),a=13}return o+=String.fromCharCode(Z),t++,a=16}case 45:if(o+=String.fromCharCode(Z),t++,t===r||!l(i.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=W(),a=11;default:for(;t<r&&ie(Z);)t++,Z=i.charCodeAt(t);if(c!==t){switch(o=i.substring(c,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(Z),t++,a=16}}function ie(Z){if(b(Z)||g(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Z;do Z=J();while(Z>=12&&Z<=15);return Z}return{setPosition:C,getPosition:()=>t,scan:n?re:J,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>h}}e.createScanner=N;function b(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function l(i){return i>=48&&i<=57}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function w(i,n){const t=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(O,C,W,X){c.value=O,c.offset=C,c.length=W,c.type=X,c.colonOffset=void 0,o=c}try{v(i,{onObjectBegin:(O,C)=>{if(n<=O)throw r;o=void 0,a=n>O,t.push("")},onObjectProperty:(O,C,W)=>{if(n<C||(h(O,C,W,"property"),t[t.length-1]=O,n<=C+W))throw r},onObjectEnd:(O,C)=>{if(n<=O)throw r;o=void 0,t.pop()},onArrayBegin:(O,C)=>{if(n<=O)throw r;o=void 0,t.push(0)},onArrayEnd:(O,C)=>{if(n<=O)throw r;o=void 0,t.pop()},onLiteralValue:(O,C,W)=>{if(n<C||(h(O,C,W,s(O)),n<=C+W))throw r},onSeparator:(O,C,W)=>{if(n<=C)throw r;if(O===":"&&o&&o.type==="property")o.colonOffset=C,a=!1,o=void 0;else if(O===","){const X=t[t.length-1];typeof X=="number"?t[t.length-1]=X+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(O){if(O!==r)throw O}return{path:t,previousNode:o,isAtPropertyKey:a,matches:O=>{let C=0;for(let W=0;C<O.length&&W<t.length;W++)if(O[C]===t[W]||O[C]==="*")C++;else if(O[C]!=="**")return!1;return C===O.length}}}e.getLocation=w;function p(i,n=[],t=L.DEFAULT){let r=null,o=[];const c=[];function a(O){Array.isArray(o)?o.push(O):r!==null&&(o[r]=O)}return v(i,{onObjectBegin:()=>{const O={};a(O),c.push(o),o=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const O=[];a(O),c.push(o),o=O,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(O,C,W)=>{n.push({error:O,offset:C,length:W})}},t),o[0]}e.parse=p;function I(i,n=[],t=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(O){r.type==="property"&&(r.length=O-r.offset,r=r.parent)}function c(O){return r.children.push(O),O}v(i,{onObjectBegin:O=>{r=c({type:"object",offset:O,length:-1,parent:r,children:[]})},onObjectProperty:(O,C,W)=>{r=c({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:O,offset:C,length:W,parent:r})},onObjectEnd:(O,C)=>{r.length=O+C-r.offset,r=r.parent,o(O+C)},onArrayBegin:(O,C)=>{r=c({type:"array",offset:O,length:-1,parent:r,children:[]})},onArrayEnd:(O,C)=>{r.length=O+C-r.offset,r=r.parent,o(O+C)},onLiteralValue:(O,C,W)=>{c({type:s(O),offset:C,length:W,parent:r,value:O}),o(C+W)},onSeparator:(O,C,W)=>{r.type==="property"&&(O===":"?r.colonOffset=C:O===","&&o(C))},onError:(O,C,W)=>{n.push({error:O,offset:C,length:W})}},t);const h=r.children[0];return h&&delete h.parent,h}e.parseTree=I;function y(i,n){if(!i)return;let t=i;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===r){t=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=y;function S(i){if(!i.parent||!i.parent.children)return[];const n=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;n.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&n.push(t)}return n}e.getNodePath=S;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const n=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(n[t.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function u(i,n,t=!1){return n>=i.offset&&n<i.offset+i.length||t&&n===i.offset+i.length}e.contains=u;function d(i,n,t=!1){if(u(i,n,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=d(r[o],n,t);if(c)return c}return i}}e.findNodeAtOffset=d;function v(i,n,t=L.DEFAULT){const r=N(i,!1);function o(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(q){return q?ee=>q(ee,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),h=c(n.onObjectProperty),O=o(n.onObjectEnd),C=o(n.onArrayBegin),W=o(n.onArrayEnd),X=c(n.onLiteralValue),J=c(n.onSeparator),ie=o(n.onComment),re=c(n.onError),Z=t&&t.disallowComments,he=t&&t.allowTrailingComma;function ce(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:Z||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(q){case 12:case 13:Z?se(10):ie();break;case 16:se(1);break;case 15:case 14:break;default:return q}}}function se(q,ee=[],P=[]){if(re(q),ee.length+P.length>0){let D=r.getToken();for(;D!==17;){if(ee.indexOf(D)!==-1){ce();break}else if(P.indexOf(D)!==-1)break;D=ce()}}}function ge(q){const ee=r.getTokenValue();return q?X(ee):h(ee),ce(),!0}function M(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(se(2),q=0)}catch{se(2)}X(q);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return ce(),!0}function A(){return r.getToken()!==10?(se(3,[],[2,5]),!1):(ge(!1),r.getToken()===6?(J(":"),ce(),G()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function U(){a(),ce();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||se(4,[],[]),J(","),ce(),r.getToken()===2&&he)break}else q&&se(6,[],[]);A()||se(4,[],[2,5]),q=!0}return O(),r.getToken()!==2?se(7,[2],[]):ce(),!0}function V(){C(),ce();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||se(4,[],[]),J(","),ce(),r.getToken()===4&&he)break}else q&&se(6,[],[]);G()||se(4,[],[4,5]),q=!0}return W(),r.getToken()!==4?se(8,[4],[]):ce(),!0}function G(){switch(r.getToken()){case 3:return V();case 1:return U();case 10:return ge(!0);default:return M()}}return ce(),r.getToken()===17?t.allowEmptyContent?!0:(se(4,[],[]),!1):G()?(r.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=v;function f(i,n){const t=N(i),r=[];let o,c=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==a&&r.push(i.substring(c,a)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),c=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function $(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function N(g){L.push(g,Date.now())}function b(){const g=[];for(let l=0;l<L.length;l+=2)g.push({name:L[l],startTime:L[l+1]});return g}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(k+N.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=T(R))}(),function($,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var R in T)(typeof exports=="object"?exports:$)[R]=T[R]}}(typeof self<"u"?self:this,function(){return function($){var e={};function T(R){if(e[R])return e[R].exports;var k=e[R]={i:R,l:!1,exports:{}};return $[R].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=$,T.c=e,T.d=function(R,k,L){T.o(R,k)||Object.defineProperty(R,k,{enumerable:!0,get:L})},T.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},T.t=function(R,k){if(1&k&&(R=T(R)),8&k||4&k&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&k&&typeof R!="string")for(var N in R)T.d(L,N,function(b){return R[b]}.bind(null,N));return L},T.n=function(R){var k=R&&R.__esModule?function(){return R.default}:function(){return R};return T.d(k,"a",k),k},T.o=function(R,k){return Object.prototype.hasOwnProperty.call(R,k)},T.p="",T(T.s=0)}([function($,e,T){(function(R){var k;e=$.exports=P,k=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],g=e.src=[],l=0,m=l++;g[m]="0|[1-9]\\d*";var w=l++;g[w]="[0-9]+";var p=l++;g[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=l++;g[I]="("+g[m]+")\\.("+g[m]+")\\.("+g[m]+")";var y=l++;g[y]="("+g[w]+")\\.("+g[w]+")\\.("+g[w]+")";var S=l++;g[S]="(?:"+g[m]+"|"+g[p]+")";var E=l++;g[E]="(?:"+g[w]+"|"+g[p]+")";var u=l++;g[u]="(?:-("+g[S]+"(?:\\."+g[S]+")*))";var d=l++;g[d]="(?:-?("+g[E]+"(?:\\."+g[E]+")*))";var v=l++;g[v]="[0-9A-Za-z-]+";var f=l++;g[f]="(?:\\+("+g[v]+"(?:\\."+g[v]+")*))";var s=l++,i="v?"+g[I]+g[u]+"?"+g[f]+"?";g[s]="^"+i+"$";var n="[v=\\s]*"+g[y]+g[d]+"?"+g[f]+"?",t=l++;g[t]="^"+n+"$";var r=l++;g[r]="((?:<|>)?=?)";var o=l++;g[o]=g[w]+"|x|X|\\*";var c=l++;g[c]=g[m]+"|x|X|\\*";var a=l++;g[a]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[u]+")?"+g[f]+"?)?)?";var h=l++;g[h]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[d]+")?"+g[f]+"?)?)?";var O=l++;g[O]="^"+g[r]+"\\s*"+g[a]+"$";var C=l++;g[C]="^"+g[r]+"\\s*"+g[h]+"$";var W=l++;g[W]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=l++;g[X]="(?:~>?)";var J=l++;g[J]="(\\s*)"+g[X]+"\\s+",b[J]=new RegExp(g[J],"g");var ie=l++;g[ie]="^"+g[X]+g[a]+"$";var re=l++;g[re]="^"+g[X]+g[h]+"$";var Z=l++;g[Z]="(?:\\^)";var he=l++;g[he]="(\\s*)"+g[Z]+"\\s+",b[he]=new RegExp(g[he],"g");var ce=l++;g[ce]="^"+g[Z]+g[a]+"$";var se=l++;g[se]="^"+g[Z]+g[h]+"$";var ge=l++;g[ge]="^"+g[r]+"\\s*("+n+")$|^$";var M=l++;g[M]="^"+g[r]+"\\s*("+i+")$|^$";var A=l++;g[A]="(\\s*)"+g[r]+"\\s*("+n+"|"+g[a]+")",b[A]=new RegExp(g[A],"g");var U=l++;g[U]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var V=l++;g[V]="^\\s*("+g[h]+")\\s+-\\s+("+g[h]+")\\s*$";var G=l++;g[G]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,g[q]),b[q]||(b[q]=new RegExp(g[q]));function ee(z,H){if(z instanceof P)return z;if(typeof z!="string"||z.length>L||!(H?b[t]:b[s]).test(z))return null;try{return new P(z,H)}catch{return null}}function P(z,H){if(z instanceof P){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof P))return new P(z,H);k("SemVer",z,H),this.loose=H;var K=z.trim().match(H?b[t]:b[s]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var pe=+ue;if(pe>=0&&pe<N)return pe}return ue}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=ee,e.valid=function(z,H){var K=ee(z,H);return K?K.version:null},e.clean=function(z,H){var K=ee(z.trim().replace(/^[=v]+/,""),H);return K?K.version:null},e.SemVer=P,P.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},P.prototype.toString=function(){return this.version},P.prototype.compare=function(z){return k("SemVer.compare",this.version,this.loose,z),z instanceof P||(z=new P(z,this.loose)),this.compareMain(z)||this.comparePre(z)},P.prototype.compareMain=function(z){return z instanceof P||(z=new P(z,this.loose)),j(this.major,z.major)||j(this.minor,z.minor)||j(this.patch,z.patch)},P.prototype.comparePre=function(z){if(z instanceof P||(z=new P(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],ue=z.prerelease[H];if(k("prerelease compare",H,K,ue),K===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(K===void 0)return-1;if(K!==ue)return j(K,ue)}while(++H)},P.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,K,ue){typeof K=="string"&&(ue=K,K=void 0);try{return new P(z,K).inc(H,ue).version}catch{return null}},e.diff=function(z,H){if(te(z,H))return null;var K=ee(z),ue=ee(H);if(K.prerelease.length||ue.prerelease.length){for(var pe in K)if((pe==="major"||pe==="minor"||pe==="patch")&&K[pe]!==ue[pe])return"pre"+pe;return"prerelease"}for(var pe in K)if((pe==="major"||pe==="minor"||pe==="patch")&&K[pe]!==ue[pe])return pe},e.compareIdentifiers=j;var D=/^[0-9]+$/;function j(z,H){var K=D.test(z),ue=D.test(H);return K&&ue&&(z=+z,H=+H),K&&!ue?-1:ue&&!K?1:z<H?-1:z>H?1:0}function F(z,H,K){return new P(z,K).compare(new P(H,K))}function B(z,H,K){return F(z,H,K)>0}function x(z,H,K){return F(z,H,K)<0}function te(z,H,K){return F(z,H,K)===0}function oe(z,H,K){return F(z,H,K)!==0}function me(z,H,K){return F(z,H,K)>=0}function ye(z,H,K){return F(z,H,K)<=0}function ae(z,H,K,ue){var pe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),pe=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),pe=z!==K;break;case"":case"=":case"==":pe=te(z,K,ue);break;case"!=":pe=oe(z,K,ue);break;case">":pe=B(z,K,ue);break;case">=":pe=me(z,K,ue);break;case"<":pe=x(z,K,ue);break;case"<=":pe=ye(z,K,ue);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function ne(z,H){if(z instanceof ne){if(z.loose===H)return z;z=z.value}if(!(this instanceof ne))return new ne(z,H);k("comparator",z,H),this.loose=H,this.parse(z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(z,H){return j(H,z)},e.major=function(z,H){return new P(z,H).major},e.minor=function(z,H){return new P(z,H).minor},e.patch=function(z,H){return new P(z,H).patch},e.compare=F,e.compareLoose=function(z,H){return F(z,H,!0)},e.rcompare=function(z,H,K){return F(H,z,K)},e.sort=function(z,H){return z.sort(function(K,ue){return e.compare(K,ue,H)})},e.rsort=function(z,H){return z.sort(function(K,ue){return e.rcompare(K,ue,H)})},e.gt=B,e.lt=x,e.eq=te,e.neq=oe,e.gte=me,e.lte=ye,e.cmp=ae,e.Comparator=ne;var de={};function le(z,H){if(z instanceof le)return z.loose===H?z:new le(z.raw,H);if(z instanceof ne)return new le(z.value,H);if(!(this instanceof le))return new le(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ve(z){return!z||z.toLowerCase()==="x"||z==="*"}function Me(z,H,K,ue,pe,ke,Se,Re,Ie,Oe,je,De,Le){return((H=ve(K)?"":ve(ue)?">="+K+".0.0":ve(pe)?">="+K+"."+ue+".0":">="+H)+" "+(Re=ve(Ie)?"":ve(Oe)?"<"+(+Ie+1)+".0.0":ve(je)?"<"+Ie+"."+(+Oe+1)+".0":De?"<="+Ie+"."+Oe+"."+je+"-"+De:"<="+Re)).trim()}function Te(z,H){for(var K=0;K<z.length;K++)if(!z[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<z.length;K++)if(k(z[K].semver),z[K].semver!==de&&z[K].semver.prerelease.length>0){var ue=z[K].semver;if(ue.major===H.major&&ue.minor===H.minor&&ue.patch===H.patch)return!0}return!1}return!0}function Ae(z,H,K){try{H=new le(H,K)}catch{return!1}return H.test(z)}function Ue(z,H,K,ue){var pe,ke,Se,Re,Ie;switch(z=new P(z,ue),H=new le(H,ue),K){case">":pe=B,ke=ye,Se=x,Re=">",Ie=">=";break;case"<":pe=x,ke=me,Se=B,Re="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(z,H,ue))return!1;for(var Oe=0;Oe<H.set.length;++Oe){var je=H.set[Oe],De=null,Le=null;if(je.forEach(function(Ce){Ce.semver===de&&(Ce=new ne(">=0.0.0")),De=De||Ce,Le=Le||Ce,pe(Ce.semver,De.semver,ue)?De=Ce:Se(Ce.semver,Le.semver,ue)&&(Le=Ce)}),De.operator===Re||De.operator===Ie||(!Le.operator||Le.operator===Re)&&ke(z,Le.semver)||Le.operator===Ie&&Se(z,Le.semver))return!1}return!0}ne.prototype.parse=function(z){var H=this.loose?b[ge]:b[M],K=z.match(H);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new P(K[2],this.loose):this.semver=de},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(z){return k("Comparator.test",z,this.loose),this.semver===de||(typeof z=="string"&&(z=new P(z,this.loose)),ae(z,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(z,H){if(!(z instanceof ne))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new le(z.value,H),Ae(this.value,K,H);if(z.operator==="")return K=new le(this.value,H),Ae(z.semver,K,H);var ue=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),ke=this.semver.version===z.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Re=ae(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ie=ae(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ue||pe||ke&&Se||Re||Ie},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),k("range",z,H);var K=H?b[V]:b[U];z=z.replace(K,Me),k("hyphen replace",z),z=z.replace(b[A],"$1$2$3"),k("comparator trim",z,b[A]),z=(z=(z=z.replace(b[J],"$1~")).replace(b[he],"$1^")).split(/\s+/).join(" ");var ue=H?b[ge]:b[M],pe=z.split(" ").map(function(ke){return function(Se,Re){return k("comp",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(je){return function(De,Le){k("caret",De,Le);var Ce=Le?b[se]:b[ce];return De.replace(Ce,function(Fe,we,Ee,be,Pe){var Ne;return k("caret",De,Fe,we,Ee,be,Pe),ve(we)?Ne="":ve(Ee)?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":ve(be)?Ne=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":Pe?(k("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ne=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+Pe+" <"+(+we+1)+".0.0"):(k("no pr"),Ne=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+" <"+(+we+1)+".0.0"),k("caret return",Ne),Ne})}(je,Oe)}).join(" ")}(Se,Re),k("caret",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(je){return function(De,Le){var Ce=Le?b[re]:b[ie];return De.replace(Ce,function(Fe,we,Ee,be,Pe){var Ne;return k("tilde",De,Fe,we,Ee,be,Pe),ve(we)?Ne="":ve(Ee)?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":ve(be)?Ne=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":Pe?(k("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ne=">="+we+"."+Ee+"."+be+Pe+" <"+we+"."+(+Ee+1)+".0"):Ne=">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0",k("tilde return",Ne),Ne})}(je,Oe)}).join(" ")}(Se,Re),k("tildes",Se),Se=function(Ie,Oe){return k("replaceXRanges",Ie,Oe),Ie.split(/\s+/).map(function(je){return function(De,Le){De=De.trim();var Ce=Le?b[C]:b[O];return De.replace(Ce,function(Fe,we,Ee,be,Pe,Ne){k("xRange",De,Fe,we,Ee,be,Pe,Ne);var We=ve(Ee),ze=We||ve(be),Be=ze||ve(Pe);return we==="="&&Be&&(we=""),We?Fe=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(be=0),Be&&(Pe=0),we===">"?(we=">=",ze?(Ee=+Ee+1,be=0,Pe=0):Be&&(be=+be+1,Pe=0)):we==="<="&&(we="<",ze?Ee=+Ee+1:be=+be+1),Fe=we+Ee+"."+be+"."+Pe):ze?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Fe=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),k("xRange return",Fe),Fe})}(je,Oe)}).join(" ")}(Se,Re),k("xrange",Se),Se=function(Ie,Oe){return k("replaceStars",Ie,Oe),Ie.trim().replace(b[G],"")}(Se,Re),k("stars",Se),Se}(ke,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(ke){return!!ke.match(ue)})),pe=pe.map(function(ke){return new ne(ke,H)})},le.prototype.intersects=function(z,H){if(!(z instanceof le))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ue){return z.set.some(function(pe){return pe.every(function(ke){return ue.intersects(ke,H)})})})})},e.toComparators=function(z,H){return new le(z,H).set.map(function(K){return K.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},le.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new P(z,this.loose));for(var H=0;H<this.set.length;H++)if(Te(this.set[H],z))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(z,H,K){var ue=null,pe=null;try{var ke=new le(H,K)}catch{return null}return z.forEach(function(Se){ke.test(Se)&&(ue&&pe.compare(Se)!==-1||(pe=new P(ue=Se,K)))}),ue},e.minSatisfying=function(z,H,K){var ue=null,pe=null;try{var ke=new le(H,K)}catch{return null}return z.forEach(function(Se){ke.test(Se)&&(ue&&pe.compare(Se)!==1||(pe=new P(ue=Se,K)))}),ue},e.validRange=function(z,H){try{return new le(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,K){return Ue(z,H,"<",K)},e.gtr=function(z,H,K){return Ue(z,H,">",K)},e.outside=Ue,e.prerelease=function(z,H){var K=ee(z,H);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(z,H,K){return z=new le(z,K),H=new le(H,K),z.intersects(H)},e.coerce=function(z){if(z instanceof P)return z;if(typeof z!="string")return null;var H=z.match(b[W]);return H==null?null:ee((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function($,e){var T,R,k=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b(E){if(T===setTimeout)return setTimeout(E,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(E,0);try{return T(E,0)}catch{try{return T.call(null,E,0)}catch{return T.call(this,E,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch{T=L}try{R=typeof clearTimeout=="function"?clearTimeout:N}catch{R=N}})();var g,l=[],m=!1,w=-1;function p(){m&&g&&(m=!1,g.length?l=g.concat(l):w=-1,l.length&&I())}function I(){if(!m){var E=b(p);m=!0;for(var u=l.length;u;){for(g=l,l=[];++w<u;)g&&g[w].run();w=-1,u=l.length}g=null,m=!1,function(d){if(R===clearTimeout)return clearTimeout(d);if((R===N||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(d);try{R(d)}catch{try{return R.call(null,d)}catch{return R.call(this,d)}}}(E)}}function y(E,u){this.fun=E,this.array=u}function S(){}k.nextTick=function(E){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];l.push(new y(E,u)),l.length!==1||m||b(I)},y.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Y[70],Q([0,1]),function($,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(b,g,l){this.level=b,this.key=g,this.value=l,this.forward=[]}}const k=void 0;class L{constructor(b,g=2**16){this.comparator=b,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new R(this.c,k,k)}get size(){return this.f}clear(){this.e=new R(this.c,k,k)}has(b){return Boolean(L.g(this,b,this.comparator))}get(b){return L.g(this,b,this.comparator)?.value}set(b,g){return L.h(this,b,g,this.comparator)&&(this.f+=1),this}delete(b){const g=L.k(this,b,this.comparator);return g&&(this.f-=1),g}forEach(b,g){let l=this.e.forward[0];for(;l;)b.call(g,l.value,l.key,this),l=l.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",g=this.e.forward[0];for(;g;)b+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return b}static g(b,g,l){let m=b.e;for(let w=b.d-1;w>=0;w--)for(;m.forward[w]&&l(m.forward[w].key,g)<0;)m=m.forward[w];if(m=m.forward[0],m&&l(m.key,g)===0)return m}static h(b,g,l,m){const w=[];let p=b.e;for(let I=b.d-1;I>=0;I--){for(;p.forward[I]&&m(p.forward[I].key,g)<0;)p=p.forward[I];w[I]=p}if(p=p.forward[0],p&&m(p.key,g)===0)return p.value=l,!1;{const I=L.j(b);if(I>b.d){for(let y=b.d;y<I;y++)w[y]=b.e;b.d=I}p=new R(I,g,l);for(let y=0;y<I;y++)p.forward[y]=w[y].forward[y],w[y].forward[y]=p;return!0}}static j(b,g=.5){let l=1;for(;Math.random()<g&&l<b.c;)l+=1;return l}static k(b,g,l){const m=[];let w=b.e;for(let p=b.d-1;p>=0;p--){for(;w.forward[p]&&l(w.forward[p].key,g)<0;)w=w.forward[p];m[p]=w}if(w=w.forward[0],!w||l(w.key,g)!==0)return!1;for(let p=0;p<b.d&&m[p].forward[p]===w;p++)m[p].forward[p]=w.forward[p];for(;b.d>0&&b.e.forward[b.d-1]===k;)b.d-=1;return!0}}e.SkipList=L}),define(Y[43],Q([0,1,11,2]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=k;function L(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function N(f){const s=f;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=N;function b(f,s){return new g(f,s)}e.newWriteableStream=b;class g{constructor(s,i){this.e=s,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(i=>i(s))}h(s){this.c.error.length===0?(0,T.onUnexpectedError)(s):this.c.error.slice(0).forEach(i=>i(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,i){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(s,i){if(this.a.destroyed)return;let n;switch(s){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const t=n.indexOf(i);t>=0&&n.splice(t,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(f,s){const i=[];let n;for(;(n=f.read())!==null;)i.push(n);return s(i)}e.consumeReadable=l;function m(f,s,i){const n=[];let t;for(;(t=f.read())!==null&&n.length<i;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=m;function w(f,s){return new Promise((i,n)=>{const t=[];p(f,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(t):void 0)}})})}e.consumeStream=w;function p(f,s){let i=!1;return f.on("error",n=>{i||s.onError(n)}),f.on("end",()=>{i||s.onEnd()}),f.on("data",n=>{i||s.onData(n)}),(0,R.toDisposable)(()=>i=!0)}e.listenStream=p;function I(f,s){return new Promise((i,n)=>{const t=new R.DisposableStore,r=[],o=h=>{if(r.push(h),r.length>s)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},c=h=>n(h),a=()=>i({stream:f,buffer:r,ended:!0});t.add((0,R.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),t.add((0,R.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,R.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=I;function y(f,s){const i=b(s);return i.end(f),i}e.toStream=y;function S(){const f=b(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function E(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=E;function u(f,s,i){const n=b(i);return p(f,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}e.transform=u;function d(f,s,i){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=d;function v(f,s,i){let n=!1;const t=b(i);return p(s,{onData:r=>n?t.write(r):(n=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(f)),t.end()}}),t}e.prefixedStream=v}),define(Y[15],Q([0,1,43]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let k,L;class N{static alloc(h){return R?new N(Buffer.allocUnsafe(h)):new N(new Uint8Array(h))}static wrap(h){return R&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new N(h)}static fromString(h,O){return!(O?.dontUseNodeBuffer||!1)&&R?new N(Buffer.from(h)):(k||(k=new TextEncoder),new N(k.encode(h)))}static fromByteArray(h){const O=N.alloc(h.length);for(let C=0,W=h.length;C<W;C++)O.buffer[C]=h[C];return O}static concat(h,O){if(typeof O>"u"){O=0;for(let X=0,J=h.length;X<J;X++)O+=h[X].byteLength}const C=N.alloc(O);let W=0;for(let X=0,J=h.length;X<J;X++){const ie=h[X];C.set(ie,W),W+=ie.byteLength}return C}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=N.alloc(this.byteLength);return h.set(this),h}toString(){return R?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,O){return new N(this.buffer.subarray(h,O))}set(h,O){if(h instanceof N)this.buffer.set(h.buffer,O);else if(h instanceof Uint8Array)this.buffer.set(h,O);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),O);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return l(this.buffer,h)}writeUInt32BE(h,O){m(this.buffer,h,O)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,O){p(this.buffer,h,O)}readUInt8(h){return I(this.buffer,h)}writeUInt8(h,O){y(this.buffer,h,O)}}e.VSBuffer=N;function b(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=b;function g(a,h,O){a[O+0]=h&255,h=h>>>8,a[O+1]=h&255}e.writeUInt16LE=g;function l(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=l;function m(a,h,O){a[O+3]=h,h=h>>>8,a[O+2]=h,h=h>>>8,a[O+1]=h,h=h>>>8,a[O]=h}e.writeUInt32BE=m;function w(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=w;function p(a,h,O){a[O+0]=h&255,h=h>>>8,a[O+1]=h&255,h=h>>>8,a[O+2]=h&255,h=h>>>8,a[O+3]=h&255}e.writeUInt32LE=p;function I(a,h){return a[h]}e.readUInt8=I;function y(a,h,O){a[O]=h}e.writeUInt8=y;function S(a){return T.consumeReadable(a,h=>N.concat(h))}e.readableToBuffer=S;function E(a){return T.toReadable(a)}e.bufferToReadable=E;function u(a){return T.consumeStream(a,h=>N.concat(h))}e.streamToBuffer=u;async function d(a){return a.ended?N.concat(a.buffer):N.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=d;function v(a){return T.toStream(a,h=>N.concat(h))}e.bufferToStream=v;function f(a){return T.transform(a,{data:h=>typeof h=="string"?N.fromString(h):N.wrap(h)},h=>N.concat(h))}e.streamToBufferReadableStream=f;function s(a){return T.newWriteableStream(h=>N.concat(h),a)}e.newWriteableBufferStream=s;function i(a,h){return T.prefixedReadable(a,h,O=>N.concat(O))}e.prefixedBufferReadable=i;function n(a,h){return T.prefixedStream(a,h,O=>N.concat(O))}e.prefixedBufferStream=n;function t(a){let h=0,O=0,C=0;const W=new Uint8Array(Math.floor(a.length/4*3)),X=ie=>{switch(O){case 3:W[C++]=h|ie,O=0;break;case 2:W[C++]=h|ie>>>2,h=ie<<6,O=3;break;case 1:W[C++]=h|ie>>>4,h=ie<<4,O=2;break;default:h=ie<<2,O=1}};for(let ie=0;ie<a.length;ie++){const re=a.charCodeAt(ie);if(re>=65&&re<=90)X(re-65);else if(re>=97&&re<=122)X(re-97+26);else if(re>=48&&re<=57)X(re-48+52);else if(re===43||re===45)X(62);else if(re===47||re===95)X(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ie]}`)}}const J=C;for(;O>0;)X(0);return N.wrap(W).slice(0,J)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},h=!0,O=!1){const C=O?o:r;let W="";const X=a.byteLength%3;let J=0;for(;J<a.byteLength-X;J+=3){const ie=a[J+0],re=a[J+1],Z=a[J+2];W+=C[ie>>>2],W+=C[(ie<<4|re>>>4)&63],W+=C[(re<<2|Z>>>6)&63],W+=C[Z&63]}if(X===1){const ie=a[J+0];W+=C[ie>>>2],W+=C[ie<<4&63],h&&(W+="==")}else if(X===2){const ie=a[J+0],re=a[J+1];W+=C[ie>>>2],W+=C[(ie<<4|re>>>4)&63],W+=C[re<<2&63],h&&(W+="=")}return W}e.encodeBase64=c}),define(Y[28],Q([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([v,f])=>{d[v]=f&&typeof f=="object"?R(f):f}),d}e.deepClone=R;function k(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const v=d.shift();Object.freeze(v);for(const f in v)if(L.call(v,f)){const s=v[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,T.isTypedArray)(s)&&d.push(s)}}return u}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function N(u,d){return b(u,d,new Set)}e.cloneAndChange=N;function b(u,d,v){if((0,T.isUndefinedOrNull)(u))return u;const f=d(u);if(typeof f<"u")return f;if(Array.isArray(u)){const s=[];for(const i of u)s.push(b(i,d,v));return s}if((0,T.isObject)(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const s={};for(const i in u)L.call(u,i)&&(s[i]=b(u[i],d,v));return v.delete(u),s}return u}function g(u,d,v=!0){return(0,T.isObject)(u)?((0,T.isObject)(d)&&Object.keys(d).forEach(f=>{f in u?v&&((0,T.isObject)(u[f])&&(0,T.isObject)(d[f])?g(u[f],d[f],v):u[f]=d[f]):u[f]=d[f]}),u):d}e.mixin=g;function l(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let v,f;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(v=0;v<u.length;v++)if(!l(u[v],d[v]))return!1}else{const s=[];for(f in u)s.push(f);s.sort();const i=[];for(f in d)i.push(f);if(i.sort(),!l(s,i))return!1;for(v=0;v<s.length;v++)if(!l(u[s[v]],d[s[v]]))return!1}return!0}e.equals=l;function m(u){const d=new Set;return JSON.stringify(u,(v,f)=>{if((0,T.isObject)(f)||Array.isArray(f)){if(d.has(f))return"[Circular]";d.add(f)}return f})}e.safeStringify=m;function w(u,d){const v=Object.create(null);return!u||!d||Object.keys(d).forEach(s=>{const i=u[s],n=d[s];l(i,n)||(v[s]=n)}),v}e.distinct=w;function p(u,d){const v=d.toLowerCase(),f=Object.keys(u).find(s=>s.toLowerCase()===v);return f?u[f]:u[d]}e.getCaseInsensitive=p;function I(u,d){const v=Object.create(null);for(const[f,s]of Object.entries(u))d(f,s)&&(v[f]=s);return v}e.filter=I;function y(u){let d=[],v=Object.getPrototypeOf(u);for(;Object.prototype!==v;)d=d.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return d}e.getAllPropertyNames=y;function S(u){const d=[];for(const v of y(u))typeof u[v]=="function"&&d.push(v);return d}e.getAllMethodNames=S;function E(u,d){const v=s=>function(){const i=Array.prototype.slice.call(arguments,0);return d(s,i)},f={};for(const s of u)f[s]=v(s);return f}e.createProxyObject=E}),define(Y[31],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(k){return T.test(k)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let g=0;g<b.length;g++)b[g]=Math.floor(Math.random()*256);return b};const L=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let g=0,l="";return l+=N[L[g++]],l+=N[L[g++]],l+=N[L[g++]],l+=N[L[g++]],l+="-",l+=N[L[g++]],l+=N[L[g++]],l+="-",l+=N[L[g++]],l+=N[L[g++]],l+="-",l+=N[L[g++]],l+=N[L[g++]],l+="-",l+=N[L[g++]],l+=N[L[g++]],l+=N[L[g++]],l+=N[L[g++]],l+=N[L[g++]],l+=N[L[g++]],l}}()}),define(Y[71],Q([5,6]),function($,e){return $.create("vs/base/common/date",e)}),define(Y[72],Q([0,1,71]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,L=k*24,N=L*7,b=L*30,g=L*365;function l(w,p,I){typeof w!="number"&&(w=w.getTime());const y=Math.round((new Date().getTime()-w)/1e3);if(y<-30)return(0,T.localize)(0,null,l(new Date().getTime()+y*1e3,!1));if(y<30)return(0,T.localize)(1,null);let S;return y<R?(S=y,p?S===1?I?(0,T.localize)(2,null,S):(0,T.localize)(3,null,S):I?(0,T.localize)(4,null,S):(0,T.localize)(5,null,S):S===1?I?(0,T.localize)(6,null,S):(0,T.localize)(7,null,S):I?(0,T.localize)(8,null,S):(0,T.localize)(9,null,S)):y<k?(S=Math.floor(y/R),p?S===1?I?(0,T.localize)(10,null,S):(0,T.localize)(11,null,S):I?(0,T.localize)(12,null,S):(0,T.localize)(13,null,S):S===1?I?(0,T.localize)(14,null,S):(0,T.localize)(15,null,S):I?(0,T.localize)(16,null,S):(0,T.localize)(17,null,S)):y<L?(S=Math.floor(y/k),p?S===1?I?(0,T.localize)(18,null,S):(0,T.localize)(19,null,S):I?(0,T.localize)(20,null,S):(0,T.localize)(21,null,S):S===1?I?(0,T.localize)(22,null,S):(0,T.localize)(23,null,S):I?(0,T.localize)(24,null,S):(0,T.localize)(25,null,S)):y<N?(S=Math.floor(y/L),p?S===1?(0,T.localize)(26,null,S):(0,T.localize)(27,null,S):S===1?(0,T.localize)(28,null,S):(0,T.localize)(29,null,S)):y<b?(S=Math.floor(y/N),p?S===1?I?(0,T.localize)(30,null,S):(0,T.localize)(31,null,S):I?(0,T.localize)(32,null,S):(0,T.localize)(33,null,S):S===1?I?(0,T.localize)(34,null,S):(0,T.localize)(35,null,S):I?(0,T.localize)(36,null,S):(0,T.localize)(37,null,S)):y<g?(S=Math.floor(y/b),p?S===1?I?(0,T.localize)(38,null,S):(0,T.localize)(39,null,S):I?(0,T.localize)(40,null,S):(0,T.localize)(41,null,S):S===1?I?(0,T.localize)(42,null,S):(0,T.localize)(43,null,S):I?(0,T.localize)(44,null,S):(0,T.localize)(45,null,S)):(S=Math.floor(y/g),p?S===1?I?(0,T.localize)(46,null,S):(0,T.localize)(47,null,S):I?(0,T.localize)(48,null,S):(0,T.localize)(49,null,S):S===1?I?(0,T.localize)(50,null,S):(0,T.localize)(51,null,S):I?(0,T.localize)(52,null,S):(0,T.localize)(53,null,S))}e.fromNow=l;function m(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(Y[73],Q([5,6]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Y[32],Q([0,1,19,8,73]),function($,e,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,p){return p&&(w.stack||w.stacktrace)?k.localize(0,null,b(w),N(w.stack)||N(w.stacktrace)):b(w)}function N(w){return Array.isArray(w)?w.join(`
`):w}function b(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function g(w=null,p=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const I=T.coalesce(w),y=g(I[0],p);return I.length>1?k.localize(4,null,y,I.length):y}if(R.isString(w))return w;if(w.detail){const I=w.detail;if(I.error)return L(I.error,p);if(I.exception)return L(I.exception,p)}return w.stack?L(w,p):w.message?w.message:k.localize(5,null)}e.toErrorMessage=g;function l(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=l;function m(w,p){let I;return typeof w=="string"?I=new Error(w):I=w,I.actions=p,I}e.createErrorWithActions=m}),define(Y[74],Q([5,6]),function($,e){return $.create("vs/base/common/jsonErrorMessages",e)}),define(Y[75],Q([0,1,74]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(k){switch(k){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Y[51],Q([0,1,12]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(b,...g){const l=g.reduce((p,I)=>(p[I]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!l[p]).forEach(p=>{for(let I=0;I<m.length;I++)if(p.search(m[I])!==-1){delete b[p];break}})}e.sanitizeProcessEnvironment=L;function N(b){!b||(delete b.DEBUG,T.isMacintosh&&delete b.DYLD_LIBRARY_PATH,T.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Y[52],Q([0,1,3,2]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=N=>({onDidChange:T.Event.None,value:N});e.staticObservableValue=k;class L extends R.Disposable{get value(){return this.b}set value(b){b!==this.b&&(this.b=b,this.a.fire(b))}constructor(b){super(),this.b=b,this.a=this.B(new T.Emitter),this.onDidChange=this.a.event}}e.MutableObservableValue=L}),define(Y[53],Q([0,1,29]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(u){return k(u,0)}e.hash=R;function k(u,d){switch(typeof u){case"object":return u===null?L(349,d):Array.isArray(u)?g(u,d):l(u,d);case"string":return b(u,d);case"boolean":return N(u,d);case"number":return L(u,d);case"undefined":return L(937,d);default:return L(617,d)}}e.doHash=k;function L(u,d){return(d<<5)-d+u|0}e.numberHash=L;function N(u,d){return L(u?433:863,d)}function b(u,d){d=L(149417,d);for(let v=0,f=u.length;v<f;v++)d=L(u.charCodeAt(v),d);return d}e.stringHash=b;function g(u,d){return d=L(104579,d),u.reduce((v,f)=>k(f,v),d)}function l(u,d){return d=L(181387,d),Object.keys(u).sort().reduce((v,f)=>(v=b(f,v),k(u[f],v)),d)}class m{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=k(d,this.g),this.g}}e.Hasher=m;var w;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(u,d,v=32){const f=v-d,s=~((1<<f)-1);return(u<<d|(s&u)>>>f)>>>0}function I(u,d=0,v=u.byteLength,f=0){for(let s=0;s<v;s++)u[d+s]=f}function y(u,d,v="0"){for(;u.length<d;)u=v+u;return u}function S(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(v=>v.toString(16).padStart(2,"0")).join(""):y((u>>>0).toString(16),d/4)}e.toHexString=S;class E{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const v=d.length;if(v===0)return;const f=this.p;let s=this.r,i=this.u,n,t;for(i!==0?(n=i,t=-1,i=0):(n=d.charCodeAt(0),t=0);;){let r=n;if(T.isHighSurrogate(n))if(t+1<v){const o=d.charCodeAt(t+1);T.isLowSurrogate(o)?(t++,r=T.computeCodePoint(n,o)):r=65533}else{i=n;break}else T.isLowSurrogate(n)&&(r=65533);if(s=this.w(f,s,r),t++,t<v)n=d.charCodeAt(t);else break}this.r=s,this.u=i}w(d,v,f){return f<128?d[v++]=f:f<2048?(d[v++]=192|(f&1984)>>>6,d[v++]=128|(f&63)>>>0):f<65536?(d[v++]=224|(f&61440)>>>12,d[v++]=128|(f&4032)>>>6,d[v++]=128|(f&63)>>>0):(d[v++]=240|(f&1835008)>>>18,d[v++]=128|(f&258048)>>>12,d[v++]=128|(f&4032)>>>6,d[v++]=128|(f&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=E.g,v=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,v.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,p(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let f=this.h,s=this.l,i=this.m,n=this.n,t=this.o,r,o,c;for(let a=0;a<80;a++)a<20?(r=s&i|~s&n,o=1518500249):a<40?(r=s^i^n,o=1859775393):a<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),c=p(f,5)+r+t+o+d.getUint32(a*4,!1)&4294967295,t=n,n=i,i=p(s,30),s=f,f=c;this.h=this.h+f&4294967295,this.l=this.l+s&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=E,E.g=new DataView(new ArrayBuffer(320))}),define(Y[54],Q([0,1,29]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const L="error",N="warning",b="warn",g="info",l="ignore";function m(p){return p?T.equalsIgnoreCase(L,p)?k.Error:T.equalsIgnoreCase(N,p)||T.equalsIgnoreCase(b,p)?k.Warning:T.equalsIgnoreCase(g,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=m;function w(p){switch(p){case k.Error:return L;case k.Warning:return N;case k.Info:return g;default:return l}}k.toString=w}(R||(R={})),e.default=R}),define(Y[76],Q([0,1,10]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(l){const m=l;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=R;function k(l){const m=[];let w;try{const p=JSON.parse(l.arguments),I=p[p.length-1];I&&I.__$stack&&(p.pop(),w=I.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",l.arguments)}return{args:m,stack:w}}e.parse=k;function L(l){if(typeof l!="string")return L(k(l).stack);const m=l;if(m){const w=N(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:T.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function N(l){if(!l)return l;const m=l.indexOf(`
`);return m===-1?l:l.substring(0,m)}function b(l,m){const{args:w,stack:p}=k(l),I=typeof w[0]=="string"&&w.length===1;let y=N(p);y&&(y=`(${y.trim()})`);let S=[];if(typeof w[0]=="string"?y&&I?S=[`%c[${m}] %c${w[0]} %c${y}`,g("blue"),g(""),g("grey")]:S=[`%c[${m}] %c${w[0]}`,g("blue"),g(""),...w.slice(1)]:S=[`%c[${m}]%`,g("blue"),...w],y&&!I&&S.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,S)}e.log=b;function g(l){return`color: ${l}`}}),define(Y[44],Q([0,1,15,29,10]),function($,e,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(l){return JSON.stringify(l,b)}e.stringify=L;function N(l){let m=JSON.parse(l);return m=g(m),m}e.parse=N;function b(l,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,R.regExpFlags)(m)}:m}function g(l,m=0){if(!l||m>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return k.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof T.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let w=0;w<l.length;++w)l[w]=g(l[w],m+1);else for(const w in l)Object.hasOwnProperty.call(l,w)&&(l[w]=g(l[w],m+1))}return l}e.revive=g}),define(Y[77],Q([0,1,38,14,20]),function($,e,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,N=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var g;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class w{constructor(s,i,n){this.exePath=s,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:f=!1}={}){return f?l===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:f=!1,findPreview:s=!1}={}){const i=p({useAlternateBitness:f});if(!i)return null;const n=R.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const a of await k.Promises.readdir(n)){let h=-1;if(s){const C=a.indexOf("-");if(C<0)continue;const W=a.substring(0,C);if(!L.test(W)||a.substring(C+1)!=="preview")continue;h=parseInt(W,10)}else{if(!L.test(a))continue;h=parseInt(a,10)}if(h<=t)continue;const O=R.join(n,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(O)||(r=O,t=h)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",c=s?" Preview":"";return new w(r,`PowerShell${c}${o}`,!0)}async function y({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=f?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(s))if(i.test(t)){const r=R.join(s,t,"pwsh.exe");return new w(r,n)}return null}function S(){const f=R.join(T.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function E(){const f=R.join(process.env.windir,l===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*u(){let f=await I();f&&(yield f),f=await I({useAlternateBitness:!0}),f&&(yield f),f=await y(),f&&(yield f),f=S(),f&&(yield f),f=await I({findPreview:!0}),f&&(yield f),f=await y({findPreview:!0}),f&&(yield f),f=await I({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=E(),f&&(yield f)}async function*d(){for await(const f of u())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=d;async function v(){for await(const f of d())return f;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Y[55],Q([0,1,14,12,33,51,8,20]),function($,e,T,R,k,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function g(w=k.env){return w.comspec||"cmd.exe"}e.getWindowsShell=g;function l(w){let p=[],I=!1;const y=function(S){if(I){p.push(S);return}(!w.send(S,u=>{if(u&&console.error(u),I=!1,p.length>0){const d=p.slice(0);p=[],d.forEach(v=>y(v))}})||R.isWindows)&&(I=!0)};return{send:y}}e.createQueuedSender=l;var m;(function(w){async function p(I,y,S){if(T.isAbsolute(I))return I;if(y===void 0&&(y=k.cwd()),T.dirname(I)!=="."||(S===void 0&&N.isString(k.env.PATH)&&(S=k.env.PATH.split(T.delimiter)),S===void 0||S.length===0))return T.join(y,I);async function u(d){if(await b.Promises.exists(d)){let v;try{v=await b.Promises.stat(d)}catch(f){f.message.startsWith("EACCES")&&(v=await b.Promises.lstat(d))}return v?!v.isDirectory():!1}return!1}for(const d of S){let v;if(T.isAbsolute(d)?v=T.join(d,I):v=T.join(y,d,I),await u(v))return v;let f=v+".com";if(await u(f)||(f=v+".exe",await u(f)))return f}return T.join(y,I)}w.findExecutable=p})(m=e.win32||(e.win32={}))}),define(Y[78],Q([0,1,38,12,77,55]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function N(I,y){return I===1?R.isWindows?w():L.getWindowsShell(y):l(I,y)}e.getSystemShell=N;function b(I,y){return I===1?R.isWindows?p(y):L.getWindowsShell(y):l(I,y)}e.getSystemShellSync=b;let g=null;function l(I,y){if(R.isLinux&&I===2||R.isMacintosh&&I===3)return"/bin/bash";if(!g){let S;if(R.isWindows)S="/bin/bash";else{if(S=y.SHELL,!S)try{S=(0,T.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}g=S}return g}let m=null;async function w(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}function p(I){if(m)return m;const y=R.isWindows&&parseFloat((0,T.release)())>=10,S=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${I.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return y?E:L.getWindowsShell(I)}});var fe=this&&this.__decorate||function($,e,T,R){var k=arguments.length,L=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,T):R,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,e,T,R);else for(var b=$.length-1;b>=0;b--)(N=$[b])&&(L=(k<3?N(L):k>3?N(e,T,L):N(e,T))||L);return k>3&&L&&Object.defineProperty(e,T,L),L};define(Y[56],Q([0,1,19,4,15,22,49,11,3,2,44,29,8]),function($,e,T,R,k,L,N,b,g,l,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var I;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(I||(I={}));function y(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function E(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(u||(u={}));class d{constructor(A){this.b=A,this.a=0}read(A){const U=this.b.slice(this.a,this.a+A);return this.a+=U.byteLength,U}}class v{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(A){this.a.push(A)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function s(M){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function i(M){return M.read(4).readUInt32BE(0)}function n(M){const A=k.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const t={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer<"u";function o(M,A){if(typeof A>"u")M.write(t.Undefined);else if(typeof A=="string"){const U=k.VSBuffer.fromString(A);M.write(t.String),M.write(s(U.byteLength)),M.write(U)}else if(r&&Buffer.isBuffer(A)){const U=k.VSBuffer.wrap(A);M.write(t.Buffer),M.write(s(U.byteLength)),M.write(U)}else if(A instanceof k.VSBuffer)M.write(t.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(t.Array),M.write(s(A.length));for(const U of A)o(M,U)}else{const U=k.VSBuffer.fromString(JSON.stringify(A));M.write(t.Object),M.write(s(U.byteLength)),M.write(U)}}function c(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(i(M)).toString();case f.Buffer:return M.read(i(M)).buffer;case f.VSBuffer:return M.read(i(M));case f.Array:{const U=i(M),V=[];for(let G=0;G<U;G++)V.push(c(M));return V}case f.Object:return JSON.parse(M.read(i(M)).toString())}}class a{constructor(A,U,V=null,G=1e3){this.h=A,this.j=U,this.k=V,this.l=G,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.p(q)),this.m({type:200})}registerChannel(A,U){this.b.set(A,U),setTimeout(()=>this.v(A),0)}m(A){switch(A.type){case 200:{const U=this.n([A.type]);this.k?.logOutgoing(U,0,1,E(A.type));return}case 201:case 202:case 204:case 203:{const U=this.n([A.type,A.id],A.data);this.k?.logOutgoing(U,A.id,1,E(A.type),A.data);return}}}n(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.o(V.buffer)}o(A){try{return this.h.send(A),A.byteLength}catch{return 0}}p(A){const U=new d(A),V=c(U),G=c(U),q=V[0];switch(q){case 100:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(q)}: ${V[2]}.${V[3]}`,G),this.q({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 102:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(q)}: ${V[2]}.${V[3]}`,G),this.s({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 101:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(q)}`),this.t({type:q,id:V[1]});case 103:return this.k?.logIncoming(A.byteLength,V[1],1,`${y(q)}`),this.t({type:q,id:V[1]})}}q(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=new L.CancellationTokenSource;let G;try{G=U.call(this.j,A.name,A.arg,V.token)}catch(P){G=Promise.reject(P)}const q=A.id;G.then(P=>{this.m({id:q,data:P,type:201}),this.d.delete(A.id)},P=>{P instanceof Error?this.m({id:q,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.m({id:q,data:P,type:203}),this.d.delete(A.id)});const ee=(0,l.toDisposable)(()=>V.cancel());this.d.set(A.id,ee)}s(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=A.id,q=U.listen(this.j,A.name,A.arg)(ee=>this.m({id:V,data:ee,type:204}));this.d.set(A.id,q)}t(A){const U=this.d.get(A.id);U&&(U.dispose(),this.d.delete(A.id))}u(A){let U=this.g.get(A.channelName);U||(U=[],this.g.set(A.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.m({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:A,timeoutTimer:V})}v(A){const U=this.g.get(A);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.q(V.request);break;case 102:this.s(V.request);break}this.g.delete(A)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=a;var h;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class O{constructor(A,U=null){this.l=A,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.r(V)),this.j=U}getChannel(A){const U=this;return{call(V,G,q){return U.a?Promise.reject(new b.CancellationError):U.m(A,V,G,q)},listen(V,G){return U.a?g.Event.None:U.n(A,V,G)}}}m(A,U,V,G=L.CancellationToken.None){const q=this.g++,P={id:q,type:100,channelName:A,name:U,arg:V};if(G.isCancellationRequested)return Promise.reject(new b.CancellationError);let D;return new Promise((F,B)=>{if(G.isCancellationRequested)return B(new b.CancellationError);const x=()=>{const ye=ae=>{switch(ae.type){case 201:this.f.delete(q),F(ae.data);break;case 202:{this.f.delete(q);const ne=new Error(ae.data.message);ne.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ne.name=ae.data.name,B(ne);break}case 203:this.f.delete(q),B(ae.data);break}};this.f.set(q,ye),this.o(P)};let te=null;this.b===u.Idle?x():(te=(0,R.createCancelablePromise)(ye=>this.t()),te.then(()=>{te=null,x()}));const oe=()=>{te?(te.cancel(),te=null):this.o({id:q,type:101}),B(new b.CancellationError)},me=G.onCancellationRequested(oe);D=(0,l.combinedDisposable)((0,l.toDisposable)(oe),me),this.d.add(D)}).finally(()=>{this.d.delete(D)})}n(A,U,V){const G=this.g++,ee={id:G,type:102,channelName:A,name:U,arg:V};let P=null;const D=new g.Emitter({onWillAddFirstListener:()=>{P=(0,R.createCancelablePromise)(F=>this.t()),P.then(()=>{P=null,this.d.add(D),this.o(ee)})},onDidRemoveLastListener:()=>{P?(P.cancel(),P=null):(this.d.delete(D),this.o({id:G,type:103}))}}),j=F=>D.fire(F.data);return this.f.set(G,j),D.event}o(A){switch(A.type){case 100:case 102:{const U=this.p([A.type,A.id,A.channelName,A.name],A.arg);this.j?.logOutgoing(U,A.id,0,`${y(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const U=this.p([A.type,A.id]);this.j?.logOutgoing(U,A.id,0,y(A.type));return}}}p(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.q(V.buffer)}q(A){try{return this.l.send(A),A.byteLength}catch{return 0}}r(A){const U=new d(A),V=c(U),G=c(U),q=V[0];switch(q){case 200:return this.j?.logIncoming(A.byteLength,0,0,E(q)),this.s({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(A.byteLength,V[1],0,E(q),G),this.s({type:V[0],id:V[1],data:G})}}s(A){if(A.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(A.id)?.(A)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}fe([N.memoize],O.prototype,"onDidInitializePromise",null),e.ChannelClient=O;class C{get connections(){const A=[];return this.f.forEach(U=>A.push(U)),A}constructor(A){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,A(({protocol:U,onDidClientDisconnect:V})=>{g.Event.once(U.onMessage)(q=>{const ee=new d(q),P=c(ee),D=new a(U,P),j=new O(U);this.a.forEach((B,x)=>D.registerChannel(x,B));const F={channelServer:D,channelClient:j,ctx:P};this.f.add(F),this.g.fire(F),V(()=>{D.dispose(),j.dispose(),this.f.delete(F),this.h.fire(F)})})})}getChannel(A,U){const V=this;return{call(G,q,ee){let P;if((0,p.isFunction)(U)){const j=(0,T.getRandomElement)(V.connections.filter(U));P=j?Promise.resolve(j):g.Event.toPromise(g.Event.filter(V.onDidAddConnection,U))}else P=U.routeCall(V,G,q);const D=P.then(j=>j.channelClient.getChannel(A));return X(D).call(G,q,ee)},listen(G,q){if((0,p.isFunction)(U))return V.j(A,U,G,q);const ee=U.routeEvent(V,G,q).then(P=>P.channelClient.getChannel(A));return X(ee).listen(G,q)}}}j(A,U,V,G){const q=this;let ee=new l.DisposableStore;const P=new g.Emitter({onWillAddFirstListener:()=>{ee=new l.DisposableStore;const D=new g.EventMultiplexer,j=new Map,F=x=>{const oe=x.channelClient.getChannel(A).listen(V,G),me=D.add(oe);j.set(x,me)},B=x=>{const te=j.get(x);!te||(te.dispose(),j.delete(x))};q.connections.filter(U).forEach(F),g.Event.filter(q.onDidAddConnection,U)(F,void 0,ee),q.onDidRemoveConnection(B,void 0,ee),D.event(P.fire,P,ee),ee.add(D)},onDidRemoveLastListener:()=>{ee.dispose()}});return P.event}registerChannel(A,U){this.a.set(A,U),this.f.forEach(V=>{V.channelServer.registerChannel(A,U)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=C;class W{constructor(A,U,V=null){const G=new v;o(G,U),A.send(G.buffer),this.a=new O(A,V),this.d=new a(A,U,V)}getChannel(A){return this.a.getChannel(A)}registerChannel(A,U){this.d.registerChannel(A,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=W;function X(M){return{call(A,U,V){return M.then(G=>G.call(A,U,V))},listen(A,U){const V=new g.Relay;return M.then(G=>V.input=G.listen(A,U)),V.event}}}e.getDelayedChannel=X;function J(M){let A=!1;return{call(U,V,G){return A?M.call(U,V,G):(0,R.timeout)(0).then(()=>A=!0).then(()=>M.call(U,V,G))},listen(U,V){if(A)return M.listen(U,V);const G=new g.Relay;return(0,R.timeout)(0).then(()=>A=!0).then(()=>G.input=M.listen(U,V)),G.event}}}e.getNextTickChannel=J;class ie{constructor(A){this.a=A}routeCall(A){return this.b(A)}routeEvent(A){return this.b(A)}async b(A){for(const U of A.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await g.Event.toPromise(A.onDidAddConnection),await this.b(A)}}e.StaticRouter=ie;var re;(function(M){function A(q,ee){const P=q,D=ee&&ee.disableMarshalling,j=new Map;for(const F in P)V(F)&&j.set(F,g.Event.buffer(P[F],!0));return new class{listen(F,B,x){const te=j.get(B);if(te)return te;if(G(B)){const oe=P[B];if(typeof oe=="function")return oe.call(P,x)}throw new Error(`Event not found: ${B}`)}call(F,B,x){const te=P[B];if(typeof te=="function"){if(!D&&Array.isArray(x))for(let oe=0;oe<x.length;oe++)x[oe]=(0,m.revive)(x[oe]);return te.apply(P,x)}throw new Error(`Method not found: ${B}`)}}}M.fromService=A;function U(q,ee){const P=ee&&ee.disableMarshalling;return new Proxy({},{get(D,j){if(typeof j=="string")return ee?.properties?.has(j)?ee.properties.get(j):G(j)?function(F){return q.listen(j,F)}:V(j)?q.listen(j):async function(...F){let B;ee&&!(0,p.isUndefinedOrNull)(ee.context)?B=[ee.context,...F]:B=F;const x=await q.call(j,B);return P?x:(0,m.revive)(x)};throw new Error(`Property not found: ${String(j)}`)}})}M.toService=U;function V(q){return q[0]==="o"&&q[1]==="n"&&w.isUpperAsciiLetter(q.charCodeAt(2))}function G(q){return/^onDynamic/.test(q)&&w.isUpperAsciiLetter(q.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const A=M.toString();if(A!=="[object Object]")return A}return M}function ce(M){return Array.isArray(M)?M.map(he):he(M)}function se(M,A,U,V,G,q,ee){ee=ce(ee);const P=Z[G],D=P[V%P.length];let j=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(q)?(j=j.concat(ee),j.push(")")):j.push(ee),console.log.apply(console,j)}class ge{constructor(A,U){this.d=A,this.f=U,this.a=0,this.b=0}logOutgoing(A,U,V,G,q){this.b+=A,se(this.d,this.b,A,U,V,G,q)}logIncoming(A,U,V,G,q){this.a+=A,se(this.f,this.a,A,U,V,G,q)}}e.IPCLogger=ge}),define(Y[79],Q([0,1,57,4,15,22,76,11,3,2,28,55,51,56]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends I.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",d=>k.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=y;class S{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const v=d&&d.timeout?d.timeout:6e4;this.b=new R.Delayer(v),this.d=null,this.f=null}getChannel(u){const d=this;return{call(v,f,s){return d.k(u,v,f,s)},listen(v,f){return d.l(u,v,f)}}}k(u,d,v,f=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(b.canceled());this.b.cancel();const s=this.n(u),i=(0,R.createCancelablePromise)(r=>s.call(d,v,r)),n=f.onCancellationRequested(()=>i.cancel()),t=(0,l.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{n.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,d,v){if(!this.b)return g.Event.None;this.b.cancel();let f;const s=new g.Emitter({onWillAddFirstListener:()=>{f=this.n(u).listen(d,v)(s.fire,s),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(d.env),this.d=(0,T.fork)(this.i,u,d);const v=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,N.isRemoteConsoleLog)(o)){(0,N.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&s.send(o.buffer.toString("base64")),n=v.event,t={send:i,onMessage:n};this.f=new I.ChannelClient(t);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",r),this.c.forEach(a=>(0,l.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(Y[80],Q([0,1,4,3,2,8]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(N=e.StorageHint||(e.StorageHint={}));function b(w){const p=w;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var g;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class l extends k.Disposable{constructor(p,I=Object.create(null)){super(),this.m=p,this.n=I,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new T.ThrottledDelayer(l.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(p=>this.r(p)))}r(p){p.changed?.forEach((I,y)=>this.s(y,I)),p.deleted?.forEach(I=>this.s(I,void 0))}s(p,I){if(this.c===g.Closed)return;let y=!1;(0,L.isUndefinedOrNull)(I)?y=this.f.delete(p):this.f.get(p)!==I&&(this.f.set(p,I),y=!0),y&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,I){const y=this.f.get(p);return(0,L.isUndefinedOrNull)(y)?I:y}getBoolean(p,I){const y=this.get(p);return(0,L.isUndefinedOrNull)(y)?I:y==="true"}getNumber(p,I){const y=this.get(p);return(0,L.isUndefinedOrNull)(y)?I:parseInt(y,10)}async set(p,I){if(this.c===g.Closed)return;if((0,L.isUndefinedOrNull)(I))return this.delete(p);const y=String(I);if(this.f.get(p)!==y)return this.f.set(p,y),this.j.set(p,y),this.h.delete(p),this.b.fire(p),this.w()}async delete(p){if(!(this.c===g.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.u)return this.w(p)}async w(p){return this.g.trigger(()=>this.v(),p)}async whenFlushed(){if(!!this.u)return new Promise(p=>this.l.push(p))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=l,l.a=100;class m{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((I,y)=>this.a.set(y,I)),p.delete?.forEach(I=>this.a.delete(I))}async close(){}}e.InMemoryStorageDatabase=m}),define(Y[81],Q([5,6]),function($,e){return $.create("vs/base/node/zip",e)}),define(Y[82],Q([5,6]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Y[83],Q([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Y[84],Q([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Y[85],Q([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Y[86],Q([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Y[87],Q([5,6]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Y[88],Q([5,6]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Y[89],Q([5,6]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Y[90],Q([5,6]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Y[91],Q([5,6]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Y[92],Q([5,6]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Y[93],Q([5,6]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Y[94],Q([5,6]),function($,e){return $.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Y[95],Q([5,6]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Y[96],Q([5,6]),function($,e){return $.create("vs/platform/shell/node/shellEnv",e)}),define(Y[97],Q([5,6]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Y[98],Q([5,6]),function($,e){return $.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Y[99],Q([5,6]),function($,e){return $.create("vs/platform/workspace/common/workspace",e)}),define(Y[100],Q([0,1,72,49,16,14,33,17,10]),function($,e,T,R,k,L,N,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(g.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=N.env.VSCODE_PORTABLE;return S?g.URI.file((0,L.join)(S,"argv.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?g.URI.file((0,L.resolve)(S)):g.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const E=N.env.VSCODE_EXTENSIONS;if(E)return E;const u=N.env.VSCODE_PORTABLE;return u?(0,L.join)(u,"extensions"):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(E=>/^[^:/?#]+?:\/\//.test(E)?g.URI.parse(E):g.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?g.URI.parse(S):g.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const E of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);u&&u[1]&&u[2]&&S.push([u[1],u[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=N.env.VSCODE_PORTABLE;return S?g.URI.file((0,L.join)(S,"policy.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this.a}constructor(S,E,u){this.a=S,this.b=E,this.c=u,this.editSessionId=this.args.editSessionId}}fe([R.memoize],l.prototype,"appRoot",null),fe([R.memoize],l.prototype,"userHome",null),fe([R.memoize],l.prototype,"userDataPath",null),fe([R.memoize],l.prototype,"appSettingsHome",null),fe([R.memoize],l.prototype,"tmpDir",null),fe([R.memoize],l.prototype,"cacheHome",null),fe([R.memoize],l.prototype,"stateResource",null),fe([R.memoize],l.prototype,"userRoamingDataHome",null),fe([R.memoize],l.prototype,"userDataSyncHome",null),fe([R.memoize],l.prototype,"userDataSyncLogResource",null),fe([R.memoize],l.prototype,"editSessionsLogResource",null),fe([R.memoize],l.prototype,"sync",null),fe([R.memoize],l.prototype,"machineSettingsResource",null),fe([R.memoize],l.prototype,"workspaceStorageHome",null),fe([R.memoize],l.prototype,"localHistoryHome",null),fe([R.memoize],l.prototype,"keyboardLayoutResource",null),fe([R.memoize],l.prototype,"argvResource",null),fe([R.memoize],l.prototype,"isExtensionDevelopment",null),fe([R.memoize],l.prototype,"untitledWorkspacesHome",null),fe([R.memoize],l.prototype,"installSourcePath",null),fe([R.memoize],l.prototype,"builtinExtensionsPath",null),fe([R.memoize],l.prototype,"extensionsPath",null),fe([R.memoize],l.prototype,"extensionDevelopmentLocationURI",null),fe([R.memoize],l.prototype,"extensionDevelopmentKind",null),fe([R.memoize],l.prototype,"extensionTestsLocationURI",null),fe([R.memoize],l.prototype,"debugExtensionHost",null),fe([R.memoize],l.prototype,"logLevel",null),fe([R.memoize],l.prototype,"extensionLogLevel",null),fe([R.memoize],l.prototype,"serviceMachineIdResource",null),fe([R.memoize],l.prototype,"telemetryLogResource",null),fe([R.memoize],l.prototype,"disableWorkspaceTrust",null),fe([R.memoize],l.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=l;function m(y,S){return I(y["inspect-extensions"],y["inspect-brk-extensions"],5870,S,y.debugId,y.extensionEnvironment)}e.parseExtensionHostPort=m;function w(y,S){return I(y["inspect-search"],y["inspect-brk-search"],5876,S,y.extensionEnvironment)}e.parseSearchPort=w;function p(y,S){return I(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,S,y.extensionEnvironment)}e.parsePtyHostPort=p;function I(y,S,E,u,d,v){const s=Number(S||y)||(u?null:E),i=s?Boolean(!!S):!1;let n;if(v)try{n=JSON.parse(v)}catch{}return{port:s,break:i,debugId:d,env:n}}}),function(){"use strict";function $(e,T,R){function k(N,b){const g=L(N,b),l=[g];return e.isAbsolute(g)||l.unshift(R),e.resolve(...l)}function L(N,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,b);const m=N["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(w,"AppData","Roaming")}break;case"darwin":l=e.join(T.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,b)}return{getUserDataPath:k}}if(typeof define=="function")define(Y[101],Q([152,38,33]),function(e,T,R){return $(e,T,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=$(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[102],Q([0,1,38,100,101]),function($,e,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends R.AbstractNativeEnvironmentService{constructor(b,g){super(b,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b,g.nameShort)},g)}}e.NativeEnvironmentService=L}),define(Y[103],Q([0,1,8,86]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,b,g){try{L(N,b,g)}catch(l){console.error(l?.message??l)}return N}e.localizeManifest=k;function L(N,b,g){const l=(m,w,p)=>{const I=m[w];if((0,T.isString)(I)){const y=I,S=y.length;if(S>1&&y[0]==="%"&&y[S-1]==="%"){const E=y.substr(1,S-2);let u=b[E];u===void 0&&g&&(u=g[E]);const d=typeof u=="string"?u:u?.message,v=g?.[E],f=typeof v=="string"?v:v?.message;if(!d){f||console.warn(`[${N.name}]: ${(0,R.localize)(0,null,E)}`);return}if(p&&(w==="title"||w==="category")&&f&&f!==d){const s={value:d,original:f};m[w]=s}else m[w]=d}}else if((0,T.isObject)(I))for(const y in I)I.hasOwnProperty(y)&&(y==="commands"?l(I,y,!0):l(I,y,p));else if(Array.isArray(I))for(let y=0;y<I.length;y++)l(I,y,p)};for(const m in N)N.hasOwnProperty(m)&&l(N,m)}}),define(Y[104],Q([0,1,11]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(L,N){this.a.set(L,N)}updateManifest(L){if(!(!Array.isArray(L.activationEvents)||!L.contributes)&&!(typeof L.main>"u"&&typeof L.browser>"u"))for(const N in L.contributes){const b=this.a.get(N);if(!b)continue;const g=L.contributes[N],l=Array.isArray(g)?g:[g];try{b(l,L.activationEvents)}catch(m){(0,T.onUnexpectedError)(m)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Y[45],Q([0,1,17,54,90,39]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function g(u){return u=u.trim(),u==="*"||N.test(u)}e.isValidVersionStr=g;function l(u){if(!g(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(N);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=l;function m(u){if(!u)return null;const d=u.majorBase,v=u.majorMustEqual,f=u.minorBase;let s=u.minorMustEqual;const i=u.patchBase;let n=u.patchMustEqual;u.hasCaret&&(d===0||(s=!1),n=!1);let t=0;if(u.preRelease){const r=b.exec(u.preRelease);if(r){const[,o,c,a]=r;t=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:d,majorMustEqual:v,minorBase:f,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=m;function w(u,d,v){let f;typeof u=="string"?f=m(l(u)):f=u;let s;d instanceof Date?s=d.getTime():typeof d=="string"&&(s=new Date(d).getTime());let i;if(typeof v=="string"?i=m(l(v)):i=v,!f||!i)return!1;const n=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,c=i.minorBase,a=i.patchBase;const h=i.notBefore;let O=i.majorMustEqual,C=i.minorMustEqual,W=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:t>c?!0:t<c||s&&s<h?!1:r>=a:(n===1&&o===0&&(!O||!C||!W)&&(o=1,c=0,a=0,O=!0,C=!1,W=!1),n<o?!1:n>o?!O:t<c?!1:t>c?!C:r<a?!1:r>a?!W:!(s&&s<h))}e.isValidVersion=w;function p(u,d,v,f,s){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([R.default.Error,k.localize(0,null)]),i;if(typeof f.name!="string")return i.push([R.default.Error,k.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([R.default.Error,k.localize(2,null,"version")]),i;if(!f.engines)return i.push([R.default.Error,k.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([R.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!E(f.extensionDependencies))return i.push([R.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!E(f.activationEvents))return i.push([R.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([R.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([R.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([R.default.Error,k.localize(9,null,"main")]),i;{const r=(0,T.joinPath)(v,f.main);(0,T.isEqualOrParent)(r,v)||i.push([R.default.Warning,k.localize(10,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return i.push([R.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([R.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,T.joinPath)(v,f.browser);(0,T.isEqualOrParent)(r,v)||i.push([R.default.Warning,k.localize(13,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return i.push([R.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(f.version))return i.push([R.default.Error,k.localize(15,null)]),i;const n=[];if(!I(u,d,f,s,n))for(const r of n)i.push([R.default.Error,r]);return i}e.validateExtensionManifest=p;function I(u,d,v,f,s){return f||typeof v.main>"u"&&typeof v.browser>"u"?!0:S(u,d,v.engines.vscode,s)}e.isValidExtensionVersion=I;function y(u,d,v){return u==="*"||S(d,v,u)}e.isEngineValid=y;function S(u,d,v,f=[]){const s=m(l(v));if(!s)return f.push(k.localize(16,null,v)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(k.localize(17,null,v)),!1}else if(!s.majorMustEqual)return f.push(k.localize(18,null,v)),!1;return w(u,d,s)?!0:(f.push(k.localize(19,null,u,v)),!1)}function E(u){if(!Array.isArray(u))return!1;for(let d=0,v=u.length;d<v;d++)if(typeof u[d]!="string")return!1;return!0}}),define(Y[105],Q([0,1,15,31]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,N,b){let g=b&&b.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const m=(await N.readFile(L.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(m)?m:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await N.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(g))}catch{}}return b?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=k}),define(Y[46],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,L=[],N=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Y[106],Q([0,1,46]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function L(b,g,l){g instanceof T.SyncDescriptor||(g=new T.SyncDescriptor(g,[],Boolean(l))),R.push([b,g])}e.registerSingleton=L;function N(){return R}e.getSingletonServiceDescriptors=N}),define(Y[107],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class R{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const b=this.lookupOrInsertNode(L),g=this.lookupOrInsertNode(N);b.outgoing.set(g.key,g),g.incoming.set(b.key,b)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let b=this.a.get(N);return b||(b=new T(N,L),this.a.set(N,b)),b}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,b]of this.a)L.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const b=new Set([L]),g=this.c(N,b);if(g)return g}}c(L,N){for(const[b,g]of L.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const l=this.c(g,N);if(l)return l;N.delete(b)}}}e.Graph=R}),define(Y[21],Q([0,1,8,10,7]),function($,e,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationOverrides=L;function N(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=N;var b;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function l(u,d){const v=Object.create(null);for(const f in u)m(v,f,u[f],d);return v}e.toValuesTree=l;function m(u,d,v,f){const s=d.split("."),i=s.pop();let n=u;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${d} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=v}catch{f(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=m;function w(u,d){const v=d.split(".");p(u,v)}e.removeFromValueTree=w;function p(u,d){const v=d.shift();if(d.length===0){delete u[v];return}if(Object.keys(u).indexOf(v)!==-1){const f=u[v];typeof f=="object"&&!Array.isArray(f)&&(p(f,d),Object.keys(f).length===0&&delete u[v])}}function I(u,d,v){function f(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=d.split("."),i=f(u,s);return typeof i>"u"?v:i}e.getConfigurationValue=I;function y(u,d,v){Object.keys(d).forEach(f=>{f!=="__proto__"&&(f in u?T.isObject(u[f])&&T.isObject(d[f])?y(u[f],d[f],v):v&&(u[f]=d[f]):u[f]=d[f])})}e.merge=y;function S(u,d,v){const f=u.inspect(d),s=u.inspect(v);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=S;function E(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Y[58],Q([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[18],Q([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Y[23],Q([0,1,84,7]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function N(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function b(u,d){return d==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function g(u,d,v){return b(d,v)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===v?!0:l(v).includes(u)}e.isTargetPlatformCompatible=g;function l(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function m(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=m;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var p;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var I;(function(u){u.Install="install",u.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var y;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var S;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(d,v){super(d),this.code=v,this.name=v}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Y[59],Q([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((L,N)=>$(["node-vsce-sign"],async b=>L(b),N))),this.a}async verify(L,N){let b;try{b=await this.b()}catch{return!1}return b.verify(L,N)}}e.ExtensionSignatureVerificationService=R}),define(Y[60],Q([0,1,15,11,92,13]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(m,w,p,I,y,S){let E;try{await b(m,w,p,I,y,S)}catch(u){E=u}finally{E&&y.errorTransformer&&(E=y.errorTransformer(E)),typeof E<"u"&&p.error(E),p.end()}}e.readFileIntoStream=N;async function b(m,w,p,I,y,S){g(S);const E=await m.open(w,{create:!1});try{g(S);let u=0,d=0,v=y&&typeof y.length=="number"?y.length:void 0,f=T.VSBuffer.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),s=y&&typeof y.position=="number"?y.position:0,i=0;do d=await m.read(E,s,f.buffer,i,f.byteLength-i),s+=d,i+=d,u+=d,typeof v=="number"&&(v-=d),i===f.byteLength&&(await p.write(I(f)),f=T.VSBuffer.alloc(Math.min(y.bufferSize,typeof v=="number"?v:y.bufferSize)),i=0);while(d>0&&(typeof v!="number"||v>0)&&g(S)&&l(u,y));if(i>0){let n=i;typeof v=="number"&&(n=Math.min(i,v)),p.write(I(f.slice(0,n)))}}catch(u){throw(0,L.ensureFileSystemProviderError)(u)}finally{await m.close(E)}}function g(m){if(m.isCancellationRequested)throw(0,R.canceled)();return!0}function l(m,w){if(w?.limits){if(typeof w.limits.memory=="number"&&m>w.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&m>w.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[108],Q([0,1,3,153,2,12,154]),function($,e,T,R,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(l){const m=this.i(l),w=m.filter(I=>{const y=this.c.get(I.path);return y?!(0,R.patternsEquals)(y.request.excludes,I.excludes)||!(0,R.patternsEquals)(y.request.includes,I.includes):!0}),p=Array.from(this.c.values()).filter(({request:I})=>!m.find(y=>y.path===I.path&&(0,R.patternsEquals)(y.excludes,I.excludes)&&(0,R.patternsEquals)(y.includes,I.includes))).map(({request:I})=>I.path);w.length&&this.j(`Request to start watching: ${w.map(I=>`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const I of p)this.h(I);for(const I of w)this.g(I)}g(l){const m=new N.NodeJSFileWatcherLibrary(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),w={request:l,instance:m};this.c.set(l.path,w)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const m=this.c.get(l);m&&(this.c.delete(l),m.instance.dispose())}i(l){const m=new Map;for(const w of l){const p=L.isLinux?w.path:w.path.toLowerCase();m.set(p,w)}return Array.from(m.values())}async setVerboseLogging(l){this.f=l;for(const[,m]of this.c)m.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,m){return m?`[File Watcher (node.js)] ${l} (path: ${m.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=b}),define(Y[109],Q([0,1,61,108]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends T.AbstractNonRecursiveWatcherClient{constructor(N,b,g){super(N,b,g),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Y[110],Q([0,1,16,56,79,61]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends L.AbstractUniversalWatcherClient{constructor(g,l,m){super(g,l,m),this.m()}l(g){const l=g.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:m,signal:w})=>this.n(`terminated by itself with code ${m}, signal: ${w}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Y[62],Q([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this.a=new Map;for(const[L,N]of k)this.set(L,N)}set(k,L){const N=this.a.get(k);return this.a.set(k,L),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=T}),define(Y[111],Q([0,1,4,11,2,46,107,7,62,155]),function($,e,T,R,k,L,N,b,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class w extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class p{constructor(E=new g.ServiceCollection,u=!1,d,v=m){this.f=E,this.g=u,this.h=d,this.i=v,this.o=new Set,this.f.set(b.IInstantiationService,this),this._globalGraph=v?d?._globalGraph??new N.Graph(f=>f):void 0}createChild(E){return new p(E,this.g,this,this.i)}invokeFunction(E,...u){const d=y.traceInvocation(this.i,E);let v=!1;try{return E({get:s=>{if(v)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(s,d);if(!i)throw new Error(`[invokeFunction] unknown service '${s}'`);return i}},...u)}finally{v=!0,d.stop()}}createInstance(E,...u){let d,v;return E instanceof L.SyncDescriptor?(d=y.traceCreation(this.i,E.ctor),v=this.j(E.ctor,E.staticArguments.concat(u),d)):(d=y.traceCreation(this.i,E),v=this.j(E,u,d)),d.stop(),v}j(E,u=[],d){const v=b._util.getServiceDependencies(E).sort((i,n)=>i.index-n.index),f=[];for(const i of v){const n=this.m(i.id,d);n||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(n)}const s=v.length>0?v[0].index:u.length;if(u.length!==s){console.trace(`[createInstance] First service dependency of ${E.name} at position ${s+1} conflicts with ${u.length} static arguments`);const i=s-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,s)}return Reflect.construct(E,u.concat(f))}k(E,u){if(this.f.get(E)instanceof L.SyncDescriptor)this.f.set(E,u);else if(this.h)this.h.k(E,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const u=this.f.get(E);return!u&&this.h?this.h.l(E):u}m(E,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const d=this.l(E);return d instanceof L.SyncDescriptor?this.q(E,d,u.branch(E,!0)):(u.branch(E,!1),d)}q(E,u,d){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,u,d)}finally{this.o.delete(E)}}r(E,u,d){const v=new N.Graph(i=>i.id.toString());let f=0;const s=[{id:E,desc:u,_trace:d}];for(;s.length;){const i=s.pop();if(v.lookupOrInsertNode(i),f++>1e3)throw new w(v);for(const n of b._util.getServiceDependencies(i.desc.ctor)){const t=this.l(n.id);if(t||this.u(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof L.SyncDescriptor){const r={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};v.insertEdge(i,r),s.push(r)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:n}of i){if(this.l(n.id)instanceof L.SyncDescriptor){const r=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,r)}v.removeNode(n)}}return this.l(E)}s(E,u,d=[],v,f){if(this.f.get(E)instanceof L.SyncDescriptor)return this.t(E,u,d,v,f);if(this.h)return this.h.s(E,u,d,v,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(E,u,d=[],v,f){if(v){const s=new p(void 0,this.g,this,this.i);s.c=String(E);const i=new Map,n=new T.IdleValue(()=>{const t=s.j(u,d,f);for(const[r,o]of i){const c=t[r];if(typeof c=="function")for(const a of o)c.apply(t,a)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=i.get(r);return a||(a=new l.LinkedList,i.set(r,a)),(O,C,W)=>{const X=a.push([O,C,W]);return(0,k.toDisposable)(X)}}if(r in t)return t[r];const o=n.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),t[r]=c),c},set(t,r,o){return n.value[r]=o,!0}})}else return this.j(u,d,f)}u(E,u){if(u&&console.warn(E),this.g)throw new Error(E)}}e.InstantiationService=p;var I;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(I||(I={}));class y{static traceInvocation(E,u){return E?new y(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(E,u){return E?new y(0,u.name):y.c}constructor(E,u){this.type=E,this.name=u,this.g=Date.now(),this.h=[]}branch(E,u){const d=new y(2,E.toString());return this.h.push([E,u,d]),d}stop(){const E=Date.now()-this.g;y.f+=E;let u=!1;function d(f,s){const i=[],n=new Array(f+1).join("	");for(const[t,r,o]of s.h)if(r&&o){u=!0,i.push(`${n}CREATES -> ${t}`);const c=d(f+1,o);c&&i.push(c)}else i.push(`${n}uses -> ${t}`);return i.join(`
`)}const v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(E>2||u)&&y.all.add(v.join(`
`))}}e.Trace=y,y.all=new Set,y.c=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y.f=0});var _=this&&this.__param||function($,e){return function(T,R){e(T,R,$)}};define(Y[63],Q([0,1,22,2,12,94,23,7]),function($,e,T,R,k,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let g=class extends R.Disposable{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new T.CancellationTokenSource;setTimeout(()=>m.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const I=w.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(S=>S.startsWith("lp-"))).map(y=>{const S=y.properties.localizedLanguages?.[0],E=this.getLocale(y);return{...this.f(E,S,y),extensionId:y.identifier.id,galleryExtension:y}});return I.push({...this.f("en","English"),extensionId:"default"}),I}getLocale(m){return m.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}f(m,w,p){const I=w??m;let y;if(I!==m&&(y=`(${m})`),m.toLowerCase()===k.language.toLowerCase()&&(y??="",y+=(0,L.localize)(0,null)),p?.installCount){y??="";const S=p.installCount;let E;S>1e6?E=`${Math.floor(S/1e5)/10}M`:S>1e3?E=`${Math.floor(S/1e3)}K`:E=String(S),y+=` $(cloud-download) ${E}`}return{id:m,label:I,description:y}}};g=fe([_(0,N.IExtensionGalleryService)],g),e.LanguagePackBaseService=g}),define(Y[9],Q([0,1,32,3,2,34,12,10,7]),function($,e,T,R,k,L,N,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function l(){return new Date().toISOString()}var m;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function w(c,a,h){switch(a){case m.Trace:c.trace(h);break;case m.Debug:c.debug(h);break;case m.Info:c.info(h);break;case m.Warning:c.warn(h);break;case m.Error:c.error(h);break;default:throw new Error(`Invalid log level ${a}`)}}e.log=w;function p(c){let a="";for(let h=0;h<c.length;h++){let O=c[h];if(typeof O=="object")try{O=JSON.stringify(O)}catch{}a+=(h>0?" ":"")+O}return a}e.format=p;class I extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=I;class y extends I{constructor(a){super(),this.g=a}h(a){return this.g||this.getLevel()<=a}trace(a,...h){this.h(m.Trace)&&this.f(m.Trace,p([a,...h]))}debug(a,...h){this.h(m.Debug)&&this.f(m.Debug,p([a,...h]))}info(a,...h){this.h(m.Info)&&this.f(m.Info,p([a,...h]))}warn(a,...h){this.h(m.Warning)&&this.f(m.Warning,p([a,...h]))}error(a,...h){if(this.h(m.Error))if(a instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=a.stack,this.f(m.Error,p(O))}else this.f(m.Error,p([a,...h]))}flush(){}}e.AbstractMessageLogger=y;class S extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.f=!N.isWindows}trace(a,...h){this.getLevel()<=m.Trace&&(this.f?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...h):console.log(`[main ${l()}]`,a,...h))}debug(a,...h){this.getLevel()<=m.Debug&&(this.f?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...h):console.log(`[main ${l()}]`,a,...h))}info(a,...h){this.getLevel()<=m.Info&&(this.f?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...h):console.log(`[main ${l()}]`,a,...h))}warn(a,...h){this.getLevel()<=m.Warning&&(this.f?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,a,...h):console.warn(`[main ${l()}]`,a,...h))}error(a,...h){this.getLevel()<=m.Error&&(this.f?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,a,...h):console.error(`[main ${l()}]`,a,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class E extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...h){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",a,...h)}debug(a,...h){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...h)}info(a,...h){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",a,...h)}warn(a,...h){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",a,...h)}error(a,...h){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",a,...h)}dispose(){}flush(){}}e.ConsoleLogger=E;class u extends I{constructor(a,h=e.DEFAULT_LOG_LEVEL){super(),this.f=a,this.setLevel(h)}trace(a,...h){this.getLevel()<=m.Trace&&this.f.log(m.Trace,[this.g(a),...h])}debug(a,...h){this.getLevel()<=m.Debug&&this.f.log(m.Debug,[this.g(a),...h])}info(a,...h){this.getLevel()<=m.Info&&this.f.log(m.Info,[this.g(a),...h])}warn(a,...h){this.getLevel()<=m.Warning&&this.f.log(m.Warning,[this.g(a),...h])}error(a,...h){this.getLevel()<=m.Error&&this.f.log(m.Error,[this.g(a),...h])}g(a){return typeof a=="string"?a:(0,T.toErrorMessage)(a,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class d extends I{constructor(a){super(),this.f=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const h of this.f)h.setLevel(a);super.setLevel(a)}trace(a,...h){for(const O of this.f)O.trace(a,...h)}debug(a,...h){for(const O of this.f)O.debug(a,...h)}info(a,...h){for(const O of this.f)O.info(a,...h)}warn(a,...h){for(const O of this.f)O.warn(a,...h)}error(a,...h){for(const O of this.f)O.error(a,...h)}flush(){for(const a of this.f)a.flush()}dispose(){for(const a of this.f)a.dispose()}}e.MultiplexLogService=d;class v extends k.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...h){this.b.trace(a,...h)}debug(a,...h){this.b.debug(a,...h)}info(a,...h){this.b.info(a,...h)}warn(a,...h){this.b.warn(a,...h)}error(a,...h){this.b.error(a,...h)}flush(){this.b.flush()}}e.LogService=v;class f extends k.Disposable{constructor(a,h){super(),this.c=a,this.b=new L.ResourceMap,this.B(h(O=>this.setLevel(O)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,h,O){let C=this.b.get(a)?.logger;return C||(O=h?.always?m.Trace:O,C=this.f(a,O??this.c,h),this.b.set(a,{logger:C,logLevel:O})),C}setLevel(a,h){const O=b.URI.isUri(a)?a:void 0,C=O?h:a;if(O){const W=this.b.get(O);W&&W.logLevel!==C&&(W.logLevel=C,W.logger.setLevel(C))}else this.c=C,this.b.forEach(({logLevel:W,logger:X})=>{W===void 0&&X.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(a){}getLevel(){return m.Info}trace(a,...h){}debug(a,...h){}info(a,...h){}warn(a,...h){}error(a,...h){}critical(a,...h){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;class n extends f{constructor(){super(m.Info,R.Event.None)}f(a,h,O){return new s}}e.NullLoggerService=n;function t(c){if(c.verbose)return m.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(c){switch(c){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(c){switch(c){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(Y[112],Q([0,1,19,4,11,3,2,14,61,9]),function($,e,T,R,k,L,N,b,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends N.Disposable{constructor(p,I){super(),this.a=p,this.b=I,this.c=this.B(new L.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new L.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(p,I){return I.recursive||this.b?.watcher?.forceUniversal?this.l(p,I):this.u(p,I)}l(p,I){const y={path:this.D(p),excludes:I.excludes,includes:I.includes,recursive:I.recursive},S=(0,T.insert)(this.j,y);return this.m(),(0,N.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,k.onUnexpectedError)(p))}n(){this.h||(this.h=this.B(this.p(I=>this.c.fire((0,g.toFileChanges)(I)),I=>this.C(I),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const I of this.j)(0,g.isRecursiveWatchRequest)(I)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const I of this.j)(0,g.isRecursiveWatchRequest)(I)&&p.includes(I.path)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,I){const y={path:this.D(p),excludes:I.excludes,includes:I.includes,recursive:!1},S=(0,T.insert)(this.s,y);return this.v(),(0,N.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,k.onUnexpectedError)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,g.toFileChanges)(p)),p=>this.C(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}C(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}D(p){return(0,b.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(Y[113],Q([0,1,19,4,15,22,3,53,64,2,114,16,115,17,43,91,13,60,9]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends l.Disposable{constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(s,i){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`);const n=new l.DisposableStore;return this.h.set(s,i),this.c.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(t=>this.R.fire(new E.FileChangesEvent(t,!this.O(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(t=>this.S.fire(new Error(t)))),n.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:s}))),(0,l.toDisposable)(()=>{this.c.fire({added:!1,scheme:s,provider:i}),this.h.delete(s),(0,l.dispose)(n)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const i=[];this.f.fire({scheme:s,join(n){i.push(n)}}),!this.h.has(s)&&await R.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,i){const n=this.h.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return g.Iterable.map(this.h,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async j(s){if(!(0,I.isAbsolutePath)(s))throw new E.FileOperationError((0,S.localize)(0,null,this.ob(s)),8);await this.activateProvider(s.scheme);const i=this.h.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,s.toString()),n}return i}async k(s){const i=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)||(0,E.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(s){const i=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.n(s,i)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,S.localize)(2,null,this.ob(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async n(s,i){const n=await this.j(s),t=this.O(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,a=await n.stat(s);let h;return this.p(n,s,a,void 0,!!c,(O,C)=>(h||(h=m.TernarySearchTree.forUris(()=>!t),h.set(s,!0),r&&h.fill(!0,r)),h.get(O.resource)||h.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&o?C===1:!1))}async p(s,i,n,t,r,o){const{providerExtUri:c}=this.N(s),a={resource:i,name:c.basename(i),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const h=await s.readdir(i),O=await R.Promises.settled(h.map(async([C,W])=>{try{const X=c.joinPath(i,C),J=r?await s.stat(X):{type:W};return await this.p(s,X,J,h.length,r,o)}catch(X){return this.b.trace(X),null}}));a.children=(0,T.coalesce)(O)}catch(h){this.b.trace(h),a.children=[]}return a}return a}async resolveAll(s){return R.Promises.settled(s.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.j(s),n=await i.stat(s);return this.p(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.j(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.r(s,i)}catch(n){return n}return!0}async r(s,i){if(!i?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,S.localize)(3,null,this.ob(s)),3,i)}async createFile(s,i=k.VSBuffer.fromString(""),n){await this.r(s,n);const t=await this.writeFile(s,i);return this.m.fire(new E.FileOperationEvent(s,0,t)),t}async writeFile(s,i,n){const t=this.mb(await this.l(s),s),{providerExtUri:r}=this.N(t);try{await this.s(t,s,n)||await this.P(t,r.dirname(s));let c;if((0,E.hasReadWriteCapability)(t)&&!(i instanceof k.VSBuffer))if((0,y.isReadableStream)(i)){const a=await(0,y.peekStream)(i,3);a.ended?c=k.VSBuffer.concat(a.buffer):c=a}else c=(0,y.peekReadable)(i,a=>k.VSBuffer.concat(a),3);else c=i;!(0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)&&c instanceof k.VSBuffer?await this.db(t,s,n,c):await this.Y(t,s,n,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this.m.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,S.localize)(4,null,this.ob(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async s(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.ob(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,S.localize)(6,null,this.ob(i)),0,n);if(this.nb(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,S.localize)(7,null),3,n);return r}async readFile(s,i,n){const t=await this.k(s);return i?.atomic?this.t(t,s,i,n):this.u(t,s,i,n)}async t(s,i,n,t){return new Promise((r,o)=>{this.X.queueFor(i,this.N(s).providerExtUri).queue(async()=>{try{const c=await this.u(s,i,n,t);r(c)}catch(c){o(c)}})})}async u(s,i,n,t){const r=await this.v(s,i,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const t=await this.k(s);return this.v(t,s,i,n)}async v(s,i,n,t){const r=new L.CancellationTokenSource(t),o=this.F(i,n).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?c=this.D(s,i,n):(0,E.hasFileReadStreamCapability)(s)?c=this.w(s,i,r.token,n):c=this.C(s,i,r.token,n),{...await o,value:c}}catch(a){c&&await(0,y.consumeStream)(c);const h=(0,S.localize)(8,null,this.ob(i),(0,E.ensureFileSystemProviderError)(a).toString());throw a instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(h,a.stat,n):new E.FileOperationError(h,(0,E.toFileOperationResult)(a),n)}}w(s,i,n,t=Object.create(null)){const r=s.readFileStream(i,t,n);return(0,y.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,S.localize)(9,null,this.ob(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}C(s,i,n,t=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,u.readFileIntoStream)(s,i,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>new E.FileOperationError((0,S.localize)(10,null,this.ob(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},n),r}D(s,i,n){const t=(0,y.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.G(i,r.byteLength,n),t.end(k.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async F(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,S.localize)(11,null,this.ob(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==E.ETAG_DISABLED&&i.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,i);return this.G(s,n.size,i),n}G(s,i,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&i>n.limits.size&&(t=7),typeof t=="number")throw new E.FileOperationError((0,S.localize)(13,null,this.ob(s)),t)}}async canMove(s,i,n){return this.H(s,i,"move",n)}async canCopy(s,i,n){return this.H(s,i,"copy",n)}async H(s,i,n,t){if(s.toString()!==i.toString())try{const r=n==="move"?this.mb(await this.l(s),s):await this.k(s),o=this.mb(await this.l(i),i);await this.M(r,s,o,i,n,t)}catch(r){return r}return!0}async move(s,i,n){const t=this.mb(await this.l(s),s),r=this.mb(await this.l(i),i),o=await this.I(t,s,r,i,"move",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,i,n){const t=await this.k(s),r=this.mb(await this.l(i),i),o=await this.I(t,s,r,i,"copy",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="copy"?3:2,c)),c}async I(s,i,n,t,r,o){if(i.toString()===t.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.M(s,i,n,t,r,o);if(c&&!a&&o&&await this.del(t,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(i,t,{overwrite:o});else{const h=await this.resolve(i);h.isDirectory?await this.L(s,h,n,t):await this.J(s,i,n,t)}return r}else return s===n?(await s.rename(i,t,{overwrite:o}),r):(await this.I(s,i,n,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async J(s,i,n,t){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.fb(s,i,n,t);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.lb(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.jb(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.hb(s,i,n,t)}async L(s,i,n,t){await n.mkdir(t),Array.isArray(i.children)&&await R.Promises.settled(i.children.map(async r=>{const o=this.N(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.L(s,await this.resolve(r.resource),n,o):this.J(s,r.resource,n,o)}))}async M(s,i,n,t,r,o){let c=!1;if(s===n){const{providerExtUri:h,isPathCaseSensitive:O}=this.N(s);if(O||(c=h.isEqual(i,t)),c&&r==="copy")throw new Error((0,S.localize)(14,null,this.ob(i),this.ob(t)));if(!c&&h.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.ob(i),this.ob(t)))}const a=await this.exists(t);if(a&&!c){if(!o)throw new E.FileOperationError((0,S.localize)(16,null,this.ob(i),this.ob(t)),4);if(s===n){const{providerExtUri:h}=this.N(s);if(h.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.ob(i),this.ob(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}N(s){const i=this.O(s);return{providerExtUri:i?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:i}}O(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.mb(await this.j(s),s);await this.P(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,0,n)),n}async P(s,i){const n=[],{providerExtUri:t}=this.N(s);for(;!t.isEqual(i,t.dirname(i));)try{if(((await s.stat(i)).type&E.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.ob(i)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(i)),i=t.dirname(i)}for(let r=n.length-1;r>=0;r--){i=t.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.Q(s,i)}catch(n){return n}return!0}async Q(s,i){const n=this.mb(await this.j(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.ob(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.nb(s,r);else throw new E.FileOperationError((0,S.localize)(20,null,this.ob(s)),1);if(!!!i?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.ob(s)))}return n}async del(s,i){const n=await this.Q(s,i),t=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this.m.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.j(s),t=this.mb(await this.l(i),i);if(n===t&&this.N(n).providerExtUri.isEqual(s,i))return;if(n===t&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.P(t,this.N(t).providerExtUri.dirname(i));const r=this.X.queueFor(s,this.N(n).providerExtUri);return n===t&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.J(n,s,t,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,l.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(s,i);t?(0,l.dispose)(o):r=()=>(0,l.dispose)(o)}catch(o){this.b.error(o)}})(),n}async W(s,i){const n=await this.j(s),t=(0,b.hash)([this.N(n).providerExtUri.getComparisonKey(s),i]);let r=this.U.get(t);return r||(r={count:0,disposable:n.watch(s,i)},this.U.set(t,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.U.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.U)(0,l.dispose)(s.disposable);this.U.clear()}async Y(s,i,n,t){return this.X.queueFor(i,this.N(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,y.isReadableStream)(t)||(0,y.isReadableBufferedStream)(t)?await this.ab(s,r,t):await this.bb(s,r,t)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async ab(s,i,n){let t=0,r;if((0,y.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.cb(s,i,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,y.listenStream)(r,{onData:async a=>{r.pause();try{await this.cb(s,i,a,a.byteLength,t,0)}catch(h){return c(h)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async bb(s,i,n){let t=0,r;for(;(r=n.read())!==null;)await this.cb(s,i,r,r.byteLength,t,0),t+=r.byteLength}async cb(s,i,n,t,r,o){let c=0;for(;c<t;)c+=await s.write(i,r+c,n.buffer,o+c,t-c)}async db(s,i,n,t){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.eb(s,i,n,t))}async eb(s,i,n,t){let r;t instanceof k.VSBuffer?r=t:(0,y.isReadableStream)(t)?r=await(0,k.streamToBuffer)(t):(0,y.isReadableBufferedStream)(t)?r=await(0,k.bufferedStreamToBuffer)(t):r=(0,k.readableToBuffer)(t),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async fb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.gb(s,i,n,t))}async gb(s,i,n,t){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let a=0,h=0,O=0;do O=await s.read(r,a,c.buffer,h,c.byteLength-h),await this.cb(n,o,c,O,a,h),a+=O,h+=O,h===c.byteLength&&(h=0);while(O>0)}catch(c){throw(0,E.ensureFileSystemProviderError)(c)}finally{await R.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async hb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.ib(s,i,n,t))}async ib(s,i,n,t){return n.writeFile(t,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async jb(s,i,n,t){return this.X.queueFor(t,this.N(n).providerExtUri).queue(()=>this.kb(s,i,n,t))}async kb(s,i,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.cb(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async lb(s,i,n,t){const r=await(0,k.streamToBuffer)(this.C(s,i,L.CancellationToken.None));await this.db(n,t,void 0,r)}mb(s,i){if(s.capabilities&2048)throw new E.FileOperationError((0,S.localize)(22,null,this.ob(i)),6);return s}nb(s,i){if((i.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,S.localize)(23,null,this.ob(s)),6)}ob(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};v=fe([_(0,d.ILogService)],v),e.FileService=v}),define(Y[116],Q([0,1,117,156,4,34,15,3,157,2,14,12,17,43,20,93,13,60,112,32,110,109]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u,d,v,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(T)}catch(n){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(n)}`)}})();class i extends d.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=b.Event.None,this.I=new L.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.M=new Map,this.N=new Map,this.O=new Map}get capabilities(){return this.G||(this.G=57374,w.isLinux&&(this.G|=1024)),this.G}async stat(t){try{const{stat:r,symbolicLink:o}=await y.SymlinkSupport.stat(this.D(t));return{type:this.H(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.ab(r)}}async readdir(t){try{const r=await y.Promises.readdir(this.D(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,c.name))).type:a=this.H(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(r){throw this.ab(r)}}H(t,r){let o;return r?.dangling?o=E.FileType.Unknown:t.isFile()?o=E.FileType.File:t.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async J(t){const r=this.D(t);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.I.get(t);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new k.Barrier;return this.I.set(t,c),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,l.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.I.get(t)===c&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.I.delete(t)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.D(t)})`),o=await this.J(t));const c=this.D(t);return await y.Promises.readFile(c)}catch(c){throw this.ab(c)}finally{o?.dispose()}}L(t){i.F&&this.a.trace(t)}readFileStream(t,r,o){const c=(0,I.newWriteableStream)(a=>N.VSBuffer.concat(a.map(h=>N.VSBuffer.wrap(h))).buffer);return(0,u.readFileIntoStream)(this,t,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(t,r,o){let c;try{const a=this.D(t);if(!o.create||!o.overwrite){if(await y.Promises.exists(a)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,S.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,S.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.bb(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){i.P=t}async open(t,r){const o=this.D(t);let c;(0,E.isFileOpenForWriteOptions)(r)&&(c=await this.J(t));let a;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:O}=await y.SymlinkSupport.stat(o);O.mode&128||await y.Promises.chmod(o,O.mode|128)}catch(O){this.a.trace(O)}let h;if((0,E.isFileOpenForWriteOptions)(r)){if(w.isWindows)try{await y.Promises.truncate(o,0),h="r+"}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}h||(h="w")}else h="r";a=await y.Promises.open(o,h)}catch(h){throw c?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.bb(t,h):this.ab(h)}if(this.M.set(a,0),(0,E.isFileOpenForWriteOptions)(r)&&this.O.set(a,t),c){const h=this.N.get(a);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.N.set(a,c),h&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(t){const r=this.N.get(t);try{if(this.M.delete(t),this.O.delete(t)&&i.P)try{await y.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await y.Promises.close(t)}catch(o){throw this.ab(o)}finally{r&&(this.N.get(t)===r&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.N.delete(t)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,c,a){const h=this.Q(t,r);let O=null;try{O=(await y.Promises.read(t,o,c,a,h)).bytesRead}catch(C){throw this.ab(C)}finally{this.R(t,h,O)}return O}Q(t,r){return r===this.M.get(t)?null:r}R(t,r,o){const c=this.M.get(t);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.M.set(t,c+o):this.M.delete(t)))}async write(t,r,o,c,a){return(0,k.retry)(()=>this.S(t,r,o,c,a),100,3)}async S(t,r,o,c,a){const h=this.Q(t,r);let O=null;try{O=(await y.Promises.write(t,o,c,a,h)).bytesWritten}catch(C){throw await this.bb(this.O.get(t),C)}finally{this.R(t,h,O)}return O}async mkdir(t){try{await y.Promises.mkdir(this.D(t))}catch(r){throw this.ab(r)}}async delete(t,r){try{const o=this.D(t);r.recursive?await y.Promises.rm(o,y.RimRafMode.MOVE):await y.Promises.unlink(o)}catch(o){throw this.ab(o)}}async rename(t,r,o){const c=this.D(t),a=this.D(r);if(c!==a)try{await this.U(t,r,"move",o.overwrite),await y.Promises.move(c,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),h.toString()))),this.ab(h)}}async copy(t,r,o){const c=this.D(t),a=this.D(r);if(c!==a)try{await this.U(t,r,"copy",o.overwrite),await y.Promises.copy(c,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),h.toString()))),this.ab(h)}}async U(t,r,o,c){const a=this.D(t),h=this.D(r);let O=!1;if(!!(this.capabilities&1024)||(O=(0,g.isEqual)(a,h,!0)),O&&o==="copy")throw(0,E.createFileSystemProviderError)((0,S.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!O&&await y.Promises.exists(h)){if(!c)throw(0,E.createFileSystemProviderError)((0,S.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.W(t,r,!1)}async W(t,r,o){const c=this.D(t),a=this.D(r),h=!!(this.capabilities&1024);if((0,g.isEqual)(c,a,!h))return;const O=new l.DisposableStore;try{const[C,W]=await Promise.all([this.J(t),this.J(r)]);O.add(C),O.add(W),o&&await y.Promises.mkdir((0,m.dirname)(a),{recursive:!0}),await y.Promises.copyFile(c,a)}catch(C){if(C.code==="ENOENT"&&!o)return this.W(t,r,!0);throw this.ab(C)}finally{O.dispose()}}p(t,r,o){return new f.UniversalWatcherClient(c=>t(c),c=>r(c),o)}y(t,r,o){return new s.NodeJSWatcherClient(c=>t(c),c=>r(c),o)}ab(t){if(t instanceof E.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(t,r)}async bb(t,r){let o=this.ab(r);if(t&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await y.SymlinkSupport.stat(this.D(t));c.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=i,i.F=!1,i.P=!0}),define(Y[118],Q([0,1,13,9]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(k||(k={}));async function L(l,m,w,p,I){try{const y=await new Promise((E,u)=>{$(["spdlog"],E,u)});y.setFlushOn(R.LogLevel.Trace);const S=await y.createAsyncRotatingLogger(l,m,w,p);return I?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(y){console.error(y)}return null}function N(l,m,w){switch(m){case R.LogLevel.Trace:l.trace(w);break;case R.LogLevel.Debug:l.debug(w);break;case R.LogLevel.Info:l.info(w);break;case R.LogLevel.Warning:l.warn(w);break;case R.LogLevel.Error:l.error(w);break;default:throw new Error(`Invalid log level ${m}`)}}function b(l,m){switch(m){case R.LogLevel.Trace:l.setLevel(k.Trace);break;case R.LogLevel.Debug:l.setLevel(k.Debug);break;case R.LogLevel.Info:l.setLevel(k.Info);break;case R.LogLevel.Warning:l.setLevel(k.Warning);break;case R.LogLevel.Error:l.setLevel(k.Error);break;case R.LogLevel.Off:l.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class g extends R.AbstractMessageLogger{constructor(m,w,p,I,y){super(),this.j=[],this.setLevel(y),this.k=this.m(m,w,p,I),this.B(this.onDidChangeLogLevel(S=>{this.l&&b(this.l,S)}))}async m(m,w,p,I){const y=p?6:1,S=30/y*T.ByteSize.MB,E=await L(m,w,S,y,I);if(E){this.l=E,b(this.l,this.getLevel());for(const{level:u,message:d}of this.j)N(this.l,u,d);this.j=[]}}f(m,w){this.l?N(this.l,m,w):this.getLevel()<=m&&this.j.push({level:m,message:w})}flush(){this.l?this.l.flush():this.k.then(()=>this.flush())}dispose(){this.l?this.p():this.k.then(()=>this.p())}p(){this.l&&(this.l.drop(),this.l=void 0)}}e.SpdLogLogger=g}),define(Y[37],Q([0,1,3,64,2,7]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const m=Object.keys(this.f).length;return this.f={...l,...this.f},m!==Object.keys(this.f).length&&await this.i(l),R.Iterable.reduce(this.g.entries(),(w,[p,I])=>({...w,[p]:I}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(l,[m,w])=>({...l,[m]:{definition:w,value:this.g.get(m)}}),{})}}e.AbstractPolicyService=N;class b{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(Y[119],Q([0,1,4,3,64,8,13,9,37]),function($,e,T,R,k,L,N,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(w,p){const I=[];for(const y of k.Iterable.concat(w.keys(),p.keys()))w.get(y)!==p.get(y)&&I.push(y);return I}let m=class extends g.AbstractPolicyService{constructor(p,I,y){super(),this.j=p,this.k=I,this.l=y,this.c=this.B(new T.ThrottledDelayer(500));const S=R.Event.filter(I.onDidFilesChange,E=>E.affects(p));this.B(I.watch(p)),this.B(S(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const I=await this.k.readFile(this.j),y=JSON.parse(I.value.toString());if(!(0,L.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(y))this.f[S]&&p.set(S,y[S])}catch(I){I.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",I)}return p}async p(){const p=await this.n(),I=l(this.g,p);this.g=p,I.length>0&&this.h.fire(I)}};m=fe([_(1,N.IFileService),_(2,b.ILogService)],m),e.FilePolicyService=m}),define(Y[30],Q([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Y[35],Q([0,1,69,8]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,b){T.ok(R.isString(N)),T.ok(R.isObject(b)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Y[120],Q([0,1,3,35]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[k(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;R.Registry.add(e.Extensions.JSONContribution,N)}),define(Y[40],Q([0,1,19,3,8,82,21,120,35]),function($,e,T,R,k,L,N,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(l=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=g.Registry.as(b.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const t=this.k(i,n);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const n=this.l(i);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:i,remove:n}){const t=[];t.push(...this.l(n)),t.push(...this.k(i,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,T.distinct)(t)})}registerDefaultConfigurations(i){const n=[],t=[];for(const{overrides:r,source:o}of i)for(const c in r)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),h=a?.valuesSources??new Map;if(o)for(const X of Object.keys(r[c]))h.set(X,o);const O={...a?.value||{},...r[c]};this.a.set(c,{source:o,value:O,valuesSources:h});const C=(0,N.getLanguageTagSettingPlainKey)(c),W={type:"object",default:O,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:O,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(c)),this.d[c]=W,this.b.properties[c]=W}else{this.a.set(c,{value:r[c],source:o});const a=this.d[c];a&&(this.s(c,a),this.o(c,a))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:t,source:r}of i)for(const o in t){const c=this.a.get(o),a=k.isString(r)?r:r?.id,h=k.isString(c?.source)?c?.source:c?.source?.id;if(a===h)if(n.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const O=this.d[o];O&&(this.s(o,O),this.o(o,O))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const n of i)this.h.add(n);this.q()}k(i,n){const t=[];return i.forEach(r=>{t.push(...this.m(r,n,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),t}l(i){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.p(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}return n}m(i,n=!0,t,r,o=3){o=k.isUndefinedOrNull(i.scope)?o:i.scope;const c=[],a=i.properties;if(a)for(const O in a){const C=a[O];if(n&&v(O,C)){delete a[O];continue}if(C.source=t,C.defaultDefaultValue=a[O].default,this.s(O,C),e.OVERRIDE_PROPERTY_REGEX.test(O)?C.scope=void 0:(C.scope=k.isUndefinedOrNull(C.scope)?o:C.scope,C.restricted=k.isUndefinedOrNull(C.restricted)?!!r?.includes(O):C.restricted),a[O].hasOwnProperty("included")&&!a[O].included){this.f[O]=a[O],delete a[O];continue}else this.d[O]=a[O],a[O].policy?.name&&this.e.set(a[O].policy.name,O);!a[O].deprecationMessage&&a[O].markdownDeprecationMessage&&(a[O].deprecationMessage=a[O].markdownDeprecationMessage),c.push(O)}const h=i.allOf;if(h)for(const O of h)c.push(...this.m(O,n,t,r,o));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const n=t=>{const r=t.properties;if(r)for(const c in r)this.o(c,r[c]);t.allOf?.forEach(n)};n(i)}o(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.g.properties[i]=n;break}}p(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const n=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,t),e.allSettings.properties[n]=t,e.applicationSettings.properties[n]=t,e.machineSettings.properties[n]=t,e.machineOverridableSettings.properties[n]=t,e.windowSettings.properties[n]=t,e.resourceSettings.properties[n]=t}this.i.fire()}r(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,n){const t=this.a.get(i);let r=t?.value,o=t?.source;k.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),k.isUndefined(r)&&(r=u(n.type)),n.default=r,n.defaultValueSource=o}}const I="\\[([^\\]]+)\\]",y=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(s){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=y.exec(s);for(;n?.length;){const t=n[1].trim();t&&i.push(t),n=y.exec(s)}}return(0,T.distinct)(i)}e.overrideIdentifiersFromKey=S;function E(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=E;function u(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new p;g.Registry.add(e.Extensions.Configuration,d);function v(s,i){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):d.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,s,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=v;function f(){const s=[],i=d.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Y[65],Q([0,1,19,3,50,2,34,28,8,10,21,40,35]),function($,e,T,R,k,L,N,b,g,l,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(n={},t=[],r=[],o){this.c=n,this.d=t,this.f=r,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof I)return t;const r=new y("");return r.parseRaw(t),r.configurationModel});this.g=n.reduce((t,r)=>r===t?r:t.merge(r),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,m.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const r=this.rawConfiguration.getValue(n),o=t?this.rawConfiguration.getOverrideValue(n,t):void 0,c=t?this.rawConfiguration.override(t).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,t){const r=this.l(t);return r?n?(0,m.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return T.distinct(n)}override(n){let t=this.b.get(n);return t||(t=this.h(n),this.b.set(n,t)),t}merge(...n){const t=b.deepClone(this.contents),r=b.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of n)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(t,a.contents);for(const h of a.overrides){const[O]=r.filter(C=>T.equals(C.identifiers,h.identifiers));O?(this.j(O.contents,h.contents),O.keys.push(...h.keys),O.keys=T.distinct(O.keys)):r.push(b.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new I(t,o,r,c.every(a=>a instanceof I)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new I(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}h(n){const t=this.l(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const a=t[o];a&&(typeof c=="object"&&typeof a=="object"?(c=b.deepClone(c),this.j(c,a)):c=a),r[o]=c}return new I(r,this.keys,this.overrides)}j(n,t){for(const r of Object.keys(t)){if(r in n&&g.isObject(n[r])&&g.isObject(t[r])){this.j(n[r],t[r]);continue}n[r]=b.deepClone(t[r])}}k(n){return this.a&&!Object.isFrozen(n)?b.deepFreeze(n):n}l(n){let t=null,r=null;const o=c=>{c&&(r?this.j(r,c):r=b.deepClone(c))};for(const c of this.overrides)T.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.m(n),(0,m.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.n(n)&&(0,m.removeFromValueTree)(this.contents,n)}m(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}n(n){const t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=I;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,t){if(!g.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,t)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,t){this.a=n;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:h}=this.h(n,t);this.b=new I(r,o,c,h?[n]:void 0),this.c=a||[]}g(n){let t={},r=null,o=[];const c=[],a=[];function h(C){Array.isArray(o)?o.push(C):r!==null&&(o[r]=C)}const O={onObjectBegin:()=>{const C={};h(C),c.push(o),o=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const C=[];h(C),c.push(o),o=C,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:h,onError:(C,W,X)=>{a.push({error:C,offset:W,length:X})}};if(n)try{k.visit(n,O),t=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return t}h(n,t){const r=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.j(n,r,!0,t);n=o.raw;const c=(0,m.toValuesTree)(n,O=>console.error(`Conflict in settings file ${this.f}: ${O}`)),a=Object.keys(n),h=this.l(n,O=>console.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:c,keys:a,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,t,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const a={},h=[];for(const O in n)if(w.OVERRIDE_PROPERTY_REGEX.test(O)&&r){const C=this.j(n[O],t,!1,o);a[O]=C.raw,c=c||C.hasExcludedProperties,h.push(...C.restricted)}else{const C=t[O],W=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&h.push(O),(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&!(o.skipRestricted&&C?.restricted)?a[O]=n[O]:c=!0}return{raw:a,restricted:h,hasExcludedProperties:c}}l(n,t){const r=[];for(const o of Object.keys(n))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in n[o])c[a]=n[o][a];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,m.toValuesTree)(c,t)})}return r}}e.ConfigurationModelParser=y;class S extends L.Disposable{constructor(n,t,r,o){super(),this.f=n,this.g=t,this.h=o,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new y(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=S;class E{constructor(n,t,r,o,c,a,h,O,C,W,X,J,ie){this.a=n,this.b=t,this.value=r,this.overrideIdentifiers=o,this.c=c,this.d=a,this.f=h,this.g=O,this.h=C,this.j=W,this.k=X,this.l=J,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(n,t,r,o,c=new I,a=new I,h=new N.ResourceMap,O=new I,C=new N.ResourceMap,W=!0){this.c=n,this.d=t,this.f=r,this.g=o,this.h=c,this.j=a,this.l=h,this.m=O,this.n=C,this.p=W,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(n,t,r){return this.s(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this.n.get(r.resource),o||(o=new I,this.n.set(r.resource,o))):o=this.m,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this.a=null)}inspect(n,t,r){const o=this.s(n,t,r),c=T.distinct(o.overrides.map(O=>O.identifiers).flat()).filter(O=>o.getOverrideValue(n,O)!==void 0),a=this.w(t.resource,r),h=t.resource?this.n.get(t.resource)||this.m:this.m;return new E(n,t,o.getValue(n),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,a?a.freeze():void 0,h.inspect(n,t.overrideIdentifier))}keys(n){const t=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,t){this.l.set(n,t),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:c,removed:a}=f(this.c,n);t=[...o,...c,...a]}for(const o of t)for(const c of(0,w.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(c),h=n.getKeysForOverrideIdentifier(c),O=[...h.filter(C=>a.indexOf(C)===-1),...a.filter(C=>h.indexOf(C)===-1),...a.filter(C=>!b.equals(this.c.override(c).getValue(C),n.override(c).getValue(C)))];r.push([c,O])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=f(this.d,n),c=[...t,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.applicationConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.localUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.remoteUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.workspaceConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const r=this.r.get(n),{added:o,updated:c,removed:a,overrides:h}=f(r,t),O=[...o,...c,...a];return(O.length||!r)&&this.updateFolderConfiguration(n,t),{keys:O,overrides:h}}compareAndDeleteFolderConfiguration(n){const t=this.r.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:a}=f(t,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,t,r){let o=this.t(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}t({resource:n},t){let r=this.u();if(t&&n){const o=t.getFolder(n);o&&(r=this.v(o.uri)||r);const c=this.n.get(n);c&&(r=r.merge(c))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let t=this.b.get(n);if(!t){const r=this.u(),o=this.l.get(n);o?(t=r.merge(o),this.p&&(t=t.freeze()),this.b.set(n,t)):t=r}return t}w(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:c}=this.l.get(t);return n.push([t,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this.j.freeze().keys.forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}y(n){const t=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.j.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.A(n.defaults),r=this.A(n.policy),o=this.A(n.application),c=this.A(n.user),a=this.A(n.workspace),h=n.folders.reduce((O,C)=>(O.set(l.URI.revive(C[0]),this.A(C[1])),O),new N.ResourceMap);return new u(t,r,o,c,new I,a,h,new I,new N.ResourceMap,!1)}static A(n){return new I(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=u;function d(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,t=new Map;for(const o of i)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,a])=>{const h=(0,N.getOrSet)(t,c,new Set);a.forEach(O=>h.add(O))});const r=[];return t.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=d;class v{constructor(n,t,r,o){this.change=n,this.b=t,this.c=r,this.d=o,this.f=void 0;const c=new Set;n.keys.forEach(h=>c.add(h)),n.overrides.forEach(([,h])=>h.forEach(O=>c.add(O))),this.affectedKeys=[...c.values()];const a=new I;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(n,t){if(this.g(this.a,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.b?.workspace):void 0,o=this.c.getValue(n,t,this.d);return!b.equals(r,o)}return!0}return!1}g(n,t){let r=(0,m.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=v;function f(i,n){const{added:t,removed:r,updated:o}=s(n?.rawConfiguration,i?.rawConfiguration),c=[],a=i?.getAllOverrideIdentifiers()||[],h=n?.getAllOverrideIdentifiers()||[];if(n){const O=h.filter(C=>!a.includes(C));for(const C of O)c.push([C,n.getKeysForOverrideIdentifier(C)])}if(i){const O=a.filter(C=>!h.includes(C));for(const C of O)c.push([C,i.getKeysForOverrideIdentifier(C)])}if(n&&i){for(const O of a)if(h.includes(O)){const C=s({contents:i.getOverrideValue(void 0,O)||{},keys:i.getKeysForOverrideIdentifier(O)},{contents:n.getOverrideValue(void 0,O)||{},keys:n.getKeysForOverrideIdentifier(O)});c.push([O,[...C.added,...C.removed,...C.updated]])}}return{added:t,removed:r,updated:o,overrides:c}}function s(i,n){const t=i?n?i.keys.filter(c=>n.keys.indexOf(c)===-1):[...i.keys]:[],r=n?i?n.keys.filter(c=>i.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(i&&n){for(const c of n.keys)if(i.keys.indexOf(c)!==-1){const a=(0,m.getConfigurationValue)(n.contents,c),h=(0,m.getConfigurationValue)(i.contents,c);b.equals(a,h)||o.push(c)}}return{added:t,removed:r,updated:o}}}),define(Y[121],Q([0,1,19,3,2,28,8,21,65,40,9,37,35]),function($,e,T,R,k,L,N,b,g,l,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new y(this.f())),this.b}async initialize(){return this.b=void 0,this.B(p.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:v})=>this.c(d,v))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(d,v){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}}e.DefaultConfiguration=I;class y extends g.ConfigurationModel{constructor(d={}){const v=p.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(v),s=Object.create(null),i=[];for(const n in v){const t=d[n],r=t!==void 0?t:v[n].default;(0,b.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))l.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,l.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,b.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,f,i)}}e.DefaultConfigurationModel=y;class S{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new g.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let E=class extends k.Disposable{get configurationModel(){return this.b}constructor(d,v,f){super(),this.c=d,this.f=v,this.g=f,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new g.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){const v={},f=[],s=p.Registry.as(l.Extensions.Configuration).getConfigurationProperties();for(const i of d){const n=s[i];if(!n){f.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(i),v[n.policy.name]={type:n.type}}}return(0,N.isEmptyObject)(v)||await this.f.updatePolicyDefinitions(v),f}i(d){const v=p.Registry.as(l.Extensions.Configuration).getPolicyConfigurations(),f=(0,T.coalesce)(d.map(s=>v.get(s)));this.j(f,!0)}j(d,v){const f=p.Registry.as(l.Extensions.Configuration).getConfigurationProperties(),s=[],i=this.b.isEmpty();for(const n of d){const t=f[n]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(i?r!==void 0:!(0,L.equals)(this.b.getValue(n),r))&&s.push([n,r])}else this.b.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this.b;this.b=new g.ConfigurationModel;for(const t of n.keys)this.b.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);v&&this.a.fire(this.b)}}};E=fe([_(1,w.IPolicyService),_(2,m.ILogService)],E),e.PolicyConfiguration=E}),define(Y[122],Q([0,1,4,3,2,17,21,65,121,37]),function($,e,T,R,k,L,N,b,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends k.Disposable{constructor(p,I,y,S){super(),this.i=p,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=y instanceof l.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,y,S)),this.f=this.B(new b.UserSettings(this.i,void 0,L.extUriBiasedIgnorePathCase,I)),this.a=new b.Configuration(this.b.configurationModel,this.c.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:E,properties:u})=>this.k(E,u))),this.B(this.c.onDidChangeConfiguration(E=>this.l(E))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,I,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.Configuration(p,I,new b.ConfigurationModel,y)}getConfigurationData(){return this.a.toData()}getValue(p,I){const y=typeof p=="string"?p:void 0,S=(0,N.isConfigurationOverrides)(p)?p:(0,N.isConfigurationOverrides)(I)?I:{};return this.a.getValue(y,S,void 0)}updateValue(p,I,y,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const I=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(y,I,2)}k(p,I){const y=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(p,I);this.m(S,y,7)}l(p){const I=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.m(y,I,7)}m(p,I,y){const S=new b.ConfigurationChangeEvent(p,{data:I},this.a);S.source=y,S.sourceConfig=this.n(y),this.h.fire(S)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(Y[123],Q([0,1,16]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(l){return l.scheme===T.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=R;function k(l){if(!l)return;const m=l.indexOf("+");return m<0?l:l.substr(0,m)}e.getRemoteName=k;function L(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=L;function N(l){const{host:m,port:w}=g(l);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:w}}e.parseAuthorityWithPort=N;function b(l,m){let{host:w,port:p}=g(l);return typeof p>"u"&&(p=m),{host:w,port:p}}e.parseAuthorityWithOptionalPort=b;function g(l){const m=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const w=l.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(Y[26],Q([0,1,29,7,123]),function($,e,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=L;function N(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var g;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class l{constructor(S){this.value=S,this.c=S.toLowerCase()}static equals(S,E){if(typeof S>"u"||S===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof S=="string"||typeof E=="string"){const u=typeof S=="string"?S:S.value,d=typeof E=="string"?E:E.value;return T.equalsIgnoreCase(u,d)}return S.c===E.c}static toKey(S){return typeof S=="string"?S.toLowerCase():S.c}}e.ExtensionIdentifier=l;function m(y){return w(y)}e.isApplicationScopedExtension=m;function w(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function p(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function I(y,S){if(S){const E=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return y.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[24],Q([0,1,29,23,26,12,10,11,33]),function($,e,T,R,k,L,N,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function l(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,T.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=l;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,r,o)}static parse(t){const r=m.exec(t);return r&&r[1]&&r[2]?new w({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?l(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(n){const t=p.exec(n);return t&&t[1]?[S(t[1]),t[2]]:[S(n),void 0]}e.getIdAndVersion=I;function y(n,t){return`${n}.${t}`}e.getExtensionId=y;function S(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function E(n,t){return S(y(n,t))}e.getGalleryExtensionId=E;function u(n,t){const r=[],o=c=>{for(const a of r)if(a.some(h=>l(t(h),t(c))))return a;return null};for(const c of n){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=u;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function v(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!l(a.identifier,{id:c}))){const a=n.filter(h=>l(h.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,t){if(!L.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function i(n,t){const r=await s(n,t),o=(0,R.getTargetPlatform)(r?"alpine":L.platform,g.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(Y[124],Q([0,1,22,11,16,17,39,10,85,23,24,26]),function($,e,T,R,k,L,N,b,g,l,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const p=E=>(0,g.localize)(0,null,E),I=(0,g.localize)(1,null,"ms-dotnettools.csharp");function y(E,u){return u?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let S=class{constructor(u,d){this.a=u,this.b=d}get d(){}async listExtensions(u,d,v,f=console){let s=await this.a.getInstalled(1,v);const i=w.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(d&&d!==""){if(i.indexOf(d.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){f.log("Possible Categories: "),i.forEach(t=>{f.log(t)});return}this.d&&f.log((0,g.localize)(2,null,this.d)),s=s.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let n;for(const t of s)n!==t.identifier.id&&(n=t.identifier.id,f.log(y(t.manifest,u)))}async installExtensions(u,d,v,f,s=console){const i=[],n=[];u.length&&s.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const t=await this.a.getInstalled(1,v.profileLocation),r=(h,O)=>{const C=t.find(W=>(0,m.areSameExtensions)(W.identifier,{id:h}));if(C){if(!f&&(!O||O==="prerelease"&&C.preRelease))return s.log((0,g.localize)(5,null,h,C.manifest.version,h)),!1;if(O&&C.manifest.version===O)return s.log((0,g.localize)(6,null,`${h}@${O}`)),!1}return!0},o=(h,O,C)=>{a.push({id:h,version:O!=="prerelease"?O:void 0,installOptions:{...v,isBuiltin:C,installPreReleaseVersion:O==="prerelease"||v.installPreReleaseVersion}})},c=[],a=[];for(const h of u)if(h instanceof b.URI)c.push(h);else{const[O,C]=(0,m.getIdAndVersion)(h);r(O,C)&&o(O,C,!1)}for(const h of d){const[O,C]=(0,m.getIdAndVersion)(h);r(O,C)&&o(O,C,!0)}if(c.length&&await Promise.all(c.map(async h=>{try{const O=await this.f(h,{...v,isBuiltin:!1},f,s);O&&n.push(O)}catch(O){s.error(O.message||O.stack||O),i.push(h.toString())}})),a.length){const h=await this.g(a);await Promise.all(a.map(async O=>{const C=h.get(O.id.toLowerCase());if(C)try{const W=await this.h(O,C,t,f,s);W&&n.push(W)}catch(W){s.error(W.message||W.stack||W),i.push(O.id)}else s.error(`${p(O.version?`${O.id}@${O.version}`:O.id)}
${I}`),i.push(O.id)}))}if(i.length)throw new Error((0,g.localize)(7,null,i.join(", ")))}async f(u,d,v,f){const s=await this.a.getManifest(u);if(!s)throw new Error("Invalid vsix");if(await this.k(s,v,d.profileLocation,f))try{return await this.a.install(u,d),f.log((0,g.localize)(8,null,(0,L.basename)(u))),s}catch(n){if((0,R.isCancellationError)(n))return f.log((0,g.localize)(9,null,(0,L.basename)(u))),null;throw n}return null}async g(u){const d=new Map,v=u.some(s=>s.installOptions.installPreReleaseVersion),f=await this.b.getExtensions(u.map(s=>({...s,preRelease:v})),T.CancellationToken.None);for(const s of f)d.set(s.identifier.id.toLowerCase(),s);return d}async h({id:u,version:d,installOptions:v},f,s,i,n){const t=await this.b.getManifest(f,T.CancellationToken.None);if(t&&!this.j(t,n))return null;const r=s.find(o=>(0,m.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,g.localize)(10,null,d?`${u}@${d}`:u)),null;n.log((0,g.localize)(11,null,u,f.version))}try{v.isBuiltin?n.log(d?(0,g.localize)(12,null,u,d):(0,g.localize)(13,null,u)):n.log(d?(0,g.localize)(14,null,u,d):(0,g.localize)(15,null,u));const o=await this.a.installFromGallery(f,{...v,installGivenVersion:!!d});return n.log((0,g.localize)(16,null,u,o.manifest.version)),t}catch(o){if((0,R.isCancellationError)(o))return n.log((0,g.localize)(17,null,u)),null;throw o}}j(u,d){return!0}async k(u,d,v,f){const s={id:(0,m.getGalleryExtensionId)(u.publisher,u.name)},n=(await this.a.getInstalled(1,v)).find(t=>(0,m.areSameExtensions)(s,t.identifier)&&(0,N.gt)(t.manifest.version,u.version));return n&&!d?(f.log((0,g.localize)(18,null,n.identifier.id,n.manifest.version,u.version)),!1):this.j(u,f)}async uninstallExtensions(u,d,v,f=console){const s=async n=>{if(n instanceof b.URI){const t=await this.a.getManifest(n);return y(t)}return n},i=[];for(const n of u){const t=await s(n),o=(await this.a.getInstalled(void 0,v)).filter(c=>(0,m.areSameExtensions)(c.identifier,{id:t}));if(!o.length)throw new Error(`${this.l(t)}
${I}`);if(o.some(c=>c.type===0)){f.log((0,g.localize)(19,null,t));return}if(!d&&o.some(c=>c.isBuiltin)){f.log((0,g.localize)(20,null,t));return}f.log((0,g.localize)(21,null,t));for(const c of o)await this.a.uninstall(c,{profileLocation:v}),i.push(c);this.d?f.log((0,g.localize)(22,null,t,this.d)):f.log((0,g.localize)(23,null,t))}}async locateExtension(u,d=console){const v=await this.a.getInstalled();u.forEach(f=>{v.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===k.Schemas.file){d.log(s.location.fsPath);return}})})}l(u){return this.d?(0,g.localize)(24,null,u,this.d):(0,g.localize)(25,null,u)}};S=fe([_(0,l.IExtensionManagementService),_(1,l.IExtensionGalleryService)],S),e.ExtensionManagementCLI=S}),define(Y[125],Q([0,1,4,11,2,16,12,17,39,31,20,21,18,23,24,59,13,9]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class Ve extends k.Disposable{constructor(f,s,i,n,t,r){super(),this.h=s,this.i=i,this.j=n,this.k=t,this.l=r,this.extensionsDownloadDir=f.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(f,s){await this.g;const i=(0,b.joinPath)(this.extensionsDownloadDir,this.u(f));try{await this.n(f,i,t=>this.i.download(f,t,s))}catch(t){throw new I.ExtensionManagementError(t.message,I.ExtensionManagementErrorCode.Download)}let n=!1;if(f.isSigned&&this.j.getValue("extensions.verifySignature")===!0){const t=await this.m(f);try{n=await this.k.verify(i.fsPath,t.fsPath),this.l.info(`Verified extension: ${f.identifier.id}`,n)}catch(r){throw await this.delete(t),await this.delete(i),new I.ExtensionManagementError(r.code,I.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:n}}async m(f){await this.g;const s=(0,b.joinPath)(this.extensionsDownloadDir,`${this.u(f)}${Ve.c}`);return await this.n(f,s,i=>this.i.downloadSignatureArchive(f,i)),s}async n(f,s,i){if(await this.h.exists(s))return;if(s.scheme!==L.Schemas.file){await i(s);return}const n=(0,b.joinPath)(this.extensionsDownloadDir,`.${(0,l.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.r(n,s,Date.now()+2*60*1e3)}catch(t){try{await this.h.del(n)}catch{}if(t.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",f.identifier.id,s.path);else throw this.l.info(`Rename failed because of ${(0,R.getErrorMessage)(t)}. Deleted the file from downloaded location`,n.path),t}}async delete(f){await this.g,await this.h.del(f)}async r(f,s,i){try{await m.Promises.rename(f.fsPath,s.fsPath)}catch(n){if(N.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.r(f,s,i);throw n}}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const f=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],i=[],n=[];for(const o of f.children)if(o.name.endsWith(Ve.c))n.push(o.resource);else{const c=y.ExtensionKey.parse(o.name);c&&i.push([c,o])}const t=(0,y.groupByExtension)(i,([o])=>o),r=[];for(const o of t)o.sort((c,a)=>g.rcompare(c[0].version,a[0].version)),s.push(...o.slice(1).map(c=>c[1].resource)),r.push(o[0][1]);r.sort((o,c)=>o.mtime-c.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),s.push(...n),await T.Promises.settled(s.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(f){this.l.error(f)}}u(f){return this.f?y.ExtensionKey.create(f).toString().toLowerCase():(0,l.generateUuid)()}};d.c=".sigzip",d=fe([_(0,p.INativeEnvironmentService),_(1,E.IFileService),_(2,I.IExtensionGalleryService),_(3,w.IConfigurationService),_(4,S.IExtensionSignatureVerificationService),_(5,u.ILogService)],d),e.ExtensionsDownloader=d}),define(Y[126],Q([0,1,2,14,20,26]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(g,l){super(),this.b=g,this.a=(0,R.join)(this.b.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this.B(l.onDidInstallExtensions(m=>this.c(m))),this.B(l.onDidUninstallExtension(m=>this.f(m)))}c(g){g.some(l=>!!l.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Y[127],Q([0,1,3,2,34,24,26]),function($,e,T,R,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends R.Disposable{constructor(l,m,w,p,I,y,S){super(),this.f=l,this.g=m,this.h=w,this.i=p,this.j=I,this.k=y,this.l=S,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,E=>S.error(E))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.D()}n(){this.B(this.h.onDidChangeProfiles(l=>this.p(l.added,l.removed))),this.B(this.i.onAddExtensions(l=>this.r(l))),this.B(this.i.onDidAddExtensions(l=>this.s(l))),this.B(this.i.onRemoveExtensions(l=>this.t(l))),this.B(this.i.onDidRemoveExtensions(l=>this.u(l))),this.B(this.k.onDidFilesChange(l=>this.v(l)))}async p(l,m){try{await Promise.all(m.map(w=>(this.c.deleteAndDispose(w.id),this.C(w.extensionsResource))))}catch(w){this.l.error(w)}try{l.length&&await Promise.all(l.map(w=>(this.c.set(w.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){this.l.error(w)}}async r(l){for(const m of l.extensions)this.F(this.H(m.identifier,m.version),l.profileLocation)}async s(l){for(const m of l.extensions){const w=this.H(m.identifier,m.version);l.error?this.G(w,l.profileLocation):this.F(w,l.profileLocation)}}async t(l){for(const m of l.extensions)this.G(this.H(m.identifier,m.version),l.profileLocation)}async u(l){let m=!1;for(const w of l.extensions){const p=this.H(w.identifier,w.version);l.error?this.F(p,l.profileLocation):(this.G(p,l.profileLocation),m=m||!this.b.has(p))}m&&await this.D()}v(l){for(const m of this.h.profiles)l.contains(m.extensionsResource,0,1)&&this.w(m.extensionsResource)}async w(l){const m=[],w=[],p=await this.i.scanProfileExtensions(l),I=new Set,y=new Set;for(const[S,E]of this.b)E.has(l)&&y.add(S);for(const S of p){const E=this.H(S.identifier,S.version);I.add(E),y.has(E)||(m.push(S.identifier),this.F(E,l))}for(const S of y)if(!I.has(S)){const E=this.I(S);E&&(w.push(E.identifier),this.G(S,l))}(m.length||w.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:l}:void 0,removed:w.length?{extensions:w,profileLocation:l}:void 0})}async y(l){const m=await this.i.scanProfileExtensions(l);for(const w of m)this.F(this.H(w.identifier,w.version),l)}async C(l){for(const m of[...this.b.keys()])this.G(m,l);await this.D()}async D(){const m=(await this.f.getAllUserInstalled()).filter(w=>!this.b.has(this.H(w.identifier,w.manifest.version)));m.length&&await this.f.markAsUninstalled(...m)}F(l,m){let w=this.b.get(l);w||this.b.set(l,w=new k.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),w.add(m)}G(l,m){const w=this.b.get(l);w&&w.delete(m),w?.size||this.b.delete(l)}H(l,m){return`${N.ExtensionIdentifier.toKey(l.id)}@${m}`}I(l){const[m,w]=(0,L.getIdAndVersion)(l);return w?{identifier:{id:m},version:w}:void 0}}e.ExtensionsWatcher=b}),define(Y[128],Q([0,1,158,19,4,2,16,14,20,18,23,24,9,63,12,10]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends I.LanguagePackBaseService{constructor(f,s,i,n){super(i),this.h=f,this.i=n,this.g=this.B(new u(s,n)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(f){const i=(await this.g.getLanguagePacks())[y.Language.value()];if(!i){this.i.warn(`No language pack found for ${y.Language.value()}`);return}const n=i.translations[f];return n?S.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),s=Object.keys(f).map(i=>{const n=f[i];return{...this.f(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.f("en","English"),extensionId:"default"}),s.sort((i,n)=>i.label.localeCompare(n.label)),s}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const s=await this.g.getLanguagePacks();Object.keys(s).some(i=>s[i]&&s[i].extensions.some(n=>(0,w.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(s);return!(0,R.equals)(Object.keys(f),Object.keys(i))}};E=fe([_(0,m.IExtensionManagementService),_(1,l.INativeEnvironmentService),_(2,m.IExtensionGalleryService),_(3,p.ILogService)],E),e.NativeLanguagePackService=E;let u=class extends L.Disposable{constructor(f,s){super(),this.i=s,this.c={},this.f=(0,b.join)(f.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(s=>{Object.keys(s).forEach(i=>delete s[i]),this.j(s,...f)}).then(()=>this.c)}j(f,...s){for(const i of s)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(f,i);Object.keys(f).forEach(i=>this.l(f[i]))}k(f,s){const i=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const t of n)if(s.location.scheme===N.Schemas.file&&d(t)){let r=f[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},f[t.languageId]=r);const o=r.extensions.filter(c=>(0,w.areSameExtensions)(c.extensionIdentifier,i))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:i,version:s.manifest.version});for(const c of t.translations)r.translations[c.id]=(0,b.join)(s.location.fsPath,c.path)}}l(f){if(f){const s=(0,T.createHash)("md5");for(const i of f.extensions)s.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);f.hash=s.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let s=null;return g.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(s=f(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),g.Promises.writeFile(this.f,n)}).then(()=>s,i=>this.i.error(i))})}};u=fe([_(0,l.INativeEnvironmentService),_(1,p.ILogService)],u);function d(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const f of v.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(Y[47],Q([0,1,15,95,40,7,35]),function($,e,T,R,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function b(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=b;function g(S){return S.res.statusCode===204}async function l(S){return g(S)?null:(await(0,T.streamToBuffer)(S.stream)).toString()}e.asText=l;async function m(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);return l(S)}e.asTextOrError=m;async function w(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);if(g(S))return null;const u=(await(0,T.streamToBuffer)(S.stream)).toString();try{return JSON.parse(u)}catch(d){throw d.message+=`:
`+u,d}}e.asJson=w;function p(S){y(S)}e.updateProxyConfigurationsScope=p;let I;function y(S){const E=N.Registry.as(k.Extensions.Configuration),u=I;I={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[I],remove:u?[u]:[]})}y(2)}),define(Y[129],Q([0,1,22,16,13,47]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(g,l){this.a=g,this.b=l}async download(g,l,m=T.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.b.copy(g,l);return}const w={type:"GET",url:g.toString(!0)},p=await this.a.request(w,m);if(p.res.statusCode===200)await this.b.writeFile(l,p.stream);else{const I=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${I}`)}}};N=fe([_(0,L.IRequestService),_(1,k.IFileService)],N),e.DownloadService=N}),define(Y[130],Q([0,1,131,8]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,b){return N.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:N.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function L(N,b,g={}){const l=(0,T.parse)(N),m=g.proxyUrl||k(l,b);if(!m)return null;const w=(0,T.parse)(m);if(!/^https?:$/.test(w.protocol||""))return null;const p={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((I,y)=>{$(["http-proxy-agent"],I,y)}))(p):new(await new Promise((I,y)=>{$(["https-proxy-agent"],I,y)}))(p)}e.getProxyAgent=L}),define(Y[132],Q([0,1,57,14,96,22,32,11,12,31,78,159,4]),function($,e,T,R,k,L,N,b,g,l,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const I=1e4;let y;async function S(u,d,v){return d["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(v)&&!d["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(v)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(f,s)=>{const i=new L.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,k.localize)(0,null)))},I);try{f(await E(u,i.token))}catch(t){!(0,b.isCancellationError)(t)&&!i.token.isCancellationRequested?s(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(t)))):f({})}finally{clearTimeout(n),i.dispose()}})),y)}e.getResolvedShellEnv=S;async function E(u,d){const v=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",v);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",f);const s=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",n);const t=await(0,m.getSystemShell)(g.OS,n);return u.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(d.isCancellationRequested)return o((0,b.canceled)());const c=(0,R.basename)(t);let a,h;const O=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${O} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${O} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?h=["-ic"]:h=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const C=(0,T.spawn)(t,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});d.onCancellationRequested(()=>(C.kill(),o((0,b.canceled)()))),C.on("error",J=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(J)),o(J)});const W=[];C.stdout.on("data",J=>W.push(J));const X=[];C.stderr.on("data",J=>X.push(J)),C.on("close",(J,ie)=>{const re=Buffer.concat(W).toString("utf8");u.trace("getUnixShellEnvironment#raw",re);const Z=Buffer.concat(X).toString("utf8");if(Z.trim()&&u.trace("getUnixShellEnvironment#stderr",Z),J||ie)return o(new Error((0,k.localize)(2,null,J,ie)));const he=i.exec(re),ce=he?he[1]:"{}";try{const se=JSON.parse(ce);v?se.ELECTRON_RUN_AS_NODE=v:delete se.ELECTRON_RUN_AS_NODE,f?se.ELECTRON_NO_ATTACH_CONSOLE=f:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",se),r(se)}catch(se){u.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(se)),o(se)}})})}}),define(Y[66],Q([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Y[133],Q([0,1,4,15,8,18,13,9]),function($,e,T,R,k,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(w,p,I){this.f=w,this.g=p,this.h=I,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.g.error(w)}}getItem(w,p){const I=this.a[w];return(0,k.isUndefinedOrNull)(I)?p:I}setItem(w,p){this.setItems([{key:w,data:p}])}setItems(w){let p=!1;for(const{key:I,data:y}of w)this.a[I]!==y&&((0,k.isUndefinedOrNull)(y)?(0,k.isUndefined)(this.a[I])||(this.a[I]=void 0,p=!0):(this.a[I]=y,p=!0));p&&this.j()}removeItem(w){(0,k.isUndefined)(this.a[w])||(this.a[w]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(w)),this.b=w}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let l=class{constructor(w,p,I){this.a=new g(w.stateResource,p,I)}async init(){await this.a.init()}getItem(w,p){return this.a.getItem(w,p)}};l=fe([_(0,L.IEnvironmentService),_(1,b.ILogService),_(2,N.IFileService)],l),e.StateService=l}),define(Y[67],Q([0,1,12,33,10,31]),function($,e,T,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(l){if(T.platform===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}async function b(l,m,w,p,I,y,S,E,u,d){const v=Object.create(null);v["common.machineId"]=S,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=I,v.version=y,v["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,T.PlatformToString)(T.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=p,v["common.product"]=d||"desktop",E&&(v["common.msftInternal"]=E);let f=0;const s=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),T.isLinuxSnap&&(v["common.snap"]="true");const i=N(w);i&&(v["common.platformDetail"]=i);try{const n=await l.readFile(k.URI.file(u));v["common.source"]=n.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=b;function g(l){const m=R.env.USERDNSDOMAIN;if(!m)return!1;const w=m.toLowerCase();return l.some(p=>w===p)}e.verifyMicrosoftInternalDomain=g}),define(Y[36],Q([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Y[41],Q([0,1,28,52,8,21,67,36]),function($,e,T,R,k,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class g{constructor(c){this.value=c}}e.TrustedTelemetryValue=g;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,R.staticObservableValue)(0)}publicLog(c,a){return Promise.resolve(void 0)}publicLog2(c,a){return this.publicLog(c,a)}publicLogError(c,a){return Promise.resolve(void 0)}publicLogError2(c,a){return this.publicLogError(c,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=l,e.NullTelemetryService=new l;class m{async publicLog(c,a,h){}async publicLogError(c,a,h){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(o,c){return c.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(a.source),configurationKeys:v(a.sourceConfig)})})}e.configurationTelemetry=w;function p(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=p;function I(o,c){return!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=I;function y(o){const c=o.getValue(b.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function S(o){const c={},a={},h={};d(o,h);for(let O in h){O=O.length>150?O.substr(O.length-149):O;const C=h[O];typeof C=="number"?a[O]=C:typeof C=="boolean"?a[O]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${O} has been trimmed to 8192, the original length is ${C.length}`),c[O]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(c[O]=C)}return{properties:c,measurements:a}}e.validateTelemetryData=S;const E=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function u(o){if(!o)return"none";for(const c of E)if(o.startsWith(`${c}+`))return c;return"other"}e.cleanRemoteAuthority=u;function d(o,c,a=0,h){if(!!o)for(const O of Object.getOwnPropertyNames(o)){const C=o[O],W=h?h+O:O;Array.isArray(C)?c[W]=(0,T.safeStringify)(C):C instanceof Date?c[W]=C.toISOString():(0,k.isObject)(C)?a<2?d(C,c,a+1,W+"."):c[W]=(0,T.safeStringify)(C):c[W]=C}}function v(o){if(!o)return[];const c=[];return f(c,"",o),c}function f(o,c,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(h=>f(o,c?`${c}.${h}`:h,a[h])):o.push(c)}function s(o,c){const a=o.msftInternalDomains||[],h=c.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(a)||h}e.isInternalTelemetry=s;function i(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=i;function n(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const h=[];for(const X of c)for(;;){const J=X.exec(o);if(!J)break;h.push([J.index,X.lastIndex])}const O=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let W=0;for(a="";;){const X=C.exec(o);if(!X)break;const J=h.some(([ie,re])=>X.index<re&&ie<C.lastIndex);!O.test(X[0])&&!J&&(a+=o.substring(W,X.index)+"<REDACTED: user-file-path>",W=C.lastIndex)}return W<o.length&&(a+=o.substr(W)),a}function t(o){if(!o)return o;const c=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(c))return`<REDACTED: ${h.label}>`;return o}function r(o,c){return(0,T.cloneAndChange)(o,a=>{if(a instanceof g)return a.value;if(typeof a=="string"){let h=a.replaceAll("%20"," ");h=n(h,c);for(const O of c)h=h.replace(O,"");return h=t(h),h}})}e.cleanData=r}),define(Y[134],Q([0,1,105,41]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,N,b,g,l,m,w){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${N.nameShort})`};if((0,R.supportsTelemetry)(N,b)&&(0,R.getTelemetryLevel)(g)===3){const I=await(0,T.getServiceMachineId)(b,l,m),{machineId:y}=await w.getTelemetryInfo();p["X-Market-User-Id"]=I,p["VSCode-SessionId"]=y||I}return p}e.resolveMarketplaceHeaders=k}),define(Y[135],Q([0,1,11,28,41]),function($,e,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function N(g,l,m){const w=await new Promise((E,u)=>{$(["@microsoft/1ds-core-js"],E,u)}),p=await new Promise((E,u)=>{$(["@microsoft/1ds-post-js"],E,u)}),I=new w.AppInsightsCore,y=new p.PostChannel,S={instrumentationKey:g,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(m){S.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:m};S.extensionConfig[y.identifier]=E}return I.initialize(S,[]),I.addTelemetryInitializer(E=>{l&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),I}class b{constructor(l,m,w,p,I){this.d=l,this.e=m,this.f=w,this.g=I,this.c=L,this.f||(this.f={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}h(l){if(!!this.a){if(typeof this.a!="string"){l(this.a);return}this.b||(this.b=N(this.a,this.d,this.g)),this.b.then(m=>{l(m)},m=>{(0,T.onUnexpectedError)(m),console.error(m)})}}log(l,m){if(!this.a)return;m=(0,R.mixin)(m,this.f),m=(0,k.validateTelemetryData)(m);const w=this.e+"/"+l;try{this.h(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(l=>{this.h(m=>{m.unload(!0,()=>{this.a=void 0,l(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(Y[136],Q([0,1,2,28,52,12,29,97,21,40,137,30,35,36,41]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(d,v,f){this.j=v,this.k=f,this.d={},this.telemetryLevel=new k.MutableObservableValue(3),this.h=new T.DisposableStore,this.i=[],this.b=d.appenders,this.c=d.commonProperties||Promise.resolve({}),this.f=d.piiPaths||[],this.g=!!d.sendErrorTelemetry,this.i=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const s of this.f)this.i.push(new RegExp((0,N.escapeRegExpCharacters)(s),"gi")),s.indexOf("\\")>=0&&this.i.push(new RegExp((0,N.escapeRegExpCharacters)(s.replace(/\\/g,"/")),"gi"));this.l(),this.j.onDidChangeConfiguration(this.l,this,this.h)}setExperimentProperty(d,v){this.d[d]=v}l(){let d=(0,y.getTelemetryLevel)(this.j);const v=this.k.enabledTelemetryLevels;if(v){this.g=this.sendErrorTelemetry?v.error:!1;const f=v.usage?3:v.error?2:0;d=Math.min(d,f)}this.telemetryLevel.value=d}get sendErrorTelemetry(){return this.g}async getTelemetryInfo(){const d=await this.c,v=d.sessionID,f=d["common.machineId"],s=d["common.firstSessionDate"],i=d["common.msftInternal"];return{sessionId:v,machineId:f,firstSessionDate:s,msftInternal:i}}dispose(){this.h.dispose()}m(d,v,f){return this.telemetryLevel.value<v?Promise.resolve(void 0):this.c.then(s=>{f=(0,R.mixin)(f,this.d),f=(0,y.cleanData)(f,this.i),f=(0,R.mixin)(f,s),this.b.forEach(i=>i.log(d,f))},s=>{console.error(s)})}publicLog(d,v){return this.m(d,3,v)}publicLog2(d,v){return this.publicLog(d,v)}publicLogError(d,v){return this.g?this.m(d,2,v):Promise.resolve(void 0)}publicLogError2(d,v){return this.publicLogError(d,v)}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=fe([_(1,g.IConfigurationService),_(2,w.IProductService)],S),e.TelemetryService=S;function E(){const u=(0,b.localize)(0,null,m.default.nameLong),d=m.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=L.isWeb?"":(0,b.localize)(3,null),f=(0,b.localize)(4,null),s=(0,b.localize)(5,null),i=(0,b.localize)(6,null),n=(0,b.localize)(7,null),t=`
|       | ${f} | ${s} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,b.localize)(8,null);return`
${u} ${d} ${v}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,b.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,b.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[138],Q([0,1,160,135]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends R.AbstractOneDataSystemAppender{constructor(N,b,g,l){const m={sendPOST:(w,p)=>{const I={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const y=T.request(w.urlString,I,S=>{S.on("data",function(E){p(S.statusCode??200,S.headers,E.toString())}),S.on("error",function(E){p(0,{})})});y.write(w.data),y.end()}catch{p(0,{})}}};super(N,b,g,l,m)}}e.OneDataSystemAppender=k}),define(Y[139],Q([0,1,14,20]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(L,N){const b=Object.create(null),g=(m,w)=>{const p=JSON.parse(m);b[w]=p};if(N){const m=[],w=await R.Promises.readdir(N);for(const I of w)try{(await R.Promises.stat((0,T.join)(N,I))).isDirectory()&&m.push(I)}catch{}const p=[];for(const I of m)(await R.Promises.readdir((0,T.join)(N,I))).filter(S=>S==="telemetry.json").length===1&&p.push(I);for(const I of p){const y=(await R.Promises.readFile((0,T.join)(N,I,"telemetry.json"))).toString();g(y,I)}}let l=(await R.Promises.readFile((0,T.join)(L,"telemetry-core.json"))).toString();return g(l,"vscode-core"),l=(await R.Promises.readFile((0,T.join)(L,"telemetry-extensions.json"))).toString(),g(l,"vscode-extensions"),JSON.stringify(b,null,4)}e.buildTelemetryMessage=k}),define(Y[27],Q([0,1,7]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Y[140],Q([0,1,27,106,13,17,70,3,2]),function($,e,T,R,k,L,N,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let m=class{constructor(p){this.g=p,this.c=new g.DisposableStore,this.f=2**16;const I=new Map,y=S=>{let E=I.get(S.scheme);return E===void 0&&(E=p.hasProvider(S)&&!this.g.hasCapability(S,1024),I.set(S.scheme,E)),E};this.c.add(b.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{I.delete(S.scheme)})),this.extUri=new L.ExtUri(y),this.d=new N.SkipList((S,E)=>this.extUri.compare(S,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,L.normalizePath)(p));const I=this.d.get(p);return I?I.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,S)=>y[1].touch<S[1].touch?1:y[1].touch>S[1].touch?-1:0);l._clock=0,this.d.clear();const I=this.f*.5;for(let y=0;y<I;y++)this.d.set(p[y][0],p[y][1].touch())}};m=fe([_(0,k.IFileService)],m),e.UriIdentityService=m,(0,R.registerSingleton)(T.IUriIdentityService,m,1)}),define(Y[141],Q([0,1,99,14,114,17,10,7,16]),function($,e,T,R,k,L,N,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function l(n){const t=n;return typeof t?.id=="string"&&N.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=l,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function m(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,R.basename)(n)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=m;function w(n){const t=n;return typeof t?.id=="string"&&N.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=w;function p(n){const t=n;if(t?.uri)return{id:t.id,uri:N.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=p;var I;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function y(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=y;function S(n){const t=n;return!!(t&&typeof t=="object"&&N.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class E{constructor(t,r,o,c,a){this.h=t,this.j=o,this.k=c,this.l=a,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function d(n){return new u({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(n,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function f(n){let t;return N.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,t){return!v(n,t)&&!f(n)}e.isSavedWorkspace=s;function i(n){return(typeof n=="string"?(0,R.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Y[25],Q([0,1,53,3,2,17,10,98,18,13,7,9,141,34,27,4,31,29]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function d(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&N.URI.isUri(t.location)&&N.URI.isUri(t.globalStorageHome)&&N.URI.isUri(t.settingsResource)&&N.URI.isUri(t.keybindingsResource)&&N.URI.isUri(t.tasksResource)&&N.URI.isUri(t.snippetsHome)&&N.URI.isUri(t.extensionsResource))}e.isUserDataProfile=d,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function v(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:N.URI.revive(n.location).with({scheme:t}),globalStorageHome:N.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:N.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:N.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:N.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:N.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:N.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=v;function f(n,t,r,o){return{id:n,name:t,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:(0,L.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=f;let s=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(t,r,o,c){super(),this.m=t,this.n=r,this.r=o,this.s=c,this.f=!1,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new I.ResourceMap},this.profilesHome=(0,L.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(t){this.f!==t&&(this.t=void 0,this.f=t)}isEnabled(){return this.f}get u(){if(!this.t){const t=this.f?this.I().map(a=>f((0,L.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let r;const o=new I.ResourceMap,c=f((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,b.localize)(0,null),this.m.userRoamingDataHome);if(t.unshift({...c,extensionsResource:this.N()??c.extensionsResource,isDefault:!0}),t.length){const a=this.L();if(a.workspaces)for(const[h,O]of Object.entries(a.workspaces)){const C=N.URI.parse(h),W=N.URI.parse(O),X=t.find(J=>this.r.extUri.isEqual(J.location,W));X&&o.set(C,X)}if(a.emptyWindow){const h=N.URI.parse(a.emptyWindow);r=t.find(O=>this.r.extUri.isEqual(O.location,h))}}this.t={profiles:t,workspaces:o,emptyWindow:r}}return this.t}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const h of this.profiles){const O=o.exec(h.name),C=O?parseInt(O[1]):0;c=C>c?C:c}const a=`${r} ${c+1}`;return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),a,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),t,r,o)}async createProfile(t,r,o,c){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.v(t,r,o);return c&&await this.setProfileForWorkspace(c,a),a}async v(t,r,o){let c=this.k.get(r);return c||(c=(async()=>{try{const a=this.profiles.find(C=>C.name===r||C.id===t);if(a)return a;const h=f(t,r,(0,L.joinPath)(this.profilesHome,t),o);await this.n.createFolder(h.location);const O=[];return this.h.fire({profile:h,join(C){O.push(C)}}),await S.Promises.settled(O),this.D([h],[],[]),h}finally{this.k.delete(r)}})(),this.k.set(r,c)),c}async updateProfile(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(c=>c.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=f(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.i.fire({profile:r,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.s.error(c)}r.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const c of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(c)?.id&&this.u.workspaces.delete(c);this.H(),this.D([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(c){this.s.error(c)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.f)return this.defaultProfile;let o=this.w(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(c=>c.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.G(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.G(t,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.H(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(r=>!this.C(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}w(t){const r=this.y(t);return N.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindow??this.u.emptyWindow}y(t){return(0,p.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,p.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}C(t){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,t.location)||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,t.location)||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location)))}D(t,r,o){const c=[...this.profiles,...t],a=[];this.l.profiles=[];for(let h of c)h.isDefault||r.some(O=>h.id===O.id)||(h=o.find(O=>h.id===O.id)??h,h.isTransient?this.l.profiles.push(h):a.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.J(a),this.t=void 0,this.F(t,r,o)}F(t,r,o){this.g.fire({added:t,removed:r,updated:o,all:this.profiles})}G(t,r,o){o=r?.isTransient?!0:o,o||this.G(t,void 0,!0);const c=this.y(t),a=o?this.l:this.u;N.URI.isUri(c)?(a.workspaces.delete(c),r&&a.workspaces.set(c,r)):a.emptyWindow=r,o||this.H()}H(){const t={};for(const[o,c]of this.u.workspaces.entries())t[o.toString()]=c.location.toString();const r=this.u.emptyWindow?.location.toString();this.M({workspaces:t,emptyWindow:r}),this.t=void 0}I(){return[]}J(t){throw new Error("not implemented")}L(){return{}}M(t){throw new Error("not implemented")}N(){}};s.b="userDataProfiles",s.c="profileAssociations",s=fe([_(0,g.IEnvironmentService),_(1,l.IFileService),_(2,y.IUriIdentityService),_(3,w.ILogService)],s),e.UserDataProfilesService=s;class i extends s{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(t){this.a=t}L(){return this.Q}M(t){this.Q=t}}e.InMemoryUserDataProfilesService=i}),define(Y[142],Q([0,1,19,4,22,11,3,2,12,10,83,23,24,26,9,30,36,25]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends b.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,r,o,c,a){super(),this.t=t,this.u=r,this.v=o,this.w=c,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,b.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(m.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.H(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.C(o.manifest,o.extension,r)}catch(o){throw s(this.u,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:o}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(o),f(o)}}async uninstall(t,r={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.J(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.P(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async C(t,r,o){const c={...o,installOnlyNewlyAddedFromExtensionPack:l.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,I.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.Q()},a=J=>`${p.ExtensionKey.create(J).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!l.URI.isUri(r)){const J=this.j.get(a(r));if(J){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await J.task.waitUntilTaskIsFinished();return ie}}const h=[],O=[],C=[],W=this.R(t,r,c);l.URI.isUri(r)||this.j.set(a(r),{task:W,waitingTasks:[]}),this.l.fire({identifier:W.identifier,source:r,profileLocation:c.profileLocation}),this.v.info("Installing extension:",W.identifier.id),h.push({task:W,manifest:t});let X=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",W.identifier.id);else try{const ie=await this.G(W.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),re=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:Z,manifest:he}of ie){X=X||!!he.extensionDependencies?.some(ge=>(0,p.areSameExtensions)({id:ge},W.identifier));const ce=a(Z),se=this.j.get(ce);if(se){if(this.D(W,se.task)){this.v.info("Waiting for already requested installing extension",Z.identifier.id,W.identifier.id),se.waitingTasks.push(W);const ge=se.task.identifier;O.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,M=>M.some(A=>(0,p.areSameExtensions)(A.identifier,ge)))).then(M=>{if(!M.find(U=>(0,p.areSameExtensions)(U.identifier,ge))?.local)throw new Error(`Extension ${ge.id} is not installed`)}))}}else if(!re.some(({identifier:ge})=>(0,p.areSameExtensions)(ge,Z.identifier))){const ge=this.R(he,Z,{...c,donotIncludePackAndDependencies:!0});this.j.set(ce,{task:ge,waitingTasks:[W]}),this.l.fire({identifier:ge.identifier,source:Z,profileLocation:c.profileLocation}),this.v.info("Installing extension:",ge.identifier.id,W.identifier.id),h.push({task:ge,manifest:he})}}}catch(ie){if(l.URI.isUri(W.source))(0,T.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",W.identifier.id,ie.message),(0,T.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",W.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",W.identifier.id),ie}const J=h.reduce((ie,{task:re,manifest:Z})=>(ie.set(re.identifier.id.toLowerCase(),{task:re,manifest:Z}),ie),new Map);for(;J.size;){let ie;const re=[...J.values()].filter(({manifest:Z})=>!Z.extensionDependencies?.some(he=>J.has(he.toLowerCase())));re.length?ie=J.size===1?re:re.filter(({task:Z})=>!(Z===W&&!X)):(this.v.info("Found extensions with circular dependencies",re.map(({task:Z})=>Z.identifier.id)),ie=[...J.values()]),await this.F(ie.map(async({task:Z})=>{const he=new Date().getTime();try{const{local:ce}=await Z.run();if(await this.F(this.s.map(se=>se.postInstall(ce,Z.source,c,k.CancellationToken.None))),!l.URI.isUri(Z.source)){const se=Z.operation===3,ge=se?void 0:(new Date().getTime()-Z.source.lastUpdated)/1e3;if(s(this.u,se?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Z.source),wasVerified:Z.wasVerified,duration:new Date().getTime()-he,durationSinceUpdate:ge}),g.isWeb&&Z.operation!==3)try{await this.t.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}}C.push({local:ce,identifier:Z.identifier,operation:Z.operation,source:Z.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:ce.isApplicationScoped})}catch(ce){throw l.URI.isUri(Z.source)||s(this.u,Z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Z.source),wasVerified:Z.wasVerified,duration:new Date().getTime()-he,error:ce}),this.v.error("Error while installing the extension:",Z.identifier.id),ce}finally{J.delete(Z.identifier.id.toLowerCase())}}))}return O.length&&await this.F(O),C.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(C),C.filter(({identifier:ie})=>(0,p.areSameExtensions)(ie,W.identifier))[0].local}catch(J){if(h.forEach(({task:ie})=>ie.cancel()),C.length)try{const ie=await Promise.allSettled(C.map(({local:re})=>this.S(re,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let re=0;re<ie.length;re++){const Z=ie[re],{identifier:he}=C[re];Z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",he.id):this.v.warn("Rollback: Error while uninstalling extension",he.id,(0,L.getErrorMessage)(Z.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,L.getErrorMessage)(ie),C.map(({identifier:re})=>re.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:c.context,profileLocation:c.profileLocation}))),J}finally{for(const[J,{task:ie,waitingTasks:re}]of this.j.entries()){const Z=re.indexOf(W);Z!==-1&&re.splice(Z,1),re.length===0&&(ie===W||Z!==-1)&&this.j.delete(J)}}}D(t,r){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===t&&(c.includes(r)||c.some(a=>this.D(a,r)))||o===r&&c[0]&&!this.D(t,c[0]))return!1;return!0}async F(t){const r=[],o=[],c=await Promise.allSettled(t);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw v(o);return r}async G(t,r,o,c,a){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,a),O=[t],C=[],W=async(X,J)=>{const ie=J.extensionDependencies||[],re=[...ie];if(J.extensionPack){const Z=o?h.find(he=>(0,p.areSameExtensions)(he.identifier,X)):void 0;for(const he of J.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(ce=>(0,p.areSameExtensions)({id:ce},{id:he}))||re.every(ce=>!(0,p.areSameExtensions)({id:ce},{id:he}))&&re.push(he)}if(re.length){const Z=[...O,...C.map(ce=>ce.gallery.identifier)],he=re.filter(ce=>Z.every(se=>!(0,p.areSameExtensions)(se,{id:ce})));if(he.length){const ce=await this.t.getExtensions(he.map(se=>({id:se,preRelease:c})),k.CancellationToken.None);for(const se of ce){if(Z.find(A=>(0,p.areSameExtensions)(A,se.identifier)))continue;const ge=ie.some(A=>(0,p.areSameExtensions)({id:A},se.identifier));let M;try{M=await this.H(se,!1,c)}catch(A){if(A instanceof w.ExtensionManagementError&&A.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ge){this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw A}C.push({gallery:M.extension,manifest:M.manifest}),await W(M.extension.identifier,M.manifest)}}}};return await W(t,r),C}async H(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(O=>(0,p.areSameExtensions)(t.identifier,O)))throw new w.ExtensionManagementError(m.localize(1,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new w.ExtensionManagementError(m.localize(2,null,t.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(O)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.I(t,r,o);if(a){if(o&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(m.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],k.CancellationToken.None))[0]?new w.ExtensionManagementError(m.localize(4,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(m.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const h=await this.t.getManifest(a,k.CancellationToken.None);if(h===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async I(t,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.t.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(t,o,c)&&(a=t),a||(r?a=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(t,o,c)),a}async J(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.Q()},c=X=>`${X.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.k.get(c(t.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const h=X=>{const J=this.S(X,o);return this.k.set(c(J.extension.identifier),J),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.n.fire({identifier:X.identifier,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped}),J},O=(X,J)=>{J?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString(),J.message):this.v.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,J.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),s(this.u,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(X),error:J}),this.p.fire({identifier:X.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped})},C=[],W=[];try{C.push(h(t));const X=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const J=this.N(t,X);for(const ie of J)this.k.has(c(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):C.push(h(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.L(C.map(J=>J.extension),X,t),await this.F(C.map(async J=>{try{if(await J.run(),await this.F(this.s.map(ie=>ie.postUninstall(J.extension,o,k.CancellationToken.None))),J.extension.identifier.uuid)try{await this.t.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}O(J.extension)}catch(ie){const re=ie instanceof w.ExtensionManagementError?ie:new w.ExtensionManagementError((0,L.getErrorMessage)(ie),w.ExtensionManagementErrorCode.Internal);throw O(J.extension,re),re}finally{W.push(J)}}))}catch(X){const J=X instanceof w.ExtensionManagementError?X:new w.ExtensionManagementError((0,L.getErrorMessage)(X),w.ExtensionManagementErrorCode.Internal);for(const ie of C){try{ie.cancel()}catch{}W.includes(ie)||O(ie.extension,J)}throw J}finally{for(const X of C)this.k.delete(c(X.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}L(t,r,o){for(const c of t){const a=this.O(c,r);if(a.length){const h=a.filter(O=>!t.some(C=>(0,p.areSameExtensions)(C.identifier,O.identifier)));if(h.length)throw new Error(this.M(c,h,o))}}}M(t,r,o){return o===t?r.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}N(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const a=r.filter(O=>!O.isBuiltin&&c.some(C=>(0,p.areSameExtensions)({id:C},O.identifier))),h=[];for(const O of a)h.push(...this.N(O,r,o));return[...a,...h]}return[]}O(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,p.areSameExtensions)({id:c},t.identifier)))}async P(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=fe([_(0,w.IExtensionGalleryService),_(1,E.ITelemetryService),_(2,y.ILogService),_(3,S.IProductService),_(4,u.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function v(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=v;function f(n){if(n instanceof w.ExtensionManagementError)return n;const t=new w.ExtensionManagementError(n.message,w.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,wasVerified:o,duration:c,error:a,durationSinceUpdate:h}){let O,C;a&&(a instanceof w.ExtensionManagementError?(O=a.code,a.code===w.ExtensionManagementErrorCode.Signature&&(C=a.message)):O=w.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,wasVerified:o,success:!a,duration:c,errorcode:O,errorcodeDetail:C,durationSinceUpdate:h})}e.reportTelemetry=s;class i{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(t=>new Promise((r,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new L.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=i}),define(Y[42],Q([0,1,4,15,2,3,34,10,24,26,13,7,9,25,27]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let S=class extends k.Disposable{constructor(d,v,f,s){super(),this.h=d,this.i=v,this.j=f,this.k=s,this.a=this.B(new L.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new L.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new L.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new L.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(d){return this.l(d)}async addExtensionsToProfile(d,v){const f=[],s=[];try{return await this.l(v,i=>{const n=[];for(const t of i)d.some(([r])=>(0,g.areSameExtensions)(r.identifier,t.identifier)&&r.manifest.version!==t.version)?f.push(t):n.push(t);for(const[t,r]of d)if(!n.some(o=>(0,g.areSameExtensions)(o.identifier,t.identifier)&&o.version===t.manifest.version)){const o={identifier:t.identifier,version:t.manifest.version,location:t.location,metadata:r};s.push(o),n.push(o)}return s.length&&this.a.fire({extensions:s,profileLocation:v}),f.length&&this.c.fire({extensions:f,profileLocation:v}),n}),s.length&&this.b.fire({extensions:s,profileLocation:v}),f.length&&this.f.fire({extensions:f,profileLocation:v}),s}catch(i){throw s.length&&this.b.fire({extensions:s,error:i,profileLocation:v}),f.length&&this.f.fire({extensions:f,error:i,profileLocation:v}),i}}async removeExtensionFromProfile(d,v){const f=[];this.c.fire({extensions:f,profileLocation:v});try{await this.l(v,s=>{const i=[];for(const n of s)(0,g.areSameExtensions)(n.identifier,d.identifier)?f.push(n):i.push(n);return f.length&&this.c.fire({extensions:f,profileLocation:v}),i}),f.length&&this.f.fire({extensions:f,profileLocation:v})}catch(s){throw f.length&&this.f.fire({extensions:f,error:s,profileLocation:v}),s}}async l(d,v){return this.p(d).queue(async()=>{let f=[],s;try{const i=await this.h.readFile(d);s=JSON.parse(i.value.toString())}catch(i){if((0,m.toFileOperationResult)(i)!==1)throw i;this.j.extUri.isEqual(d,this.i.defaultProfile.extensionsResource)&&(s=await this.n())}if(s)for(const i of s){if(!i.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",i);continue}if(!i.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",i);continue}if(!i.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",i);continue}f.push({identifier:i.identifier,location:b.URI.revive(i.location),version:i.version,metadata:i.metadata})}if(v){f=v(f);const i=f.map(n=>({identifier:n.identifier,version:n.version,location:n.location.toJSON(),metadata:n.metadata}));await this.h.writeFile(d,R.VSBuffer.fromString(JSON.stringify(i)))}return f})}async n(){return this.m||(this.m=(async()=>{const d=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let v;try{v=(await this.h.readFile(d)).value.toString()}catch(s){if((0,m.toFileOperationResult)(s)===1)return;throw s}this.k.info("Migrating extensions from old default profile location",d.toString());let f;try{const s=JSON.parse(v);Array.isArray(s)&&s.every(i=>!!(i&&typeof i=="object"&&(0,l.isIExtensionIdentifier)(i.identifier)&&E(i.location)&&i.version&&typeof i.version=="string"))?f=s:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.k.error(s)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",d.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(s){if((0,m.toFileOperationResult)(s)===3)this.k.info("Migration from old default profile location to new location is done by another window",d.toString(),this.i.defaultProfile.extensionsResource.toString());else throw s}try{await this.h.del(d)}catch(s){(0,m.toFileOperationResult)(s)!==1&&this.k.error(s)}return f})()),this.m}p(d){let v=this.g.get(d);return v||(v=new T.Queue,this.g.set(d,v)),v}};S=fe([_(0,m.IFileService),_(1,I.IUserDataProfilesService),_(2,y.IUriIdentityService),_(3,p.ILogService)],S),e.ExtensionsProfileScannerService=S;function E(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}}),define(Y[48],Q([0,1,19,4,28,15,11,50,75,2,16,14,12,17,39,54,8,10,87,18,24,26,45,13,7,9,30,3,44,42,25,27,103,104]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u,d,v,f,s,i,n,t,r,o,c,a,h,O,C,W,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(ge){function M(A,U){if(A===U)return!0;const V=Object.keys(A),G=new Set;for(const q of Object.keys(U))G.add(q);if(V.length!==G.size)return!1;for(const q of V){if(A[q]!==U[q])return!1;G.delete(q)}return G.size===0}ge.equals=M})(J=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let ie=class extends l.Disposable{constructor(M,A,U,V,G,q,ee,P,D,j,F,B){super(),this.systemExtensionsLocation=M,this.userExtensionsLocation=A,this.l=U,this.m=V,this.n=G,this.p=q,this.r=ee,this.s=P,this.t=D,this.u=j,this.v=F,this.w=B,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,I.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(he,(0,I.joinPath)(this.m,s.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(he,(0,I.joinPath)(this.m,s.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Z,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(M,A,U){const[V,G]=await Promise.all([this.scanSystemExtensions(M),this.scanUserExtensions(A)]),q=U?await this.scanExtensionsUnderDevelopment(M,[...V,...G]):[];return this.F(V,G,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(M){const A=[];A.push(this.G(!!M.useCache,M.language)),A.push(this.H(M.language,!!M.checkControlFile));const[U,V]=await Promise.all(A);return this.D([...U,...V],0,M,!1)}async scanUserExtensions(M){const A=M.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",A);const U=await this.J(A,!!M.profileLocation,1,!M.includeUninstalled,M.language);let G=await(M.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k).scanExtensions(U);return G=await this.D(G,1,M,!0),this.s.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(M,A){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===m.Schemas.file).map(async V=>{const G=await this.J(V,!1,1,!0,M.language,!1);return(await this.k.scanOneOrMultipleExtensions(G)).map(ee=>(ee.type=A.find(P=>(0,f.areSameExtensions)(P.identifier,ee.identifier))?.type??ee.type,this.k.validate(ee,G)))}))).flat();return this.D(U,"development",M,!0)}return[]}async scanExistingExtension(M,A,U){const V=await this.J(M,!1,A,!0,U.language),G=await this.k.scanExtension(V);return!G||!U.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(M,A,U){const V=await this.J(M,!1,A,!0,U.language),G=await this.k.scanOneOrMultipleExtensions(V);return this.D(G,A,U,!0)}async scanMetadata(M){const A=(0,I.joinPath)(M,"package.json"),U=(await this.r.readFile(A)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(M,A){const U=(0,I.joinPath)(M,"package.json"),V=(await this.r.readFile(U)).value.toString(),G=JSON.parse(V);A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0,G.__metadata={...G.__metadata,...A},await this.r.writeFile((0,I.joinPath)(M,"package.json"),L.VSBuffer.fromString(JSON.stringify(G,null,"	")))}initializeDefaultProfileExtensions(){return this.C||(this.C=(async()=>{try{const M=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(M))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const A=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(A.map(U=>[U,U.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(M,L.VSBuffer.fromString(""))}catch(A){(0,n.toFileOperationResult)(A)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(A))}}catch(M){throw this.s.error(M),M}})()),this.C}async D(M,A,U,V){return U.includeAllVersions||(M=this.F(A===0?M:void 0,A===1?M:void 0,A==="development"?M:void 0,await this.getTargetPlatform(),V)),U.includeInvalid||(M=M.filter(G=>G.isValid)),M.sort((G,q)=>{const ee=w.basename(G.location.fsPath),P=w.basename(q.location.fsPath);return ee<P?-1:ee>P?1:0})}F(M,A,U,V,G){const q=(P,D,j)=>{if(P.isValid&&!D.isValid)return!1;if(P.isValid===D.isValid){if(G&&y.gt(P.manifest.version,D.manifest.version))return this.s.debug(`Skipping extension ${D.location.path} with lower version ${D.manifest.version} in favour of ${P.location.path} with version ${P.manifest.version}`),!1;if(y.eq(P.manifest.version,D.manifest.version)){if(P.type===0)return this.s.debug(`Skipping extension ${D.location.path} in favour of system extension ${P.location.path} with same version`),!1;if(P.targetPlatform===V)return this.s.debug(`Skipping extension ${D.location.path} from different target platform ${D.targetPlatform}`),!1}}return j?this.s.warn(`Overwriting user extension ${P.location.path} with ${D.location.path}.`):this.s.debug(`Overwriting user extension ${P.location.path} with ${D.location.path}.`),!0},ee=new Map;return M?.forEach(P=>{const D=s.ExtensionIdentifier.toKey(P.identifier.id),j=ee.get(D);(!j||q(j,P,!1))&&ee.set(D,P)}),A?.forEach(P=>{const D=s.ExtensionIdentifier.toKey(P.identifier.id),j=ee.get(D);if(!j&&M&&P.type===0){this.s.debug(`Skipping obsolete system extension ${P.location.path}.`);return}(!j||q(j,P,!1))&&ee.set(D,P)}),U?.forEach(P=>{const D=s.ExtensionIdentifier.toKey(P.identifier.id),j=ee.get(D);(!j||q(j,P,!0))&&ee.set(D,P),ee.set(D,P)}),[...ee.values()]}async G(M,A){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,A),G=await(M&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",G.length),G}async H(M,A){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const V=A?await this.I():{},G=[],q=u.URI.file(w.normalize(w.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const P of U){const D=V[P.name]||"marketplace";switch(D){case"disabled":break;case"marketplace":G.push((0,I.joinPath)(q,P.name));break;default:G.push(u.URI.file(D));break}}const ee=await Promise.all(G.map(async P=>this.k.scanExtension(await this.J(P,!1,0,!0,M))));return this.s.trace("Scanned dev system extensions:",ee.length),(0,T.coalesce)(ee)}async I(){try{const M=await this.r.readFile(this.l);return JSON.parse(M.value.toString())}catch{return{}}}async J(M,A,U,V,G,q=!0){const ee=await this.f(G??p.language),P=await this.L(M),D=A&&!this.v.extUri.isEqual(M,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,j=D?await this.L(D):void 0;return new re(M,P,D,j,A,U,V,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,G,ee)}async L(M){try{const A=await this.r.stat(M);if(typeof A.mtime=="number")return A.mtime}catch{}}};ie=fe([_(4,O.IUserDataProfilesService),_(5,h.IExtensionsProfileScannerService),_(6,n.IFileService),_(7,r.ILogService),_(8,v.IEnvironmentService),_(9,o.IProductService),_(10,C.IUriIdentityService),_(11,t.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class re{constructor(M,A,U,V,G,q,ee,P,D,j,F,B,x,te){this.location=M,this.mtime=A,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=V,this.profile=G,this.type=q,this.excludeObsolete=ee,this.validate=P,this.productVersion=D,this.productDate=j,this.productCommit=F,this.devMode=B,this.language=x,this.translations=te}static createNlsConfiguration(M){return{language:M.language,pseudo:M.language==="pseudo",devMode:M.devMode,translations:M.translations}}static equals(M,A){return(0,I.isEqual)(M.location,A.location)&&M.mtime===A.mtime&&(0,I.isEqual)(M.applicationExtensionslocation,A.applicationExtensionslocation)&&M.applicationExtensionslocationMtime===A.applicationExtensionslocationMtime&&M.profile===A.profile&&M.type===A.type&&M.excludeObsolete===A.excludeObsolete&&M.validate===A.validate&&M.productVersion===A.productVersion&&M.productDate===A.productDate&&M.productCommit===A.productCommit&&M.devMode===A.devMode&&M.language===A.language&&J.equals(M.translations,A.translations)}}let Z=class extends l.Disposable{constructor(M,A,U,V,G){super(),this.f=M,this.g=A,this.h=U,this.i=V,this.j=G}async scanExtensions(M){const A=M.profile?await this.l(M):await this.k(M);let U={};if(M.excludeObsolete&&M.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(V)}catch{}return(0,E.isEmptyObject)(U)?A:A.filter(V=>!U[f.ExtensionKey.create(V).toString()])}async k(M){const A=await this.i.resolve(M.location);if(!A.children?.length)return[];const U=await Promise.all(A.children.map(async V=>{if(!V.isDirectory||M.type===1&&(0,I.basename)(V.resource).indexOf(".")===0)return null;const G=new re(V.resource,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(G)}));return(0,T.coalesce)(U).sort((V,G)=>V.location.path<G.location.path?-1:1)}async l(M){let A=await this.m(M.location,()=>!0,M);if(M.applicationExtensionslocation&&!this.h.extUri.isEqual(M.location,M.applicationExtensionslocation)){A=A.filter(V=>!V.metadata?.isApplicationScoped);const U=await this.m(M.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,M);A.push(...U)}return A}async m(M,A,U){const V=await this.g.scanProfileExtensions(M);if(!V.length)return[];const G=await Promise.all(V.map(async q=>{if(A(q)){const ee=new re(q.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ee,q.metadata)}return null}));return(0,T.coalesce)(G)}async scanOneOrMultipleExtensions(M){try{if(await this.i.exists((0,I.joinPath)(M.location,"package.json"))){const A=await this.scanExtension(M);return A?[A]:[]}else return await this.scanExtensions(M)}catch(A){return this.j.error(`Error scanning extensions at ${M.location.path}:`,(0,N.getErrorMessage)(A)),[]}}async scanExtension(M,A){try{let U=await this.scanExtensionManifest(M.location);if(U){U.publisher||(U.publisher=s.UNDEFINED_PUBLISHER),A=A??U.__metadata,delete U.__metadata;const V=(0,f.getGalleryExtensionId)(U.publisher,U.name),G=A?.id?{id:V,uuid:A.id}:{id:V},q=A?.isSystem?0:M.type,ee=q===0||!!A?.isBuiltin;X.ImplicitActivationEvents.updateManifest(U),U=await this.n(M.location,U,re.createNlsConfiguration(M));const P={type:q,identifier:G,manifest:U,location:M.location,isBuiltin:ee,targetPlatform:A?.targetPlatform??"undefined",metadata:A,isValid:!0,validations:[]};return M.validate?this.validate(P,M):P}}catch(U){M.type!==0&&this.j.error(U)}return null}validate(M,A){let U=!0;const V=(0,i.validateExtensionManifest)(A.productVersion,A.productDate,A.location,M.manifest,M.isBuiltin);for(const[G,q]of V)G===S.default.Error&&(U=!1,this.j.error(this.t(A.location,q)));return M.isValid=U,M.validations=V,M}async scanExtensionManifest(M){const A=(0,I.joinPath)(M,"package.json");let U;try{U=(await this.i.readFile(A)).value.toString()}catch(G){return(0,n.toFileOperationResult)(G)!==1&&this.j.error(this.t(M,(0,d.localize)(0,null,A.path,G.message))),null}let V;try{V=JSON.parse(U)}catch{const q=[];(0,b.parse)(U,q);for(const ee of q)this.j.error(this.t(M,(0,d.localize)(1,null,A.path,ee.offset,ee.length,(0,g.getParseErrorMessage)(ee.error))));return null}return(0,b.getNodeType)(V)!=="object"?(this.j.error(this.t(M,(0,d.localize)(2,null,A.path))),null):V}async n(M,A,U){const V=await this.p(M,A,U);if(V)try{const G=[],q=await this.r(V.default,G);if(G.length>0)return G.forEach(P=>{this.j.error(this.t(M,(0,d.localize)(3,null,V.default?.path,(0,g.getParseErrorMessage)(P.error))))}),A;if((0,b.getNodeType)(V)!=="object")return this.j.error(this.t(M,(0,d.localize)(4,null,V.default?.path))),A;const ee=V.values||Object.create(null);return(0,W.localizeManifest)(A,ee,q)}catch{}return A}async p(M,A,U){const V=(0,I.joinPath)(M,"package.nls.json"),G=(D,j)=>{j.forEach(F=>{this.j.error(this.t(M,(0,d.localize)(5,null,D?.path,(0,g.getParseErrorMessage)(F.error))))})},q=D=>{this.j.error(this.t(M,(0,d.localize)(6,null,D?.path)))},ee=`${A.publisher}.${A.name}`,P=U.translations[ee];if(P)try{const D=u.URI.file(P),j=(await this.i.readFile(D)).value.toString(),F=[],B=(0,b.parse)(j,F);return F.length>0?(G(D,F),{values:void 0,default:V}):(0,b.getNodeType)(B)!=="object"?(q(D),{values:void 0,default:V}):{values:B.contents?B.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let j;try{j=await this.s(M,U)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const F=(await this.i.readFile(j.localized)).value.toString(),B=[],x=(0,b.parse)(F,B);return B.length>0?(G(j.localized,B),{values:void 0,default:j.original}):(0,b.getNodeType)(x)!=="object"?(q(j.localized),{values:void 0,default:j.original}):{values:x,default:j.original}}catch{return{values:void 0,default:j.original}}}}async r(M,A){if(M)try{const U=(await this.i.readFile(M)).value.toString();return(0,b.parse)(U,A)}catch{}}s(M,A){return new Promise((U,V)=>{const G=q=>{const ee=(0,I.joinPath)(M,`package.nls.${q}.json`);this.i.exists(ee).then(P=>{P&&U({localized:ee,original:(0,I.joinPath)(M,"package.nls.json")});const D=q.lastIndexOf("-");D===-1?U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null}):(q=q.substring(0,D),G(q))})};if(A.devMode||A.pseudo||!A.language)return U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null});G(A.language)})}t(M,A){return`[${M.path}]: ${A}`}};Z=fe([_(1,h.IExtensionsProfileScannerService),_(2,C.IUriIdentityService),_(3,n.IFileService),_(4,r.ILogService)],Z);let he=class extends Z{constructor(M,A,U,V,G,q){super(A,U,V,G,q),this.y=M,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(M){const A=await this.C();if(this.u=M,A&&A.input&&re.equals(A.input,this.u))return this.v.trigger(()=>this.F()),A.result.map(V=>(V.location=u.URI.revive(V.location),V));const U=await super.scanExtensions(M);return await this.D({input:M,result:U}),U}async C(){try{const M=await this.i.readFile(this.y),A=JSON.parse(M.value.toString());return{result:A.result,input:(0,a.revive)(A.input)}}catch(M){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(M))}return null}async D(M){try{await this.i.writeFile(this.y,L.VSBuffer.fromString(JSON.stringify(M)))}catch(A){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(A))}}async F(){if(!this.u)return;const M=await this.C();if(!M)return;const A=M.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(U,A))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};he=fe([_(2,h.IExtensionsProfileScannerService),_(3,C.IUriIdentityService),_(4,n.IFileService),_(5,r.ILogService)],he);function ce(ge,M){const A=(0,f.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:A,identifier:new s.ExtensionIdentifier(A),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:M,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ce;class se extends ie{constructor(M,A,U,V,G,q,ee,P,D,j,F,B){super(M,A,(0,I.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(V,s.MANIFEST_CACHE_FOLDER),G,q,ee,P,D,j,F,B),this.M=(async()=>{if(p.translationsConfigFile)try{const x=await this.r.readFile(u.URI.file(p.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(M){return this.M}}e.NativeExtensionsScannerService=se}),define(Y[143],Q([0,1,57,4,32,3,2,16,14,20,9,25]),function($,e,T,R,k,L,N,b,g,l,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends N.Disposable{constructor(y,S){super(),this.b=y,this.f=S,this.a=new R.Limiter(5)}async postUninstall(y){const S=this.g(y,"uninstall");return S&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(S.script,"uninstall",S.args,!0,y).then(()=>this.f.info(y.identifier.id,y.manifest.version,"Finished running post uninstall script"),E=>this.f.error(y.identifier.id,y.manifest.version,`Failed to run post uninstall script: ${E}`)))),l.Promises.rm(this.j(y)).then(void 0,E=>this.f.error("Error while removing extension storage path",E))}g(y,S){const E=`vscode:${S}`;if(y.location.scheme===b.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[E]=="string"){const u=y.manifest.scripts[E].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${E} should be a node script`),null):{script:(0,g.join)(y.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(y,S,E,u,d){return new Promise((v,f)=>{const s=this.i(y,S,E,d);let i;const n=t=>{i&&(clearTimeout(i),i=null),t?f(t):v(void 0)};s.on("error",t=>{n((0,k.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${S} process exited with code ${t}`:void 0)}),u&&(i=setTimeout(()=>{i=null,s.kill(),f("timed out")},5e3))})}i(y,S,E,u){const d={silent:!0,execArgv:void 0},v=(0,T.fork)(y,[`--type=extension-post-${S}`,...E],d);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(v.stdout,"data"),s=L.Event.fromNodeEventEmitter(v.stderr,"data");f(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${S}`,t)),s(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${S}`,t));const i=L.Event.any(L.Event.map(f,t=>({data:`%c${t}`,format:[""]})),L.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}j(y){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};p=fe([_(0,w.IUserDataProfilesService),_(1,m.ILogService)],p),e.ExtensionsLifecycle=p}),define(Y[144],Q([0,1,10,18,42,48,13,7,9,30,27,25]),function($,e,T,R,k,L,N,b,g,l,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends L.NativeExtensionsScannerService{constructor(y,S,E,u,d,v,f,s){super(T.URI.file(d.builtinExtensionsPath),T.URI.file(d.extensionsPath),d.userHome,T.URI.file(d.userDataPath),y,S,E,u,d,v,f,s)}};p=fe([_(0,w.IUserDataProfilesService),_(1,k.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,g.ILogService),_(4,R.INativeEnvironmentService),_(5,l.IProductService),_(6,m.IUriIdentityService),_(7,b.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(Y[145],Q([0,1,4,3,2,115,8,80,7,25]),function($,e,T,R,k,L,N,b,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var m;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var p;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function I(d){const v=d.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=I;class y extends k.Disposable{constructor(v={flushInterval:y.a}){super(),this.j=v,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.u=void 0,this.w=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.J()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(v,f){if(f===e.TARGET_KEY){switch(v){case-1:this.C=void 0;break;case 0:this.w=void 0;break;case 1:this.u=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:f,target:this.F(v)[f]})}emitWillSaveState(v){this.f.fire({reason:v})}get(v,f,s){return this.L(f)?.get(v,s)}getBoolean(v,f,s){return this.L(f)?.getBoolean(v,s)}getNumber(v,f,s){return this.L(f)?.getNumber(v,s)}store(v,f,s,i){if((0,N.isUndefinedOrNull)(f)){this.remove(v,s);return}this.r(()=>{this.t(v,s,i),this.L(s)?.set(v,f)})}remove(v,f){this.r(()=>{this.t(v,f,void 0),this.L(f)?.delete(v)})}r(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,f){const s=[],i=this.F(v);for(const n of Object.keys(i))i[n]===f&&s.push(n);return s}t(v,f,s){const i=this.F(f);typeof s=="number"?i[v]!==s&&(i[v]=s,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[v]=="number"&&(delete i[v],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get v(){return this.u||(this.u=this.G(1)),this.u}get y(){return this.w||(this.w=this.G(0)),this.w}get D(){return this.C||(this.C=this.G(-1)),this.C}F(v){switch(v){case-1:return this.D;case 0:return this.y;default:return this.v}}G(v){const f=this.L(v);return f?I(f):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=m.NONE){this.f.fire({reason:v});const f=this.L(-1),s=this.L(0),i=this.L(1);switch(v){case m.NONE:await T.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await T.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,s=this.L(1)?.items??new Map;return u(v,f,s,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(v,f){return this.emitWillSaveState(m.NONE),(0,l.isUserDataProfile)(v)?this.N(v,f):this.O(v,f)}H(v,f){return!(v.id===f.id||S(f)&&S(v))}I(v,f,s,i){this.r(()=>{if(i)for(const[n,t]of v)f.set(n,t);else{const n=new Set;for(const[t,r]of v)n.add(t),f.get(t)!==r&&this.n(s,t);for(const[t]of f.items)n.has(t)||this.n(s,t)}})}}e.AbstractStorageService=y,y.a=60*1e3;function S(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class E extends y{constructor(){super(),this.p=this.B(new b.Storage(new b.InMemoryStorageDatabase)),this.P=this.B(new b.Storage(new b.InMemoryStorageDatabase)),this.Q=this.B(new b.Storage(new b.InMemoryStorageDatabase)),this.B(this.Q.onDidChangeStorage(v=>this.n(1,v))),this.B(this.P.onDidChangeStorage(v=>this.n(0,v))),this.B(this.p.onDidChangeStorage(v=>this.n(-1,v)))}L(v){switch(v){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(v){return!1}}e.InMemoryStorageService=E;async function u(d,v,f,s,i,n){const t=X=>{try{return JSON.parse(X)}catch{return X}},r=new Map,o=new Map;d.forEach((X,J)=>{r.set(J,X),o.set(J,t(X))});const c=new Map,a=new Map;v.forEach((X,J)=>{c.set(J,X),a.set(J,t(X))});const h=new Map,O=new Map;f.forEach((X,J)=>{h.set(J,X),O.set(J,t(X))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const C=[];if(r.forEach((X,J)=>{C.push({key:J,value:X})}),console.table(C),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const X=[];c.forEach((J,ie)=>{X.push({key:ie,value:J})}),console.table(X),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const W=[];h.forEach((X,J)=>{W.push({key:J,value:X})}),console.table(W),console.groupEnd(),console.log(O)}e.logStorage=u}),define(Y[146],Q([0,1,19,22,11,12,33,8,10,21,18,23,24,45,13,9,30,47,134,145,36]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u,d,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,w.getTargetPlatform)(L.platform,N.arch);var i;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...P){return String(P.reduce((D,j)=>D|j,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class h{constructor(D=a){this.d=D}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(D,j=this.d.pageSize){return new h({...this.d,pageNumber:D,pageSize:j})}withFilter(D,...j){const F=[...this.d.criteria,...j.length?j.map(B=>({filterType:D,value:B})):[{filterType:D}]];return new h({...this.d,criteria:F})}withSortBy(D){return new h({...this.d,sortBy:D})}withSortOrder(D){return new h({...this.d,sortOrder:D})}withFlags(...D){return new h({...this.d,flags:D.reduce((j,F)=>j|F,0)})}withAssetTypes(...D){return new h({...this.d,assetTypes:D})}withSource(D){return new h({...this.d,source:D})}get raw(){const{criteria:D,pageNumber:j,pageSize:F,sortBy:B,sortOrder:x,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:D,pageNumber:j,pageSize:F,sortBy:B,sortOrder:x}],assetTypes:oe,flags:te}}get searchText(){const D=this.d.criteria.filter(j=>j.filterType===t.SearchText)[0];return D&&D.value?D.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(D=>String(D.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(P,D){const j=(P||[]).filter(F=>F.statisticName===D)[0];return j?j.value:0}function C(P){const D="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(F=>F.assetType.indexOf(D)===0).reduce((F,B)=>{const x=J(P,B.assetType);return x&&F.push([B.assetType.substring(D.length),x]),F},[])}function W(P){if(P.properties){const D=P.properties.filter(B=>B.key===r.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=D.filter(B=>j.test(B.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return J(P,r.Repository)}function X(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function J(P,D){return P.files.filter(F=>F.assetType===D)[0]?{uri:`${P.assetUri}/${D}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${D}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function ie(P,D){const j=P.properties?P.properties.filter(B=>B.key===D):[],F=j.length>0&&j[0].value;return F?F.split(",").map(B=>(0,p.adoptToGalleryExtensionId)(B)):[]}function re(P){const D=P.properties?P.properties.filter(j=>j.key===o.Engine):[];return D.length>0&&D[0].value||""}function Z(P){const D=P.properties?P.properties.filter(j=>j.key===o.PreRelease):[];return D.length>0&&D[0].value==="true"}function he(P){const D=P.properties?P.properties.filter(F=>F.key===o.LocalizedLanguages):[],j=D.length>0&&D[0].value||"";return j?j.split(","):[]}function ce(P){return P.properties?.find(D=>D.key===o.SponsorLink)?.value}function se(P){return P.indexOf("preview")!==-1}function ge(P){return P.targetPlatform?(0,w.toTargetPlatform)(P.targetPlatform):"undefined"}function M(P){const D=(0,T.distinct)(P.versions.map(ge)),j=!!P.tags?.includes(w.WEB_EXTENSION_TAG),F=D.indexOf("web");return j?F===-1&&D.push("web"):F!==-1&&D.splice(F,1),D}function A(P,D){const j=(0,w.getFallbackTargetPlarforms)(D);for(let F=0;F<P.length;F++){const B=P[F];if(B.version===P[F-1]?.version){let x=F;const te=ge(B);if(te===D)for(;x>0&&P[x-1].version===B.version;)x--;else if(j.includes(te))for(;x>0&&P[x-1].version===B.version&&ge(P[x-1])!==D;)x--;x!==F&&(P.splice(F,1),P.splice(x,0,B))}}return P}e.sortExtensionVersions=A;function U(P,D,j){P.telemetryData={index:D,querySource:j}}function V(P,D,j){const F=P.versions[0],B={manifest:J(D,r.Manifest),readme:J(D,r.Details),changelog:J(D,r.Changelog),license:J(D,r.License),repository:W(D),download:X(D),icon:J(D,r.Icon),signature:J(D,r.Signature),coreTranslations:C(D)};return{identifier:{id:(0,p.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:D.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:ce(F),description:P.shortDescription||"",installCount:O(P.statistics,"install"),rating:O(P.statistics,"averagerating"),ratingCount:O(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:j,assets:B,properties:{dependencies:ie(D,o.Dependency),extensionPack:ie(D,o.ExtensionPack),engine:re(D),localizedLanguages:he(D),targetPlatform:ge(D),isPreReleaseVersion:Z(D)},hasPreReleaseVersion:Z(F),hasReleaseVersion:!0,preview:se(P.flags),isSigned:!!B.signature}}let G=class{constructor(D,j,F,B,x,te,oe,me){this.k=j,this.l=F,this.n=B,this.o=x,this.q=te,this.u=oe,this.w=me;const ye=oe.extensionsGallery,ae=ye?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ae?ye.servicePPEUrl:ye?.serviceUrl,this.g=ae?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,D,this.o)}x(D=""){return`${this.d}${D}`}isEnabled(){return!!this.d}async getExtensions(D,j,F){const B=R.CancellationToken.isCancellationToken(j)?{}:j,x=R.CancellationToken.isCancellationToken(j)?j:F,te=[],oe=[],me=[],ye=[];let ae=!0;for(const le of D){le.uuid?oe.push(le.uuid):te.push(le.id);const ve=!!(le.version||le.preRelease);me.push({id:le.id,uuid:le.uuid,includePreRelease:ve}),le.version&&ye.push({id:le.id,uuid:le.uuid,version:le.version}),ae=ae&&!!le.hasPreRelease&&!ve}if(!oe.length&&!te.length)return[];let ne=new h().withPage(1,D.length);oe.length&&(ne=ne.withFilter(t.ExtensionId,...oe)),te.length&&(ne=ne.withFilter(t.ExtensionName,...te)),(B.queryAllVersions||ae)&&(ne=ne.withFlags(ne.flags,i.IncludeVersions)),B.source&&(ne=ne.withSource(B.source));const{extensions:de}=await this.A(ne,{targetPlatform:B.targetPlatform??s,includePreRelease:me,versions:ye,compatible:!!B.compatible},x);return B.source&&de.forEach((le,ve)=>U(le,ve,B.source)),de}async getCompatibleExtension(D,j,F){if((0,w.isNotWebExtensionInWebTargetPlatform)(D.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(D,j,F))return D;const B=new h().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,D.identifier.uuid),{extensions:x}=await this.A(B,{targetPlatform:F,compatible:!0,includePreRelease:j},R.CancellationToken.None);return x[0]||null}async isExtensionCompatible(D,j,F){if(!(0,w.isTargetPlatformCompatible)(D.properties.targetPlatform,D.allTargetPlatforms,F)||!j&&D.properties.isPreReleaseVersion)return!1;let B=D.properties.engine;if(!B){const x=await this.getManifest(D,R.CancellationToken.None);if(!x)throw new Error("Manifest was not found");B=x.engines.vscode}return(0,I.isEngineValid)(B,this.u.version,this.u.date)}async y(D,j,F,B,x){if(!(0,w.isTargetPlatformCompatible)(ge(D),B,x)||j!=="any"&&Z(D)!==(j==="prerelease"))return!1;if(F)try{const te=await this.F(D);if(!(0,I.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${D.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(D,j){let F=D.text||"";const B=D.pageSize??50;let x=new h().withPage(1,B);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ne,de)=>(x=x.withFilter(t.Category,de||ne),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ne,de)=>(x=x.withFilter(t.Tag,de||ne),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(x=x.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),x=x.withFilter(t.SearchText,F)),x=x.withSortBy(0)):D.ids?x=x.withFilter(t.ExtensionId,...D.ids):D.names?x=x.withFilter(t.ExtensionName,...D.names):x=x.withSortBy(4),typeof D.sortBy=="number"&&(x=x.withSortBy(D.sortBy)),typeof D.sortOrder=="number"&&(x=x.withSortOrder(D.sortOrder)),D.source&&(x=x.withSource(D.source));const te=async(ae,ne)=>{const{extensions:de,total:le}=await this.A(ae,{targetPlatform:s,compatible:!1,includePreRelease:!!D.includePreRelease},ne);return de.forEach((ve,Me)=>U(ve,(ae.pageNumber-1)*ae.pageSize+Me,D.source)),{extensions:de,total:le}},{extensions:oe,total:me}=await te(x,j),ye=async(ae,ne)=>{if(ne.isCancellationRequested)throw new k.CancellationError;const{extensions:de}=await te(x.withPage(ae+1),ne);return de};return{firstPage:oe,total:me,pageSize:x.pageSize,getPage:ye}}async A(D,j,F){const B=D.flags;!!(D.flags&i.IncludeLatestVersionOnly)&&!!(D.flags&i.IncludeVersions)&&(D=D.withFlags(D.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(D.flags&i.IncludeLatestVersionOnly)&&!(D.flags&i.IncludeVersions)&&(D=D.withFlags(D.flags,i.IncludeLatestVersionOnly)),j.versions?.length&&(D=D.withFlags(D.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),D=D.withFlags(D.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:x,total:te}=await this.C(D,F);if(!(D.flags&i.IncludeLatestVersionOnly)){const ae=[];for(const ne of x){const de=await this.B(ne,j);de&&ae.push(de)}return{extensions:ae,total:te}}const me=[],ye=new Map;for(let ae=0;ae<x.length;ae++){const ne=x[ae],de={id:(0,p.getGalleryExtensionId)(ne.publisher.publisherName,ne.extensionName),uuid:ne.extensionId},le=(0,b.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Me=>(0,p.areSameExtensions)(Me,de))?.includePreRelease;if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(M(ne),j.targetPlatform))continue;const ve=await this.B(ne,j);!ve||ve.properties.isPreReleaseVersion&&(!le||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==j.targetPlatform&&ve.hasPreReleaseVersion?ye.set(ne.extensionId,ae):me.push([ae,ve])}if(ye.size){const ae=new Date().getTime(),ne=new h().withFlags(B&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ye.size).withFilter(t.ExtensionId,...ye.keys()),{extensions:de}=await this.A(ne,j,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ae,count:ye.size});for(const le of de){const ve=ye.get(le.identifier.uuid);me.push([ve,le])}}return{extensions:me.sort((ae,ne)=>ae[0]-ne[0]).map(([,ae])=>ae),total:te}}async B(D,j){const F={id:(0,p.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},B=j.versions?.find(me=>(0,p.areSameExtensions)(me,F))?.version,x=(0,b.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(me=>(0,p.areSameExtensions)(me,F))?.includePreRelease,te=M(D),oe=A(D.versions,j.targetPlatform);if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(te,j.targetPlatform))return null;for(let me=0;me<oe.length;me++){const ye=oe[me];if(!(B&&ye.version!==B)){if(await this.y(ye,x?"any":"release",j.compatible,te,j.targetPlatform))return V(D,ye,te);if(B&&ye.version===B)return null}}return B||j.compatible?null:V(D,D.versions[0],te)}async C(D,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");D=D.withFlags(D.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(i.Unpublished));const F=await this.j,B=JSON.stringify(D.raw),x={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},te=new Date().getTime();let oe,me,ye=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&D.criteria.some(ne=>ne.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:x},j),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:ye};const ae=await(0,u.asJson)(oe);if(ae){const ne=ae.results[0],de=ne.extensions,le=ne.resultMetadata&&ne.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return ye=le&&le.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye}}return{galleryExtensions:[],total:ye}}catch(ae){throw me=ae,ae}finally{this.o.publicLog2("galleryService:query",{...D.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-te,success:!!oe&&(0,u.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,k.isCancellationError)(me)?"canceled":(0,k.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(D,j,F,B){if(!this.isEnabled())return;const x=L.isWeb?this.x(`/itemName/${D}.${j}/version/${F}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${D}/extensions/${j}/${F}/stats?statType=${B}`),te=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:x,headers:me},R.CancellationToken.None)}catch{}}async download(D,j,F){this.l.trace("ExtensionGalleryService#download",D.identifier.id);const B=(0,p.getGalleryExtensionTelemetryData)(D),x=new Date().getTime(),te=ae=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ae}),oe=F===2?"install":F===3?"update":"",me=oe?{uri:`${D.assets.download.uri}${g.URI.parse(D.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${D.assets.download.fallbackUri}${g.URI.parse(D.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:D.assets.download,ye=await this.E(me);await this.q.writeFile(j,ye.stream),te(new Date().getTime()-x)}async downloadSignatureArchive(D,j){if(!D.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",D.identifier.id);const F=await this.E(D.assets.signature);await this.q.writeFile(j,F.stream)}async getReadme(D,j){if(D.assets.readme){const F=await this.E(D.assets.readme,{},j);return await(0,u.asTextOrError)(F)||""}return""}async getManifest(D,j){if(D.assets.manifest){const F=await this.E(D.assets.manifest,{},j),B=await(0,u.asTextOrError)(F);return B?JSON.parse(B):null}return null}async D(D,j){const F=J(D,r.Manifest);if(!F)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},x=await this.E(F,{headers:B});return await(0,u.asJson)(x)}async getCoreTranslation(D,j){const F=D.assets.coreTranslations.filter(B=>B[0]===j.toUpperCase())[0];if(F){const B=await this.E(F[1]),x=await(0,u.asTextOrError)(B);return x?JSON.parse(x):null}return null}async getChangelog(D,j){if(D.assets.changelog){const F=await this.E(D.assets.changelog,{},j);return await(0,u.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(D,j,F){let B=new h().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);D.identifier.uuid?B=B.withFilter(t.ExtensionId,D.identifier.uuid):B=B.withFilter(t.ExtensionName,D.identifier.id);const{galleryExtensions:x}=await this.C(B,R.CancellationToken.None);if(!x.length)return[];const te=M(x[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const oe=[];await Promise.all(x[0].versions.map(async ae=>{try{await this.y(ae,j?"any":"release",!0,te,F)&&oe.push(ae)}catch{}}));const me=[],ye=new Set;for(const ae of A(oe,F))ye.has(ae.version)||(ye.add(ae.version),me.push({version:ae.version,date:ae.lastUpdated,isPreReleaseVersion:Z(ae)}));return me}async E(D,j={},F=R.CancellationToken.None){const B=await this.j,x={type:"GET"},te={...B,...j.headers||{}};j={...j,...x,headers:te};const oe=D.uri,me=D.fallbackUri,ye={...j,url:oe};try{const ae=await this.k.request(ye,F);if(ae.res.statusCode===200)return ae;const ne=await(0,u.asTextOrError)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${ne}`)}catch(ae){if((0,k.isCancellationError)(ae))throw ae;const ne=(0,k.getErrorMessage)(ae);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ne});const de={...j,url:me};return this.k.request(de,F)}}async F(D){let j=re(D);if(!j){const F=await this.D(D,R.CancellationToken.None);if(!F)throw new Error("Manifest was not found");j=F.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const D=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(D.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,u.asJson)(D),F=[],B={};if(j){for(const x of j.malicious)F.push({id:x});if(j.migrateToPreRelease)for(const[x,te]of Object.entries(j.migrateToPreRelease))(!te.engine||(0,I.isEngineValid)(te.engine,this.u.version,this.u.date))&&(B[x.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[x,te]of Object.entries(j.deprecated))te&&(B[x.toLowerCase()]=(0,b.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:B}}};G=fe([_(1,u.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,y.IFileService),_(6,E.IProductService),_(7,l.IConfigurationService)],G);let q=class extends G{constructor(D,j,F,B,x,te,oe,me){super(D,j,F,B,x,te,oe,me)}};q=fe([_(0,v.IStorageService),_(1,u.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,y.IFileService),_(6,E.IProductService),_(7,l.IConfigurationService)],q),e.ExtensionGalleryService=q;let ee=class extends G{constructor(D,j,F,B,x,te,oe){super(void 0,D,j,F,B,x,te,oe)}};ee=fe([_(0,u.IRequestService),_(1,S.ILogService),_(2,m.IEnvironmentService),_(3,f.ITelemetryService),_(4,y.IFileService),_(5,E.IProductService),_(6,l.IConfigurationService)],ee),e.ExtensionGalleryServiceWithNoStorageService=ee}),define(Y[147],Q([0,1,44,10,18,13,9,66,27,25]),function($,e,T,R,k,L,N,b,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class $e extends l.UserDataProfilesService{constructor(p,I,y,S,E){super(y,S,I,E),this.a=p,this.O=y}I(){return(0,T.revive)(this.a.getItem($e.b,[]))}L(){return(0,T.revive)(this.a.getItem($e.c,{}))}N(){return this.r.extUri.joinPath(R.URI.file(this.O.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m=fe([_(0,b.IStateService),_(1,g.IUriIdentityService),_(2,k.INativeEnvironmentService),_(3,L.IFileService),_(4,N.ILogService)],m),e.UserDataProfilesService=m}),define(Y[148],Q([0,1,37,4,161,2,9]),function($,e,T,R,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let b=class extends T.AbstractPolicyService{constructor(l,m){super(),this.j=l,this.k=m,this.a=new R.Throttler,this.b=this.B(new L.MutableDisposable)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((m,w)=>{try{this.b.value=(0,k.createWatcher)(this.k,l,p=>{this.m(p),m()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),w(p)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const m in l){const w=l[m];w===void 0?this.g.delete(m):this.g.set(m,w)}this.h.fire(Object.keys(l))}};b=fe([_(0,N.ILogService)],b),e.NativePolicyService=b}),define(Y[68],Q([0,1,117,4,14,8,20,81,162,163]),function($,e,T,R,k,L,N,b,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class m extends Error{constructor(i,n){let t=n.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=n}}e.ExtractError=m;function w(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,t)=>n+t,i&61440)}function p(s){if(s instanceof m)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new m(i,s)}function I(s,i,n,t,r,o){const c=k.dirname(i),a=k.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(b.localize(0,null,i)));const h=k.join(t,i);let O;return o.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(N.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((C,W)=>{if(!o.isCancellationRequested)try{O=(0,T.createWriteStream)(h,{mode:n}),O.once("close",()=>C()),O.once("error",W),s.once("error",W),s.pipe(O)}catch(X){W(X)}}))}function y(s,i,n,t){let r=(0,R.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,a)=>{const h=new R.Sequencer,O=C=>{C.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?c():a(new m("Incomplete",new Error(b.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",C=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(C.fileName)){O(t);return}const W=C.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(W)){const ie=k.join(i,W);r=(0,R.createCancelablePromise)(re=>N.Promises.mkdir(ie,{recursive:!0}).then(()=>O(re)).then(void 0,a));return}const X=E(s,C),J=w(C);r=(0,R.createCancelablePromise)(ie=>h.queue(()=>X.then(re=>I(re,W,J,i,n,ie).then(()=>O(ie)))).then(null,a))})})}function S(s,i=!1){return new Promise((n,t)=>{(0,g.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(p(r)):n((0,L.assertIsDefined)(o))})})}function E(s,i){return new Promise((n,t)=>{s.openReadStream(i,(r,o)=>{r?t(p(r)):n((0,L.assertIsDefined)(o))})})}function u(s,i){return new Promise((n,t)=>{const r=new l.ZipFile;i.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,T.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}e.zip=u;function d(s,i,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=S(s,!0);return n.overwrite&&(o=o.then(c=>N.Promises.rm(i).then(()=>c))),o.then(c=>y(c,i,{sourcePathRegex:r},t))}e.extract=d;function v(s,i){return S(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===i&&E(n,o).then(c=>t(c),c=>r(c))}),n.once("close",()=>r(new Error(b.localize(2,null,i))))}))}function f(s,i){return v(s,i).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(Y[149],Q([0,1,68,89]),function($,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,T.buffer)(L,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=k}),define(Y[150],Q([0,1,4,22,32,11,3,2,34,16,14,12,17,39,8,10,31,20,68,88,58,18,142,23,24,42,48,125,143,149,126,127,26,45,13,7,9,30,36,27,25]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u,d,v,f,s,i,n,t,r,o,c,a,h,O,C,W,X,J,ie,re,Z,he,ce,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let ge=class extends i.AbstractExtensionManagementService{constructor(P,D,j,F,B,x,te,oe,me,ye,ae,ne){super(P,D,j,ye,ne),this.ab=B,this.bb=x,this.cb=te,this.db=me,this.eb=ae,this.Y=new Map,this.mb=new g.ResourceSet;const de=this.B(oe.createInstance(a.ExtensionsLifecycle));this.U=this.B(oe.createInstance(M,ve=>de.postUninstall(ve))),this.W=this.B(new O.ExtensionsManifestCache(F,this)),this.X=this.B(oe.createInstance(c.ExtensionsDownloader));const le=this.B(new C.ExtensionsWatcher(this,this.ab,ne,x,ae,me,j));this.B(le.onDidChangeExtensionsByAnotherSource(ve=>this.lb(ve))),this.nb()}getTargetPlatform(){return this.fb||(this.fb=(0,t.computeTargetPlatform)(this.db,this.v)),this.fb}async zip(P){this.v.trace("ExtensionManagementService#zip",P.identifier.id);const D=await this.kb(P),j=await(0,d.zip)((0,p.joinPath)(this.X.extensionsDownloadDir,(0,E.generateUuid)()).fsPath,D);return S.URI.file(j)}async unzip(P){return this.v.trace("ExtensionManagementService#unzip",P.toString()),(await this.install(P)).identifier}async getManifest(P){const{location:D,cleanup:j}=await this.gb(P),F=m.resolve(D.fsPath);try{return await(0,h.getManifest)(F)}finally{await j()}}getInstalled(P,D){return this.U.scanExtensions(P??null,D)}getAllUserInstalled(){return this.U.scanAllUserExtensions(!1)}async install(P,D={}){this.v.trace("ExtensionManagementService#install",P.toString());const{location:j,cleanup:F}=await this.gb(P);try{const B=await(0,h.getManifest)(m.resolve(j.fsPath));if(B.engines&&B.engines.vscode&&!(0,X.isEngineValid)(B.engines.vscode,this.w.version,this.w.date))throw new Error(v.localize(0,null,(0,t.getGalleryExtensionId)(B.publisher,B.name),this.w.version));return await this.C(B,j,D)}finally{await F()}}async installFromLocation(P,D){this.v.trace("ExtensionManagementService#installFromLocation",P.toString());const j=await this.U.scanUserExtensionAtLocation(P);if(!j)throw new Error(`Cannot find a valid extension from the location ${P.toString()}`);return await this.pb([j],D),this.v.info("Successfully installed extension",j.identifier.id,D.toString()),j}getMetadata(P){return this.ab.scanMetadata(P.location)}async updateMetadata(P,D){this.v.trace("ExtensionManagementService#updateMetadata",P.identifier.id);const j={...D};return D.isPreReleaseVersion&&(j.preRelease=!0),P=await this.U.updateMetadata(P,j),this.W.invalidate(),P}async updateExtensionScope(P,D){return this.v.trace("ExtensionManagementService#updateExtensionScope",P.identifier.id),P=await this.U.updateMetadata(P,{isMachineScoped:D}),this.W.invalidate(),P}async reinstallFromGallery(P){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",P.identifier.id),!this.t.isEnabled())throw new Error(v.localize(1,null));const D=await this.getTargetPlatform(),[j]=await this.t.getExtensions([{...P.identifier,preRelease:P.preRelease}],{targetPlatform:D,compatible:!0},R.CancellationToken.None);if(!j)throw new Error(v.localize(2,null));await this.U.setUninstalled(P);try{await this.U.removeUninstalledExtension(P)}catch(F){throw new Error(v.localize(3,null,(0,k.toErrorMessage)(F)))}await this.installFromGallery(j)}markAsUninstalled(...P){return this.U.setUninstalled(...P)}removeUninstalledExtensions(){return this.U.cleanUp()}async download(P,D){const{location:j}=await this.X.download(P,D);return j}async gb(P){if(P.scheme===l.Schemas.file)return{location:P,async cleanup(){}};this.v.trace("Downloading extension from",P.toString());const D=(0,p.joinPath)(this.X.extensionsDownloadDir,(0,E.generateUuid)());return await this.cb.download(P,D),this.v.info("Downloaded extension to",D.toString()),{location:D,cleanup:async()=>{try{await this.db.del(D)}catch(F){this.v.error(F)}}}}Q(){return this.y.defaultProfile.extensionsResource}R(P,D,j){let F;if(S.URI.isUri(D))F=new V(P,D,j,this.t,this.U,this.v);else{const B=t.ExtensionKey.create(D).toString();F=this.Y.get(B),F||(this.Y.set(B,F=new U(P,D,j,this.X,this.U,this.v)),F.waitUntilTaskIsFinished().then(()=>this.Y.delete(B)))}return new G(F,j.profileLocation,this.bb)}S(P,D){return new q(P,D.profileLocation,this.bb)}async kb(P){const D=async F=>{let B=await u.Promises.readdir(F);B=B.map(oe=>m.join(F,oe));const x=await Promise.all(B.map(oe=>u.Promises.stat(oe)));let te=Promise.resolve([]);return x.forEach((oe,me)=>{const ye=B[me];oe.isFile()&&(te=te.then(ae=>[...ae,ye])),oe.isDirectory()&&(te=te.then(ae=>D(ye).then(ne=>[...ae,...ne])))}),te};return(await D(P.location.fsPath)).map(F=>({path:`extension/${m.relative(P.location.fsPath,F)}`,localPath:F}))}async lb({added:P,removed:D}){if(D)for(const j of D.extensions)this.v.info("Extensions removed from another source",j.id,D.profileLocation.toString()),this.p.fire({identifier:j,profileLocation:D.profileLocation});if(P){const F=(await this.U.scanExtensions(1,P.profileLocation)).filter(B=>P.extensions.some(x=>(0,t.areSameExtensions)(x,B.identifier)));this.m.fire(F.map(B=>(this.v.info("Extensions added from another source",B.identifier.id,P.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:P.profileLocation,operation:1})))}}async nb(){this.B(this.U.onExtract(D=>this.mb.add(D)));const P=await this.db.resolve(this.ab.userExtensionsLocation);for(const D of P.children??[])D.isDirectory&&this.mb.add(D.resource);this.B(this.db.watch(this.ab.userExtensionsLocation)),this.B(this.db.onDidFilesChange(D=>this.ob(D)))}async ob(P){const D=[];for(const j of P.rawAdded){if(this.mb.has(j)||!this.eb.extUri.isEqual(this.eb.extUri.dirname(j),this.ab.userExtensionsLocation)||this.eb.extUri.isEqual(j,this.eb.extUri.joinPath(this.ab.userExtensionsLocation,".obsolete"))||this.eb.extUri.basename(j).startsWith(".")||!(await this.db.stat(j)).isDirectory)continue;const F=await this.U.scanUserExtensionAtLocation(j);F&&F.installedTimestamp===void 0&&(this.mb.add(j),D.push(F))}D.length&&(await this.pb(D,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",D.map(j=>j.identifier.id)))}async pb(P,D){await this.bb.addExtensionsToProfile(P.map(j=>[j,void 0]),D),this.m.fire(P.map(j=>({local:j,identifier:j.identifier,operation:1,profileLocation:D})))}};ge=fe([_(0,n.IExtensionGalleryService),_(1,he.ITelemetryService),_(2,re.ILogService),_(3,s.INativeEnvironmentService),_(4,o.IExtensionsScannerService),_(5,r.IExtensionsProfileScannerService),_(6,f.IDownloadService),_(7,ie.IInstantiationService),_(8,J.IFileService),_(9,Z.IProductService),_(10,ce.IUriIdentityService),_(11,se.IUserDataProfilesService)],ge),e.ExtensionManagementService=ge;let M=class extends b.Disposable{constructor(P,D,j,F){super(),this.j=P,this.k=D,this.l=j,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,p.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(P,D){await this.l.initializeDefaultProfileExtensions();const j={includeInvalid:!0,profileLocation:D};let F=[];return P===null||P===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},j,!1)):P===1&&F.push(...await this.l.scanUserExtensions(j)),F=P!==null?F.filter(B=>B.type===P):F,Promise.all(F.map(B=>this.u(B)))}async scanAllUserExtensions(P){const D=await this.l.scanUserExtensions({includeAllVersions:!P,includeInvalid:!0});return Promise.all(D.map(j=>this.u(j)))}async scanUserExtensionAtLocation(P){try{const D=await this.l.scanExistingExtension(P,1,{includeInvalid:!0});if(D)return await this.u(D)}catch(D){this.m.error(D)}return null}async extractUserExtension(P,D,j,F){await this.l.initializeDefaultProfileExtensions();const B=P.toString(),x=m.join(this.l.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),te=m.join(this.l.userExtensionsLocation.fsPath,B);try{await u.Promises.rm(te)}catch{throw new n.ExtensionManagementError(v.localize(4,null,te,P.id),n.ExtensionManagementErrorCode.Delete)}await this.p(P,D,x,F),await this.l.updateMetadata(S.URI.file(x),j);try{this.h.fire(S.URI.file(te)),await this.s(P,x,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(oe){try{await u.Promises.rm(x)}catch{}if(oe.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",P.id);else throw this.m.info(`Rename failed because of ${(0,L.getErrorMessage)(oe)}. Deleted from extracted location`,x),oe}return this.t(S.URI.file(te),1)}async updateMetadata(P,D){return await this.l.updateMetadata(P.location,D),this.t(P.location,P.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...P){const D=P.map(j=>t.ExtensionKey.create(j));await this.n(j=>D.forEach(F=>{j[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(P){await this.n(F=>delete F[P.toString()]);const j=(await this.scanAllUserExtensions(!0)).find(F=>t.ExtensionKey.create(F).equals(P))||null;return j?this.updateMetadata(j,{installedTimestamp:Date.now()}):null}async removeExtension(P,D){this.m.trace(`Deleting ${D} extension from disk`,P.identifier.id,P.location.fsPath),await u.Promises.rm(P.location.fsPath),this.m.info("Deleted from disk",P.identifier.id,P.location.fsPath)}async removeUninstalledExtension(P){await this.removeExtension(P,"uninstalled"),await this.n(D=>delete D[t.ExtensionKey.create(P).toString()])}async n(P){return this.g.queue(async()=>{let D;try{D=await u.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let j={};if(D)try{j=JSON.parse(D)}catch{}return P&&(P(j),Object.keys(j).length?await u.Promises.writeFile(this.c,JSON.stringify(j)):await u.Promises.rm(this.c)),j})}async p(P,D,j,F){this.m.trace(`Started extracting the extension from ${D} to ${j}`);try{await u.Promises.rm(j)}catch(B){throw new n.ExtensionManagementError(this.w(B).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(D,j,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${j}:`,P.id)}catch(B){try{await u.Promises.rm(j)}catch{}let x=n.ExtensionManagementErrorCode.Extract;throw B instanceof d.ExtractError&&(B.type==="CorruptZip"?x=n.ExtensionManagementErrorCode.CorruptZip:B.type==="Incomplete"&&(x=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(B.message,x)}}async s(P,D,j,F){try{await u.Promises.rename(D,j)}catch(B){if(w.isWindows&&B&&B.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${D} to ${j} with 'EPERM' error. Trying again...`,P.id),this.s(P,D,j,F);throw new n.ExtensionManagementError(B.message||v.localize(5,null,D,j),B.code||n.ExtensionManagementErrorCode.Rename)}}async t(P,D){const j=await this.l.scanExistingExtension(P,D,{includeInvalid:!0});if(j)return this.u(j);throw new Error(v.localize(6,null,P.path))}async u(P){const D=await this.k.resolve(P.location);let j,F;return D.children&&(j=D.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=D.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:P.identifier,type:P.type,isBuiltin:P.isBuiltin||!!P.metadata?.isBuiltin,location:P.location,manifest:P.manifest,targetPlatform:P.targetPlatform,validations:P.validations,isValid:P.isValid,readmeUrl:j,changelogUrl:F,publisherDisplayName:P.metadata?.publisherDisplayName||null,publisherId:P.metadata?.publisherId||null,isApplicationScoped:!!P.metadata?.isApplicationScoped,isMachineScoped:!!P.metadata?.isMachineScoped,isPreReleaseVersion:!!P.metadata?.isPreReleaseVersion,preRelease:!!P.metadata?.preRelease,installedTimestamp:P.metadata?.installedTimestamp,updated:!!P.metadata?.updated}}async v(){const P=await this.getUninstalledExtensions(),D=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const x of D)P[t.ExtensionKey.create(x).toString()]||j.add(x.identifier.id.toLowerCase());const F=(0,t.groupByExtension)(D,x=>x.identifier);await T.Promises.settled(F.map(async x=>{const te=x.sort((oe,me)=>I.rcompare(oe.manifest.version,me.manifest.version))[0];j.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const B=D.filter(x=>P[t.ExtensionKey.create(x).toString()]);await T.Promises.settled(B.map(x=>this.removeUninstalledExtension(x)))}w(P){const D=Array.isArray(P)?P:[P];return D.length===1?D[0]instanceof Error?D[0]:new Error(D[0]):D.reduce((j,F)=>new Error(`${j.message}${j.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};M=fe([_(1,J.IFileService),_(2,o.IExtensionsScannerService),_(3,re.ILogService)],M),e.ExtensionsScanner=M;class A extends i.AbstractExtensionTask{get operation(){return(0,y.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(P,D,j,F,B){super(),this.identifier=P,this.source=D,this.k=j,this.l=F,this.m=B,this.wasVerified=!1,this.j=2}async n(P,D){try{const j=await this.o(P.key);if(j)return this.l.updateMetadata(j,P.metadata)}catch{throw w.isMacintosh?new n.ExtensionManagementError(v.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(v.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(P,D)}async o(P){if(!await this.p(P))return null;this.m.trace("Removing the extension from uninstalled list:",P.id);const j=await this.l.setInstalled(P);return this.m.info("Removed the extension from uninstalled list:",P.id),j}async p(P){return!!(await this.l.getUninstalledExtensions())[P.toString()]}async q({zipPath:P,key:D,metadata:j},F){const B=await this.l.extractUserExtension(D,P,j,F);return this.m.info("Extracting completed.",D.id),B}}class U extends A{constructor(P,D,j,F,B,x){super(D.identifier,D,j,B,x),this.s=P,this.t=D,this.u=F}async h(P){const j=(await this.l.scanExtensions(null,void 0)).find(te=>(0,t.areSameExtensions)(te.identifier,this.t.identifier));j&&(this.j=3);const F={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,W.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||j?.isMachineScoped,isBuiltin:this.k.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,y.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:j?.preRelease)};if(j?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(j,F),metadata:F};const{location:B,verified:x}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!x,this.w(B.fsPath),{local:await this.n({zipPath:B.fsPath,key:t.ExtensionKey.create(this.t),metadata:F},P),metadata:F}}catch(te){try{await this.u.delete(B)}catch(oe){this.m.warn("Error while deleting the downloaded file",B.toString(),(0,L.getErrorMessage)(oe))}throw te}}async w(P){try{await(0,h.getManifest)(P)}catch(D){throw new n.ExtensionManagementError((0,i.joinErrors)(D).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class V extends A{constructor(P,D,j,F,B,x){super({id:(0,t.getGalleryExtensionId)(P.publisher,P.name)},D,j,B,x),this.s=P,this.t=D,this.u=F}async h(P){const D=new t.ExtensionKey(this.identifier,this.s.version),F=(await this.l.scanExtensions(1,void 0)).find(te=>(0,t.areSameExtensions)(this.identifier,te.identifier)),B=await this.w(this.identifier.id,this.s.version,P);if(B.isApplicationScoped=(0,W.isApplicationScopedExtension)(this.s),B.isMachineScoped=this.k.isMachineScoped||F?.isMachineScoped,B.isBuiltin=this.k.isBuiltin||F?.isBuiltin,B.installedTimestamp=Date.now(),F)if(this.j=3,D.equals(new t.ExtensionKey(F.identifier,F.manifest.version)))try{await this.l.removeExtension(F,"existing")}catch{throw new Error(v.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&I.gt(F.manifest.version,this.s.version)&&await this.l.setUninstalled(F);else{const te=await this.o(D);if(te)try{await this.l.removeExtension(te,"existing")}catch{throw new Error(v.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:m.resolve(this.t.fsPath),key:D,metadata:B},P),metadata:B}}async w(P,D,j){try{let[F]=await this.u.getExtensions([{id:P,version:D}],j);if(F||([F]=await this.u.getExtensions([{id:P}],j)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class G{constructor(P,D,j){this.d=P,this.g=D,this.h=j,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const P=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[P.local,P.metadata]],this.g),P}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends i.AbstractExtensionTask{constructor(P,D,j){super(),this.extension=P,this.j=D,this.k=j}async h(P){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Y[151],Q([0,1,131,4,15,11,2,8,21,18,132,9,130,164]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends N.Disposable{constructor(E,u,d){super(),this.h=u,this.i=d,this.j(E.getValue()),this.B(E.onDidChangeConfiguration(()=>this.j(E.getValue()),this))}j(E){this.a=E.http&&E.http.proxy,this.b=!!(E.http&&E.http.proxyStrictSSL),this.f=E.http&&E.http.proxyAuthorization}async request(E,u){this.i.trace("RequestService#request (node) - begin",E.url);const{a:d,b:v}=this;let f;try{f=await(0,m.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},i=E.agent?E.agent:await(0,p.getProxyAgent)(E.url||"",s,{proxyUrl:d,strictSSL:v});E.agent=i,E.strictSSL=v,this.f&&(E.headers={...E.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(E,u);return this.i.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",E.url,n),n}}async k(E){return((0,T.parse)(E.url).protocol==="https:"?await new Promise((v,f)=>{$(["https"],v,f)}):await new Promise((v,f)=>{$(["http"],v,f)})).request}l(E,u){return R.Promises.withAsyncBody(async(d,v)=>{const f=(0,T.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.k(E),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,b.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(i.auth=E.user+":"+E.password);const n=s(i,t=>{const r=(0,b.isNumber)(E.followRedirects)?E.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this.l({...E,url:t.headers.location,followRedirects:r-1},u).then(d,v);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,I.createGunzip)())),d({res:t,stream:(0,k.streamToBufferReadableStream)(o)})}});n.on("error",v),E.timeout&&n.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),u.onCancellationRequested(()=>{n.abort(),v(new L.CancellationError)})})}async resolveProxy(E){}};y=fe([_(0,g.IConfigurationService),_(1,l.INativeEnvironmentService),_(2,w.ILogService)],y),e.RequestService=y}),define(Y[165],Q([0,1,38,4,15,32,11,2,16,14,12,33,10,20,21,122,58,129,18,102,146,23,59,124,42,48,150,144,13,113,116,46,111,62,63,128,9,118,119,37,148,137,30,47,151,66,133,67,36,136,41,138,139,27,140,25,147]),function($,e,T,R,k,L,N,b,g,l,m,w,p,I,y,S,E,u,d,v,f,s,i,n,t,r,o,c,a,h,O,C,W,X,J,ie,re,Z,he,ce,se,ge,M,A,U,V,G,q,ee,P,D,j,F,B,x,te,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class me extends b.Disposable{constructor(ne){super(),this.b=ne,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ne,de]=await this.f();return ne.invokeFunction(async le=>{const ve=le.get(re.ILogService),Me=le.get(a.IFileService),Te=le.get(d.INativeEnvironmentService),Ae=le.get(te.IUserDataProfilesService);ve.info("CLI main",this.b),this.g(ve),await this.h(Te,Me,Ae,ne),await Promise.all(de.map(Ue=>{(0,R.raceTimeout)(Ue.flush(),1e3)}))})}async f(){const ne=new X.ServiceCollection,de={_serviceBrand:void 0,...ge.default};ne.set(M.IProductService,de);const le=new v.NativeEnvironmentService(this.b,de);ne.set(d.INativeEnvironmentService,le),await Promise.all([le.appSettingsHome.fsPath,le.extensionsPath].map(Re=>Re?I.Promises.mkdir(Re,{recursive:!0}):void 0));const ve=(0,re.getLogLevel)(le),Me=[];Me.push(new Z.SpdLogLogger("cli",(0,l.join)(le.logsPath,"cli.log"),!0,!1,ve)),ve===re.LogLevel.Trace&&Me.push(new re.ConsoleLogger(ve));const Te=this.B(new re.MultiplexLogService(Me));ne.set(re.ILogService,Te);const Ae=this.B(new h.FileService(Te));ne.set(a.IFileService,Ae);const Ue=this.B(new O.DiskFileSystemProvider(Te));Ae.registerProvider(g.Schemas.file,Ue);const z=new G.StateService(le,Te,Ae);ne.set(V.IStateService,z);const H=new x.UriIdentityService(Ae);ne.set(B.IUriIdentityService,H);const K=new oe.UserDataProfilesService(z,H,le,Ae,Te);ne.set(te.IUserDataProfilesService,K);const ue=m.isWindows&&de.win32RegValueName?this.B(new se.NativePolicyService(Te,de.win32RegValueName)):le.policyFile?this.B(new he.FilePolicyService(le.policyFile,Ae,Te)):new ce.NullPolicyService;ne.set(ce.IPolicyService,ue);const pe=this.B(new S.ConfigurationService(K.defaultProfile.settingsResource,Ae,ue,Te));ne.set(y.IConfigurationService,pe),await Promise.all([z.init(),pe.initialize()]),K.setEnablement(de.quality!=="stable"||pe.getValue(te.PROFILES_ENABLEMENT_CONFIG)),ne.set(B.IUriIdentityService,new x.UriIdentityService(Ae)),ne.set(A.IRequestService,new C.SyncDescriptor(U.RequestService,void 0,!0)),ne.set(E.IDownloadService,new C.SyncDescriptor(u.DownloadService,void 0,!0)),ne.set(t.IExtensionsProfileScannerService,new C.SyncDescriptor(t.ExtensionsProfileScannerService,void 0,!0)),ne.set(r.IExtensionsScannerService,new C.SyncDescriptor(c.ExtensionsScannerService,void 0,!0)),ne.set(i.IExtensionSignatureVerificationService,new C.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),ne.set(o.INativeServerExtensionManagementService,new C.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),ne.set(s.IExtensionGalleryService,new C.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ne.set(J.ILanguagePackService,new C.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const ke=[],Se=(0,D.isInternalTelemetry)(de,pe);if((0,D.supportsTelemetry)(de,le)){de.aiConfig&&de.aiConfig.ariaKey&&ke.push(new j.OneDataSystemAppender(Se,"monacoworkbench",null,de.aiConfig.ariaKey));const{installSourcePath:Re}=le,Ie={appenders:ke,sendErrorTelemetry:!1,commonProperties:(async()=>{let Oe;try{const je=await I.Promises.readFile(le.stateResource.fsPath);Oe=JSON.parse(je.toString())[ee.machineIdKey]}catch(je){je.code!=="ENOENT"&&Te.error(je)}return(0,q.resolveCommonProperties)(Ae,(0,T.release)(),(0,T.hostname)(),process.arch,de.commit,de.version,Oe,Se,Re)})(),piiPaths:(0,D.getPiiPathsFromEnvironment)(le)};ne.set(ee.ITelemetryService,new C.SyncDescriptor(P.TelemetryService,[Ie],!1))}else ne.set(ee.ITelemetryService,D.NullTelemetryService);return[new W.InstantiationService(ne),ke]}g(ne){(0,N.setUnexpectedErrorHandler)(de=>{const le=(0,L.toErrorMessage)(de,!0);!le||ne.error(`[uncaught exception in CLI]: ${le}`)}),process.on("uncaughtException",de=>(0,N.onUnexpectedError)(de)),process.on("unhandledRejection",de=>(0,N.onUnexpectedError)(de))}async h(ne,de,le,ve){const Me=(ne.args.profile?le.profiles.find(Te=>Te.name===ne.args.profile)??le.defaultProfile:le.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(ne,de,this.b["install-source"]);if(this.b["list-extensions"])return ve.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Me);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Me};return ve.createInstance(n.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],Te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ve.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Me);if(this.b["locate-extension"])return ve.createInstance(n.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(ne.appRoot,ne.extensionsPath))}}i(ne){return ne.map(de=>/\.vsix$/i.test(de)?p.URI.file((0,l.isAbsolute)(de)?de:(0,l.join)((0,w.cwd)(),de)):de)}async j(ne,de,le){await de.writeFile(p.URI.file(ne.installSourcePath),k.VSBuffer.fromString(le.slice(0,30)))}}async function ye(ae){const ne=new me(ae);try{await ne.run()}finally{ne.dispose()}}e.main=ye})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58e7c7b8865e3c3ea77055461ffb5d656a7a46af/core/vs/code/node/cliProcessMain.js.map
