/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(te){for(var e=[],i=0,k=te.length;i<k;i++)e[i]=De[te[i]];return e};define(De[78],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(C,R){const w=Object.create(null);for(const T of C){const O=R(T);let I=w[O];I||(I=w[O]=[]),I.push(T)}return w}e.groupBy=i;function k(C,R){const w=[],T=[];for(const O of C)R.has(O)||w.push(O);for(const O of R)C.has(O)||T.push(O);return{removed:w,added:T}}e.diffSets=k;function y(C,R){const w=[],T=[];for(const[O,I]of C)R.has(O)||w.push(I);for(const[O,I]of R)C.has(O)||T.push(I);return{removed:w,added:T}}e.diffMaps=y;class M{constructor(){this.a=new Map}add(R,w){let T=this.a.get(R);T||(T=new Set,this.a.set(R,T)),T.add(w)}delete(R,w){const T=this.a.get(R);!T||(T.delete(w),T.size===0&&this.a.delete(R))}forEach(R,w){const T=this.a.get(R);!T||T.forEach(w)}}e.SetMap=M}),define(De[59],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(C){return(R,w,T)=>{let O=null,I=null;if(typeof T.value=="function"?(O="value",I=T.value):typeof T.get=="function"&&(O="get",I=T.get),!I)throw new Error("not supported");T[O]=C(I,w)}}function k(C,R,w){let T=null,O=null;if(typeof w.value=="function"?(T="value",O=w.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(T="get",O=w.get),!O)throw new Error("not supported");const I=`$memoize$${R}`;w[T]=function(...m){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[I]}}e.memoize=k;function y(C,R,w){return i((T,O)=>{const I=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...v){this[m]||(this[m]=w?w():void 0),clearTimeout(this[I]),R&&(this[m]=R(this[m],...v),v=[this[m]]),this[I]=setTimeout(()=>{T.apply(this,v),this[m]=w?w():void 0},C)}})}e.debounce=y;function M(C,R,w){return i((T,O)=>{const I=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,v=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...t){if(this[m]||(this[m]=w?w():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...t)),this[f])return;const o=this[v]+C;o<=Date.now()?(this[v]=Date.now(),T.apply(this,[this[m]]),this[m]=w?w():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),T.apply(this,[this[m]]),this[m]=w?w():void 0},o-Date.now()))}})}e.throttle=M}),define(De[79],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(De[107],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var k;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(s){s.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function C(s,r=!1){let a=0;const h=s.length;let c="",d=0,n=16,l=0;function p(N){let F=0,$=0;for(;F<N;){const z=s.charCodeAt(a);if(z>=48&&z<=57)$=$*16+z-48;else if(z>=65&&z<=70)$=$*16+z-65+10;else if(z>=97&&z<=102)$=$*16+z-97+10;else break;a++,F++}return F<N&&($=-1),$}function A(N){a=N,c="",d=0,n=16,l=0}function L(){const N=a;if(s.charCodeAt(a)===48)a++;else for(a++;a<s.length&&T(s.charCodeAt(a));)a++;if(a<s.length&&s.charCodeAt(a)===46)if(a++,a<s.length&&T(s.charCodeAt(a)))for(a++;a<s.length&&T(s.charCodeAt(a));)a++;else return l=3,s.substring(N,a);let F=a;if(a<s.length&&(s.charCodeAt(a)===69||s.charCodeAt(a)===101))if(a++,(a<s.length&&s.charCodeAt(a)===43||s.charCodeAt(a)===45)&&a++,a<s.length&&T(s.charCodeAt(a))){for(a++;a<s.length&&T(s.charCodeAt(a));)a++;F=a}else l=3;return s.substring(N,F)}function q(){let N="",F=a;for(;;){if(a>=h){N+=s.substring(F,a),l=2;break}const $=s.charCodeAt(a);if($===34){N+=s.substring(F,a),a++;break}if($===92){if(N+=s.substring(F,a),a++,a>=h){l=2;break}switch(s.charCodeAt(a++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const V=p(4);V>=0?N+=String.fromCharCode(V):l=4;break}default:l=5}F=a;continue}if($>=0&&$<=31)if(w($)){N+=s.substring(F,a),l=2;break}else l=6;a++}return N}function K(){if(c="",l=0,d=a,a>=h)return d=h,n=17;let N=s.charCodeAt(a);if(R(N)){do a++,c+=String.fromCharCode(N),N=s.charCodeAt(a);while(R(N));return n=15}if(w(N))return a++,c+=String.fromCharCode(N),N===13&&s.charCodeAt(a)===10&&(a++,c+=`
`),n=14;switch(N){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,c=q(),n=10;case 47:{const F=a-1;if(s.charCodeAt(a+1)===47){for(a+=2;a<h&&!w(s.charCodeAt(a));)a++;return c=s.substring(F,a),n=12}if(s.charCodeAt(a+1)===42){a+=2;const $=h-1;let z=!1;for(;a<$;){if(s.charCodeAt(a)===42&&s.charCodeAt(a+1)===47){a+=2,z=!0;break}a++}return z||(a++,l=1),c=s.substring(F,a),n=13}return c+=String.fromCharCode(N),a++,n=16}case 45:if(c+=String.fromCharCode(N),a++,a===h||!T(s.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=L(),n=11;default:for(;a<h&&j(N);)a++,N=s.charCodeAt(a);if(d!==a){switch(c=s.substring(d,a),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(N),a++,n=16}}function j(N){if(R(N)||w(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let N;do N=K();while(N>=12&&N<=15);return N}return{setPosition:A,getPosition:()=>a,scan:r?P:K,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>d,getTokenLength:()=>a-d,getTokenError:()=>l}}e.createScanner=C;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function w(s){return s===10||s===13||s===8232||s===8233}function T(s){return s>=48&&s<=57}var O;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(O||(O={}));function I(s,r){const a=[],h=new Object;let c;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function l(p,A,L,q){d.value=p,d.offset=A,d.length=L,d.type=q,d.colonOffset=void 0,c=d}try{E(s,{onObjectBegin:(p,A)=>{if(r<=p)throw h;c=void 0,n=r>p,a.push("")},onObjectProperty:(p,A,L)=>{if(r<A||(l(p,A,L,"property"),a[a.length-1]=p,r<=A+L))throw h},onObjectEnd:(p,A)=>{if(r<=p)throw h;c=void 0,a.pop()},onArrayBegin:(p,A)=>{if(r<=p)throw h;c=void 0,a.push(0)},onArrayEnd:(p,A)=>{if(r<=p)throw h;c=void 0,a.pop()},onLiteralValue:(p,A,L)=>{if(r<A||(l(p,A,L,S(p)),r<=A+L))throw h},onSeparator:(p,A,L)=>{if(r<=A)throw h;if(p===":"&&c&&c.type==="property")c.colonOffset=A,n=!1,c=void 0;else if(p===","){const q=a[a.length-1];typeof q=="number"?a[a.length-1]=q+1:(n=!0,a[a.length-1]=""),c=void 0}}})}catch(p){if(p!==h)throw p}return{path:a,previousNode:c,isAtPropertyKey:n,matches:p=>{let A=0;for(let L=0;A<p.length&&L<a.length;L++)if(p[A]===a[L]||p[A]==="*")A++;else if(p[A]!=="**")return!1;return A===p.length}}}e.getLocation=I;function m(s,r=[],a=M.DEFAULT){let h=null,c=[];const d=[];function n(p){Array.isArray(c)?c.push(p):h!==null&&(c[h]=p)}return E(s,{onObjectBegin:()=>{const p={};n(p),d.push(c),c=p,h=null},onObjectProperty:p=>{h=p},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const p=[];n(p),d.push(c),c=p,h=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:n,onError:(p,A,L)=>{r.push({error:p,offset:A,length:L})}},a),c[0]}e.parse=m;function v(s,r=[],a=M.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(p){h.type==="property"&&(h.length=p-h.offset,h=h.parent)}function d(p){return h.children.push(p),p}E(s,{onObjectBegin:p=>{h=d({type:"object",offset:p,length:-1,parent:h,children:[]})},onObjectProperty:(p,A,L)=>{h=d({type:"property",offset:A,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:p,offset:A,length:L,parent:h})},onObjectEnd:(p,A)=>{h.length=p+A-h.offset,h=h.parent,c(p+A)},onArrayBegin:(p,A)=>{h=d({type:"array",offset:p,length:-1,parent:h,children:[]})},onArrayEnd:(p,A)=>{h.length=p+A-h.offset,h=h.parent,c(p+A)},onLiteralValue:(p,A,L)=>{d({type:S(p),offset:A,length:L,parent:h,value:p}),c(A+L)},onSeparator:(p,A,L)=>{h.type==="property"&&(p===":"?h.colonOffset=A:p===","&&c(A))},onError:(p,A,L)=>{r.push({error:p,offset:A,length:L})}},a);const l=h.children[0];return l&&delete l.parent,l}e.parseTree=v;function f(s,r){if(!s)return;let a=s;for(const h of r)if(typeof h=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const d of a.children)if(Array.isArray(d.children)&&d.children[0].value===h){a=d.children[1],c=!0;break}if(!c)return}else{const c=h;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=f;function t(s){if(!s.parent||!s.parent.children)return[];const r=t(s.parent);if(s.parent.type==="property"){const a=s.parent.children[0].value;r.push(a)}else if(s.parent.type==="array"){const a=s.parent.children.indexOf(s);a!==-1&&r.push(a)}return r}e.getNodePath=t;function o(s){switch(s.type){case"array":return s.children.map(o);case"object":{const r=Object.create(null);for(const a of s.children){const h=a.children[1];h&&(r[a.children[0].value]=o(h))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=o;function u(s,r,a=!1){return r>=s.offset&&r<s.offset+s.length||a&&r===s.offset+s.length}e.contains=u;function g(s,r,a=!1){if(u(s,r,a)){const h=s.children;if(Array.isArray(h))for(let c=0;c<h.length&&h[c].offset<=r;c++){const d=g(h[c],r,a);if(d)return d}return s}}e.findNodeAtOffset=g;function E(s,r,a=M.DEFAULT){const h=C(s,!1);function c(ce){return ce?()=>ce(h.getTokenOffset(),h.getTokenLength()):()=>!0}function d(ce){return ce?he=>ce(he,h.getTokenOffset(),h.getTokenLength()):()=>!0}const n=c(r.onObjectBegin),l=d(r.onObjectProperty),p=c(r.onObjectEnd),A=c(r.onArrayBegin),L=c(r.onArrayEnd),q=d(r.onLiteralValue),K=d(r.onSeparator),j=c(r.onComment),P=d(r.onError),N=a&&a.disallowComments,F=a&&a.allowTrailingComma;function $(){for(;;){const ce=h.scan();switch(h.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:N||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ce){case 12:case 13:N?z(10):j();break;case 16:z(1);break;case 15:case 14:break;default:return ce}}}function z(ce,he=[],Y=[]){if(P(ce),he.length+Y.length>0){let ge=h.getToken();for(;ge!==17;){if(he.indexOf(ge)!==-1){$();break}else if(Y.indexOf(ge)!==-1)break;ge=$()}}}function V(ce){const he=h.getTokenValue();return ce?q(he):l(he),$(),!0}function X(){switch(h.getToken()){case 11:{let ce=0;try{ce=JSON.parse(h.getTokenValue()),typeof ce!="number"&&(z(2),ce=0)}catch{z(2)}q(ce);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return $(),!0}function ee(){return h.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),h.getToken()===6?(K(":"),$(),ue()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function fe(){n(),$();let ce=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(ce||z(4,[],[]),K(","),$(),h.getToken()===2&&F)break}else ce&&z(6,[],[]);ee()||z(4,[],[2,5]),ce=!0}return p(),h.getToken()!==2?z(7,[2],[]):$(),!0}function oe(){A(),$();let ce=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(ce||z(4,[],[]),K(","),$(),h.getToken()===4&&F)break}else ce&&z(6,[],[]);ue()||z(4,[],[4,5]),ce=!0}return L(),h.getToken()!==4?z(8,[4],[]):$(),!0}function ue(){switch(h.getToken()){case 3:return oe();case 1:return fe();case 10:return V(!0);default:return X()}}return $(),h.getToken()===17?a.allowEmptyContent?!0:(z(4,[],[]),!1):ue()?(h.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=E;function b(s,r){const a=C(s),h=[];let c,d=0,n;do switch(n=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:d!==n&&h.push(s.substring(d,n)),r!==void 0&&h.push(a.getTokenValue().replace(/[^\r\n]/g,r)),d=a.getPosition();break}while(c!==17);return h.join("")}e.stripComments=b;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(De[28],Ce([1,0]),function(te,e){"use strict";var i,k,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(f,t,o){let u=f.get(t);return u===void 0&&(u=o,f.set(t,u)),u}e.getOrSet=M;function C(f){const t=[];return f.forEach((o,u)=>{t.push(`${u} => ${o}`)}),`Map(${f.size}) {${t.join(", ")}}`}e.mapToString=C;function R(f){const t=[];return f.forEach(o=>{t.push(o)}),`Set(${f.size}) {${t.join(", ")}}`}e.setToString=R;class w{constructor(t,o){this.uri=t,this.value=o}}class T{constructor(t,o){this[i]="ResourceMap",t instanceof T?(this.b=new Map(t.b),this.c=o??T.a):(this.b=new Map,this.c=t??T.a)}set(t,o){return this.b.set(this.c(t),new w(t,o)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[u,g]of this.b)t(g.value,g.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=T,T.a=f=>f.toString();class O{constructor(t,o){this[k]="ResourceSet",!t||typeof t=="function"?this.a=new T(t):(this.a=new T(o),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,o){this.a.forEach((u,g)=>t.call(o,g,g,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var I;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class m{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,o=0){const u=this.a.get(t);if(!!u)return o!==0&&this.j(u,o),u.value}set(t,o,u=0){let g=this.a.get(t);if(g)g.value=o,u!==0&&this.j(g,u);else{switch(g={key:t,value:o,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(t,g),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.a.get(t);if(!!o)return this.a.delete(t),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,o){const u=this.e;let g=this.b;for(;g;){if(o?t.bind(o)(g.value,g.key,this):t(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const t=this,o=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.key,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return g}values(){const t=this,o=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.value,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return g}entries(){const t=this,o=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:[u.key,u.value],done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return g}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.b,u=this.size;for(;o&&u>t;)this.a.delete(o.key),o=o.next,u--;this.b=o,this.d=u,o&&(o.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const o=t.next,u=t.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}t.next=void 0,t.previous=void 0,this.e++}j(t,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.b)return;const u=t.next,g=t.previous;t===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(o===2){if(t===this.c)return;const u=t.next,g=t.previous;t===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((o,u)=>{t.push([u,o])}),t}fromJSON(t){this.clear();for(const[o,u]of t)this.set(o,u)}}e.LinkedMap=m;class v extends m{constructor(t,o=1){super(),this.k=t,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=v}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[108],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(ke,Ie){for(var Te=0;Te<Ie.length;Te++){var re=Ie[Te];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ke,re.key,re)}}function i(ke,Ie,Te){return Ie&&e(ke.prototype,Ie),Te&&e(ke,Te),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function k(ke,Ie){if(!!ke){if(typeof ke=="string")return y(ke,Ie);var Te=Object.prototype.toString.call(ke).slice(8,-1);if(Te==="Object"&&ke.constructor&&(Te=ke.constructor.name),Te==="Map"||Te==="Set")return Array.from(ke);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return y(ke,Ie)}}function y(ke,Ie){(Ie==null||Ie>ke.length)&&(Ie=ke.length);for(var Te=0,re=new Array(Ie);Te<Ie;Te++)re[Te]=ke[Te];return re}function M(ke,Ie){var Te=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(Te)return(Te=Te.call(ke)).next.bind(Te);if(Array.isArray(ke)||(Te=k(ke))||Ie&&ke&&typeof ke.length=="number"){Te&&(ke=Te);var re=0;return function(){return re>=ke.length?{done:!0}:{done:!1,value:ke[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function R(ke){te.defaults=ke}var w=/[&<>"']/,T=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(Ie){return m[Ie]};function f(ke,Ie){if(Ie){if(w.test(ke))return ke.replace(T,v)}else if(O.test(ke))return ke.replace(I,v);return ke}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(t,function(Ie,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var u=/(^|[^\[])\^/g;function g(ke,Ie){ke=typeof ke=="string"?ke:ke.source,Ie=Ie||"";var Te={replace:function(ae,J){return J=J.source||J,J=J.replace(u,"$1"),ke=ke.replace(ae,J),Te},getRegex:function(){return new RegExp(ke,Ie)}};return Te}var E=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(ke,Ie,Te){if(ke){var re;try{re=decodeURIComponent(o(Te)).replace(E,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Ie&&!b.test(Te)&&(Te=c(Ie,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch{return null}return Te}var s={},r=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ke,Ie){s[" "+ke]||(r.test(ke)?s[" "+ke]=ke+"/":s[" "+ke]=p(ke,"/",!0)),ke=s[" "+ke];var Te=ke.indexOf(":")===-1;return Ie.substring(0,2)==="//"?Te?Ie:ke.replace(a,"$1")+Ie:Ie.charAt(0)==="/"?Te?Ie:ke.replace(h,"$1")+Ie:ke+Ie}var d={exec:function(){}};function n(ke){for(var Ie=1,Te,re;Ie<arguments.length;Ie++){Te=arguments[Ie];for(re in Te)Object.prototype.hasOwnProperty.call(Te,re)&&(ke[re]=Te[re])}return ke}function l(ke,Ie){var Te=ke.replace(/\|/g,function(J,D,B){for(var H=!1,G=D;--G>=0&&B[G]==="\\";)H=!H;return H?"|":" |"}),re=Te.split(/ \|/),ae=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>Ie)re.splice(Ie);else for(;re.length<Ie;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function p(ke,Ie,Te){var re=ke.length;if(re===0)return"";for(var ae=0;ae<re;){var J=ke.charAt(re-ae-1);if(J===Ie&&!Te)ae++;else if(J!==Ie&&Te)ae++;else break}return ke.slice(0,re-ae)}function A(ke,Ie){if(ke.indexOf(Ie[1])===-1)return-1;for(var Te=ke.length,re=0,ae=0;ae<Te;ae++)if(ke[ae]==="\\")ae++;else if(ke[ae]===Ie[0])re++;else if(ke[ae]===Ie[1]&&(re--,re<0))return ae;return-1}function L(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(ke,Ie){if(Ie<1)return"";for(var Te="";Ie>1;)Ie&1&&(Te+=ke),Ie>>=1,ke+=ke;return Te+ke}function K(ke,Ie,Te,re){var ae=Ie.href,J=Ie.title?f(Ie.title):null,D=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){re.state.inLink=!0;var B={type:"link",raw:Te,href:ae,title:J,text:D,tokens:re.inlineTokens(D)};return re.state.inLink=!1,B}return{type:"image",raw:Te,href:ae,title:J,text:f(D)}}function j(ke,Ie){var Te=ke.match(/^(\s+)(?:```)/);if(Te===null)return Ie;var re=Te[1];return Ie.split(`
`).map(function(ae){var J=ae.match(/^\s+/);if(J===null)return ae;var D=J[0];return D.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var P=function(){function ke(Te){this.options=Te||te.defaults}var Ie=ke.prototype;return Ie.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},Ie.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var J=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?J:p(J,`
`)}}},Ie.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var J=ae[0],D=j(J,ae[3]||"");return{type:"code",raw:J,lang:ae[2]?ae[2].trim():ae[2],text:D}}},Ie.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var J=ae[2].trim();if(/#$/.test(J)){var D=p(J,"#");(this.options.pedantic||!D||/ $/.test(D))&&(J=D.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:J,tokens:this.lexer.inline(J)}}},Ie.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Ie.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var J=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Ie.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var J,D,B,H,G,Z,le,be,se,we,ve,$e,He=ae[1].trim(),et=He.length>1,xe={type:"list",raw:"",ordered:et,start:et?+He.slice(0,-1):"",loose:!1,items:[]};He=et?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=et?He:"[*+-]");for(var tt=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&($e=!1,!(!(ae=tt.exec(re))||this.rules.block.hr.test(re)));){if(J=ae[0],re=re.substring(J.length),be=ae[2].split(`
`,1)[0],se=re.split(`
`,1)[0],this.options.pedantic?(H=2,ve=be.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,ve=be.slice(H),H+=ae[1].length),Z=!1,!be&&/^ *$/.test(se)&&(J+=se+`
`,re=re.substring(se.length+1),$e=!0),!$e)for(var nt=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Le=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");re&&(we=re.split(`
`,1)[0],be=we,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Le.test(be)||ot.test(be)||nt.test(be)||dt.test(re)));){if(be.search(/[^ ]/)>=H||!be.trim())ve+=`
`+be.slice(H);else if(!Z)ve+=`
`+be;else break;!Z&&!be.trim()&&(Z=!0),J+=we+`
`,re=re.substring(we.length+1)}xe.loose||(le?xe.loose=!0:/\n *\n *$/.test(J)&&(le=!0)),this.options.gfm&&(D=/^\[[ xX]\] /.exec(ve),D&&(B=D[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:J,task:!!D,checked:B,loose:!1,text:ve}),xe.raw+=J}xe.items[xe.items.length-1].raw=J.trimRight(),xe.items[xe.items.length-1].text=ve.trimRight(),xe.raw=xe.raw.trimRight();var Q=xe.items.length;for(G=0;G<Q;G++){this.lexer.state.top=!1,xe.items[G].tokens=this.lexer.blockTokens(xe.items[G].text,[]);var _=xe.items[G].tokens.filter(function(Me){return Me.type==="space"}),pe=_.every(function(Me){for(var Be=Me.raw.split(""),je=0,Ye=M(Be),it;!(it=Ye()).done;){var bt=it.value;if(bt===`
`&&(je+=1),je>1)return!0}return!1});!xe.loose&&_.length&&pe&&(xe.loose=!0,xe.items[G].loose=!0)}return xe}},Ie.html=function(re){var ae=this.rules.block.html.exec(re);if(ae){var J={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var D=this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]);J.type="paragraph",J.text=D,J.tokens=this.lexer.inline(D)}return J}},Ie.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var J=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ae[0],href:ae[2],title:ae[3]}}},Ie.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var J={type:"table",header:l(ae[1]).map(function(le){return{text:le}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ae[0];var D=J.align.length,B,H,G,Z;for(B=0;B<D;B++)/^ *-+: *$/.test(J.align[B])?J.align[B]="right":/^ *:-+: *$/.test(J.align[B])?J.align[B]="center":/^ *:-+ *$/.test(J.align[B])?J.align[B]="left":J.align[B]=null;for(D=J.rows.length,B=0;B<D;B++)J.rows[B]=l(J.rows[B],J.header.length).map(function(le){return{text:le}});for(D=J.header.length,H=0;H<D;H++)J.header[H].tokens=this.lexer.inline(J.header[H].text);for(D=J.rows.length,H=0;H<D;H++)for(Z=J.rows[H],G=0;G<Z.length;G++)Z[G].tokens=this.lexer.inline(Z[G].text);return J}}},Ie.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},Ie.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae){var J=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:J,tokens:this.lexer.inline(J)}}},Ie.text=function(re){var ae=this.rules.block.text.exec(re);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},Ie.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:f(ae[1])}},Ie.tag=function(re){var ae=this.rules.inline.tag.exec(re);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]):ae[0]}},Ie.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var J=ae[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var D=p(J.slice(0,-1),"\\");if((J.length-D.length)%2===0)return}else{var B=A(ae[2],"()");if(B>-1){var H=ae[0].indexOf("!")===0?5:4,G=H+ae[1].length+B;ae[2]=ae[2].substring(0,B),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var Z=ae[2],le="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);be&&(Z=be[1],le=be[3])}else le=ae[3]?ae[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(J)?Z=Z.slice(1):Z=Z.slice(1,-1)),K(ae,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:le&&le.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Ie.reflink=function(re,ae){var J;if((J=this.rules.inline.reflink.exec(re))||(J=this.rules.inline.nolink.exec(re))){var D=(J[2]||J[1]).replace(/\s+/g," ");if(D=ae[D.toLowerCase()],!D||!D.href){var B=J[0].charAt(0);return{type:"text",raw:B,text:B}}return K(J,D,J[0],this.lexer)}},Ie.emStrong=function(re,ae,J){J===void 0&&(J="");var D=this.rules.inline.emStrong.lDelim.exec(re);if(!!D&&!(D[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=D[1]||D[2]||"";if(!B||B&&(J===""||this.rules.inline.punctuation.exec(J))){var H=D[0].length-1,G,Z,le=H,be=0,se=D[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,ae=ae.slice(-1*re.length+H);(D=se.exec(ae))!=null;)if(G=D[1]||D[2]||D[3]||D[4]||D[5]||D[6],!!G){if(Z=G.length,D[3]||D[4]){le+=Z;continue}else if((D[5]||D[6])&&H%3&&!((H+Z)%3)){be+=Z;continue}if(le-=Z,!(le>0)){if(Z=Math.min(Z,Z+le+be),Math.min(H,Z)%2){var we=re.slice(1,H+D.index+Z);return{type:"em",raw:re.slice(0,H+D.index+Z+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ve=re.slice(2,H+D.index+Z-1);return{type:"strong",raw:re.slice(0,H+D.index+Z+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},Ie.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var J=ae[2].replace(/\n/g," "),D=/[^ ]/.test(J),B=/^ /.test(J)&&/ $/.test(J);return D&&B&&(J=J.substring(1,J.length-1)),J=f(J,!0),{type:"codespan",raw:ae[0],text:J}}},Ie.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Ie.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},Ie.autolink=function(re,ae){var J=this.rules.inline.autolink.exec(re);if(J){var D,B;return J[2]==="@"?(D=f(this.options.mangle?ae(J[1]):J[1]),B="mailto:"+D):(D=f(J[1]),B=D),{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Ie.url=function(re,ae){var J;if(J=this.rules.inline.url.exec(re)){var D,B;if(J[2]==="@")D=f(this.options.mangle?ae(J[0]):J[0]),B="mailto:"+D;else{var H;do H=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(H!==J[0]);D=f(J[0]),J[1]==="www."?B="http://"+D:B=D}return{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Ie.inlineText=function(re,ae){var J=this.rules.inline.text.exec(re);if(J){var D;return this.lexer.state.inRawBlock?D=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):f(J[0]):J[0]:D=f(this.options.smartypants?ae(J[0]):J[0]),{type:"text",raw:J[0],text:D}}},ke}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=g(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=g(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=g(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=g(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=g(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=g(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=n({},N),N.gfm=n({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=g(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=g(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=n({},N.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:g(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=g(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=g(N._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=g(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=g(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=g(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=g(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=g(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=g(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=g(F.reflink).replace("label",F._label).replace("ref",N._label).getRegex(),F.nolink=g(F.nolink).replace("ref",N._label).getRegex(),F.reflinkSearch=g(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:g(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=g(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:g(F.br).replace("{2,}","*").getRegex(),text:g(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(ke){var Ie="",Te,re,ae=ke.length;for(Te=0;Te<ae;Te++)re=ke.charCodeAt(Te),Math.random()>.5&&(re="x"+re.toString(16)),Ie+="&#"+re+";";return Ie}var V=function(){function ke(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||te.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:N.normal,inline:F.normal};this.options.pedantic?(re.block=N.pedantic,re.inline=F.pedantic):this.options.gfm&&(re.block=N.gfm,this.options.breaks?re.inline=F.breaks:re.inline=F.gfm),this.tokenizer.rules=re}ke.lex=function(re,ae){var J=new ke(ae);return J.lex(re)},ke.lexInline=function(re,ae){var J=new ke(ae);return J.inlineTokens(re)};var Ie=ke.prototype;return Ie.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Ie.blockTokens=function(re,ae){var J=this;ae===void 0&&(ae=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(le,be,se){return be+"    ".repeat(se.length)});for(var D,B,H,G;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(le){return(D=le.call({lexer:J},re,ae))?(re=re.substring(D.raw.length),ae.push(D),!0):!1}))){if(D=this.tokenizer.space(re)){re=re.substring(D.raw.length),D.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(D);continue}if(D=this.tokenizer.code(re)){re=re.substring(D.raw.length),B=ae[ae.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ae.push(D);continue}if(D=this.tokenizer.fences(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.heading(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.hr(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.blockquote(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.list(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.html(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.def(re)){re=re.substring(D.raw.length),B=ae[ae.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[D.tag]||(this.tokens.links[D.tag]={href:D.href,title:D.title});continue}if(D=this.tokenizer.table(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.lheading(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(H=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var le=1/0,be=re.slice(1),se=void 0;J.options.extensions.startBlock.forEach(function(we){se=we.call({lexer:this},be),typeof se=="number"&&se>=0&&(le=Math.min(le,se))}),le<1/0&&le>=0&&(H=re.substring(0,le+1))}(),this.state.top&&(D=this.tokenizer.paragraph(H))){B=ae[ae.length-1],G&&B.type==="paragraph"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ae.push(D),G=H.length!==re.length,re=re.substring(D.raw.length);continue}if(D=this.tokenizer.text(re)){re=re.substring(D.raw.length),B=ae[ae.length-1],B&&B.type==="text"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ae.push(D);continue}if(re){var Z="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ae},Ie.inline=function(re,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:re,tokens:ae}),ae},Ie.inlineTokens=function(re,ae){var J=this;ae===void 0&&(ae=[]);var D,B,H,G=re,Z,le,be;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)se.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,Z.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(le||(be=""),le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(D=ve.call({lexer:J},re,ae))?(re=re.substring(D.raw.length),ae.push(D),!0):!1}))){if(D=this.tokenizer.escape(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.tag(re)){re=re.substring(D.raw.length),B=ae[ae.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ae.push(D);continue}if(D=this.tokenizer.link(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(D.raw.length),B=ae[ae.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ae.push(D);continue}if(D=this.tokenizer.emStrong(re,G,be)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.codespan(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.br(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.del(re)){re=re.substring(D.raw.length),ae.push(D);continue}if(D=this.tokenizer.autolink(re,z)){re=re.substring(D.raw.length),ae.push(D);continue}if(!this.state.inLink&&(D=this.tokenizer.url(re,z))){re=re.substring(D.raw.length),ae.push(D);continue}if(H=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,$e=re.slice(1),He=void 0;J.options.extensions.startInline.forEach(function(et){He=et.call({lexer:this},$e),typeof He=="number"&&He>=0&&(ve=Math.min(ve,He))}),ve<1/0&&ve>=0&&(H=re.substring(0,ve+1))}(),D=this.tokenizer.inlineText(H,$)){re=re.substring(D.raw.length),D.raw.slice(-1)!=="_"&&(be=D.raw.slice(-1)),le=!0,B=ae[ae.length-1],B&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ae.push(D);continue}if(re){var we="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return ae},i(ke,null,[{key:"rules",get:function(){return{block:N,inline:F}}}]),ke}(),X=function(){function ke(Te){this.options=Te||te.defaults}var Ie=ke.prototype;return Ie.code=function(re,ae,J){var D=(ae||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(re,D);B!=null&&B!==re&&(J=!0,re=B)}return re=re.replace(/\n$/,"")+`
`,D?'<pre><code class="'+this.options.langPrefix+f(D,!0)+'">'+(J?re:f(re,!0))+`</code></pre>
`:"<pre><code>"+(J?re:f(re,!0))+`</code></pre>
`},Ie.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Ie.html=function(re){return re},Ie.heading=function(re,ae,J,D){if(this.options.headerIds){var B=this.options.headerPrefix+D.slug(J);return"<h"+ae+' id="'+B+'">'+re+"</h"+ae+`>
`}return"<h"+ae+">"+re+"</h"+ae+`>
`},Ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ie.list=function(re,ae,J){var D=ae?"ol":"ul",B=ae&&J!==1?' start="'+J+'"':"";return"<"+D+B+`>
`+re+"</"+D+`>
`},Ie.listitem=function(re){return"<li>"+re+`</li>
`},Ie.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ie.paragraph=function(re){return"<p>"+re+`</p>
`},Ie.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Ie.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Ie.tablecell=function(re,ae){var J=ae.header?"th":"td",D=ae.align?"<"+J+' align="'+ae.align+'">':"<"+J+">";return D+re+("</"+J+`>
`)},Ie.strong=function(re){return"<strong>"+re+"</strong>"},Ie.em=function(re){return"<em>"+re+"</em>"},Ie.codespan=function(re){return"<code>"+re+"</code>"},Ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ie.del=function(re){return"<del>"+re+"</del>"},Ie.link=function(re,ae,J){if(re=S(this.options.sanitize,this.options.baseUrl,re),re===null)return J;var D='<a href="'+f(re)+'"';return ae&&(D+=' title="'+ae+'"'),D+=">"+J+"</a>",D},Ie.image=function(re,ae,J){if(re=S(this.options.sanitize,this.options.baseUrl,re),re===null)return J;var D='<img src="'+re+'" alt="'+J+'"';return ae&&(D+=' title="'+ae+'"'),D+=this.options.xhtml?"/>":">",D},Ie.text=function(re){return re},ke}(),ee=function(){function ke(){}var Ie=ke.prototype;return Ie.strong=function(re){return re},Ie.em=function(re){return re},Ie.codespan=function(re){return re},Ie.del=function(re){return re},Ie.html=function(re){return re},Ie.text=function(re){return re},Ie.link=function(re,ae,J){return""+J},Ie.image=function(re,ae,J){return""+J},Ie.br=function(){return""},ke}(),fe=function(){function ke(){this.seen={}}var Ie=ke.prototype;return Ie.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ie.getNextSafeSlug=function(re,ae){var J=re,D=0;if(this.seen.hasOwnProperty(J)){D=this.seen[re];do D++,J=re+"-"+D;while(this.seen.hasOwnProperty(J))}return ae||(this.seen[re]=D,this.seen[J]=0),J},Ie.slug=function(re,ae){ae===void 0&&(ae={});var J=this.serialize(re);return this.getNextSafeSlug(J,ae.dryrun)},ke}(),oe=function(){function ke(Te){this.options=Te||te.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new fe}ke.parse=function(re,ae){var J=new ke(ae);return J.parse(re)},ke.parseInline=function(re,ae){var J=new ke(ae);return J.parseInline(re)};var Ie=ke.prototype;return Ie.parse=function(re,ae){ae===void 0&&(ae=!0);var J="",D,B,H,G,Z,le,be,se,we,ve,$e,He,et,xe,tt,nt,dt,Le,ot,Q=re.length;for(D=0;D<Q;D++){if(ve=re[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(ot=this.options.extensions.renderers[ve.type].call({parser:this},ve),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){J+=ot||"";continue}switch(ve.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,o(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(se="",be="",G=ve.header.length,B=0;B<G;B++)be+=this.renderer.tablecell(this.parseInline(ve.header[B].tokens),{header:!0,align:ve.align[B]});for(se+=this.renderer.tablerow(be),we="",G=ve.rows.length,B=0;B<G;B++){for(le=ve.rows[B],be="",Z=le.length,H=0;H<Z;H++)be+=this.renderer.tablecell(this.parseInline(le[H].tokens),{header:!1,align:ve.align[H]});we+=this.renderer.tablerow(be)}J+=this.renderer.table(se,we);continue}case"blockquote":{we=this.parse(ve.tokens),J+=this.renderer.blockquote(we);continue}case"list":{for($e=ve.ordered,He=ve.start,et=ve.loose,G=ve.items.length,we="",B=0;B<G;B++)tt=ve.items[B],nt=tt.checked,dt=tt.task,xe="",tt.task&&(Le=this.renderer.checkbox(nt),et?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=Le+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=Le+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:Le}):xe+=Le),xe+=this.parse(tt.tokens,et),we+=this.renderer.listitem(xe,dt,nt);J+=this.renderer.list(we,$e,He);continue}case"html":{J+=this.renderer.html(ve.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(we=ve.tokens?this.parseInline(ve.tokens):ve.text;D+1<Q&&re[D+1].type==="text";)ve=re[++D],we+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);J+=ae?this.renderer.paragraph(we):we;continue}default:{var _='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(_);return}else throw new Error(_)}}}return J},Ie.parseInline=function(re,ae){ae=ae||this.renderer;var J="",D,B,H,G=re.length;for(D=0;D<G;D++){if(B=re[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(H=this.options.extensions.renderers[B.type].call({parser:this},B),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){J+=H||"";continue}switch(B.type){case"escape":{J+=ae.text(B.text);break}case"html":{J+=ae.html(B.text);break}case"link":{J+=ae.link(B.href,B.title,this.parseInline(B.tokens,ae));break}case"image":{J+=ae.image(B.href,B.title,B.text);break}case"strong":{J+=ae.strong(this.parseInline(B.tokens,ae));break}case"em":{J+=ae.em(this.parseInline(B.tokens,ae));break}case"codespan":{J+=ae.codespan(B.text);break}case"br":{J+=ae.br();break}case"del":{J+=ae.del(this.parseInline(B.tokens,ae));break}case"text":{J+=ae.text(B.text);break}default:{var Z='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return J},ke}();function ue(ke,Ie,Te){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof Ie=="function"&&(Te=Ie,Ie=null),Ie=n({},ue.defaults,Ie||{}),L(Ie),Te){var re=Ie.highlight,ae;try{ae=V.lex(ke,Ie)}catch(G){return Te(G)}var J=function(Z){var le;if(!Z)try{Ie.walkTokens&&ue.walkTokens(ae,Ie.walkTokens),le=oe.parse(ae,Ie)}catch(be){Z=be}return Ie.highlight=re,Z?Te(Z):Te(null,le)};if(!re||re.length<3||(delete Ie.highlight,!ae.length))return J();var D=0;ue.walkTokens(ae,function(G){G.type==="code"&&(D++,setTimeout(function(){re(G.text,G.lang,function(Z,le){if(Z)return J(Z);le!=null&&le!==G.text&&(G.text=le,G.escaped=!0),D--,D===0&&J()})},0))}),D===0&&J();return}function B(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+f(G.message+"",!0)+"</pre>";throw G}try{var H=V.lex(ke,Ie);if(Ie.walkTokens){if(Ie.async)return Promise.all(ue.walkTokens(H,Ie.walkTokens)).then(function(){return oe.parse(H,Ie)}).catch(B);ue.walkTokens(H,Ie.walkTokens)}return oe.parse(H,Ie)}catch(G){B(G)}}ue.options=ue.setOptions=function(ke){return n(ue.defaults,ke),R(ue.defaults),ue},ue.getDefaults=C,ue.defaults=te.defaults,ue.use=function(){for(var ke=arguments.length,Ie=new Array(ke),Te=0;Te<ke;Te++)Ie[Te]=arguments[Te];var re=n.apply(void 0,[{}].concat(Ie)),ae=ue.defaults.extensions||{renderers:{},childTokens:{}},J;Ie.forEach(function(D){if(D.extensions&&(J=!0,D.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var G=ae.renderers?ae.renderers[H.name]:null;G?ae.renderers[H.name]=function(){for(var Z=arguments.length,le=new Array(Z),be=0;be<Z;be++)le[be]=arguments[be];var se=H.renderer.apply(this,le);return se===!1&&(se=G.apply(this,le)),se}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),D.renderer&&function(){var H=ue.defaults.renderer||new X,G=function(be){var se=H[be];H[be]=function(){for(var we=arguments.length,ve=new Array(we),$e=0;$e<we;$e++)ve[$e]=arguments[$e];var He=D.renderer[be].apply(H,ve);return He===!1&&(He=se.apply(H,ve)),He}};for(var Z in D.renderer)G(Z);re.renderer=H}(),D.tokenizer&&function(){var H=ue.defaults.tokenizer||new P,G=function(be){var se=H[be];H[be]=function(){for(var we=arguments.length,ve=new Array(we),$e=0;$e<we;$e++)ve[$e]=arguments[$e];var He=D.tokenizer[be].apply(H,ve);return He===!1&&(He=se.apply(H,ve)),He}};for(var Z in D.tokenizer)G(Z);re.tokenizer=H}(),D.walkTokens){var B=ue.defaults.walkTokens;re.walkTokens=function(H){var G=[];return G.push(D.walkTokens.call(this,H)),B&&(G=G.concat(B.call(this,H))),G}}J&&(re.extensions=ae),ue.setOptions(re)})},ue.walkTokens=function(ke,Ie){for(var Te=[],re=function(){var B=J.value;switch(Te=Te.concat(Ie.call(ue,B)),B.type){case"table":{for(var H=M(B.header),G;!(G=H()).done;){var Z=G.value;Te=Te.concat(ue.walkTokens(Z.tokens,Ie))}for(var le=M(B.rows),be;!(be=le()).done;)for(var se=be.value,we=M(se),ve;!(ve=we()).done;){var $e=ve.value;Te=Te.concat(ue.walkTokens($e.tokens,Ie))}break}case"list":{Te=Te.concat(ue.walkTokens(B.items,Ie));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[B.type]?ue.defaults.extensions.childTokens[B.type].forEach(function(He){Te=Te.concat(ue.walkTokens(B[He],Ie))}):B.tokens&&(Te=Te.concat(ue.walkTokens(B.tokens,Ie)))}},ae=M(ke),J;!(J=ae()).done;)re();return Te},ue.parseInline=function(ke,Ie){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");Ie=n({},ue.defaults,Ie||{}),L(Ie);try{var Te=V.lexInline(ke,Ie);return Ie.walkTokens&&ue.walkTokens(Te,Ie.walkTokens),oe.parseInline(Te,Ie)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+f(re.message+"",!0)+"</pre>";throw re}},ue.Parser=oe,ue.parser=oe.parse,ue.Renderer=X,ue.TextRenderer=ee,ue.Lexer=V,ue.lexer=V.lex,ue.Tokenizer=P,ue.Slugger=fe,ue.parse=ue;var ce=ue.options,he=ue.setOptions,Y=ue.use,ge=ue.walkTokens,Se=ue.parseInline,Fe=ue,ze=oe.parse,_e=V.lex;te.Lexer=V,te.Parser=oe,te.Renderer=X,te.Slugger=fe,te.TextRenderer=ee,te.Tokenizer=P,te.getDefaults=C,te.lexer=_e,te.marked=ue,te.options=ce,te.parse=Fe,te.parseInline=Se,te.parser=ze,te.setOptions=he,te.use=Y,te.walkTokens=ge,Object.defineProperty(te,"__esModule",{value:!0})}),define(De[109],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(R,w,T){return Math.min(Math.max(R,w),T)}e.clamp=i;function k(R,w){return(w+R%w)%w}e.rot=k;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class M{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class C{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const T=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=T,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function te(y){const M=[];typeof y=="number"&&M.push("code/timeOrigin",y);function C(w){M.push(w,Date.now())}function R(){const w=[];for(let T=0;T<M.length;T+=2)w.push({name:M[T],startTime:M[T+1]});return w}return{mark:C,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(y+C.startTime)});return M}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=i(k))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var k in i)(typeof exports=="object"?exports:te)[k]=i[k]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function i(k){if(e[k])return e[k].exports;var y=e[k]={i:k,l:!1,exports:{}};return te[k].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=te,i.c=e,i.d=function(k,y,M){i.o(k,y)||Object.defineProperty(k,y,{enumerable:!0,get:M})},i.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},i.t=function(k,y){if(1&y&&(k=i(k)),8&y||4&y&&typeof k=="object"&&k&&k.__esModule)return k;var M=Object.create(null);if(i.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:k}),2&y&&typeof k!="string")for(var C in k)i.d(M,C,function(R){return k[R]}.bind(null,C));return M},i.n=function(k){var y=k&&k.__esModule?function(){return k.default}:function(){return k};return i.d(y,"a",y),y},i.o=function(k,y){return Object.prototype.hasOwnProperty.call(k,y)},i.p="",i(i.s=0)}([function(te,e,i){(function(k){var y;e=te.exports=Y,y=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],w=e.src=[],T=0,O=T++;w[O]="0|[1-9]\\d*";var I=T++;w[I]="[0-9]+";var m=T++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=T++;w[v]="("+w[O]+")\\.("+w[O]+")\\.("+w[O]+")";var f=T++;w[f]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var t=T++;w[t]="(?:"+w[O]+"|"+w[m]+")";var o=T++;w[o]="(?:"+w[I]+"|"+w[m]+")";var u=T++;w[u]="(?:-("+w[t]+"(?:\\."+w[t]+")*))";var g=T++;w[g]="(?:-?("+w[o]+"(?:\\."+w[o]+")*))";var E=T++;w[E]="[0-9A-Za-z-]+";var b=T++;w[b]="(?:\\+("+w[E]+"(?:\\."+w[E]+")*))";var S=T++,s="v?"+w[v]+w[u]+"?"+w[b]+"?";w[S]="^"+s+"$";var r="[v=\\s]*"+w[f]+w[g]+"?"+w[b]+"?",a=T++;w[a]="^"+r+"$";var h=T++;w[h]="((?:<|>)?=?)";var c=T++;w[c]=w[I]+"|x|X|\\*";var d=T++;w[d]=w[O]+"|x|X|\\*";var n=T++;w[n]="[v=\\s]*("+w[d]+")(?:\\.("+w[d]+")(?:\\.("+w[d]+")(?:"+w[u]+")?"+w[b]+"?)?)?";var l=T++;w[l]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[g]+")?"+w[b]+"?)?)?";var p=T++;w[p]="^"+w[h]+"\\s*"+w[n]+"$";var A=T++;w[A]="^"+w[h]+"\\s*"+w[l]+"$";var L=T++;w[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=T++;w[q]="(?:~>?)";var K=T++;w[K]="(\\s*)"+w[q]+"\\s+",R[K]=new RegExp(w[K],"g");var j=T++;w[j]="^"+w[q]+w[n]+"$";var P=T++;w[P]="^"+w[q]+w[l]+"$";var N=T++;w[N]="(?:\\^)";var F=T++;w[F]="(\\s*)"+w[N]+"\\s+",R[F]=new RegExp(w[F],"g");var $=T++;w[$]="^"+w[N]+w[n]+"$";var z=T++;w[z]="^"+w[N]+w[l]+"$";var V=T++;w[V]="^"+w[h]+"\\s*("+r+")$|^$";var X=T++;w[X]="^"+w[h]+"\\s*("+s+")$|^$";var ee=T++;w[ee]="(\\s*)"+w[h]+"\\s*("+r+"|"+w[n]+")",R[ee]=new RegExp(w[ee],"g");var fe=T++;w[fe]="^\\s*("+w[n]+")\\s+-\\s+("+w[n]+")\\s*$";var oe=T++;w[oe]="^\\s*("+w[l]+")\\s+-\\s+("+w[l]+")\\s*$";var ue=T++;w[ue]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)y(ce,w[ce]),R[ce]||(R[ce]=new RegExp(w[ce]));function he(se,we){if(se instanceof Y)return se;if(typeof se!="string"||se.length>M||!(we?R[a]:R[S]).test(se))return null;try{return new Y(se,we)}catch{return null}}function Y(se,we){if(se instanceof Y){if(se.loose===we)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Y))return new Y(se,we);y("SemVer",se,we),this.loose=we;var ve=se.trim().match(we?R[a]:R[S]);if(!ve)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<C)return He}return $e}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=he,e.valid=function(se,we){var ve=he(se,we);return ve?ve.version:null},e.clean=function(se,we){var ve=he(se.trim().replace(/^[=v]+/,""),we);return ve?ve.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(se){return y("SemVer.compare",this.version,this.loose,se),se instanceof Y||(se=new Y(se,this.loose)),this.compareMain(se)||this.comparePre(se)},Y.prototype.compareMain=function(se){return se instanceof Y||(se=new Y(se,this.loose)),Se(this.major,se.major)||Se(this.minor,se.minor)||Se(this.patch,se.patch)},Y.prototype.comparePre=function(se){if(se instanceof Y||(se=new Y(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var we=0;do{var ve=this.prerelease[we],$e=se.prerelease[we];if(y("prerelease compare",we,ve,$e),ve===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ve===void 0)return-1;if(ve!==$e)return Se(ve,$e)}while(++we)},Y.prototype.inc=function(se,we){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,we,ve,$e){typeof ve=="string"&&($e=ve,ve=void 0);try{return new Y(se,ve).inc(we,$e).version}catch{return null}},e.diff=function(se,we){if(ke(se,we))return null;var ve=he(se),$e=he(we);if(ve.prerelease.length||$e.prerelease.length){for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==$e[He])return He},e.compareIdentifiers=Se;var ge=/^[0-9]+$/;function Se(se,we){var ve=ge.test(se),$e=ge.test(we);return ve&&$e&&(se=+se,we=+we),ve&&!$e?-1:$e&&!ve?1:se<we?-1:se>we?1:0}function Fe(se,we,ve){return new Y(se,ve).compare(new Y(we,ve))}function ze(se,we,ve){return Fe(se,we,ve)>0}function _e(se,we,ve){return Fe(se,we,ve)<0}function ke(se,we,ve){return Fe(se,we,ve)===0}function Ie(se,we,ve){return Fe(se,we,ve)!==0}function Te(se,we,ve){return Fe(se,we,ve)>=0}function re(se,we,ve){return Fe(se,we,ve)<=0}function ae(se,we,ve,$e){var He;switch(we){case"===":typeof se=="object"&&(se=se.version),typeof ve=="object"&&(ve=ve.version),He=se===ve;break;case"!==":typeof se=="object"&&(se=se.version),typeof ve=="object"&&(ve=ve.version),He=se!==ve;break;case"":case"=":case"==":He=ke(se,ve,$e);break;case"!=":He=Ie(se,ve,$e);break;case">":He=ze(se,ve,$e);break;case">=":He=Te(se,ve,$e);break;case"<":He=_e(se,ve,$e);break;case"<=":He=re(se,ve,$e);break;default:throw new TypeError("Invalid operator: "+we)}return He}function J(se,we){if(se instanceof J){if(se.loose===we)return se;se=se.value}if(!(this instanceof J))return new J(se,we);y("comparator",se,we),this.loose=we,this.parse(se),this.semver===D?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(se,we){return Se(we,se)},e.major=function(se,we){return new Y(se,we).major},e.minor=function(se,we){return new Y(se,we).minor},e.patch=function(se,we){return new Y(se,we).patch},e.compare=Fe,e.compareLoose=function(se,we){return Fe(se,we,!0)},e.rcompare=function(se,we,ve){return Fe(we,se,ve)},e.sort=function(se,we){return se.sort(function(ve,$e){return e.compare(ve,$e,we)})},e.rsort=function(se,we){return se.sort(function(ve,$e){return e.rcompare(ve,$e,we)})},e.gt=ze,e.lt=_e,e.eq=ke,e.neq=Ie,e.gte=Te,e.lte=re,e.cmp=ae,e.Comparator=J;var D={};function B(se,we){if(se instanceof B)return se.loose===we?se:new B(se.raw,we);if(se instanceof J)return new B(se.value,we);if(!(this instanceof B))return new B(se,we);if(this.loose=we,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function H(se){return!se||se.toLowerCase()==="x"||se==="*"}function G(se,we,ve,$e,He,et,xe,tt,nt,dt,Le,ot,Q){return((we=H(ve)?"":H($e)?">="+ve+".0.0":H(He)?">="+ve+"."+$e+".0":">="+we)+" "+(tt=H(nt)?"":H(dt)?"<"+(+nt+1)+".0.0":H(Le)?"<"+nt+"."+(+dt+1)+".0":ot?"<="+nt+"."+dt+"."+Le+"-"+ot:"<="+tt)).trim()}function Z(se,we){for(var ve=0;ve<se.length;ve++)if(!se[ve].test(we))return!1;if(we.prerelease.length){for(ve=0;ve<se.length;ve++)if(y(se[ve].semver),se[ve].semver!==D&&se[ve].semver.prerelease.length>0){var $e=se[ve].semver;if($e.major===we.major&&$e.minor===we.minor&&$e.patch===we.patch)return!0}return!1}return!0}function le(se,we,ve){try{we=new B(we,ve)}catch{return!1}return we.test(se)}function be(se,we,ve,$e){var He,et,xe,tt,nt;switch(se=new Y(se,$e),we=new B(we,$e),ve){case">":He=ze,et=re,xe=_e,tt=">",nt=">=";break;case"<":He=_e,et=Te,xe=ze,tt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(le(se,we,$e))return!1;for(var dt=0;dt<we.set.length;++dt){var Le=we.set[dt],ot=null,Q=null;if(Le.forEach(function(_){_.semver===D&&(_=new J(">=0.0.0")),ot=ot||_,Q=Q||_,He(_.semver,ot.semver,$e)?ot=_:xe(_.semver,Q.semver,$e)&&(Q=_)}),ot.operator===tt||ot.operator===nt||(!Q.operator||Q.operator===tt)&&et(se,Q.semver)||Q.operator===nt&&xe(se,Q.semver))return!1}return!0}J.prototype.parse=function(se){var we=this.loose?R[V]:R[X],ve=se.match(we);if(!ve)throw new TypeError("Invalid comparator: "+se);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Y(ve[2],this.loose):this.semver=D},J.prototype.toString=function(){return this.value},J.prototype.test=function(se){return y("Comparator.test",se,this.loose),this.semver===D||(typeof se=="string"&&(se=new Y(se,this.loose)),ae(se,this.operator,this.semver,this.loose))},J.prototype.intersects=function(se,we){if(!(se instanceof J))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new B(se.value,we),le(this.value,ve,we);if(se.operator==="")return ve=new B(this.value,we),le(se.semver,ve,we);var $e=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),et=this.semver.version===se.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),tt=ae(this.semver,"<",se.semver,we)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),nt=ae(this.semver,">",se.semver,we)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return $e||He||et&&xe||tt||nt},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(se){var we=this.loose;se=se.trim(),y("range",se,we);var ve=we?R[oe]:R[fe];se=se.replace(ve,G),y("hyphen replace",se),se=se.replace(R[ee],"$1$2$3"),y("comparator trim",se,R[ee]),se=(se=(se=se.replace(R[K],"$1~")).replace(R[F],"$1^")).split(/\s+/).join(" ");var $e=we?R[V]:R[X],He=se.split(" ").map(function(et){return function(xe,tt){return y("comp",xe),xe=function(nt,dt){return nt.trim().split(/\s+/).map(function(Le){return function(ot,Q){y("caret",ot,Q);var _=Q?R[z]:R[$];return ot.replace(_,function(pe,Me,Be,je,Ye){var it;return y("caret",ot,pe,Me,Be,je,Ye),H(Me)?it="":H(Be)?it=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(je)?it=Me==="0"?">="+Me+"."+Be+".0 <"+Me+"."+(+Be+1)+".0":">="+Me+"."+Be+".0 <"+(+Me+1)+".0.0":Ye?(y("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),it=Me==="0"?Be==="0"?">="+Me+"."+Be+"."+je+Ye+" <"+Me+"."+Be+"."+(+je+1):">="+Me+"."+Be+"."+je+Ye+" <"+Me+"."+(+Be+1)+".0":">="+Me+"."+Be+"."+je+Ye+" <"+(+Me+1)+".0.0"):(y("no pr"),it=Me==="0"?Be==="0"?">="+Me+"."+Be+"."+je+" <"+Me+"."+Be+"."+(+je+1):">="+Me+"."+Be+"."+je+" <"+Me+"."+(+Be+1)+".0":">="+Me+"."+Be+"."+je+" <"+(+Me+1)+".0.0"),y("caret return",it),it})}(Le,dt)}).join(" ")}(xe,tt),y("caret",xe),xe=function(nt,dt){return nt.trim().split(/\s+/).map(function(Le){return function(ot,Q){var _=Q?R[P]:R[j];return ot.replace(_,function(pe,Me,Be,je,Ye){var it;return y("tilde",ot,pe,Me,Be,je,Ye),H(Me)?it="":H(Be)?it=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(je)?it=">="+Me+"."+Be+".0 <"+Me+"."+(+Be+1)+".0":Ye?(y("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),it=">="+Me+"."+Be+"."+je+Ye+" <"+Me+"."+(+Be+1)+".0"):it=">="+Me+"."+Be+"."+je+" <"+Me+"."+(+Be+1)+".0",y("tilde return",it),it})}(Le,dt)}).join(" ")}(xe,tt),y("tildes",xe),xe=function(nt,dt){return y("replaceXRanges",nt,dt),nt.split(/\s+/).map(function(Le){return function(ot,Q){ot=ot.trim();var _=Q?R[A]:R[p];return ot.replace(_,function(pe,Me,Be,je,Ye,it){y("xRange",ot,pe,Me,Be,je,Ye,it);var bt=H(Be),Dt=bt||H(je),kt=Dt||H(Ye);return Me==="="&&kt&&(Me=""),bt?pe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&kt?(Dt&&(je=0),kt&&(Ye=0),Me===">"?(Me=">=",Dt?(Be=+Be+1,je=0,Ye=0):kt&&(je=+je+1,Ye=0)):Me==="<="&&(Me="<",Dt?Be=+Be+1:je=+je+1),pe=Me+Be+"."+je+"."+Ye):Dt?pe=">="+Be+".0.0 <"+(+Be+1)+".0.0":kt&&(pe=">="+Be+"."+je+".0 <"+Be+"."+(+je+1)+".0"),y("xRange return",pe),pe})}(Le,dt)}).join(" ")}(xe,tt),y("xrange",xe),xe=function(nt,dt){return y("replaceStars",nt,dt),nt.trim().replace(R[ue],"")}(xe,tt),y("stars",xe),xe}(et,we)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(et){return!!et.match($e)})),He=He.map(function(et){return new J(et,we)})},B.prototype.intersects=function(se,we){if(!(se instanceof B))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function($e){return se.set.some(function(He){return He.every(function(et){return $e.intersects(et,we)})})})})},e.toComparators=function(se,we){return new B(se,we).set.map(function(ve){return ve.map(function($e){return $e.value}).join(" ").trim().split(" ")})},B.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new Y(se,this.loose));for(var we=0;we<this.set.length;we++)if(Z(this.set[we],se))return!0;return!1},e.satisfies=le,e.maxSatisfying=function(se,we,ve){var $e=null,He=null;try{var et=new B(we,ve)}catch{return null}return se.forEach(function(xe){et.test(xe)&&($e&&He.compare(xe)!==-1||(He=new Y($e=xe,ve)))}),$e},e.minSatisfying=function(se,we,ve){var $e=null,He=null;try{var et=new B(we,ve)}catch{return null}return se.forEach(function(xe){et.test(xe)&&($e&&He.compare(xe)!==1||(He=new Y($e=xe,ve)))}),$e},e.validRange=function(se,we){try{return new B(se,we).range||"*"}catch{return null}},e.ltr=function(se,we,ve){return be(se,we,"<",ve)},e.gtr=function(se,we,ve){return be(se,we,">",ve)},e.outside=be,e.prerelease=function(se,we){var ve=he(se,we);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(se,we,ve){return se=new B(se,ve),we=new B(we,ve),se.intersects(we)},e.coerce=function(se){if(se instanceof Y)return se;if(typeof se!="string")return null;var we=se.match(R[L]);return we==null?null:he((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,i(1))},function(te,e){var i,k,y=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function R(o){if(i===setTimeout)return setTimeout(o,0);if((i===M||!i)&&setTimeout)return i=setTimeout,setTimeout(o,0);try{return i(o,0)}catch{try{return i.call(null,o,0)}catch{return i.call(this,o,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:M}catch{i=M}try{k=typeof clearTimeout=="function"?clearTimeout:C}catch{k=C}})();var w,T=[],O=!1,I=-1;function m(){O&&w&&(O=!1,w.length?T=w.concat(T):I=-1,T.length&&v())}function v(){if(!O){var o=R(m);O=!0;for(var u=T.length;u;){for(w=T,T=[];++I<u;)w&&w[I].run();I=-1,u=T.length}w=null,O=!1,function(g){if(k===clearTimeout)return clearTimeout(g);if((k===C||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(g);try{k(g)}catch{try{return k.call(null,g)}catch{return k.call(this,g)}}}(o)}}function f(o,u){this.fun=o,this.array=u}function t(){}y.nextTick=function(o){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];T.push(new f(o,u)),T.length!==1||O||R(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=t,y.addListener=t,y.once=t,y.off=t,y.removeListener=t,y.removeAllListeners=t,y.emit=t,y.prependListener=t,y.prependOnceListener=t,y.listeners=function(o){return[]},y.binding=function(o){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(o){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(De[110],Ce([1,0,11,7]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(b){const S=b;return S?typeof S.read=="function":!1}e.isReadable=y;function M(b){const S=b;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=M;function C(b){const S=b;return S?M(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(b,S){return new w(b,S)}e.newWriteableStream=R;class w{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,i.onUnexpectedError)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let r;switch(S){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const a=r.indexOf(s);a>=0&&r.splice(a,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function T(b,S){const s=[];let r;for(;(r=b.read())!==null;)s.push(r);return S(s)}e.consumeReadable=T;function O(b,S,s){const r=[];let a;for(;(a=b.read())!==null&&r.length<s;)r.push(a);return a===null&&r.length>0?S(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a<"u"){const h=a;return a=void 0,h}return b.read()}}}e.peekReadable=O;function I(b,S){return new Promise((s,r)=>{const a=[];m(b,{onData:h=>{S&&a.push(h)},onError:h=>{S?r(h):s(void 0)},onEnd:()=>{s(S?S(a):void 0)}})})}e.consumeStream=I;function m(b,S){let s=!1;return b.on("error",r=>{s||S.onError(r)}),b.on("end",()=>{s||S.onEnd()}),b.on("data",r=>{s||S.onData(r)}),(0,k.toDisposable)(()=>s=!0)}e.listenStream=m;function v(b,S){return new Promise((s,r)=>{const a=new k.DisposableStore,h=[],c=l=>{if(h.push(l),h.length>S)return a.dispose(),b.pause(),s({stream:b,buffer:h,ended:!1})},d=l=>r(l),n=()=>s({stream:b,buffer:h,ended:!0});a.add((0,k.toDisposable)(()=>b.removeListener("error",d))),b.on("error",d),a.add((0,k.toDisposable)(()=>b.removeListener("end",n))),b.on("end",n),a.add((0,k.toDisposable)(()=>b.removeListener("data",c))),b.on("data",c)})}e.peekStream=v;function f(b,S){const s=R(S);return s.end(b),s}e.toStream=f;function t(){const b=R(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=t;function o(b){let S=!1;return{read:()=>S?null:(S=!0,b)}}e.toReadable=o;function u(b,S,s){const r=R(s);return m(b,{onData:a=>r.write(S.data(a)),onError:a=>r.error(S.error?S.error(a):a),onEnd:()=>r.end()}),r}e.transform=u;function g(b,S,s){let r=!1;return{read:()=>{const a=S.read();return r?a:(r=!0,a!==null?s([b,a]):b)}}}e.prefixedReadable=g;function E(b,S,s){let r=!1;const a=R(s);return m(S,{onData:h=>r?a.write(h):(r=!0,a.write(s([b,h]))),onError:h=>a.error(h),onEnd:()=>{r||(r=!0,a.write(b)),a.end()}}),a}e.prefixedStream=E}),define(De[24],Ce([1,0,110]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let y,M;class C{static alloc(l){return k?new C(Buffer.allocUnsafe(l)):new C(new Uint8Array(l))}static wrap(l){return k&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new C(l)}static fromString(l,p){return!(p?.dontUseNodeBuffer||!1)&&k?new C(Buffer.from(l)):(y||(y=new TextEncoder),new C(y.encode(l)))}static fromByteArray(l){const p=C.alloc(l.length);for(let A=0,L=l.length;A<L;A++)p.buffer[A]=l[A];return p}static concat(l,p){if(typeof p>"u"){p=0;for(let q=0,K=l.length;q<K;q++)p+=l[q].byteLength}const A=C.alloc(p);let L=0;for(let q=0,K=l.length;q<K;q++){const j=l[q];A.set(j,L),L+=j.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=C.alloc(this.byteLength);return l.set(this),l}toString(){return k?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(l,p){return new C(this.buffer.subarray(l,p))}set(l,p){if(l instanceof C)this.buffer.set(l.buffer,p);else if(l instanceof Uint8Array)this.buffer.set(l,p);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),p);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return T(this.buffer,l)}writeUInt32BE(l,p){O(this.buffer,l,p)}readUInt32LE(l){return I(this.buffer,l)}writeUInt32LE(l,p){m(this.buffer,l,p)}readUInt8(l){return v(this.buffer,l)}writeUInt8(l,p){f(this.buffer,l,p)}}e.VSBuffer=C;function R(n,l){return n[l+0]<<0>>>0|n[l+1]<<8>>>0}e.readUInt16LE=R;function w(n,l,p){n[p+0]=l&255,l=l>>>8,n[p+1]=l&255}e.writeUInt16LE=w;function T(n,l){return n[l]*2**24+n[l+1]*2**16+n[l+2]*2**8+n[l+3]}e.readUInt32BE=T;function O(n,l,p){n[p+3]=l,l=l>>>8,n[p+2]=l,l=l>>>8,n[p+1]=l,l=l>>>8,n[p]=l}e.writeUInt32BE=O;function I(n,l){return n[l+0]<<0>>>0|n[l+1]<<8>>>0|n[l+2]<<16>>>0|n[l+3]<<24>>>0}e.readUInt32LE=I;function m(n,l,p){n[p+0]=l&255,l=l>>>8,n[p+1]=l&255,l=l>>>8,n[p+2]=l&255,l=l>>>8,n[p+3]=l&255}e.writeUInt32LE=m;function v(n,l){return n[l]}e.readUInt8=v;function f(n,l,p){n[p]=l}e.writeUInt8=f;function t(n){return i.consumeReadable(n,l=>C.concat(l))}e.readableToBuffer=t;function o(n){return i.toReadable(n)}e.bufferToReadable=o;function u(n){return i.consumeStream(n,l=>C.concat(l))}e.streamToBuffer=u;async function g(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await u(n.stream)])}e.bufferedStreamToBuffer=g;function E(n){return i.toStream(n,l=>C.concat(l))}e.bufferToStream=E;function b(n){return i.transform(n,{data:l=>typeof l=="string"?C.fromString(l):C.wrap(l)},l=>C.concat(l))}e.streamToBufferReadableStream=b;function S(n){return i.newWriteableStream(l=>C.concat(l),n)}e.newWriteableBufferStream=S;function s(n,l){return i.prefixedReadable(n,l,p=>C.concat(p))}e.prefixedBufferReadable=s;function r(n,l){return i.prefixedStream(n,l,p=>C.concat(p))}e.prefixedBufferStream=r;function a(n){let l=0,p=0,A=0;const L=new Uint8Array(Math.floor(n.length/4*3)),q=j=>{switch(p){case 3:L[A++]=l|j,p=0;break;case 2:L[A++]=l|j>>>2,l=j<<6,p=3;break;case 1:L[A++]=l|j>>>4,l=j<<4,p=2;break;default:l=j<<2,p=1}};for(let j=0;j<n.length;j++){const P=n.charCodeAt(j);if(P>=65&&P<=90)q(P-65);else if(P>=97&&P<=122)q(P-97+26);else if(P>=48&&P<=57)q(P-48+52);else if(P===43||P===45)q(62);else if(P===47||P===95)q(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${n[j]}`)}}const K=A;for(;p>0;)q(0);return C.wrap(L).slice(0,K)}e.decodeBase64=a;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:n},l=!0,p=!1){const A=p?c:h;let L="";const q=n.byteLength%3;let K=0;for(;K<n.byteLength-q;K+=3){const j=n[K+0],P=n[K+1],N=n[K+2];L+=A[j>>>2],L+=A[(j<<4|P>>>4)&63],L+=A[(P<<2|N>>>6)&63],L+=A[N&63]}if(q===1){const j=n[K+0];L+=A[j>>>2],L+=A[j<<4&63],l&&(L+="==")}else if(q===2){const j=n[K+0],P=n[K+1];L+=A[j>>>2],L+=A[(j<<4|P>>>4)&63],L+=A[P<<2&63],l&&(L+="=")}return L}e.encodeBase64=d}),define(De[34],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(y){return i.test(y)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(R){for(let w=0;w<R.length;w++)R[w]=Math.floor(Math.random()*256);return R};const M=new Uint8Array(16),C=[];for(let R=0;R<256;R++)C.push(R.toString(16).padStart(2,"0"));return function(){y(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let w=0,T="";return T+=C[M[w++]],T+=C[M[w++]],T+=C[M[w++]],T+=C[M[w++]],T+="-",T+=C[M[w++]],T+=C[M[w++]],T+="-",T+=C[M[w++]],T+=C[M[w++]],T+="-",T+=C[M[w++]],T+=C[M[w++]],T+="-",T+=C[M[w++]],T+=C[M[w++]],T+=C[M[w++]],T+=C[M[w++]],T+=C[M[w++]],T+=C[M[w++]],T}}()}),define(De[111],Ce([1,0,16,34]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(R){return{id:(0,k.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=y;function M(R,w,T){return{id:(0,k.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:w,data:T}),value:void 0}}e.createFileDataTransferItem=M;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(w){return this.a.has(this.b(w))}get(w){return this.a.get(this.b(w))?.[0]}append(w,T){const O=this.a.get(w);O?O.push(T):this.a.set(this.b(w),[T])}replace(w,T){this.a.set(this.b(w),[T])}delete(w){this.a.delete(this.b(w))}*entries(){for(const[w,T]of this.a.entries())for(const O of T)yield[w,O]}values(){return Array.from(this.a.values()).flat()}forEach(w){for(const[T,O]of this.entries())w(O,T)}b(w){return w.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:R=>(0,i.distinct)(R.map(w=>w.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(w=>!w.startsWith("#"))})}),define(De[112],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[113],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class k{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let w=0,T=R.notIn.length;w<T;w++)switch(R.notIn[w]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,w){if(R.getTokenCount()===0)return!0;const T=R.findTokenIndexAtOffset(w-2),O=R.getStandardTokenType(T);return this.isOK(O)}g(R,w){for(let T=R;T<=w;T++){const O=String.fromCharCode(T);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=k;class y{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of R)M(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),M(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),M(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),M(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&M(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=y;function M(C,R,w){C.has(R)?C.get(R).push(w):C.set(R,[w])}}),define(De[114],Ce([17,18]),function(te,e){return te.create("vs/base/common/date",e)}),define(De[115],Ce([1,0,114]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,y=k*60,M=y*24,C=M*7,R=M*30,w=M*365;function T(I,m,v){typeof I!="number"&&(I=I.getTime());const f=Math.round((new Date().getTime()-I)/1e3);if(f<-30)return(0,i.localize)(0,null,T(new Date().getTime()+f*1e3,!1));if(f<30)return(0,i.localize)(1,null);let t;return f<k?(t=f,m?t===1?v?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):v?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?v?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):v?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):f<y?(t=Math.floor(f/k),m?t===1?v?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):v?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?v?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):v?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):f<M?(t=Math.floor(f/y),m?t===1?v?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):v?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?v?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):v?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):f<C?(t=Math.floor(f/M),m?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):f<R?(t=Math.floor(f/C),m?t===1?v?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):v?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?v?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):v?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):f<w?(t=Math.floor(f/R),m?t===1?v?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):v?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?v?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):v?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(f/w),m?t===1?v?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):v?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?v?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):v?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=T;function O(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(De[116],Ce([17,18]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(De[45],Ce([1,0,16,9,116]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(I,m){return m&&(I.stack||I.stacktrace)?y.localize(0,null,R(I),C(I.stack)||C(I.stacktrace)):R(I)}function C(I){return Array.isArray(I)?I.join(`
`):I}function R(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?y.localize(1,null,I.message):I.message||y.localize(2,null)}function w(I=null,m=!1){if(!I)return y.localize(3,null);if(Array.isArray(I)){const v=i.coalesce(I),f=w(v[0],m);return v.length>1?y.localize(4,null,f,v.length):f}if(k.isString(I))return I;if(I.detail){const v=I.detail;if(v.error)return M(v.error,m);if(v.exception)return M(v.exception,m)}return I.stack?M(I,m):I.message?I.message:y.localize(5,null)}e.toErrorMessage=w;function T(I){const m=I;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=T;function O(I,m){let v;return typeof I=="string"?v=new Error(I):v=I,v.actions=m,v}e.createErrorWithActions=O}),define(De[60],Ce([1,0,19]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const I=(0,i.extname)(O),m=k[I.toLowerCase()];return m!==void 0?m:C(O)}e.getMediaOrTextMime=M;function C(O){const I=(0,i.extname)(O);return y[I.toLowerCase()]}e.getMediaMime=C;function R(O){for(const I in y)if(y[I]===O)return I}e.getExtensionForMimeType=R;const w=/^(.+)\/(.+?)(;.+)?$/;function T(O,I){const m=w.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:I?void 0:O}e.normalizeMimeType=T}),define(De[117],Ce([1,0,4,7]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const y=C=>({onDidChange:i.Event.None,value:C});e.staticObservableValue=y;class M extends k.Disposable{get value(){return this.b}set value(R){R!==this.b&&(this.b=R,this.a.fire(R))}constructor(R){super(),this.b=R,this.a=this.B(new i.Emitter),this.onDidChange=this.a.event}}e.MutableObservableValue=M}),define(De[39],Ce([1,0,19,21,10,9]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function R(c){return c.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=R;function w(c){return c.indexOf("/")===-1&&(c=R(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=w;function T(c,d=i.posix.sep){if(!c)return"";const n=c.length,l=c.charCodeAt(0);if(C(l)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let A=3;const L=A;for(;A<n&&!C(c.charCodeAt(A));A++);if(L!==A&&!C(c.charCodeAt(A+1))){for(A+=1;A<n;A++)if(C(c.charCodeAt(A)))return c.slice(0,A+1).replace(/[\\/]/g,d)}}return d}else if(u(l)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+d:c.slice(0,2);let p=c.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(C(c.charCodeAt(p)))return c.slice(0,p+1)}return""}e.getRoot=T;function O(c){if(!k.isWindows||!c||c.length<5)return!1;let d=c.charCodeAt(0);if(d!==92||(d=c.charCodeAt(1),d!==92))return!1;let n=2;const l=n;for(;n<c.length&&(d=c.charCodeAt(n),d!==92);n++);return!(l===n||(d=c.charCodeAt(n+1),isNaN(d)||d===92))}e.isUNC=O;const I=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(c,d=k.isWindows){const n=d?I:m;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||d&&v.test(c)||c==="."||c===".."||d&&c[c.length-1]==="."||d&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=f;function t(c,d,n){const l=c===d;return!n||l?l:!c||!d?!1:(0,y.equalsIgnoreCase)(c,d)}e.isEqual=t;function o(c,d,n,l=i.sep){if(c===d)return!0;if(!c||!d||d.length>c.length)return!1;if(n){if(!(0,y.startsWithIgnoreCase)(c,d))return!1;if(d.length===c.length)return!0;let A=d.length;return d.charAt(d.length-1)===l&&A--,c.charAt(A)===l}return d.charAt(d.length-1)!==l&&(d+=l),c.indexOf(d)===0}e.isEqualOrParent=o;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=u;function g(c,d){return k.isWindows&&c.endsWith(":")&&(c+=i.sep),(0,i.isAbsolute)(c)||(c=(0,i.join)(d,c)),c=(0,i.normalize)(c),k.isWindows?(c=(0,y.rtrim)(c,i.sep),c.endsWith(":")&&(c+=i.sep)):(c=(0,y.rtrim)(c,i.sep),c||(c=i.sep)),c}e.sanitizeFilePath=g;function E(c){const d=(0,i.normalize)(c);return k.isWindows?c.length>3?!1:b(d)&&(c.length===2||d.charCodeAt(2)===92):d===i.posix.sep}e.isRootOrDriveLetter=E;function b(c,d=k.isWindows){return d?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function S(c){return b(c)?c[0]:void 0}e.getDriveLetter=S;function s(c,d,n){return d.length>c.length?-1:c===d?0:(n&&(c=c.toLowerCase(),d=d.toLowerCase()),c.indexOf(d))}e.indexOfPath=s;function r(c){const d=c.split(":");let n,l,p;for(const A of d){const L=Number(A);(0,M.isNumber)(L)?l===void 0?l=L:p===void 0&&(p=L):n=n?[n,A].join(":"):A}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:l!==void 0?l:void 0,column:p!==void 0?p:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function h(c,d,n=8){let l="";for(let A=0;A<n;A++)l+=a.charAt(Math.floor(Math.random()*a.length));let p;return d?p=`${d}-${l}`:p=l,c?(0,i.join)(c,p):p}e.randomPath=h}),define(De[118],Ce([1,0,28,10]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...J){return function(D,B){for(let H=0,G=J.length;H<G;H++){const Z=J[H](D,B);if(Z)return Z}return null}}e.or=y,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(J,D,B){if(!B||B.length<D.length)return null;let H;return J?H=k.startsWithIgnoreCase(B,D):H=B.indexOf(D)===0,H?D.length>0?[{start:0,end:D.length}]:[]:null}function C(J,D){const B=D.toLowerCase().indexOf(J.toLowerCase());return B===-1?null:[{start:B,end:B+J.length}]}e.matchesContiguousSubString=C;function R(J,D){return w(J.toLowerCase(),D.toLowerCase(),0,0)}e.matchesSubString=R;function w(J,D,B,H){if(B===J.length)return[];if(H===D.length)return null;if(J[B]===D[H]){let G=null;return(G=w(J,D,B+1,H+1))?u({start:H,end:H+1},G):null}return w(J,D,B,H+1)}function T(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function I(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>v.add(J.charCodeAt(0)));function f(J){return m(J)||v.has(J)}function t(J,D){return J===D||f(J)&&f(D)}function o(J){return T(J)||O(J)||I(J)}function u(J,D){return D.length===0?D=[J]:J.end===D[0].start?D[0].start=J.start:D.unshift(J),D}function g(J,D){for(let B=D;B<J.length;B++){const H=J.charCodeAt(B);if(O(H)||I(H)||B>0&&!o(J.charCodeAt(B-1)))return B}return J.length}function E(J,D,B,H){if(B===J.length)return[];if(H===D.length)return null;if(J[B]!==D[H].toLowerCase())return null;{let G=null,Z=H+1;for(G=E(J,D,B+1,H+1);!G&&(Z=g(D,Z))<D.length;)G=E(J,D,B+1,Z),Z++;return G===null?null:u({start:H,end:H+1},G)}}function b(J){let D=0,B=0,H=0,G=0,Z=0;for(let ve=0;ve<J.length;ve++)Z=J.charCodeAt(ve),O(Z)&&D++,T(Z)&&B++,o(Z)&&H++,I(Z)&&G++;const le=D/J.length,be=B/J.length,se=H/J.length,we=G/J.length;return{upperPercent:le,lowerPercent:be,alphaPercent:se,numericPercent:we}}function S(J){const{upperPercent:D,lowerPercent:B}=J;return B===0&&D>.6}function s(J){const{upperPercent:D,lowerPercent:B,alphaPercent:H,numericPercent:G}=J;return B>.2&&D<.8&&H>.6&&G<.2}function r(J){let D=0,B=0,H=0,G=0;for(let Z=0;Z<J.length;Z++)H=J.charCodeAt(Z),O(H)&&D++,T(H)&&B++,m(H)&&G++;return(D===0||B===0)&&G===0?J.length<=30:D<=5}function a(J,D){if(!D||(D=D.trim(),D.length===0)||!r(J)||D.length>60)return null;const B=b(D);if(!s(B)){if(!S(B))return null;D=D.toLowerCase()}let H=null,G=0;for(J=J.toLowerCase();G<D.length&&(H=E(J,D,0,G))===null;)G=g(D,G+1);return H}e.matchesCamelCase=a;function h(J,D,B=!1){if(!D||D.length===0)return null;let H=null,G=0;for(J=J.toLowerCase(),D=D.toLowerCase();G<D.length&&(H=c(J,D,0,G,B))===null;)G=d(D,G+1);return H}e.matchesWords=h;function c(J,D,B,H,G){if(B===J.length)return[];if(H===D.length)return null;if(t(J.charCodeAt(B),D.charCodeAt(H))){let Z=null,le=H+1;if(Z=c(J,D,B+1,H+1,G),!G)for(;!Z&&(le=d(D,le))<D.length;)Z=c(J,D,B+1,le,G),le++;return Z?J.charCodeAt(B)!==D.charCodeAt(H)?Z:u({start:H,end:H+1},Z):null}else return null}function d(J,D){for(let B=D;B<J.length;B++)if(f(J.charCodeAt(B))||B>0&&f(J.charCodeAt(B-1)))return B;return J.length}const n=y(e.matchesPrefix,a,C),l=y(e.matchesPrefix,a,R),p=new i.LRUCache(1e4);function A(J,D,B=!1){if(typeof J!="string"||typeof D!="string")return null;let H=p.get(J);H||(H=new RegExp(k.convertSimple2RegExpPattern(J),"i"),p.set(J,H));const G=H.exec(D);return G?[{start:G.index,end:G.index+G[0].length}]:B?l(J,D):n(J,D)}e.matchesFuzzy=A;function L(J,D){const B=ze(J,J.toLowerCase(),0,D,D.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?K(B):null}e.matchesFuzzy2=L;function q(J,D,B,H,G,Z){const le=Math.min(13,J.length);for(;B<le;B++){const be=ze(J,D,B,H,G,Z,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,Z]}e.anyScore=q;function K(J){if(typeof J>"u")return[];const D=[],B=J[1];for(let H=J.length-1;H>1;H--){const G=J[H]+B,Z=D[D.length-1];Z&&Z.end===G?Z.end=G+1:D.push({start:G,end:G+1})}return D}e.createMatches=K;const j=128;function P(){const J=[],D=[];for(let B=0;B<=j;B++)D[B]=0;for(let B=0;B<=j;B++)J.push(D.slice(0));return J}function N(J){const D=[];for(let B=0;B<=J;B++)D[B]=0;return D}const F=N(2*j),$=N(2*j),z=P(),V=P(),X=P(),ee=!1;function fe(J,D,B,H,G){function Z(be,se,we=" "){for(;be.length<se;)be=we+be;return be}let le=` |   |${H.split("").map(be=>Z(be,3)).join("|")}
`;for(let be=0;be<=B;be++)be===0?le+=" |":le+=`${D[be-1]}|`,le+=J[be].slice(0,G+1).map(se=>Z(se.toString(),3)).join("|")+`
`;return le}function oe(J,D,B,H){J=J.substr(D),B=B.substr(H),console.log(fe(V,J,J.length,B,B.length)),console.log(fe(X,J,J.length,B,B.length)),console.log(fe(z,J,J.length,B,B.length))}function ue(J,D){if(D<0||D>=J.length)return!1;const B=J.codePointAt(D);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(B)}}function ce(J,D){if(D<0||D>=J.length)return!1;switch(J.charCodeAt(D)){case 32:case 9:return!0;default:return!1}}function he(J,D,B){return D[J]!==B[J]}function Y(J,D,B,H,G,Z,le=!1){for(;D<B&&G<Z;)J[D]===H[G]&&(le&&(F[D]=G),D+=1),G+=1;return D===B}e.isPatternInWord=Y;var ge;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Se;(function(J){J.Default=[-100,0];function D(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}J.isDefault=D})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(D,B){this.firstMatchCanBeWeak=D,this.boostFullMatch=B}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ze(J,D,B,H,G,Z,le=Fe.default){const be=J.length>j?j:J.length,se=H.length>j?j:H.length;if(B>=be||Z>=se||be-B>se-Z||!Y(D,B,be,G,Z,se,!0))return;_e(be,se,B,Z,D,G);let we=1,ve=1,$e=B,He=Z;const et=[!1];for(we=1,$e=B;$e<be;we++,$e++){const Le=F[$e],ot=$[$e],Q=$e+1<be?$[$e+1]:se;for(ve=Le-Z+1,He=Le;He<Q;ve++,He++){let _=Number.MIN_SAFE_INTEGER,pe=!1;He<=ot&&(_=ke(J,D,$e,B,H,G,He,se,Z,z[we-1][ve-1]===0,et));let Me=0;_!==Number.MAX_SAFE_INTEGER&&(pe=!0,Me=_+V[we-1][ve-1]);const Be=He>Le,je=Be?V[we][ve-1]+(z[we][ve-1]>0?-5:0):0,Ye=He>Le+1&&z[we][ve-1]>0,it=Ye?V[we][ve-2]+(z[we][ve-2]>0?-5:0):0;if(Ye&&(!Be||it>=je)&&(!pe||it>=Me))V[we][ve]=it,X[we][ve]=3,z[we][ve]=0;else if(Be&&(!pe||je>=Me))V[we][ve]=je,X[we][ve]=2,z[we][ve]=0;else if(pe)V[we][ve]=Me,X[we][ve]=1,z[we][ve]=z[we-1][ve-1]+1;else throw new Error("not possible")}}if(ee&&oe(J,B,H,Z),!et[0]&&!le.firstMatchCanBeWeak)return;we--,ve--;const xe=[V[we][ve],Z];let tt=0,nt=0;for(;we>=1;){let Le=ve;do{const ot=X[we][Le];if(ot===3)Le=Le-2;else if(ot===2)Le=Le-1;else break}while(Le>=1);tt>1&&D[B+we-1]===G[Z+ve-1]&&!he(Le+Z-1,H,G)&&tt+1>z[we][Le]&&(Le=ve),Le===ve?tt++:tt=1,nt||(nt=Le),we--,ve=Le-1,xe.push(ve)}se===be&&le.boostFullMatch&&(xe[0]+=2);const dt=nt-be;return xe[0]-=dt,xe}e.fuzzyScore=ze;function _e(J,D,B,H,G,Z){let le=J-1,be=D-1;for(;le>=B&&be>=H;)G[le]===Z[be]&&($[le]=be,le--),be--}function ke(J,D,B,H,G,Z,le,be,se,we,ve){if(D[B]!==Z[le])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return le===B-H?$e=J[B]===G[le]?7:5:he(le,G,Z)&&(le===0||!he(le-1,G,Z))?($e=J[B]===G[le]?7:5,He=!0):ue(Z,le)&&(le===0||!ue(Z,le-1))?$e=5:(ue(Z,le-1)||ce(Z,le-1))&&($e=5,He=!0),$e>1&&B===H&&(ve[0]=!0),He||(He=he(le,G,Z)||ue(Z,le-1)||ce(Z,le-1)),B===H?le>se&&($e-=He?3:5):we?$e+=He?2:0:$e+=He?0:1,le+1===be&&($e-=He?3:5),$e}function Ie(J,D,B,H,G,Z,le){return re(J,D,B,H,G,Z,!0,le)}e.fuzzyScoreGracefulAggressive=Ie;function Te(J,D,B,H,G,Z,le){return re(J,D,B,H,G,Z,!1,le)}e.fuzzyScoreGraceful=Te;function re(J,D,B,H,G,Z,le,be){let se=ze(J,D,B,H,G,Z,be);if(se&&!le)return se;if(J.length>=3){const we=Math.min(7,J.length-1);for(let ve=B+1;ve<we;ve++){const $e=ae(J,ve);if($e){const He=ze($e,$e.toLowerCase(),B,H,G,Z,be);He&&(He[0]-=3,(!se||He[0]>se[0])&&(se=He))}}}return se}function ae(J,D){if(D+1>=J.length)return;const B=J[D],H=J[D+1];if(B!==H)return J.slice(0,D)+H+B+J.slice(D+2)}}),define(De[119],Ce([1,0,120,118,10]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",C=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(i.CSSIcon.iconNameCharacter),w=new RegExp(`(\\\\)?${C.source}`,"g");function T(u){return u.replace(w,(g,E)=>E?g:`\\${g}`)}e.escapeIcons=T;const O=new RegExp(`\\\\${C.source}`,"g");function I(u){return u.replace(O,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=I;const m=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(u){return u.indexOf(M)===-1?u:u.replace(m,(g,E,b,S)=>b?g:E||S||"")}e.stripIcons=v;function f(u){const g=u.indexOf(M);return g===-1?{text:u}:t(u,g)}e.parseLabelWithIcons=f;function t(u,g){const E=[];let b="";function S(l){if(l){b+=l;for(const p of l)E.push(a)}}let s=-1,r="",a=0,h,c,d=g;const n=u.length;for(S(u.substr(0,g));d<n;)h=u[d],c=u[d+1],h===M[0]&&c===M[1]?(s=d,S(r),r=M,d++):h===")"&&s!==-1?(a+=d-s+1,s=-1,r=""):s!==-1?R.test(h)?r+=h:(S(r),s=-1,r=""):S(h),d++;return S(r),{text:b,iconOffsets:E}}function o(u,g,E=!1){const{text:b,iconOffsets:S}=g;if(!S||S.length===0)return(0,k.matchesFuzzy)(u,b,E);const s=(0,y.ltrim)(b," "),r=b.length-s.length,a=(0,k.matchesFuzzy)(u,s,E);if(a)for(const h of a){const c=S[h.start+r]+r;h.start+=c,h.end+=c}return a}e.matchesFuzzyIconAware=o}),define(De[29],Ce([1,0,10]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(k||(k={})),function(y){const M="error",C="warning",R="warn",w="info",T="ignore";function O(m){return m?i.equalsIgnoreCase(M,m)?y.Error:i.equalsIgnoreCase(C,m)||i.equalsIgnoreCase(R,m)?y.Warning:i.equalsIgnoreCase(w,m)?y.Info:y.Ignore:y.Ignore}y.fromValue=O;function I(m){switch(m){case y.Error:return M;case y.Warning:return C;case y.Info:return w;default:return T}}y.toString=I}(k||(k={})),e.default=k}),define(De[46],Ce([1,0,16,10]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const f=v.charCodeAt(0),t=this.b.charCodeAt(this.c);return f-t}value(){return this.b[this.c]}}e.StringIterator=y;class M{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,k.compareSubstring)(v,this.b,0,v.length,this.c,this.d):(0,k.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class C{constructor(v=!0,f=!0){this.f=v,this.g=f}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let f=v.length-1;f>=0;f--,this.c--){const t=this.b.charCodeAt(f);if(!(t===47||this.f&&t===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,k.compareSubstring)(v,this.b,0,v.length,this.d,this.e):(0,k.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class w{constructor(v,f){this.f=v,this.g=f,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,k.compareIgnoreCase)(v,this.c.scheme);if(this.d[this.e]===2)return(0,k.compareIgnoreCase)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,k.compare)(v,this.c.query);if(this.d[this.e]===5)return(0,k.compare)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class T{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(O||(O={}));class I{static forUris(v=()=>!1,f=()=>!1){return new I(new w(v,f))}static forPaths(v=!1){return new I(new C(void 0,!v))}static forStrings(){return new I(new y)}static forConfigKeys(){return new I(new M)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,f){if(f){const t=f.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o,v)}else{const t=v.slice(0);(0,i.shuffle)(t);for(const o of t)this.set(o[0],o[1])}}set(v,f){const t=this.b.reset(v);let o;this.c||(this.c=new T,this.c.segment=t.value());const u=[];for(o=this.c;;){const E=t.cmp(o.segment);if(E>0)o.left||(o.left=new T,o.left.segment=t.value()),u.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new T,o.right.segment=t.value()),u.push([1,o]),o=o.right;else if(t.hasNext())t.next(),o.mid||(o.mid=new T,o.mid.segment=t.value()),u.push([0,o]),o=o.mid;else break}const g=o.value;o.value=f,o.key=v;for(let E=u.length-1;E>=0;E--){const b=u[E][1];b.updateHeight();const S=b.balanceFactor();if(S<-1||S>1){const s=u[E][0],r=u[E+1][0];if(s===1&&r===1)u[E][1]=b.rotateLeft();else if(s===-1&&r===-1)u[E][1]=b.rotateRight();else if(s===1&&r===-1)b.right=u[E+1][1]=u[E+1][1].rotateRight(),u[E][1]=b.rotateLeft();else if(s===-1&&r===1)b.left=u[E+1][1]=u[E+1][1].rotateLeft(),u[E][1]=b.rotateRight();else throw new Error;if(E>0)switch(u[E-1][0]){case-1:u[E-1][1].left=u[E][1];break;case 1:u[E-1][1].right=u[E][1];break;case 0:u[E-1][1].mid=u[E][1];break}else this.c=u[0][1]}}return g}get(v){return this.d(v)?.value}d(v){const f=this.b.reset(v);let t=this.c;for(;t;){const o=f.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else break}return t}has(v){const f=this.d(v);return!(f?.value===void 0&&f?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,f){const t=this.b.reset(v),o=[];let u=this.c;for(;u;){const g=t.cmp(u.segment);if(g>0)o.push([-1,u]),u=u.left;else if(g<0)o.push([1,u]),u=u.right;else if(t.hasNext())t.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:E,value:b,segment:S}=g;this.e(g.key,!1),u.key=E,u.value=b,u.segment=S}}else{const g=u.left??u.right;if(o.length>0){const[E,b]=o[o.length-1];switch(E){case-1:b.left=g;break;case 0:b.mid=g;break;case 1:b.right=g;break}}else this.c=g}for(let g=o.length-1;g>=0;g--){const E=o[g][1];E.updateHeight();const b=E.balanceFactor();if(b>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),o[g][1]=E.rotateLeft()):b<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),o[g][1]=E.rotateRight()),g>0)switch(o[g-1][0]){case-1:o[g-1][1].left=o[g][1];break;case 1:o[g-1][1].right=o[g][1];break;case 0:o[g-1][1].mid=o[g][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const f=this.b.reset(v);let t=this.c,o;for(;t;){const u=f.cmp(t.segment);if(u>0)t=t.left;else if(u<0)t=t.right;else if(f.hasNext())f.next(),o=t.value||o,t=t.mid;else break}return t&&t.value||o}findSuperstr(v){const f=this.b.reset(v);let t=this.c;for(;t;){const o=f.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.g(t.mid):void 0}}forEach(v){for(const[f,t]of this)v(t,f)}*[Symbol.iterator](){yield*this.g(this.c)}g(v){const f=[];return this.h(v,f),f[Symbol.iterator]()}h(v,f){!v||(v.left&&this.h(v.left,f),v.value&&f.push([v.key,v.value]),v.mid&&this.h(v.mid,f),v.right&&this.h(v.right,f))}_isBalanced(){const v=f=>{if(!f)return!0;const t=f.balanceFactor();return t<-1||t>1?!1:v(f.left)&&v(f.right)};return v(this.c)}}e.TernarySearchTree=I}),define(De[80],Ce([1,0,24,10,2]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(T){return JSON.stringify(T,R)}e.stringify=M;function C(T){let O=JSON.parse(T);return O=w(O),O}e.parse=C;function R(T,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,k.regExpFlags)(O)}:O}function w(T,O=0){if(!T||O>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return y.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 16:return new Date(T.source)}if(T instanceof i.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let I=0;I<T.length;++I)T[I]=w(T[I],O+1);else for(const I in T)Object.hasOwnProperty.call(T,I)&&(T[I]=w(T[I],O+1))}return T}e.revive=w}),define(De[13],Ce([1,0,21,2]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${y.vscodeRemoteResource}`}set(T,O,I){this.a[T]=O,this.b[T]=I}setConnectionToken(T,O){this.c[T]=O}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)return this.e(T);const O=T.authority;let I=this.a[O];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const m=this.b[O],v=this.c[O];let f=`path=${encodeURIComponent(T.path)}`;return typeof v=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),k.URI.from({scheme:i.isWeb?this.d:y.vscodeRemoteResource,authority:`${I}:${m}`,path:this.f,query:f})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(T){const O=this.b(T,te);return this.uriToBrowserUri(O)}uriToBrowserUri(T){return T.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===y.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${y.vscodeFileResource}://${C.a}`)?T.with({scheme:y.vscodeFileResource,authority:T.authority||C.a,query:null,fragment:null}):T}asFileUri(T){const O=this.b(T,te);return this.uriToFileUri(O)}uriToFileUri(T){return T.scheme===y.vscodeFileResource?T.with({scheme:y.file,authority:T.authority!==C.a?T.authority:null,query:null,fragment:null}):T}b(T,O){return k.URI.isUri(T)?T:k.URI.parse(O.toUrl(T))}}C.a="vscode-app",e.FileAccess=new C;var R;(function(w){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(T.get("3"));const O="vscode-coi";function I(v){let f;typeof v=="string"?f=new URL(v).searchParams:v instanceof URL?f=v.searchParams:k.URI.isUri(v)&&(f=new URL(v.toString(!0)).searchParams);const t=f?.get(O);if(!!t)return T.get(t)}w.getHeadersFromQuery=I;function m(v,f,t){if(!globalThis.crossOriginIsolated)return;const o=f&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(O,o):v[O]=o}w.addSearchParam=m})(R=e.COI||(e.COI={}))}),define(De[22],Ce([1,0,39,13,19,21,10,2]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(v){return(0,R.uriToFsPath)(v,!0)}e.originalFSPath=w;class T{constructor(f){this.a=f}compare(f,t,o=!1){return f===t?0:(0,C.compare)(this.getComparisonKey(f,o),this.getComparisonKey(t,o))}isEqual(f,t,o=!1){return f===t?!0:!f||!t?!1:this.getComparisonKey(f,o)===this.getComparisonKey(t,o)}getComparisonKey(f,t=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,t,o=!1){if(f.scheme===t.scheme){if(f.scheme===k.Schemas.file)return i.isEqualOrParent(w(f),w(t),this.a(f))&&f.query===t.query&&(o||f.fragment===t.fragment);if((0,e.isEqualAuthority)(f.authority,t.authority))return i.isEqualOrParent(f.path,t.path,this.a(f),"/")&&f.query===t.query&&(o||f.fragment===t.fragment)}return!1}joinPath(f,...t){return R.URI.joinPath(f,...t)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return y.posix.basename(f.path)}extname(f){return y.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let t;return f.scheme===k.Schemas.file?t=R.URI.file(y.dirname(w(f))).path:(t=y.posix.dirname(f.path),f.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),t="/")),f.with({path:t})}normalizePath(f){if(!f.path.length)return f;let t;return f.scheme===k.Schemas.file?t=R.URI.file(y.normalize(w(f))).path:t=y.posix.normalize(f.path),f.with({path:t})}relativePath(f,t){if(f.scheme!==t.scheme||!(0,e.isEqualAuthority)(f.authority,t.authority))return;if(f.scheme===k.Schemas.file){const g=y.relative(w(f),w(t));return M.isWindows?i.toSlashes(g):g}let o=f.path||"/";const u=t.path||"/";if(this.a(f)){let g=0;for(const E=Math.min(o.length,u.length);g<E&&!(o.charCodeAt(g)!==u.charCodeAt(g)&&o.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);o=u.substr(0,g)+o.substr(g)}return y.posix.relative(o,u)}resolvePath(f,t){if(f.scheme===k.Schemas.file){const o=R.URI.file(y.resolve(w(f),t));return f.with({authority:o.authority,path:o.path})}return t=i.toPosixPath(t),f.with({path:y.posix.resolve(f.path,t)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,t){return f===t||f!==void 0&&t!==void 0&&(0,C.equalsIgnoreCase)(f,t)}hasTrailingPathSeparator(f,t=y.sep){if(f.scheme===k.Schemas.file){const o=w(f);return o.length>i.getRoot(o).length&&o[o.length-1]===t}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,t=y.sep){return(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,t=y.sep){let o=!1;if(f.scheme===k.Schemas.file){const u=w(f);o=u!==void 0&&u.length===i.getRoot(u).length&&u[u.length-1]===t}else{t="/";const u=f.path;o=u.length===1&&u.charCodeAt(u.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path+"/"}):f}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(v=>v.scheme===k.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new T(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(v,f){const t=[];for(let o=0;o<v.length;o++){const u=f(v[o]);v.some((g,E)=>E===o?!1:(0,e.isEqualOrParent)(u,f(g)))||t.push(v[o])}return t}e.distinctParents=O;var I;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function f(t){const o=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(E=>{const[b,S]=E.split(":");b&&S&&o.set(b,S)});const g=t.path.substring(0,t.path.indexOf(";"));return g&&o.set(v.META_DATA_MIME,g),o}v.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function m(v,f,t){if(f){let o=v.path;return o&&o[0]!==y.posix.sep&&(o=y.posix.sep+o),v.with({scheme:t,authority:f,path:o})}return v.with({scheme:t})}e.toLocalResource=m}),define(De[15],Ce([1,0,20,11,4,7,22,21]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(he){return!!he&&typeof he.then=="function"}e.isThenable=w;function T(he){const Y=new i.CancellationTokenSource,ge=he(Y.token),Se=new Promise((Fe,ze)=>{const _e=Y.token.onCancellationRequested(()=>{_e.dispose(),Y.dispose(),ze(new k.CancellationError)});Promise.resolve(ge).then(ke=>{_e.dispose(),Y.dispose(),Fe(ke)},ke=>{_e.dispose(),Y.dispose(),ze(ke)})});return new class{cancel(){Y.cancel()}then(Fe,ze){return Se.then(Fe,ze)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Se.finally(Fe)}}}e.createCancelablePromise=T;function O(he,Y,ge){return new Promise((Se,Fe)=>{const ze=Y.onCancellationRequested(()=>{ze.dispose(),Se(ge)});he.then(Se,Fe).finally(()=>ze.dispose())})}e.raceCancellation=O;function I(he,Y){return new Promise((ge,Se)=>{const Fe=Y.onCancellationRequested(()=>{Fe.dispose(),Se(new k.CancellationError)});he.then(ge,Se).finally(()=>Fe.dispose())})}e.raceCancellationError=I;async function m(he){let Y=-1;const ge=he.map((Fe,ze)=>Fe.then(_e=>(Y=ze,_e))),Se=await Promise.race(ge);return he.forEach((Fe,ze)=>{ze!==Y&&Fe.cancel()}),Se}e.raceCancellablePromises=m;function v(he,Y,ge){let Se;const Fe=setTimeout(()=>{Se?.(void 0),ge?.()},Y);return Promise.race([he.finally(()=>clearTimeout(Fe)),new Promise(ze=>Se=ze)])}e.raceTimeout=v;function f(he){return new Promise((Y,ge)=>{const Se=he();w(Se)?Se.then(Y,ge):Y(Se)})}e.asPromise=f;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(Y){if(this.a){if(this.d=Y,!this.b){const ge=()=>{this.b=null;const Se=this.queue(this.d);return this.d=null,Se};this.b=new Promise(Se=>{this.a.then(ge,ge).then(Se)})}return new Promise((ge,Se)=>{this.b.then(ge,Se)})}return this.a=Y(),new Promise((ge,Se)=>{this.a.then(Fe=>{this.a=null,ge(Fe)},Fe=>{this.a=null,Se(Fe)})})}}e.Throttler=t;class o{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.Sequencer=o;class u{constructor(){this.a=new Map}queue(Y,ge){const Fe=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(Y)===Fe&&this.a.delete(Y)});return this.a.set(Y,Fe),Fe}}e.SequencerByKey=u;const g=(he,Y)=>{let ge=!0;const Se=setTimeout(()=>{ge=!1,Y()},he);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Se),ge=!1}}},E=he=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,he())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class b{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ge=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((Fe,ze)=>{this.d=Fe,this.f=ze}).then(()=>{if(this.b=null,this.d=null,this.g){const Fe=this.g;return this.g=null,Fe()}}));const Se=()=>{this.a=null,this.d?.(null)};return this.a=ge===e.MicrotaskDelay?E(Se):g(ge,Se),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=b;class S{constructor(Y){this.a=new b(Y),this.b=new t}trigger(Y,ge){return this.a.trigger(()=>this.b.queue(Y),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=S;class s{constructor(){this.a=!1,this.b=new Promise((Y,ge)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function a(he,Y){return Y?new Promise((ge,Se)=>{const Fe=setTimeout(()=>{ze.dispose(),ge()},he),ze=Y.onCancellationRequested(()=>{clearTimeout(Fe),ze.dispose(),Se(new k.CancellationError)})}):T(ge=>a(he,ge))}e.timeout=a;function h(he,Y=0){const ge=setTimeout(he,Y);return(0,M.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=h;function c(he){const Y=[];let ge=0;const Se=he.length;function Fe(){return ge<Se?he[ge++]():null}function ze(_e){_e!=null&&Y.push(_e);const ke=Fe();return ke?ke.then(ze):Promise.resolve(Y)}return Promise.resolve(null).then(ze)}e.sequence=c;function d(he,Y=Se=>!!Se,ge=null){let Se=0;const Fe=he.length,ze=()=>{if(Se>=Fe)return Promise.resolve(ge);const _e=he[Se++];return Promise.resolve(_e()).then(Ie=>Y(Ie)?Promise.resolve(Ie):ze())};return ze()}e.first=d;function n(he,Y=Se=>!!Se,ge=null){if(he.length===0)return Promise.resolve(ge);let Se=he.length;const Fe=()=>{Se=-1;for(const ze of he)ze.cancel?.()};return new Promise((ze,_e)=>{for(const ke of he)ke.then(Ie=>{--Se>=0&&Y(Ie)?(Fe(),ze(Ie)):Se===0&&ze(ge)}).catch(Ie=>{--Se>=0&&(Fe(),_e(Ie))})})}e.firstParallel=n;class l{constructor(Y){this.a=0,this.d=Y,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Y){return this.a++,new Promise((ge,Se)=>{this.f.push({factory:Y,c:ge,e:Se}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Y=this.f.shift();this.b++;const ge=Y.factory();ge.then(Y.c,Y.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=l;class p extends l{constructor(){super(1)}}e.Queue=p;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Y=new X;return this.b.add(Y),Y.p}d(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueFor(Y,ge=C.extUri){const Se=ge.getComparisonKey(Y);let Fe=this.a.get(Se);return Fe||(Fe=new p,y.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(Se),this.f()}),this.a.set(Se,Fe)),Fe}f(){!this.d()||this.g()}g(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class L{constructor(Y,ge){this.a=-1,typeof Y=="function"&&typeof ge=="number"&&this.setIfNotSet(Y,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ge)}setIfNotSet(Y,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ge))}}e.TimeoutTimer=L;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Y,ge){this.cancel(),this.a=setInterval(()=>{Y()},ge)}}e.IntervalTimer=q;class K{constructor(Y,ge){this.b=-1,this.a=Y,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class j{constructor(Y,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=j;class P extends K{constructor(Y,ge){super(Y,ge),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=P;class N extends M.Disposable{constructor(Y,ge){super(),this.g=Y,this.h=ge,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...Y),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,R.setTimeout0)(()=>{if(Y)return;const ge=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(he,Y)=>{const ge=requestIdleCallback(he,typeof Y=="number"?{timeout:Y}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(ge))}}}}();class F{constructor(Y){this.d=!1,this.a=()=>{try{this.f=Y()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function $(he,Y,ge){let Se;for(let Fe=0;Fe<ge;Fe++)try{return await he()}catch(ze){Se=ze,await a(Y)}throw Se}e.retry=$;class z{hasPending(Y){return this.a?typeof Y=="number"?this.a.taskId===Y:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Y,ge,Se){return this.a={taskId:Y,cancel:()=>Se?.(),promise:ge},ge.then(()=>this.d(Y),()=>this.d(Y)),ge}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this.b)this.b.run=Y;else{let ge,Se;const Fe=new Promise((ze,_e)=>{ge=ze,Se=_e});this.b={run:Y,promise:Fe,promiseResolve:ge,promiseReject:Se}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class V{constructor(Y,ge=()=>Date.now()){this.d=Y,this.f=ge,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class X{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Y,ge)=>{this.a=Y,this.b=ge})}complete(Y){return new Promise(ge=>{this.a(Y),this.f=!0,ge()})}error(Y){return new Promise(ge=>{this.b(Y),this.d=!0,ge()})}cancel(){new Promise(Y=>{this.b(new k.CancellationError),this.d=!0,Y()})}}e.DeferredPromise=X;var ee;(function(he){async function Y(Se){let Fe;const ze=await Promise.all(Se.map(_e=>_e.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return ze}he.settled=Y;function ge(Se){return new Promise(async(Fe,ze)=>{try{await Se(Fe,ze)}catch(_e){ze(_e)}})}he.withAsyncBody=ge})(ee=e.Promises||(e.Promises={}));var fe;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(fe||(fe={}));class oe{static fromArray(Y){return new oe(ge=>{ge.emitMany(Y)})}static fromPromise(Y){return new oe(async ge=>{ge.emitMany(await Y)})}static fromPromises(Y){return new oe(async ge=>{await Promise.all(Y.map(async Se=>ge.emitOne(await Se)))})}static merge(Y){return new oe(async ge=>{await Promise.all(Y.map(async Se=>{for await(const Fe of Se)ge.emitOne(Fe)}))})}constructor(Y){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const ge={emitOne:Se=>this.g(Se),emitMany:Se=>this.h(Se),reject:Se=>this.k(Se)};try{await Promise.resolve(Y(ge)),this.j()}catch(Se){this.k(Se)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(Y,ge){return new oe(async Se=>{for await(const Fe of Y)Se.emitOne(ge(Fe))})}map(Y){return oe.map(this,Y)}static filter(Y,ge){return new oe(async Se=>{for await(const Fe of Y)ge(Fe)&&Se.emitOne(Fe)})}filter(Y){return oe.filter(this,Y)}static coalesce(Y){return oe.filter(Y,ge=>!!ge)}coalesce(){return oe.coalesce(this)}static async toPromise(Y){const ge=[];for await(const Se of Y)ge.push(Se);return ge}toPromise(){return oe.toPromise(this)}g(Y){this.a===0&&(this.b.push(Y),this.f.fire())}h(Y){this.a===0&&(this.b=this.b.concat(Y),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Y){this.a===0&&(this.a=2,this.d=Y,this.f.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class ue extends oe{constructor(Y,ge){super(ge),this.l=Y}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ue;function ce(he){const Y=new i.CancellationTokenSource,ge=he(Y.token);return new ue(Y,async Se=>{const Fe=Y.token.onCancellationRequested(()=>{Fe.dispose(),Y.dispose(),Se.reject(new k.CancellationError)});try{for await(const ze of ge){if(Y.token.isCancellationRequested)return;Se.emitOne(ze)}Fe.dispose(),Y.dispose()}catch(ze){Fe.dispose(),Y.dispose(),Se.reject(ze)}})}e.createCancelableAsyncIterable=ce}),define(De[121],Ce([1,0,15,19]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new i.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),M=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(p,A,L=!1){const q=p||"",K=A||"",j=y.value.collator.compare(q,K);return y.value.collatorIsNumeric&&j===0&&q!==K?q<K?-1:1:j}e.compareFileNames=R;function w(p,A){const L=M.value.collator;return p=p||"",A=A||"",S(L,p,A)}e.compareFileNamesDefault=w;function T(p,A){const L=M.value.collator;return p=p||"",A=A||"",h(p,A)||S(L,p,A)}e.compareFileNamesUpper=T;function O(p,A){const L=M.value.collator;return p=p||"",A=A||"",a(p,A)||S(L,p,A)}e.compareFileNamesLower=O;function I(p,A){return p=p||"",A=A||"",p===A?0:p<A?-1:1}e.compareFileNamesUnicode=I;function m(p,A,L=!1){L||(p=p&&p.toLowerCase(),A=A&&A.toLowerCase());const[q,K]=E(p),[j,P]=E(A);return q!==j?q<j?-1:1:K===P?0:K<P?-1:1}e.noIntlCompareFileNames=m;function v(p,A){const[L,q]=E(p),[K,j]=E(A);let P=y.value.collator.compare(q,j);if(P===0){if(y.value.collatorIsNumeric&&q!==j)return q<j?-1:1;if(P=y.value.collator.compare(L,K),y.value.collatorIsNumeric&&P===0&&L!==K)return L<K?-1:1}return P}e.compareFileExtensions=v;function f(p,A){p=p||"",A=A||"";const L=b(p),q=b(A),K=M.value.collator,j=C.value.collator;return S(j,L,q)||S(K,p,A)}e.compareFileExtensionsDefault=f;function t(p,A){p=p||"",A=A||"";const L=b(p),q=b(A),K=M.value.collator,j=C.value.collator;return S(j,L,q)||h(p,A)||S(K,p,A)}e.compareFileExtensionsUpper=t;function o(p,A){p=p||"",A=A||"";const L=b(p),q=b(A),K=M.value.collator,j=C.value.collator;return S(j,L,q)||a(p,A)||S(K,p,A)}e.compareFileExtensionsLower=o;function u(p,A){p=p||"",A=A||"";const L=b(p).toLowerCase(),q=b(A).toLowerCase();return L!==q?L<q?-1:1:p!==A?p<A?-1:1:0}e.compareFileExtensionsUnicode=u;const g=/^(.*?)(\.([^.]*))?$/;function E(p,A=!1){const L=p?g.exec(p):[];let q=[L&&L[1]||"",L&&L[3]||""];return A&&(!q[0]&&q[1]||q[0]&&q[0].charAt(0)===".")&&(q=[q[0]+"."+q[1],""]),q}function b(p){const A=p?g.exec(p):[];return A&&A[1]&&A[1].charAt(0)!=="."&&A[3]||""}function S(p,A,L){const q=p.compare(A,L);return q!==0?q:A.length!==L.length?A.length<L.length?-1:1:0}function s(p){const A=p.charAt(0);return A.toLocaleUpperCase()!==A}function r(p){const A=p.charAt(0);return A.toLocaleLowerCase()!==A}function a(p,A){return s(p)&&r(A)?-1:r(p)&&s(A)?1:0}function h(p,A){return r(p)&&s(A)?-1:s(p)&&r(A)?1:0}function c(p,A,L=!1){return L||(p=p&&p.toLowerCase(),A=A&&A.toLowerCase()),p===A?0:p<A?-1:1}function d(p,A,L=!1){const q=p.split(k.sep),K=A.split(k.sep),j=q.length-1,P=K.length-1;let N,F;for(let $=0;;$++){if(N=j===$,F=P===$,N&&F)return R(q[$],K[$],L);if(N)return-1;if(F)return 1;const z=c(q[$],K[$],L);if(z!==0)return z}}e.comparePaths=d;function n(p,A,L){const q=p.toLowerCase(),K=A.toLowerCase(),j=l(p,A,L);if(j)return j;const P=q.endsWith(L),N=K.endsWith(L);if(P!==N)return P?-1:1;const F=R(q,K);return F!==0?F:q.localeCompare(K)}e.compareAnything=n;function l(p,A,L){const q=p.toLowerCase(),K=A.toLowerCase(),j=q.startsWith(L),P=K.startsWith(L);if(j!==P)return j?-1:1;if(j&&P){if(q.length<K.length)return-1;if(q.length>K.length)return 1}return 0}e.compareByPrefix=l}),define(De[35],Ce([1,0,16,15,39,28,19,21,10]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",I="[^/\\\\]",m=/\//g;function v(X,ee){switch(X){case 0:return"";case 1:return`${I}*?`;default:return`(?:${O}|${I}+${O}${ee?`|${O}${I}+`:""})*?`}}function f(X,ee){if(!X)return[];const fe=[];let oe=!1,ue=!1,ce="";for(const he of X){switch(he){case ee:if(!oe&&!ue){fe.push(ce),ce="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ce+=he}return ce&&fe.push(ce),fe}e.splitGlobAware=f;function t(X){if(!X)return"";let ee="";const fe=f(X,e.GLOB_SPLIT);if(fe.every(oe=>oe===e.GLOBSTAR))ee=".*";else{let oe=!1;fe.forEach((ue,ce)=>{if(ue===e.GLOBSTAR){if(oe)return;ee+=v(2,ce===fe.length-1)}else{let he=!1,Y="",ge=!1,Se="";for(const Fe of ue){if(Fe!=="}"&&he){Y+=Fe;continue}if(ge&&(Fe!=="]"||!Se)){let ze;Fe==="-"?ze=Fe:(Fe==="^"||Fe==="!")&&!Se?ze="^":Fe===e.GLOB_SPLIT?ze="":ze=(0,w.escapeRegExpCharacters)(Fe),Se+=ze;continue}switch(Fe){case"{":he=!0;continue;case"[":ge=!0;continue;case"}":{ee+=`(?:${f(Y,",").map(ke=>t(ke)).join("|")})`,he=!1,Y="";break}case"]":{ee+="["+Se+"]",ge=!1,Se="";break}case"?":ee+=I;continue;case"*":ee+=v(1);continue;default:ee+=(0,w.escapeRegExpCharacters)(Fe)}}ce<fe.length-1&&(fe[ce+1]!==e.GLOBSTAR||ce+2<fe.length)&&(ee+=O)}oe=ue===e.GLOBSTAR})}return ee}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new M.LRUCache(1e4),r=function(){return!1},a=function(){return null};function h(X,ee){if(!X)return a;let fe;typeof X!="string"?fe=X.pattern:fe=X,fe=fe.trim();const oe=`${fe}_${!!ee.trimForExclusions}`;let ue=s.get(oe);if(ue)return c(ue,X);let ce;return o.test(fe)?ue=n(fe.substr(4),fe):(ce=u.exec(d(fe,ee)))?ue=l(ce[1],fe):(ee.trimForExclusions?E:g).test(fe)?ue=p(fe,ee):(ce=b.exec(d(fe,ee)))?ue=A(ce[1].substr(1),fe,!0):(ce=S.exec(d(fe,ee)))?ue=A(ce[1],fe,!1):ue=L(fe),s.set(oe,ue),c(ue,X)}function c(X,ee){if(typeof ee=="string")return X;const fe=function(oe,ue){return(0,y.isEqualOrParent)(oe,ee.base,!R.isLinux)?X((0,w.ltrim)(oe.substr(ee.base.length),C.sep),ue):null};return fe.allBasenames=X.allBasenames,fe.allPaths=X.allPaths,fe.basenames=X.basenames,fe.patterns=X.patterns,fe}function d(X,ee){return ee.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function n(X,ee){return function(fe,oe){return typeof fe=="string"&&fe.endsWith(X)?ee:null}}function l(X,ee){const fe=`/${X}`,oe=`\\${X}`,ue=function(he,Y){return typeof he!="string"?null:Y?Y===X?ee:null:he===X||he.endsWith(fe)||he.endsWith(oe)?ee:null},ce=[X];return ue.basenames=ce,ue.patterns=[ee],ue.allBasenames=ce,ue}function p(X,ee){const fe=z(X.slice(1,-1).split(",").map(Y=>h(Y,ee)).filter(Y=>Y!==a),X),oe=fe.length;if(!oe)return a;if(oe===1)return fe[0];const ue=function(Y,ge){for(let Se=0,Fe=fe.length;Se<Fe;Se++)if(fe[Se](Y,ge))return X;return null},ce=fe.find(Y=>!!Y.allBasenames);ce&&(ue.allBasenames=ce.allBasenames);const he=fe.reduce((Y,ge)=>ge.allPaths?Y.concat(ge.allPaths):Y,[]);return he.length&&(ue.allPaths=he),ue}function A(X,ee,fe){const oe=C.sep===C.posix.sep,ue=oe?X:X.replace(m,C.sep),ce=C.sep+ue,he=C.posix.sep+X;let Y;return fe?Y=function(ge,Se){return typeof ge=="string"&&(ge===ue||ge.endsWith(ce)||!oe&&(ge===X||ge.endsWith(he)))?ee:null}:Y=function(ge,Se){return typeof ge=="string"&&(ge===ue||!oe&&ge===X)?ee:null},Y.allPaths=[(fe?"*/":"./")+X],Y}function L(X){try{const ee=new RegExp(`^${t(X)}$`);return function(fe){return ee.lastIndex=0,typeof fe=="string"&&ee.test(fe)?X:null}}catch{return a}}function q(X,ee,fe){return!X||typeof ee!="string"?!1:K(X)(ee,void 0,fe)}e.match=q;function K(X,ee={}){if(!X)return r;if(typeof X=="string"||j(X)){const fe=h(X,ee);if(fe===a)return r;const oe=function(ue,ce){return!!fe(ue,ce)};return fe.allBasenames&&(oe.allBasenames=fe.allBasenames),fe.allPaths&&(oe.allPaths=fe.allPaths),oe}return F(X,ee)}e.parse=K;function j(X){const ee=X;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.isRelativePattern=j;function P(X){return X.allBasenames||[]}e.getBasenameTerms=P;function N(X){return X.allPaths||[]}e.getPathTerms=N;function F(X,ee){const fe=z(Object.getOwnPropertyNames(X).map(Y=>$(Y,X[Y],ee)).filter(Y=>Y!==a)),oe=fe.length;if(!oe)return a;if(!fe.some(Y=>!!Y.requiresSiblings)){if(oe===1)return fe[0];const Y=function(Fe,ze){let _e;for(let ke=0,Ie=fe.length;ke<Ie;ke++){const Te=fe[ke](Fe,ze);if(typeof Te=="string")return Te;(0,k.isThenable)(Te)&&(_e||(_e=[]),_e.push(Te))}return _e?(async()=>{for(const ke of _e){const Ie=await ke;if(typeof Ie=="string")return Ie}return null})():null},ge=fe.find(Fe=>!!Fe.allBasenames);ge&&(Y.allBasenames=ge.allBasenames);const Se=fe.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return Se.length&&(Y.allPaths=Se),Y}const ue=function(Y,ge,Se){let Fe,ze;for(let _e=0,ke=fe.length;_e<ke;_e++){const Ie=fe[_e];Ie.requiresSiblings&&Se&&(ge||(ge=(0,C.basename)(Y)),Fe||(Fe=ge.substr(0,ge.length-(0,C.extname)(Y).length)));const Te=Ie(Y,ge,Fe,Se);if(typeof Te=="string")return Te;(0,k.isThenable)(Te)&&(ze||(ze=[]),ze.push(Te))}return ze?(async()=>{for(const _e of ze){const ke=await _e;if(typeof ke=="string")return ke}return null})():null},ce=fe.find(Y=>!!Y.allBasenames);ce&&(ue.allBasenames=ce.allBasenames);const he=fe.reduce((Y,ge)=>ge.allPaths?Y.concat(ge.allPaths):Y,[]);return he.length&&(ue.allPaths=he),ue}function $(X,ee,fe){if(ee===!1)return a;const oe=h(X,fe);if(oe===a)return a;if(typeof ee=="boolean")return oe;if(ee){const ue=ee.when;if(typeof ue=="string"){const ce=(he,Y,ge,Se)=>{if(!Se||!oe(he,Y))return null;const Fe=ue.replace("$(basename)",ge),ze=Se(Fe);return(0,k.isThenable)(ze)?ze.then(_e=>_e?X:null):ze?X:null};return ce.requiresSiblings=!0,ce}}return oe}function z(X,ee){const fe=X.filter(Y=>!!Y.basenames);if(fe.length<2)return X;const oe=fe.reduce((Y,ge)=>{const Se=ge.basenames;return Se?Y.concat(Se):Y},[]);let ue;if(ee){ue=[];for(let Y=0,ge=oe.length;Y<ge;Y++)ue.push(ee)}else ue=fe.reduce((Y,ge)=>{const Se=ge.patterns;return Se?Y.concat(Se):Y},[]);const ce=function(Y,ge){if(typeof Y!="string")return null;if(!ge){let Fe;for(Fe=Y.length;Fe>0;Fe--){const ze=Y.charCodeAt(Fe-1);if(ze===47||ze===92)break}ge=Y.substr(Fe)}const Se=oe.indexOf(ge);return Se!==-1?ue[Se]:null};ce.basenames=oe,ce.patterns=ue,ce.allBasenames=oe;const he=X.filter(Y=>!Y.basenames);return he.push(ce),he}function V(X,ee){return(0,i.equals)(X,ee,(fe,oe)=>typeof fe=="string"&&typeof oe=="string"?fe===oe:typeof fe!="string"&&typeof oe!="string"?fe.base===oe.base&&fe.pattern===oe.pattern:!1)}e.patternsEquals=V}),define(De[81],Ce([1,0,11,119,22,10,2]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(u="",g=!1){if(this.value=u,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(u,g=0){return this.value+=m(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(E,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,g){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(u,g,E){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(u),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(u,g){const E=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return u.replace(E,(b,S)=>u.charAt(S-1)!=="\\"?`\\${b}`:b)}}e.MarkdownString=w;function T(o){return O(o)?!o.value:Array.isArray(o)?o.every(T):!0}e.isEmptyMarkdownString=T;function O(o){return o instanceof w?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function I(o,u){return o===u?!0:!o||!u?!1:o.value===u.value&&o.isTrusted===u.isTrusted&&o.supportThemeIcons===u.supportThemeIcons&&o.supportHtml===u.supportHtml&&(o.baseUri===u.baseUri||!!o.baseUri&&!!u.baseUri&&(0,y.isEqual)(C.URI.from(o.baseUri),C.URI.from(u.baseUri)))}e.markdownStringEqual=I;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function v(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function f(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function t(o){const u=[],g=o.split("|").map(b=>b.trim());o=g[0];const E=g[1];if(E){const b=/height=(\d+)/.exec(E),S=/width=(\d+)/.exec(E),s=b?b[1]:"",r=S?S[1]:"",a=isFinite(parseInt(r)),h=isFinite(parseInt(s));a&&u.push(`width="${r}"`),h&&u.push(`height="${s}"`)}return{href:o,dimensions:u}}e.parseHrefAndDimensions=t}),define(De[82],Ce([1,0,16,39,19,21,22,10]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(a,h){const{os:c,tildify:d,relative:n}=h;if(n){const A=T(a,n,c);if(typeof A=="string")return A}let l=a.fsPath;if(c===1&&!M.isWindows?l=l.replace(/\//g,"\\"):c!==1&&M.isWindows&&(l=l.replace(/\\/g,"/")),c!==1&&d?.userHome){const A=d.userHome.fsPath;let L;a.scheme!==d.userHome.scheme&&a.path.startsWith(y.posix.sep)?L=d.userHome.with({path:a.path}).fsPath:L=a.fsPath,l=m(L,A,c)}return(c===1?y.win32:y.posix).normalize(O(l,c===1))}e.getPathLabel=w;function T(a,h,c){const d=c===1?y.win32:y.posix,n=c===3?C.extUri:C.extUriIgnorePathCase,l=h.getWorkspace(),p=(0,i.firstOrDefault)(l.folders);if(!p)return;a.scheme!==p.uri.scheme&&a.path.startsWith(y.posix.sep)&&(a=p.uri.with({path:a.path}));const A=h.getWorkspaceFolder(a);if(!A)return;let L;if(n.isEqual(A.uri,a)?L="":L=n.relativePath(A.uri,a)??"",L&&(L=d.normalize(L)),l.folders.length>1&&!h.noPrefix){const q=A.name?A.name:n.basenameOrAuthority(A.uri);L=L?`${q} \u2022 ${L}`:q}return L}function O(a,h=M.isWindows){return(0,k.hasDriveLetter)(a,h)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=O;let I=Object.create(null);function m(a,h,c=M.OS){if(c===1||!a||!h)return a;let d=I.original===h?I.normalized:void 0;d||(d=h,M.isWindows&&(d=(0,k.toSlashes)(d)),d=`${(0,R.rtrim)(d,y.posix.sep)}${y.posix.sep}`,I={original:h,normalized:d});let n=a;return M.isWindows&&(n=(0,k.toSlashes)(n)),(c===3?n.startsWith(d):(0,R.startsWithIgnoreCase)(n,d))?`~/${n.substr(d.length)}`:a}e.tildify=m;function v(a,h){return a.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=v;const f="\u2026",t="\\\\",o="~";function u(a,h=y.sep){const c=new Array(a.length);let d=!1;for(let n=0;n<a.length;n++){const l=a[n];if(l===""){c[n]=`.${h}`;continue}if(!l){c[n]=l;continue}d=!0;let p="",A=l;A.indexOf(t)===0?(p=A.substr(0,A.indexOf(t)+t.length),A=A.substr(A.indexOf(t)+t.length)):A.indexOf(h)===0?(p=A.substr(0,A.indexOf(h)+h.length),A=A.substr(A.indexOf(h)+h.length)):A.indexOf(o)===0&&(p=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const L=A.split(h);for(let q=1;d&&q<=L.length;q++)for(let K=L.length-q;d&&K>=0;K--){d=!1;let j=L.slice(K,K+q).join(h);for(let P=0;!d&&P<a.length;P++)if(P!==n&&a[P]&&a[P].indexOf(j)>-1){const N=K+q===L.length,F=K>0&&a[P].indexOf(h)>-1?h+j:j,$=a[P].endsWith(F);d=!N||$}if(!d){let P="";(L[0].endsWith(":")||p!=="")&&(K===1&&(K=0,q++,j=L[0]+h+j),K>0&&(P=L[0]+h),P=p+P),K>0&&(P=P+f+h),P=P+j,K+q<L.length&&(P=P+h+f),c[n]=P}}d&&(c[n]=l)}return c}e.shorten=u;var g;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(a,h=Object.create(null)){const c=[];let d=!1,n="";for(const l of a)if(l==="$"||d&&l==="{")n&&c.push({value:n,type:g.TEXT}),n="",d=!0;else if(l==="}"&&d){const p=h[n];if(typeof p=="string")p.length&&c.push({value:p,type:g.VARIABLE});else if(p){const A=c[c.length-1];(!A||A.type!==g.SEPARATOR)&&c.push({value:p.label,type:g.SEPARATOR})}n="",d=!1}else n+=l;return n&&!d&&c.push({value:n,type:g.TEXT}),c.filter((l,p)=>{if(l.type===g.SEPARATOR){const A=c[p-1],L=c[p+1];return[A,L].every(q=>q&&(q.type===g.VARIABLE||q.type===g.TEXT)&&q.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=E;function b(a,h){return M.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function S(a,h){return M.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,""):M.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=S;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(a){const h=a.indexOf("/")!==-1?y.posix:y.win32,c=h.basename(a),d=h.dirname(a);return c.length?{name:c,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(De[122],Ce([1,0,2]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(O){return O.toJSON()}class y{constructor(I){this.a=I}transformIncoming(I){const m=this.a.transformIncoming(I);return m===I?I:k(i.URI.from(m))}transformOutgoing(I){const m=this.a.transformOutgoing(I);return m===I?I:k(i.URI.from(m))}transformOutgoingURI(I){const m=this.a.transformOutgoing(I);return m===I?I:i.URI.from(m)}transformOutgoingScheme(I){return this.a.transformOutgoingScheme(I)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,I,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof i.URI)return I.transformOutgoing(O);for(const v in O)if(Object.hasOwnProperty.call(O,v)){const f=M(O[v],I,m+1);f!==null&&(O[v]=f)}}return null}function C(O,I){const m=M(O,I,0);return m===null?O:m}e.transformOutgoingURIs=C;function R(O,I,m,v){if(!O||v>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?i.URI.revive(I.transformIncoming(O)):I.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const t=R(O[f],I,m,v+1);t!==null&&(O[f]=t)}}return null}function w(O,I){const m=R(O,I,!1,0);return m===null?O:m}e.transformIncomingURIs=w;function T(O,I){const m=R(O,I,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=T}),define(De[123],Ce([1,0,35,19]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(M,C,R,w,T,O){if(Array.isArray(M)){let I=0;for(const m of M){const v=y(m,C,R,w,T,O);if(v===10)return v;v>I&&(I=v)}return I}else{if(typeof M=="string")return w?M==="*"?5:M===R?10:0:0;if(M){const{language:I,pattern:m,scheme:v,hasAccessToAllModels:f,notebookType:t}=M;if(!w&&!f)return 0;t&&T&&(C=T);let o=0;if(v)if(v===C.scheme)o=10;else if(v==="*")o=5;else return 0;if(I)if(I===R)o=10;else if(I==="*")o=Math.max(o,5);else return 0;if(t)if(t===O)o=10;else if(t==="*"&&O!==void 0)o=Math.max(o,5);else return 0;if(m){let u;if(typeof m=="string"?u=m:u={...m,base:(0,k.normalize)(m.base)},u===C.fsPath||(0,i.match)(u,C.fsPath))o=10;else return 0}return o}else return 0}}e.score=y}),define(De[83],Ce([1,0,24,21]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(y||(y={}));function M(I){for(let m=0,v=I.length;m<v;m+=4){const f=I[m+0],t=I[m+1],o=I[m+2],u=I[m+3];I[m+0]=u,I[m+1]=o,I[m+2]=t,I[m+3]=f}}function C(I){const m=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return k.isLittleEndian()||M(m),i.VSBuffer.wrap(m)}function R(I){const m=I.buffer;if(k.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function w(I){const m=new Uint32Array(T(I));let v=0;if(m[v++]=I.id,I.type==="full")m[v++]=1,m[v++]=I.data.length,m.set(I.data,v),v+=I.data.length;else{m[v++]=2,m[v++]=I.deltas.length;for(const f of I.deltas)m[v++]=f.start,m[v++]=f.deleteCount,f.data?(m[v++]=f.data.length,m.set(f.data,v),v+=f.data.length):m[v++]=0}return C(m)}e.encodeSemanticTokensDto=w;function T(I){let m=0;if(m+=1+1,I.type==="full")m+=1+I.data.length;else{m+=1,m+=(1+1+1)*I.deltas.length;for(const v of I.deltas)v.data&&(m+=v.data.length)}return m}function O(I){const m=R(I);let v=0;const f=m[v++];if(m[v++]===1){const g=m[v++],E=m.subarray(v,v+g);return v+=g,{id:f,type:"full",data:E}}const o=m[v++],u=[];for(let g=0;g<o;g++){const E=m[v++],b=m[v++],S=m[v++];let s;S>0&&(s=m.subarray(v,v+S),v+=S),u[g]={start:E,deleteCount:b,data:s}}return{id:f,type:"delta",deltas:u}}e.decodeSemanticTokensDto=O}),define(De[124],Ce([17,18]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(De[125],Ce([1,0,124,21,126,16,23,112]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontFamily=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=T;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class I{constructor(_,pe,Me,Be){this.id=_,this.name=pe,this.defaultValue=Me,this.schema=Be}applyUpdate(_,pe){return v(_,pe)}compute(_,pe,Me){return Me}}class m{constructor(_,pe){this.newValue=_,this.didChange=pe}}e.ApplyUpdateResult=m;function v(Q,_){if(typeof Q!="object"||typeof _!="object"||!Q||!_)return new m(_,Q!==_);if(Array.isArray(Q)||Array.isArray(_)){const Me=Array.isArray(Q)&&Array.isArray(_)&&M.equals(Q,_);return new m(_,!Me)}let pe=!1;for(const Me in _)if(_.hasOwnProperty(Me)){const Be=v(Q[Me],_[Me]);Be.didChange&&(Q[Me]=Be.newValue,pe=!0)}return new m(Q,pe)}class f{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,pe){return v(_,pe)}validate(_){return this.defaultValue}}class t{constructor(_,pe,Me,Be){this.id=_,this.name=pe,this.defaultValue=Me,this.schema=Be}applyUpdate(_,pe){return v(_,pe)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,pe,Me){return Me}}function o(Q,_){return typeof Q>"u"?_:Q==="false"?!1:Boolean(Q)}e.boolean=o;class u extends t{constructor(_,pe,Me,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=Me),super(_,pe,Me,Be)}validate(_){return o(_,this.defaultValue)}}function g(Q,_,pe,Me){if(typeof Q>"u")return _;let Be=parseInt(Q,10);return isNaN(Be)?_:(Be=Math.max(pe,Be),Be=Math.min(Me,Be),Be|0)}e.clampedInt=g;class E extends t{static clampedInt(_,pe,Me,Be){return g(_,pe,Me,Be)}constructor(_,pe,Me,Be,je,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Me,Ye.minimum=Be,Ye.maximum=je),super(_,pe,Me,Ye),this.minimum=Be,this.maximum=je}validate(_){return E.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}class b extends t{static clamp(_,pe,Me){return _<pe?pe:_>Me?Me:_}static float(_,pe){if(typeof _=="number")return _;if(typeof _>"u")return pe;const Me=parseFloat(_);return isNaN(Me)?pe:Me}constructor(_,pe,Me,Be,je){typeof je<"u"&&(je.type="number",je.default=Me),super(_,pe,Me,je),this.validationFn=Be}validate(_){return this.validationFn(b.float(_,this.defaultValue))}}class S extends t{static string(_,pe){return typeof _!="string"?pe:_}constructor(_,pe,Me,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=Me),super(_,pe,Me,Be)}validate(_){return S.string(_,this.defaultValue)}}function s(Q,_,pe){return typeof Q!="string"||pe.indexOf(Q)===-1?_:Q}e.stringSet=s;class r extends t{constructor(_,pe,Me,Be,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Be,je.default=Me),super(_,pe,Me,je),this.c=Be}validate(_){return s(_,this.defaultValue,this.c)}}class a extends I{constructor(_,pe,Me,Be,je,Ye,it=void 0){typeof it<"u"&&(it.type="string",it.enum=je,it.default=Be),super(_,pe,Me,it),this.c=je,this.d=Ye}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function h(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,pe,Me){return Me===0?_.accessibilitySupport:Me}}class d extends I{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:i.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function A(Q){switch(Q){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=A;function L(Q){switch(Q){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class q extends f{constructor(){super(133)}compute(_,pe,Me){const Be=["monaco-editor"];return pe.get(34)&&Be.push(pe.get(34)),_.extraEditorClassName&&Be.push(_.extraEditorClassName),pe.get(68)==="default"?Be.push("mouse-default"):pe.get(68)==="copy"&&Be.push("mouse-copy"),pe.get(103)&&Be.push("showUnused"),pe.get(131)&&Be.push("showDeprecated"),Be.join(" ")}}class K extends u{constructor(){super(33,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(_,pe,Me){return Me&&_.emptySelectionClipboard}}class j extends I{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:i.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:i.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class P extends I{constructor(){super(46,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?P.OFF:_==="true"?P.ON:_:Boolean(_)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class N extends I{constructor(){super(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{anyOf:[{type:"string"},{type:"array",items:{type:"string"}}],description:i.localize(22,null),default:e.EDITOR_FONT_DEFAULTS.fontFamily})}validate(_){return typeof _=="string"?_:Array.isArray(_)&&_.length>0?_.map(pe=>JSON.stringify(pe)).join(","):this.defaultValue}}e.EditorFontFamily=N;class F extends I{constructor(){super(49,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:i.localize(23,null)},{type:"string",description:i.localize(24,null)}],description:i.localize(25,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?F.OFF:_==="true"?F.TRANSLATE:_:Boolean(_)?F.TRANSLATE:F.OFF}compute(_,pe,Me){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=F,F.OFF="normal",F.TRANSLATE="translate";class $ extends f{constructor(){super(45)}compute(_,pe,Me){return _.fontInfo}}class z extends t{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(26,null)})}validate(_){const pe=b.float(_,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp(pe,6,100)}compute(_,pe,Me){return _.fontInfo.fontSize}}class V extends I{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:i.localize(27,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(28,null)})}validate(_){return _==="normal"||_==="bold"?_:String(E.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class X extends I{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[i.localize(29,null),i.localize(30,null),i.localize(31,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(32,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(33,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(34,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(35,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(36,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(37,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Me,description:i.localize(38,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Me,description:i.localize(39,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Me,description:i.localize(40,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Me,description:i.localize(41,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Me,description:i.localize(42,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends I{constructor(){const _={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:i.localize(43,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:i.localize(44,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:i.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:i.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:E.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),above:o(pe.above,this.defaultValue.above)}}}var fe;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(fe=e.RenderMinimap||(e.RenderMinimap={}));class oe extends f{constructor(){super(136)}compute(_,pe,Me){return oe.computeLayout(pe,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio})}static computeContainedMinimapLineCount(_){const pe=_.height/_.lineHeight,Me=_.scrollBeyondLastLine?pe-1:0,Be=(_.viewLineCount+Me)/(_.pixelRatio*_.height),je=Math.floor(_.viewLineCount/Be);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Me,desiredRatio:Be,minimapLineCount:je}}static c(_,pe){const Me=_.outerWidth,Be=_.outerHeight,je=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Ye=pe.stableMinimapLayoutInput,it=Ye&&_.outerHeight===Ye.outerHeight&&_.lineHeight===Ye.lineHeight&&_.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&_.pixelRatio===Ye.pixelRatio&&_.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&_.minimap.enabled===Ye.minimap.enabled&&_.minimap.side===Ye.minimap.side&&_.minimap.size===Ye.minimap.size&&_.minimap.showSlider===Ye.minimap.showSlider&&_.minimap.renderCharacters===Ye.minimap.renderCharacters&&_.minimap.maxColumn===Ye.minimap.maxColumn&&_.minimap.scale===Ye.minimap.scale&&_.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&_.isViewportWrapping===Ye.isViewportWrapping,bt=_.lineHeight,Dt=_.typicalHalfwidthCharacterWidth,kt=_.scrollBeyondLastLine,lt=_.minimap.renderCharacters;let at=je>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Bt=_.minimap.maxColumn,Rt=_.minimap.size,Mt=_.minimap.side,ft=_.verticalScrollbarWidth,St=_.viewLineCount,Pt=_.remainingWidth,Nt=_.isViewportWrapping,Ge=lt?2:3;let Ot=Math.floor(je*Be);const Vt=Ot/je;let qt=!1,mt=!1,Ct=Ge*at,ye=at/je,Pe=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:yt,desiredRatio:pt,minimapLineCount:At}=oe.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:kt,height:Be,lineHeight:bt,pixelRatio:je});if(St/At>1)qt=!0,mt=!0,at=1,Ct=1,ye=at/je;else{let wt=!1,ht=at+1;if(Rt==="fit"){const $t=Math.ceil((St+yt)*Ct);Nt&&it&&Pt<=pe.stableFitRemainingWidth?(wt=!0,ht=pe.stableFitMaxMinimapScale):wt=$t>Ot}if(Rt==="fill"||wt){qt=!0;const $t=at;Ct=Math.min(bt*je,Math.max(1,Math.floor(1/pt))),Nt&&it&&Pt<=pe.stableFitRemainingWidth&&(ht=pe.stableFitMaxMinimapScale),at=Math.min(ht,Math.max(1,Math.floor(Ct/Ge))),at>$t&&(Pe=Math.min(2,at/$t)),ye=at/je/Pe,Ot=Math.ceil(Math.max(Ze,St+yt)*Ct),Nt?(pe.stableMinimapLayoutInput=_,pe.stableFitRemainingWidth=Pt,pe.stableFitMaxMinimapScale=at):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const me=Math.floor(Bt*ye),x=Math.min(me,Math.max(0,Math.floor((Pt-ft-2)*ye/(Dt+ye)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(je*x);const Ne=Ae/je;Ae=Math.floor(Ae*Pe);const Xe=lt?1:2,We=Mt==="left"?0:Me-x-ft;return{renderMinimap:Xe,minimapLeft:We,minimapWidth:x,minimapHeightIsEditorHeight:qt,minimapIsSampling:mt,minimapScale:at,minimapLineHeight:Ct,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:Ne,minimapCanvasOuterHeight:Vt}}static computeLayout(_,pe){const Me=pe.outerWidth|0,Be=pe.outerHeight|0,je=pe.lineHeight|0,Ye=pe.lineNumbersDigitCount|0,it=pe.typicalHalfwidthCharacterWidth,bt=pe.maxDigitWidth,Dt=pe.pixelRatio,kt=pe.viewLineCount,lt=_.get(128),at=lt==="inherit"?_.get(127):lt,Bt=at==="inherit"?_.get(123):at,Rt=_.get(126),Mt=pe.isDominatedByLongLines,ft=_.get(52),St=_.get(62).renderType!==0,Pt=_.get(63),Nt=_.get(97),Ge=_.get(67),Ot=_.get(95),Vt=Ot.verticalScrollbarSize,qt=Ot.verticalHasArrows,mt=Ot.arrowSize,Ct=Ot.horizontalScrollbarSize,ye=_.get(60),Pe=_.get(38),me=_.get(102)!=="never";let x;if(typeof ye=="string"&&/^\d+(\.\d+)?ch$/.test(ye)){const xt=parseFloat(ye.substr(0,ye.length-2));x=E.clampedInt(xt*it,0,0,1e3)}else x=E.clampedInt(ye,0,0,1e3);Pe&&me&&(x+=16);let Ae=0;if(St){const xt=Math.max(Ye,Pt);Ae=Math.round(xt*bt)}let Ne=0;ft&&(Ne=je);let Xe=0,We=Xe+Ne,Ze=We+Ae,yt=Ze+x;const pt=Me-Ne-Ae-x;let At=!1,Et=!1,wt=-1;at==="inherit"&&Mt?(At=!0,Et=!0):Bt==="on"||Bt==="bounded"?Et=!0:Bt==="wordWrapColumn"&&(wt=Rt);const ht=oe.c({outerWidth:Me,outerHeight:Be,lineHeight:je,typicalHalfwidthCharacterWidth:it,pixelRatio:Dt,scrollBeyondLastLine:Nt,minimap:Ge,verticalScrollbarWidth:Vt,viewLineCount:kt,remainingWidth:pt,isViewportWrapping:Et},pe.memory||new O);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Xe+=ht.minimapWidth,We+=ht.minimapWidth,Ze+=ht.minimapWidth,yt+=ht.minimapWidth);const $t=pt-ht.minimapWidth,Jt=Math.max(1,Math.floor(($t-Vt-2)/it)),vt=qt?mt:0;return Et&&(wt=Math.max(1,Jt),Bt==="bounded"&&(wt=Math.min(wt,Rt))),{width:Me,height:Be,glyphMarginLeft:Xe,glyphMarginWidth:Ne,lineNumbersLeft:We,lineNumbersWidth:Ae,decorationsLeft:Ze,decorationsWidth:x,contentLeft:yt,contentWidth:$t,minimap:ht,viewportColumn:Jt,isWordWrapMinified:At,isViewportWrapping:Et,wrappingColumn:wt,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:Ct,overviewRuler:{top:vt,width:Vt,height:Be-2*vt,right:0}}}}e.EditorLayoutInfoComputer=oe;class ue extends I{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(47,null),i.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(49,null)}})}validate(_){return s(_,"simple",["simple","advanced"])}compute(_,pe,Me){return pe.get(2)===2?"advanced":Me}}class ce extends I{constructor(){const _={enabled:!0};super(59,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:i.localize(50,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:o(_.enabled,this.defaultValue.enabled)}}}class he extends I{constructor(){const _={enabled:!1,maxLineCount:5};super(107,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:i.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:i.localize(52,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Y extends I{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:i.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(54,null),i.localize(55,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:i.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:i.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:i.localize(60,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class ge extends b{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>b.clamp(_,0,150),{markdownDescription:i.localize(61,null)})}compute(_,pe,Me){return _.fontInfo.lineHeight}}class Se extends I{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:i.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:i.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(64,null),i.localize(65,null),i.localize(66,null)],default:_.size,description:i.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:i.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:i.localize(69,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:i.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:i.localize(72,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(pe.scale,1,1,3),maxColumn:E.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Fe(Q){return Q==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ze extends I{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(74,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{top:E.clampedInt(pe.top,0,0,1e3),bottom:E.clampedInt(pe.bottom,0,0,1e3)}}}class _e extends I{constructor(){const _={enabled:!0,cycle:!1};super(79,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:i.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:i.localize(76,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class ke extends f{constructor(){super(134)}compute(_,pe,Me){return _.pixelRatio}}class Ie extends I{constructor(){const _={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(77,null),i.localize(78,null),i.localize(79,null)]}];super(82,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:_.strings,description:i.localize(80,null)},comments:{anyOf:pe,default:_.comments,description:i.localize(81,null)},other:{anyOf:pe,default:_.other,description:i.localize(82,null)}},default:_,markdownDescription:i.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Dt=_?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!_||typeof _!="object")return this.defaultValue;const{other:pe,comments:Me,strings:Be}=_,je=["on","inline","off"];let Ye,it,bt;return typeof pe=="boolean"?Ye=pe?"on":"off":Ye=s(pe,this.defaultValue.other,je),typeof Me=="boolean"?it=Me?"on":"off":it=s(Me,this.defaultValue.comments,je),typeof Be=="boolean"?bt=Be?"on":"off":bt=s(Be,this.defaultValue.strings,je),{other:Ye,comments:it,strings:bt}}}var Te;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class re extends I{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(84,null),i.localize(85,null),i.localize(86,null),i.localize(87,null)],default:"on",description:i.localize(88,null)})}validate(_){let pe=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(pe=4,Me=_):_==="interval"?pe=3:_==="relative"?pe=2:_==="on"?pe=1:pe=0),{renderType:pe,renderFn:Me}}}function ae(Q){const _=Q.get(90);return _==="editable"?Q.get(84):_!=="on"}e.filterValidationDecorations=ae;class J extends I{constructor(){const _=[],pe={type:"number",description:i.localize(89,null)};super(94,"rulers",_,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(90,null),format:"color-hex"}}}]},default:_,description:i.localize(91,null)})}validate(_){if(Array.isArray(_)){const pe=[];for(const Me of _)if(typeof Me=="number")pe.push({column:E.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const Be=Me;pe.push({column:E.clampedInt(Be.column,0,0,1e4),color:Be.color})}return pe.sort((Me,Be)=>Me.column-Be.column),pe}return this.defaultValue}}function D(Q,_){if(typeof Q!="string")return _;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(92,null),i.localize(93,null),i.localize(94,null)],default:"auto",description:i.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(96,null),i.localize(97,null),i.localize(98,null)],default:"auto",description:i.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:i.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:i.localize(102,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_,Me=E.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=E.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:D(pe.vertical,this.defaultValue.vertical),horizontal:D(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:E.clampedInt(pe.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:E.clampedInt(pe.verticalSliderSize,Be,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends I{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:i.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:i.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:i.localize(109,null)}})}applyUpdate(_,pe){let Me=!1;pe.allowedCharacters&&_&&(C.equals(_.allowedCharacters,pe.allowedCharacters)||(_={..._,allowedCharacters:pe.allowedCharacters},Me=!0)),pe.allowedLocales&&_&&(C.equals(_.allowedLocales,pe.allowedLocales)||(_={..._,allowedLocales:pe.allowedLocales},Me=!0));const Be=super.applyUpdate(_,pe);return Me?new m(Be.newValue,!0):Be}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{nonBasicASCII:be(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:be(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:be(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,pe){if(typeof _!="object"||!_)return pe;const Me={};for(const[Be,je]of Object.entries(_))je===!0&&(Me[Be]=!0);return Me}}class G extends I{constructor(){const _={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:i.localize(110,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Z extends I{constructor(){const _={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:i.localize(111,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:i.localize(112,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class le extends I{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(113,null),i.localize(114,null),i.localize(115,null)],default:_.bracketPairs,description:i.localize(116,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(117,null),i.localize(118,null),i.localize(119,null)],default:_.bracketPairsHorizontal,description:i.localize(120,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:i.localize(121,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:i.localize(122,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(123,null),i.localize(124,null),i.localize(125,null)],default:_.highlightActiveIndentation,description:i.localize(126,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{bracketPairs:be(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:be(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:be(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function be(Q,_,pe){const Me=pe.indexOf(Q);return Me===-1?_:pe[Me]}class se extends I{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(127,null),i.localize(128,null)],default:_.insertMode,description:i.localize(129,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:i.localize(130,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:i.localize(131,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:i.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:i.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:i.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:i.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:i.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:i.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:o(pe.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class we extends I{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(170,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ve extends f{constructor(){super(135)}compute(_,pe,Me){return pe.get(84)?!0:_.tabFocusMode}}var $e;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));class He extends I{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(171,null),i.localize(172,null),i.localize(173,null),i.localize(174,null)],description:i.localize(175,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,pe,Me){return pe.get(2)===2?0:Me}}class et extends f{constructor(){super(137)}compute(_,pe,Me){const Be=pe.get(136);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class xe extends I{constructor(){const _={enabled:!0};super(32,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:i.localize(176,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:o(_.enabled,this.defaultValue.enabled)}}}const tt="Consolas, 'Courier New', monospace",nt="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?nt:k.isLinux?dt:tt,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var ot;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.columnSelection=18]="columnSelection",Q[Q.comments=19]="comments",Q[Q.contextmenu=20]="contextmenu",Q[Q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=22]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=24]="cursorStyle",Q[Q.cursorSurroundingLines=25]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=27]="cursorWidth",Q[Q.disableLayerHinting=28]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",Q[Q.domReadOnly=30]="domReadOnly",Q[Q.dragAndDrop=31]="dragAndDrop",Q[Q.dropIntoEditor=32]="dropIntoEditor",Q[Q.emptySelectionClipboard=33]="emptySelectionClipboard",Q[Q.extraEditorClassName=34]="extraEditorClassName",Q[Q.fastScrollSensitivity=35]="fastScrollSensitivity",Q[Q.find=36]="find",Q[Q.fixedOverflowWidgets=37]="fixedOverflowWidgets",Q[Q.folding=38]="folding",Q[Q.foldingStrategy=39]="foldingStrategy",Q[Q.foldingHighlight=40]="foldingHighlight",Q[Q.foldingImportsByDefault=41]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=42]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=44]="fontFamily",Q[Q.fontInfo=45]="fontInfo",Q[Q.fontLigatures=46]="fontLigatures",Q[Q.fontSize=47]="fontSize",Q[Q.fontWeight=48]="fontWeight",Q[Q.fontVariations=49]="fontVariations",Q[Q.formatOnPaste=50]="formatOnPaste",Q[Q.formatOnType=51]="formatOnType",Q[Q.glyphMargin=52]="glyphMargin",Q[Q.gotoLocation=53]="gotoLocation",Q[Q.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",Q[Q.hover=55]="hover",Q[Q.inDiffEditor=56]="inDiffEditor",Q[Q.inlineSuggest=57]="inlineSuggest",Q[Q.letterSpacing=58]="letterSpacing",Q[Q.lightbulb=59]="lightbulb",Q[Q.lineDecorationsWidth=60]="lineDecorationsWidth",Q[Q.lineHeight=61]="lineHeight",Q[Q.lineNumbers=62]="lineNumbers",Q[Q.lineNumbersMinChars=63]="lineNumbersMinChars",Q[Q.linkedEditing=64]="linkedEditing",Q[Q.links=65]="links",Q[Q.matchBrackets=66]="matchBrackets",Q[Q.minimap=67]="minimap",Q[Q.mouseStyle=68]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=70]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=72]="multiCursorModifier",Q[Q.multiCursorPaste=73]="multiCursorPaste",Q[Q.multiCursorLimit=74]="multiCursorLimit",Q[Q.occurrencesHighlight=75]="occurrencesHighlight",Q[Q.overviewRulerBorder=76]="overviewRulerBorder",Q[Q.overviewRulerLanes=77]="overviewRulerLanes",Q[Q.padding=78]="padding",Q[Q.parameterHints=79]="parameterHints",Q[Q.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=82]="quickSuggestions",Q[Q.quickSuggestionsDelay=83]="quickSuggestionsDelay",Q[Q.readOnly=84]="readOnly",Q[Q.renameOnType=85]="renameOnType",Q[Q.renderControlCharacters=86]="renderControlCharacters",Q[Q.renderFinalNewline=87]="renderFinalNewline",Q[Q.renderLineHighlight=88]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=90]="renderValidationDecorations",Q[Q.renderWhitespace=91]="renderWhitespace",Q[Q.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",Q[Q.roundedSelection=93]="roundedSelection",Q[Q.rulers=94]="rulers",Q[Q.scrollbar=95]="scrollbar",Q[Q.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=97]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=98]="scrollPredominantAxis",Q[Q.selectionClipboard=99]="selectionClipboard",Q[Q.selectionHighlight=100]="selectionHighlight",Q[Q.selectOnLineNumbers=101]="selectOnLineNumbers",Q[Q.showFoldingControls=102]="showFoldingControls",Q[Q.showUnused=103]="showUnused",Q[Q.snippetSuggestions=104]="snippetSuggestions",Q[Q.smartSelect=105]="smartSelect",Q[Q.smoothScrolling=106]="smoothScrolling",Q[Q.stickyScroll=107]="stickyScroll",Q[Q.stickyTabStops=108]="stickyTabStops",Q[Q.stopRenderingLineAfter=109]="stopRenderingLineAfter",Q[Q.suggest=110]="suggest",Q[Q.suggestFontSize=111]="suggestFontSize",Q[Q.suggestLineHeight=112]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",Q[Q.suggestSelection=114]="suggestSelection",Q[Q.tabCompletion=115]="tabCompletion",Q[Q.tabIndex=116]="tabIndex",Q[Q.unicodeHighlighting=117]="unicodeHighlighting",Q[Q.unusualLineTerminators=118]="unusualLineTerminators",Q[Q.useShadowDOM=119]="useShadowDOM",Q[Q.useTabStops=120]="useTabStops",Q[Q.wordBreak=121]="wordBreak",Q[Q.wordSeparators=122]="wordSeparators",Q[Q.wordWrap=123]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=126]="wordWrapColumn",Q[Q.wordWrapOverride1=127]="wordWrapOverride1",Q[Q.wordWrapOverride2=128]="wordWrapOverride2",Q[Q.wrappingIndent=129]="wrappingIndent",Q[Q.wrappingStrategy=130]="wrappingStrategy",Q[Q.showDeprecated=131]="showDeprecated",Q[Q.inlayHints=132]="inlayHints",Q[Q.editorClassName=133]="editorClassName",Q[Q.pixelRatio=134]="pixelRatio",Q[Q.tabFocusMode=135]="tabFocusMode",Q[Q.layoutInfo=136]="layoutInfo",Q[Q.wrappingInfo=137]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(177,null)})),acceptSuggestionOnEnter:Le(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(178,null),""],markdownDescription:i.localize(179,null)})),accessibilitySupport:Le(new c),accessibilityPageSize:Le(new E(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(180,null),tags:["accessibility"]})),ariaLabel:Le(new S(4,"ariaLabel",i.localize(181,null))),autoClosingBrackets:Le(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(182,null),i.localize(183,null),""],description:i.localize(184,null)})),autoClosingDelete:Le(new r(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(185,null),""],description:i.localize(186,null)})),autoClosingOvertype:Le(new r(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(187,null),""],description:i.localize(188,null)})),autoClosingQuotes:Le(new r(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(189,null),i.localize(190,null),""],description:i.localize(191,null)})),autoIndent:Le(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[i.localize(192,null),i.localize(193,null),i.localize(194,null),i.localize(195,null),i.localize(196,null)],description:i.localize(197,null)})),automaticLayout:Le(new u(10,"automaticLayout",!1)),autoSurround:Le(new r(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(198,null),i.localize(199,null),i.localize(200,null),""],description:i.localize(201,null)})),bracketPairColorization:Le(new Z),bracketPairGuides:Le(new le),stickyTabStops:Le(new u(108,"stickyTabStops",!1,{description:i.localize(202,null)})),codeLens:Le(new u(14,"codeLens",!0,{description:i.localize(203,null)})),codeLensFontFamily:Le(new S(15,"codeLensFontFamily","",{description:i.localize(204,null)})),codeLensFontSize:Le(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(205,null)})),colorDecorators:Le(new u(17,"colorDecorators",!0,{description:i.localize(206,null)})),columnSelection:Le(new u(18,"columnSelection",!1,{description:i.localize(207,null)})),comments:Le(new d),contextmenu:Le(new u(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new u(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(208,null)})),cursorBlinking:Le(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:i.localize(209,null)})),cursorSmoothCaretAnimation:Le(new u(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(210,null)})),cursorStyle:Le(new a(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:i.localize(211,null)})),cursorSurroundingLines:Le(new E(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(212,null)})),cursorSurroundingLinesStyle:Le(new r(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(213,null),i.localize(214,null)],description:i.localize(215,null)})),cursorWidth:Le(new E(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(216,null)})),disableLayerHinting:Le(new u(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new u(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new u(30,"domReadOnly",!1)),dragAndDrop:Le(new u(31,"dragAndDrop",!0,{description:i.localize(217,null)})),emptySelectionClipboard:Le(new K),dropIntoEditor:Le(new xe),stickyScroll:Le(new he),extraEditorClassName:Le(new S(34,"extraEditorClassName","")),fastScrollSensitivity:Le(new b(35,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:i.localize(218,null)})),find:Le(new j),fixedOverflowWidgets:Le(new u(37,"fixedOverflowWidgets",!1)),folding:Le(new u(38,"folding",!0,{description:i.localize(219,null)})),foldingStrategy:Le(new r(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(220,null),i.localize(221,null)],description:i.localize(222,null)})),foldingHighlight:Le(new u(40,"foldingHighlight",!0,{description:i.localize(223,null)})),foldingImportsByDefault:Le(new u(41,"foldingImportsByDefault",!1,{description:i.localize(224,null)})),foldingMaximumRegions:Le(new E(42,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(225,null)})),unfoldOnClickAfterEndOfLine:Le(new u(43,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(226,null)})),fontFamily:Le(new N),fontInfo:Le(new $),fontLigatures2:Le(new P),fontSize:Le(new z),fontWeight:Le(new V),fontVariations:Le(new F),formatOnPaste:Le(new u(50,"formatOnPaste",!1,{description:i.localize(227,null)})),formatOnType:Le(new u(51,"formatOnType",!1,{description:i.localize(228,null)})),glyphMargin:Le(new u(52,"glyphMargin",!0,{description:i.localize(229,null)})),gotoLocation:Le(new X),hideCursorInOverviewRuler:Le(new u(54,"hideCursorInOverviewRuler",!1,{description:i.localize(230,null)})),hover:Le(new ee),inDiffEditor:Le(new u(56,"inDiffEditor",!1)),letterSpacing:Le(new b(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>b.clamp(Q,-5,20),{description:i.localize(231,null)})),lightbulb:Le(new ce),lineDecorationsWidth:Le(new t(60,"lineDecorationsWidth",10)),lineHeight:Le(new ge),lineNumbers:Le(new re),lineNumbersMinChars:Le(new E(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new u(64,"linkedEditing",!1,{description:i.localize(232,null)})),links:Le(new u(65,"links",!0,{description:i.localize(233,null)})),matchBrackets:Le(new r(66,"matchBrackets","always",["always","near","never"],{description:i.localize(234,null)})),minimap:Le(new Se),mouseStyle:Le(new r(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new b(69,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:i.localize(235,null)})),mouseWheelZoom:Le(new u(70,"mouseWheelZoom",!1,{markdownDescription:i.localize(236,null)})),multiCursorMergeOverlapping:Le(new u(71,"multiCursorMergeOverlapping",!0,{description:i.localize(237,null)})),multiCursorModifier:Le(new a(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[i.localize(238,null),i.localize(239,null)],markdownDescription:i.localize(240,null)})),multiCursorPaste:Le(new r(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(241,null),i.localize(242,null)],markdownDescription:i.localize(243,null)})),multiCursorLimit:Le(new E(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(244,null)})),occurrencesHighlight:Le(new u(75,"occurrencesHighlight",!0,{description:i.localize(245,null)})),overviewRulerBorder:Le(new u(76,"overviewRulerBorder",!0,{description:i.localize(246,null)})),overviewRulerLanes:Le(new E(77,"overviewRulerLanes",3,0,3)),padding:Le(new ze),parameterHints:Le(new _e),peekWidgetDefaultFocus:Le(new r(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(247,null),i.localize(248,null)],description:i.localize(249,null)})),definitionLinkOpensInPeek:Le(new u(81,"definitionLinkOpensInPeek",!1,{description:i.localize(250,null)})),quickSuggestions:Le(new Ie),quickSuggestionsDelay:Le(new E(83,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(251,null)})),readOnly:Le(new u(84,"readOnly",!1)),renameOnType:Le(new u(85,"renameOnType",!1,{description:i.localize(252,null),markdownDeprecationMessage:i.localize(253,null)})),renderControlCharacters:Le(new u(86,"renderControlCharacters",!0,{description:i.localize(254,null),restricted:!0})),renderFinalNewline:Le(new u(87,"renderFinalNewline",!0,{description:i.localize(255,null)})),renderLineHighlight:Le(new r(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(256,null)],description:i.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Le(new u(89,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(258,null)})),renderValidationDecorations:Le(new r(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new r(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(259,null),i.localize(260,null),i.localize(261,null),""],description:i.localize(262,null)})),revealHorizontalRightPadding:Le(new E(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new u(93,"roundedSelection",!0,{description:i.localize(263,null)})),rulers:Le(new J),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new E(96,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(264,null)})),scrollBeyondLastLine:Le(new u(97,"scrollBeyondLastLine",!0,{description:i.localize(265,null)})),scrollPredominantAxis:Le(new u(98,"scrollPredominantAxis",!0,{description:i.localize(266,null)})),selectionClipboard:Le(new u(99,"selectionClipboard",!0,{description:i.localize(267,null),included:k.isLinux})),selectionHighlight:Le(new u(100,"selectionHighlight",!0,{description:i.localize(268,null)})),selectOnLineNumbers:Le(new u(101,"selectOnLineNumbers",!0)),showFoldingControls:Le(new r(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(269,null),i.localize(270,null),i.localize(271,null)],description:i.localize(272,null)})),showUnused:Le(new u(103,"showUnused",!0,{description:i.localize(273,null)})),showDeprecated:Le(new u(131,"showDeprecated",!0,{description:i.localize(274,null)})),inlayHints:Le(new Y),snippetSuggestions:Le(new r(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(275,null),i.localize(276,null),i.localize(277,null),i.localize(278,null)],description:i.localize(279,null)})),smartSelect:Le(new we),smoothScrolling:Le(new u(106,"smoothScrolling",!1,{description:i.localize(280,null)})),stopRenderingLineAfter:Le(new E(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new se),inlineSuggest:Le(new G),suggestFontSize:Le(new E(111,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new E(112,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new u(113,"suggestOnTriggerCharacters",!0,{description:i.localize(283,null)})),suggestSelection:Le(new r(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null)],description:i.localize(287,null)})),tabCompletion:Le(new r(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null)],description:i.localize(291,null)})),tabIndex:Le(new E(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new H),unusualLineTerminators:Le(new r(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(292,null),i.localize(293,null),i.localize(294,null)],description:i.localize(295,null)})),useShadowDOM:Le(new u(119,"useShadowDOM",!0)),useTabStops:Le(new u(120,"useTabStops",!0,{description:i.localize(296,null)})),wordBreak:Le(new r(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(297,null),i.localize(298,null)],description:i.localize(299,null)})),wordSeparators:Le(new S(122,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:i.localize(300,null)})),wordWrap:Le(new r(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null),i.localize(304,null)],description:i.localize(305,null)})),wordWrapBreakAfterCharacters:Le(new S(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new S(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new E(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(306,null)})),wordWrapOverride1:Le(new r(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new r(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new q),pixelRatio:Le(new ke),tabFocusMode:Le(new ve),layoutInfo:Le(new oe),wrappingInfo:Le(new et),wrappingIndent:Le(new He),wrappingStrategy:Le(new ue)}}),define(De[127],Ce([17,18]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[128],Ce([17,18]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[129],Ce([17,18]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[130],Ce([17,18]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(De[131],Ce([17,18]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(De[132],Ce([17,18]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(De[133],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[134],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[135],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(De[136],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[137],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[138],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[139],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[140],Ce([17,18]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(De[141],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[142],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[143],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[144],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[145],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[146],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[147],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[148],Ce([1,0,11]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map}register(M,C){this.a.set(M,C)}updateManifest(M){if(!(!Array.isArray(M.activationEvents)||!M.contributes)&&!(typeof M.main>"u"&&typeof M.browser>"u"))for(const C in M.contributes){const R=this.a.get(C);if(!R)continue;const w=M.contributes[C],T=Array.isArray(w)?w:[w];try{R(T,M.activationEvents)}catch(O){(0,i.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(De[149],Ce([1,0,22,29,129,249]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function w(u){return u=u.trim(),u==="*"||C.test(u)}e.isValidVersionStr=w;function T(u){if(!w(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(C);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=T;function O(u){if(!u)return null;const g=u.majorBase,E=u.majorMustEqual,b=u.minorBase;let S=u.minorMustEqual;const s=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(g===0||(S=!1),r=!1);let a=0;if(u.preRelease){const h=R.exec(u.preRelease);if(h){const[,c,d,n]=h;a=Date.UTC(Number(c),Number(d)-1,Number(n))}}return{majorBase:g,majorMustEqual:E,minorBase:b,minorMustEqual:S,patchBase:s,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:a}}e.normalizeVersion=O;function I(u,g,E){let b;typeof u=="string"?b=O(T(u)):b=u;let S;g instanceof Date?S=g.getTime():typeof g=="string"&&(S=new Date(g).getTime());let s;if(typeof E=="string"?s=O(T(E)):s=E,!b||!s)return!1;const r=b.majorBase,a=b.minorBase,h=b.patchBase;let c=s.majorBase,d=s.minorBase,n=s.patchBase;const l=s.notBefore;let p=s.majorMustEqual,A=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?r>c?!0:r<c?!1:a>d?!0:a<d||S&&S<l?!1:h>=n:(r===1&&c===0&&(!p||!A||!L)&&(c=1,d=0,n=0,p=!0,A=!1,L=!1),r<c?!1:r>c?!p:a<d?!1:a>d?!A:h<n?!1:h>n?!L:!(S&&S<l))}e.isValidVersion=I;function m(u,g,E,b,S){const s=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return s.push([k.default.Error,y.localize(0,null)]),s;if(typeof b.name!="string")return s.push([k.default.Error,y.localize(1,null,"name")]),s;if(typeof b.version!="string")return s.push([k.default.Error,y.localize(2,null,"version")]),s;if(!b.engines)return s.push([k.default.Error,y.localize(3,null,"engines")]),s;if(typeof b.engines.vscode!="string")return s.push([k.default.Error,y.localize(4,null,"engines.vscode")]),s;if(typeof b.extensionDependencies<"u"&&!o(b.extensionDependencies))return s.push([k.default.Error,y.localize(5,null,"extensionDependencies")]),s;if(typeof b.activationEvents<"u"){if(!o(b.activationEvents))return s.push([k.default.Error,y.localize(6,null,"activationEvents")]),s;if(typeof b.main>"u"&&typeof b.browser>"u")return s.push([k.default.Error,y.localize(7,null,"activationEvents","main")]),s}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&s.push([k.default.Warning,y.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return s.push([k.default.Error,y.localize(9,null,"main")]),s;{const h=(0,i.joinPath)(E,b.main);(0,i.isEqualOrParent)(h,E)||s.push([k.default.Warning,y.localize(10,null,h.path,E.path)])}if(typeof b.activationEvents>"u")return s.push([k.default.Error,y.localize(11,null,"activationEvents","main")]),s}if(typeof b.browser<"u"){if(typeof b.browser!="string")return s.push([k.default.Error,y.localize(12,null,"browser")]),s;{const h=(0,i.joinPath)(E,b.browser);(0,i.isEqualOrParent)(h,E)||s.push([k.default.Warning,y.localize(13,null,h.path,E.path)])}if(typeof b.activationEvents>"u")return s.push([k.default.Error,y.localize(14,null,"activationEvents","browser")]),s}if(!M.valid(b.version))return s.push([k.default.Error,y.localize(15,null)]),s;const r=[];if(!v(u,g,b,S,r))for(const h of r)s.push([k.default.Error,h]);return s}e.validateExtensionManifest=m;function v(u,g,E,b,S){return b||typeof E.main>"u"&&typeof E.browser>"u"?!0:t(u,g,E.engines.vscode,S)}e.isValidExtensionVersion=v;function f(u,g,E){return u==="*"||t(g,E,u)}e.isEngineValid=f;function t(u,g,E,b=[]){const S=O(T(E));if(!S)return b.push(y.localize(16,null,E)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return b.push(y.localize(17,null,E)),!1}else if(!S.majorMustEqual)return b.push(y.localize(18,null,E)),!1;return I(u,g,S)?!0:(b.push(y.localize(19,null,u,E)),!1)}function o(u){if(!Array.isArray(u))return!1;for(let g=0,E=u.length;g<E;g++)if(typeof u[g]!="string")return!1;return!0}}),define(De[84],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,M=[],C=!1){this.ctor=y,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=i}),define(De[61],Ce([1,0,84]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var y;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function M(R,w,T){w instanceof i.SyncDescriptor||(w=new i.SyncDescriptor(w,[],Boolean(T))),k.push([R,w])}e.registerSingleton=M;function C(){return k}e.getSingletonServiceDescriptors=C}),define(De[150],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class k{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const R=this.lookupOrInsertNode(M),w=this.lookupOrInsertNode(C);R.outgoing.set(w.key,w),w.incoming.set(R.key,R)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const R of this.a.values())R.outgoing.delete(C),R.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let R=this.a.get(C);return R||(R=new i(C,M),this.a.set(C,R)),R}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,R]of this.a)M.push(`${C}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const R=new Set([M]),w=this.c(C,R);if(w)return w}}c(M,C){for(const[R,w]of M.outgoing){if(C.has(R))return[...C,R].join(" -> ");C.add(R);const T=this.c(w,C);if(T)return T;C.delete(R)}}}e.Graph=k}),define(De[3],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function R(w){return w[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=R})(i=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function k(C,R,w){R[i.DI_TARGET]===R?R[i.DI_DEPENDENCIES].push({id:C,index:w}):(R[i.DI_DEPENDENCIES]=[{id:C,index:w}],R[i.DI_TARGET]=R)}function y(C){if(i.serviceIds.has(C))return i.serviceIds.get(C);const R=function(w,T,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(R,w,O)};return R.toString=()=>C,i.serviceIds.set(C,R),R}e.createDecorator=y;function M(C){return C}e.refineServiceDecorator=M}),define(De[40],Ce([1,0,9,2,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationOverrides=M;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=C;var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function T(u,g){const E=Object.create(null);for(const b in u)O(E,b,u[b],g);return E}e.toValuesTree=T;function O(u,g,E,b){const S=g.split("."),s=S.pop();let r=u;for(let a=0;a<S.length;a++){const h=S[a];let c=r[h];switch(typeof c){case"undefined":c=r[h]=Object.create(null);break;case"object":break;default:b(`Ignoring ${g} as ${S.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[s]=E}catch{b(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}else b(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=O;function I(u,g){const E=g.split(".");m(u,E)}e.removeFromValueTree=I;function m(u,g){const E=g.shift();if(g.length===0){delete u[E];return}if(Object.keys(u).indexOf(E)!==-1){const b=u[E];typeof b=="object"&&!Array.isArray(b)&&(m(b,g),Object.keys(b).length===0&&delete u[E])}}function v(u,g,E){function b(r,a){let h=r;for(const c of a){if(typeof h!="object"||h===null)return;h=h[c]}return h}const S=g.split("."),s=b(u,S);return typeof s>"u"?E:s}e.getConfigurationValue=v;function f(u,g,E){Object.keys(g).forEach(b=>{b!=="__proto__"&&(b in u?i.isObject(u[b])&&i.isObject(g[b])?f(u[b],g[b],E):E&&(u[b]=g[b]):u[b]=g[b])})}e.merge=f;function t(u,g,E){const b=u.inspect(g),S=u.inspect(E);return typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:b.defaultValue}e.getMigratedSettingValue=t;function o(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(De[41],Ce([1,0,21,10,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",i.isMacintosh),M.set("isLinux",i.isLinux),M.set("isWindows",i.isWindows),M.set("isWeb",i.isWeb),M.set("isMacNative",i.isMacintosh&&!i.isWeb),M.set("isEdge",i.isEdge),M.set("isFirefox",i.isFirefox),M.set("isChrome",i.isChrome),M.set("isSafari",i.isSafari);const C=Object.prototype.hasOwnProperty;var R;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return I.INSTANCE}static true(){return m.INSTANCE}static has(P){return v.create(P)}static equals(P,N){return f.create(P,N)}static notEquals(P,N){return u.create(P,N)}static regex(P,N){return a.create(P,N)}static in(P,N){return t.create(P,N)}static notIn(P,N){return o.create(P,N)}static not(P){return g.create(P)}static and(...P){return d.create(P,null,!0)}static or(...P){return n.create(P,null,!0)}static greater(P,N){return b.create(P,N)}static greaterEquals(P,N){return S.create(P,N)}static smaller(P,N){return s.create(P,N)}static smallerEquals(P,N){return r.create(P,N)}static deserialize(P,N=!1){if(!!P)return this.c(P,N)}static c(P,N){const F=P.split("||");return n.create(F.map($=>this.d($,N)),null,!0)}static d(P,N){const F=P.split("&&");return d.create(F.map($=>this.f($,N)),null,!0)}static f(P,N){if(P=P.trim(),P.indexOf("!=")>=0){const F=P.split("!=");return u.create(F[0].trim(),this.g(F[1],N))}if(P.indexOf("==")>=0){const F=P.split("==");return f.create(F[0].trim(),this.g(F[1],N))}if(P.indexOf("=~")>=0){const F=P.split("=~");return a.create(F[0].trim(),this.h(F[1],N))}if(P.indexOf(" not in ")>=0){const F=P.split(" not in ");return o.create(F[0].trim(),this.g(F[1],N))}if(P.indexOf(" in ")>=0){const F=P.split(" in ");return t.create(F[0].trim(),this.g(F[1],N))}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const F=P.split(">=");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const F=P.split(">");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const F=P.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const F=P.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(P)?g.create(P.substr(1).trim()):v.create(P)}static g(P,N){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;const F=/^'([^']*)'$/.exec(P);return F?F[1].trim():P}static h(P,N){if((0,k.isFalsyOrWhitespace)(P)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=P.indexOf("/"),$=P.lastIndexOf("/");if(F===$||F<0){if(N)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}const z=P.slice(F+1,$),V=P[$+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(X){if(N)throw new Error(`bad regexp-value '${P}', parse error: ${X}`);return console.warn(`bad regexp-value '${P}', parse error: ${X}`),null}}}e.ContextKeyExpr=w;function T(j,P){const N=j?j.substituteConstants():void 0,F=P?P.substituteConstants():void 0;return!N&&!F?!0:!N||!F?!1:N.equals(F)}e.expressionsAreEqualWithConstantSubstitution=T;function O(j,P){return j.cmp(P)}class I{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class m{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class v{static create(P,N=null){const F=M.get(P);return typeof F=="boolean"?F?m.INSTANCE:I.INSTANCE:new v(P,N)}constructor(P,N){this.key=P,this.c=N,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:p(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=M.get(this.key);return typeof P=="boolean"?P?m.INSTANCE:I.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=v;class f{static create(P,N,F=null){if(typeof N=="boolean")return N?v.create(P,F):g.create(P,F);const $=M.get(P);return typeof $=="boolean"?N===($?"true":"false")?m.INSTANCE:I.INSTANCE:new f(P,N,F)}constructor(P,N,F){this.c=P,this.d=N,this.f=F,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=M.get(this.c);if(typeof P=="boolean"){const N=P?"true":"false";return this.d===N?m.INSTANCE:I.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class t{static create(P,N){return new t(P,N)}constructor(P,N){this.d=P,this.f=N,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:A(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const N=P.getValue(this.f),F=P.getValue(this.d);return Array.isArray(N)?N.includes(F):typeof F=="string"&&typeof N=="object"&&N!==null?C.call(N,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=t;class o{static create(P,N){return new o(P,N)}constructor(P,N){this.d=P,this.f=N,this.type=11,this.c=t.create(P,N)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class u{static create(P,N,F=null){if(typeof N=="boolean")return N?g.create(P,F):v.create(P,F);const $=M.get(P);return typeof $=="boolean"?N===($?"true":"false")?I.INSTANCE:m.INSTANCE:new u(P,N,F)}constructor(P,N,F){this.c=P,this.d=N,this.f=F,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=M.get(this.c);if(typeof P=="boolean"){const N=P?"true":"false";return this.d===N?I.INSTANCE:m.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class g{static create(P,N=null){const F=M.get(P);return typeof F=="boolean"?F?I.INSTANCE:m.INSTANCE:new g(P,N)}constructor(P,N){this.c=P,this.d=N,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:p(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=M.get(this.c);return typeof P=="boolean"?P?I.INSTANCE:m.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function E(j,P){if(typeof j=="string"){const N=parseFloat(j);isNaN(N)||(j=N)}return typeof j=="string"||typeof j=="number"?P(j):I.INSTANCE}class b{static create(P,N,F=null){return E(N,$=>new b(P,$,F))}constructor(P,N,F){this.c=P,this.d=N,this.f=F,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=b;class S{static create(P,N,F=null){return E(N,$=>new S(P,$,F))}constructor(P,N,F){this.c=P,this.d=N,this.f=F,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=S;class s{static create(P,N,F=null){return E(N,$=>new s(P,$,F))}constructor(P,N,F){this.c=P,this.d=N,this.f=F,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class r{static create(P,N,F=null){return E(N,$=>new r(P,$,F))}constructor(P,N,F){this.c=P,this.d=N,this.f=F,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:A(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class a{static create(P,N){return new a(P,N)}constructor(P,N){this.d=P,this.f=N,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const N=this.f?this.f.source:"",F=P.f?P.f.source:"";return N<F?-1:N>F?1:0}equals(P){if(P.type===this.type){const N=this.f?this.f.source:"",F=P.f?P.f.source:"";return this.d===P.d&&N===F}return!1}substituteConstants(){return this}evaluate(P){const N=P.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=h.create(this)),this.c}}e.ContextKeyRegexExpr=a;class h{static create(P){return new h(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(P){return new h(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=h;function c(j){let P=null;for(let N=0,F=j.length;N<F;N++){const $=j[N].substituteConstants();if(j[N]!==$&&P===null){P=[];for(let z=0;z<N;z++)P[z]=j[z]}P!==null&&(P[N]=$)}return P===null?j:P}class d{static create(P,N,F){return d.d(P,N,F)}constructor(P,N){this.expr=P,this.c=N,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const $=O(this.expr[N],P.expr[N]);if($!==0)return $}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(P.expr[N]))return!1;return!0}return!1}substituteConstants(){const P=c(this.expr);return P===this.expr?this:d.create(P,this.c,!1)}evaluate(P){for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].evaluate(P))return!1;return!0}static d(P,N,F){const $=[];let z=!1;for(const V of P)if(!!V){if(V.type===1){z=!0;continue}if(V.type===0)return I.INSTANCE;if(V.type===6){$.push(...V.expr);continue}$.push(V)}if($.length===0&&z)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(O);for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];for(;$.length>1;){const V=$[$.length-1];if(V.type!==9)break;$.pop();const X=$.pop(),ee=$.length===0,fe=n.create(V.expr.map(oe=>d.create([oe,X],null,F)),null,ee);fe&&($.push(fe),$.sort(O))}if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let X=V+1;X<$.length;X++)if($[V].negate().equals($[X]))return I.INSTANCE;if($.length===1)return $[0]}return new d($,N)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const N of this.expr)P.push(...N.keys());return P}map(P){return new d(this.expr.map(N=>N.map(P)),null)}negate(){if(!this.c){const P=[];for(const N of this.expr)P.push(N.negate());this.c=n.create(P,this,!0)}return this.c}}class n{static create(P,N,F){return n.d(P,N,F)}constructor(P,N){this.expr=P,this.c=N,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const $=O(this.expr[N],P.expr[N]);if($!==0)return $}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(P.expr[N]))return!1;return!0}return!1}substituteConstants(){const P=c(this.expr);return P===this.expr?this:n.create(P,this.c,!1)}evaluate(P){for(let N=0,F=this.expr.length;N<F;N++)if(this.expr[N].evaluate(P))return!0;return!1}static d(P,N,F){let $=[],z=!1;if(P){for(let V=0,X=P.length;V<X;V++){const ee=P[V];if(!!ee){if(ee.type===0){z=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){$=$.concat(ee.expr);continue}$.push(ee)}}if($.length===0&&z)return I.INSTANCE;$.sort(O)}if($.length!==0){if($.length===1)return $[0];for(let V=1;V<$.length;V++)$[V-1].equals($[V])&&($.splice(V,1),V--);if($.length===1)return $[0];if(F){for(let V=0;V<$.length;V++)for(let X=V+1;X<$.length;X++)if($[V].negate().equals($[X]))return m.INSTANCE;if($.length===1)return $[0]}return new n($,N)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const N of this.expr)P.push(...N.keys());return P}map(P){return new n(this.expr.map(N=>N.map(P)),null)}negate(){if(!this.c){const P=[];for(const N of this.expr)P.push(N.negate());for(;P.length>1;){const N=P.shift(),F=P.shift(),$=[];for(const z of K(N))for(const V of K(F))$.push(d.create([z,V],null,!1));P.unshift(n.create($,null,!1))}this.c=n.create(P,this,!0)}return this.c}}class l extends v{static all(){return l.d.values()}constructor(P,N,F){super(P,null),this.f=N,typeof F=="object"?l.d.push({...F,key:P}):F!==!0&&l.d.push({key:P,description:F,type:N!=null?typeof N:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return f.create(this.key,P)}notEqualsTo(P){return u.create(this.key,P)}}e.RawContextKey=l,l.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(j,P){return j<P?-1:j>P?1:0}function A(j,P,N,F){return j<N?-1:j>N?1:P<F?-1:P>F?1:0}function L(j,P){if(j.type===0||P.type===1)return!0;if(j.type===9)return P.type===9?q(j.expr,P.expr):!1;if(P.type===9){for(const N of P.expr)if(L(j,N))return!0;return!1}if(j.type===6){if(P.type===6)return q(P.expr,j.expr);for(const N of j.expr)if(L(N,P))return!0;return!1}return j.equals(P)}e.implies=L;function q(j,P){let N=0,F=0;for(;N<j.length&&F<P.length;){const $=j[N].cmp(P[F]);if($<0)return!1;$===0&&N++,F++}return N===j.length}function K(j){return j.type===9?j.expr:[j]}}),define(De[151],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(De[85],Ce([1,0,128,3]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function C(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function R(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function w(u,g,E){return R(g,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:T(E).includes(u)}e.isTargetPlatformCompatible=w;function T(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function O(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=O;var I;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(u){u.Install="install",u.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var t;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[36],Ce([1,0,46,19,10,9,2,130,3]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function T(z){return z.create===!0}e.isFileOpenForWriteOptions=T;var O;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var I;(function(z){z[z.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var m;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=v;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function t(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=t;function o(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function u(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=u;function g(z){return v(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(V,X){super(V),this.code=X}}e.FileSystemProviderError=b;function S(z,V){const X=new b(z.toString(),V);return r(X,V),X}e.createFileSystemProviderError=S;function s(z){return z||S((0,R.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=s;function r(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function a(z){if(!z)return E.Unknown;if(z instanceof b)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return E.Unknown;switch(V[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=a;function h(z){if(z instanceof A)return z.fileOperationResult;switch(a(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class d{constructor(V,X,ee){this.resource=V,this.operation=X,this.target=ee}isOperation(V){return this.operation===V}}e.FileOperationEvent=d;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class l{constructor(V,X){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const ee=new Map;for(const fe of V){const oe=ee.get(fe.type);switch(oe?oe.push([fe.resource,fe]):ee.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,oe]of ee)switch(fe){case 1:this.a=i.TernarySearchTree.forUris(()=>X),this.a.fill(oe);break;case 0:this.b=i.TernarySearchTree.forUris(()=>X),this.b.fill(oe);break;case 2:this.c=i.TernarySearchTree.forUris(()=>X),this.c.fill(oe);break}}contains(V,...X){return this.d(V,{includeChildren:!1},...X)}affects(V,...X){return this.d(V,{includeChildren:!0},...X)}d(V,X,...ee){if(!V)return!1;const fe=ee.length>0;return!!((!fe||ee.includes(1))&&(this.a?.get(V)||X.includeChildren&&this.a?.findSuperstr(V))||(!fe||ee.includes(0))&&(this.b?.get(V)||X.includeChildren&&this.b?.findSuperstr(V))||(!fe||ee.includes(2))&&(this.c?.findSubstr(V)||X.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=l;function p(z,V,X){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==k.sep&&(V+=k.sep),X?(0,y.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=p;class A extends Error{constructor(V,X,ee){super(V),this.fileOperationResult=X,this.options=ee}}e.FileOperationError=A;class L extends A{constructor(V,X,ee){super(V,2,ee),this.stat=X}}e.NotModifiedSinceFileOperationError=L;var q;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=j;async function P(z,V){if(!V.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(X=>{const ee=V.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===z.scheme&&fe.added&&(ee.dispose(),X())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(V){return(0,M.isNumber)(V)||(V=0),V<N.KB?(0,R.localize)(1,null,V.toFixed(0)):V<N.MB?(0,R.localize)(2,null,(V/N.KB).toFixed(2)):V<N.GB?(0,R.localize)(3,null,(V/N.MB).toFixed(2)):V<N.TB?(0,R.localize)(4,null,(V/N.GB).toFixed(2)):(0,R.localize)(5,null,(V/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var F;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(z){return{maxFileSize:z===0?300*N.MB:16*N.GB,maxHeapSize:z===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=$}),define(De[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this.a=new Map;for(const[M,C]of y)this.set(M,C)}set(y,M){const C=this.a.get(y);return this.a.set(y,M),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=i}),define(De[152],Ce([1,0,15,11,7,84,150,3,62,153]),function(te,e,i,k,y,M,C,R,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class I extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class m{constructor(o=new w.ServiceCollection,u=!1,g,E=O){this.f=o,this.g=u,this.h=g,this.i=E,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=E?g?._globalGraph??new C.Graph(b=>b):void 0}createChild(o){return new m(o,this.g,this,this.i)}invokeFunction(o,...u){const g=f.traceInvocation(this.i,o);let E=!1;try{return o({get:S=>{if(E)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(S,g);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...u)}finally{E=!0,g.stop()}}createInstance(o,...u){let g,E;return o instanceof M.SyncDescriptor?(g=f.traceCreation(this.i,o.ctor),E=this.j(o.ctor,o.staticArguments.concat(u),g)):(g=f.traceCreation(this.i,o),E=this.j(o,u,g)),g.stop(),E}j(o,u=[],g){const E=R._util.getServiceDependencies(o).sort((s,r)=>s.index-r.index),b=[];for(const s of E){const r=this.m(s.id,g);r||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${s.id}.`,!1),b.push(r)}const S=E.length>0?E[0].index:u.length;if(u.length!==S){console.trace(`[createInstance] First service dependency of ${o.name} at position ${S+1} conflicts with ${u.length} static arguments`);const s=S-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,S)}return Reflect.construct(o,u.concat(b))}k(o,u){if(this.f.get(o)instanceof M.SyncDescriptor)this.f.set(o,u);else if(this.h)this.h.k(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const u=this.f.get(o);return!u&&this.h?this.h.l(o):u}m(o,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const g=this.l(o);return g instanceof M.SyncDescriptor?this.q(o,g,u.branch(o,!0)):(u.branch(o,!1),g)}q(o,u,g){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,u,g)}finally{this.o.delete(o)}}r(o,u,g){const E=new C.Graph(s=>s.id.toString());let b=0;const S=[{id:o,desc:u,_trace:g}];for(;S.length;){const s=S.pop();if(E.lookupOrInsertNode(s),b++>1e3)throw new I(E);for(const r of R._util.getServiceDependencies(s.desc.ctor)){const a=this.l(r.id);if(a||this.u(`[createInstance] ${o} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),a instanceof M.SyncDescriptor){const h={id:r.id,desc:a,_trace:s._trace.branch(r.id,!0)};E.insertEdge(s,h),S.push(h)}}}for(;;){const s=E.roots();if(s.length===0){if(!E.isEmpty())throw new I(E);break}for(const{data:r}of s){if(this.l(r.id)instanceof M.SyncDescriptor){const h=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,h)}E.removeNode(r)}}return this.l(o)}s(o,u,g=[],E,b){if(this.f.get(o)instanceof M.SyncDescriptor)return this.t(o,u,g,E,b);if(this.h)return this.h.s(o,u,g,E,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(o,u,g=[],E,b){if(E){const S=new m(void 0,this.g,this,this.i);S.c=String(o);const s=new Map,r=new i.IdleValue(()=>{const a=S.j(u,g,b);for(const[h,c]of s){const d=a[h];if(typeof d=="function")for(const n of c)d.apply(a,n)}return s.clear(),a});return new Proxy(Object.create(null),{get(a,h){if(!r.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let n=s.get(h);return n||(n=new T.LinkedList,s.set(h,n)),(p,A,L)=>{const q=n.push([p,A,L]);return(0,y.toDisposable)(q)}}if(h in a)return a[h];const c=r.value;let d=c[h];return typeof d!="function"||(d=d.bind(c),a[h]=d),d},set(a,h,c){return r.value[h]=c,!0}})}else return this.j(u,g,b)}u(o,u){if(u&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=m;var v;(function(t){t[t.Creation=0]="Creation",t[t.Invocation=1]="Invocation",t[t.Branch=2]="Branch"})(v||(v={}));class f{static traceInvocation(o,u){return o?new f(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,u){return o?new f(0,u.name):f.c}constructor(o,u){this.type=o,this.name=u,this.g=Date.now(),this.h=[]}branch(o,u){const g=new f(2,o.toString());return this.h.push([o,u,g]),g}stop(){const o=Date.now()-this.g;f.f+=o;let u=!1;function g(b,S){const s=[],r=new Array(b+1).join("	");for(const[a,h,c]of S.h)if(h&&c){u=!0,s.push(`${r}CREATES -> ${a}`);const d=g(b+1,c);d&&s.push(d)}else s.push(`${r}uses -> ${a}`);return s.join(`
`)}const E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||u)&&f.all.add(E.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f.f=0}),define(De[12],Ce([1,0,45,4,7,28,21,2,3]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function T(){return new Date().toISOString()}var O;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function I(d,n,l){switch(n){case O.Trace:d.trace(l);break;case O.Debug:d.debug(l);break;case O.Info:d.info(l);break;case O.Warning:d.warn(l);break;case O.Error:d.error(l);break;default:throw new Error(`Invalid log level ${n}`)}}e.log=I;function m(d){let n="";for(let l=0;l<d.length;l++){let p=d[l];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(l>0?" ":"")+p}return n}e.format=m;class v extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new k.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=v;class f extends v{constructor(n){super(),this.g=n}h(n){return this.g||this.getLevel()<=n}trace(n,...l){this.h(O.Trace)&&this.f(O.Trace,m([n,...l]))}debug(n,...l){this.h(O.Debug)&&this.f(O.Debug,m([n,...l]))}info(n,...l){this.h(O.Info)&&this.f(O.Info,m([n,...l]))}warn(n,...l){this.h(O.Warning)&&this.f(O.Warning,m([n,...l]))}error(n,...l){if(this.h(O.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.f(O.Error,m(p))}else this.f(O.Error,m([n,...l]))}flush(){}}e.AbstractMessageLogger=f;class t extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.f=!C.isWindows}trace(n,...l){this.getLevel()<=O.Trace&&(this.f?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,n,...l):console.log(`[main ${T()}]`,n,...l))}debug(n,...l){this.getLevel()<=O.Debug&&(this.f?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,n,...l):console.log(`[main ${T()}]`,n,...l))}info(n,...l){this.getLevel()<=O.Info&&(this.f?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,n,...l):console.log(`[main ${T()}]`,n,...l))}warn(n,...l){this.getLevel()<=O.Warning&&(this.f?console.warn(`\x1B[93m[main ${T()}]\x1B[0m`,n,...l):console.warn(`[main ${T()}]`,n,...l))}error(n,...l){this.getLevel()<=O.Error&&(this.f?console.error(`\x1B[91m[main ${T()}]\x1B[0m`,n,...l):console.error(`[main ${T()}]`,n,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class o extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...l){this.getLevel()<=O.Trace&&console.log("%cTRACE","color: #888",n,...l)}debug(n,...l){this.getLevel()<=O.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...l)}info(n,...l){this.getLevel()<=O.Info&&console.log("%c INFO","color: #33f",n,...l)}warn(n,...l){this.getLevel()<=O.Warning&&console.log("%c WARN","color: #993",n,...l)}error(n,...l){this.getLevel()<=O.Error&&console.log("%c  ERR","color: #f33",n,...l)}dispose(){}flush(){}}e.ConsoleLogger=o;class u extends v{constructor(n,l=e.DEFAULT_LOG_LEVEL){super(),this.f=n,this.setLevel(l)}trace(n,...l){this.getLevel()<=O.Trace&&this.f.log(O.Trace,[this.g(n),...l])}debug(n,...l){this.getLevel()<=O.Debug&&this.f.log(O.Debug,[this.g(n),...l])}info(n,...l){this.getLevel()<=O.Info&&this.f.log(O.Info,[this.g(n),...l])}warn(n,...l){this.getLevel()<=O.Warning&&this.f.log(O.Warning,[this.g(n),...l])}error(n,...l){this.getLevel()<=O.Error&&this.f.log(O.Error,[this.g(n),...l])}g(n){return typeof n=="string"?n:(0,i.toErrorMessage)(n,this.getLevel()<=O.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class g extends v{constructor(n){super(),this.f=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const l of this.f)l.setLevel(n);super.setLevel(n)}trace(n,...l){for(const p of this.f)p.trace(n,...l)}debug(n,...l){for(const p of this.f)p.debug(n,...l)}info(n,...l){for(const p of this.f)p.info(n,...l)}warn(n,...l){for(const p of this.f)p.warn(n,...l)}error(n,...l){for(const p of this.f)p.error(n,...l)}flush(){for(const n of this.f)n.flush()}dispose(){for(const n of this.f)n.dispose()}}e.MultiplexLogService=g;class E extends y.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...l){this.b.trace(n,...l)}debug(n,...l){this.b.debug(n,...l)}info(n,...l){this.b.info(n,...l)}warn(n,...l){this.b.warn(n,...l)}error(n,...l){this.b.error(n,...l)}flush(){this.b.flush()}}e.LogService=E;class b extends y.Disposable{constructor(n,l){super(),this.c=n,this.b=new M.ResourceMap,this.B(l(p=>this.setLevel(p)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,l,p){let A=this.b.get(n)?.logger;return A||(p=l?.always?O.Trace:p,A=this.f(n,p??this.c,l),this.b.set(n,{logger:A,logLevel:p})),A}setLevel(n,l){const p=R.URI.isUri(n)?n:void 0,A=p?l:n;if(p){const L=this.b.get(p);L&&L.logLevel!==A&&(L.logLevel=A,L.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:L,logger:q})=>{L===void 0&&q.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=b;class S{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(n){}getLevel(){return O.Info}trace(n,...l){}debug(n,...l){}info(n,...l){}warn(n,...l){}error(n,...l){}critical(n,...l){}dispose(){}flush(){}}e.NullLogger=S;class s extends S{}e.NullLogService=s;class r extends b{constructor(){super(O.Info,k.Event.None)}f(n,l,p){return new S}}e.NullLoggerService=r;function a(d){if(d.verbose)return O.Trace;if(typeof d.logLevel=="string"){const n=c(d.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function h(d){switch(d){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=h;function c(d){switch(d){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=c}),define(De[86],Ce([1,0,29,131,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var C;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function T(f,t){return t-f}w.compare=T;const O=Object.create(null);O[w.Error]=(0,k.localize)(0,null),O[w.Warning]=(0,k.localize)(1,null),O[w.Info]=(0,k.localize)(2,null);function I(f){return O[f]||""}w.toString=I;function m(f){switch(f){case i.default.Error:return w.Error;case i.default.Warning:return w.Warning;case i.default.Info:return w.Info;case i.default.Ignore:return w.Hint}}w.fromSeverity=m;function v(f){switch(f){case w.Error:return i.default.Error;case w.Warning:return i.default.Warning;case w.Info:return i.default.Info;case w.Hint:return i.default.Ignore}}w.toSeverity=v}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(w){const T="";function O(m){return I(m,!0)}w.makeKey=O;function I(m,v){const f=[T];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(T),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(T),m.severity!==void 0&&m.severity!==null?f.push(C.toString(m.severity)):f.push(T),m.message&&v?f.push(m.message.replace("\xA6","\\\xA6")):f.push(T),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(T),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(T),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(T),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(T),f.push(T),f.join("\xA6")}w.makeKeyOptionalMessage=I})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(De[154],Ce([1,0,4,29,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,y.createDecorator)("notificationService");var M;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new w,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=R;class w{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=w}),define(De[87],Ce([1,0,10,2,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function M(T,O){return k.URI.isUri(T)?(0,i.equalsIgnoreCase)(T.scheme,O):(0,i.startsWithIgnoreCase)(T,O+":")}e.matchesScheme=M;function C(T,...O){return O.some(I=>M(T,I))}e.matchesSomeScheme=C;function R(T,O){return T.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=R;function w(T){let O;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(T.fragment);return I&&(O={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},T=T.with({fragment:""})),{selection:O,uri:T}}e.extractSelection=w}),define(De[155],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,i,k){var y=arguments.length,M=y<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,i):k,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,i,k);else for(var R=te.length-1;R>=0;R--)(C=te[R])&&(M=(y<3?C(M):y>3?C(e,i,M):C(e,i))||M);return y>3&&M&&Object.defineProperty(e,i,M),M},Ve=this&&this.__param||function(te,e){return function(i,k){e(i,k,te)}};define(De[156],Ce([1,0,15,20,7,3]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var C;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(I){this.b=I}report(I){this.a=I,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let w=class extends y.Disposable{constructor(I,m){super(),this.a=new i.DeferredPromise,m.withProgress(I,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};w=qe([Ve(1,e.IProgressService)],w),e.UnmanagedProgress=w;class T extends y.Disposable{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new y.DisposableStore)}start(I){this.stop();const m=++this.a,v=new k.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>v.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:v.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(De[30],Ce([1,0,47,9]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,R){i.ok(k.isString(C)),i.ok(k.isObject(R)),i.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,R)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(De[88],Ce([1,0,4,30]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class M{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,T){this.a[y(w)]=T,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;k.Registry.add(e.Extensions.JSONContribution,C)}),define(De[89],Ce([1,0,16,4,9,127,40,88,30]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=w.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new k.Emitter,this.onDidSchemaChange=this.i.event,this.j=new k.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const a=this.k(s,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(s){const r=this.l(s);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const a=[];a.push(...this.l(r)),a.push(...this.k(s,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,i.distinct)(a)})}registerDefaultConfigurations(s){const r=[],a=[];for(const{overrides:h,source:c}of s)for(const d in h)if(r.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const n=this.a.get(d),l=n?.valuesSources??new Map;if(c)for(const q of Object.keys(h[d]))l.set(q,c);const p={...n?.value||{},...h[d]};this.a.set(d,{source:c,value:p,valuesSources:l});const A=(0,C.getLanguageTagSettingPlainKey)(d),L={type:"object",default:p,description:M.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:y.isString(c)?void 0:c,defaultValueSource:c};a.push(...t(d)),this.d[d]=L,this.b.properties[d]=L}else{this.a.set(d,{value:h[d],source:c});const n=this.d[d];n&&(this.s(d,n),this.o(d,n))}this.registerOverrideIdentifiers(a),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:a,source:h}of s)for(const c in a){const d=this.a.get(c),n=y.isString(h)?h:h?.id,l=y.isString(d?.source)?d?.source:d?.source?.id;if(n===l)if(r.push(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const p=this.d[c];p&&(this.s(c,p),this.o(c,p))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const r of s)this.h.add(r);this.q()}k(s,r){const a=[];return s.forEach(h=>{a.push(...this.m(h,r,h.extensionInfo,h.restrictedProperties)),this.c.push(h),this.n(h)}),a}l(s){const r=[],a=h=>{if(h.properties)for(const c in h.properties){r.push(c);const d=this.d[c];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[c],this.p(c,h.properties[c])}h.allOf?.forEach(c=>a(c))};for(const h of s){a(h);const c=this.c.indexOf(h);c!==-1&&this.c.splice(c,1)}return r}m(s,r=!0,a,h,c=3){c=y.isUndefinedOrNull(s.scope)?c:s.scope;const d=[],n=s.properties;if(n)for(const p in n){const A=n[p];if(r&&E(p,A)){delete n[p];continue}if(A.source=a,A.defaultDefaultValue=n[p].default,this.s(p,A),e.OVERRIDE_PROPERTY_REGEX.test(p)?A.scope=void 0:(A.scope=y.isUndefinedOrNull(A.scope)?c:A.scope,A.restricted=y.isUndefinedOrNull(A.restricted)?!!h?.includes(p):A.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.f[p]=n[p],delete n[p];continue}else this.d[p]=n[p],n[p].policy?.name&&this.e.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),d.push(p)}const l=s.allOf;if(l)for(const p of l)d.push(...this.m(p,r,a,h,c));return d}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const r=a=>{const h=a.properties;if(h)for(const d in h)this.o(d,h[d]);a.allOf?.forEach(r)};r(s)}o(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.g.properties[s]=r;break}}p(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const r=`[${s}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this.i.fire()}r(){const s={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,r){const a=this.a.get(s);let h=a?.value,c=a?.source;y.isUndefined(h)&&(h=r.defaultDefaultValue,c=void 0),y.isUndefined(h)&&(h=u(r.type)),r.default=h,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(S){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let r=f.exec(S);for(;r?.length;){const a=r[1].trim();a&&s.push(a),r=f.exec(S)}}return(0,i.distinct)(s)}e.overrideIdentifiersFromKey=t;function o(S){return S.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=o;function u(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new m;w.Registry.add(e.Extensions.Configuration,g);function E(S,s){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?M.localize(7,null,S):g.getConfigurationProperties()[S]!==void 0?M.localize(8,null,S):s.policy?.name&&g.getPolicyConfigurations().get(s.policy?.name)!==void 0?M.localize(9,null,S,s.policy?.name,g.getPolicyConfigurations().get(s.policy?.name)):null:M.localize(6,null)}e.validateProperty=E;function b(){const S=[],s=g.getConfigurationProperties();for(const r of Object.keys(s))S.push([r,s[r].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=b}),define(De[157],Ce([1,0,16,4,107,7,28,23,9,2,40,89,30]),function(te,e,i,k,y,M,C,R,w,T,O,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(r={},a=[],h=[],c){this.c=r,this.d=a,this.f=h,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof v)return a;const h=new f("");return h.parseRaw(a),h.configurationModel});this.g=r.reduce((a,h)=>h===a?h:a.merge(h),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const h=this.rawConfiguration.getValue(r),c=a?this.rawConfiguration.getOverrideValue(r,a):void 0,d=a?this.rawConfiguration.override(a).getValue(r):h;return{value:h,override:c,merged:d}}getOverrideValue(r,a){const h=this.l(a);return h?r?(0,O.getConfigurationValue)(h,r):h:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const h of this.overrides)h.identifiers.includes(r)&&a.push(...h.keys);return i.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return i.distinct(r)}override(r){let a=this.b.get(r);return a||(a=this.h(r),this.b.set(r,a)),a}merge(...r){const a=R.deepClone(this.contents),h=R.deepClone(this.overrides),c=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const n of r)if(d.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(a,n.contents);for(const l of n.overrides){const[p]=h.filter(A=>i.equals(A.identifiers,l.identifiers));p?(this.j(p.contents,l.contents),p.keys.push(...l.keys),p.keys=i.distinct(p.keys)):h.push(R.deepClone(l))}for(const l of n.keys)c.indexOf(l)===-1&&c.push(l)}return new v(a,c,h,d.every(n=>n instanceof v)?void 0:d)}freeze(){return this.a=!0,this}clone(){return new v(R.deepClone(this.contents),[...this.keys],R.deepClone(this.overrides))}h(r){const a=this.l(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const h={};for(const c of i.distinct([...Object.keys(this.contents),...Object.keys(a)])){let d=this.contents[c];const n=a[c];n&&(typeof d=="object"&&typeof n=="object"?(d=R.deepClone(d),this.j(d,n)):d=n),h[c]=d}return new v(h,this.keys,this.overrides)}j(r,a){for(const h of Object.keys(a)){if(h in r&&w.isObject(r[h])&&w.isObject(a[h])){this.j(r[h],a[h]);continue}r[h]=R.deepClone(a[h])}}k(r){return this.a&&!Object.isFrozen(r)?R.deepFreeze(r):r}l(r){let a=null,h=null;const c=d=>{d&&(h?this.j(h,d):h=R.deepClone(d))};for(const d of this.overrides)i.equals(d.identifiers,[r])?a=d.contents:d.identifiers.includes(r)&&c(d.contents);return c(a),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,a){this.m(r),(0,O.addToValueTree)(this.contents,r,a,h=>{throw new Error(h)})}removeValue(r){this.n(r)&&(0,O.removeFromValueTree)(this.contents,r)}m(r){let a=this.keys.length;for(let h=0;h<a;h++)r.indexOf(this.keys[h])===0&&(a=h);this.keys.splice(a,1,r)}n(r){const a=this.keys.indexOf(r);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class f{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!w.isUndefinedOrNull(r)){const h=this.g(r);this.parseRaw(h,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:h,keys:c,overrides:d,restricted:n,hasExcludedProperties:l}=this.h(r,a);this.b=new v(h,c,d,l?[r]:void 0),this.c=n||[]}g(r){let a={},h=null,c=[];const d=[],n=[];function l(A){Array.isArray(c)?c.push(A):h!==null&&(c[h]=A)}const p={onObjectBegin:()=>{const A={};l(A),d.push(c),c=A,h=null},onObjectProperty:A=>{h=A},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const A=[];l(A),d.push(c),c=A,h=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:l,onError:(A,L,q)=>{n.push({error:A,offset:L,length:q})}};if(r)try{y.visit(r,p),a=c[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return a}h(r,a){const h=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=this.j(r,h,!0,a);r=c.raw;const d=(0,O.toValuesTree)(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),n=Object.keys(r),l=this.l(r,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:d,keys:n,overrides:l,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(r,a,h,c){let d=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:d};const n={},l=[];for(const p in r)if(I.OVERRIDE_PROPERTY_REGEX.test(p)&&h){const A=this.j(r[p],a,!1,c);n[p]=A.raw,d=d||A.hasExcludedProperties,l.push(...A.restricted)}else{const A=a[p],L=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&l.push(p),(L===void 0||c.scopes===void 0||c.scopes.includes(L))&&!(c.skipRestricted&&A?.restricted)?n[p]=r[p]:d=!0}return{raw:n,restricted:l,hasExcludedProperties:d}}l(r,a){const h=[];for(const c of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(c)){const d={};for(const n in r[c])d[n]=r[c][n];h.push({identifiers:(0,I.overrideIdentifiersFromKey)(c),keys:Object.keys(d),contents:(0,O.toValuesTree)(d,a)})}return h}}e.ConfigurationModelParser=f;class t extends M.Disposable{constructor(r,a,h,c){super(),this.f=r,this.g=a,this.h=c,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(h.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(k.Event.any(k.Event.filter(this.h.onDidFilesChange,d=>d.contains(this.f)),k.Event.filter(this.h.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&h.isEqual(d.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class o{constructor(r,a,h,c,d,n,l,p,A,L,q,K,j){this.a=r,this.b=a,this.value=h,this.overrideIdentifiers=c,this.c=d,this.d=n,this.f=l,this.g=p,this.h=A,this.j=L,this.k=q,this.l=K,this.m=j}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(r,a,h,c,d=new v,n=new v,l=new C.ResourceMap,p=new v,A=new C.ResourceMap,L=!0){this.c=r,this.d=a,this.f=h,this.g=c,this.h=d,this.j=n,this.l=l,this.m=p,this.n=A,this.p=L,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(r,a,h){return this.s(r,a,h).getValue(r)}updateValue(r,a,h={}){let c;h.resource?(c=this.n.get(h.resource),c||(c=new v,this.n.set(h.resource,c))):c=this.m,a===void 0?c.removeValue(r):c.setValue(r,a),h.resource||(this.a=null)}inspect(r,a,h){const c=this.s(r,a,h),d=i.distinct(c.overrides.map(p=>p.identifiers).flat()).filter(p=>c.getOverrideValue(r,p)!==void 0),n=this.w(a.resource,h),l=a.resource?this.n.get(a.resource)||this.m:this.m;return new o(r,a,c.getValue(r),d.length?d:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),h?this.j.freeze():void 0,n?n.freeze():void 0,l.inspect(r,a.overrideIdentifier))}keys(r){const a=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,a){this.l.set(r,a),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const h=[];if(!a){const{added:c,updated:d,removed:n}=b(this.c,r);a=[...c,...d,...n]}for(const c of a)for(const d of(0,I.overrideIdentifiersFromKey)(c)){const n=this.c.getKeysForOverrideIdentifier(d),l=r.getKeysForOverrideIdentifier(d),p=[...l.filter(A=>n.indexOf(A)===-1),...n.filter(A=>l.indexOf(A)===-1),...n.filter(A=>!R.equals(this.c.override(d).getValue(A),r.override(d).getValue(A)))];h.push([d,p])}return this.updateDefaultConfiguration(r),{keys:a,overrides:h}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:h,removed:c}=b(this.d,r),d=[...a,...h,...c];return d.length&&this.updatePolicyConfiguration(r),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:h,removed:c,overrides:d}=b(this.applicationConfiguration,r),n=[...a,...h,...c];return n.length&&this.updateApplicationConfiguration(r),{keys:n,overrides:d}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:h,removed:c,overrides:d}=b(this.localUserConfiguration,r),n=[...a,...h,...c];return n.length&&this.updateLocalUserConfiguration(r),{keys:n,overrides:d}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:h,removed:c,overrides:d}=b(this.remoteUserConfiguration,r),n=[...a,...h,...c];return n.length&&this.updateRemoteUserConfiguration(r),{keys:n,overrides:d}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:h,removed:c,overrides:d}=b(this.workspaceConfiguration,r),n=[...a,...h,...c];return n.length&&this.updateWorkspaceConfiguration(r),{keys:n,overrides:d}}compareAndUpdateFolderConfiguration(r,a){const h=this.r.get(r),{added:c,updated:d,removed:n,overrides:l}=b(h,a),p=[...c,...d,...n];return(p.length||!h)&&this.updateFolderConfiguration(r,a),{keys:p,overrides:l}}compareAndDeleteFolderConfiguration(r){const a=this.r.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:h,updated:c,removed:d,overrides:n}=b(a,void 0);return{keys:[...h,...c,...d],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,a,h){let c=this.t(a,h);return a.overrideIdentifier&&(c=c.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}t({resource:r},a){let h=this.u();if(a&&r){const c=a.getFolder(r);c&&(h=this.v(c.uri)||h);const d=this.n.get(r);d&&(h=h.merge(d))}return h}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let a=this.b.get(r);if(!a){const h=this.u(),c=this.l.get(r);c?(a=h.merge(c),this.p&&(a=a.freeze()),this.b.set(r,a)):a=h}return a}w(r,a){if(a&&r){const h=a.getFolder(r);if(h)return this.l.get(h.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,a)=>{const{contents:h,overrides:c,keys:d}=this.l.get(a);return r.push([a,{contents:h,overrides:c,keys:d}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(a=>r.add(a)),this.userConfiguration.freeze().keys.forEach(a=>r.add(a)),this.j.freeze().keys.forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(h=>r.add(h))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(h=>r.add(h))),[...r.values()]}y(r){const a=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(h=>a.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(h=>a.add(h)),this.j.getKeysForOverrideIdentifier(r).forEach(h=>a.add(h)),this.l.forEach(h=>h.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c))),[...a.values()]}static parse(r){const a=this.A(r.defaults),h=this.A(r.policy),c=this.A(r.application),d=this.A(r.user),n=this.A(r.workspace),l=r.folders.reduce((p,A)=>(p.set(T.URI.revive(A[0]),this.A(A[1])),p),new C.ResourceMap);return new u(a,h,c,d,new v,n,l,new v,new C.ResourceMap,!1)}static A(r){return new v(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function g(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const c of s)c.keys.forEach(d=>r.add(d)),c.overrides.forEach(([d,n])=>{const l=(0,C.getOrSet)(a,d,new Set);n.forEach(p=>l.add(p))});const h=[];return a.forEach((c,d)=>h.push([d,[...c.values()]])),{keys:[...r.values()],overrides:h}}e.mergeChanges=g;class E{constructor(r,a,h,c){this.change=r,this.b=a,this.c=h,this.d=c,this.f=void 0;const d=new Set;r.keys.forEach(l=>d.add(l)),r.overrides.forEach(([,l])=>l.forEach(p=>d.add(p))),this.affectedKeys=[...d.values()];const n=new v;this.affectedKeys.forEach(l=>n.setValue(l,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(r,a){if(this.g(this.a,r)){if(a){const h=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.b?.workspace):void 0,c=this.c.getValue(r,a,this.d);return!R.equals(h,c)}return!0}return!1}g(r,a){let h=(0,O.toValuesTree)({[a]:!0},()=>{}),c;for(;typeof h=="object"&&(c=Object.keys(h)[0]);){if(r=r[c],!r)return!1;h=h[c]}return!0}}e.ConfigurationChangeEvent=E;function b(s,r){const{added:a,removed:h,updated:c}=S(r?.rawConfiguration,s?.rawConfiguration),d=[],n=s?.getAllOverrideIdentifiers()||[],l=r?.getAllOverrideIdentifiers()||[];if(r){const p=l.filter(A=>!n.includes(A));for(const A of p)d.push([A,r.getKeysForOverrideIdentifier(A)])}if(s){const p=n.filter(A=>!l.includes(A));for(const A of p)d.push([A,s.getKeysForOverrideIdentifier(A)])}if(r&&s){for(const p of n)if(l.includes(p)){const A=S({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)});d.push([p,[...A.added,...A.removed,...A.updated]])}}return{added:a,removed:h,updated:c,overrides:d}}function S(s,r){const a=s?r?s.keys.filter(d=>r.keys.indexOf(d)===-1):[...s.keys]:[],h=r?s?r.keys.filter(d=>s.keys.indexOf(d)===-1):[...r.keys]:[],c=[];if(s&&r){for(const d of r.keys)if(s.keys.indexOf(d)!==-1){const n=(0,O.getConfigurationValue)(r.contents,d),l=(0,O.getConfigurationValue)(s.contents,d);R.equals(n,l)||c.push(d)}}return{added:a,removed:h,updated:c}}}),define(De[90],Ce([1,0,11,3]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends i.ErrorNoTelemetry{static isNotAvailable(R){return R instanceof M&&R._code===y.NotAvailable}static isTemporarilyNotAvailable(R){return R instanceof M&&R._code===y.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof M&&R._code===y.NoResolverFound}static isHandled(R){return R instanceof M&&R.isHandled}constructor(R,w=y.Unknown,T){super(R),this._message=R,this._code=w,this._detail=T,this.isHandled=w===y.NotAvailable&&T===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(De[63],Ce([1,0,13]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(T){return T.scheme===i.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=k;function y(T){if(!T)return;const O=T.indexOf("+");return O<0?T:T.substr(0,O)}e.getRemoteName=y;function M(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=M;function C(T){const{host:O,port:I}=w(T);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:I}}e.parseAuthorityWithPort=C;function R(T,O){let{host:I,port:m}=w(T);return typeof m>"u"&&(m=O),{host:I,port:m}}e.parseAuthorityWithOptionalPort=R;function w(T){const O=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const I=T.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const m=T.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:T,port:void 0}}}),define(De[26],Ce([1,0,10,3,63]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function C(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var w;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class T{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,o){if(typeof t>"u"||t===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof t=="string"||typeof o=="string"){const u=typeof t=="string"?t:t.value,g=typeof o=="string"?o:o.value;return i.equalsIgnoreCase(u,g)}return t.c===o.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=T;function O(f){return I(f)}e.isApplicationScopedExtension=O;function I(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function v(f,t){if(t){const o=`onResolveRemoteAuthority:${(0,y.getRemoteName)(t)}`;return f.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[158],Ce([1,0,10,85,26,21,2,11,48]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,i.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=T;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(a){const h=a.manifest?a.manifest.version:a.version,c=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new I(a.identifier,h,c)}static parse(a){const h=O.exec(a);return h&&h[1]&&h[2]?new I({id:h[1]},h[2],h[4]||void 0):null}constructor(a,h,c="undefined"){this.version=h,this.targetPlatform=c,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof I?T(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=I;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const a=m.exec(r);return a&&a[1]?[t(a[1]),a[2]]:[t(r),void 0]}e.getIdAndVersion=v;function f(r,a){return`${r}.${a}`}e.getExtensionId=f;function t(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function o(r,a){return t(f(r,a))}e.getGalleryExtensionId=o;function u(r,a){const h=[],c=d=>{for(const n of h)if(n.some(l=>T(a(l),a(d))))return n;return null};for(const d of r){const n=c(d);n?n.push(d):h.push([d])}return h}e.groupByExtension=u;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function E(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function b(r,a){const h=[],c=a.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const d=c.shift();if(d&&h.every(n=>!T(n.identifier,{id:d}))){const n=r.filter(l=>T(l.identifier,{id:d}));n.length===1&&(h.push(n[0]),c.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}e.getExtensionDependencies=b;async function S(r,a){if(!M.isLinux)return!1;let h;try{h=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){a.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(d))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=S;async function s(r,a){const h=await S(r,a),c=(0,k.getTargetPlatform)(h?"alpine":M.platform,w.arch);return a.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=s}),define(De[159],Ce([1,0,21,48,2,34]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(T){if(i.platform===2&&/^penguin(\.|$)/i.test(T))return"chromebook"}async function R(T,O,I,m,v,f,t,o,u,g){const E=Object.create(null);E["common.machineId"]=t,E.sessionID=(0,M.generateUuid)()+Date.now(),E.commitHash=v,E.version=f,E["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,i.PlatformToString)(i.platform),E["common.nodePlatform"]=k.platform,E["common.nodeArch"]=m,E["common.product"]=g||"desktop",o&&(E["common.msftInternal"]=o);let b=0;const S=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),i.isLinuxSnap&&(E["common.snap"]="true");const s=C(I);s&&(E["common.platformDetail"]=s);try{const r=await T.readFile(y.URI.file(u));E["common.source"]=r.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=R;function w(T){const O=k.env.USERDNSDOMAIN;if(!O)return!1;const I=O.toLowerCase();return T.some(m=>I===m)}e.verifyMicrosoftInternalDomain=w}),define(De[160],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[91],Ce([1,0,23,117,9,40,159,160]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class w{constructor(d){this.value=d}}e.TrustedTelemetryValue=w;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,k.staticObservableValue)(0)}publicLog(d,n){return Promise.resolve(void 0)}publicLog2(d,n){return this.publicLog(d,n)}publicLogError(d,n){return Promise.resolve(void 0)}publicLogError2(d,n){return this.publicLogError(d,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class O{async publicLog(d,n,l){}async publicLogError(d,n,l){}}e.NullEndpointTelemetryService=O,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,d){return d.onDidChangeConfiguration(n=>{n.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(n.source),configurationKeys:E(n.sourceConfig)})})}e.configurationTelemetry=I;function m(c,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!c.enableTelemetry||d.extensionTestsLocationURI)}e.supportsTelemetry=m;function v(c,d){return!(d.isBuilt||d.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=v;function f(c){const d=c.getValue(R.TELEMETRY_SETTING_ID),n=c.getValue("telemetry.enableCrashReporter");if(c.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function t(c){const d={},n={},l={};g(c,l);for(let p in l){p=p.length>150?p.substr(p.length-149):p;const A=l[p];typeof A=="number"?n[p]=A:typeof A=="boolean"?n[p]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${A.length}`),d[p]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(d[p]=A)}return{properties:d,measurements:n}}e.validateTelemetryData=t;const o=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function u(c){if(!c)return"none";for(const d of o)if(c.startsWith(`${d}+`))return d;return"other"}e.cleanRemoteAuthority=u;function g(c,d,n=0,l){if(!!c)for(const p of Object.getOwnPropertyNames(c)){const A=c[p],L=l?l+p:p;Array.isArray(A)?d[L]=(0,i.safeStringify)(A):A instanceof Date?d[L]=A.toISOString():(0,y.isObject)(A)?n<2?g(A,d,n+1,L+"."):d[L]=(0,i.safeStringify)(A):d[L]=A}}function E(c){if(!c)return[];const d=[];return b(d,"",c),d}function b(c,d,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(l=>b(c,d?`${d}.${l}`:l,n[l])):c.push(d)}function S(c,d){const n=c.msftInternalDomains||[],l=d.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(n)||l}e.isInternalTelemetry=S;function s(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=s;function r(c,d){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let n=c;const l=[];for(const q of d)for(;;){const K=q.exec(c);if(!K)break;l.push([K.index,q.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(n="";;){const q=A.exec(c);if(!q)break;const K=l.some(([j,P])=>q.index<P&&j<A.lastIndex);!p.test(q[0])&&!K&&(n+=c.substring(L,q.index)+"<REDACTED: user-file-path>",L=A.lastIndex)}return L<c.length&&(n+=c.substr(L)),n}function a(c){if(!c)return c;const d=c.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of n)if(l.regex.test(d))return`<REDACTED: ${l.label}>`;return c}function h(c,d){return(0,i.cloneAndChange)(c,n=>{if(n instanceof w)return n.value;if(typeof n=="string"){let l=n.replaceAll("%20"," ");l=r(l,d);for(const p of d)l=l.replace(p,"");return l=a(l),l}})}e.cleanData=h}),define(De[161],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,M,C=5){const R=M(w=>{const T=typeof w=="string"?w:w.data;let O=this.a.get(y);if(O){O.data.push(T);return}const I=setTimeout(()=>this.flushBuffer(y),C);O={data:[T],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(y),R.dispose()}},this.a.set(y,O)});return R}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const M=this.a.get(y);M&&(this.a.delete(y),this.b(y,M.data.join("")))}}e.TerminalDataBufferer=i}),define(De[162],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function k(M){return M===i.HIGH_CONTRAST_DARK||M===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=k;function y(M){return M===i.DARK||M===i.HIGH_CONTRAST_DARK}e.isDark=y}),define(De[64],Ce([1,0,120,4,7,3,30,162]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var w;(function(o){function u(g){return g&&typeof g=="object"&&typeof g.id=="string"}o.isThemeColor=u})(w=e.ThemeColor||(e.ThemeColor={}));function T(o){return{id:o}}e.themeColorFromId=T;var O;(function(o){function u(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||w.isThemeColor(h.color))}o.isThemeIcon=u;const g=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function E(h){const c=g.exec(h);if(!c)return;const[,d]=c;return{id:d}}o.fromString=E;function b(h){return{id:h}}o.fromId=b;function S(h,c){let d=h.id;const n=d.lastIndexOf("~");return n!==-1&&(d=d.substring(0,n)),c&&(d=`${d}~${c}`),{id:d}}o.modify=S;function s(h){const c=h.id.lastIndexOf("~");if(c!==-1)return h.id.substring(c+1)}o.getModifier=s;function r(h,c){return h.id===c.id&&h.color?.id===c.color?.id}o.isEqual=r;function a(h,c){return{id:h.id,color:c?T(c):void 0}}o.asThemeIcon=a,o.asClassNameArray=i.CSSIcon.asClassNameArray,o.asClassName=i.CSSIcon.asClassName,o.asCSSSelector=i.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function I(o){switch(o){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new k.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,y.toDisposable)(()=>{const g=this.a.indexOf(u);this.a.splice(g,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const v=new m;C.Registry.add(e.Extensions.ThemingContribution,v);function f(o){return v.onColorThemeChange(o)}e.registerThemingParticipant=f;class t extends y.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(g=>this.n(g)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,g){let E=this.h.getColor(u);return E&&g&&(E=g(E,this.h)),E?E.toString():null}}e.Themable=t}),define(De[163],Ce([1,0,4,40,3,12]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(t){t.Http="http",t.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=I;function m(t,o,u,g){if(u===1)return!1;if(u===2&&I(o)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.isPortPrivileged=m;class v{constructor(o,u,g){this.remoteAddress=o,this.localAddress=u,this.b=g,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=v;let f=class{constructor(o,u){this.i=o,this.j=u,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],u=Array.from(this.d.values());for(const g of u){const E=Array.from(g.values());for(const b of E){const S=await b.value;S&&o.push(S)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:u}of o.values())await u.then(g=>g?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,u,g,E,b){this.o(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:g,privacy:E,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(I(o)||O(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const g=this.q(o,u);if(g)return++g.refcount,g.value}openTunnel(o,u,g,E,b=!1,S,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${E}.`),!o)return;if(u||(u="localhost"),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(o,u,g,E,b,S,s);return r?r.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.m(a);return(a.tunnelRemoteHost!==u||a.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(h),h}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this.d.get(o.tunnelRemoteHost);if(u){const g=u.get(o.tunnelRemotePort);g&&(g.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,g))}}}}async n(o,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const E=g.value.then(async b=>{b&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(u),E}}async closeTunnel(o,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const g=this.d.get(o);if(g&&g.has(u)){const E=g.get(u);E.refcount=0,await this.n(o,u,E)}}o(o,u,g){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(u,{refcount:1,value:g})}async p(o,u){const g=this.d.get(o);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(o))}q(o,u){const g=[o];O(o)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):I(o)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(b=>this.d.get(b));for(const b of E){const S=b?.get(u);if(S)return S}}canTunnel(o){return!!T(o)}s(o,u,g,E,b,S,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${E}.`);const r=g;this.h.add(r);const a=E===void 0?g:E,h={elevationRequired:b?this.isPortPrivileged(a):!1},c={remoteAddress:{host:u,port:g},localAddressPort:E,privacy:S,public:S?S!==R.Private:void 0,protocol:s},d=o.forwardPort(c,h);return d?(this.o(u,g,d),d.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),d}};f=qe([Ve(0,M.ILogService),Ve(1,k.IConfigurationService)],f),e.AbstractTunnelService=f}),define(De[164],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var k;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(k=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[165],Ce([1,0,13]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(w){return w.scheme!==i.Schemas.file&&w.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=k;function y(w){if(w.folders.length)return w.folders.every(T=>k(T.uri))?w.folders[0].uri:void 0;if(w.configuration&&k(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=y;function M(w){return y(w)?.scheme}e.getVirtualWorkspaceScheme=M;function C(w){return y(w)?.authority}e.getVirtualWorkspaceAuthority=C;function R(w){return y(w)!==void 0}e.isVirtualWorkspace=R}),define(De[49],Ce([1,0,132,19,46,22,2,3,13]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function T(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,k.basename)(r)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const h=r;if(h.configuration)return{id:h.id,configPath:h.configuration};if(h.folders.length===1)return{id:h.id,uri:h.folders[0].uri}}e.toWorkspaceIdentifier=O;function I(r){const a=r;return typeof a?.id=="string"&&C.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=I;function m(r){const a=r;if(a?.uri)return{id:a.id,uri:C.URI.revive(a.uri)};const h=r;if(h?.configPath)return{id:h.id,configPath:C.URI.revive(h.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=m;var v;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=f;function t(r){const a=r;return!!(a&&typeof a=="object"&&C.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=t;class o{constructor(a,h,c,d,n){this.h=a,this.j=c,this.k=d,this.l=n,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=h}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class u{constructor(a,h){this.raw=h,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,M.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function g(r){return new u({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(r,a){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,a.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function b(r){let a;return C.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=b;function S(r,a){return!E(r,a)&&!b(r)}e.isSavedWorkspace=S;function s(r){return(typeof r=="string"?(0,k.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(De[50],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const M=this.c++;return this.b.set(M,y),this.e(),M}get(y,M){return this.b.has(y)?this.b.get(y)[M]:void 0}delete(y){this.b.delete(y),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(De[37],Ce([1,0,13,22,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new k.ExtUri(R=>{const w=this.b.get(R.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(R,w){w===null?this.b.delete(R.scheme):this.b.set(R.scheme,w)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(De[166],Ce([1,0,15]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(C,R,w){this.h=new Map,this.a=C,this.b=R,this.c=w,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(T=>(this.f=T,this)),this.g=this.c.onDidChangeStorage(T=>{T.shared===this.b&&T.key===this.a&&(this.f=T.value)}),this.i=new i.RunOnceScheduler(()=>{const T=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of T.values())O.complete()}catch(O){for(const I of T.values())I.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,R){let w=this.f[C];return typeof w>"u"&&(w=R),w}update(C,R){this.f[C]=R;const w=this.h.get(C);if(w!==void 0)return w.p;const T=new i.DeferredPromise;return this.h.set(C,T),this.i.isScheduled()||this.i.schedule(),T.p}dispose(){this.g.dispose()}}e.ExtensionMemento=k;class y extends k{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,R){super(C.identifier.value,!0,R),this.j=C}}e.ExtensionGlobalMemento=y}),define(De[167],Ce([1,0,4,2]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,R,w,T){const I=this.c.getNotebookDocument(k.URI.revive(C)).acceptModelChanged(R.value,w,T);this.b.fire(I)}$acceptDirtyStateChanged(C,R){this.c.getNotebookDocument(k.URI.revive(C)).acceptDirty(R)}$acceptModelSaved(C){const R=this.c.getNotebookDocument(k.URI.revive(C));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(De[14],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class k{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[168],Ce([1,0,26,4]),function(te,e,i,k){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(R,w){y.set(this,void 0),this.b=new k.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(R.identifier),Je(this,y,w,"f"),Re(this,y,"f").onDidChangePassword(T=>{T.extensionId===this.a&&this.b.fire({key:T.key})})}get(R){return Re(this,y,"f").get(this.a,R)}store(R,w){return Re(this,y,"f").store(this.a,R,w)}delete(R){return Re(this,y,"f").delete(this.a,R)}}e.ExtensionSecrets=M,y=new WeakMap}),define(De[65],Ce([1,0,3,163,4,14]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(w){function T(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:I.protocol}}w.fromApiTunnel=T;function O(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==k.TunnelPrivacyId.ConstantPrivate&&I.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}w.fromServiceTunnel=O})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let R=class{constructor(T){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,O){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,O){return{dispose:()=>{}}}async $providePortAttributes(T,O,I,m,v){return[]}async $forwardPort(T,O){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([Ve(0,M.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(De[51],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class k{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=k}),define(De[169],Ce([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(w){let T=this.buffers.indexOf(w);return T<0&&(T=this.buffers.length,this.buffers.push(w)),T}}function y(R,w){if(w.serializeBuffersForPostMessage){const T=new k,O=(v,f)=>{if(f instanceof ArrayBuffer){const t=T.add(f);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(f)){const t=M(f);if(t){const o=T.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:t,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},I=JSON.stringify(R,O),m=T.buffers.map(v=>{const f=new Uint8Array(v);return i.VSBuffer.wrap(f)});return{message:I,buffers:m}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=y;function M(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(R,w){const T=w.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),O=w.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const f=v,{index:t}=f,o=T[t];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(R,O),arrayBuffers:T}}e.deserializeWebviewMessage=C}),define(De[92],Ce([1,0,140,9,2,7,3,30,36,13]),function(te,e,i,k,y,M,C,R,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var I;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(I=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(X){const ee=X;return!!ee&&typeof ee.getSelection=="function"&&!!ee.onDidChangeSelection}e.isEditorPaneWithSelection=m;function v(X,ee,fe){for(const oe of fe.visibleEditorPanes)if(oe.group.id===ee&&X.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=v;function f(X){if(c(X))return!1;const ee=X;return y.URI.isUri(ee?.resource)}e.isResourceEditorInput=f;function t(X){if(c(X))return!1;const ee=X;return ee?.original!==void 0&&ee.modified!==void 0}e.isResourceDiffEditorInput=t;function o(X){if(c(X)||t(X))return!1;const ee=X;return ee?.primary!==void 0&&ee.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function u(X){if(c(X))return!1;const ee=X;return ee?ee.resource===void 0||ee.resource.scheme===T.Schemas.untitled||ee.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;const g=/Untitled-\d+/;function E(X){return X.scheme===T.Schemas.untitled&&X.path.length>1&&!g.test(X.path)}e.isUntitledWithAssociatedResource=E;function b(X){if(c(X))return!1;const ee=X;return y.URI.isUri(ee?.base?.resource)&&y.URI.isUri(ee?.input1?.resource)&&y.URI.isUri(ee?.input2?.resource)&&y.URI.isUri(ee?.result?.resource)}e.isResourceMergeEditorInput=b;var S;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(S=e.Verbosity||(e.Verbosity={}));var s;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(ee,fe){let oe=this.a.get(ee);return oe||(oe={source:ee,label:fe},this.a.set(ee,oe)),oe.source}getSourceLabel(ee){return this.a.get(ee)?.label??ee}}e.SaveSourceRegistry=new r;var a;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends M.Disposable{}e.AbstractEditorInput=h;function c(X){return X instanceof h}e.isEditorInput=c;function d(X){const ee=X;return y.URI.isUri(ee?.preferredResource)}function n(X){const ee=X;return c(ee?.primary)&&c(ee?.secondary)}e.isSideBySideEditorInput=n;function l(X){const ee=X;return c(ee?.modified)&&c(ee?.original)}e.isDiffEditorInput=l;function p(X){return c(X?.editor)}e.isEditorInputWithOptions=p;function A(X){const ee=X;return p(X)&&ee?.group!==void 0}e.isEditorInputWithOptionsAndGroup=A;function L(X){const ee=X;return typeof ee?.groupId=="number"&&c(ee.editor)}e.isEditorIdentifier=L;var q;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(q=e.EditorCloseContext||(e.EditorCloseContext={}));var K;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(K=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var j;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(j=e.SideBySideEditor||(e.SideBySideEditor={}));class P{getOriginalUri(ee,fe){if(!ee)return;if(b(ee))return e.EditorResourceAccessor.getOriginalUri(ee.result,fe);if(fe?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(ee);if(ue&&ce){if(fe?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:fe.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:fe.filterByScheme})};if(fe?.supportSideBySide===j.ANY)return this.getOriginalUri(ue,{filterByScheme:fe.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:fe.filterByScheme});ee=fe.supportSideBySide===j.PRIMARY?ue:ce}}if(t(ee)||o(ee)||b(ee))return;const oe=d(ee)?ee.preferredResource:ee.resource;return!oe||!fe||!fe.filterByScheme?oe:this.b(oe,fe.filterByScheme)}a(ee){return n(ee)||o(ee)?{primary:ee.primary,secondary:ee.secondary}:l(ee)||t(ee)?{primary:ee.modified,secondary:ee.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ee,fe){if(!ee)return;if(b(ee))return e.EditorResourceAccessor.getCanonicalUri(ee.result,fe);if(fe?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(ee);if(ue&&ce){if(fe?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:fe.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:fe.filterByScheme})};if(fe?.supportSideBySide===j.ANY)return this.getCanonicalUri(ue,{filterByScheme:fe.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:fe.filterByScheme});ee=fe.supportSideBySide===j.PRIMARY?ue:ce}}if(t(ee)||o(ee)||b(ee))return;const oe=ee.resource;return!oe||!fe||!fe.filterByScheme?oe:this.b(oe,fe.filterByScheme)}b(ee,fe){if(Array.isArray(fe)){if(fe.some(oe=>ee.scheme===oe))return ee}else if(fe===ee.scheme)return ee}}e.EditorResourceAccessor=new P;var N;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(N=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(ee){const fe=this.a=ee.get(C.IInstantiationService);for(const[oe,ue]of this.c)this.e(oe,ue,fe);this.c.clear()}e(ee,fe,oe){const ue=oe.createInstance(fe);this.d.set(ee,ue)}registerFileEditorFactory(ee){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ee}getFileEditorFactory(){return(0,k.assertIsDefined)(this.b)}registerEditorSerializer(ee,fe){if(this.c.has(ee)||this.d.has(ee))throw new Error(`A editor serializer with type ID '${ee}' was already registered.`);return this.a?this.e(ee,fe,this.a):this.c.set(ee,fe),(0,M.toDisposable)(()=>{this.c.delete(ee),this.d.delete(ee)})}getEditorSerializer(ee){return this.d.get(typeof ee=="string"?ee:ee.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new F);async function $(X,ee,fe){return!X||!X.length?[]:await Promise.all(X.map(async oe=>{const ue=y.URI.revive(oe.fileUri);if(!ue){fe.info("Cannot resolve the path because it is not valid.",oe);return}if(!await ee.canHandleResource(ue)){fe.info("Cannot resolve the path because it cannot be handled",oe);return}let he=oe.exists,Y=oe.type;if(typeof he!="boolean"||typeof Y!="number")try{Y=(await ee.stat(ue)).isDirectory?w.FileType.Directory:w.FileType.Unknown,he=!0}catch(Se){fe.error(Se),he=!1}if(!he&&oe.openOnlyIfExists){fe.info("Cannot resolve the path because it does not exist",oe);return}if(Y===w.FileType.Directory){fe.info("Cannot resolve the path because it is a directory",oe);return}const ge={...oe.options,pinned:!0};return he?{resource:ue,options:ge}:{resource:ue,options:ge,forceUntitled:!0}}))}e.pathsToEditors=$;var z;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function V(X){const ee=X;if(!ee)return!1;const fe=ee;if(fe.modified)return V(fe.modified);const oe=ee;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=V}),define(De[170],Ce([1,0,4,15,141]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,w,T,O){const I={command:R};if(w&&Object.keys(w).length>0&&(I.arguments=w),this.s("request",I),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(I.seq);if(v){this.f.delete(I.seq);const f={type:"response",seq:0,request_seq:I.seq,success:!1,command:R,message:(0,y.localize)(0,null,O,R)};v(f)}},O)}return T&&this.f.set(I.seq,T),I.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,w){return R.type!=="event"||w.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,k.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const w=R,T=this.f.get(w.request_seq);T&&(this.f.delete(w.request_seq),T(w));break}}}}s(R,w){w.type=R,w.seq=this.d++,this.sendMessage(w)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((w,T)=>R.set(T,w)),await(0,k.timeout)(500),R.forEach((w,T)=>{w({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.f.delete(T)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(De[171],Ce([1,0,142,41,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(49,null)});const M=m=>i.localize(50,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(51,null)};var C;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(C=e.State||(e.State={}));function R(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var w;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var I;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[172],Ce([1,0,10,2,19,23,13]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function w(a,h,c){return a.replace(R,function(d,n){return h&&n.length>0&&n[0]!=="_"?d:c&&c.hasOwnProperty(n)?c[n]:d})}e.formatPII=w;function T(a){const h={};for(const c of Object.keys(a))c.startsWith("!")||(h[c]=a[c]);return h}e.filterExceptionsFromTelemetry=T;function O(a){return a.configuration.request==="attach"&&!I(a)&&(!a.parentSession||O(a.parentSession))}e.isSessionAttach=O;function I(a){let h=a.configuration.type;if(!!h)return h==="vslsShare"&&(h=a.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(h,"extensionhost")||(0,i.equalsIgnoreCase)(h,"pwa-extensionhost")?a:a.parentSession?I(a.parentSession):void 0}e.getExtensionHostDebugSession=I;function m(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=m;function v(a,h,c){let d,n=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=l.exec(a);){const A=p.index+1,L=A+p[0].length;if(A<=h&&L>=c){d=p[0],n=A;break}}if(d){const A=/\w+/g;let L=null;for(;(L=A.exec(d))&&!(L.index+1+n+L[0].length>=c););L&&(d=d.substring(0,A.lastIndex))}return d?{start:n,end:n+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=v;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(a){return!!(a&&a.match(f))}e.isUri=t;function o(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(t(a.path))return k.URI.parse(a.path);if((0,y.isAbsolute)(a.path))return k.URI.file(a.path)}return a.path}function u(a){if(typeof a.path=="object"){const h=k.URI.revive(a.path);if(h)return h.scheme===C.Schemas.file?h.fsPath:h.toString()}return a.path}function g(a,h){const c=h?o:u,d=(0,M.deepClone)(a);return b(d,(n,l)=>{n&&l&&(l.path=c(l))}),d}e.convertToDAPaths=g;function E(a,h){const c=h?o:u,d=(0,M.deepClone)(a);return b(d,(n,l)=>{!n&&l&&(l.path=c(l))}),d}e.convertToVSCPaths=E;function b(a,h){switch(a.type){case"event":{const c=a;switch(c.event){case"output":h(!1,c.body.source);break;case"loadedSource":h(!1,c.body.source);break;case"breakpoint":h(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=a;switch(c.command){case"setBreakpoints":h(!0,c.arguments.source);break;case"breakpointLocations":h(!0,c.arguments.source);break;case"source":h(!0,c.arguments.source);break;case"gotoTargets":h(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(d=>h(!1,d));break;default:break}break}case"response":{const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(d=>h(!1,d.source));break;case"loadedSources":c.body.sources.forEach(d=>h(!1,d));break;case"scopes":c.body.scopes.forEach(d=>h(!1,d.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(d=>h(!1,d.source));break;case"setBreakpoints":c.body.breakpoints.forEach(d=>h(!1,d.source));break;case"disassemble":c.body?.instructions.forEach(n=>h(!1,n.location));break;default:break}break}}}function S(a){return a.filter(h=>!h.presentation?.hidden).sort((h,c)=>h.presentation?c.presentation?h.presentation.group?c.presentation.group?h.presentation.group!==c.presentation.group?h.presentation.group.localeCompare(c.presentation.group):s(h.presentation.order,c.presentation.order):-1:c.presentation.group?1:s(h.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=S;function s(a,h){return typeof a!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:a-h}async function r(a,h){const c=a.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(c!=="none"&&(await h.saveAll(),c==="allEditorsInActiveGroup")){const d=h.activeEditorPane;d&&d.input.resource?.scheme===C.Schemas.untitled&&await h.save({editor:d.input,groupId:d.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(De[66],Ce([1,0,24,35,173,60,13,19,21,41]),function(te,e,i,k,y,M,C,R,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var m;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var u;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var g;(function($){$.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${z.join("")}]+`),X=7;function ee(Y,ge){const Se=ge.toString(X),ze=`${Se.length<z.length?z[Se.length-1]:"z"}${Se}s${(0,i.encodeBase64)(i.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:$.scheme,fragment:ze})}$.generate=ee;function fe(Y){if(Y.scheme!==$.scheme)return;const ge=Y.fragment.indexOf("s");if(ge<0)return;const Se=parseInt(Y.fragment.substring(0,ge).replace(V,""),X),Fe=(0,i.decodeBase64)(Y.fragment.substring(ge+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Y.with({scheme:Fe,fragment:null})}}$.parse=fe;function oe(Y,ge){return Y.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${Y.scheme!==C.Schemas.file?Y.scheme:""}`})}$.generateCellOutputUri=oe;function ue(Y){if(Y.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!ge)return;const Se=ge[1]&&ge[1]!==""?ge[1]:void 0,Fe=ge[2];return{outputId:Se,notebook:Y.with({scheme:Fe||C.Schemas.file,fragment:null})}}$.parseCellOutputUri=ue;function ce(Y,ge,Se){return $.generate(Y,ge).with({scheme:Se})}$.generateCellPropertyUri=ce;function he(Y,ge){if(Y.scheme===ge)return $.parse(Y.with({scheme:$.scheme}))}$.parseCellPropertyUri=he})(g=e.CellUri||(e.CellUri={}));const E=$=>w.isWindows?$.replace(/\//g,"\\"):$;class b{constructor(z=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(z)].map(X=>({pattern:X,matches:k.parse(E(X))}))}sort(z){const V=new Map(y.Iterable.map(z,ee=>[ee,E(ee)]));let X=[];for(const{matches:ee}of this.d)for(const[fe,oe]of V)if(ee(oe)){X.push(fe),V.delete(fe);break}return V.size&&(X=X.concat([...V.keys()].sort((ee,fe)=>this.e.indexOf(ee)-this.e.indexOf(fe)))),X}prioritize(z,V){const X=this.f(z);if(X===-1){this.d.unshift({pattern:z,matches:k.parse(E(z))});return}const ee=new Set(V.map(oe=>this.f(oe,X)));ee.delete(-1);const fe=Array.from(ee).sort();this.d.splice(X+1,0,...fe.map(oe=>this.d[oe]));for(let oe=fe.length-1;oe>=0;oe--)this.d.splice(fe[oe],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,V=this.d.length){const X=E(z);for(let ee=0;ee<V;ee++)if(this.d[ee].matches(X))return ee;return-1}}e.MimeTypeDisplayOrder=b;function S($,z,V,X=(ee,fe)=>ee===fe){const ee=[];function fe(ce,he,Y){if(he===0&&Y.length===0)return;const ge=ee[ee.length-1];ge&&ge.start+ge.deleteCount===ce?(ge.deleteCount+=he,ge.toInsert.push(...Y)):ee.push({start:ce,deleteCount:he,toInsert:Y})}let oe=0,ue=0;for(;;){if(oe===$.length){fe(oe,0,z.slice(ue));break}if(ue===z.length){fe(oe,$.length-oe,[]);break}const ce=$[oe],he=z[ue];if(X(ce,he)){oe+=1,ue+=1;continue}V(he)?(fe(oe,1,[]),oe+=1):(fe(oe,0,[he]),ue+=1)}return ee}e.diff=S,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function($){$.default="default",$.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r($){const z=$;return!!((typeof z.include=="string"||k.isRelativePattern(z.include))&&(typeof z.exclude=="string"||k.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function a($,z,V){if(Array.isArray($.viewType)&&$.viewType.indexOf(z)>=0||$.viewType===z)return!0;if($.filenamePattern){const X=r($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,ee=r($.filenamePattern)?$.filenamePattern.exclude:void 0;if(k.match(X,(0,R.basename)(V.fsPath).toLowerCase()))return!(ee&&k.match(ee,(0,R.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var h;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(z){return`${c.d}${z}`}static parse(z){if(z.startsWith(c.d))return z.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function d($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=d;const n=new TextDecoder;function l($){const z=[];let V=!1;for(const X of $)(z.length===0||V)&&(z.push(X),V=!0);return q(z),F(i.VSBuffer.concat(z.map(X=>i.VSBuffer.wrap(X))))}e.compressOutputItemStreams=l;const p=`${String.fromCharCode(27)}[A`,A=p.split("").map($=>$.charCodeAt(0)),L=10;function q($){$.forEach((z,V)=>{if(V===0||z.length<p.length)return;const X=$[V-1],ee=z.subarray(0,p.length);if(ee[0]===A[0]&&ee[1]===A[1]&&ee[2]===A[2]){const fe=X.lastIndexOf(L);if(fe===-1)return;$[V-1]=X.subarray(0,fe),$[V]=z.subarray(p.length)}})}function K($){let z=$;do $=z,z=$.replace(/[^\n]\x08/gm,"");while(z.length<$.length);return $}function j($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const z=$.match(/^(.*)\r+/m)[1];let V=$.match(/\r+(.*)$/m)[1];V=V+z.slice(V.length,z.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return $}const P="\b".charCodeAt(0),N="\r".charCodeAt(0);function F($){return!$.buffer.includes(P)&&!$.buffer.includes(N)?$:i.VSBuffer.fromString(j(K(n.decode($.buffer))))}}),define(De[174],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(De[175],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=i;function k(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=k;function y(C){return Array.from(C.entries()).map(R=>[R[0],i(R[1].map)])}e.serializeEnvironmentVariableCollections=y;function M(C){return new Map(C.map(R=>[R[0],{map:k(R[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(De[42],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(M){M.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,R,w=C.parent){if(C._isRoot)return new y([R]);const T=[C.id];for(let O=w;O&&O.id!==R;O=O.parent)T.push(O.id);return T.push(R),new y(T.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const R=C.indexOf("\0");return R===-1?C:C.slice(0,R)}static fromString(C){return new y(C.split("\0"))}static join(C,R){return new y([...C.path,R])}static joinToString(C,R){return C.toString()+"\0"+R}static parentId(C){const R=C.lastIndexOf("\0");return R===-1?void 0:C.slice(0,R)}static compare(C,R){return C===R?0:R.startsWith(C+"\0")?2:C.startsWith(R+"\0")?3:1}constructor(C,R=C.length){if(this.path=C,this.d=R,C.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let R=0;R<C.d&&R<this.d;R++)if(C.path[R]!==this.path[R])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(De[52],Ce([1,0,2,53,42]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var C;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var R;(function(n){n.serialize=l=>({range:l.range.toJSON(),uri:l.uri.toJSON()}),n.deserialize=l=>({range:k.Range.lift(l.range),uri:i.URI.revive(l.uri)})})(R=e.IRichLocation||(e.IRichLocation={}));var w;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(w=e.TestMessageType||(e.TestMessageType={}));var T;(function(n){n.serialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,location:l.location&&R.serialize(l.location)}),n.deserialize=l=>({message:l.message,type:0,expected:l.expected,actual:l.actual,location:l.location&&R.deserialize(l.location)})})(T=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(n,l)=>`${l?"s":"e"}${n}`;e.getMarkId=O;var I;(function(n){n.serialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&R.serialize(l.location)}),n.deserialize=l=>({message:l.message,type:1,offset:l.offset,length:l.length,location:l.location&&R.deserialize(l.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(n){n.serialize=l=>l.type===0?T.serialize(l):I.serialize(l),n.deserialize=l=>l.type===0?T.deserialize(l):I.deserialize(l)})(m=e.ITestMessage||(e.ITestMessage={}));var v;(function(n){n.serializeWithoutMessages=l=>({state:l.state,duration:l.duration,messages:[]}),n.serialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(m.serialize)}),n.deserialize=l=>({state:l.state,duration:l.duration,messages:l.messages.map(m.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",t=(n,l)=>n+f+l;e.namespaceTestTag=t;const o=n=>{const l=n.indexOf(f);return{ctrlId:n.slice(0,l),tagId:n.slice(l+1)}};e.denamespaceTestTag=o;var u;(function(n){n.serialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?.toJSON(),range:l.range?.toJSON()||null,description:l.description,error:l.error,sortText:l.sortText}),n.deserialize=l=>({extId:l.extId,label:l.label,tags:l.tags,busy:l.busy,children:void 0,uri:l.uri?i.URI.revive(l.uri):void 0,range:l.range?k.Range.lift(l.range):null,description:l.description,error:l.error,sortText:l.sortText})})(u=e.ITestItem||(e.ITestItem={}));var g;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));var E;(function(n){n.serialize=l=>({expand:l.expand,item:u.serialize(l.item)}),n.deserialize=l=>({controllerId:y.TestId.root(l.item.extId),expand:l.expand,item:u.deserialize(l.item)})})(E=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(n){n.serialize=l=>{let p;return l.item&&(p={},l.item.label!==void 0&&(p.label=l.item.label),l.item.tags!==void 0&&(p.tags=l.item.tags),l.item.busy!==void 0&&(p.busy=l.item.busy),l.item.uri!==void 0&&(p.uri=l.item.uri?.toJSON()),l.item.range!==void 0&&(p.range=l.item.range?.toJSON()),l.item.description!==void 0&&(p.description=l.item.description),l.item.error!==void 0&&(p.error=l.item.error),l.item.sortText!==void 0&&(p.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:p}},n.deserialize=l=>{let p;return l.item&&(p={},l.item.label!==void 0&&(p.label=l.item.label),l.item.tags!==void 0&&(p.tags=l.item.tags),l.item.busy!==void 0&&(p.busy=l.item.busy),l.item.range!==void 0&&(p.range=l.item.range?k.Range.lift(l.item.range):null),l.item.description!==void 0&&(p.description=l.item.description),l.item.error!==void 0&&(p.error=l.item.error),l.item.sortText!==void 0&&(p.sortText=l.item.sortText)),{extId:l.extId,expand:l.expand,item:p}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const S=(n,l)=>{l.expand!==void 0&&(n.expand=l.expand),l.item!==void 0&&(n.item=n.item?Object.assign(n.item,l.item):l.item)};e.applyTestItemUpdate=S;var s;(function(n){n.serializeWithoutMessages=l=>({...E.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(v.serializeWithoutMessages),retired:l.retired}),n.serialize=l=>({...E.serialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(v.serialize),retired:l.retired}),n.deserialize=l=>({...E.deserialize(l),ownComputedState:l.ownComputedState,computedState:l.computedState,tasks:l.tasks.map(v.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var a;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var h;(function(n){n.deserialize=l=>l.op===0?{op:l.op,item:E.deserialize(l.item)}:l.op===1?{op:l.op,item:b.deserialize(l.item)}:l.op===2?{op:l.op,uri:i.URI.revive(l.uri),docv:l.docv}:l,n.serialize=l=>l.op===0?{op:l.op,item:E.serialize(l.item)}:l.op===1?{op:l.op,item:b.serialize(l.item)}:l})(h=e.TestsDiffOp||(e.TestsDiffOp={}));class c{add(l){}update(l){}remove(l,p){}complete(){}}e.IncrementalChangeCollector=c;class d{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(l){const p=this.k();for(const A of l)switch(A.op){case 0:{const L=E.deserialize(A.item),q=y.TestId.parentId(L.item.extId)?.toString();if(q){if(this.d.has(q)){const K=this.d.get(q);K.children.add(L.item.extId);const j=this.l(L,K);this.d.set(L.item.extId,j),p.add(j)}}else{const K=this.l(L);this.f.add(K),this.d.set(L.item.extId,K),p.add(K)}L.expand===2&&this.g++;break}case 1:{const L=b.deserialize(A.item),q=this.d.get(L.extId);if(!q)break;L.expand!==void 0&&(q.expand===2&&this.g--,L.expand===2&&this.g++),(0,e.applyTestItemUpdate)(q,L),p.update(q);break}case 3:{const L=this.d.get(A.itemId);if(!L)break;const q=y.TestId.parentId(L.item.extId)?.toString();q?this.d.get(q).children.delete(L.item.extId):this.f.delete(L);const K=[[A.itemId]];for(;K.length;)for(const j of K.pop()){const P=this.d.get(j);P&&(K.push(P.children),this.d.delete(j),p.remove(P,P!==L),P.expand===2&&this.g--)}break}case 5:this.j(A.itemId);break;case 4:this.updatePendingRoots(A.amount);break;case 6:this.c.set(A.tag.id,A.tag);break;case 7:this.c.delete(A.id);break}p.complete()}j(l){}updatePendingRoots(l){this.h+=l}k(){return new c}}e.AbstractIncrementalTestCollection=d}),define(De[67],Ce([1,0,15,4,7,47,52,42]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(u,g)=>u===g,O={range:(u,g)=>u===g?!0:!u||!g?!1:u.equalsRange(g),busy:T,label:T,description:T,error:T,tags:(u,g)=>!(u.length!==g.length||u.some(E=>!g.includes(E)))},I=(u,g)=>{let E;for(const[b,S]of Object.entries(O))S(u[b],g[b])||(E?E[b]=g[b]:E={[b]:g[b]});return E};class m extends y.Disposable{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new k.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const E of this.tree.values())this.H(E)}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const E of this.k)if(E.op===2&&E.uri===g.uri){E.docv=g.docv;return}break}case 1:{const E=this.k[this.k.length-1];if(E){if(E.op===1&&E.item.extId===g.item.extId){(0,C.applyTestItemUpdate)(E.item,g.item);return}if(E.op===0&&E.item.item.extId===g.item.extId){(0,C.applyTestItemUpdate)(E.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,E){const b=this.tree.get(g);if(!!b){if((b.expandLevels===void 0||E>b.expandLevels)&&(b.expandLevels=E),b.expand===1){const S=this.J(b);return S.isOpen()?this.I(b,E-1):S.wait().then(()=>this.I(b,E-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.I(b,E-1)):this.I(b,E-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,E){switch(E.op){case 3:this.M(R.TestId.joinToString(g.fullId,E.id));break;case 0:this.u(E.item,g);break;case 5:for(const b of E.ops)this.p(g,b);break;case 1:this.w(E.new,E.old,g.fullId.toString());break;case 2:this.H(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:E.update}});break;case 6:this.s(g.actual.uri);break;default:(0,M.assertNever)(E)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,E){const b=R.TestId.fromExtHostTestItem(g,this.root.id,E?.actual),S=this.m.getApiFor(g);S.parent&&S.parent!==E?.actual&&this.m.getChildren(S.parent).delete(g.id);let s=this.tree.get(b.toString());if(!s){s={fullId:b,actual:g,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.D(g,E),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(g)}}),this.G(g,s,E);return}if(s.actual===g){this.F(g,s,E);return}const r=this.m.getChildren(s.actual),a=s.actual,h=I(this.m.toITestItem(a),this.m.toITestItem(g));this.m.getApiFor(a).listener=void 0,s.actual=g,s.expand=0,h&&(h.hasOwnProperty("tags")&&(this.w(g.tags,a.tags,b.toString()),delete h.tags),this.p(s,{op:4,update:h})),this.G(g,s,E);for(const[c,d]of r)this.m.getChildren(g).get(d.id)||this.M(R.TestId.joinToString(b,d.id));this.s(s.actual.uri)}w(g,E,b){const S=new Set(E.map(s=>s.id));for(const s of g)S.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:b,item:{tags:g.map(s=>(0,C.namespaceTestTag)(this.m.controllerId,s.id))}}}),S.forEach(this.C,this)}y(g){const E=this.j.get(g.id);E?E.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,g.id)}}))}C(g){const E=this.j.get(g);E&&!--E.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,g)}))}D(g,E){this.m.getApiFor(g).parent=E&&E.actual!==this.root?E.actual:void 0}F(g,E,b){this.D(g,b);const S=this.m.getApiFor(g);S.parent=b?.actual,S.listener=s=>this.p(E,s),this.H(E)}G(g,E,b){this.F(g,E,b);for(const[S,s]of this.m.getChildren(g))this.u(s,E)}H(g){let E;this.h?g.resolveBarrier?E=g.resolveBarrier.isOpen()?3:2:E=g.actual.canResolveChildren?1:0:E=0,E!==g.expand&&(g.expand=E,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:E}}),E===1&&g.expandLevels!==void 0&&this.J(g))}I(g,E){if(E<0)return;const b=[];for(const[S,s]of this.m.getChildren(g.actual)){const r=this.expand(R.TestId.joinToString(g.fullId,s.id),E);(0,i.isThenable)(r)&&b.push(r)}if(b.length)return Promise.all(b).then(()=>{})}J(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const s=new i.Barrier;return s.open(),s}g.expand=2,this.L(g);const E=g.resolveBarrier=new i.Barrier,b=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let S;try{S=this.h(g.actual===this.root?void 0:g.actual)}catch(s){b(s)}return(0,i.isThenable)(S)?S.catch(b).then(()=>{E.open(),this.H(g)}):(E.open(),this.H(g)),g.resolveBarrier}L(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}M(g){const E=this.tree.get(g);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const b=[E];for(;b.length;){const S=b.pop();if(!!S){this.m.getApiFor(S.actual).listener=void 0;for(const s of S.actual.tags)this.C(s.id);this.tree.delete(S.fullId.toString());for(const[s,r]of this.m.getChildren(S.actual))b.push(this.tree.get(R.TestId.joinToString(S.fullId,r.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.TestItemCollection=m;class v extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=v;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class t extends Error{constructor(g,E,b){super(`TestItem with ID "${g}" is from controller "${E}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=t;const o=(u,g,E)=>{let b=new Map;return{get size(){return b.size},forEach(S,s){for(const r of b.values())S.call(s,r,this)},[Symbol.iterator](){return b.entries()},replace(S){const s=new Map,r=new Set(b.keys()),a={op:5,ops:[]};for(const h of S){if(!(h instanceof E))throw new f(h.id);const c=g(h).controllerId;if(c!==u.controllerId)throw new t(h.id,c,u.controllerId);if(s.has(h.id))throw new v(h.id);s.set(h.id,h),r.delete(h.id),a.ops.push({op:0,item:h})}for(const h of r.keys())a.ops.push({op:3,id:h});u.listener?.(a),b=s},add(S){if(!(S instanceof E))throw new f(S.id);b.set(S.id,S),u.listener?.({op:0,item:S})},delete(S){b.delete(S)&&u.listener?.({op:3,id:S})},get(S){return b.get(S)},toJSON(){return Array.from(b.values())}}};e.createTestItemChildren=o}),define(De[93],Ce([1,0,67]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,y=(C,R)=>{const w={controllerId:R};return k.set(C,w),w};e.createPrivateApiFor=y;const M=C=>{const R=k.get(C);if(!R)throw new i.InvalidTestItemError(C?.id||"<unknown>");return R};e.getPrivateApiFor=M}),define(De[68],Ce([1,0,13,2]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(R,w){return R.scheme===i.Schemas.http||R.scheme===i.Schemas.https?R:(w&&w.authority&&w.isRemote&&R.scheme===i.Schemas.file&&(R=k.URI.from({scheme:i.Schemas.vscodeRemote,authority:w.authority,path:R.path})),k.URI.from({scheme:i.Schemas.https,authority:`${R.scheme}+${M(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=y;function M(R){return R.replace(/./g,w=>{const T=w.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?w:"-"+T.toString(16).padStart(4,"0")})}function C(R){return R.replace(/-([0-9a-f]{4})/g,(w,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=C}),define(De[176],Ce([1,0,4,7,68]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(R,w,T){this.d=R,this.e=w,this.f=T,this.a=0,this.b=new k.DisposableStore,this.c=new Map,this.b.add(w.onDidChangeVisibleTextEditors(()=>{const O=w.getVisibleTextEditors();for(const I of this.c.values())O.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,w,T,O,I){let m;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===R){m=E;break}if(!m)throw new Error("not a visible editor");const v=this,f=this.a++,t=new i.Emitter,o=new i.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,y.asWebviewUri)(E,v.f)}get cspSource(){return y.webviewGenericCspSource}set options(E){this.b=E,v.d.$setOptions(f,E)}get options(){return this.b}set html(E){this.a=E,v.d.$setHtml(f,E)}get html(){return this.a}get onDidReceiveMessage(){return t.event}postMessage(E){return v.d.$postMessage(f,E)}},g=new class{constructor(){this.editor=R,this.line=w,this.height=T,this.webview=u,this.onDidDispose=o.event}dispose(){v.c.has(f)&&(v.c.delete(f),v.d.$disposeEditorInset(f),o.fire(),o.dispose(),t.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,w+1,T,O||{},I.identifier,I.extensionLocation),this.c.set(f,{editor:R,inset:g,onDidReceiveMessage:t}),g}$onDidDispose(R){const w=this.c.get(R);w&&w.inset.dispose()}$onDidReceiveMessage(R,w){this.c.get(R)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=M}),define(De[177],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var k;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(k=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,R){super(R),this.variable=C}}e.VariableError=y}),define(De[178],Ce([1,0,19,48,9,23,21,82,145,177,10]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(v,f,t,o){this.g=new Map,this.a=v,this.b=f,this.d=t,o&&(this.c=o.then(u=>this.h(u)))}h(v){if(C.isWindows){const f=Object.create(null);return Object.keys(v).forEach(t=>{f[t.toLowerCase()]=v[t]}),f}return v}resolveWithEnvironment(v,f,t){return this.j({env:this.h(v),userHome:void 0},f?f.uri:void 0,t)}async resolveAsync(v,f){const t={env:await this.c,userHome:await this.d};return this.j(t,v?v.uri:void 0,f)}async i(v,f,t,o){const u=M.deepClone(f);C.isWindows&&u.windows?Object.keys(u.windows).forEach(E=>u[E]=u.windows[E]):C.isMacintosh&&u.osx?Object.keys(u.osx).forEach(E=>u[E]=u.osx[E]):C.isLinux&&u.linux&&Object.keys(u.linux).forEach(E=>u[E]=u.linux[E]),delete u.windows,delete u.osx,delete u.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,v?v.uri:void 0,u,t,o)}async resolveAnyAsync(v,f,t){return this.i(v,f,t)}async resolveAnyMap(v,f,t){const o=new Map;return{newConfig:await this.i(v,f,t,o),resolvedVariables:o}}resolveWithInteractionReplace(v,f,t,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,f,t,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,f){if(this.g.has(v))throw new Error("Variable "+v+" is contributed twice.");this.g.set(v,f)}async j(v,f,t,o,u){if(y.isString(t))return this.l(v,f,t,o,u);if(Array.isArray(t))return Promise.all(t.map(g=>this.j(v,f,g,o,u)));if(y.isObject(t)){const g=Object.create(null),E=await Promise.all(Object.keys(t).map(async b=>[await this.l(v,f,b,o,u),await this.j(v,f,t[b],o,u)]));for(const[b,S]of E)g[b]=S;return g}return t}l(v,f,t,o,u){return(0,O.replaceAsync)(t,I.VARIABLE_REGEXP,async(g,E)=>{if(E.includes(I.VARIABLE_LHS))return g;let b=await this.n(v,g,E,f,o);return u?.set(E,b),b!==g&&y.isString(b)&&b.match(I.VARIABLE_REGEXP)&&(b=await this.l(v,f,b,o,u)),b})}m(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async n(v,f,t,o,u){let g;const E=t.split(":");E.length>1&&(t=E[0],g=E[1]);const b=r=>{const a=this.a.getFilePath();if(a)return a;throw new T.VariableError(r,(0,w.localize)(0,null,f))},S=r=>{const a=b(r);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return h}throw new T.VariableError(r,(0,w.localize)(1,null,f,i.basename(a)))},s=r=>{if(g){const a=this.a.getFolderUri(g);if(a)return a;throw new T.VariableError(r,(0,w.localize)(2,null,f,g))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new T.VariableError(r,(0,w.localize)(3,null,f)):new T.VariableError(r,(0,w.localize)(4,null,f))};switch(t){case"env":if(g){if(v.env){const r=v.env[C.isWindows?g.toLowerCase():g];if(y.isString(r))return r}return""}throw new T.VariableError(T.VariableKind.Env,(0,w.localize)(5,null,f));case"config":if(g){const r=this.a.getConfigurationValue(o,g);if(y.isUndefinedOrNull(r))throw new T.VariableError(T.VariableKind.Config,(0,w.localize)(6,null,f,g));if(y.isObject(r))throw new T.VariableError(T.VariableKind.Config,(0,w.localize)(7,null,f,g));return r}throw new T.VariableError(T.VariableKind.Config,(0,w.localize)(8,null,f));case"command":return this.o(T.VariableKind.Command,f,g,u,"command");case"input":return this.o(T.VariableKind.Input,f,g,u,"input");case"extensionInstallFolder":if(g){const r=await this.a.getExtension(g);if(!r)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,f,g));return this.m(r.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,f));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(s(T.VariableKind.WorkspaceFolder)));case"cwd":return o||g?(0,R.normalizeDriveLetter)(this.m(s(T.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(this.m(s(T.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(v.userHome)return v.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,w.localize)(11,null,f))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new T.VariableError(T.VariableKind.LineNumber,(0,w.localize)(12,null,f))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new T.VariableError(T.VariableKind.SelectedText,(0,w.localize)(13,null,f))}case"file":return b(T.VariableKind.File);case"fileWorkspaceFolder":return S(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||g?i.relative(this.m(s(T.VariableKind.RelativeFile)),b(T.VariableKind.RelativeFile)):b(T.VariableKind.RelativeFile);case"relativeFileDirname":{const r=i.dirname(b(T.VariableKind.RelativeFileDirname));if(o||g){const a=i.relative(this.m(s(T.VariableKind.RelativeFileDirname)),r);return a.length===0?".":a}return r}case"fileDirname":return i.dirname(b(T.VariableKind.FileDirname));case"fileExtname":return i.extname(b(T.VariableKind.FileExtname));case"fileBasename":return i.basename(b(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=i.basename(b(T.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-i.extname(r).length)}case"fileDirnameBasename":return i.basename(i.dirname(b(T.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||f}case"execInstallFolder":{const r=this.a.getAppRoot();return r||f}case"pathSeparator":return i.sep;default:try{const r=g?`${t}:${g}`:t;return this.o(T.VariableKind.Unknown,f,r,u,void 0)}catch{return f}}}}o(v,f,t,o,u){if(t&&o){const g=u===void 0?o[t]:o[u+":"+t];if(typeof g=="string")return g;throw new T.VariableError(v,(0,w.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[94],Ce([1,0,3,92]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var y;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var R;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function T(f){const t=f;return(0,k.isEditorInput)(t?.editor)&&(0,k.isEditorInput)(t?.replacement)}e.isEditorReplacement=T;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const t=f;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=m;function v(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(De[179],Ce([1,0,3,94]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(M){const C=M;return typeof M=="number"||(0,k.isEditorGroup)(C)}e.isPreferredGroup=y}),define(De[180],Ce([1,0,3,151]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(k.IEnvironmentService)}),define(De[181],Ce([1,0,26,4,19]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(I){this.removedDueToLooping=I}}e.DeltaExtensionsResult=M;class C{constructor(I){this.c=new k.Emitter,this.onDidChange=this.c.event,this.d=I,this.h()}h(){this.d.sort(w),this.e=new Map,this.f=[],this.g=new Map;for(const I of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(I.identifier))){console.error("Extension `"+I.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(I.identifier),I),this.f.push(I),Array.isArray(I.activationEvents))for(let m of I.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(I.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(I)}}set(I){this.d=I,this.h(),this.c.fire(void 0)}deltaExtensions(I,m){this.d=T(this.d,m),this.d=this.d.concat(I);const v=C.j(this.d);return this.d=T(this.d,v.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new M(v)}static j(I){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,g){this.addNode(u),this.addNode(g),this.c.has(u)?this.c.get(u).push(g):this.c.set(u,[g])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,g){const E=m.getArcs(u);for(let b=0;b<E.length;b++)if(!g.has(E[b]))return!1;return!0}getNodes(){return this.e}},v=new Map;for(const u of I){const g=i.ExtensionIdentifier.toKey(u.identifier);if(v.set(g,u),u.extensionDependencies)for(const E of u.extensionDependencies){const b=i.ExtensionIdentifier.toKey(E);m.addArc(g,b)}}const f=new Set;m.getNodes().filter(u=>m.getArcs(u).length===0).forEach(u=>f.add(u));const t=m.getNodes().filter(u=>!f.has(u));let o;do{o=!1;for(let u=0;u<t.length;u++){const g=t[u];m.hasOnlyGoodArcs(g,f)&&(t.splice(u,1),u--,f.add(g),o=!0)}}while(o);return t.map(u=>v.get(u))}containsActivationEvent(I){return this.g.has(I)}containsExtension(I){return this.e.has(i.ExtensionIdentifier.toKey(I))}getExtensionDescriptionsForActivationEvent(I){const m=this.g.get(I);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(I){const m=this.e.get(i.ExtensionIdentifier.toKey(I));return m||void 0}getExtensionDescriptionByUUID(I){for(const m of this.f)if(m.uuid===I)return m}getExtensionDescriptionByIdOrUUID(I,m){return this.getExtensionDescription(I)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=C;var R;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(R||(R={}));function w(O,I){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,v=I.isBuiltin?0:I.isUnderDevelopment?2:1;if(m!==v)return m-v;const f=y.posix.basename(O.extensionLocation.path),t=y.posix.basename(I.extensionLocation.path);return f<t?-1:f>t?1:0}function T(O,I){const m=new Set;return I.forEach(v=>m.add(i.ExtensionIdentifier.toKey(v))),O.filter(v=>!m.has(i.ExtensionIdentifier.toKey(v.identifier)))}}),define(De[69],Ce([1,0,24]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var y;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function C(T){const O=i.VSBuffer.alloc(1);switch(T){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=C;function R(T,O){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=R;var w;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[70],Ce([1,0,3,4,12,27,69,63,91,23,2]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class{constructor(t,o){this.i=t,this.a=new k.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new k.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(O.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(t,o){const u=this.getTelemetryDetails(),g=new m(o,t,this.g,this.f,this.getBuiltInCommonProperties(t),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled});return this.h.set(t.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(t,o,u){this.d=t,this.f=o,this.c=u??{usage:!0,error:!0}}getBuiltInCommonProperties(t){const o={};switch(o["common.extname"]=t.name,o["common.extversion"]=t.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=v(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:o["common.uikind"]="web";break;case C.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,R.getRemoteName)((0,w.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(t){this.e=this.getTelemetryConfiguration(),this.d=t;const o=this.getTelemetryDetails();this.h.forEach(u=>{u.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(t,o){const u=this.h.get(t.value);return u?(u.logError(o),!0):!1}};I=qe([Ve(0,M.IExtHostInitDataService),Ve(1,y.ILoggerService)],I),e.ExtHostTelemetry=I;class m{constructor(t,o,u,g,E,b){this.e=o,this.f=u,this.g=g,this.h=E,this.b=new k.Emitter,this.a=t,this.c={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(t,o){this.d&&(this.c={isUsageEnabled:t,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(t){let o=t.properties??t;return o=(0,w.cleanData)(o,[]),this.a.additionalCommonProperties&&(o=(0,T.mixin)(o,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(o=(0,T.mixin)(o,this.h)),t.properties?t.properties=o:t=o,t}i(t,o){this.e.publisher==="vscode"?t=this.e.name+"/"+t:t=this.e.identifier.value+"/"+t,o=this.mixInCommonPropsAndCleanData(o||{}),this.g||this.a.logEvent(t,o),this.f.trace(t,o)}logUsage(t,o){!this.c.isUsageEnabled||this.i(t,o)}logError(t,o){!this.c.isErrorsEnabled||(typeof t=="string"?this.i(t,o):this.a.logException(t,o))}get apiTelemetryLogger(){if(!this.d){const t=this,o={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.c.isUsageEnabled},get isErrorsEnabled(){return t.c.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.b.event.bind(t)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function v(f){const t=Date.now()-new Date(f).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=v,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(De[25],Ce([1,0,4,2,3,26,158]),function(te,e,i,k,y,M,C){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class w{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class T{constructor(d){this.affinity=d,this.kind=2}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=T;class O{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class I{constructor(d){this.dependency=d}}e.MissingExtensionDependency=I;var m;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=v;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(d,n){const l=[],p=[],A=[],L=[],q=u(this.c),K=u(d),j=($,z)=>$.extensionLocation.toString()===z.extensionLocation.toString()||$.isBuiltin===z.isBuiltin||$.isUserBuiltin===z.isUserBuiltin||$.isUnderDevelopment===z.isUnderDevelopment;for(const $ of this.c){const z=K.get(M.ExtensionIdentifier.toKey($.identifier));if(!z){l.push($.identifier),q.delete(M.ExtensionIdentifier.toKey($.identifier));continue}if(!j($,z)){l.push($.identifier),q.delete(M.ExtensionIdentifier.toKey($.identifier));continue}}for(const $ of d){const z=q.get(M.ExtensionIdentifier.toKey($.identifier));if(!z){p.push($);continue}if(!j(z,$)){l.push(z.identifier),q.delete(M.ExtensionIdentifier.toKey(z.identifier));continue}}const P=o(this.d),N=o(n);for(const $ of this.d)N.has(M.ExtensionIdentifier.toKey($))||A.push($);for(const $ of n)P.has(M.ExtensionIdentifier.toKey($))||L.push($);const F={toRemove:l,toAdd:p,myToRemove:A,myToAdd:L};return this.delta(F),F}delta(d){const{toRemove:n,toAdd:l,myToRemove:p,myToAdd:A}=d,L=o(n),q=o(p);for(let K=0;K<this.c.length;K++)L.has(M.ExtensionIdentifier.toKey(this.c[K].identifier))&&(this.c.splice(K,1),K--);for(let K=0;K<this.d.length;K++)q.has(M.ExtensionIdentifier.toKey(this.d[K]))&&(this.d.splice(K,1),K--);for(const K of l)this.c.push(K);for(const K of A)this.d.push(K)}containsExtension(d){for(const n of this.d)if(M.ExtensionIdentifier.equals(n,d))return!0;return!1}}e.ExtensionHostExtensions=f;class t{constructor(d){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,d)for(const n of d)this.add(n)}get size(){return this.c.size}add(d){return this.c.set(this.d(d),d),this}clear(){this.c.clear()}delete(d){return this.c.delete(this.d(d))}has(d){return this.c.has(this.d(d))}forEach(d,n){this.c.forEach(l=>d.call(n,l,l,this))}*entries(){for(const[d,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=t;function o(c){const d=new Set;for(const n of c)d.add(M.ExtensionIdentifier.toKey(n));return d}e.extensionIdentifiersArrayToSet=o;function u(c){const d=new Map;for(const n of c)d.set(M.ExtensionIdentifier.toKey(n.identifier),n);return d}function g(c,d){return c.enabledApiProposals?c.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=g;function E(c,d){if(!g(c,d))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=E;class b{constructor(d,n,l,p){this.codeLoadingTime=d,this.activateCallTime=n,this.activateResolvedTime=l,this.activationReason=p}}e.ActivationTimes=b;class S{constructor(d,n){this.description=d,this.value=n}}e.ExtensionPointContribution=S,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function a(c,d){return{identifier:new M.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!d,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=a;class h{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,n){return Promise.resolve(0)}getInspectPorts(d,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=h}),define(De[182],Ce([1,0,11,26,25,12,15]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class R{constructor(o,u,g,E){this.startup=o,this.codeLoadingTime=u,this.activateCallTime=g,this.activateResolvedTime=E}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class w{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,u){return o===-1||u===-1?-1:u-o}build(){return new R(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=w;class T{constructor(o,u,g,E,b,S){this.activationFailed=o,this.activationFailedError=u,this.activationTimes=g,this.module=E,this.exports=b,this.subscriptions=S}}e.ActivatedExtension=T;class O extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class I extends T{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class m extends T{constructor(o){super(!0,o,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,u,g,E,b){this.h=b,this.a=o,this.b=new Set,u.forEach(S=>this.b.add(k.ExtensionIdentifier.toKey(S))),this.c=new Map,g.forEach(S=>this.c.set(k.ExtensionIdentifier.toKey(S),S)),this.d=E,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[o,u]of this.f)u.dispose()}isActivated(o){const u=this.f.get(k.ExtensionIdentifier.toKey(o));return Boolean(u&&u.value)}getActivatedExtension(o){const u=this.f.get(k.ExtensionIdentifier.toKey(o));if(!u||!u.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return u.value}async activateByEvent(o,u){if(this.g[o])return;const g=this.a.getExtensionDescriptionsForActivationEvent(o);await this.j(g.map(E=>({id:E.identifier,reason:{startup:u,extensionId:E.identifier,activationEvent:o}}))),this.g[o]=!0}activateById(o,u){const g=this.a.getExtensionDescription(o);if(!g)throw new Error(`Extension '${o}' is not known`);return this.j([{id:g.identifier,reason:u}])}async j(o){const u=o.filter(g=>!this.isActivated(g.id)).map(g=>this.k(g));await Promise.all(u.map(g=>g.wait()))}k(o){if(this.f.has(k.ExtensionIdentifier.toKey(o.id)))return this.f.get(k.ExtensionIdentifier.toKey(o.id));if(this.c.has(k.ExtensionIdentifier.toKey(o.id)))return this.l(o,null,[],null);const u=this.a.getExtensionDescription(o.id);if(!u){const b=new Error(`Cannot activate unknown extension '${o.id.value}'`),S=this.l(o,null,[],new m(b));return this.d.onExtensionActivationError(o.id,b,new y.MissingExtensionDependency(o.id.value)),S}const g=[],E=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const b of E){if(this.b.has(k.ExtensionIdentifier.toKey(b)))continue;const S=this.f.get(k.ExtensionIdentifier.toKey(b));if(S){g.push(S);continue}if(this.c.has(k.ExtensionIdentifier.toKey(b))){g.push(this.k({id:this.c.get(k.ExtensionIdentifier.toKey(b)),reason:o.reason}));continue}const s=this.a.getExtensionDescription(b);if(s){if(!s.main&&!s.browser)continue;g.push(this.k({id:s.identifier,reason:o.reason}));continue}const r=u.displayName||u.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${b}'`),h=this.l(o,u.displayName,[],new m(a));return this.d.onExtensionActivationError(u.identifier,a,new y.MissingExtensionDependency(b)),h}return this.l(o,u.displayName,g,null)}l(o,u,g,E){const b=new f(o.id,u,o.reason,g,E,this.d,this.h);return this.f.set(k.ExtensionIdentifier.toKey(o.id),b),b}};v=qe([Ve(4,M.ILogService)],v),e.ExtensionsActivator=v;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,u,g,E,b,S,s){this.c=o,this.d=u,this.f=g,this.g=E,this.h=b,this.j=S,this.k=s,this.a=new C.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const u=this.g[o];if(u.value&&!u.value.activationFailed){this.g.splice(o,1),o--;continue}if(u.value&&u.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);g.detail=u.value.activationFailedError,this.h=new m(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const u=new Error;if(o&&o.name&&(u.name=o.name),o&&o.message?u.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:u.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(u.stack=o.stack),this.h=new m(u),this.b&&i.isCancellationError(o))return;this.j.onExtensionActivationError(this.c,u,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};f=qe([Ve(6,M.ILogService)],f)}),define(De[183],Ce([1,0,12,27,25]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends i.LogService{constructor(R,w){super(R.createLogger(w.logFile,{name:y.ExtensionHostLogFileName}))}};M=qe([Ve(0,i.ILoggerService),Ve(1,k.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[6],Ce([1,0,16,11,81,28,60,10,9,2,34,36,90,66,25]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f){"use strict";var t,o,u,g,E,b,S,s,r,a,h,c,d,n,l,p,A,L,q,K,j,P,N;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(W){return Object.assign(W,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(W,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[ie,...Ee]=arguments;return Reflect.construct(W,Ee,ie.constructor)}}})}let $=b=class{static from(...U){let ie=U;return new b(function(){if(ie){for(const Ee of ie)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ie=void 0}})}constructor(U){t.set(this,void 0),Je(this,t,U,"f")}dispose(){typeof Re(this,t,"f")=="function"&&(Re(this,t,"f").call(this),Je(this,t,void 0,"f"))}};t=new WeakMap,$=b=qe([F],$),e.Disposable=$;let z=S=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ke=U[Ee];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ke=U[Ee];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof S)return!0;const{line:ie,character:Ee}=U;return typeof ie=="number"&&typeof Ee=="number"}static of(U){if(U instanceof S)return U;if(this.isPosition(U))return new S(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("line must be non-negative");if(ie<0)throw(0,k.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,k.illegalArgument)();let Ee;return typeof U>"u"?Ee=0:typeof U=="number"?Ee=U:(Ee=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),Ee===0&&ie===0?this:new S(this.line+Ee,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,k.illegalArgument)();let Ee;return typeof U>"u"?Ee=this.line:typeof U=="number"?Ee=U:(Ee=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),Ee===this.line&&ie===this.character?this:new S(Ee,ie)}toJSON(){return{line:this.line,character:this.character}}};z=S=qe([F],z),e.Position=z;let V=s=class{static isRange(U){return U instanceof s?!0:U?z.isPosition(U.start)&&z.isPosition(U.end):!1}static of(U){if(U instanceof s)return U;if(this.isRange(U))return new s(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,Ee,Ke){let Qe,st;if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Qe=new z(U,ie),st=new z(Ee,Ke)):z.isPosition(U)&&z.isPosition(ie)&&(Qe=z.of(U),st=z.of(ie)),!Qe||!st)throw new Error("Invalid arguments");Qe.isBefore(st)?(this.c=Qe,this.e=st):(this.c=st,this.e=Qe)}contains(U){return s.isRange(U)?this.contains(U.start)&&this.contains(U.end):z.isPosition(U)?!(z.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=z.Max(U.start,this.c),Ee=z.Min(U.end,this.e);if(!ie.isAfter(Ee))return new s(ie,Ee)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=z.Min(U.start,this.c),Ee=z.Max(U.end,this.end);return new s(ie,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,k.illegalArgument)();let Ee;return U?z.isPosition(U)?Ee=U:(Ee=U.start||this.start,ie=U.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&ie.isEqual(this.end)?this:new s(Ee,ie)}toJSON(){return[this.start,this.end]}};V=s=qe([F],V),e.Range=V;let X=r=class extends V{static isSelection(U){return U instanceof r?!0:U?V.isRange(U)&&z.isPosition(U.anchor)&&z.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,Ee,Ke){let Qe,st;if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Qe=new z(U,ie),st=new z(Ee,Ke)):z.isPosition(U)&&z.isPosition(ie)&&(Qe=z.of(U),st=z.of(ie)),!Qe||!st)throw new Error("Invalid arguments");super(Qe,st),this.f=Qe,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};X=r=qe([F],X),e.Selection=X;class ee{constructor(U,ie,Ee){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,k.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,k.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=Ee}}e.ResolvedAuthority=ee;class fe extends Error{static NotAvailable(U,ie){return new fe(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new fe(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=m.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(U),this._message=U,this._code=ie,this._detail=Ee,Object.setPrototypeOf(this,fe.prototype)}}e.RemoteAuthorityResolverError=fe;var oe;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var ue;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(ue=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ce=a=class{static isTextEdit(U){return U instanceof a?!0:U?V.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new a(U,ie)}static insert(U,ie){return a.replace(new V(U,U),ie)}static delete(U){return a.replace(U,"")}static setEndOfLine(U){const ie=new a(new V(new z(0,0),new z(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!V.isRange(U))throw(0,k.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,k.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,k.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};ce=a=qe([F],ce),e.TextEdit=ce;let he=h=class{static isNotebookCellEdit(U){return U instanceof h?!0:U?Wt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new h(U,ie)}static insertCells(U,ie){return new h(new Wt(U,U),ie)}static deleteCells(U){return new h(U,[])}static updateCellMetadata(U,ie){const Ee=new h(new Wt(U,U),[]);return Ee.newCellMetadata=ie,Ee}static updateNotebookMetadata(U){const ie=new h(new Wt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};he=h=qe([F],he),e.NotebookEdit=he;class Y{static isSnippetTextEdit(U){return U instanceof Y?!0:U?V.isRange(U.range)&&Fe.isSnippetString(U.snippet):!1}static replace(U,ie){return new Y(U,ie)}static insert(U,ie){return Y.replace(new V(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=Y;var ge;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(ge=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,Ee,Ke){this.c.push({_type:1,from:U,to:ie,options:Ee,metadata:Ke})}createFile(U,ie,Ee){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:Ee})}deleteFile(U,ie,Ee){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:Ee})}e(U,ie,Ee){this.c.push({_type:3,metadata:Ee,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,Ee,Ke){const Qe=ie.start,st=ie.end;(Qe!==st||Ee.length>0)&&this.c.push({_type:5,uri:U,index:Qe,count:st-Qe,cells:Ee,metadata:Ke})}g(U,ie,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:ie,metadata:Ee}})}replace(U,ie,Ee,Ke){this.c.push({_type:2,uri:U,edit:new ce(ie,Ee),metadata:Ke})}insert(U,ie,Ee,Ke){this.replace(U,new V(ie,ie),Ee,Ke)}delete(U,ie,Ee){this.replace(U,ie,"",Ee)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const Ee of ie){if(!Ee)continue;let Ke,Qe;Array.isArray(Ee)?(Ke=Ee[0],Qe=Ee[1]):Ke=Ee,he.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,Qe):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,Qe):this.f(U,Ke.range,Ke.newCells,Qe):Y.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:Qe}):this.c.push({_type:2,uri:U,edit:Ke,metadata:Qe})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[Ee]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===U.toString()&&ie.push(Ee.edit);return ie}entries(){const U=new M.ResourceMap;for(const ie of this.c)if(ie._type===2){let Ee=U.get(ie.uri);Ee||(Ee=[ie.uri,[]],U.set(ie.uri,Ee)),Ee[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=qe([F],Se),e.WorkspaceEdit=Se;let Fe=c=class{static isSnippetString(U){return U instanceof c?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=c.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const Ee=new c;Ee.e=this.e,U(Ee),this.e=Ee.e,U=Ee.value}else U=c.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const Ee=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const Ee=new c;Ee.e=this.e,ie(Ee),this.e=Ee.e,ie=Ee.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Fe=c=qe([F],Fe),e.SnippetString=Fe;var ze;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(ze=e.DiagnosticTag||(e.DiagnosticTag={}));var _e;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(_e=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=d=class{static isLocation(U){return U instanceof d?!0:U?V.isRange(U.range)&&T.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(V.isRange(ie))this.range=V.of(ie);else if(z.isPosition(ie))this.range=new V(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=d=qe([F],ke),e.Location=ke;let Ie=class{static is(U){return U?typeof U.message=="string"&&U.location&&V.isRange(U.location.range)&&T.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};Ie=qe([F],Ie),e.DiagnosticRelatedInformation=Ie;let Te=class{constructor(U,ie,Ee=_e.Error){if(!V.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=Ee}toJSON(){return{severity:_e[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,i.equals)(U.tags,ie.tags)&&(0,i.equals)(U.relatedInformation,ie.relatedInformation,Ie.isEqual)}};Te=qe([F],Te),e.Diagnostic=Te;let re=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};re=qe([F],re),e.Hover=re;var ae;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let J=class{constructor(U,ie=ae.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:ae[this.kind]}}};J=qe([F],J),e.DocumentHighlight=J;var D;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(D=e.SymbolKind||(e.SymbolKind={}));var B;(function(W){W[W.Deprecated=1]="Deprecated"})(B=e.SymbolTag||(e.SymbolTag={}));let H=n=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,Ee,Ke,Qe){this.name=U,this.kind=ie,this.containerName=Qe,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ke?this.location=Ke:Ee instanceof V&&(this.location=new ke(Ke,Ee)),n.validate(this)}toJSON(){return{name:this.name,kind:D[this.kind],location:this.location,containerName:this.containerName}}};H=n=qe([F],H),e.SymbolInformation=H;let G=l=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(l.validate)}constructor(U,ie,Ee,Ke,Qe){this.name=U,this.detail=ie,this.kind=Ee,this.range=Ke,this.selectionRange=Qe,this.children=[],l.validate(this)}};G=l=qe([F],G),e.DocumentSymbol=G;var Z;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(U,ie){this.title=U,this.kind=ie}};le=qe([F],le),e.CodeAction=le;let be=p=class{constructor(U){this.value=U}append(U){return new p(this.value?this.value+p.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+p.c)}};be.c=".",be=p=qe([F],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let se=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=qe([F],se),e.SelectionRange=se;class we{constructor(U,ie,Ee,Ke,Qe,st){this.kind=U,this.name=ie,this.detail=Ee,this.uri=Ke,this.range=Qe,this.selectionRange=st}}e.CallHierarchyItem=we;class ve{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=ve;class $e{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=$e;var He;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([F],et),e.CodeLens=et;let xe=A=class{static isMarkdownString(U){return U instanceof A?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){o.set(this,void 0),Je(this,o,new y.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Re(this,o,"f").value}set value(U){Re(this,o,"f").value=U}get isTrusted(){return Re(this,o,"f").isTrusted}set isTrusted(U){Re(this,o,"f").isTrusted=U}get supportThemeIcons(){return Re(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Re(this,o,"f").supportThemeIcons=U}get supportHtml(){return Re(this,o,"f").supportHtml}set supportHtml(U){Re(this,o,"f").supportHtml=U}get baseUri(){return Re(this,o,"f").baseUri}set baseUri(U){Re(this,o,"f").baseUri=U}appendText(U){return Re(this,o,"f").appendText(U),this}appendMarkdown(U){return Re(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Re(this,o,"f").appendCodeblock(ie??"",U),this}};o=new WeakMap,xe=A=qe([F],xe),e.MarkdownString=xe;let tt=class{constructor(U,ie){this.label=U,this.documentation=ie}};tt=qe([F],tt),e.ParameterInformation=tt;let nt=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};nt=qe([F],nt),e.SignatureInformation=nt;let dt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};dt=qe([F],dt),e.SignatureHelp=dt;var Le;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ot;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(ot=e.InlayHintKind||(e.InlayHintKind={}));let Q=class{constructor(U){this.value=U}};Q=qe([F],Q),e.InlayHintLabelPart=Q;let _=class{constructor(U,ie,Ee){this.position=U,this.label=ie,this.kind=Ee}};_=qe([F],_),e.InlayHint=_;var pe;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(Me=e.CompletionItemKind||(e.CompletionItemKind={}));var Be;(function(W){W[W.Deprecated=1]="Deprecated"})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));let je=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};je=qe([F],je),e.CompletionItem=je;let Ye=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};Ye=qe([F],Ye),e.CompletionList=Ye;let it=class{constructor(U,ie,Ee){this.insertText=U,this.range=ie,this.command=Ee}};it=qe([F],it),e.InlineSuggestion=it;let bt=class{constructor(U){this.commands=void 0,this.items=U}};bt=qe([F],bt),e.InlineSuggestionList=bt;var Dt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(Dt=e.ViewColumn||(e.ViewColumn={}));var kt;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(kt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var lt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(lt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var at;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(at=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Bt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Bt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Rt;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Mt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ft;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(ft=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function U(ie){switch(ie){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=U}(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let St=class{constructor(U,ie){if(ie&&!T.URI.isUri(ie))throw(0,k.illegalArgument)("target");if(!V.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.target=ie}};St=qe([F],St),e.DocumentLink=St;let Pt=class{constructor(U,ie,Ee,Ke){this.red=U,this.green=ie,this.blue=Ee,this.alpha=Ke}};Pt=qe([F],Pt),e.Color=Pt;let Nt=class{constructor(U,ie){if(ie&&!(ie instanceof Pt))throw(0,k.illegalArgument)("color");if(!V.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.color=ie}};Nt=qe([F],Nt),e.ColorInformation=Nt;let Ge=class{constructor(U){if(!U||typeof U!="string")throw(0,k.illegalArgument)("label");this.label=U}};Ge=qe([F],Ge),e.ColorPresentation=Ge;var Ot;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ot=e.ColorFormat||(e.ColorFormat={}));var Vt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(Vt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var qt;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(qt=e.TerminalExitReason||(e.TerminalExitReason={}));class mt{constructor(U,ie,Ee){if(this.startIndex=U,this.length=ie,this.tooltip=Ee,typeof U!="number"||U<0)throw(0,k.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,k.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=mt;var Ct;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Ct=e.TerminalLocation||(e.TerminalLocation={}));class ye{constructor(U){if(this.options=U,typeof U!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=ye;var Pe;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Pe=e.TaskRevealKind||(e.TaskRevealKind={}));var me;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(me=e.TaskPanelKind||(e.TaskPanelKind={}));let x=L=class{static from(U){switch(U){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,k.illegalArgument)("name");this.c=U}get id(){return this.c}};x.Clean=new L("clean","Clean"),x.Build=new L("build","Build"),x.Rebuild=new L("rebuild","Rebuild"),x.Test=new L("test","Test"),x=L=qe([F],x),e.TaskGroup=x;function Ae(W){let U="";for(let ie=0;ie<W.length;ie++)U+=W[ie].replace(/,/g,",,")+",";return U}let Ne=class{constructor(U,ie,Ee){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Ee):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ae(U)}};Ne=qe([F],Ne),e.ProcessExecution=Ne;let Xe=class{constructor(U,ie,Ee){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U,this.f=ie,this.g=Ee}else{if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ae(U)}};Xe=qe([F],Xe),e.ShellExecution=Xe;var We;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(We=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class yt{constructor(U){this.c=U}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=yt;let pt=q=class{constructor(U,ie,Ee,Ke,Qe,st){this.j=!1,this.k=this.definition=U;let ut;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=Ee,this.execution=Ke,ut=Qe,this.j=!0):ie===Ze.Global||ie===Ze.Workspace?(this.target=ie,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=Qe,ut=st):(this.target=ie,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=Qe,ut=st),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ne?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof Xe?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof yt?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,k.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(q.g===ie||q.e===ie||q.f===ie||q.c===ie)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};pt.c="customExecution",pt.e="process",pt.f="shell",pt.g="$empty",pt=q=qe([F],pt),e.Task=pt;var At;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(At=e.ProgressLocation||(e.ProgressLocation={}));var Et;(function(W){function U(ie){const Ee=ie;return(0,w.isNumber)(Ee.value)?Ee.tooltip&&!(0,w.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}W.isViewBadge=U})(Et=e.ViewBadge||(e.ViewBadge={}));let wt=K=class{static isTreeItem(U,ie){if(U instanceof K)return!0;const Ee=U;if(Ee.label!==void 0&&!(0,w.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,w.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,w.isString)(Ee.iconPath)&&!T.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,w.isString)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,w.isString)(Ke.light)&&!T.URI.isUri(Ke.light)&&!(0,w.isString)(Ke.dark)&&!T.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,w.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!T.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,w.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof xe))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<ht.None&&Ee.collapsibleState>ht.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,w.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ke=(0,w.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,w.isObject)(Ee.checkboxState)&&(0,w.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Qe=!(0,w.isNumber)(Ee.checkboxState)&&(0,w.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==$t.Checked&&Ke!==$t.Unchecked||Qe!==void 0&&!(0,w.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(U,ie=ht.None){this.collapsibleState=ie,T.URI.isUri(U)?this.resourceUri=U:this.label=U}};wt=K=qe([F],wt),e.TreeItem=wt;var ht;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var $t;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})($t=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,O.generateUuid)()}};Jt=qe([F],Jt),e.DataTransferItem=Jt;let vt=class{constructor(U){u.set(this,new Map);for(const[ie,Ee]of U??[]){const Ke=Re(this,u,"f").get(ie);Ke?Ke.push(Ee):Re(this,u,"f").set(ie,[Ee])}}get(U){return Re(this,u,"f").get(U)?.[0]}set(U,ie){Re(this,u,"f").set(U,[ie])}forEach(U,ie){for(const[Ee,Ke]of Re(this,u,"f"))for(const Qe of Ke)U.call(ie,Qe,Ee,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Re(this,u,"f"))for(const Ee of ie)yield[U,Ee]}};vt=qe([F],vt),e.DataTransfer=vt;let xt=class{constructor(U){this.insertText=U}};xt=qe([F],xt),e.DocumentDropEdit=xt;let ai=class{constructor(U){this.insertText=U}};ai=qe([F],ai),e.DocumentPasteEdit=ai;let Ut=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Ut=qe([F],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let gi=class{constructor(U){this.id=U}};gi=qe([F],gi),e.ThemeColor=gi;var Ft;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ci=class{get base(){return this.c}set base(U){this.c=U,this.e=T.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!T.URI.isUri(U)&&!T.URI.isUri(U.uri)))throw(0,k.illegalArgument)("base");if(typeof ie!="string")throw(0,k.illegalArgument)("pattern");typeof U=="string"?this.baseUri=T.URI.file(U):T.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ci=qe([F],ci),e.RelativePattern=ci;let Zt=class{constructor(U,ie,Ee,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,O.generateUuid)()),this.c}};Zt=qe([F],Zt),e.Breakpoint=Zt;let ei=class extends Zt{constructor(U,ie,Ee,Ke,Qe){if(super(ie,Ee,Ke,Qe),U===null)throw(0,k.illegalArgument)("location");this.location=U}};ei=qe([F],ei),e.SourceBreakpoint=ei;let ti=class extends Zt{constructor(U,ie,Ee,Ke,Qe){super(ie,Ee,Ke,Qe),this.functionName=U}};ti=qe([F],ti),e.FunctionBreakpoint=ti;let ct=class extends Zt{constructor(U,ie,Ee,Ke,Qe,st,ut){if(super(Ke,Qe,st,ut),!ie)throw(0,k.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=Ee}};ct=qe([F],ct),e.DataBreakpoint=ct;let pi=class{constructor(U,ie,Ee){this.command=U,this.args=ie||[],this.options=Ee}};pi=qe([F],pi),e.DebugAdapterExecutable=pi;let Kt=class{constructor(U,ie){this.port=U,this.host=ie}};Kt=qe([F],Kt),e.DebugAdapterServer=Kt;let _t=class{constructor(U){this.path=U}};_t=qe([F],_t),e.DebugAdapterNamedPipeServer=_t;let ui=class{constructor(U){this.implementation=U}};ui=qe([F],ui),e.DebugAdapterInlineImplementation=ui;let vi=class{constructor(U,ie){this.range=U,this.expression=ie}};vi=qe([F],vi),e.EvaluatableExpression=vi;var Ci;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Ci=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let bi=class{constructor(U,ie){this.range=U,this.text=ie}};bi=qe([F],bi),e.InlineValueText=bi;let li=class{constructor(U,ie,Ee=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=Ee}};li=qe([F],li),e.InlineValueVariableLookup=li;let ii=class{constructor(U,ie){this.range=U,this.expression=ie}};ii=qe([F],ii),e.InlineValueEvaluatableExpression=ii;let Ei=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Ei=qe([F],Ei),e.InlineValueContext=Ei;var wi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(wi=e.FileChangeType||(e.FileChangeType={}));let ni=j=class extends Error{static FileExists(U){return new j(U,I.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(U){return new j(U,I.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(U){return new j(U,I.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(U){return new j(U,I.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(U){return new j(U,I.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(U){return new j(U,I.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(U,ie=I.FileSystemProviderErrorCode.Unknown,Ee){super(T.URI.isUri(U)?U.toString(!0):U),this.code=Ee?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};ni=j=qe([F],ni),e.FileSystemError=ni;let Si=class{constructor(U,ie,Ee){this.start=U,this.end=ie,this.kind=Ee}};Si=qe([F],Si),e.FoldingRange=Si;var Oi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Oi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ri;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(ri=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Fi;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Fi=e.CommentMode||(e.CommentMode={}));var Li;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Li=e.CommentThreadState||(e.CommentThreadState={}));class Mi{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Mi;function Ni(W){return typeof W>"u"||(0,w.isStringArray)(W)}class yi{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,Ee=U.tokenTypes.length;ie<Ee;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,Ee=U.tokenModifiers.length;ie<Ee;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,Ee,Ke,Qe){if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this.n(U,ie,Ee,Ke,Qe);if(V.isRange(U)&&typeof ie=="string"&&Ni(Ee))return this.m(U,ie,Ee);throw(0,k.illegalArgument)()}m(U,ie,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,Qe=U.start.character,st=U.end.character-U.start.character,ut=this.j.get(ie);let Lt=0;if(Ee)for(const jt of Ee){if(!this.k.has(jt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(jt);Lt|=1<<Gt>>>0}this.n(Ke,Qe,st,ut,Lt)}n(U,ie,Ee,Ke,Qe){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Lt=this.g.length/5|0;let jt=0,Gt=0;for(let Xt=0;Xt<Lt;Xt++){let Qt=this.g[5*Xt],Ii=this.g[5*Xt+1];Qt===0?(Qt=jt,Ii+=Gt):Qt+=jt,this.g[5*Xt]=Qt,this.g[5*Xt+1]=Ii,jt=Qt,Gt=Ii}}let st=U,ut=ie;this.f&&this.h>0&&(st-=this.c,st===0&&(ut-=this.e)),this.g[this.h++]=st,this.g[this.h++]=ut,this.g[this.h++]=Ee,this.g[this.h++]=Ke,this.g[this.h++]=Qe,this.c=U,this.e=ie}static o(U){const ie=[],Ee=U.length/5|0;for(let ut=0;ut<Ee;ut++)ie[ut]=ut;ie.sort((ut,Lt)=>{const jt=U[5*ut],Gt=U[5*Lt];if(jt===Gt){const Xt=U[5*ut+1],Qt=U[5*Lt+1];return Xt-Qt}return jt-Gt});const Ke=new Uint32Array(U.length);let Qe=0,st=0;for(let ut=0;ut<Ee;ut++){const Lt=5*ie[ut],jt=U[Lt+0],Gt=U[Lt+1],Xt=U[Lt+2],Qt=U[Lt+3],Ii=U[Lt+4],en=jt-Qe,In=en===0?Gt-st:Gt,Di=5*ut;Ke[Di+0]=en,Ke[Di+1]=In,Ke[Di+2]=Xt,Ke[Di+3]=Qt,Ke[Di+4]=Ii,Qe=jt,st=Gt}return Ke}build(U){return this.f?new si(new Uint32Array(this.g),U):new si(yi.o(this.g),U)}}e.SemanticTokensBuilder=yi;class si{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=si;class ki{constructor(U,ie,Ee){this.start=U,this.deleteCount=ie,this.data=Ee}}e.SemanticTokensEdit=ki;class Ti{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=Ti;var Ue;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(Ue=e.DebugConsoleMode||(e.DebugConsoleMode={}));let zt=class{constructor(){}};zt.Back={iconPath:new Ut("arrow-left")},zt=qe([F],zt),e.QuickInputButtons=zt;var Pi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Pi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var gt;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(gt=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ui;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Ui=e.ExtensionKind||(e.ExtensionKind={}));class Bi{static validate(U){if(typeof U.badge=="string"){let ie=(0,R.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,R.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Ut.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,Ee){this.badge=U,this.tooltip=ie,this.color=Ee}}e.FileDecoration=Bi;let di=class{constructor(U){this.kind=U}};di=qe([F],di),e.ColorTheme=di;var $i;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})($i=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{static isNotebookRange(U){return U instanceof Wt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("start must be positive");if(ie<0)throw(0,k.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,Ee=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(Ee=U.end),ie===this.c&&Ee===this.e?this:new Wt(ie,Ee)}}e.NotebookRange=Wt;class hi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>hi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,Ee,Ke,Qe,st,ut){this.kind=U,this.value=ie,this.languageId=Ee,this.mime=Ke,this.outputs=Qe??[],this.metadata=st,this.executionSummary=ut,hi.validate(this)}}e.NotebookCellData=hi;class zi{constructor(U){this.cells=U}}e.NotebookData=zi;class Ht{static isNotebookCellOutputItem(U){return U instanceof Ht?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return Ht.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return Ht.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Ht.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new Ht(U,ie)}static text(U,ie=C.Mimes.text){const Ee=Re(Ht,g,"f",E).encode(String(U));return new Ht(Ee,ie)}static json(U,ie="text/x-json"){const Ee=JSON.stringify(U,void 0,"	");return Ht.text(Ee,ie)}constructor(U,ie){this.data=U,this.mime=ie;const Ee=(0,C.normalizeMimeType)(ie,!0);if(!Ee)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=Ht,g=Ht,E={value:new TextEncoder};class oi{static isNotebookCellOutput(U){return U instanceof oi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const Ee=new Set,Ke=new Set;for(let Qe=0;Qe<U.length;Qe++){const st=U[Qe],ut=(0,C.normalizeMimeType)(st.mime);if(!Ee.has(ut)||(0,v.isTextStreamMime)(ut)){Ee.add(ut);continue}Ke.add(Qe),ie&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ke.size===0?U:U.filter((Qe,st)=>!Ke.has(st))}constructor(U,ie,Ee){this.items=oi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ee):(this.id=(0,O.generateUuid)(),this.metadata=ie??Ee)}}e.NotebookCellOutput=oi;var Wi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Wi=e.NotebookCellKind||(e.NotebookCellKind={}));var Hi;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Hi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Vi;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Vi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ji;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(ji=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class qi{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=qi;var Ki;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(Ki=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ne;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(ne=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class de{constructor(U,ie=[]){this.uri=U,this.provides=(0,i.asArray)(ie)}}e.NotebookRendererScript=de;class Oe{constructor(U){this.label=U}}e.NotebookKernelSourceAction=Oe;let rt=class{constructor(U,ie){this.label=U,this.timestamp=ie}};rt=qe([F],rt),e.TimelineItem=rt;var It;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(It=e.ExtensionMode||(e.ExtensionMode={}));var Tt;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(Tt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var sn;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(sn=e.StandardTokenType||(e.StandardTokenType={}));class on{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=on;class an{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=an;var cn;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(cn=e.TestResultState||(e.TestResultState={}));var un;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(un=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Gi=class{constructor(U=void 0,ie=void 0,Ee=void 0){this.include=U,this.exclude=ie,this.profile=Ee}};Gi=qe([F],Gi),e.TestRunRequest=Gi;let xi=P=class{static diff(U,ie,Ee){const Ke=new P(U);return Ke.expectedOutput=ie,Ke.actualOutput=Ee,Ke}constructor(U){this.message=U}};xi=P=qe([F],xi),e.TestMessage=xi;let Xi=class{constructor(U){this.id=U}};Xi=qe([F],Xi),e.TestTag=Xi;let fi=class{constructor(U,ie){this.covered=U,this.total=ie}};fi=qe([F],fi),e.CoveredCount=fi;let _i=N=class{static fromDetails(U,ie){const Ee=new fi(0,0),Ke=new fi(0,0),Qe=new fi(0,0);for(const ut of ie)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const Lt of ut.branches)Ke.total+=1,Ke.covered+=Lt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ut.executionCount>0?1:0;const st=new N(U,Ee,Ke.total>0?Ke:void 0,Qe.total>0?Qe:void 0);return st.detailedCoverage=ie,st}constructor(U,ie,Ee,Ke){this.uri=U,this.statementCoverage=ie,this.branchCoverage=Ee,this.functionCoverage=Ke}};_i=N=qe([F],_i),e.FileCoverage=_i;let Qi=class{constructor(U,ie,Ee=[]){this.executionCount=U,this.location=ie,this.branches=Ee}};Qi=qe([F],Qi),e.StatementCoverage=Qi;let Yi=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Yi=qe([F],Yi),e.BranchCoverage=Yi;let Ji=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Ji=qe([F],Ji),e.FunctionCoverage=Ji;var ln;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(ln=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var dn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(dn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var hn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class fn{constructor(U,ie,Ee,Ke,Qe,st){this.kind=U,this.name=ie,this.detail=Ee,this.uri=Ke,this.range=Qe,this.selectionRange=st}}e.TypeHierarchyItem=fn;class mn{constructor(U){this.uri=U}}e.TextTabInput=mn;class gn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=gn;class pn{constructor(U,ie,Ee,Ke){this.base=U,this.input1=ie,this.input2=Ee,this.result=Ke}}e.TextMergeTabInput=pn;class vn{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=vn;class bn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=bn;class En{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=En;class wn{constructor(U,ie,Ee){this.original=U,this.modified=ie,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=wn;class Sn{constructor(){}}e.TerminalEditorTabInput=Sn;class yn{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=yn}),define(De[95],Ce([1,0,47,13,10,250,126,6,16]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const T=new Map;function O(f,t){t?T.set(f,t):T.delete(f)}e.setWordDefinitionFor=O;function I(f){return T.get(f)}class m extends M.MirrorTextModel{constructor(t,o,u,g,E,b,S,s){super(o,u,g,E),this.m=t,this.p=b,this.q=S,this.notebook=s,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(t){return(0,w.equals)(this.d,t)}get document(){if(!this.a){const t=this;this.a={get uri(){return t.c},get fileName(){return t.c.fsPath},get isUntitled(){return t.c.scheme===k.Schemas.untitled},get languageId(){return t.p},get version(){return t.g},get isClosed(){return t.b},get isDirty(){return t.q},save(){return t.r()},getText(o){return o?t.s(o):t.getText()},get eol(){return t.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return t.d.length},lineAt(o){return t.t(o)},offsetAt(o){return t.u(o)},positionAt(o){return t.v(o)},validateRange(o){return t.w(o)},validatePosition(o){return t.x(o)},getWordRangeAtPosition(o,u){return t.y(o,u)}}}return Object.freeze(this.a)}_acceptLanguageId(t){(0,i.ok)(!this.b),this.p=t}_acceptIsDirty(t){(0,i.ok)(!this.b),this.q=t}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(t){const o=this.w(t);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const u=this.f,g=o.start.line,E=o.end.line,b=[];b.push(this.d[g].substring(o.start.character));for(let S=g+1;S<E;S++)b.push(this.d[S]);return b.push(this.d[E].substring(0,o.end.character)),b.join(u)}t(t){let o;if(t instanceof R.Position?o=t.line:typeof t=="number"&&(o=t),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.d[o],o===this.d.length-1)}u(t){return t=this.x(t),this.k(),this.h.getPrefixSum(t.line-1)+t.character}v(t){t=Math.floor(t),t=Math.max(0,t),this.k();const o=this.h.getIndexOf(t),u=this.d[o.index].length;return new R.Position(o.index,Math.min(o.remainder,u))}w(t){if(!(t instanceof R.Range))throw new Error("Invalid argument");const o=this.x(t.start),u=this.x(t.end);return o===t.start&&u===t.end?t:new R.Range(o.line,o.character,u.line,u.character)}x(t){if(!(t instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return t.with(0,0);let{line:o,character:u}=t,g=!1;if(o<0)o=0,u=0,g=!0;else if(o>=this.d.length)o=this.d.length-1,u=this.d[o].length,g=!0;else{const E=this.d[o].length;u<0?(u=0,g=!0):u>E&&(u=E,g=!0)}return g?new R.Position(o,u):t}y(t,o){const u=this.x(t);if(!o)o=I(this.p);else if((0,y.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const g=(0,C.getWordAtText)(u.character+1,(0,C.ensureValidWordDefinition)(o),this.d[u.line],0);if(g)return new R.Range(u.line,g.startColumn-1,u.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class v{constructor(t,o,u){this.a=t,this.b=o,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=v}),define(De[184],Ce([1,0,6,14,4]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(R){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let w;switch(R){case"light":w=i.ColorThemeKind.Light;break;case"hcDark":w=i.ColorThemeKind.HighContrast;break;case"hcLight":w=i.ColorThemeKind.HighContrastLight;break;default:w=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(w),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([Ve(0,k.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(De[8],Ce([1,0,16,24,111,185,81,28,108,80,60,23,9,2,53,71,86,93,92,66,42,52,179,6]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b,S,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ye){function Pe(x){const{selectionStartLineNumber:Ae,selectionStartColumn:Ne,positionLineNumber:Xe,positionColumn:We}=x,Ze=new r.Position(Ae-1,Ne-1),yt=new r.Position(Xe-1,We-1);return new r.Selection(Ze,yt)}ye.to=Pe;function me(x){const{anchor:Ae,active:Ne}=x;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}ye.from=me})(a=e.Selection||(e.Selection={}));var h;(function(ye){function Pe(x){if(!x)return;const{start:Ae,end:Ne}=x;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}ye.from=Pe;function me(x){if(!x)return;const{startLineNumber:Ae,startColumn:Ne,endLineNumber:Xe,endColumn:We}=x;return new r.Range(Ae-1,Ne-1,Xe-1,We-1)}ye.to=me})(h=e.Range||(e.Range={}));var c;(function(ye){function Pe(me){switch(me){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}ye.to=Pe})(c=e.TokenType||(e.TokenType={}));var d;(function(ye){function Pe(x){return new r.Position(x.lineNumber-1,x.column-1)}ye.to=Pe;function me(x){return{lineNumber:x.line+1,column:x.character+1}}ye.from=me})(d=e.Position||(e.Position={}));var n;(function(ye){function Pe(Ae,Ne){return(0,i.coalesce)((0,i.asArray)(Ae).map(Xe=>me(Xe,Ne)))}ye.from=Pe;function me(Ae,Ne){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:x(Ae.scheme,Ne),pattern:_.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function x(Ae,Ne){return Ne&&typeof Ae=="string"?Ne.transformOutgoingScheme(Ae):Ae}})(n=e.DocumentSelector||(e.DocumentSelector={}));var l;(function(ye){function Pe(x){switch(x){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function me(x){switch(x){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}ye.to=me})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(ye){function Pe(x){let Ae;return x.code&&((0,m.isString)(x.code)||(0,m.isNumber)(x.code)?Ae=String(x.code):Ae={value:String(x.code.value),target:x.code.target}),{...h.from(x.range),message:x.message,source:x.source,code:Ae,severity:L.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(A.from),tags:Array.isArray(x.tags)?(0,i.coalesce)(x.tags.map(l.from)):void 0}}ye.from=Pe;function me(x){const Ae=new r.Diagnostic(h.to(x),x.message,L.to(x.severity));return Ae.source=x.source,Ae.code=(0,m.isString)(x.code)?x.code:x.code?.value,Ae.relatedInformation=x.relatedInformation&&x.relatedInformation.map(A.to),Ae.tags=x.tags&&(0,i.coalesce)(x.tags.map(l.to)),Ae}ye.to=me})(p=e.Diagnostic||(e.Diagnostic={}));var A;(function(ye){function Pe(x){return{...h.from(x.location.range),message:x.message,resource:x.location.uri}}ye.from=Pe;function me(x){return new r.DiagnosticRelatedInformation(new r.Location(x.resource,h.to(x)),x.message)}ye.to=me})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(ye){function Pe(x){switch(x){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ye.from=Pe;function me(x){switch(x){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}ye.to=me})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(ye){function Pe(x){return typeof x=="number"&&x>=r.ViewColumn.One?x-1:x===r.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ye.from=Pe;function me(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=me})(q=e.ViewColumn||(e.ViewColumn={}));function K(ye){return typeof ye.range<"u"}function j(ye){return ye.length===0?!0:!!K(ye[0])}e.isDecorationOptionsArr=j;var P;(function(ye){function Pe(We){return We.map(ye.from)}ye.fromMany=Pe;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function x(We){let Ze;if(me(We)){const{language:Et,value:wt}=We;Ze={value:"```"+Et+`
`+wt+"\n```\n"}}else r.MarkdownString.isMarkdownString(We)?Ze={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?Ze={value:We}:Ze={value:""};const yt=Object.create(null);Ze.uris=yt;const pt=Et=>{try{let wt=v.URI.parse(Et,!0);wt=wt.with({query:Ae(wt.query,yt)}),yt[Et]=wt}catch{}return""},At=new w.marked.Renderer;return At.link=pt,At.image=Et=>typeof Et=="string"?pt(C.parseHrefAndDimensions(Et).href):"",(0,w.marked)(Ze.value,{renderer:At}),Ze}ye.from=x;function Ae(We,Ze){if(!We)return We;let yt;try{yt=(0,T.parse)(We)}catch{}if(!yt)return We;let pt=!1;return yt=(0,I.cloneAndChange)(yt,At=>{if(v.URI.isUri(At)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Et]=At,pt=!0,Et}else return}),pt?JSON.stringify(yt):We}function Ne(We){const Ze=new r.MarkdownString(We.value,We.supportThemeIcons);return Ze.isTrusted=We.isTrusted,Ze.supportHtml=We.supportHtml,Ze.baseUri=We.baseUri?v.URI.from(We.baseUri):void 0,Ze}ye.to=Ne;function Xe(We){if(!!We)return typeof We=="string"?We:ye.from(We)}ye.fromStrict=Xe})(P=e.MarkdownString||(e.MarkdownString={}));function N(ye){return j(ye)?ye.map(Pe=>({range:h.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?P.fromMany(Pe.hoverMessage):Pe.hoverMessage?P.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:h.from(Pe)}))}e.fromRangeOrRangeWithMessage=N;function F(ye){return typeof ye>"u"?ye:typeof ye=="string"?v.URI.file(ye):ye}e.pathOrURIToURI=F;var $;(function(ye){function Pe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?F(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}ye.from=Pe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?F(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(ye){function Pe(me){if(typeof me>"u")return me;switch(me){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var X;(function(ye){function Pe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?V.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?z.from(me.light):void 0,dark:me.dark?z.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?F(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}ye.from=Pe})(X=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(ye){function Pe(x){return{text:x.newText,eol:x.newEol&&nt.from(x.newEol),range:h.from(x.range)}}ye.from=Pe;function me(x){const Ae=new r.TextEdit(h.to(x.range),x.text);return Ae.newEol=typeof x.eol>"u"?void 0:nt.to(x.eol),Ae}ye.to=me})(ee=e.TextEdit||(e.TextEdit={}));var fe;(function(ye){function Pe(x,Ae){const Ne={edits:[]};if(x instanceof r.WorkspaceEdit){const Xe=new R.ResourceSet;for(const We of x._allEntries())We._type===1&&v.URI.isUri(We.to)&&We.from===void 0&&Xe.add(We.to);for(const We of x._allEntries())We._type===1?Ne.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,k.encodeBase64)(k.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Ne.edits.push({resource:We.uri,textEdit:ee.from(We.edit),versionId:Xe.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Ne.edits.push({resource:We.uri,textEdit:{range:h.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Xe.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ne.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ne.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(bt.from)}})}return Ne}ye.from=Pe;function me(x){const Ae=new r.WorkspaceEdit;for(const Ne of x.edits)Ne.textEdit?Ae.replace(v.URI.revive(Ne.resource),h.to(Ne.textEdit.range),Ne.textEdit.text):Ae.renameFile(v.URI.revive(Ne.oldResource),v.URI.revive(Ne.newResource),Ne.options);return Ae}ye.to=me})(fe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(ye){const Pe=Object.create(null);Pe[r.SymbolKind.File]=0,Pe[r.SymbolKind.Module]=1,Pe[r.SymbolKind.Namespace]=2,Pe[r.SymbolKind.Package]=3,Pe[r.SymbolKind.Class]=4,Pe[r.SymbolKind.Method]=5,Pe[r.SymbolKind.Property]=6,Pe[r.SymbolKind.Field]=7,Pe[r.SymbolKind.Constructor]=8,Pe[r.SymbolKind.Enum]=9,Pe[r.SymbolKind.Interface]=10,Pe[r.SymbolKind.Function]=11,Pe[r.SymbolKind.Variable]=12,Pe[r.SymbolKind.Constant]=13,Pe[r.SymbolKind.String]=14,Pe[r.SymbolKind.Number]=15,Pe[r.SymbolKind.Boolean]=16,Pe[r.SymbolKind.Array]=17,Pe[r.SymbolKind.Object]=18,Pe[r.SymbolKind.Key]=19,Pe[r.SymbolKind.Null]=20,Pe[r.SymbolKind.EnumMember]=21,Pe[r.SymbolKind.Struct]=22,Pe[r.SymbolKind.Event]=23,Pe[r.SymbolKind.Operator]=24,Pe[r.SymbolKind.TypeParameter]=25;function me(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}ye.from=me;function x(Ae){for(const Ne in Pe)if(Pe[Ne]===Ae)return Number(Ne);return r.SymbolKind.Property}ye.to=x})(oe=e.SymbolKind||(e.SymbolKind={}));var ue;(function(ye){function Pe(x){switch(x){case r.SymbolTag.Deprecated:return 1}}ye.from=Pe;function me(x){switch(x){case 1:return r.SymbolTag.Deprecated}}ye.to=me})(ue=e.SymbolTag||(e.SymbolTag={}));var ce;(function(ye){function Pe(x){return{name:x.name,kind:oe.from(x.kind),tags:x.tags&&x.tags.map(ue.from),containerName:x.containerName,location:Fe.from(x.location)}}ye.from=Pe;function me(x){const Ae=new r.SymbolInformation(x.name,oe.to(x.kind),x.containerName,Fe.to(x.location));return Ae.tags=x.tags&&x.tags.map(ue.to),Ae}ye.to=me})(ce=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var he;(function(ye){function Pe(x){const Ae={name:x.name||"!!MISSING: name!!",detail:x.detail,range:h.from(x.range),selectionRange:h.from(x.selectionRange),kind:oe.from(x.kind),tags:x.tags?.map(ue.from)??[]};return x.children&&(Ae.children=x.children.map(Pe)),Ae}ye.from=Pe;function me(x){const Ae=new r.DocumentSymbol(x.name,x.detail,oe.to(x.kind),h.to(x.range),h.to(x.selectionRange));return(0,i.isNonEmptyArray)(x.tags)&&(Ae.tags=x.tags.map(ue.to)),x.children&&(Ae.children=x.children.map(me)),Ae}ye.to=me})(he=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(ye){function Pe(x){const Ae=new r.CallHierarchyItem(oe.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),h.to(x.range),h.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}ye.to=Pe;function me(x,Ae,Ne){if(Ae=Ae??x._sessionId,Ne=Ne??x._itemId,Ae===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ne,name:x.name,detail:x.detail,kind:oe.from(x.kind),uri:x.uri,range:h.from(x.range),selectionRange:h.from(x.selectionRange),tags:x.tags?.map(ue.from)}}ye.from=me})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(ye){function Pe(me){return new r.CallHierarchyIncomingCall(Y.to(me.from),me.fromRanges.map(x=>h.to(x)))}ye.to=Pe})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Se;(function(ye){function Pe(me){return new r.CallHierarchyOutgoingCall(Y.to(me.to),me.fromRanges.map(x=>h.to(x)))}ye.to=Pe})(Se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Fe;(function(ye){function Pe(x){return{range:x.range&&h.from(x.range),uri:x.uri}}ye.from=Pe;function me(x){return new r.Location(v.URI.revive(x.uri),h.to(x.range))}ye.to=me})(Fe=e.location||(e.location={}));var ze;(function(ye){function Pe(x){const Ae=x,Ne=x;return{originSelectionRange:Ae.originSelectionRange?h.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ne.uri,range:h.from(Ae.targetRange?Ae.targetRange:Ne.range),targetSelectionRange:Ae.targetSelectionRange?h.from(Ae.targetSelectionRange):void 0}}ye.from=Pe;function me(x){return{targetUri:v.URI.revive(x.uri),targetRange:h.to(x.range),targetSelectionRange:x.targetSelectionRange?h.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?h.to(x.originSelectionRange):void 0}}ye.to=me})(ze=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ye){function Pe(x){return{range:h.from(x.range),contents:P.fromMany(x.contents)}}ye.from=Pe;function me(x){return new r.Hover(x.contents.map(P.to),h.to(x.range))}ye.to=me})(_e=e.Hover||(e.Hover={}));var ke;(function(ye){function Pe(x){return{range:h.from(x.range),expression:x.expression}}ye.from=Pe;function me(x){return new r.EvaluatableExpression(h.to(x.range),x.expression)}ye.to=me})(ke=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(ye){function Pe(x){if(x instanceof r.InlineValueText)return{type:"text",range:h.from(x.range),text:x.text};if(x instanceof r.InlineValueVariableLookup)return{type:"variable",range:h.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function me(x){switch(x.type){case"text":return{range:h.to(x.range),text:x.text};case"variable":return{range:h.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:h.to(x.range),expression:x.expression}}}ye.to=me})(Ie=e.InlineValue||(e.InlineValue={}));var Te;(function(ye){function Pe(x){return{frameId:x.frameId,stoppedLocation:h.from(x.stoppedLocation)}}ye.from=Pe;function me(x){return new r.InlineValueContext(x.frameId,h.to(x.stoppedLocation))}ye.to=me})(Te=e.InlineValueContext||(e.InlineValueContext={}));var re;(function(ye){function Pe(x){return{range:h.from(x.range),kind:x.kind}}ye.from=Pe;function me(x){return new r.DocumentHighlight(h.to(x.range),x.kind)}ye.to=me})(re=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(ye){function Pe(me){switch(me){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}ye.to=Pe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(ye){function Pe(me){return{triggerKind:ae.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}ye.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var D;(function(ye){function Pe(x){switch(x){case r.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function me(x){switch(x){case 1:return r.CompletionItemTag.Deprecated}}ye.to=me})(D=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(ye){const Pe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function me(Ne){return Pe.get(Ne)??9}ye.from=me;const x=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ae(Ne){return x.get(Ne)??r.CompletionItemKind.Property}ye.to=Ae})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Pe(me,x){const Ae=new r.CompletionItem(me.label);return Ae.insertText=me.insertText,Ae.kind=B.to(me.kind),Ae.tags=me.tags?.map(D.to),Ae.detail=me.detail,Ae.documentation=C.isMarkdownString(me.documentation)?P.to(me.documentation):me.documentation,Ae.sortText=me.sortText,Ae.filterText=me.filterText,Ae.preselect=me.preselect,Ae.commitCharacters=me.commitCharacters,f.Range.isIRange(me.range)?Ae.range=h.to(me.range):typeof me.range=="object"&&(Ae.range={inserting:h.to(me.range.insert),replacing:h.to(me.range.replace)}),Ae.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Ae.insertText=new r.SnippetString(me.insertText):(Ae.insertText=me.insertText,Ae.textEdit=Ae.range instanceof r.Range?new r.TextEdit(Ae.range,Ae.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ae.additionalTextEdits=me.additionalTextEdits.map(Ne=>ee.to(Ne))),Ae.command=x&&me.command?x.fromInternal(me.command):void 0,Ae}ye.to=Pe})(H=e.CompletionItem||(e.CompletionItem={}));var G;(function(ye){function Pe(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:P.fromStrict(x.documentation)}}ye.from=Pe;function me(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?P.to(x.documentation):x.documentation}}ye.to=me})(G=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ye){function Pe(x){return{label:x.label,documentation:P.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(G.from):[],activeParameter:x.activeParameter}}ye.from=Pe;function me(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?P.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(G.to):[],activeParameter:x.activeParameter}}ye.to=me})(Z=e.SignatureInformation||(e.SignatureInformation={}));var le;(function(ye){function Pe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(Z.from):[]}}ye.from=Pe;function me(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(Z.to):[]}}ye.to=me})(le=e.SignatureHelp||(e.SignatureHelp={}));var be;(function(ye){function Pe(me,x){const Ae=new r.InlayHint(d.to(x.position),typeof x.label=="string"?x.label:x.label.map(se.to.bind(void 0,me)),x.kind&&we.to(x.kind));return Ae.textEdits=x.textEdits&&x.textEdits.map(ee.to),Ae.tooltip=C.isMarkdownString(x.tooltip)?P.to(x.tooltip):x.tooltip,Ae.paddingLeft=x.paddingLeft,Ae.paddingRight=x.paddingRight,Ae}ye.to=Pe})(be=e.InlayHint||(e.InlayHint={}));var se;(function(ye){function Pe(me,x){const Ae=new r.InlayHintLabelPart(x.label);return Ae.tooltip=C.isMarkdownString(x.tooltip)?P.to(x.tooltip):x.tooltip,t.Command.is(x.command)&&(Ae.command=me.fromInternal(x.command)),x.location&&(Ae.location=Fe.to(x.location)),Ae}ye.to=Pe})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(ye){function Pe(x){return x}ye.from=Pe;function me(x){return x}ye.to=me})(we=e.InlayHintKind||(e.InlayHintKind={}));var ve;(function(ye){function Pe(x){return{range:h.from(x.range),url:x.target,tooltip:x.tooltip}}ye.from=Pe;function me(x){let Ae;if(x.url)try{Ae=typeof x.url=="string"?v.URI.parse(x.url,!0):v.URI.revive(x.url)}catch{}return new r.DocumentLink(h.to(x.range),Ae)}ye.to=me})(ve=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ye){function Pe(x){const Ae=new r.ColorPresentation(x.label);return x.textEdit&&(Ae.textEdit=ee.to(x.textEdit)),x.additionalTextEdits&&(Ae.additionalTextEdits=x.additionalTextEdits.map(Ne=>ee.to(Ne))),Ae}ye.to=Pe;function me(x){return{label:x.label,textEdit:x.textEdit?ee.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Ae=>ee.from(Ae)):void 0}}ye.from=me})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Pe(x){return new r.Color(x[0],x[1],x[2],x[3])}ye.to=Pe;function me(x){return[x.red,x.green,x.blue,x.alpha]}ye.from=me})(He=e.Color||(e.Color={}));var et;(function(ye){function Pe(x){return{range:h.from(x.range)}}ye.from=Pe;function me(x){return new r.SelectionRange(h.to(x.range))}ye.to=me})(et=e.SelectionRange||(e.SelectionRange={}));var xe;(function(ye){function Pe(me){switch(me){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(ye){function Pe(x){switch(x){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function me(x){switch(x){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}ye.to=me})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(ye){function Pe(x){if(x===r.EndOfLine.CRLF)return 1;if(x===r.EndOfLine.LF)return 0}ye.from=Pe;function me(x){if(x===1)return r.EndOfLine.CRLF;if(x===0)return r.EndOfLine.LF}ye.to=me})(nt=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(me){if(typeof me=="object")return me.viewId;switch(me){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(ye){function Pe(me){const x={start:me.start+1,end:me.end+1};return me.kind&&(x.kind=ot.from(me.kind)),x}ye.from=Pe})(Le=e.FoldingRange||(e.FoldingRange={}));var ot;(function(ye){function Pe(me){if(me)switch(me){case r.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}ye.from=Pe})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ye){function Pe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?h.from(me.selection):void 0,override:typeof me.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var _;(function(ye){function Pe(Ne){return Ne instanceof r.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:me(Ne)||x(Ne)?new r.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}ye.from=Pe;function me(Ne){const Xe=Ne;return Xe?v.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function x(Ne){const Xe=Ne;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Ne){return typeof Ne=="string"?Ne:new r.RelativePattern(v.URI.revive(Ne.baseUri),Ne.pattern)}ye.to=Ae})(_=e.GlobPattern||(e.GlobPattern={}));var pe;(function(ye){function Pe(me){if(me){if(Array.isArray(me))return me.map(Pe);if(typeof me=="string")return me;{const x=me;return{language:x.language,scheme:x.scheme,pattern:_.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}ye.from=Pe})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(ye){function Pe(x){return{start:x.start,end:x.end}}ye.from=Pe;function me(x){return new r.NotebookRange(x.start,x.end)}ye.to=me})(Me=e.NotebookRange||(e.NotebookRange={}));var Be;(function(ye){function Pe(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}ye.to=Pe;function me(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}ye.from=me})(Be=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(ye){function Pe(me){if(me===E.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(me===E.NotebookCellExecutionState.Pending)return;if(me===E.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}ye.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(ye){function Pe(x){switch(x){case r.NotebookCellKind.Markup:return E.CellKind.Markup;case r.NotebookCellKind.Code:default:return E.CellKind.Code}}ye.from=Pe;function me(x){switch(x){case E.CellKind.Markup:return r.NotebookCellKind.Markup;case E.CellKind.Code:default:return r.NotebookCellKind.Code}}ye.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(ye){function Pe(x){const Ae={metadata:x.metadata??Object.create(null),cells:[]};for(const Ne of x.cells)r.NotebookCellData.validate(Ne),Ae.cells.push(bt.from(Ne));return Ae}ye.from=Pe;function me(x){const Ae=new r.NotebookData(x.cells.map(bt.to));return(0,m.isEmptyObject)(x.metadata)||(Ae.metadata=x.metadata),Ae}ye.to=me})(it=e.NotebookData||(e.NotebookData={}));var bt;(function(ye){function Pe(x){return{cellKind:Ye.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:Be.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(kt.from):[]}}ye.from=Pe;function me(x){return new r.NotebookCellData(Ye.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(kt.to):void 0,x.metadata,x.internalMetadata?Be.to(x.internalMetadata):void 0)}ye.to=me})(bt=e.NotebookCellData||(e.NotebookCellData={}));var Dt;(function(ye){function Pe(x){return{mime:x.mime,valueBytes:k.VSBuffer.wrap(x.data)}}ye.from=Pe;function me(x){return new r.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}ye.to=me})(Dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var kt;(function(ye){function Pe(x){return{outputId:x.id,items:x.items.map(Dt.from),metadata:x.metadata}}ye.from=Pe;function me(x){const Ae=x.items.map(Dt.to);return new r.NotebookCellOutput(Ae,x.outputId,x.metadata)}ye.to=me})(kt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Pe(Ae){return x(Ae)?{include:(0,m.withNullAsUndefined)(_.from(Ae.include)),exclude:(0,m.withNullAsUndefined)(_.from(Ae.exclude))}:(0,m.withNullAsUndefined)(_.from(Ae))}ye.from=Pe;function me(Ae){return x(Ae)?{include:_.to(Ae.include),exclude:_.to(Ae.exclude)}:_.to(Ae)}ye.to=me;function x(Ae){const Ne=Ae;return Ne?!(0,m.isUndefinedOrNull)(Ne.include)&&!(0,m.isUndefinedOrNull)(Ne.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Pe(me,x,Ae){const Ne=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Ne,Ae),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}ye.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(ye){function Pe(me,x,Ae){const Ne=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:x.toInternal(Ne,Ae),label:me.label,description:me.description,detail:me.detail}}ye.from=Pe})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Rt;(function(ye){function Pe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}ye.from=Pe})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Mt;(function(ye){function Pe(x){return{uri:x.uri,provides:x.provides}}ye.from=Pe;function me(x){return new r.NotebookRendererScript(v.URI.revive(x.uri),x.provides)}ye.to=me})(Mt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(ye){function Pe(x){return{message:P.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:h.from(x.location.range),uri:x.location.uri}}}ye.from=Pe;function me(x){const Ae=new r.TestMessage(typeof x.message=="string"?x.message:P.to(x.message));return Ae.actualOutput=x.actual,Ae.expectedOutput=x.expected,Ae.location=x.location?Fe.to(x.location):void 0,Ae}ye.to=me})(ft=e.TestMessage||(e.TestMessage={}));var St;(function(ye){ye.namespace=S.namespaceTestTag,ye.denamespace=S.denamespaceTestTag})(St=e.TestTag||(e.TestTag={}));var Pt;(function(ye){function Pe(x){const Ae=(0,u.getPrivateApiFor)(x).controllerId;return{extId:b.TestId.fromExtHostTestItem(x,Ae).toString(),label:x.label,uri:v.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Ne=>St.namespace(Ae,Ne.id)),range:f.Range.lift(h.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&P.fromStrict(x.error)||null}}ye.from=Pe;function me(x){return{parent:void 0,error:void 0,id:b.TestId.fromString(x.extId).localId,label:x.label,uri:v.URI.revive(x.uri),tags:(x.tags||[]).map(Ae=>{const{tagId:Ne}=St.denamespace(Ae);return new r.TestTag(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}ye.toPlain=me})(Pt=e.TestItem||(e.TestItem={})),function(ye){function Pe(x){return{id:x.id}}ye.from=Pe;function me(x){return new r.TestTag(x.id)}ye.to=me}(St=e.TestTag||(e.TestTag={}));var Nt;(function(ye){const Pe=(x,Ae)=>{const Ne=[];for(const[We,Ze]of Ae)b.TestId.compare(Ze.item.extId,We)===2&&(Ae.delete(We),Ne.push(Ze));const Xe={...Pt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Ne.map(We=>Pe(We,Ae))};for(const We of Xe.children)We.parent=Xe;return Xe};function me(x){const Ae=[],Ne=new Map;for(const Xe of x.items){Ne.set(Xe.item.extId,Xe);const We=b.TestId.root(Xe.item.extId);x.request.targets.some(Ze=>Ze.controllerId===We&&Ze.testIds.includes(Xe.item.extId))&&Ae.push(Xe)}return{completedAt:x.completedAt,results:Ae.map(Xe=>Pe(Xe,Ne))}}ye.to=me})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(ye){function Pe(Ne){return{covered:Ne.covered,total:Ne.covered}}function me(Ne){return"line"in Ne?d.from(Ne):h.from(Ne)}function x(Ne){return"branches"in Ne?{count:Ne.executionCount,location:me(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&me(Xe.location)})):void 0}:{type:0,count:Ne.executionCount,location:me(Ne.location)}}ye.fromDetailed=x;function Ae(Ne){return{uri:Ne.uri,statement:Pe(Ne.statementCoverage),branch:Ne.branchCoverage&&Pe(Ne.branchCoverage),function:Ne.functionCoverage&&Pe(Ne.functionCoverage),details:Ne.detailedCoverage?.map(x)}}ye.fromFile=Ae})(Ge=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(ye){function Pe(me){switch(me){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Vt;(function(ye){function Pe(x){const Ae=new r.TypeHierarchyItem(oe.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),h.to(x.range),h.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}ye.to=Pe;function me(x,Ae,Ne){if(Ae=Ae??x._sessionId,Ne=Ne??x._itemId,Ae===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ne,kind:oe.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:h.from(x.range),selectionRange:h.from(x.selectionRange),tags:x.tags?.map(ue.from)}}ye.from=me})(Vt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var qt;(function(ye){function Pe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}ye.from=Pe})(qt=e.ViewBadge||(e.ViewBadge={}));var mt;(function(ye){function Pe(Ne,Xe,We){const Ze=Xe.fileData;return Ze?new class extends r.DataTransferItem{asFile(){return{name:Ze.name,uri:v.URI.revive(Ze.uri),data:(0,M.once)(()=>We())}}}("",Xe.id):Ne===O.Mimes.uriList&&Xe.uriListData?new r.DataTransferItem(Ae(Xe.uriListData)):new r.DataTransferItem(Xe.asString)}ye.to=Pe;async function me(Ne,Xe){const We=await Xe.asString();if(Ne===O.Mimes.uriList)return{id:Xe.id,asString:"",fileData:void 0,uriListData:x(We)};const Ze=Xe.asFile();return{id:Xe.id,asString:We,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=me;function x(Ne){return y.UriList.split(Ne).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return v.URI.parse(Xe)}catch{}return Xe})}function Ae(Ne){return y.UriList.create(Ne.map(Xe=>typeof Xe=="string"?Xe:v.URI.revive(Xe)))}})(mt=e.DataTransferItem||(e.DataTransferItem={}));var Ct;(function(ye){function Pe(x,Ae){const Ne=x.items.map(([Xe,We])=>[Xe,mt.to(Xe,We,()=>Ae(We.id))]);return new r.DataTransfer(Ne)}ye.toDataTransfer=Pe;async function me(x){const Ae={items:[]},Ne=[];return x.forEach((Xe,We)=>{Ne.push((async()=>{Ae.items.push([We,await mt.from(We,Xe)])})())}),await Promise.all(Ne),Ae}ye.toDataTransferDTO=me})(Ct=e.DataTransfer||(e.DataTransfer={}))}),define(De[186],Ce([1,0,2,11,6,8,153]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(T,O,I,m={timeout:1500,errors:3}){this.c=T,this.d=O,this.f=I,this.g=m,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(O,I,m)=>{const f={dispose:this.a.push([O,I,T])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(T,O){const I=i.URI.revive(T);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const t of[...this.a]){if(m)break;const o=this.d.getDocument(I),u=await this.h(t,{document:o,reason:M.TextDocumentSaveReason.to(O)});f.push(u)}}finally{clearTimeout(v)}return f}h([T,O,I],m){const v=this.b.get(T);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(I,T,O,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const t=this.b.get(T);this.b.set(T,t?t+1:1),typeof t=="number"&&t>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,O,I,m){const v=[],f=Date.now(),{document:t,reason:o}=m,{version:u}=t,g=Object.freeze({document:t,reason:o,waitUntil(E){if(Object.isFrozen(v))throw(0,k.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(E))}});try{O.apply(I,[g])}catch(E){return Promise.reject(E)}return Object.freeze(v),new Promise((E,b)=>{const S=setTimeout(()=>b(new Error("timeout")),this.g.timeout);return Promise.all(v).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(S),E(s)}).catch(s=>{clearTimeout(S),b(s)})}).then(E=>{const b={edits:[]};for(const S of E)if(Array.isArray(S)&&S.every(s=>s instanceof y.TextEdit))for(const{newText:s,newEol:r,range:a}of S)b.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:s,eol:r&&M.EndOfLine.from(r)}});if(b.edits.length!==0)return u===t.version?this.f.$tryApplyWorkspaceEdit(b):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(De[187],Ce([1,0,13,2,8,6,66]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(I,m,v,f){this.start=I,this.deletedCount=m,this.deletedItems=v,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(I,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,m,v){this.notebook=I,this.h=m,this.j=v,this.handle=v.handle,this.uri=k.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(y.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return I.g},set mime(f){I.g=f},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(v)}return this.f}setOutputs(I){this.a=I.map(y.NotebookCellOutput.to)}setOutputItems(I,m,v){const f=v.map(y.NotebookCellOutputItem.to),t=this.a.find(o=>o.id===I);if(t&&(m||(t.items.length=0),t.items.push(...f),t.items.length>1&&t.items.every(o=>C.isTextStreamMime(o.mime)))){const o=new Map,u=[];t.items.forEach(g=>{let E;o.has(g.mime)?E=o.get(g.mime):(E=[],o.set(g.mime,E),u.push(g.mime)),E.push(g.data)}),t.items.length=0,u.forEach(g=>{const E=C.compressOutputItemStreams(o.get(g));t.items.push({mime:g,data:E.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=w;class T{constructor(I,m,v,f,t){this.k=I,this.l=m,this.m=v,this.uri=f,this.handle=T.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=t.viewType,this.f=Object.freeze(t.metadata??Object.create(null)),this.r([[0,0,t.cells]],!0,void 0),this.g=t.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const I=this,m={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===i.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(v){return v=I.n(v),I.b[v].apiCell},getCells(v){return(v?I.p(v):I.b).map(t=>t.apiCell)},save(){return I.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,m,v){this.g=I.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const f={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},t=[];for(const u of I.rawEvents)u.kind===C.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,f.contentChanges):u.kind===C.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,f.contentChanges):u.kind===C.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),t.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),t.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),t.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===C.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),t.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),t.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const o=new Map;for(let u=0;u<t.length;u++){const g=t[u],E=o.get(g.cell);if(E===void 0){const b=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});o.set(g.cell,b-1)}else f.cellChanges[E]={...f.cellChanges[E],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let m=I.start|0,v=I.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),I.with({start:m,end:v})}p(I){I=this.o(I);const m=[];for(let v=I.start;v<I.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,m,v){if(this.j)return;const f=[],t=[],o=[];if(I.reverse().forEach(u=>{const E=u[2].map(s=>{const r=new w(this,this.l,s);return m||t.push(w.asModelAddData(this.apiNotebook,s)),r}),b=new R(u[0],u[1],[],E),S=this.b.splice(u[0],u[1],...E);for(const s of S)o.push(s.uri),b.deletedItems.push(s.apiCell);f.push(b)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:o}),v)for(const u of f)v.push(u.asApiEvent())}s(I,m,v,f){const t=this.b.splice(I,m);this.b.splice(v,0,...t);const o=[new R(I,m,t.map(u=>u.apiCell),[]),new R(v,0,[],t)];for(const u of o)f.push(u.asApiEvent())}t(I,m){this.b[I].setOutputs(m)}u(I,m,v,f){this.b[I].setOutputItems(m,v,f)}v(I,m){const v=this.b[I];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(I,m){const v=this.b[I];v.apiCell.mime=m}x(I,m){this.b[I].setMetadata(m)}y(I,m){this.b[I].setInternalMetadata(m)}getCellFromApiCell(I){return this.b.find(m=>m.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(m=>m.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.ExtHostNotebookDocument=T,T.a=0}),define(De[96],Ce([1,0,11,8,6]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(R,w,T,O,I,m){this.id=R,this.f=w,this.notebookData=T,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=O,this.c=m}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(w){this.selections=[w]},get selections(){return R.a},set selections(w){if(!Array.isArray(w)||!w.every(y.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");R.a=w,R.g(w)},get visibleRanges(){return R.b},revealRange(w,T){R.f.$tryRevealRange(R.id,k.NotebookRange.from(w),T??y.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(k.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(De[188],Ce([1,0,4,12,8]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(R,w){this.c=R,this.d=w,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,w);const T=this.d.getEditorById(R);w.visibleRanges&&T._acceptVisibleRanges(w.visibleRanges.ranges.map(y.NotebookRange.to)),w.selections&&T._acceptSelections(w.selections.selections.map(y.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const w in R)this.d.getEditorById(w)._acceptViewColumn(y.ViewColumn.to(R[w]))}};M=qe([Ve(0,k.ILogService)],M),e.ExtHostNotebookEditors=M}),define(De[189],Ce([1,0,8,156,135,20,59,11]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,v,f){const t=this.b++,{title:o,location:u,cancellable:g}=v,E={label:(0,y.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(t,{location:i.ProgressLocation.from(u),title:o,source:E,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(R.onUnexpectedExternalError),this.d(t,f,!!g)}d(m,v,f){let t;f&&(t=new M.CancellationTokenSource,this.c.set(m,t));const o=g=>{this.a.$progressEnd(g),this.c.delete(g),t?.dispose()};let u;try{u=v(new O(this.a,m),f&&t?t.token:M.CancellationToken.None)}catch(g){throw o(m),g}return u.then(g=>o(m),g=>o(m)),u}$acceptProgressCanceled(m){const v=this.c.get(m);v&&(v.cancel(),this.c.delete(m))}}e.ExtHostProgress=w;function T(I,m){return I.message=m.message,typeof m.increment=="number"&&(typeof I.increment=="number"?I.increment+=m.increment:I.increment=m.increment),I}class O extends k.Progress{constructor(m,v){super(f=>this.throttledReport(f)),this.c=m,this.d=v}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,C.throttle)(100,(I,m)=>T(I,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(De[97],Ce([1,0,53,93,42,67,52,8,2]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(E,b,S,s)=>{let r=b;return{enumerable:!0,configurable:!1,get(){return r},set(a){if(!S(r,a)){const h=r;r=a,E.listener?.(s(a,h))}}}},O=(E,b)=>E===b,I={range:(E,b)=>E===b?!0:!E||!b?!1:E.isEqual(b),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(E,b)=>!(E.length!==b.length||E.some(S=>!b.find(s=>S.id===s.id)))},m=E=>b=>({op:4,update:E(b)}),v=(E,b)=>({range:(()=>{let S;const s=m(r=>({range:i.Range.lift(R.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return S},set(r){E.listener?.({op:6}),I.range(S,r)||(S=r,E.listener?.(s(r)))}}})(),label:T(E,b,I.label,m(S=>({label:S}))),description:T(E,void 0,I.description,m(S=>({description:S}))),sortText:T(E,void 0,I.sortText,m(S=>({sortText:S}))),canResolveChildren:T(E,!1,I.canResolveChildren,S=>({op:2,state:S})),busy:T(E,!1,I.busy,m(S=>({busy:S}))),error:T(E,void 0,I.error,m(S=>({error:R.MarkdownString.fromStrict(S)||null}))),tags:T(E,[],I.tags,(S,s)=>({op:1,new:S.map(R.TestTag.from),old:s.map(R.TestTag.from)}))}),f=E=>{const b=y.TestId.fromString(E.extId),S=new o(b.controllerId,b.localId,E.label,w.URI.revive(E.uri)||void 0);return S.range=R.Range.to(E.range||void 0),S.description=E.description||void 0,S.sortText=E.sortText||void 0,S.tags=E.tags.map(s=>R.TestTag.to({id:(0,C.denamespaceTestTag)(s).tagId})),S},t=E=>{let b;for(const S of E.tests){const s=f(S.item);(0,k.getPrivateApiFor)(s).parent=b,b=s}return b};e.toItemFromContext=t;class o{constructor(b,S,s,r){if(S.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(S)} symbol`);const a=(0,k.createPrivateApiFor)(this,b);Object.defineProperties(this,{id:{value:S,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof u?void 0:a.parent}},children:{value:(0,M.createTestItemChildren)(a,k.getPrivateApiFor,o),enumerable:!0,writable:!1},...v(a,s)})}}e.TestItemImpl=o;class u extends o{constructor(b,S){super(b,b,S,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class g extends M.TestItemCollection{constructor(b,S,s){super({controllerId:b,getDocumentVersion:r=>r&&s.getDocument(r)?.version,getApiFor:k.getPrivateApiFor,getChildren:r=>r.children,root:new u(b,S),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(De[98],Ce([1,0,47,11,79,8,6]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class R{constructor(m,v,f){const t=R.c.nextId();m.$registerTextEditorDecorationType(v.identifier,t,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:t,dispose(){m.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=R,R.c=new y.IdGenerator("TextEditorDecorationType");class w{constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let f=null;if(m instanceof C.Position)f=new C.Range(m,m);else if(m instanceof C.Range)f=m;else throw new Error("Unrecognized location");this.l(f,v,!1)}insert(m,v){this.k(),this.l(new C.Range(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof C.Range)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,f){const t=this.c.validateRange(m);this.g.push({range:t,text:v,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==C.EndOfLine.LF&&m!==C.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this.h=m}}e.TextEditorEdit=w;class T{constructor(m,v,f,t){this.c=m,this.d=v,this._accept(f),this.e=t;const o=this;this.value={get tabSize(){return o.f},set tabSize(u){o.m(u)},get indentSize(){return o.g},set indentSize(u){o.o(u)},get insertSpaces(){return o.h},set insertSpaces(u){o.q(u)},get cursorStyle(){return o.j},set cursorStyle(u){o.s(u)},get lineNumbers(){return o.k},set lineNumbers(u){o.t(u)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}m(m){const v=this.l(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}o(m){const v=this.n(m);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const v=this.p(m);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let f=!1;if(typeof m.tabSize<"u"){const t=this.l(m.tabSize);t==="auto"?(f=!0,v.tabSize=t):typeof t=="number"&&this.f!==t&&(this.f=t,f=!0,v.tabSize=t)}if(typeof m.indentSize<"u"){const t=this.n(m.indentSize);t==="tabSize"?(f=!0,v.indentSize=t):typeof t=="number"&&this.g!==t&&(this.g=t,f=!0,v.indentSize=t)}if(typeof m.insertSpaces<"u"){const t=this.p(m.insertSpaces);t==="auto"?(f=!0,v.insertSpaces=t):this.h!==t&&(this.h=t,f=!0,v.insertSpaces=t)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,v.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(m,v){v.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=T;class O{constructor(m,v,f,t,o,u,g,E){this.id=m,this.j=v,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new T(this.j,this.id,u,f),this.e=g,this.f=E;const b=this;this.value=Object.freeze({get document(){return t.getValue()},set document(S){throw(0,k.readonly)("document")},get selection(){return b.c&&b.c[0]},set selection(S){if(!(S instanceof C.Selection))throw(0,k.illegalArgument)("selection");b.c=[S],b.l()},get selections(){return b.c},set selections(S){if(!Array.isArray(S)||S.some(s=>!(s instanceof C.Selection)))throw(0,k.illegalArgument)("selections");b.c=S,b.l()},get visibleRanges(){return b.e},set visibleRanges(S){throw(0,k.readonly)("visibleRanges")},get options(){return b.d.value},set options(S){b.g||b.d.assign(S)},get viewColumn(){return b.f},set viewColumn(S){throw(0,k.readonly)("viewColumn")},edit(S,s={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new w(t.getValue(),s);return S(r),b.m(r)},insertSnippet(S,s,r={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!s||Array.isArray(s)&&s.length===0)a=b.c.map(h=>M.Range.from(h));else if(s instanceof C.Position){const{lineNumber:h,column:c}=M.Position.from(s);a=[{startLineNumber:h,startColumn:c,endLineNumber:h,endColumn:c}]}else if(s instanceof C.Range)a=[M.Range.from(s)];else{a=[];for(const h of s)if(h instanceof C.Range)a.push(M.Range.from(h));else{const{lineNumber:c,column:d}=M.Position.from(h);a.push({startLineNumber:c,startColumn:d,endLineNumber:c,endColumn:d})}}return v.$tryInsertSnippet(m,t.getValue().version,S.value,a,r)},setDecorations(S,s){const r=s.length===0;r&&!b.h.has(S.key)||(r?b.h.delete(S.key):b.h.add(S.key),b.n(()=>{if(M.isDecorationOptionsArr(s))return v.$trySetDecorations(m,S.key,M.fromRangeOrRangeWithMessage(s));{const a=new Array(4*s.length);for(let h=0,c=s.length;h<c;h++){const d=s[h];a[4*h]=d.start.line+1,a[4*h+1]=d.start.character+1,a[4*h+2]=d.end.line+1,a[4*h+3]=d.end.character+1}return v.$trySetDecorationsFast(m,S.key,a)}}))},revealRange(S,s){b.n(()=>v.$tryRevealRange(m,M.Range.from(S),s||C.TextEditorRevealType.Default))},show(S){v.$tryShowEditor(m,M.ViewColumn.from(S))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,i.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,i.ok)(!this.g),this.f=m}_acceptSelections(m){(0,i.ok)(!this.g),this.c=m}async l(){const m=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const f=v.edits.map(o=>o.range);f.sort((o,u)=>o.end.line===u.end.line?o.end.character===u.end.character?o.start.line===u.start.line?o.start.character-u.start.character:o.start.line-u.start.line:o.end.character-u.end.character:o.end.line-u.end.line);for(let o=0,u=f.length-1;o<u;o++){const g=f[o].end;if(f[o+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=v.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,t,{setEndOfLine:typeof v.setEndOfLine=="number"?M.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.ExtHostTextEditor=O}),define(De[190],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[191],Ce([1,0,146,11,29,85,88,30,26,190,155,148]),function(te,e,i,k,y,M,C,R,w,T,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=R.Registry.as(C.Extensions.JSONContribution);class v{constructor(S,s,r){this.a=S,this.b=s,this.c=r}d(S,s){this.a({type:S,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(S){this.d(y.default.Error,S)}warn(S){this.d(y.default.Warning,S)}info(S){this.d(y.default.Info,S)}}e.ExtensionMessageCollector=v;class f{static a(S){const s=new Set;for(let r=0,a=S.length;r<a;r++)s.add(w.ExtensionIdentifier.toKey(S[r].description.identifier));return s}static compute(S,s){if(!S||!S.length)return new f(s,[]);if(!s||!s.length)return new f([],S);const r=this.a(S),a=this.a(s),h=s.filter(d=>!r.has(w.ExtensionIdentifier.toKey(d.description.identifier))),c=S.filter(d=>!a.has(w.ExtensionIdentifier.toKey(d.description.identifier)));return new f(h,c)}constructor(S,s){this.added=S,this.removed=s}}e.ExtensionPointUserDelta=f;class t{constructor(S,s){this.name=S,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(S){if(this.a!==null)throw new Error("Handler already set!");this.a=S,this.d()}acceptUsers(S){this.c=f.compute(this.b,S),this.b=S,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(S){(0,k.onUnexpectedError)(S)}}}e.ExtensionPoint=t;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},activationEvents:{description:i.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(30,null)},{label:"onUri",body:"onUri",description:i.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(35,null)},{label:"onRenderer",description:i.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(38,null)},{label:"*",description:i.localize(39,null),body:"*"}]}},badges:{type:"array",description:i.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(41,null)},href:{type:"string",description:i.localize(42,null)},description:{type:"string",description:i.localize(43,null)}}}},markdown:{type:"string",description:i.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(48,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(49,null)},{body:["workspace"],description:i.localize(50,null)},{body:["ui","workspace"],description:i.localize(51,null)},{body:["workspace","ui"],description:i.localize(52,null)},{body:[],description:i.localize(53,null)}]},capabilities:{description:i.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(57,null),i.localize(58,null),i.localize(59,null)]},description:{type:"string",markdownDescription:i.localize(60,null)}}},untrustedWorkspaces:{description:i.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)]},restrictedConfigurations:{description:i.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(67,null)}}}}},sponsor:{description:i.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(70,null),type:"string"},"vscode:uninstall":{description:i.localize(71,null),type:"string"}}},icon:{type:"string",description:i.localize(72,null)},l10n:{type:"string",description:i.localize(73,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(S){if(this.a.has(S.extensionPoint))throw new Error("Duplicate extension point: "+S.extensionPoint);const s=new t(S.extensionPoint,S.defaultExtensionKind);return this.a.set(S.extensionPoint,s),S.activationEventsGenerator&&I.ImplicitActivationEvents.register(S.extensionPoint,S.activationEventsGenerator),e.schema.properties.contributes.properties[S.extensionPoint]=S.jsonSchema,m.registerSchema(u,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const E={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(E.ExtensionsRegistry,new g),e.ExtensionsRegistry=R.Registry.as(E.ExtensionsRegistry),m.registerSchema(u,e.schema),m.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(De[192],Ce([1,0,143,9,23,191,41,4]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var T;(function(m){function v(f,t,o){if(!f)return;const u=k.isString(f.type)?f.type:void 0;if(!u||u.length===0){o.error(i.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const E of f.required)k.isString(E)&&g.push(E);return{extensionId:t.value,taskType:u,required:g,properties:f.properties?y.deepClone(f.properties):{},when:f.when?C.ContextKeyExpr.deserialize(f.when):void 0}}m.from=v})(T||(T={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:w}});class I{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,f)=>{O.setHandler((t,o)=>{this.c=void 0;try{for(const u of o.removed){const g=u.value;for(const E of g)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const u of o.added){const g=u.value;for(const E of g){const b=T.from(E,u.description.identifier,u.collector);b&&(this.a[b.taskType]=b)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const f of this.all()){const t={type:"object",additionalProperties:!1};f.required.length>0&&(t.required=f.required.slice(0)),f.properties!==void 0?t.properties=y.deepClone(f.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[f.taskType]},v.push(t)}this.c={oneOf:v}}return this.c}}e.TaskDefinitionRegistry=new I}),define(De[193],Ce([1,0,144,9,22,23,41,192]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var w;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function $(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=$}(w=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var O;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=$}(O=e.RevealKind||(e.RevealKind={}));var I;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function $(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=$}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function $(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=$}(m=e.PanelKind||(e.PanelKind={}));var v;(function(F){F.defaults={echo:!0,reveal:O.Always,revealProblems:I.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function $(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=$;function z(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(f=e.RuntimeType||(e.RuntimeType={}));var t;(function(F){function $(z){return k.isString(z)?z:z.value}F.value=$})(t=e.CommandString||(e.CommandString={}));var o;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function $(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=$;function z(V){if(V!==void 0)return k.isString(V)?$(V)?{_id:V,isDefault:!1}:void 0:V}F.from=z})(o=e.TaskGroup||(e.TaskGroup={}));var u;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var g;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function $(z){switch(z){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=$})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(F){F.parallel="parallel",F.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var b;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(b=e.RunOnOptions||(e.RunOnOptions={}));var S;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:b.default,instanceLimit:1}})(S=e.RunOptions||(e.RunOptions={}));class s{constructor($,z,V,X,ee,fe){this._label="",this._id=$,z&&(this._label=z),V&&(this.type=V),this.runOptions=X,this.configurationProperties=ee,this._source=fe}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,z=!1){if($===void 0)return!1;if(k.isString($))return $===this._label||$===this.configurationProperties.identifier||z&&$===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class r extends s{constructor($,z,V,X,ee,fe,oe,ue){super($,V,void 0,oe,ue,z),this.command={},this._source=z,this.hasDefinedMatchers=fe,ee&&(this.command=ee)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case f.Shell:z="shell";break;case f.Process:z="process";break;case f.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is($){return $ instanceof r}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new r($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=r;class a extends s{constructor($,z,V,X,ee,fe,oe){super($,V,X,fe,oe,z),this._source=z,this.configures=ee}static is($){return $ instanceof a}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let z=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:z};return JSON.stringify(V)}}e.ConfiguringTask=a;class h extends s{constructor($,z,V,X,ee,fe,oe,ue,ce){super($,V,X,ue,ce,z),this.defines=ee,this.hasDefinedMatchers=oe,this.command=fe,this.icon=ce.icon,this.hide=ce.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof h}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new h($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=h;class c extends s{constructor($,z,V,X,ee,fe){super($,V,X,ee,fe,z),this._source=z}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new c($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=c;var d;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor($){this.c=new Map;for(let z=0;z<$.length;z++)this.c.set($[z].uri.toString(),z)}compare($,z){const V=$.getWorkspaceFolder(),X=z.getWorkspaceFolder();if(V&&X){let ee=this.c.get(V.uri.toString());ee=ee===void 0?0:ee+1;let fe=this.c.get(X.uri.toString());return fe=fe===void 0?0:fe+1,ee===fe?$._label.localeCompare(z._label):ee-fe}else return!V&&X?-1:V&&!X?1:0}}e.TaskSorter=l;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var A;(function(F){F.SingleRun="singleRun",F.Background="background"})(A=e.TaskRunType||(e.TaskRunType={}));var L;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(F){function $(z,V,X,ee){if(V){const fe={kind:z,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:X,__task:V};return z==="start"?fe.resolvedVariables=ee:z==="processStarted"?fe.processId=ee:z==="processEnded"&&(fe.exitCode=ee),Object.freeze(fe)}else return Object.freeze({kind:"changed"})}F.create=$})(q=e.TaskEvent||(e.TaskEvent={}));var K;(function(F){function $(V){const X=Object.keys(V).sort();let ee="";for(const fe of X){let oe=V[fe];oe instanceof Object?oe=$(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),ee+=fe+","+oe+","}return ee}function z(V){const ee={_key:$(V),type:V.taskType};return Object.assign(ee,V),ee}F.create=z})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var j;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(j=e.TaskSettingId||(e.TaskSettingId={}));var P;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(P=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var N;(function(F){function $(z,V){const X=R.TaskDefinitionRegistry.get(z.type);if(X===void 0){const ue=M.deepClone(z);return delete ue._key,K.create(ue)}const ee=Object.create(null);ee.type=X.taskType;const fe=new Set;X.required.forEach(ue=>fe.add(ue));const oe=X.properties;for(const ue of Object.keys(oe)){const ce=z[ue];if(ce!=null)ee[ue]=ce;else if(fe.has(ue)){const he=oe[ue];if(he.default!==void 0)ee[ue]=M.deepClone(he.default);else switch(he.type){case"boolean":ee[ue]=!1;break;case"number":case"integer":ee[ue]=0;break;case"string":ee[ue]="";break;default:V.error(i.localize(2,null,JSON.stringify(z,void 0,0),ue));return}}}return K.create(ee)}F.createTaskIdentifier=$})(N=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[194],Ce([1,0,11]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,R)=>{this.b=C,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,i.onUnexpectedError)(C))}then(C,R){return this.j().then(C,R)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=k;class y extends k{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=y}),define(De[43],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const k=[];function y(R){const w=new i(R);return k[w.nid]=w,w}e.createProxyIdentifier=y;function M(R){return k[R].sid}e.getStringIdentifierForProxy=M;class C{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=C}),define(De[5],Ce([1,0,43]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var M;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(o){return o._id=I.a++,o}}e.IdObject=I,I.a=0;var m;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(De[72],Ce([1,0,3,12,5,14]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(w,T){this.c=T,this.a=new Set,this.b=w.getProxy(y.MainContext.MainThreadTelemetry)}report(w,T,O){const I=this.d(w,T);this.a.has(I)||(this.a.add(I),T.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${w}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:w}))}d(w,T){return`${w}-${T.identifier.value}`}};C=qe([Ve(0,M.IExtHostRpcService),Ve(1,k.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(R,w,T){}})}),define(De[195],Ce([1,0,4,5,6,26]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(w){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=w.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,T,O,I={}){const m=M.ExtensionIdentifier.toKey(w.identifier),v=this.f.get(m)||[],f=[...O].sort().join(" ");let t=v.find(o=>o.providerId===T&&o.scopes===f);if(t)return t.result;{const o=this.g(w,m,T,O,I);t={providerId:T,scopes:f,result:o},v.push(t),this.f.set(m,v);try{await o}finally{const u=v.findIndex(g=>g.providerId===T&&g.scopes===f);u>-1&&(v.splice(u),this.f.set(m,v))}return o}}async g(w,T,O,I,m={}){await this.a.$ensureProvider(O);const v=w.displayName||w.name;return this.a.$getSession(O,I,T,v,m)}async removeSession(w,T){const O=this.b.get(w);return O?O.provider.removeSession(T):this.a.$removeSession(w,T)}registerAuthenticationProvider(w,T,O,I){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:T,provider:O,options:I??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===w)||this.c.push({id:w,label:T});const m=O.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(w,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(w,T,I?.supportsMultipleAccounts??!1),new y.Disposable(()=>{m.dispose(),this.b.delete(w);const v=this.c.findIndex(f=>f.id===w);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,T){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,T){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,T){const O=this.b.get(w);if(O)return Promise.resolve(O.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,T){return this.d.fire({provider:{id:w,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(De[196],Ce([1,0,5,14,8]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(R,w){this.a=R.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>w.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,w,T){const O=y.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,T?.isRefactoring??!1)}};M=qe([Ve(0,k.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(De[197],Ce([1,0,5]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(M){const C=M.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(R){return C.$writeText(R)}})}}e.ExtHostClipboard=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[38],Ce([1,0,9,6,8,23,5,16,12,80,53,251,2,7,3,14,97,24,43,45]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E){"use strict";var b,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(n,l){b.set(this,void 0),this.b=new Map,this.c=new Map,S.set(this,void 0),Je(this,b,n.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=l,Je(this,S,n.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new r(this,p=>{const A=this.c.get(p);return A?.result===h.Void?A:void 0},l),this.f=[{processArgument(p){return(0,T.revive)(p)}},{processArgument(p){return(0,M.cloneAndChange)(p,function(A){if(O.Range.isIRange(A))return y.Range.to(A);if(I.Position.isIPosition(A))return y.Position.to(A);if(O.Range.isIRange(A.range)&&m.URI.isUri(A.uri))return y.location.to(A);if(A instanceof u.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(n){this.f.push(n)}registerApiCommand(n){const l=this.registerCommand(!1,n.id,async(...p)=>{const A=n.args.map((q,K)=>{if(!q.validate(p[K]))throw new Error(`Invalid argument '${q.name}' when running '${n.id}', received: ${p[K]}`);return q.convert(p[K])}),L=await this.executeCommand(n.internalId,...A);return n.result.convert(L,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this.c.set(n.id,n),new k.Disposable(()=>{l.dispose(),this.c.delete(n.id)})}registerCommand(n,l,p,A,L,q){if(this.d.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this.b.has(l))throw new Error(`command '${l}' already exists`);return this.b.set(l,{callback:p,thisArg:A,description:L,extension:q}),n&&Re(this,b,"f").$registerCommand(l),new k.Disposable(()=>{this.b.delete(l)&&n&&Re(this,b,"f").$unregisterCommand(l)})}executeCommand(n,...l){return this.d.trace("ExtHostCommands#executeCommand",n),this.g(n,l,!0)}async g(n,l,p){if(this.b.has(n))return Re(this,b,"f").$fireCommandActivationEvent(n),this.h(n,l,!1);{let A=!1;const L=(0,M.cloneAndChange)(l,function(q){if(q instanceof k.Position)return y.Position.from(q);if(q instanceof k.Range)return y.Range.from(q);if(q instanceof k.Location)return y.location.from(q);if(k.NotebookRange.isNotebookRange(q))return y.NotebookRange.from(q);if(q instanceof ArrayBuffer)return A=!0,u.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return A=!0,u.VSBuffer.wrap(q);if(q instanceof u.VSBuffer)return A=!0,q;if(!Array.isArray(q))return q});try{const q=await Re(this,b,"f").$executeCommand(n,A?new g.SerializableObjectWithBuffers(L):L,p);return(0,T.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(n,l,!1);throw q}}}async h(n,l,p){const A=this.b.get(n);if(!A)throw new Error("Unknown command");const{callback:L,thisArg:q,description:K}=A;if(K)for(let P=0;P<K.args.length;P++)try{(0,i.validateConstraint)(l[P],K.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${K.args[P].name}' - ${K.args[P].description}`)}const j=Date.now();try{return await L.apply(q,l)}catch(P){if(n===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...l);N&&(n=N.command)}throw this.d.error(P,n,A.extension?.identifier),p?new class extends Error{constructor(){super((0,E.toErrorMessage)(P)),this.id=n,this.source=A.extension?.displayName??A.extension?.name}}:P}finally{this.j(A,n,Date.now()-j)}}j(n,l,p){!n.extension||n.extension.isBuiltin||Re(this,S,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:l,duration:p})}$executeContributedCommand(n,...l){return this.d.trace("ExtHostCommands#$executeContributedCommand",n),this.b.has(n)?(l=l.map(p=>this.f.reduce((A,L)=>L.processArgument(A),p)),this.h(n,l,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this.d.trace("ExtHostCommands#getCommands",n),Re(this,b,"f").$getCommands().then(l=>(n&&(l=l.filter(p=>p[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[l,p]of this.b){const{description:A}=p;A&&(n[l]=A)}return Promise.resolve(n)}};b=new WeakMap,S=new WeakMap,s=qe([Ve(0,t.IExtHostRpcService),Ve(1,w.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class r{constructor(n,l,p){this.d=n,this.f=l,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(n,l){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const A=this.f(n.command);if(A)p.id=A.internalId,p.arguments=A.args.map((L,q)=>L.convert(n.arguments&&n.arguments[q]));else if((0,R.isNonEmptyArray)(n.arguments)){const L=`${n.command}/${++this.c}`;this.b.set(L,n),l.add((0,v.toDisposable)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),p.$ident=L,p.id=this.delegatingCommandId,p.arguments=[L],this.g.trace("CommandsConverter#CREATE",n.command,L)}return p}fromInternal(n){return typeof n.$ident=="string"?this.b.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this.b.get(n[0])}h(...n){const l=this.getActualCommand(...n);return this.g.trace("CommandsConverter#EXECUTE",n[0],l?l.command:"MISSING"),l?this.d.executeCommand(l.command,...l.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=r;class a{constructor(n,l,p,A){this.name=n,this.description=l,this.validate=p,this.convert=A}optional(){return new a(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,l){return new a(n??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",d=>m.URI.isUri(d),d=>d),a.Position=new a("position","A position in a text document",d=>k.Position.isPosition(d),y.Position.from),a.Range=new a("range","A range in a text document",d=>k.Range.isRange(d),y.Range.from),a.Selection=new a("selection","A selection in a text document",d=>k.Selection.isSelection(d),y.Selection.from),a.Number=new a("number","",d=>typeof d=="number",d=>d),a.String=new a("string","",d=>typeof d=="string",d=>d),a.CallHierarchyItem=new a("item","A call hierarchy item",d=>d instanceof k.CallHierarchyItem,y.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",d=>d instanceof k.TypeHierarchyItem,y.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",d=>d instanceof o.TestItemImpl,y.TestItem.from);class h{constructor(n,l){this.description=n,this.convert=l}}e.ApiCommandResult=h,h.Void=new h("no result",d=>d);class c{constructor(n,l,p,A,L){this.id=n,this.internalId=l,this.description=p,this.args=A,this.result=L}}e.ApiCommand=c}),define(De[198],Ce([1,0,2,8,6,71,38,16,83,87,13]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",v(k.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,o)=>{if((0,R.isFalsyOrEmpty)(t))return;class u extends y.SymbolInformation{static to(E){const b=new u(E.name,k.SymbolKind.to(E.kind),E.containerName||"",new y.Location(o[0],k.Range.to(E.range)));return b.detail=E.detail,b.range=b.location.range,b.selectionRange=k.Range.to(E.selectionRange),b.children=E.children?E.children.map(u.to):[],b}}return t.map(u.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(k.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(o=>y.Position.isPosition(o)),t=>t.map(k.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(o=>{let u;for(const g of o.reverse())u=new y.SelectionRange(k.Range.to(g),u);return u}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(k.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(k.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(k.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(k.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:k.Range.to(t.range),placeholder:t.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return k.WorkspaceEdit.to(t)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(k.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,w.decodeSemanticTokensDto)(t);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,w.decodeSemanticTokensDto)(t);if(o.type==="full")return new y.SemanticTokens(o.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,o,u)=>{if(!t)return new y.CompletionList([]);const g=t.suggestions.map(E=>k.CompletionItem.to(E,u));return new y.CompletionList(g,t.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return k.SignatureHelp.to(t)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,o,u)=>v(g=>new y.CodeLens(k.Range.to(g.range),g.command&&u.fromInternal(g.command)))(t))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?k.Selection.from(t):k.Range.from(t)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,o,u)=>v(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const E=new y.CodeAction(g.title,g.kind?new y.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=k.WorkspaceEdit.to(g.edit)),g.command&&(E.command=u.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(t))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(o=>new y.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,k.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:k.Range.from(t.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(k.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,o,u)=>t.map(k.InlayHint.to.bind(void 0,u)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(k.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,T.matchesSomeScheme)(t,O.Schemas.http,O.Schemas.https),t=>t),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[k.ViewColumn.from(t),void 0]:[k.ViewColumn.from(t.viewColumn),k.TextEditorOpenOptions.from(t)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[k.ViewColumn.from(t),void 0]:[k.ViewColumn.from(t.viewColumn),k.TextEditorOpenOptions.from(t)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[k.ViewColumn.from(t.viewColumn),k.TextEditorOpenOptions.from(t)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void)];class m{static register(o){I.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=m;function v(t){return o=>{if(Array.isArray(o))return o.map(t)}}function f(t){if(!Array.isArray(t))return;const o=[];for(const u of t)M.isLocationLink(u)?o.push(k.DefinitionLink.to(u)):o.push(k.location.to(u));return o}}),define(De[199],Ce([1,0,15,59,4,7,2,71,26,8,6,25,5]),function(te,e,i,k,y,M,C,R,w,T,O,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(f,t,o){const u=f.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this.b=new Map,this.c=new Map,t.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const n=this.b.get(d.handle);return n?n.value:d}else if(d&&d.$mid===7){const n=this.b.get(d.commentControlHandle);if(!n)return d;const l=n.getCommentThread(d.commentThreadHandle);return l?l.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const n=this.b.get(d.thread.commentControlHandle);if(!n)return d;const l=n.getCommentThread(d.thread.commentThreadHandle);return l?d.$mid===8?l.value:{thread:l.value,text:d.text}:d}else if(d&&d.$mid===10){const n=this.b.get(d.thread.commentControlHandle);if(!n)return d;const l=n.getCommentThread(d.thread.commentThreadHandle);if(!l)return d;const p=d.commentUniqueId,A=l.getCommentByUniqueId(p);return A||d}else if(d&&d.$mid===11){const n=this.b.get(d.thread.commentControlHandle);if(!n)return d;const l=n.getCommentThread(d.thread.commentThreadHandle);if(!l)return d;const p=d.text,A=d.commentUniqueId,L=l.getCommentByUniqueId(A);return L?(typeof L.body=="string"?L.body=p:L.body.value=p,L):d}return d}})}createCommentController(d,n,l){const p=g.a++,A=new b(d,p,n,l);this.b.set(A.handle,A);const L=this.c.get(w.ExtensionIdentifier.toKey(d.identifier))||[];return L.push(A),this.c.set(w.ExtensionIdentifier.toKey(d.identifier),L),A.value}$createCommentThreadTemplate(d,n,l){const p=this.b.get(d);!p||p.$createCommentThreadTemplate(n,l)}async $updateCommentThreadTemplate(d,n,l){const p=this.b.get(d);!p||p.$updateCommentThreadTemplate(n,l)}$deleteCommentThread(d,n){this.b.get(d)?.$deleteCommentThread(n)}$provideCommentingRanges(d,n,l){const p=this.b.get(d);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const A=o.getDocument(C.URI.revive(n));return(0,i.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(A,l)).then(L=>L?L.map(q=>T.Range.from(q)):void 0)}$toggleReaction(d,n,l,p,A){const L=this.b.get(d);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const q=L.getCommentThread(n);if(q){const K=q.getCommentByUniqueId(p.uniqueIdInThread);if(L!==void 0&&K&&L.reactionHandler)return L.reactionHandler(K,r(A))}return Promise.resolve(void 0)})}dispose(){}}g.a=0;class E{set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){d.isEqual(this.p)||(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(d){(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,n,l,p,A,L,q,K){this.m=n,this.n=l,this.o=p,this.p=A,this.q=L,this.extensionDescription=q,this.r=K,this.handle=E.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${d}.${this.handle}`),u.$createCommentThread(n,this.handle,this.n,this.o,T.Range.from(this.p),q.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{u.$deleteCommentThread(n,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(P){j.range=P},get comments(){return j.comments},set comments(P){j.comments=P},get collapsibleState(){return j.collapsibleState},set collapsibleState(P){j.collapsibleState=P},get canReply(){return j.canReply},set canReply(P){j.canReply=P},get contextValue(){return j.contextValue},set contextValue(P){j.contextValue=P},get label(){return j.label},set label(P){j.label=P},get state(){return j.state},set state(P){j.state=P},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const d=l=>Object.prototype.hasOwnProperty.call(this.b,l),n={};d("range")&&(n.range=T.Range.from(this.p)),d("label")&&(n.label=this.label),d("contextValue")&&(n.contextValue=this.contextValue??null),d("comments")&&(n.comments=this.q.map(l=>S(this,l,this.k))),d("collapsibleState")&&(n.collapseState=a(this.g)),d("canReply")&&(n.canReply=this.canReply),d("state")&&(n.state=h(this.h)),d("isTemplate")&&(n.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(d){for(const n of this.k){const l=n[0],p=n[1];if(d===p)return l}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}E.a=0,qe([(0,k.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,n,l,p){this.f=d,this.g=n,this.h=l,this.i=p,this.a=new Map,u.$registerCommentController(this.handle,l,p);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(L){A.options=L},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(L){A.commentingRangeProvider=L},get reactionHandler(){return A.reactionHandler},set reactionHandler(L){A.reactionHandler=L},createCommentThread(L,q,K){return A.createCommentThread(L,q,K).value},dispose:()=>{A.dispose()}}),this.e=[],this.e.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(d,n,l,p){if(typeof d=="string"){const A=new E(this.id,this.handle,d,n,l,p,this.f,!1);return this.a.set(A.handle,A),A}else{const A=new E(this.id,this.handle,void 0,d,n,l,this.f,!1);return this.a.set(A.handle,A),A}}$createCommentThreadTemplate(d,n){const l=new E(this.id,this.handle,void 0,C.URI.revive(d),T.Range.to(n),[],this.f,!0);return l.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(l.handle,l),l}$updateCommentThreadTemplate(d,n){const l=this.a.get(d);l&&(l.range=T.Range.to(n))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function S(c,d,n){let l=n.get(d);l||(l=++c.commentHandle,n.set(d,l));const p=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:l,body:typeof d.body=="string"?d.body:T.MarkdownString.from(d.body),userName:d.author.name,userIconPath:p,label:d.label,commentReactions:d.reactions?d.reactions.map(A=>s(A)):void 0,timestamp:d.timestamp?.toJSON()}}function s(c){return{label:c.label,iconPath:c.iconPath?T.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?C.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function h(c){if(c!==void 0)switch(c){case O.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new g}e.createExtHostComments=v}),define(De[200],Ce([1,0,23,5,27,14]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(O,I){this.a=O.getProxy(k.MainContext.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,I){const m=this,v=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m.e(O,I,v,arguments)}})}e(O,I,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:w(v,this.b)}),this.c&&this.f(O,m,v)}};C=qe([Ve(0,M.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const R=1e5;function w(T,O){const I=[];if(T.length)for(let m=0;m<T.length;m++){let v=T[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const f=v;f.stack?v=f.stack:v=f.toString()}I.push(v)}if(O){const m=new Error().stack;m&&I.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(I);return m.length>R?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(De[99],Ce([1,0,2,5,6,3,14,12,16,10,19,25]),function(te,e,i,k,y,M,C,R,w,T,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ai{constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,t){const o=Ai.c++;this.f.set(o,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(o,t.identifier.value);const u=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(o,null);return}const E=(0,w.asArray)(g);if(E.length<=Ai.d){this.g.$onDidChange(o,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const b=E.map(r=>({uri:r,rank:(0,T.count)(r.path,"/")})),S=(0,w.groupBy)(b,(r,a)=>r.rank-a.rank||(0,T.compare)(r.uri.path,a.uri.path)),s=[];e:for(const r of S){let a;for(const h of r){const c=(0,O.dirname)(h.uri.path);if(a!==c&&(a=c,s.push(h.uri)>=Ai.d))break e}}this.g.$onDidChange(o,s)});return new y.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(f,t,o){if(!this.f.has(f))return Object.create(null);const u=Object.create(null),{provider:g,extensionDescription:E}=this.f.get(f);return await Promise.all(t.map(async b=>{try{const{uri:S,id:s}=b,r=await Promise.resolve(g.provideFileDecoration(i.URI.revive(S),o));if(!r)return;try{y.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,I.checkProposedApiEnabled)(E,"codiconDecoration"),u[s]=[r.propagate,r.tooltip,r.badge,r.color]}catch(a){this.h.warn(`INVALID decoration from extension '${E}': ${a}`)}}catch(S){this.h.error(S)}})),u}};m.c=0,m.d=250,m=qe([Ve(0,C.IExtHostRpcService),Ve(1,R.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[201],Ce([1,0,133,86,2,5,6,8,4,12,28,37]),function(te,e,i,k,y,M,C,R,w,T,O,I){"use strict";var m,v,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(g,E,b,S,s,r,a){this.d=g,this.e=E,this.f=b,this.g=S,m.set(this,void 0),v.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new O.ResourceMap(h=>s.getComparisonKey(h)),"f"),Je(this,m,r,"f"),Je(this,v,a,"f")}dispose(){this.c||(Re(this,v,"f").fire([...Re(this,f,"f").keys()]),Re(this,m,"f")?.$clear(this.e),Re(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,E){if(!g){this.clear();return}this.h();let b=[];if(y.URI.isUri(g)){if(!E){this.delete(g);return}Re(this,f,"f").set(g,E.slice()),b=[g]}else if(Array.isArray(g)){b=[];let s;g=[...g].sort(t.j);for(const r of g){const[a,h]=r;if((!s||a.toString()!==s.toString())&&(s&&Re(this,f,"f").get(s).length===0&&Re(this,f,"f").delete(s),s=a,b.push(a),Re(this,f,"f").set(a,[])),h)Re(this,f,"f").get(a)?.push(...h);else{const c=Re(this,f,"f").get(a);c&&(c.length=0)}}}if(Re(this,v,"f").fire(b),!Re(this,m,"f"))return;const S=[];for(const s of b){let r=[];const a=Re(this,f,"f").get(s);if(a)if(a.length>this.f){r=[];const h=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const d of a)if(d.severity===h[c]&&r.push({...R.Diagnostic.from(d),modelVersionId:this.g(s)})===this.f)break e;r.push({severity:k.MarkerSeverity.Info,message:(0,i.localize)(0,null,a.length-this.f),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=a.map(h=>({...R.Diagnostic.from(h),modelVersionId:this.g(s)}));S.push([s,r])}Re(this,m,"f").$changeMany(this.e,S)}delete(g){this.h(),Re(this,v,"f").fire([g]),Re(this,f,"f").delete(g),Re(this,m,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Re(this,v,"f").fire([...Re(this,f,"f").keys()]),Re(this,f,"f").clear(),Re(this,m,"f")?.$clear(this.e)}forEach(g,E){this.h();for(const[b,S]of this)g.call(E,b,S,this)}*[(m=new WeakMap,v=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const g of Re(this,f,"f").keys())yield[g,this.get(g)]}get(g){this.h();const E=Re(this,f,"f").get(g);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(g){return this.h(),Array.isArray(Re(this,f,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,E){return g[0].toString()<E[0].toString()?-1:g[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=t;let o=class mi{static _mapper(g){const E=new O.ResourceMap;for(const b of g)E.set(b,b);return{uris:Object.freeze(Array.from(E.values()))}}constructor(g,E,b,S){this.h=E,this.j=b,this.k=S,this.f=new Map,this.g=new w.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this.g.event,mi._mapper),this.e=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,E){const{f:b,e:S,g:s,h:r,j:a,k:h}=this,c=new class{$changeMany(l,p){S.$changeMany(l,p),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,l,p.length===0?"CLEARING":p)}$clear(l){S.$clear(l),r.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,l)}dispose(){S.dispose()}};let d;if(!E)E="_generated_diagnostic_collection_name_#"+mi.c++,d=E;else if(!b.has(E))d=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do d=E+mi.c++;while(b.has(d))}return new class extends t{constructor(){super(E,d,mi.d,l=>h.getDocument(l)?.version,a.extUri,c,s),b.set(d,this)}dispose(){super.dispose(),b.delete(d)}}}getDiagnostics(g){if(g)return this.l(g);{const E=new Map,b=[];for(const S of this.f.values())S.forEach((s,r)=>{let a=E.get(s.toString());typeof a>"u"&&(a=b.length,E.set(s.toString(),a),b.push([s,[]])),b[a][1]=b[a][1].concat(...r)});return b}}l(g){let E=[];for(const b of this.f.values())b.has(g)&&(E=E.concat(b.get(g)));return E}$acceptMarkersChange(g){if(!this.m){const E="_generated_mirror",b=new t(E,E,mi.d,S=>{},this.j.extUri,void 0,this.g);this.f.set(E,b),this.m=b}for(const[E,b]of g)this.m.set(y.URI.revive(E),b.map(R.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([Ve(1,T.ILogService),Ve(2,I.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(De[202],Ce([1,0,2,5]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(R=>R?R.map(w=>i.URI.revive(w)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(R=>R?i.URI.revive(R):void 0)}}e.ExtHostDialogs=y}),define(De[203],Ce([1,0,11,2,6,5,13,20,10]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(I,m,v){this.d=m,this.e=v,this.b=new Map,this.c=I.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,m){if(Object.keys(C.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const v=T.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,I);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(t=>{if(t.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this.d.getDocument(t)&&this.$provideTextDocumentContent(v,t).then(o=>{if(!o&&typeof o!="string")return;const u=this.d.getDocument(t);if(!u)return;const g=(0,w.splitLines)(o);if(!u.equalLines(g))return this.c.$onVirtualDocumentChange(t,o)},i.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(I,m){const v=this.b.get(I);return v?Promise.resolve(v.provideTextDocumentContent(k.URI.revive(m),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=T,T.a=0}),define(De[204],Ce([1,0,4,7,2,5,95,8,9,23,6]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(v,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.DisposableStore,this.h=new Map,this.f=v.getProxy(M.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const o of t)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const o of t)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const f=this.g.getDocument(v);if(f)return f}getDocument(v){const f=this.getDocumentData(v);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return f.document}ensureDocumentData(v){const f=this.g.getDocument(v);if(f)return Promise.resolve(f);let t=this.h.get(v.toString());return t||(t=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const u=y.URI.revive(o);return(0,w.assertIsDefined)(this.g.getDocument(u))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),t)),t}createDocumentData(v){return this.f.$tryCreateDocument(v).then(f=>y.URI.revive(f))}$acceptModelLanguageChanged(v,f){const t=y.URI.revive(v),o=this.g.getDocument(t);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(v){const f=y.URI.revive(v),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(v,f){const t=y.URI.revive(v),o=this.g.getDocument(t);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,f,t){const o=y.URI.revive(v),u=this.g.getDocument(o);if(!u)throw new Error("unknown document");u._acceptIsDirty(t),u.onEvents(f);let g;f.isUndoing?g=O.TextDocumentChangeReason.Undo:f.isRedoing&&(g=O.TextDocumentChangeReason.Redo),this.c.fire((0,T.deepFreeze)({document:u.document,contentChanges:f.changes.map(E=>({range:R.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:g}))}setWordDefinitionFor(v,f){(0,C.setWordDefinitionFor)(v,f)}}e.ExtHostDocuments=I}),define(De[54],Ce([1,0,47,4,7,2,3,5,95,14,98,8,12,28,13,173,205]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(b){this.value=b,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(b,S){this.h=b,this.i=S,this.a=null,this.b=new Map,this.c=new v.ResourceMap,this.d=new k.Emitter,this.e=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(b){this.acceptDocumentsAndEditorsDelta(b)}acceptDocumentsAndEditorsDelta(b){const S=[],s=[],r=[];if(b.removedDocuments)for(const a of b.removedDocuments){const h=M.URI.revive(a),c=this.c.get(h);c?.unref()&&(this.c.delete(h),S.push(c.value))}if(b.addedDocuments)for(const a of b.addedDocuments){const h=M.URI.revive(a.uri);let c=this.c.get(h);if(c&&h.scheme!==f.Schemas.vscodeNotebookCell&&h.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);c||(c=new u(new w.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),h,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(h,c),s.push(c.value)),c.ref()}if(b.removedEditors)for(const a of b.removedEditors){const h=this.b.get(a);this.b.delete(a),h&&r.push(h)}if(b.addedEditors)for(const a of b.addedEditors){const h=M.URI.revive(a.documentUri);i.ok(this.c.has(h),`document '${h}' does not exist`),i.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(h).value,d=new O.ExtHostTextEditor(a.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>c.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(n=>I.Range.to(n)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,d)}b.newActiveEditor!==void 0&&(i.ok(b.newActiveEditor===null||this.b.has(b.newActiveEditor),`active editor '${b.newActiveEditor}' does not exist`),this.a=b.newActiveEditor),(0,y.dispose)(S),(0,y.dispose)(r),b.removedDocuments&&this.e.fire(S),b.addedDocuments&&this.d.fire(s),(b.removedEditors||b.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),b.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(b){return this.c.get(b)?.value}allDocuments(){return t.Iterable.map(this.c.values(),b=>b.value)}getEditor(b){return this.b.get(b)}activeEditor(b){if(!this.a)return;const S=this.b.get(this.a);return b?S:S?.value}allEditors(){return[...this.b.values()]}};g=qe([Ve(0,T.IExtHostRpcService),Ve(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[55],Ce([1,0,8,5,2,4,3,6,14,9,78]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class I{constructor(o,u,g){this.e=g,this.d=u,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,u={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(o,u){this.c=[],this.d="",this.b=o,this.e=u;for(const g of o.tabs)g.isActive&&(this.d=g.id),this.c.push(new I(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,u={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return i.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(g=>g.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(g=>g.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const g=new I(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,g),o.tabDto.isActive&&(this.d=g.tabId),g}else if(o.kind===1){const g=this.c.splice(o.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(o.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,g),g}const u=this.c.find(g=>g.tabId===o.tabDto.id);if(!u)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(o.tabDto),u}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=o.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,u={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(g=>g.apiObject))},get activeTabGroup(){const g=o.d;return(0,T.assertIsDefined)(o.e.find(b=>b.groupId===g)?.apiObject)},close:async(g,E)=>{const b=Array.isArray(g)?g:[g];return b.length?f(b[0])?this.j(b,E):this.i(b,E):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(o){const u=new Set(this.e.map(a=>a.groupId)),g=new Set(o.map(a=>a.groupId)),E=(0,O.diffSets)(u,g),b=this.e.filter(a=>E.removed.includes(a.groupId)).map(a=>a.apiObject),S=[],s=[];this.e=o.map(a=>{const h=new m(a,()=>this.d);return E.added.includes(h.groupId)?S.push(h.apiObject):s.push(h.apiObject),h});const r=(0,T.assertIsDefined)(o.find(a=>a.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:S,closed:b,changed:s}))}$acceptTabGroupUpdate(o){const u=this.e.find(g=>g.groupId===o.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const u=this.e.find(E=>E.groupId===o.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const g=u.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(o){for(const u of this.e)for(const g of u.tabs)if(g.apiObject===o)return g}h(o){return this.e.find(u=>u.apiObject===o)}async i(o,u){const g=[];for(const E of o){const b=this.g(E);if(!b)throw new Error("Tab close: Invalid tab not found!");g.push(b.tabId)}return this.a.$closeTab(g,u)}async j(o,u){const g=[];for(const E of o){const b=this.h(E);if(!b)throw new Error("Group close: Invalid group not found!");g.push(b.groupId)}return this.a.$closeGroup(g,u)}};v=qe([Ve(0,w.IExtHostRpcService)],v),e.ExtHostEditorTabs=v;function f(t){return t.tabs!==void 0}}),define(De[206],Ce([1,0,2,5,7,6,8,252,10,24,25]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let o,u,g=14,E=14;for(const b of f){let S=o?(0,w.commonPrefixLength)(o,b):0;for(S===0?u=1:u=E;S<b.length;S++)S+1===b.length?(g=E,E=9):E+=1,t.push([u,b.toUpperCase().charCodeAt(S),E]),t.push([u,b.toLowerCase().charCodeAt(S),E]),u=E;o=b,E=g}t.push([9,58,10]),t.push([10,47,12]),this.b=new R.StateMachine(t)}}provideDocumentLinks(f){this.c();const t=[],o=R.LinkComputer.computeLinks({getLineContent(u){return f.lineAt(u-1).text},getLineCount(){return f.lineCount}},this.b);for(const u of o){const g=C.DocumentLink.to(u);g.target&&t.push(g)}return t}}class m{constructor(f,t){this.i=t,this.b=new I,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,o,u={}){if(this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const g=this.h++;this.b.add(t),this.d.add(t),this.c.set(g,o);let E=2;u.isCaseSensitive&&(E+=1024),u.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(g,t,E).catch(S=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(S)});const b=o.onDidChangeFile(S=>{const s=[];for(const r of S){const{uri:a,type:h}=r;if(a.scheme!==t)continue;let c;switch(h){case M.FileChangeType.Changed:c=0;break;case M.FileChangeType.Created:c=1;break;case M.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:c})}this.a.$onFileSystemChange(g,s)});return(0,y.toDisposable)(()=>{b.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(f){const{type:t,ctime:o,mtime:u,size:g,permissions:E}=f;return{type:t,ctime:o,mtime:u,size:g,permissions:E}}$stat(f,t){return Promise.resolve(this.k(f).stat(i.URI.revive(t))).then(o=>m.j(o))}$readdir(f,t){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.k(f).readFile(i.URI.revive(t))).then(o=>T.VSBuffer.wrap(o))}$writeFile(f,t,o,u){return Promise.resolve(this.k(f).writeFile(i.URI.revive(t),o.buffer,u))}$delete(f,t,o){return Promise.resolve(this.k(f).delete(i.URI.revive(t),o))}$rename(f,t,o,u){return Promise.resolve(this.k(f).rename(i.URI.revive(t),i.URI.revive(o),u))}$copy(f,t,o,u){const g=this.k(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(i.URI.revive(t),i.URI.revive(o),u))}$mkdir(f,t){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(t)))}$watch(f,t,o,u){const g=this.k(f).watch(i.URI.revive(o),u);this.f.set(t,g)}$unwatch(f,t){const o=this.f.get(t);o&&(o.dispose(),this.f.delete(t))}$open(f,t,o){const u=this.k(f);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(i.URI.revive(t),o))}$close(f,t){const o=this.k(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(t))}$read(f,t,o,u){const g=this.k(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=T.VSBuffer.alloc(u);return Promise.resolve(g.read(t,o,E.buffer,0,u)).then(b=>E.slice(0,b))}$write(f,t,o,u){const g=this.k(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(t,o,u.buffer,0,u.byteLength))}k(f){const t=this.c.get(f);if(!t){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return t}}e.ExtHostFileSystem=m}),define(De[56],Ce([1,0,5,36,6,24,3,14,37,7]),function(te,e,i,k,y,M,C,R,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Yt{constructor(m,v){this.b=new Map,this.a=m.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(t){try{const o=f.b.get(t.scheme);if(!o)return await f.a.$stat(t);await f.a.$ensureActivation(t.scheme);const u=await o.stat(t);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(o){Yt.c(o)}},async readDirectory(t){try{const o=f.b.get(t.scheme);return o?(await f.a.$ensureActivation(t.scheme),(await o.readDirectory(t)).slice()):await f.a.$readdir(t)}catch(o){return Yt.c(o)}},async createDirectory(t){try{return await f.a.$mkdir(t)}catch(o){return Yt.c(o)}},async readFile(t){try{const o=f.b.get(t.scheme);return o?(await f.a.$ensureActivation(t.scheme),(await o.readFile(t)).slice()):(await f.a.$readFile(t)).buffer}catch(o){return Yt.c(o)}},async writeFile(t,o){try{return await f.a.$writeFile(t,M.VSBuffer.wrap(o))}catch(u){return Yt.c(u)}},async delete(t,o){try{const u=f.b.get(t.scheme);return u?(await f.a.$ensureActivation(t.scheme),await u.delete(t,{recursive:!1,...o})):await f.a.$delete(t,{recursive:!1,useTrash:!1,...o})}catch(u){return Yt.c(u)}},async rename(t,o,u){try{return await f.a.$rename(t,o,{overwrite:!1,...u})}catch(g){return Yt.c(g)}},async copy(t,o,u){try{return await f.a.$copy(t,o,{overwrite:!1,...u})}catch(g){return Yt.c(g)}},isWritableFileSystem(t){const o=v.getCapabilities(t);if(typeof o=="number")return!(o&2048)}})}static c(m){if(m instanceof y.FileSystemError)throw m;if(!(m instanceof Error))throw new y.FileSystemError(String(m));if(m.name==="ENOPRO")throw y.FileSystemError.Unavailable(m.message);switch(m.name){case k.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(m.message);case k.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(m.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(m.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(m.message);case k.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(m.message);case k.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(m.message);default:throw new y.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,v){return this.b.set(m,v),(0,T.toDisposable)(()=>this.b.delete(m))}};O=qe([Ve(0,R.IExtHostRpcService),Ve(1,w.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(De[207],Ce([1,0,4,35,2,5,8,6]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(I,m,v,f,t,o,u,g){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const E=this.h(I,v,t);this.g=0,o&&(this.g+=1),u&&(this.g+=2),g&&(this.g+=4);const b=(0,k.parse)(t),S=typeof t=="string",s=f(r=>{if(!o)for(const a of r.created){const h=y.URI.revive(a);b(h.fsPath)&&(!S||m.getWorkspaceFolder(h))&&this.a.fire(h)}if(!u)for(const a of r.changed){const h=y.URI.revive(a);b(h.fsPath)&&(!S||m.getWorkspaceFolder(h))&&this.b.fire(h)}if(!g)for(const a of r.deleted){const h=y.URI.revive(a);b(h.fsPath)&&(!S||m.getWorkspaceFolder(h))&&this.c.fire(h)}});this.d=R.Disposable.from(E,this.a,this.b,this.c,s)}h(I,m,v){const f=R.Disposable.from();if(typeof v=="string")return f;const t=I.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(v.pattern.includes(k.GLOBSTAR)||v.pattern.includes(k.GLOB_SPLIT))&&(o=!0);const u=Math.random();return t.$watch(m.identifier.value,u,v.baseUri,{recursive:o,excludes:[]}),R.Disposable.from({dispose:()=>t.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class T{constructor(I,m,v){this.j=I,this.k=m,this.l=v,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,m,v,f,t,o){return new w(this.j,I,m,this.a.event,C.GlobPattern.from(v),f,t,o)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,m){switch(I){case 2:this.b.fire(Object.freeze({files:m.map(v=>({oldUri:y.URI.revive(v.source),newUri:y.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(v=>y.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(v=>y.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,m){return(v,f,t)=>{const o=function(g){v.call(f,g)};return o.extension=I,m.event(o,void 0,t)}}async $onWillRunFileOperation(I,m,v,f){switch(I){case 2:return await this.n(this.g,{files:m.map(t=>({oldUri:y.URI.revive(t.source),newUri:y.URI.revive(t.target)}))},v,f);case 1:return await this.n(this.i,{files:m.map(t=>y.URI.revive(t.target))},v,f);case 0:case 3:return await this.n(this.h,{files:m.map(t=>y.URI.revive(t.target))},v,f)}}async n(I,m,v,f){const t=new Set,o=[];if(await I.fireAsync(m,f,async(g,E)=>{const b=Date.now(),S=await Promise.resolve(g);S instanceof R.WorkspaceEdit&&(o.push([E.extension,S]),t.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-b>v&&this.k.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||o.length===0)return;const u={edits:[]};for(const[,g]of o){const{edits:E}=C.WorkspaceEdit.from(g,{getTextDocumentVersion:b=>this.l.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(E)}return{edit:u,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=T}),define(De[208],Ce([1,0,2,38]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,R,w,T,O){this.a=R,this.b=w,this.c=T;const I=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new k.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new k.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new k.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new k.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(C,R,w,T){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:w,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(De[209],Ce([1,0,7,5]),function(te,e,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,C),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=y}),define(De[210],Ce([1,0,2,23,8,6,71,5,10,53,16,9,253,20,7,83,79,50,211,11,15,25]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(D,B){this.d=D,this.e=B}async provideDocumentSymbols(D,B){const H=this.d.getDocument(D),G=await this.e.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(G))return G[0]instanceof M.DocumentSymbol?G.map(y.DocumentSymbol.from):s.f(G)}static f(D){D=D.slice(0).sort((G,Z)=>{let le=G.location.range.start.compareTo(Z.location.range.start);return le===0&&(le=Z.location.range.end.compareTo(G.location.range.end)),le});const B=[],H=[];for(const G of D){const Z={name:G.name||"!!MISSING: name!!",kind:y.SymbolKind.from(G.kind),tags:G.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:y.Range.from(G.location.range),selectionRange:y.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(Z),B.push(Z);break}const le=H[H.length-1];if(T.Range.containsRange(le.range,Z.range)&&!T.Range.equalsRange(le.range,Z.range)){le.children?.push(Z),H.push(Z);break}H.pop()}}return B}}class r{constructor(D,B,H){this.g=D,this.h=B,this.j=H,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(D,B){const H=this.g.getDocument(D),G=await this.j.provideCodeLenses(H,B);if(!G||B.isCancellationRequested)return;const Z=this.e.add(G),le=new f.DisposableStore;this.f.set(Z,le);const be={cacheId:Z,lenses:[]};for(let se=0;se<G.length;se++)be.lenses.push({cacheId:[Z,se],range:y.Range.from(G[se].range),command:this.h.toInternal(G[se].command,le)});return be}async resolveCodeLens(D,B){const H=D.cacheId&&this.e.get(...D.cacheId);if(!H)return;let G;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.j.resolveCodeLens(H,B),G||(G=H),B.isCancellationRequested)return;const Z=D.cacheId&&this.f.get(D.cacheId[0]);if(!!Z)return D.command=this.h.toInternal(G.command??r.d,Z),D}releaseCodeLenses(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}}r.d={command:"missing",title:"!!MISSING: command!!"};function a(J){return Array.isArray(J)?J.map(y.DefinitionLink.from):J?[y.DefinitionLink.from(J)]:[]}class h{constructor(D,B){this.d=D,this.e=B}async provideDefinition(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideDefinition(G,Z,H);return a(le)}}class c{constructor(D,B){this.d=D,this.e=B}async provideDeclaration(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideDeclaration(G,Z,H);return a(le)}}class d{constructor(D,B){this.d=D,this.e=B}async provideImplementation(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideImplementation(G,Z,H);return a(le)}}class n{constructor(D,B){this.d=D,this.e=B}async provideTypeDefinition(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideTypeDefinition(G,Z,H);return a(le)}}class l{constructor(D,B){this.d=D,this.e=B}async provideHover(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideHover(G,Z,H);if(!(!le||(0,O.isFalsyOrEmpty)(le.contents)))return le.range||(le.range=G.getWordRangeAtPosition(Z)),le.range||(le.range=new M.Range(Z,Z)),y.Hover.from(le)}}class p{constructor(D,B){this.d=D,this.e=B}async provideEvaluatableExpression(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideEvaluatableExpression(G,Z,H);if(le)return y.EvaluatableExpression.from(le)}}class A{constructor(D,B){this.d=D,this.e=B}async provideInlineValues(D,B,H,G){const Z=this.d.getDocument(D),le=await this.e.provideInlineValues(Z,y.Range.to(B),y.InlineValueContext.to(H),G);if(Array.isArray(le))return le.map(be=>y.InlineValue.from(be))}}class L{constructor(D,B){this.d=D,this.e=B}async provideDocumentHighlights(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideDocumentHighlights(G,Z,H);if(Array.isArray(le))return le.map(y.DocumentHighlight.from)}}class q{constructor(D,B){this.d=D,this.e=B}async provideLinkedEditingRanges(D,B,H){const G=this.d.getDocument(D),Z=y.Position.to(B),le=await this.e.provideLinkedEditingRanges(G,Z,H);if(le&&Array.isArray(le.ranges))return{ranges:(0,O.coalesce)(le.ranges.map(y.Range.from)),wordPattern:le.wordPattern}}}class K{constructor(D,B){this.d=D,this.e=B}async provideReferences(D,B,H,G){const Z=this.d.getDocument(D),le=y.Position.to(B),be=await this.e.provideReferences(Z,le,H,G);if(Array.isArray(be))return be.map(y.location.from)}}class j{constructor(D,B,H,G,Z,le,be){this.g=D,this.h=B,this.j=H,this.k=G,this.l=Z,this.m=le,this.n=be,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(D,B,H,G){const Z=this.g.getDocument(D),le=m.Selection.isISelection(B)?y.Selection.to(B):y.Range.to(B),be=[];for(const et of this.j.getDiagnostics(D))if(le.intersection(et.range)&&be.push(et)>j.d)break;const se={diagnostics:be,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},we=await this.k.provideCodeActions(Z,le,se,G);if(!(0,O.isNonEmptyArray)(we)||G.isCancellationRequested)return;const ve=this.e.add(we),$e=new f.DisposableStore;this.f.set(ve,$e);const He=[];for(let et=0;et<we.length;et++){const xe=we[et];!xe||(j.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,$e)})):(se.only&&(xe.kind?se.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${se.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${se.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[ve,et],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,$e),diagnostics:xe.diagnostics&&xe.diagnostics.map(y.Diagnostic.from),edit:xe.edit&&y.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})))}return{cacheId:ve,actions:He}}async resolveCodeAction(D,B){const[H,G]=D,Z=this.e.get(H,G);if(!Z||j.o(Z)||!this.k.resolveCodeAction)return;const le=await this.k.resolveCodeAction(Z,B)??Z;return le?.edit?y.WorkspaceEdit.from(le.edit,void 0):void 0}releaseCodeActions(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}static o(D){return typeof D.command=="string"&&typeof D.title=="string"}}j.d=1e3;class P{constructor(D,B,H,G){this.d=D,this.e=B,this.f=H,this.g=G}async prepareDocumentPaste(D,B,H,G){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(D),le=B.map(se=>y.Range.to(se)),be=y.DataTransfer.toDataTransfer(H,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(Z,le,be,G),y.DataTransfer.toDataTransferDTO(be)}async providePasteEdits(D,B,H,G,Z){const le=this.e.getDocument(B),be=H.map(ve=>y.Range.to(ve)),se=y.DataTransfer.toDataTransfer(G,async ve=>(await this.d.$resolvePasteFileData(this.g,D,ve)).buffer),we=await this.f.provideDocumentPasteEdits(le,be,se,Z);if(!!we)return{insertText:typeof we.insertText=="string"?we.insertText:{snippet:we.insertText.value},additionalEdit:we.additionalEdit?y.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}}class N{constructor(D,B){this.d=D,this.e=B}async provideDocumentFormattingEdits(D,B,H){const G=this.d.getDocument(D),Z=await this.e.provideDocumentFormattingEdits(G,B,H);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class F{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeFormattingEdits(D,B,H,G){const Z=this.d.getDocument(D),le=y.Range.to(B),be=await this.e.provideDocumentRangeFormattingEdits(Z,le,H,G);if(Array.isArray(be))return be.map(y.TextEdit.from)}}class ${constructor(D,B){this.d=D,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(D,B,H,G,Z){const le=this.d.getDocument(D),be=y.Position.to(B),se=await this.e.provideOnTypeFormattingEdits(le,be,H,G,Z);if(Array.isArray(se))return se.map(y.TextEdit.from)}}class z{constructor(D,B){this.e=D,this.f=B,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(D,B){const H=await this.e.provideWorkspaceSymbols(D,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const G=this.d.add(H),Z={cacheId:G,symbols:[]};for(let le=0;le<H.length;le++){const be=H[le];if(!be||!be.name){this.f.warn("INVALID SymbolInformation",be);continue}Z.symbols.push({...y.WorkspaceSymbol.from(be),cacheId:[G,le]})}return Z}async resolveWorkspaceSymbol(D,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!D.cacheId)return D;const H=this.d.get(...D.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,B);return G&&(0,k.mixin)(D,y.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(D){this.d.delete(D)}}class V{static supportsResolving(D){return typeof D.prepareRename=="function"}constructor(D,B,H){this.d=D,this.e=B,this.f=H}async provideRenameEdits(D,B,H,G){const Z=this.d.getDocument(D),le=y.Position.to(B);try{const be=await this.e.provideRenameEdits(Z,le,H,G);return be?y.WorkspaceEdit.from(be):void 0}catch(be){const se=V.g(be);return se?{rejectReason:se,edits:void 0}:Promise.reject(be)}}async resolveRenameLocation(D,B,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(D),Z=y.Position.to(B);try{const le=await this.e.prepareRename(G,Z,H);let be,se;if(M.Range.isRange(le)?(be=le,se=G.getText(le)):(0,I.isObject)(le)&&(be=le.range,se=le.placeholder),!be||!se)return;if(be.start.line>Z.line||be.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(be),text:se}}catch(le){const be=V.g(le);return be?{rejectReason:be,range:void 0,text:void 0}:Promise.reject(le)}}static g(D){return typeof D=="string"?D:D instanceof Error&&typeof D.message=="string"?D.message:void 0}}class X{constructor(D,B){this.resultId=D,this.tokens=B}}class ee{constructor(D,B){this.f=D,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(D,B,H){const G=this.f.getDocument(D),Z=B!==0?this.d.get(B):null;let le=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,Z.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return Z&&this.d.delete(B),le?(le=ee.h(le),this.o(ee.n(Z,le),le)):null}async releaseDocumentSemanticColoring(D){this.d.delete(D)}static h(D){return ee.j(D)?ee.k(D)?D:new M.SemanticTokens(new Uint32Array(D.data),D.resultId):ee.l(D)?ee.m(D)?D:new M.SemanticTokensEdits(D.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),D.resultId):D}static j(D){return D&&!!D.data}static k(D){return D.data instanceof Uint32Array}static l(D){return D&&Array.isArray(D.edits)}static m(D){for(const B of D.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(D,B){if(!ee.j(B)||!D||!D.tokens)return B;const H=D.tokens,G=H.length,Z=B.data,le=Z.length;let be=0;const se=Math.min(G,le);for(;be<se&&H[be]===Z[be];)be++;if(be===G&&be===le)return new M.SemanticTokensEdits([],B.resultId);let we=0;const ve=se-be;for(;we<ve&&H[G-we-1]===Z[le-we-1];)we++;return new M.SemanticTokensEdits([{start:be,deleteCount:G-be-we,data:Z.subarray(be,le-we)}],B.resultId)}o(D,B){if(ee.j(D)){const H=this.e++;return this.d.set(H,new X(D.resultId,D.data)),(0,t.encodeSemanticTokensDto)({id:H,type:"full",data:D.data})}if(ee.l(D)){const H=this.e++;return ee.j(B)?this.d.set(H,new X(B.resultId,B.data)):this.d.set(H,new X(D.resultId)),(0,t.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(D.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class fe{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeSemanticTokens(D,B,H){const G=this.d.getDocument(D),Z=await this.e.provideDocumentRangeSemanticTokens(G,y.Range.to(B),H);return Z?this.f(Z):null}f(D){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:D.data})}}class oe{static supportsResolving(D){return typeof D.resolveCompletionItem=="function"}constructor(D,B,H,G,Z){this.f=D,this.g=B,this.h=H,this.j=G,this.k=Z,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(D,B,H,G){const Z=this.f.getDocument(D),le=y.Position.to(B),be=Z.getWordRangeAtPosition(le)||new M.Range(le,le),se=be.with({end:le}),we=new g.StopWatch(!0),ve=await this.h.provideCompletionItems(Z,le,G,y.CompletionContext.to(H));if(!ve||G.isCancellationRequested)return;const $e=Array.isArray(ve)?new M.CompletionList(ve):ve,He=oe.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),et=new f.DisposableStore;this.e.set(He,et);const xe=[],tt={x:He,b:xe,a:{replace:y.Range.from(be),insert:y.Range.from(se)},c:$e.isIncomplete||void 0,d:we.elapsed()};for(let nt=0;nt<$e.items.length;nt++){const dt=$e.items[nt],Le=this.l(dt,[He,nt],se,be);xe.push(Le)}return tt}async resolveCompletionItem(D,B){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...D);if(!H)return;const G=await this.h.resolveCompletionItem(H,B);if(!!G)return this.l(G,D)}releaseCompletionItems(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B,H,G){const Z=this.e.get(B[0]);if(!Z)throw Error("DisposableStore is missing...");const le=this.g.toInternal(D.command,Z),be={x:B,a:D.label,b:D.kind!==void 0?y.CompletionItemKind.from(D.kind):void 0,m:D.tags&&D.tags.map(y.CompletionItemTag.from),c:D.detail,d:typeof D.documentation>"u"?void 0:y.MarkdownString.fromStrict(D.documentation),e:D.sortText!==D.label?D.sortText:void 0,f:D.filterText!==D.label?D.filterText:void 0,g:D.preselect||void 0,i:D.keepWhitespace?1:0,k:D.commitCharacters?.join(""),l:D.additionalTextEdits&&D.additionalTextEdits.map(y.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};D.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=D.textEdit.newText):typeof D.insertText=="string"?be.h=D.insertText:D.insertText instanceof M.SnippetString&&(be.h=D.insertText.value,be.i|=4);let se;return D.textEdit?se=D.textEdit.range:D.range&&(se=D.range),M.Range.isRange(se)?be.j=y.Range.from(se):se&&(!H?.isEqual(se.inserting)||!G?.isEqual(se.replacing))&&(be.j={insert:y.Range.from(se.inserting),replace:y.Range.from(se.replacing)}),be}}class ue{async provideInlineCompletions(D,B,H,G){}disposeCompletions(D){}handleDidShowCompletionItem(D,B){}}class ce extends ue{constructor(D,B,H,G){super(),this.f=D,this.g=B,this.h=H,this.j=G,this.d=new he,this.e=(0,S.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,S.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(D,B,H,G){const Z=this.g.getDocument(D),le=y.Position.to(B),be=await this.h.provideInlineCompletionItems(Z,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!be||G.isCancellationRequested)return;const se=Array.isArray(be)?be:be.items,we=this.e?Array.isArray(be)?[]:be.commands||[]:[];let ve;return{pid:this.d.createReferenceId({dispose(){ve?.dispose()},items:se}),items:se.map((He,et)=>{let xe;He.command&&(ve||(ve=new f.DisposableStore),xe=this.j.toInternal(He.command,ve));const tt=He.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:xe,idx:et,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:we.map(He=>(ve||(ve=new f.DisposableStore),this.j.toInternal(He,ve)))}}disposeCompletions(D){this.d.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,B){const H=this.d.get(D)?.items[B];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class he{constructor(){this.d=new Map,this.e=1}createReferenceId(D){const B=this.e++;return this.d.set(B,D),B}disposeReferenceId(D){const B=this.d.get(D);return this.d.delete(D),B}get(D){return this.d.get(D)}}class Y{constructor(D,B){this.e=D,this.f=B,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(D,B,H,G){const Z=this.e.getDocument(D),le=y.Position.to(B),be=this.g(H),se=await this.f.provideSignatureHelp(Z,le,G,be);if(se){const we=this.d.add([se]);return{...y.SignatureHelp.from(se),id:we}}}g(D){let B;if(D.activeSignatureHelp){const H=y.SignatureHelp.to(D.activeSignatureHelp),G=this.d.get(D.activeSignatureHelp.id,0);G?(B=G,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...D,activeSignatureHelp:B}}releaseSignatureHelp(D){this.d.delete(D)}}class ge{constructor(D,B,H,G,Z){this.f=D,this.g=B,this.h=H,this.j=G,this.k=Z,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(D,B,H){const G=this.f.getDocument(D),Z=y.Range.to(B),le=await this.h.provideInlayHints(G,Z,H);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const be=this.d.add(le);this.e.set(be,new f.DisposableStore);const se={hints:[],cacheId:be};for(let we=0;we<le.length;we++)this.l(le[we],Z)&&se.hints.push(this.m(le[we],[be,we]));return this.j.trace(`[InlayHints] ${se.hints.length} inlay hints from '${this.k.identifier.value}' for ${B}`),se}async resolveInlayHint(D,B){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...D);if(!H)return;const G=await this.h.resolveInlayHint(H,B);if(!!G&&!!this.l(G))return this.m(G,D)}releaseHints(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B){return D.label.length===0||Array.isArray(D.label)&&D.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",D),!1):!(B&&!B.contains(D.position))}m(D,B){const H=this.e.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:B,tooltip:y.MarkdownString.fromStrict(D.tooltip),position:y.Position.from(D.position),textEdits:D.textEdits&&D.textEdits.map(y.TextEdit.from),kind:D.kind&&y.InlayHintKind.from(D.kind),paddingLeft:D.paddingLeft,paddingRight:D.paddingRight};return typeof D.label=="string"?G.label=D.label:G.label=D.label.map(Z=>{const le={label:Z.value};return le.tooltip=y.MarkdownString.fromStrict(Z.tooltip),M.Location.isLocation(Z.location)&&(le.location=y.location.from(Z.location)),Z.command&&(le.command=this.g.toInternal(Z.command,H)),le}),G}}class Se{constructor(D,B){this.e=D,this.f=B,this.d=new u.Cache("DocumentLink")}async provideLinks(D,B){const H=this.e.getDocument(D),G=await this.f.provideDocumentLinks(H,B);if(!(!Array.isArray(G)||G.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(Se.g).map(y.DocumentLink.from)};{const Z=this.d.add(G),le={links:[],cacheId:Z};for(let be=0;be<G.length;be++){if(!Se.g(G[be]))continue;const se=y.DocumentLink.from(G[be]);se.cacheId=[Z,be],le.links.push(se)}return le}}}static g(D){return D.target&&D.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(D,B){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...D);if(!H)return;const G=await this.f.resolveDocumentLink(H,B);if(!(!G||!Se.g(G)))return y.DocumentLink.from(G)}releaseLinks(D){this.d.delete(D)}}class Fe{constructor(D,B){this.d=D,this.e=B}async provideColors(D,B){const H=this.d.getDocument(D),G=await this.e.provideDocumentColors(H,B);return Array.isArray(G)?G.map(le=>({color:y.Color.from(le.color),range:y.Range.from(le.range)})):[]}async provideColorPresentations(D,B,H){const G=this.d.getDocument(D),Z=y.Range.to(B.range),le=y.Color.to(B.color),be=await this.e.provideColorPresentations(le,{document:G,range:Z},H);if(!!Array.isArray(be))return be.map(y.ColorPresentation.from)}}class ze{constructor(D,B){this.d=D,this.e=B}async provideFoldingRanges(D,B,H){const G=this.d.getDocument(D),Z=await this.e.provideFoldingRanges(G,B,H);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class _e{constructor(D,B,H){this.d=D,this.e=B,this.f=H}async provideSelectionRanges(D,B,H){const G=this.d.getDocument(D),Z=B.map(y.Position.to),le=await this.e.provideSelectionRanges(G,Z,H);if(!(0,O.isNonEmptyArray)(le))return[];if(le.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const be=[];for(let se=0;se<Z.length;se++){const we=[];be.push(we);let ve=Z[se],$e=le[se];for(;;){if(!$e.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(we.push(y.SelectionRange.from($e)),!$e.parent)break;ve=$e.range,$e=$e.parent}}return be}}class ke{constructor(D,B){this.f=D,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,B,H){const G=this.f.getDocument(D),Z=y.Position.to(B),le=await this.g.prepareCallHierarchy(G,Z,H);if(!le)return;const be=this.d.nextId();return this.e.set(be,new Map),Array.isArray(le)?le.map(se=>this.h(be,se)):[this.h(be,le)]}async provideCallsTo(D,B,H){const G=this.j(D,B);if(!G)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(G,H);if(!!Z)return Z.map(le=>({from:this.h(D,le.from),fromRanges:le.fromRanges.map(be=>y.Range.from(be))}))}async provideCallsFrom(D,B,H){const G=this.j(D,B);if(!G)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(!!Z)return Z.map(le=>({to:this.h(D,le.to),fromRanges:le.fromRanges.map(be=>y.Range.from(be))}))}releaseSession(D){this.e.delete(D)}h(D,B){const H=this.e.get(D),G=y.CallHierarchyItem.from(B,D,H.size.toString(36));return H.set(G._itemId,B),G}j(D,B){return this.e.get(D)?.get(B)}}class Ie{constructor(D,B){this.f=D,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,B,H){const G=this.f.getDocument(D),Z=y.Position.to(B),le=await this.g.prepareTypeHierarchy(G,Z,H);if(!le)return;const be=this.d.nextId();return this.e.set(be,new Map),Array.isArray(le)?le.map(se=>this.h(be,se)):[this.h(be,le)]}async provideSupertypes(D,B,H){const G=this.j(D,B);if(!G)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(G,H);if(!!Z)return Z.map(le=>this.h(D,le))}async provideSubtypes(D,B,H){const G=this.j(D,B);if(!G)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(G,H);if(!!Z)return Z.map(le=>this.h(D,le))}releaseSession(D){this.e.delete(D)}h(D,B){const H=this.e.get(D),G=y.TypeHierarchyItem.from(B,D,H.size.toString(36));return H.set(G._itemId,B),G}j(D,B){return this.e.get(D)?.get(B)}}class Te{constructor(D,B,H,G){this.d=D,this.e=B,this.f=H,this.g=G}async provideDocumentOnDropEdits(D,B,H,G,Z){const le=this.e.getDocument(B),be=y.Position.to(H),se=y.DataTransfer.toDataTransfer(G,async ve=>(await this.d.$resolveDocumentOnDropFileData(this.g,D,ve)).buffer),we=await this.f.provideDocumentDropEdits(le,be,se,Z);if(!!we)return{insertText:typeof we.insertText=="string"?we.insertText:{snippet:we.insertText.value},additionalEdit:we.additionalEdit?y.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}}class re{constructor(D,B){this.adapter=D,this.extension=B}}class ae{constructor(D,B,H,G,Z,le,be,se){this.g=B,this.h=H,this.j=G,this.k=Z,this.l=le,this.m=be,this.n=se,this.f=new Map,this.e=D.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(D){return y.DocumentSelector.from(D,this.g)}p(D){return new M.Disposable(()=>{this.f.delete(D),this.e.$unregister(D)})}q(){return ae.d++}async s(D,B,H,G,Z,le=!1){const be=this.f.get(D);if(!be||!(be.adapter instanceof B))return G;const se=Date.now();le||this.l.trace(`[${be.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const we=H(be.adapter,be.extension);return Promise.resolve(we).catch(ve=>{(0,E.isCancellationError)(ve)||(this.l.error(`[${be.extension.identifier.value}] provider FAILED`),this.l.error(ve),this.n.onExtensionError(be.extension.identifier,ve))}).finally(()=>{le||this.l.trace(`[${be.extension.identifier.value}] provider DONE after ${Date.now()-se}ms`)}),v.CancellationToken.isCancellationToken(Z)?(0,b.raceCancellationError)(we,Z):we}t(D,B){const H=this.q();return this.f.set(H,new re(D,B)),H}static u(D){return D.displayName||D.name}registerDocumentSymbolProvider(D,B,H,G){const Z=this.t(new s(this.h,H),D),le=G&&G.label||ae.u(D);return this.e.$registerDocumentSymbolProvider(Z,this.o(B),le),this.p(Z)}$provideDocumentSymbols(D,B,H){return this.s(D,s,G=>G.provideDocumentSymbols(i.URI.revive(B),H),void 0,H)}registerCodeLensProvider(D,B,H){const G=this.q(),Z=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new re(new r(this.h,this.j.converter,H),D)),this.e.$registerCodeLensSupport(G,this.o(B),Z);let le=this.p(G);if(Z!==void 0){const be=H.onDidChangeCodeLenses(se=>this.e.$emitCodeLensEvent(Z));le=M.Disposable.from(le,be)}return le}$provideCodeLenses(D,B,H){return this.s(D,r,G=>G.provideCodeLenses(i.URI.revive(B),H),void 0,H)}$resolveCodeLens(D,B,H){return this.s(D,r,G=>G.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(D,B){this.s(D,r,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(D,B,H){const G=this.t(new h(this.h,H),D);return this.e.$registerDefinitionSupport(G,this.o(B)),this.p(G)}$provideDefinition(D,B,H,G){return this.s(D,h,Z=>Z.provideDefinition(i.URI.revive(B),H,G),[],G)}registerDeclarationProvider(D,B,H){const G=this.t(new c(this.h,H),D);return this.e.$registerDeclarationSupport(G,this.o(B)),this.p(G)}$provideDeclaration(D,B,H,G){return this.s(D,c,Z=>Z.provideDeclaration(i.URI.revive(B),H,G),[],G)}registerImplementationProvider(D,B,H){const G=this.t(new d(this.h,H),D);return this.e.$registerImplementationSupport(G,this.o(B)),this.p(G)}$provideImplementation(D,B,H,G){return this.s(D,d,Z=>Z.provideImplementation(i.URI.revive(B),H,G),[],G)}registerTypeDefinitionProvider(D,B,H){const G=this.t(new n(this.h,H),D);return this.e.$registerTypeDefinitionSupport(G,this.o(B)),this.p(G)}$provideTypeDefinition(D,B,H,G){return this.s(D,n,Z=>Z.provideTypeDefinition(i.URI.revive(B),H,G),[],G)}registerHoverProvider(D,B,H,G){const Z=this.t(new l(this.h,H),D);return this.e.$registerHoverProvider(Z,this.o(B)),this.p(Z)}$provideHover(D,B,H,G){return this.s(D,l,Z=>Z.provideHover(i.URI.revive(B),H,G),void 0,G)}registerEvaluatableExpressionProvider(D,B,H,G){const Z=this.t(new p(this.h,H),D);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(B)),this.p(Z)}$provideEvaluatableExpression(D,B,H,G){return this.s(D,p,Z=>Z.provideEvaluatableExpression(i.URI.revive(B),H,G),void 0,G)}registerInlineValuesProvider(D,B,H,G){const Z=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new A(this.h,H),D);this.e.$registerInlineValuesProvider(le,this.o(B),Z);let be=this.p(le);if(Z!==void 0){const se=H.onDidChangeInlineValues(we=>this.e.$emitInlineValuesEvent(Z));be=M.Disposable.from(be,se)}return be}$provideInlineValues(D,B,H,G,Z){return this.s(D,A,le=>le.provideInlineValues(i.URI.revive(B),H,G,Z),void 0,Z)}registerDocumentHighlightProvider(D,B,H){const G=this.t(new L(this.h,H),D);return this.e.$registerDocumentHighlightProvider(G,this.o(B)),this.p(G)}$provideDocumentHighlights(D,B,H,G){return this.s(D,L,Z=>Z.provideDocumentHighlights(i.URI.revive(B),H,G),void 0,G)}registerLinkedEditingRangeProvider(D,B,H){const G=this.t(new q(this.h,H),D);return this.e.$registerLinkedEditingRangeProvider(G,this.o(B)),this.p(G)}$provideLinkedEditingRanges(D,B,H,G){return this.s(D,q,async Z=>{const le=await Z.provideLinkedEditingRanges(i.URI.revive(B),H,G);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?ae.w(le.wordPattern):void 0}},void 0,G)}registerReferenceProvider(D,B,H){const G=this.t(new K(this.h,H),D);return this.e.$registerReferenceSupport(G,this.o(B)),this.p(G)}$provideReferences(D,B,H,G,Z){return this.s(D,K,le=>le.provideReferences(i.URI.revive(B),H,G,Z),void 0,Z)}registerCodeActionProvider(D,B,H,G){const Z=new f.DisposableStore,le=this.t(new j(this.h,this.j.converter,this.k,H,this.l,D,this.m),D);return this.e.$registerQuickFixSupport(le,this.o(B),{providedKinds:G?.providedCodeActionKinds?.map(be=>be.value),documentation:G?.documentation?.map(be=>({kind:be.kind.value,command:this.j.converter.toInternal(be.command,Z)}))},ae.u(D),Boolean(H.resolveCodeAction)),Z.add(this.p(le)),Z}$provideCodeActions(D,B,H,G,Z){return this.s(D,j,le=>le.provideCodeActions(i.URI.revive(B),H,G,Z),void 0,Z)}$resolveCodeAction(D,B,H){return this.s(D,j,G=>G.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(D,B){this.s(D,j,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(D,B,H){const G=this.t(new N(this.h,H),D);return this.e.$registerDocumentFormattingSupport(G,this.o(B),D.identifier,D.displayName||D.name),this.p(G)}$provideDocumentFormattingEdits(D,B,H,G){return this.s(D,N,Z=>Z.provideDocumentFormattingEdits(i.URI.revive(B),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(D,B,H){const G=this.t(new F(this.h,H),D);return this.e.$registerRangeFormattingSupport(G,this.o(B),D.identifier,D.displayName||D.name),this.p(G)}$provideDocumentRangeFormattingEdits(D,B,H,G,Z){return this.s(D,F,le=>le.provideDocumentRangeFormattingEdits(i.URI.revive(B),H,G,Z),void 0,Z)}registerOnTypeFormattingEditProvider(D,B,H,G){const Z=this.t(new $(this.h,H),D);return this.e.$registerOnTypeFormattingSupport(Z,this.o(B),G,D.identifier),this.p(Z)}$provideOnTypeFormattingEdits(D,B,H,G,Z,le){return this.s(D,$,be=>be.provideOnTypeFormattingEdits(i.URI.revive(B),H,G,Z,le),void 0,le)}registerWorkspaceSymbolProvider(D,B){const H=this.t(new z(B,this.l),D);return this.e.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(D,B,H){return this.s(D,z,G=>G.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(D,B,H){return this.s(D,z,G=>G.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(D,B){this.s(D,z,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(D,B,H){const G=this.t(new V(this.h,H,this.l),D);return this.e.$registerRenameSupport(G,this.o(B),V.supportsResolving(H)),this.p(G)}$provideRenameEdits(D,B,H,G,Z){return this.s(D,V,le=>le.provideRenameEdits(i.URI.revive(B),H,G,Z),void 0,Z)}$resolveRenameLocation(D,B,H,G){return this.s(D,V,Z=>Z.resolveRenameLocation(i.URI.revive(B),H,G),void 0,G)}registerDocumentSemanticTokensProvider(D,B,H,G){const Z=this.t(new ee(this.h,H),D),le=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(B),G,le);let be=this.p(Z);if(le){const se=H.onDidChangeSemanticTokens(we=>this.e.$emitDocumentSemanticTokensEvent(le));be=M.Disposable.from(be,se)}return be}$provideDocumentSemanticTokens(D,B,H,G){return this.s(D,ee,Z=>Z.provideDocumentSemanticTokens(i.URI.revive(B),H,G),null,G)}$releaseDocumentSemanticTokens(D,B){this.s(D,ee,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(D,B,H,G){const Z=this.t(new fe(this.h,H),D);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(B),G),this.p(Z)}$provideDocumentRangeSemanticTokens(D,B,H,G){return this.s(D,fe,Z=>Z.provideDocumentRangeSemanticTokens(i.URI.revive(B),H,G),null,G)}registerCompletionItemProvider(D,B,H,G){const Z=this.t(new oe(this.h,this.j.converter,H,this.m,D),D);return this.e.$registerCompletionsProvider(Z,this.o(B),G,oe.supportsResolving(H),`${D.identifier.value}(${G.join("")})`),this.p(Z)}$provideCompletionItems(D,B,H,G,Z){return this.s(D,oe,le=>le.provideCompletionItems(i.URI.revive(B),H,G,Z),void 0,Z)}$resolveCompletionItem(D,B,H){return this.s(D,oe,G=>G.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(D,B){this.s(D,oe,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(D,B,H){const G=new ce(D,this.h,H,this.j.converter),Z=this.t(G,D);return this.e.$registerInlineCompletionsSupport(Z,this.o(B),G.supportsHandleDidShowCompletionItem),this.p(Z)}$provideInlineCompletions(D,B,H,G,Z){return this.s(D,ue,le=>le.provideInlineCompletions(i.URI.revive(B),H,G,Z),void 0,Z)}$handleInlineCompletionDidShow(D,B,H){this.s(D,ue,async G=>{G.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(D,B){this.s(D,ue,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(D,B,H,G){const Z=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,le=this.t(new Y(this.h,H),D);return this.e.$registerSignatureHelpProvider(le,this.o(B),Z),this.p(le)}$provideSignatureHelp(D,B,H,G,Z){return this.s(D,Y,le=>le.provideSignatureHelp(i.URI.revive(B),H,G,Z),void 0,Z)}$releaseSignatureHelp(D,B){this.s(D,Y,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(D,B,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new ge(this.h,this.j.converter,H,this.l,D),D);this.e.$registerInlayHintsProvider(Z,this.o(B),typeof H.resolveInlayHint=="function",G,ae.u(D));let le=this.p(Z);if(G!==void 0){const be=H.onDidChangeInlayHints(se=>this.e.$emitInlayHintsEvent(G));le=M.Disposable.from(le,be)}return le}$provideInlayHints(D,B,H,G){return this.s(D,ge,Z=>Z.provideInlayHints(i.URI.revive(B),H,G),void 0,G)}$resolveInlayHint(D,B,H){return this.s(D,ge,G=>G.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(D,B){this.s(D,ge,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(D,B,H){const G=this.t(new Se(this.h,H),D);return this.e.$registerDocumentLinkProvider(G,this.o(B),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(D,B,H){return this.s(D,Se,G=>G.provideLinks(i.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(D,B,H){return this.s(D,Se,G=>G.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(D,B){this.s(D,Se,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(D,B,H){const G=this.t(new Fe(this.h,H),D);return this.e.$registerDocumentColorProvider(G,this.o(B)),this.p(G)}$provideDocumentColors(D,B,H){return this.s(D,Fe,G=>G.provideColors(i.URI.revive(B),H),[],H)}$provideColorPresentations(D,B,H,G){return this.s(D,Fe,Z=>Z.provideColorPresentations(i.URI.revive(B),H,G),void 0,G)}registerFoldingRangeProvider(D,B,H){const G=this.q(),Z=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new re(new ze(this.h,H),D)),this.e.$registerFoldingRangeProvider(G,this.o(B),D.identifier,Z);let le=this.p(G);if(Z!==void 0){const be=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));le=M.Disposable.from(le,be)}return le}$provideFoldingRanges(D,B,H,G){return this.s(D,ze,Z=>Z.provideFoldingRanges(i.URI.revive(B),H,G),void 0,G)}registerSelectionRangeProvider(D,B,H){const G=this.t(new _e(this.h,H,this.l),D);return this.e.$registerSelectionRangeProvider(G,this.o(B)),this.p(G)}$provideSelectionRanges(D,B,H,G){return this.s(D,_e,Z=>Z.provideSelectionRanges(i.URI.revive(B),H,G),[],G)}registerCallHierarchyProvider(D,B,H){const G=this.t(new ke(this.h,H),D);return this.e.$registerCallHierarchyProvider(G,this.o(B)),this.p(G)}$prepareCallHierarchy(D,B,H,G){return this.s(D,ke,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(B),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(D,B,H,G){return this.s(D,ke,Z=>Z.provideCallsTo(B,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(D,B,H,G){return this.s(D,ke,Z=>Z.provideCallsFrom(B,H,G),void 0,G)}$releaseCallHierarchy(D,B){this.s(D,ke,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(D,B,H){const G=this.t(new Ie(this.h,H),D);return this.e.$registerTypeHierarchyProvider(G,this.o(B)),this.p(G)}$prepareTypeHierarchy(D,B,H,G){return this.s(D,Ie,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(B),H,G)),void 0,G)}$provideTypeHierarchySupertypes(D,B,H,G){return this.s(D,Ie,Z=>Z.provideSupertypes(B,H,G),void 0,G)}$provideTypeHierarchySubtypes(D,B,H,G){return this.s(D,Ie,Z=>Z.provideSubtypes(B,H,G),void 0,G)}$releaseTypeHierarchy(D,B){this.s(D,Ie,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(D,B,H){const G=this.q();return this.f.set(G,new re(new Te(this.e,this.h,H,G),D)),this.e.$registerDocumentOnDropEditProvider(G,this.o(B)),this.p(G)}$provideDocumentOnDropEdits(D,B,H,G,Z,le){return this.s(D,Te,be=>Promise.resolve(be.provideDocumentOnDropEdits(B,i.URI.revive(H),G,Z,le)),void 0,void 0)}registerDocumentPasteEditProvider(D,B,H,G){const Z=this.q();return this.f.set(Z,new re(new P(this.e,this.h,H,Z),D)),this.e.$registerPasteEditProvider(Z,this.o(B),!!H.prepareDocumentPaste,G.pasteMimeTypes),this.p(Z)}$prepareDocumentPaste(D,B,H,G,Z){return this.s(D,P,le=>le.prepareDocumentPaste(i.URI.revive(B),H,G,Z),void 0,Z)}$providePasteEdits(D,B,H,G,Z,le){return this.s(D,P,be=>be.providePasteEdits(B,i.URI.revive(H),G,Z,le),void 0,le)}static w(D){return{pattern:D.source,flags:(0,w.regExpFlags)(D)}}static y(D){return{decreaseIndentPattern:ae.w(D.decreaseIndentPattern),increaseIndentPattern:ae.w(D.increaseIndentPattern),indentNextLinePattern:D.indentNextLinePattern?ae.w(D.indentNextLinePattern):void 0,unIndentedLinePattern:D.unIndentedLinePattern?ae.w(D.unIndentedLinePattern):void 0}}static B(D){return{beforeText:ae.w(D.beforeText),afterText:D.afterText?ae.w(D.afterText):void 0,previousLineText:D.previousLineText?ae.w(D.previousLineText):void 0,action:D.action}}static C(D){return D.map(ae.B)}setLanguageConfiguration(D,B,H){const{wordPattern:G}=H;if(G&&(0,w.regExpLeadsToEndlessLoop)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(B,G):this.h.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",D,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",D,"Do not use.");const Z=this.q(),le={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ae.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(Z,B,le),this.p(Z)}$setWordDefinitions(D){for(const B of D)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae.d=0}),define(De[212],Ce([1,0,5,8,6,29,15,7]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(O,I,m,v){this.c=I,this.d=m,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,I){await this.a.$changeLanguage(O,I);const m=this.c.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,I){const m=O.version,v=k.Position.from(I),f=await this.a.$tokensAtPosition(O.uri,v),t={type:y.StandardTokenType.Other,range:O.getWordRangeAtPosition(I)??new y.Range(I.line,I.character,I.line,I.character)};if(!f)return t;const o={range:k.Range.to(f.range),type:k.TokenType.to(f.type)};return!o.range.contains(I)||m!==O.version?t:o}createLanguageStatusItem(O,I,m){const v=this.f++,f=this.a,t=this.g,o=`${O.identifier.value}/${I}`;if(t.has(o))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);t.add(o);const u={selector:m,id:I,name:O.displayName??O.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const E=new R.DisposableStore,b=()=>{g?.dispose(),g=(0,C.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(v,{id:o,name:u.name??O.displayName??O.name,source:O.displayName??O.name,selector:k.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===y.LanguageStatusSeverity.Error?M.default.Error:u.severity===y.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:u.command&&this.d.toInternal(u.command,E),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},S={dispose(){E.dispose(),g?.dispose(),f.$removeLanguageStatus(v),t.delete(o)},get id(){return u.id},get name(){return u.name},set name(s){u.name=s,b()},get selector(){return u.selector},set selector(s){u.selector=s,b()},get text(){return u.text},set text(s){u.text=s,b()},get detail(){return u.detail},set detail(s){u.detail=s,b()},get severity(){return u.severity},set severity(s){u.severity=s,b()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(s){u.accessibilityInformation=s,b()},get command(){return u.command},set command(s){u.command=s,b()},get busy(){return u.busy},set busy(s){u.busy=s,b()}};return b(),S}}e.ExtHostLanguages=w}),define(De[73],Ce([1,0,21,10,2,3,12,5,27,14]),function(te,e,i,k,y,M,C,R,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(m,v,f){this.f=f,this.d=new Map,this.a=v.getProxy(R.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(m,v){const{message:f,args:t,comment:o}=v;if(this.c)return(0,k.format2)(f,t??{});let u=f;o&&o.length>0&&(u+=`/${Array.isArray(o)?o.join():o}`);const g=this.d.get(m)?.contents[u];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,k.format2)(g??f,t??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const t=await this.a.$fetchBundleContents(f),o=JSON.parse(t);v=m.isBuiltin?o.contents?.bundle:o}catch(t){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${t.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:f})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return y.URI.revive(v)}return m.l10n?y.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=qe([Ve(0,w.IExtHostInitDataService),Ve(1,T.IExtHostRpcService),Ve(2,C.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(De[213],Ce([1,0,12,5,27,14,2,4,9]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends i.AbstractLoggerService{constructor(m,v){super(v.logLevel,R.Event.None),this.g=m.getProxy(k.MainContext.MainThreadLogger)}$setLevel(m,v){v?this.setLevel(C.URI.revive(v),m):(0,w.isUndefined)(m)||this.setLevel(m)}f(m,v,f){return new O(this.g,m,v,f)}};T=qe([Ve(0,M.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class O extends i.AbstractMessageLogger{constructor(m,v,f,t){super(t?.always),this.l=m,this.m=v,this.j=!1,this.k=[],this.setLevel(f),this.l.$createLogger(v,t).then(()=>{this.p(this.k),this.j=!0})}f(m,v){const f=[[m,v]];this.j?this.p(f):this.k.push(...f)}p(m){this.l.$log(this.m,m)}}}),define(De[214],Ce([1,0,5,12,25]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(R){return R&&R.title}let C=class{constructor(w,T){this.b=T,this.a=w.getProxy(i.MainContext.MainThreadMessageService)}showMessage(w,T,O,I,m){const v={source:{identifier:w.identifier,label:w.displayName||w.name}};let f;typeof I=="string"||M(I)?f=[I,...m]:(v.modal=I?.modal,v.useCustom=I?.useCustom,v.detail=I?.detail,f=m),v.useCustom&&(0,y.checkProposedApiEnabled)(w,"resolvers");const t=[];for(let o=0;o<f.length;o++){const u=f[o];if(typeof u=="string")t.push({title:u,handle:o,isCloseAffordance:!1});else if(typeof u=="object"){const{title:g,isCloseAffordance:E}=u;t.push({title:g,isCloseAffordance:!!E,handle:o})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(T,O,v,t).then(o=>{if(typeof o=="number")return f[o]})}};C=qe([Ve(1,k.ILogService)],C),e.ExtHostMessageService=C}),define(De[215],Ce([1,0,24,4,7,28,10,9,2,50,5,38,8,6,43,187,96]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,b,S,s){this.q=S,this.r=s,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new k.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new T.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(O.MainContext.MainThreadNotebook),this.c=E.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,h=r.cell.handle,d=this.g.get(a)?.getCell(h);if(d)return d.apiCell}if(r&&r.$mid===14){const a=r.uri,h=this.g.get(a);if(h)return h.apiNotebook}return r}}),u.x(b)}getEditorById(E){const b=this.h.get(E);if(!b)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(E){for(const[b,S]of this.h)if(S.apiEditor===E)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,b){const S=this.g.get(E);if(!S&&!b)throw new Error(`NO notebook document for '${E}'`);return S}static s(E,b){if(!b)return;const S=b.filenamePattern.map(s=>m.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(b.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:b.displayName,filenamePattern:S,exclusive:b.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,b,S){const s=u.a++,r=typeof S.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(s,S),this.b.$registerNotebookCellStatusBarItemProvider(s,r,b);let a;return r!==void 0&&(a=S.onDidChangeCellStatusBarItems(h=>this.b.$emitCellStatusBarEvent(r))),new v.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,r),a?.dispose()})}async createNotebookDocument(E){const b=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return w.URI.revive(b)}async openNotebookDocument(E){const b=this.g.get(E);if(b)return b.apiNotebook;const S=await this.c.$tryOpenNotebook(E),s=this.g.get(w.URI.revive(S));return(0,R.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(E,b){w.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let S;typeof b=="object"?S={position:m.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(m.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:S={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,S),r=s&&this.h.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,b,S,s){const r=this.f.get(E),a=w.URI.revive(b),h=this.g.get(a);if(!h||!r)return;const c=h.getCellFromIndex(S);if(!c)return;const d=await r.provideCellStatusBarItems(c.apiCell,s);if(!d)return;const n=new y.DisposableStore,l=this.p.add([n]),A=(Array.isArray(d)?d:[d]).map(L=>m.NotebookStatusBarItem.from(L,this.i,n));return{cacheId:l,items:A}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,b,S,s,r){if((0,C.isFalsyOrWhitespace)(b))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,S),this.b.$registerNotebookSerializer(a,{id:E.identifier,location:E.extensionLocation},b,m.NotebookDocumentContentOptions.from(s),u.s(E,r)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(E,b,S){const s=this.u.get(E);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(b.buffer,S);return new f.SerializableObjectWithBuffers(m.NotebookData.from(r))}async $notebookToData(E,b,S){const s=this.u.get(E);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(m.NotebookData.to(b.value),S);return i.VSBuffer.wrap(r)}w(E,b,S){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const s=new o.ExtHostNotebookEditor(b,this.d,E,S.visibleRanges.map(m.NotebookRange.to),S.selections.map(m.NotebookRange.to),typeof S.viewColumn=="number"?m.ViewColumn.to(S.viewColumn):void 0);this.h.set(b,s)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const S of E.value.removedDocuments){const s=w.URI.revive(S),r=this.g.get(s);r&&(r.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(r.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===s.toString()&&this.h.delete(a.id)}if(E.value.addedDocuments){const S=[];for(const s of E.value.addedDocuments){const r=w.URI.revive(s.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new t.ExtHostNotebookDocument(this.c,this.q,this.r,r,s);S.push(...s.cells.map(h=>t.ExtHostCell.asModelAddData(a.apiNotebook,h))),this.g.get(r)?.dispose(),this.g.set(r,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(a.apiNotebook)}}if(E.value.addedEditors)for(const S of E.value.addedEditors){if(this.h.has(S.id))return;const s=w.URI.revive(S.documentUri),r=this.g.get(s);r&&this.w(r,S.id,S)}const b=[];if(E.value.removedEditors)for(const S of E.value.removedEditors){const s=this.h.get(S);s&&(this.h.delete(S),this.k?.id===s.id&&(this.k=void 0),b.push(s))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const S=new Set;this.l.forEach(s=>S.add(s.id));for(const s of this.h.values()){const r=S.has(s.id);s._acceptVisibility(r)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const b=I.ApiCommandArgument.String.with("notebookType","A notebook type"),S=new I.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new I.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>i.VSBuffer.wrap(r))],new I.ApiCommandResult("Notebook Data",r=>m.NotebookData.to(r.value))),s=new I.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new I.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new f.SerializableObjectWithBuffers(m.NotebookData.from(r)))],new I.ApiCommandResult("Bytes",r=>r.buffer));E.registerApiCommand(S),E.registerApiCommand(s)}}e.ExtHostNotebookController=u,u.a=0}),define(De[216],Ce([1,0,16,15,20,4,7,28,2,26,12,50,5,38,8,6,68,174,25,43]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let b=class{constructor(c,d,n,l,p){this.k=d,this.l=n,this.m=l,this.n=p,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new I.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(m.MainContext.MainThreadNotebookKernels);const A=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const q=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:q}}else if(L&&"notebookEditor"in L){const q=this.l.getIdByEditor(L.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return L})],v.ApiCommandResult.Void);this.m.registerApiCommand(A)}createNotebookController(c,d,n,l,p,A){for(const ue of this.h.values())if(ue.controller.id===d&&T.ExtensionIdentifier.equals(c.identifier,ue.extensionId))throw new Error(`notebook controller with id '${d}' ALREADY exist`);const L=this.i++,q=this;this.n.trace(`NotebookController[${L}], CREATED by ${c.identifier.value}, ${d}`);const K=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${c.identifier}'`);let j=!1;const P=new C.DisposableStore,N=new M.Emitter,F=new M.Emitter,$={id:a(c.identifier,d),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:l||c.identifier.value,preloads:A?A.map(f.NotebookRendererScript.from):[]};let z=p??K,V;this.a.$addKernel(L,$).catch(ue=>{console.log(ue),j=!0});let X=0;const ee=()=>{if(j)return;const ue=++X;Promise.resolve().then(()=>{ue===X&&this.a.$updateKernel(L,$)})},fe=new R.ResourceMap,oe={get id(){return d},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return $.label},set label(ue){$.label=ue??c.displayName??c.name,ee()},get detail(){return $.detail??""},set detail(ue){$.detail=ue,ee()},get description(){return $.description??""},set description(ue){$.description=ue,ee()},get kind(){return(0,g.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind??""},set kind(ue){(0,g.checkProposedApiEnabled)(c,"notebookControllerKind"),$.kind=ue,ee()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(ue){$.supportedLanguages=ue,ee()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){$.supportsExecutionOrder=ue,ee()},get rendererScripts(){return $.preloads?$.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ue){z=ue??K},get interruptHandler(){return V},set interruptHandler(ue){V=ue,$.supportsInterrupt=Boolean(ue),ee()},createNotebookCellExecution(ue){if(j)throw new Error("notebook controller is DISPOSED");if(!fe.has(ue.notebook.uri))throw q.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(fe.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return q._createNotebookCellExecution(ue,a(c.identifier,this.id))},dispose:()=>{j||(this.n.trace(`NotebookController[${L}], DISPOSED`),j=!0,this.h.delete(L),P.dispose(),N.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(ue,ce){ce===t.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(L,ue.uri,ce)},onDidReceiveMessage:F.event,postMessage(ue,ce){return(0,g.checkProposedApiEnabled)(c,"notebookMessaging"),q.a.$postMessage(L,ce&&q.l.getIdByEditor(ce),ue)},asWebviewUri(ue){return(0,g.checkProposedApiEnabled)(c,"notebookMessaging"),(0,o.asWebviewUri)(ue,q.k.remote)}};return this.h.set(L,{extensionId:c.identifier,controller:oe,onDidReceiveMessage:F,onDidChangeSelection:N,associatedNotebooks:fe}),oe}getIdByController(c){for(const[d,n]of this.h)if(n.controller===c)return a(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,d){const n=this.d++,l=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(n,d);const p={dispose:()=>{this.c.delete(n),l.a.$removeKernelDetectionTask(n)}};return this.c.set(n,p),p}registerKernelSourceActionProvider(c,d,n){const l=this.f++,p=this;return this.e.set(l,n),this.n.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(l,d),{dispose:()=>{this.e.delete(l),p.a.$removeKernelSourceActionProvider(l)}}}async $provideKernelSourceActions(c,d){const n=this.e.get(c);if(n){const l=new C.DisposableStore;return this.g.add([l]),(await n.provideNotebookKernelSourceActions(d)??[]).map(A=>f.NotebookKernelSourceAction.from(A,this.m.converter,l))}return[]}$acceptNotebookAssociation(c,d,n){const l=this.h.get(c);if(l){const p=this.l.getNotebookDocument(w.URI.revive(d));n?l.associatedNotebooks.set(p.uri,!0):l.associatedNotebooks.delete(p.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,p.uri.toString(),n),l.onDidChangeSelection.fire({selected:n,notebook:p.apiNotebook})}}async $executeCells(c,d,n){const l=this.h.get(c);if(!l)return;const p=this.l.getNotebookDocument(w.URI.revive(d)),A=[];for(const L of n){const q=p.getCell(L);q&&A.push(q.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,p.uri.toString(),A.length),await l.controller.executeHandler.call(l.controller,A,p.apiNotebook,l.controller)}catch(L){this.n.error(`NotebookController[${c}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(c,d,n){const l=this.h.get(c);if(!l)return;const p=this.l.getNotebookDocument(w.URI.revive(d));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,p.apiNotebook);else for(const A of n){const L=p.getCell(A);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,d,n){const l=this.h.get(c);if(!l)return;const p=this.l.getEditorById(d);l.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:n}))}$cellExecutionChanged(c,d,n){const p=this.l.getNotebookDocument(w.URI.revive(c)).getCell(d);if(p){const A=n?f.NotebookCellExecutionState.to(n):t.NotebookCellExecutionState.Idle;A!==void 0&&this.j.fire({cell:p.apiCell,state:A})}}_createNotebookCellExecution(c,d){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const p=new s(d,l,this.a);this.b.set(l.uri,p);const A=p.onDidChangeState(()=>{p.state===S.Resolved&&(p.dispose(),A.dispose(),this.b.delete(l.uri))});return p.asApiObject()}};b=qe([Ve(4,O.ILogService)],b),e.ExtHostNotebookKernels=b;var S;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(S||(S={}));class s extends C.Disposable{get state(){return this.f}constructor(c,d,n){super(),this.j=d,this.k=n,this.b=s.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=S.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new r(10,l=>this.m(l)),this.i=d.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const d=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(d))}n(){if(this.f===S.Init)throw new Error("Must call start before modifying cell output");if(this.f===S.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let d=this.j;if(c&&(d=this.j.notebook.getCellFromApiCell(c)),!d)throw new Error("INVALID cell");return d.handle}s(c){return c.map(d=>{const n=t.NotebookCellOutput.ensureUniqueMimeTypes(d.items,!0);return n===d.items?f.NotebookCellOutput.from(d):f.NotebookCellOutput.from({items:n,id:d.id,metadata:d.metadata})})}async t(c,d,n){const l=this.r(d),p=this.s((0,i.asArray)(c));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:l,append:n,outputs:p})}async w(c,d,n){return c=t.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(c),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:c.map(f.NotebookCellOutputItem.from),outputId:d.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(n){c.i=n,c.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(n){if(c.f===S.Resolved||c.f===S.Started)throw new Error("Cannot call start again");c.f=S.Started,c.c.fire(),c.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,l){if(c.f===S.Resolved)throw new Error("Cannot call resolve twice");c.f=S.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new E.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:n}))},clearOutput(n){return c.n(),c.t([],n,!1)},appendOutput(n,l){return c.n(),c.t(n,l,!0)},replaceOutput(n,l){return c.n(),c.t(n,l,!1)},appendOutputItems(n,l){return c.n(),c.w(n,l,!0)},replaceOutputItems(n,l){return c.n(),c.w(n,l,!1)}})}}s.a=0;class r{constructor(c,d){this.d=c,this.e=d,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new k.DeferredPromise,this.b=Date.now(),(0,k.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const d=this.a;return this.a=[],this.e(d).finally(()=>c.complete())}}function a(h,c){return`${h.value}/${c}`}e.createKernelId=a}),define(De[217],Ce([1,0,4,5,96]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(R,w){this.c=w,this.a=new Map,this.b=R.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,w,T){const O=this.c.getEditorById(R);this.a.get(w)?.fire({editor:O.apiEditor,message:T})}createRendererMessaging(R,w){if(!R.contributes?.notebookRenderer?.some(O=>O.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(O,I,m)=>this.d(w).event(O,I,m),postMessage:(O,I)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,I]=[I,O]);const m=I&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.b.$postMessage(m?.id,w,O)}}}d(R){let w=this.a.get(R);return w||(w=new i.Emitter({onDidRemoveLastListener:()=>{w?.dispose(),this.a.delete(R)}}),this.a.set(R,w),w)}}e.ExtHostNotebookRenderers=M}),define(De[218],Ce([1,0,7,2,25,5]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(w){this.b=new Map,this.a=w.getProxy(M.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,T,O){if((0,y.checkProposedApiEnabled)(w,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,O),this.a.$registerProfileContentHandler(T,O.name,w.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(w,T,O,I){const m=this.b.get(w);if(!m)throw new Error(`Unknown handler with id: ${w}`);return m.saveProfile(T,O,I)}async $readProfile(w,T,O){const I=this.b.get(w);if(!I)throw new Error(`Unknown handler with id: ${w}`);return I.readProfile(k.URI.revive(T),O)}}e.ExtHostProfileContentHandlers=C}),define(De[219],Ce([1,0,20,4,7,5,2,6,11,16,29,64]),function(te,e,i,k,y,M,C,R,w,T,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(v,f,t){const o=v.getProxy(M.MainContext.MainThreadQuickOpen);class u{constructor(c,d){this.e=new Map,this.f=0,this.a=c,this.b=d}showQuickPick(c,d,n=i.CancellationToken.None){this.c=void 0;const l=Promise.resolve(c),p=++this.f,A=o.$show(p,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},n),L={},q=A.then(()=>L);return Promise.race([q,l]).then(K=>{if(K!==L)return l.then(j=>{const P=[];for(let N=0;N<j.length;N++){const F=j[N];typeof F=="string"?P.push({label:F,handle:N}):F.kind===R.QuickPickItemKind.Separator?P.push({type:"separator",label:F.label}):P.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:N})}return d&&typeof d.onDidSelectItem=="function"&&(this.c=N=>{d.onDidSelectItem(j[N])}),o.$setItems(p,P),A.then(N=>{if(typeof N=="number")return j[N];if(Array.isArray(N))return N.map(F=>j[F])})})}).then(void 0,K=>{if(!(0,w.isCancellationError)(K))return o.$setError(p,K),Promise.reject(K)})}$onItemSelected(c){this.c?.(c)}showInput(c,d=i.CancellationToken.None){return this.d=c?.validateInput,o.$input(c,typeof this.d=="function",d).then(void 0,n=>{if(!(0,w.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(c){if(!this.d)return;const d=await this.d(c);if(!d||typeof d=="string")return d;let n;switch(d.severity){case R.InputBoxValidationSeverity.Info:n=O.default.Info;break;case R.InputBoxValidationSeverity.Warning:n=O.default.Warning;break;case R.InputBoxValidationSeverity.Error:n=O.default.Error;break;default:n=d.message?O.default.Error:O.default.Ignore;break}return{content:d.message,severity:n}}async showWorkspaceFolderPick(c,d=i.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!n)return;const l=await this.a.getWorkspaceFolders2();if(!!l)return l.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(c){const d=new r(c,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}createInputBox(c){const d=new a(c,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}$onDidChangeValue(c,d){this.e.get(c)?._fireDidChangeValue(d)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,d){const n=this.e.get(c);n instanceof r&&n._fireDidChangeActive(d)}$onDidChangeSelection(c,d){const n=this.e.get(c);n instanceof r&&n._fireDidChangeSelection(d)}$onDidTriggerButton(c,d){this.e.get(c)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(c,d,n){const l=this.e.get(c);l instanceof r&&l._fireDidTriggerItemButton(d,n)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class g{constructor(c,d){this.x=c,this.y=d,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.Emitter,this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.A({title:c})}get step(){return this.c}set step(c){this.c=c,this.A({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.A({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.A({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.A({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.A({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.A({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.A({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((d,n)=>{const l=d===R.QuickInputButtons.Back?-1:n;this.o.set(l,d)}),this.A({buttons:c.map((d,n)=>({...s(d),tooltip:d.tooltip,handle:d===R.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.A({visible:!0})}hide(){this.e=!1,this.A({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const d=this.o.get(c);d&&this.r.fire(d)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}A(c){if(!this.v){for(const d of Object.keys(c)){const n=c[d];this.u[d]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.B()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.B()},0))}}B(){o.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function E(h){if(h instanceof R.ThemeIcon)return{id:h.id};const c=S(h),d=b(h);return{dark:typeof c=="string"?C.URI.file(c):c,light:typeof d=="string"?C.URI.file(d):d}}function b(h){return typeof h=="object"&&"light"in h?h.light:h}function S(h){return typeof h=="object"&&"dark"in h?h.dark:h}function s(h){const c=E(h.iconPath);let d,n;return"id"in c?n=I.ThemeIcon.asClassName(c):d=c,{iconPath:d,iconClass:n}}class r extends g{constructor(c,d){super(c.identifier,d),this.C=[],this.D=new Map,this.E=new Map,this.F=!1,this.G=!0,this.H=!0,this.I=!0,this.J=!1,this.K=[],this.L=new k.Emitter,this.M=[],this.N=new k.Emitter,this.O=new k.Emitter,this.onDidChangeActive=this.L.event,this.onDidChangeSelection=this.N.event,this.onDidTriggerItemButton=this.O.event,this.w.push(this.L,this.N,this.O),this.A({type:"quickPick"})}get items(){return this.C}set items(c){this.C=c.slice(),this.D.clear(),this.E.clear(),c.forEach((n,l)=>{this.D.set(l,n),this.E.set(n,l)});const d=[];for(let n=0;n<c.length;n++){const l=c[n];l.kind===R.QuickPickItemKind.Separator?d.push({type:"separator",label:l.label}):d.push({handle:n,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((p,A)=>({...s(p),tooltip:p.tooltip,handle:A}))})}this.A({items:d})}get canSelectMany(){return this.F}set canSelectMany(c){this.F=c,this.A({canSelectMany:c})}get matchOnDescription(){return this.G}set matchOnDescription(c){this.G=c,this.A({matchOnDescription:c})}get matchOnDetail(){return this.H}set matchOnDetail(c){this.H=c,this.A({matchOnDetail:c})}get sortByLabel(){return this.I}set sortByLabel(c){this.I=c,this.A({sortByLabel:c})}get keepScrollPosition(){return this.J}set keepScrollPosition(c){this.J=c,this.A({keepScrollPosition:c})}get activeItems(){return this.K}set activeItems(c){this.K=c.filter(d=>this.E.has(d)),this.A({activeItems:this.K.map(d=>this.E.get(d))})}get selectedItems(){return this.M}set selectedItems(c){this.M=c.filter(d=>this.E.has(d)),this.A({selectedItems:this.M.map(d=>this.E.get(d))})}_fireDidChangeActive(c){const d=(0,T.coalesce)(c.map(n=>this.D.get(n)));this.K=d,this.L.fire(d)}_fireDidChangeSelection(c){const d=(0,T.coalesce)(c.map(n=>this.D.get(n)));this.M=d,this.N.fire(d)}_fireDidTriggerItemButton(c,d){const n=this.D.get(c);if(!n||!n.buttons||!n.buttons.length)return;const l=n.buttons[d];l&&this.O.fire({button:l,item:n})}}class a extends g{constructor(c,d){super(c.identifier,d),this.C=!1,this.A({type:"inputBox"})}get password(){return this.C}set password(c){this.C=c,this.A({password:c})}get prompt(){return this.D}set prompt(c){this.D=c,this.A({prompt:c})}get valueSelection(){return this.E}set valueSelection(c){this.E=c,this.A({valueSelection:c})}get validationMessage(){return this.F}set validationMessage(c){this.F=c,c?typeof c=="string"?this.A({validationMessage:c,severity:O.default.Error}):this.A({validationMessage:c.message,severity:c.severity??O.default.Error}):this.A({validationMessage:void 0,severity:O.default.Ignore})}}return new u(f,t)}e.createExtHostQuickOpen=m});var Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i};define(De[220],Ce([1,0,2,4,59,7,15,5,16,121,12,26,64,8,25]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f){"use strict";var t,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(l){if(l)return typeof l.iconPath=="string"?i.URI.file(l.iconPath):i.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function g(l,p){if(!l.iconPath&&!p.iconPath)return 0;if(l.iconPath){if(!p.iconPath)return 1}else return-1;const A=typeof l.iconPath=="string"?l.iconPath:i.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,L=typeof p.iconPath=="string"?p.iconPath:i.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,T.comparePaths)(A,L)}function E(l,p){let A=0;if(l.strikeThrough!==p.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==p.faded)return l.faded?1:-1;if(l.tooltip!==p.tooltip)return(l.tooltip||"").localeCompare(p.tooltip||"");if(A=g(l,p),A!==0)return A;if(l.light&&p.light)A=g(l.light,p.light);else{if(l.light)return 1;if(p.light)return-1}if(A!==0)return A;if(l.dark&&p.dark)A=g(l.dark,p.dark);else{if(l.dark)return 1;if(p.dark)return-1}return A}function b(l,p){if(l.command!==p.command)return l.command<p.command?-1:1;if(l.title!==p.title)return l.title<p.title?-1:1;if(l.tooltip!==p.tooltip){if(l.tooltip!==void 0&&p.tooltip!==void 0)return l.tooltip<p.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(l.arguments===p.arguments)return 0;if(l.arguments)if(p.arguments){if(l.arguments.length!==p.arguments.length)return l.arguments.length-p.arguments.length}else return 1;else return-1;for(let A=0;A<l.arguments.length;A++){const L=l.arguments[A],q=p.arguments[A];if(L!==q)return L<q?-1:1}return 0}function S(l,p){let A=(0,T.comparePaths)(l.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(A!==0)return A;if(l.command&&p.command)A=b(l.command,p.command);else{if(l.command)return 1;if(p.command)return-1}if(A!==0)return A;if(l.decorations&&p.decorations)A=E(l.decorations,p.decorations);else{if(l.decorations)return 1;if(p.decorations)return-1}return A}function s(l,p){for(let A=0;A<l.length;A++)if(l[A]!==p[A])return!1;return!0}function r(l,p){return l.command===p.command&&l.title===p.title&&l.tooltip===p.tooltip&&(l.arguments&&p.arguments?s(l.arguments,p.arguments):l.arguments===p.arguments)}function a(l,p){return(0,w.equals)(l,p,r)}class h{get value(){return this.d}set value(p){p=p??"",Re(this,t,"f").$setInputBoxValue(this.l,p),this.m(p)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(p){Re(this,t,"f").$setInputBoxPlaceholder(this.l,p),this.f=p}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(p){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=p,Re(this,t,"f").$setValidationProviderIsEnabled(this.l,!!p)}get enabled(){return this.h}set enabled(p){p=!!p,this.h!==p&&(this.h=p,Re(this,t,"f").$setInputBoxEnablement(this.l,p))}get visible(){return this.j}set visible(p){p=!!p,this.j!==p&&(this.j=p,Re(this,t,"f").$setInputBoxVisibility(this.l,p))}constructor(p,A,L){this.k=p,this.l=L,t.set(this,void 0),this.d="",this.e=new k.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,t,A,"f")}showValidationMessage(p,A){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Re(this,t,"f").$showValidationMessage(this.l,p,A)}$onInputBoxValueChange(p){this.m(p)}m(p){this.d=p,this.e.fire(p)}}e.ExtHostSCMInputBox=h,t=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(p){this.v=p,this.q.$updateGroupLabel(this.t,this.handle,p)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(p){this.p=p,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(p){this.f=[...p],this.k.fire()}constructor(p,A,L,q,K){this.q=p,this.s=A,this.t=L,this.u=q,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new k.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(p){return this.g.get(p)}$executeResourceCommand(p,A){const L=this.h.get(p);return L?(0,C.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this.f].sort(S),L=(0,w.sortedDiff)(this.o,p,S).map(j=>{const P=j.toInsert.map(N=>{const F=this.e++;this.g.set(F,N);const $=N.resourceUri;let z;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const ge=new M.DisposableStore;z=this.s.converter.toInternal(N.command,ge),this.j.set(F,ge)}else this.h.set(F,N.command);const V=u(N.decorations),X=N.decorations&&u(N.decorations.light)||V,ee=N.decorations&&u(N.decorations.dark)||V,fe=[X,ee],oe=N.decorations&&N.decorations.tooltip||"",ue=N.decorations&&!!N.decorations.strikeThrough,ce=N.decorations&&!!N.decorations.faded,he=N.contextValue||"";return{rawResource:[F,$,fe,oe,ue,ce,he,z],handle:F}});return{start:j.start,deleteCount:j.deleteCount,toInsert:P}}),q=L.map(({start:j,deleteCount:P,toInsert:N})=>[j,P,N.map(F=>F.rawResource)]),K=L.reverse();for(const{start:j,deleteCount:P,toInsert:N}of K){const F=N.map(z=>z.handle),$=this.n.splice(j,P,...F);for(const z of $)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=p,q}dispose(){this.l=!0,this.m.fire()}}c.d=0;class d{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(p){this.g!==p&&(this.g=p,Re(this,o,"f").$updateSourceControl(this.t,{count:p}))}get quickDiffProvider(){return this.h}set quickDiffProvider(p){this.h=p,Re(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this.j}set commitTemplate(p){p!==this.j&&(this.j=p,Re(this,o,"f").$updateSourceControl(this.t,{commitTemplate:p}))}get acceptInputCommand(){return this.l}set acceptInputCommand(p){this.k.value=new M.DisposableStore,this.l=p;const A=this.v.converter.toInternal(p,this.k.value);Re(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:A})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(p){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=p;const A=p!==void 0?{command:this.v.converter.toInternal(p.command,this.m.value),secondaryCommands:p.secondaryCommands?.map(L=>L.map(q=>this.v.converter.toInternal(q,this.m.value))),description:p.description,enabled:p.enabled}:void 0;Re(this,o,"f").$updateSourceControl(this.t,{actionButton:A??null})}get statusBarCommands(){return this.p}set statusBarCommands(p){if(this.p&&p&&a(this.p,p))return;this.o.value=new M.DisposableStore,this.p=p;const A=(p||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Re(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:A})}get selected(){return this.q}constructor(p,A,L,q,K,j){this.u=p,this.v=L,this.w=q,this.x=K,this.y=j,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new k.Emitter,this.onDidChangeSelection=this.s.event,this.t=d.d++,this.A=new Map,this.B=new Set,Je(this,o,A,"f"),this.f=new h(p,Re(this,o,"f"),this.t),Re(this,o,"f").$registerSourceControl(this.t,q,K,j)}createResourceGroup(p,A){const L=new c(Re(this,o,"f"),this.v,this.t,p,A),q=k.Event.once(L.onDidDispose)(()=>this.A.delete(L));return this.A.set(L,q),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const p=[],A=[];for(const[L,q]of this.A){q.dispose();const K=L.onDidUpdateResourceStates(()=>{this.B.add(L),this.eventuallyUpdateResourceStates()});k.Event.once(L.onDidDispose)(()=>{this.B.delete(L),K.dispose(),this.e.delete(L.handle),Re(this,o,"f").$unregisterGroup(this.t,L.handle)}),p.push([L.handle,L.id,L.label,L.features]);const j=L._takeResourceStateSnapshot();j.length>0&&A.push([L.handle,j]),this.e.set(L.handle,L)}Re(this,o,"f").$registerGroups(this.t,p,A),this.A.clear()}eventuallyUpdateResourceStates(){const p=[];this.B.forEach(A=>{const L=A._takeResourceStateSnapshot();L.length!==0&&p.push([A.handle,L])}),p.length>0&&Re(this,o,"f").$spliceResourceStates(this.t,p),this.B.clear()}getResourceGroup(p){return this.e.get(p)}setSelectionState(p){this.q=p,this.s.fire(p)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(p=>p.dispose()),Re(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,d.d=0,qe([(0,y.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let n=class tn{get onDidChangeActiveProvider(){return this.j.event}constructor(p,A,L){this.l=A,this.m=L,this.g=new Map,this.h=new Map,this.j=new k.Emitter,this.e=p.getProxy(R.MainContext.MainThreadSCM),this.f=p.getProxy(R.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const K=this.g.get(q.sourceControlHandle);if(!K)return q;const j=K.getResourceGroup(q.groupHandle);return j?j.getResourceState(q.handle):q}else if(q&&q.$mid===4){const K=this.g.get(q.sourceControlHandle);return K?K.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const K=this.g.get(q.handle);return K||q}return q}})}createSourceControl(p,A,L,q){this.m.trace("ExtHostSCM#createSourceControl",p.identifier.value,A,L,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const K=tn.d++,j=new d(p,this.e,this.l,A,L,q);this.g.set(K,j);const P=this.h.get(I.ExtensionIdentifier.toKey(p.identifier))||[];return P.push(j),this.h.set(I.ExtensionIdentifier.toKey(p.identifier),P),j}getLastInputBox(p){this.m.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const A=this.h.get(I.ExtensionIdentifier.toKey(p.identifier)),L=A&&A[A.length-1];return L&&L.inputBox}$provideOriginalResource(p,A,L){const q=i.URI.revive(A);this.m.trace("ExtHostSCM#$provideOriginalResource",p,q.toString());const K=this.g.get(p);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(q,L)).then(j=>j||null)}$onInputBoxValueChange(p,A){this.m.trace("ExtHostSCM#$onInputBoxValueChange",p);const L=this.g.get(p);return L&&L.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(p,A,L,q){this.m.trace("ExtHostSCM#$executeResourceCommand",p,A,L);const K=this.g.get(p);if(!K)return Promise.resolve(void 0);const j=K.getResourceGroup(A);return j?j.$executeResourceCommand(L,q):Promise.resolve(void 0)}$validateInput(p,A,L){this.m.trace("ExtHostSCM#$validateInput",p);const q=this.g.get(p);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>q.inputBox.validateInput(A,L)).then(K=>{if(!K)return Promise.resolve(void 0);const j=v.MarkdownString.fromStrict(K.message);return j?Promise.resolve([j,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this.g.get(p)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=p,Promise.resolve(void 0)}};n.d=0,n=qe([Ve(2,O.ILogService)],n),e.ExtHostSCM=n}),define(De[74],Ce([1,0,5,4,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(R){this.b=new k.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,w){return this.a.$getPassword(R,w)}store(R,w,T){return this.a.$setPassword(R,w,T)}delete(R,w){return this.a.$deletePassword(R,w)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[221],Ce([1,0,6,5,136,7,8,9]),function(te,e,i,k,y,M,C,R){"use strict";var w,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,t,o,u,g=i.StatusBarAlignment.Left,E){w.set(this,void 0),T.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new M.DisposableStore,Je(this,w,f,"f"),Je(this,T,t,"f"),this.c=O.a++,this.e=o,this.f=u,this.g=g,this.h=this.t(E)}t(f){if(!!(0,R.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(f){this.k=f,this.u()}set name(f){this.m=f,this.u()}set tooltip(f){this.l=f,this.u()}set color(f){this.n=f,this.u()}set backgroundColor(f){f&&!O.b.has(f.id)&&(f=void 0),this.o=f,this.u()}set command(f){this.q?.fromApi!==f&&(this.p.clear(),typeof f=="string"?this.q={fromApi:f,internal:Re(this,T,"f").toInternal({title:"",command:f},this.p)}:f?this.q={fromApi:f,internal:Re(this,T,"f").toInternal(f,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(f){this.s=f,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Re(this,w,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let t;this.m?t=this.m:t=(0,y.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=O.b.get(this.o.id));const u=C.MarkdownString.fromStrict(this.l);Re(this,w,"f").$setEntry(this.c,f,t,this.k,u,this.q?.internal,o,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,w=new WeakMap,T=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const t={message:f};return this.b.unshift(t),this.c(),new i.Disposable(()=>{const o=this.b.indexOf(t);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,t){this.a=f.getProxy(k.MainContext.MainThreadStatusBar),this.b=t,this.c=new I(this)}createStatusBarEntry(f,t,o,u){return new O(this.a,this.b,f,t,o,u)}setStatusBarMessage(f,t){const o=this.c.setMessage(f);let u;return typeof t=="number"?u=setTimeout(()=>o.dispose(),t):typeof t<"u"&&t.then(()=>o.dispose(),()=>o.dispose()),new i.Disposable(()=>{o.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=m}),define(De[75],Ce([1,0,5,4,3]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(R,w){this.c=w,this.b=new k.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,w){this.a.$registerExtensionStorageKeysToSync(R,w)}async initializeExtensionStorage(R,w,T){const O=await this.a.$initializeExtensionStorage(R,w);let I;return O&&(I=this.d(R,w,O)),I||T}setValue(R,w,T){return this.a.$setValue(R,w,T)}$acceptValue(R,w,T){const O=this.d(R,w,T);O&&this.b.fire({shared:R,key:w,value:O})}d(R,w,T){try{return JSON.parse(T)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${R}): ${O}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(De[76],Ce([1,0,3,27,12,56,2]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let R=class{constructor(T,O,I){this.d=O,this.f=I,this.a=T.workspace??void 0,this.b=T.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(T){return C.URI.joinPath(this.b.workspaceStorageHome,T)}async h(){if(!this.a)return Promise.resolve(void 0);const T=this.a.id,O=await this.g(T);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(C.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(T){if(this.c)return C.URI.joinPath(this.c,T.identifier.value)}globalValue(T){return C.URI.joinPath(this.b.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([Ve(0,k.IExtHostInitDataService),Ve(1,y.ILogService),Ve(2,M.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(De[57],Ce([1,0,4,5,3,2,14,7,6,137,11,175,20,34,161,64,9,15,8]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class E{constructor(n,l,p,A){this.k=n,this._id=l,this.l=p,this.m=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(q,K=!0){L.o(),L.k.$sendText(L._id,q,K)},show(q){L.o(),L.k.$show(L._id,q)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(n,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,o.withNullAsUndefined)(n.shellPath),shellArgs:(0,o.withNullAsUndefined)(n.shellArgs),cwd:(0,o.withNullAsUndefined)(n.cwd),env:(0,o.withNullAsUndefined)(n.env),icon:(0,o.withNullAsUndefined)(h(n.iconPath)),color:t.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,o.withNullAsUndefined)(n.message),strictEnv:(0,o.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this.n(n.location,l?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,l,p,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:p,color:t.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(n,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,l){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in n?{viewColumn:g.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,l){this.h=Object.freeze({code:n,reason:l})}setDimensions(n,l){return n===this.d&&l===this.g||n===0||l===0?!1:(this.d=n,this.g=l,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(l=>{l!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=E;class b{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,l){this.g.setDimensions?.({columns:n,rows:l})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let S=1,s=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,l){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=l.getProxy(k.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[p,A]of this.g)A.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,l){const p=new E(this.a,(0,v.generateUuid)(),n,n.name),A=new b(n.pty);return p.createExtensionTerminal(n.location,this.L(n,l).resolvedExtHostIdentifier,h(n.iconPath),c(n.color)).then(L=>{const q=this.M(L,A);this.h[L]=q}),this.f.push(p),p.value}L(n,l){if(l=l||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const A=this.f.find(L=>L.value===p);A&&(l.resolvedExtHostIdentifier=A._id)}}else n.location&&typeof n.location!="object"?l.location=n.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(n,l){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const A=new b(l),L=this.M(n,A);this.h[n]=L}async $acceptActiveTerminalChanged(n){const l=this.b;if(n===null){this.b=void 0,l!==this.b&&this.F.fire(this.b);return}const p=this.O(n);p&&(this.b=p,l!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,l){const p=this.O(n);p&&this.I.fire({terminal:p.value,data:l})}async $acceptTerminalDimensions(n,l,p){const A=this.O(n);A&&A.setDimensions(l,p)&&this.G.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptTerminalMaximumDimensions(n,l,p){this.g.get(n)?.resize(l,p)}async $acceptTerminalTitleChange(n,l){const p=this.O(n);p&&(p.name=l)}async $acceptTerminalClosed(n,l,p){const A=this.Q(this.f,n);if(A!==null){const L=this.f.splice(A,1)[0];L.setExitStatus(l,p),this.C.fire(L.value)}}$acceptTerminalOpened(n,l,p,A){if(l){const K=this.Q(this.f,l);if(K!==null){this.f[K]._id=n,this.D.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const L={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:M.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},q=new E(this.a,n,L,p);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(n,l){this.O(n)?._setProcessId(l)}async $startExtensionTerminal(n,l){const p=this.O(n);if(!p)return{message:(0,T.localize)(0,null,n)};p.isOpen||await new Promise(L=>{const q=this.onDidOpenTerminal(async K=>{K===p.value&&(q.dispose(),L())})});const A=this.g.get(n);A?A.startSendingEvents(l):this.j[n]={initialDimensions:l}}M(n,l){const p=new R.DisposableStore;p.add(l.onProcessReady(L=>this.a.$sendProcessReady(n,L.pid,L.cwd))),p.add(l.onDidChangeProperty(L=>this.a.$sendProcessProperty(n,L))),this.s.startBuffering(n,l.onProcessData),p.add(l.onProcessExit(L=>this.N(n,L))),this.g.set(n,l);const A=this.j[n];return A&&l instanceof b&&(l.startSendingEvents(A.initialDimensions),delete this.j[n]),p}$acceptProcessAckDataEvent(n,l){this.g.get(n)?.acknowledgeDataEvent(l)}$acceptProcessInput(n,l){this.g.get(n)?.input(l)}$acceptTerminalInteraction(n){const l=this.O(n);l?.setInteractedWith()&&this.H.fire(l.value)}$acceptProcessResize(n,l,p){try{this.g.get(n)?.resize(l,p)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(n,l){this.g.get(n)?.shutdown(l)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(l=>this.a.$sendProcessProperty(n,{type:"cwd",value:l}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new w.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,l,p){if(this.v.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.v.set(l,p),this.a.$registerProfileProvider(l,n.identifier.value),new w.Disposable(()=>{this.v.delete(l),this.a.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(n,l){const p=new m.CancellationTokenSource().token;let A=await this.v.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,l);return}this.createTerminalFromOptions(A.options,l)}}async $provideLinks(n,l){const p=this.O(n);if(!p)return[];this.w.delete(n),this.y.get(n)?.dispose(!0);const L=new m.CancellationTokenSource;this.y.set(n,L);const q=[],K={terminal:p.value,line:l},j=[];for(const F of this.u)j.push(u.Promises.withAsyncBody(async $=>{L.token.onCancellationRequested(()=>$({provider:F,links:[]}));const z=await F.provideTerminalLinks(K,L.token)||[];L.token.isCancellationRequested||$({provider:F,links:z})}));const P=await Promise.all(j);if(L.token.isCancellationRequested)return[];const N=new Map;for(const F of P)F&&F.links.length>0&&q.push(...F.links.map($=>{const z={id:S++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return N.set(z.id,{provider:F.provider,link:$}),z}));return this.w.set(n,N),q}$activateLink(n,l){const p=this.w.get(n)?.get(l);!p||p.provider.handleTerminalLink(p.link)}N(n,l){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const p=this.h[n];p&&(p.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,l)}O(n){return this.P(this.f,n)}P(n,l){const p=this.Q(n,l);return p!==null?n[p]:null}Q(n,l){let p=null;return n.some((A,L)=>A._id===l?(p=L,!0):!1),p}getEnvironmentVariableCollection(n){let l=this.l.get(n.identifier.value);return l||(l=new r,this.S(n.identifier.value,l)),l}R(n,l){const p=(0,I.serializeEnvironmentVariableCollection)(l.map);this.a.$setEnvironmentVariableCollection(n,l.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(l=>{const p=l[0],A=new r(l[1]);this.S(p,A)})}$acceptDefaultProfile(n,l){const p=this.m;this.m=n,this.n=l,p?.path!==n.path&&this.J.fire(n.path)}S(n,l){this.l.set(n,l),l.onDidChangeCollection(()=>{this.R(n,l)})}};s=qe([Ve(1,C.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class r{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,l){this.d(n,{value:l,type:w.EnvironmentVariableMutatorType.Replace})}append(n,l){this.d(n,{value:l,type:w.EnvironmentVariableMutatorType.Append})}prepend(n,l){this.d(n,{value:l,type:w.EnvironmentVariableMutatorType.Prepend})}d(n,l){const p=this.map.get(n);(!p||p.value!==l.value||p.type!==l.type)&&(this.map.set(n,l),this.b.fire())}get(n){return this.map.get(n)}forEach(n,l){this.map.forEach((p,A)=>n.call(l,A,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}e.EnvironmentVariableCollection=r;let a=class extends s{constructor(n){super(!1,n)}createTerminal(n,l,p){throw new O.NotSupportedError}createTerminalFromOptions(n,l){throw new O.NotSupportedError}};a=qe([Ve(0,C.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function h(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function c(d){return t.ThemeColor.isThemeColor(d)?d:void 0}});var Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i};define(De[222],Ce([1,0,16,24,20,4,185,223,7,23,9,34,5,14,97,8,6,42,67,52]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E){"use strict";var b,S;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(K,j,P){this.j=P,this.c=new M.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=K.getProxy(m.MainContext.MainThreadTesting),this.h=new p(this.f),this.g=new a(this.f),j.registerArgumentProcessor({processArgument:N=>{if(N?.$mid!==15)return N;const F=N,$=F.tests[F.tests.length-1].item.extId;return this.d.get(u.TestId.root($))?.collection.tree.get($)?.actual??(0,f.toItemFromContext)(N)}})}createTestController(K,j,P){if(this.d.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const N=new w.DisposableStore,F=N.add(new f.ExtHostTestItemCollection(K,j,this.j));F.root.label=j;const $=new Map,z=this.f,V={items:F.root.children,get label(){return j},set label(ee){j=ee,F.root.label=ee,z.$updateController(K,{label:j})},get refreshHandler(){return P},set refreshHandler(ee){P=ee,z.$updateController(K,{canRefresh:!!ee})},get id(){return K},createRunProfile:(ee,fe,oe,ue,ce)=>{let he=(0,R.hash)(ee);for(;$.has(he);)he++;return new A(this.f,$,K,he,ee,fe,oe,ue,ce)},createTestItem(ee,fe,oe){return new f.TestItemImpl(K,ee,fe,oe)},createTestRun:(ee,fe,oe=!0)=>this.g.createTestRun(K,F,ee,fe,oe),set resolveHandler(ee){F.resolveHandler=ee},get resolveHandler(){return F.resolveHandler},dispose:()=>{N.dispose()}};z.$registerTestController(K,j,!!P),N.add((0,w.toDisposable)(()=>z.$unregisterTestController(K)));const X={controller:V,collection:F,profiles:$};return this.d.set(K,X),N.add((0,w.toDisposable)(()=>this.d.delete(K))),N.add(F.onDidGenerateDiff(ee=>z.$publishDiff(K,ee.map(E.TestsDiffOp.serialize)))),V}createTestObserver(){return this.h.checkout()}async runTests(K,j=y.CancellationToken.None){const P=h(K);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.d.get(P.controllerId);if(!N)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:K.include?.map(F=>u.TestId.fromExtHostTestItem(F,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:L[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:K.exclude?.map(F=>F.id)},j)}$syncTests(){for(const{collection:K}of this.d.values())K.flushDiff();return Promise.resolve()}$provideFileCoverage(K,j,P){return(0,i.mapFind)(this.g.trackers,F=>F.id===K?F.getCoverage(j):void 0)?.provideFileCoverage(P)??Promise.resolve([])}$resolveFileCoverage(K,j,P,N){return(0,i.mapFind)(this.g.trackers,$=>$.id===K?$.getCoverage(j):void 0)?.resolveFileCoverage(P,N)??Promise.resolve([])}$configureRunProfile(K,j){this.d.get(K)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(K,j){await this.d.get(K)?.controller.refreshHandler?.(j)}$publishTestResults(K){this.results=Object.freeze(K.map(j=>(0,T.deepFreeze)(t.TestResults.to(j))).concat(this.results).sort((j,P)=>P.completedAt-j.completedAt).slice(0,32)),this.c.fire()}async $expandTest(K,j){const P=this.d.get(u.TestId.fromString(K).controllerId)?.collection;P&&(await P.expand(K,j<0?1/0:j),P.flushDiff())}$acceptDiff(K){this.h.applyDiff(K.map(E.TestsDiffOp.deserialize))}async $runControllerTests(K,j){return Promise.all(K.map(P=>this.runControllerTestRequest(P,j)))}async runControllerTestRequest(K,j){const P=this.d.get(K.controllerId);if(!P)return{};const{collection:N,profiles:F}=P,$=F.get(K.profileId);if(!$)return{};const z=K.testIds.map(fe=>N.tree.get(fe)).filter(O.isDefined),V=K.excludeExtIds.map(fe=>P.collection.tree.get(fe)).filter(O.isDefined).filter(fe=>z.some(oe=>oe.fullId.compare(fe.fullId)===2));if(!z.length)return{};const X=new o.TestRunRequest(z.some(fe=>fe.actual instanceof f.TestItemRootImpl)?void 0:z.map(fe=>fe.actual),V.map(fe=>fe.actual),$),ee=this.g.prepareForMainThreadTestRun(X,c.fromInternal(K,P.collection),j);try{return await $.runHandler(X,j),{}}catch(fe){return{error:String(fe)}}finally{ee.isRunning&&!j.isCancellationRequested&&await M.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(K){K===void 0?this.g.cancelAllRuns():this.g.cancelRunById(K)}};s=qe([Ve(0,v.IExtHostRpcService)],s),e.ExtHostTesting=s;class r extends w.Disposable{get isRunning(){return this.c.size>0}get id(){return this.k.id}constructor(K,j,P){super(),this.k=K,this.l=j,this.c=new Map,this.f=new Set,this.h=this.B(new M.Emitter),this.j=!1,this.onEnd=this.h.event,this.g=this.B(new y.CancellationTokenSource(P)),this.B(this.g.token.onCancellationRequested(()=>{for(const{run:N}of this.c.values())N.end()}))}getCoverage(K){return this.c.get(K)?.coverage}createRun(K){const j=this.k.id,P=this.k.controllerId,N=(0,I.generateUuid)(),F=new d(this.l,j,N),$=ee=>(fe,...oe)=>{if(V){console.warn(`Setting the state of test "${fe.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(fe)||(this.m(fe),ee(fe,...oe))},z=(ee,fe)=>{const oe=fe instanceof Array?fe.map(t.TestMessage.from):[t.TestMessage.from(fe)];if(ee.uri&&ee.range){const ue={range:t.Range.from(ee.range),uri:ee.uri};for(const ce of oe)ce.location=ce.location||ue}this.l.$appendTestMessagesInRun(j,N,u.TestId.fromExtHostTestItem(ee,P).toString(),oe)};let V=!1;const X={isPersisted:this.k.isPersisted,token:this.g.token,name:K,get coverageProvider(){return F.coverageProvider},set coverageProvider(ee){F.coverageProvider=ee},enqueued:$(ee=>{this.l.$updateTestStateInRun(j,N,u.TestId.fromExtHostTestItem(ee,P).toString(),1)}),skipped:$(ee=>{this.l.$updateTestStateInRun(j,N,u.TestId.fromExtHostTestItem(ee,P).toString(),5)}),started:$(ee=>{this.l.$updateTestStateInRun(j,N,u.TestId.fromExtHostTestItem(ee,P).toString(),2)}),errored:$((ee,fe,oe)=>{z(ee,fe),this.l.$updateTestStateInRun(j,N,u.TestId.fromExtHostTestItem(ee,P).toString(),6,oe)}),failed:$((ee,fe,oe)=>{z(ee,fe),this.l.$updateTestStateInRun(j,N,u.TestId.fromExtHostTestItem(ee,P).toString(),4,oe)}),passed:$((ee,fe)=>{this.l.$updateTestStateInRun(j,N,u.TestId.fromExtHostTestItem(ee,this.k.controllerId).toString(),3,fe)}),appendOutput:(ee,fe,oe)=>{V||(oe&&(this.k.isIncluded(oe)?this.m(oe):oe=void 0),this.l.$appendOutputToRun(j,N,k.VSBuffer.fromString(ee),fe&&t.location.from(fe),oe&&u.TestId.fromExtHostTestItem(oe,P).toString()))},end:()=>{V||(V=!0,this.l.$finishedTestRunTask(j,N),this.c.delete(N),this.isRunning||this.dispose())}};return this.c.set(N,{run:X,coverage:F}),this.l.$startedTestRunTask(j,{id:N,name:K,running:!0}),X}dispose(){this.j||(this.j=!0,this.h.fire(),this.g.cancel(),super.dispose())}m(K){if(!(K instanceof f.TestItemImpl))throw new g.InvalidTestItemError(K.id);if(this.f.has(u.TestId.fromExtHostTestItem(K,this.k.controllerId).toString()))return;const j=[],P=this.k.colllection.root;for(;;){const N=t.TestItem.from(K);if(j.unshift(N),this.f.has(N.extId)||(this.f.add(N.extId),K===P))break;K=K.parent||P}this.l.$addTestsToRun(this.k.controllerId,this.k.id,j)}}class a{get trackers(){return this.c.values()}constructor(K){this.d=K,this.c=new Map}prepareForMainThreadTestRun(K,j,P){return this.f(K,j,P)}cancelRunById(K){for(const j of this.c.values())if(j.id===K){j.dispose();return}}cancelAllRuns(){for(const K of this.c.values())K.dispose()}createTestRun(K,j,P,N,F){const $=this.c.get(P);if($)return $.createRun(N);const z=c.fromPublic(K,j,P,F),V=h(P);this.d.$startedExtensionTestRun({controllerId:K,profile:V&&{group:L[V.kind],id:V.profileId},exclude:P.exclude?.map(ee=>u.TestId.fromExtHostTestItem(ee,j.root.id).toString())??[],id:z.id,include:P.include?.map(ee=>u.TestId.fromExtHostTestItem(ee,j.root.id).toString())??[j.root.id],persist:F});const X=this.f(P,z);return X.onEnd(()=>this.d.$finishedExtensionTestRun(z.id)),X.createRun(N)}f(K,j,P){const N=new r(j,this.d,P);return this.c.set(K,N),N.onEnd(()=>this.c.delete(K)),N}}e.TestRunCoordinator=a;const h=q=>{if(!!q.profile){if(!(q.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class c{static fromPublic(K,j,P,N){return new c(K,(0,I.generateUuid)(),P.include?.map(F=>u.TestId.fromExtHostTestItem(F,K).toString())??[K],P.exclude?.map(F=>u.TestId.fromExtHostTestItem(F,K).toString())??[],N,j)}static fromInternal(K,j){return new c(K.controllerId,K.runId,K.testIds,K.excludeExtIds,!0,j)}constructor(K,j,P,N,F,$){this.controllerId=K,this.id=j,this.isPersisted=F,this.colllection=$,this.c=P.map(z=>z+"\0"),this.d=N.map(z=>z+"\0")}isIncluded(K){const j=u.TestId.fromExtHostTestItem(K,this.controllerId).toString()+"\0";for(const P of this.d)if(j===P||j.startsWith(P))return!1;for(const P of this.c)if(j===P||j.startsWith(P))return!0;return!1}}e.TestRunDto=c;class d{set coverageProvider(K){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!K||(this.c=K,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(K,j,P){this.f=K,this.g=j,this.h=P}async provideFileCoverage(K){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(K))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(j){throw this.d=void 0,j}}async resolveFileCoverage(K,j){const P=await this.d;let N=P?.[K];return!this.c||!P||!N?[]:(N.detailedCoverage||(N=P[K]=await this.c.resolveFileCoverage?.(N,j)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class n extends E.IncrementalChangeCollector{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(K){super(),this.h=K,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(K){this.c.add(K)}update(K){Object.assign(K.revived,t.TestItem.toPlain(K.item)),this.c.has(K)||this.d.add(K)}remove(K){if(this.c.has(K)){this.c.delete(K);return}this.d.delete(K);const j=u.TestId.parentId(K.item.extId);if(j&&this.g.has(j.toString())){this.g.add(K.item.extId);return}this.f.add(K)}getChangeEvent(){const{c:K,d:j,f:P}=this;return{get added(){return[...K].map(N=>N.revived)},get updated(){return[...j].map(N=>N.revived)},get removed(){return[...P].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class l extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.m=new M.Emitter,this.onDidChangeTests=this.m.event}get rootTests(){return super.f}getMirroredTestDataById(K){return this.d.get(K)}getMirroredTestDataByReference(K){return this.d.get(K.id)}l(K,j){return{...K,revived:t.TestItem.toPlain(K.item),depth:j?j.depth+1:0,children:new Set}}k(){return new n(this.m)}}e.MirroredTestCollection=l;class p{constructor(K){this.d=K}checkout(){this.c||(this.c=this.f());const K=this.c;return K.observers++,{onDidChangeTest:K.tests.onDidChangeTests,get tests(){return[...K.tests.rootTests].map(j=>j.revived)},dispose:(0,C.once)(()=>{--K.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(K){return this.c?.tests.getMirroredTestDataByReference(K)}applyDiff(K){this.c?.tests.apply(K)}f(){const K=new l;return this.d.$subscribeToDiffs(),{observers:0,tests:K}}}class A{get label(){return this.d}set label(K){K!==this.d&&(this.d=K,Re(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:K}))}get isDefault(){return this.f}set isDefault(K){K!==this.f&&(this.f=K,Re(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:K}))}get tag(){return this._tag}set tag(K){K?.id!==this._tag?.id&&(this._tag=K,Re(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:K?t.TestTag.namespace(this.controllerId,K.id):null}))}get configureHandler(){return this.c}set configureHandler(K){K!==this.c&&(this.c=K,Re(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!K}))}constructor(K,j,P,N,F,$,z,V=!1,X=void 0){this.controllerId=P,this.profileId=N,this.d=F,this.kind=$,this.runHandler=z,this.f=V,this._tag=X,b.set(this,void 0),S.set(this,void 0),Je(this,b,K,"f"),Je(this,S,j,"f"),j.set(N,this);const ee=L[$];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Re(this,b,"f").$publishTestRunProfile({profileId:N,controllerId:P,tag:X?t.TestTag.namespace(this.controllerId,X.id):null,label:F,group:ee,isDefault:V,hasConfigurationHandler:!1})}dispose(){Re(this,S,"f")?.delete(this.profileId)&&(Je(this,S,void 0,"f"),Re(this,b,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=A,b=new WeakMap,S=new WeakMap;const L={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[224],Ce([1,0,16,4,5,98,8,6]),function(te,e,i,k,y,M,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(O,I){this.i=I,this.a=new k.Emitter,this.b=new k.Emitter,this.c=new k.Emitter,this.d=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const I=this.i.allEditors();return O?I:I.map(m=>m.value)}async showTextDocument(O,I,m){let v;typeof I=="number"?v={position:C.ViewColumn.from(I),preserveFocus:m}:typeof I=="object"?v={position:C.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?C.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:v={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(O.uri,v),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,I){return new M.TextEditorDecorationType(this.h,O,I).value}$acceptEditorPropertiesChanged(O,I){const m=this.i.getEditor(O);if(!m)throw new Error("unknown text editor");if(I.options&&m._acceptOptions(I.options),I.selections){const v=I.selections.selections.map(C.Selection.to);m._acceptSelections(v)}if(I.visibleRanges){const v=i.coalesce(I.visibleRanges.map(C.Range.to));m._acceptVisibleRanges(v)}if(I.options&&this.b.fire({textEditor:m.value,options:{...I.options,lineNumbers:C.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const v=R.TextEditorSelectionChangeKind.fromValue(I.selections.source),f=I.selections.selections.map(C.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:v})}if(I.visibleRanges){const v=i.coalesce(I.visibleRanges.map(C.Range.to));this.c.fire({textEditor:m.value,visibleRanges:v})}}$acceptEditorPositionData(O){for(const I in O){const m=this.i.getEditor(I);if(!m)throw new Error("Unknown text editor");const v=C.ViewColumn.to(O[I]);m.value.viewColumn!==v&&(m._acceptViewColumn(v),this.d.fire({textEditor:m.value,viewColumn:v}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=w}),define(De[225],Ce([1,0,2,3,5,7,6,8,9]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class T{constructor(m,v){this.b=new Map,this.c=new Map,this.a=m.getProxy(y.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===12){const t=f.uri===void 0?void 0:i.URI.revive(f.uri);return this.c.get(f.source)?.get(O(t))?.get(f.handle)}return f}})}async $getTimeline(m,v,f,t){return this.b.get(m)?.provideTimeline(i.URI.revive(v),f,t)}registerTimelineProvider(m,v,f,t){const o=new M.DisposableStore,u=this.d(v.id,t,o).bind(this);let g;v.onDidChange&&(g=v.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:v.id}),this));const E=this.c;return this.f({...v,scheme:m,onDidChange:void 0,async provideTimeline(b,S,s){S?.resetCache&&(o.clear(),E.get(v.id)?.clear());const r=await v.provideTimeline(b,S,s);if(r==null)return;const a=u(b,S);return{...r,source:v.id,items:r.items.map(a)}},dispose(){for(const b of E.values())b.get(v.id)?.clear();g?.dispose(),o.dispose()}})}d(m,v,f){return(t,o)=>{let u;if(o?.cacheResults){let g=this.c.get(m);g===void 0&&(g=new Map,this.c.set(m,g));const E=O(t);u=g.get(E),u===void 0&&(u=new Map,g.set(E,u))}return g=>{const{iconPath:E,...b}=g,S=`${m}|${g.id??g.timestamp}`;u?.set(S,g);let s,r,a;g.iconPath&&(E instanceof C.ThemeIcon?a={id:E.id,color:E.color}:i.URI.isUri(E)?(s=E,r=E):{light:s,dark:r}=E);let h;return C.MarkdownString.isMarkdownString(b.tooltip)?h=R.MarkdownString.from(b.tooltip):(0,w.isString)(b.tooltip)?h=b.tooltip:C.MarkdownString.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=R.MarkdownString.from(b.detail)):(0,w.isString)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=b.detail),{...b,id:b.id??void 0,handle:S,source:m,command:g.command?v.toInternal(g.command,f):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:h,accessibilityInformation:g.accessibilityInformation}}}}f(m){if(this.b.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this.a.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this.b.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this.c.values())f.get(m.id)?.clear();this.b.delete(m.id),this.a.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=T;function O(I){return I?.toString()}}),define(De[226],Ce([1,0,7,13,2,5]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(w){this.c=new Map,this.b=w.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,T,O,I){if(this.c.has(T))throw new Error(`Opener with id '${T}' already registered`);const m=I.schemes.find(v=>!C.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(T,O),this.b.$registerUriOpener(T,I.schemes,w,I.label),(0,i.toDisposable)(()=>{this.c.delete(T),this.b.$unregisterUriOpener(T)})}async $canOpenUri(w,T,O){const I=this.c.get(w);if(!I)throw new Error(`Unknown opener with id: ${w}`);const m=y.URI.revive(T);return I.canOpenExternalUri(m,O)}async $openUri(w,T,O){const I=this.c.get(w);if(!I)throw new Error(`Unknown opener id: '${w}'`);return I.openExternalUri(y.URI.revive(T.resolvedUri),{sourceUri:y.URI.revive(T.sourceUri)},O)}}e.ExtHostUriOpeners=C,C.a=new Set([k.Schemas.http,k.Schemas.https])}),define(De[227],Ce([1,0,5,2,7,11,26]),function(te,e,i,k,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(T){this.c=new Set,this.d=new Map,this.b=T.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(T,O){if(this.c.has(C.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const I=R.a++;return this.c.add(C.ExtensionIdentifier.toKey(T)),this.d.set(I,O),this.b.$registerUriHandler(I,T),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(T)),this.d.delete(I),this.b.$unregisterUriHandler(I)})}$handleExternalUri(T,O){const I=this.d.get(T);if(!I)return Promise.resolve(void 0);try{I.handleUri(k.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(T){return k.URI.revive(await this.b.$createAppUri(T))}}e.ExtHostUrls=R,R.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[58],Ce([1,0,4,13,23,2,149,169,68,5]),function(te,e,i,k,y,M,C,R,w,T){"use strict";var O,I,m,v,f,t,o,u,g,E,b,S,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(L,q,K,j,P,N,F){O.set(this,void 0),I.set(this,void 0),m.set(this,void 0),v.set(this,void 0),f.set(this,void 0),t.set(this,void 0),o.set(this,""),u.set(this,void 0),g.set(this,!1),E.set(this,!1),b.set(this,void 0),S.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new i.Emitter),this._onDidDispose=Re(this,s,"f").event,Je(this,O,L,"f"),Je(this,I,q,"f"),Je(this,u,K,"f"),Je(this,v,j,"f"),Je(this,f,P,"f"),Je(this,t,N,"f"),Je(this,b,a(N),"f"),Je(this,S,h(N),"f"),Je(this,m,F,"f")}dispose(){Je(this,g,!0,"f"),Re(this,s,"f").fire(),Re(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,E,!0,"f"),(0,w.asWebviewUri)(L,Re(this,v,"f"))}get cspSource(){const L=Re(this,t,"f").extensionLocation;if(L.scheme===k.Schemas.https||L.scheme===k.Schemas.http){let q=L.toString();return q.endsWith("/")||(q+="/"),q+" "+w.webviewGenericCspSource}return w.webviewGenericCspSource}get html(){return this.a(),Re(this,o,"f")}set html(L){this.a(),Re(this,o,"f")!==L&&(Je(this,o,L,"f"),Re(this,S,"f")&&!Re(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,E,!0,"f"),Re(this,m,"f").report("Webview vscode-resource: uris",Re(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,I,"f").$setHtml(Re(this,O,"f"),this.b(L)))}get options(){return this.a(),Re(this,u,"f")}set options(L){this.a(),y.equals(Re(this,u,"f"),L)||Re(this,I,"f").$setOptions(Re(this,O,"f"),n(Re(this,t,"f"),Re(this,f,"f"),L)),Je(this,u,L,"f")}async postMessage(L){if(Re(this,g,"f"))return!1;const q=(0,R.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Re(this,b,"f")});return Re(this,I,"f").$postMessage(Re(this,O,"f"),q.message,...q.buffers)}a(){if(Re(this,g,"f"))throw new Error("Webview is disposed")}b(L){if(!Re(this,S,"f"))return L;const q=Re(this,t,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,K=Re(this,t,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Re(this,t,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,P,N,F,$,z)=>{const V=M.URI.from({scheme:F||"file",path:decodeURIComponent($)}),X=(0,w.asWebviewUri)(V,{isRemote:q,authority:K}).toString();return`${P}${X}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,P,N,F,$,z)=>{const V=M.URI.from({scheme:F||"file",path:decodeURIComponent($)}),X=(0,w.asWebviewUri)(V,{isRemote:q,authority:K}).toString();return`${P}${X}${z}`})}}e.ExtHostWebview=r,O=new WeakMap,I=new WeakMap,m=new WeakMap,v=new WeakMap,f=new WeakMap,t=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap,E=new WeakMap,b=new WeakMap,S=new WeakMap,s=new WeakMap;function a(A){try{const L=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function h(A){try{const L=(0,C.normalizeVersion)((0,C.parseVersion)(A.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class c{constructor(L,q,K,j,P){this.c=q,this.d=K,this.e=j,this.f=P,this.b=new Map,this.a=L.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(L,q,K){const j=this.g(L);if(j){const{message:P}=(0,R.deserializeWebviewMessage)(q,K.value);j._onMessageEmitter.fire(P)}}$onMissingCsp(L,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,q,K){const j=new r(L,this.a,l(q),this.c,this.d,K,this.f);return this.b.set(L,j),j._onDidDispose(()=>{this.b.delete(L)}),j}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=c;function d(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=d;function n(A,L,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||p(A,L)}}e.serializeWebviewOptions=n;function l(A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,enableForms:A.enableForms,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots?.map(L=>M.URI.from(L))}}function p(A,L){return[...(L?.getWorkspaceFolders()||[]).map(q=>q.uri),A.extensionLocation]}}),define(De[228],Ce([1,0,20,223,7,13,22,2,8,58,50,5,6]),function(te,e,i,k,y,M,C,R,w,T,O,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(r,a){this.document=r,this.b=a,this.a=1,this.c=new O.Cache("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,a){await this.f(r).undo(),a||this.disposeBackup()}async redo(r,a){await this.f(r).redo(),a||this.disposeBackup()}disposeEdits(r){for(const a of r)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=S(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const a=this.c.get(r,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this.a=new Map}get(r,a){return this.a.get(this.b(r,a))}add(r,a,h){const c=this.b(r,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${a.uri}`);const d=new v(a,h);return this.a.set(c,d),d}delete(r,a){const h=this.b(r,a.uri);this.a.delete(h)}b(r,a){return`${r}@@@${a}`}}var t;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(t||(t={}));class o{constructor(){this.a=new Map}addTextProvider(r,a,h){return this.b(0,r,a,h)}addCustomProvider(r,a,h){return this.b(1,r,a,h)}get(r){return this.a.get(r)}b(r,a,h,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:r,extension:h,provider:c}),new m.Disposable(()=>this.a.delete(a))}}class u{constructor(r,a,h,c,d){this.d=a,this.f=h,this.g=c,this.h=d,this.b=new o,this.c=new f,this.a=r.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,a,h,c){const d=new y.DisposableStore;return E(h)?(d.add(this.b.addTextProvider(a,r,h)),this.a.$registerTextEditorProvider((0,T.toExtensionData)(r),a,c.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(r))):(d.add(this.b.addCustomProvider(a,r,h)),g(h)&&d.add(h.onDidChangeCustomDocument(n=>{const l=this.i(a,n.document.uri);if(b(n)){const p=l.addEdit(n);this.a.$onDidEdit(n.document.uri,a,p,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,T.toExtensionData)(r),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(r))),m.Disposable.from(d,new m.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(r,a,h,c,d){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const l=R.URI.revive(r),p=await n.provider.openCustomDocument(l,{backupId:h,untitledDocumentData:c?.buffer},d);let A;return g(n.provider)&&this.f&&(A=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,p,A),{editable:g(n.provider)}}async $disposeCustomDocument(r,a){const h=this.b.get(a);if(!h)throw new Error(`No provider found for '${a}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=R.URI.revive(r),{document:d}=this.i(a,c);this.c.delete(a,d),d.dispose()}async $resolveWebviewEditor(r,a,h,c,d,n){const l=this.b.get(h);if(!l)throw new Error(`No provider found for '${h}'`);const p=w.ViewColumn.to(d),A=this.g.createNewWebview(a,c.contentOptions,l.extension),L=this.h.createNewWebviewPanel(a,h,c.title,p,c.options,A,!0),q=R.URI.revive(r);switch(l.type){case 1:{const{document:K}=this.i(h,q);return l.provider.resolveCustomEditor(K,L,n)}case 0:{const K=this.d.getDocument(q);return l.provider.resolveCustomTextEditor(K,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,a,h){this.i(a,r).disposeEdits(h)}async $onMoveCustomEditor(r,a,h){const c=this.b.get(h);if(!c)throw new Error(`No provider found for '${h}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const d=this.h.getWebviewPanel(r);if(!d)throw new Error("No webview found");const n=R.URI.revive(a),l=this.d.getDocument(n);await c.provider.moveCustomTextEditor(l,d,i.CancellationToken.None)}async $undo(r,a,h,c){return this.i(a,r).undo(h,c)}async $redo(r,a,h,c){return this.i(a,r).redo(h,c)}async $revert(r,a,h){const c=this.i(a,r);await this.j(a).revertCustomDocument(c.document,h),c.disposeBackup()}async $onSave(r,a,h){const c=this.i(a,r);await this.j(a).saveCustomDocument(c.document,h),c.disposeBackup()}async $onSaveAs(r,a,h,c){const d=this.i(a,r);return this.j(a).saveCustomDocumentAs(d.document,R.URI.revive(h),c)}async $backup(r,a,h){const c=this.i(a,r),n=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},h);return c.updateBackup(n),n.id}i(r,a){const h=this.c.get(r,R.URI.revive(a));if(!h)throw new Error("No custom document found");return h}j(r){const h=this.b.get(r)?.provider;if(!h||!g(h))throw new Error("Custom document is not editable");return h}}e.ExtHostCustomEditors=u;function g(s){return!!s.onDidChangeCustomDocument}function E(s){return typeof s.resolveCustomTextEditor=="function"}function b(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function S(s){const r=s.scheme===M.Schemas.file||s.scheme===M.Schemas.untitled?s.fsPath:s.toString();return(0,k.hash)(r)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[229],Ce([1,0,4,7,2,34,8,58,5,6]),function(te,e,i,k,y,M,C,R,w,T){"use strict";var O,I,m,v,f,t,o,u,g,E,b,S,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends k.Disposable{constructor(d,n,l,p){super(),O.set(this,void 0),I.set(this,void 0),m.set(this,void 0),v.set(this,void 0),f.set(this,void 0),t.set(this,void 0),o.set(this,void 0),u.set(this,void 0),g.set(this,!0),E.set(this,void 0),b.set(this,!1),S.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,S,"f").event,s.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Re(this,s,"f").event,Je(this,O,d,"f"),Je(this,I,n,"f"),Je(this,v,l,"f"),Je(this,m,p.viewType,"f"),Je(this,f,p.panelOptions,"f"),Je(this,u,p.viewColumn,"f"),Je(this,t,p.title,"f"),Je(this,E,p.active,"f")}dispose(){Re(this,b,"f")||(Je(this,b,!0,"f"),Re(this,S,"f").fire(),Re(this,I,"f").$disposeWebview(Re(this,O,"f")),Re(this,v,"f").dispose(),super.dispose())}get webview(){return this.c(),Re(this,v,"f")}get viewType(){return this.c(),Re(this,m,"f")}get title(){return this.c(),Re(this,t,"f")}set title(d){this.c(),Re(this,t,"f")!==d&&(Je(this,t,d,"f"),Re(this,I,"f").$setTitle(Re(this,O,"f"),d))}get iconPath(){return this.c(),Re(this,o,"f")}set iconPath(d){this.c(),Re(this,o,"f")!==d&&(Je(this,o,d,"f"),Re(this,I,"f").$setIconPath(Re(this,O,"f"),y.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Re(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Re(this,u,"f")=="number"&&Re(this,u,"f")<0))return Re(this,u,"f")}get active(){return this.c(),Re(this,E,"f")}get visible(){return this.c(),Re(this,g,"f")}_updateViewState(d){Re(this,b,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Je(this,E,d.active,"f"),Je(this,g,d.visible,"f"),Je(this,u,d.viewColumn,"f"),Re(this,s,"f").fire({webviewPanel:this}))}reveal(d,n){this.c(),Re(this,I,"f").$reveal(Re(this,O,"f"),{viewColumn:typeof d>"u"?void 0:C.ViewColumn.from(d),preserveFocus:!!n})}c(){if(Re(this,b,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,I=new WeakMap,m=new WeakMap,v=new WeakMap,f=new WeakMap,t=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap,E=new WeakMap,b=new WeakMap,S=new WeakMap,s=new WeakMap;class a{static c(){return(0,M.generateUuid)()}constructor(d,n,l){this.g=n,this.h=l,this.e=new Map,this.f=new Map,this.d=d.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,n,l,p,A={}){const L=typeof p=="object"?p.viewColumn:p,q={viewColumn:C.ViewColumn.from(L),preserveFocus:typeof p=="object"&&!!p.preserveFocus},K=(0,R.shouldSerializeBuffersForPostMessage)(d),j=a.c();this.d.$createWebviewPanel((0,R.toExtensionData)(d),j,n,{title:l,panelOptions:h(A),webviewOptions:(0,R.serializeWebviewOptions)(d,this.h,A),serializeBuffersForPostMessage:K},q);const P=this.g.createNewWebview(j,A,d);return this.createNewWebviewPanel(j,n,l,L,A,P,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((l,p)=>{const A=d[l],L=d[p];return A.active?1:L.active?-1:+A.visible-+L.visible});for(const l of n){const p=this.getWebviewPanel(l);if(!p)continue;const A=d[l];p._updateViewState({active:A.active,visible:A.visible,viewColumn:C.ViewColumn.to(A.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.e.delete(d),this.g.deleteWebview(d)}registerWebviewPanelSerializer(d,n,l){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:l,extension:d}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(d)}),new T.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,l,p){const A=this.f.get(n);if(!A)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:q}=A,K=this.g.createNewWebview(d,l.webviewOptions,q),j=this.createNewWebviewPanel(d,n,l.title,p,l.panelOptions,K,l.active);await L.deserializeWebviewPanel(j,l.state)}createNewWebviewPanel(d,n,l,p,A,L,q){const K=new r(d,this.d,L,{viewType:n,title:l,viewColumn:p,panelOptions:A,active:q});return this.e.set(d,K),K}getWebviewPanel(d){return this.e.get(d)}}e.ExtHostWebviewPanels=a;function h(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[230],Ce([1,0,4,7,58,8,5,6]),function(te,e,i,k,y,M,C,R){"use strict";var w,T,O,I,m,v,f,t,o,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends k.Disposable{constructor(s,r,a,h,c,d){super(),w.set(this,void 0),T.set(this,void 0),O.set(this,void 0),I.set(this,void 0),m.set(this,!1),v.set(this,void 0),f.set(this,void 0),t.set(this,void 0),o.set(this,void 0),u.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Re(this,u,"f").event,g.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,g,"f").event,Je(this,O,a,"f"),Je(this,f,h,"f"),Je(this,w,s,"f"),Je(this,T,r,"f"),Je(this,I,c,"f"),Je(this,v,d,"f")}dispose(){Re(this,m,"f")||(Je(this,m,!0,"f"),Re(this,g,"f").fire(),Re(this,I,"f").dispose(),super.dispose())}get title(){return this.a(),Re(this,f,"f")}set title(s){this.a(),Re(this,f,"f")!==s&&(Je(this,f,s,"f"),Re(this,T,"f").$setWebviewViewTitle(Re(this,w,"f"),s))}get description(){return this.a(),Re(this,t,"f")}set description(s){this.a(),Re(this,t,"f")!==s&&(Je(this,t,s,"f"),Re(this,T,"f").$setWebviewViewDescription(Re(this,w,"f"),s))}get visible(){return Re(this,v,"f")}get webview(){return Re(this,I,"f")}get viewType(){return Re(this,O,"f")}_setVisible(s){s===Re(this,v,"f")||Re(this,m,"f")||(Je(this,v,s,"f"),Re(this,u,"f").fire())}get badge(){return this.a(),Re(this,o,"f")}set badge(s){this.a(),!(s?.value===Re(this,o,"f")?.value&&s?.tooltip===Re(this,o,"f")?.tooltip)&&(Je(this,o,M.ViewBadge.from(s),"f"),Re(this,T,"f").$setWebviewViewBadge(Re(this,w,"f"),s))}show(s){this.a(),Re(this,T,"f").$show(Re(this,w,"f"),!!s)}a(){if(Re(this,m,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,T=new WeakMap,O=new WeakMap,I=new WeakMap,m=new WeakMap,v=new WeakMap,f=new WeakMap,t=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap;class b{constructor(s,r){this.d=r,this.b=new Map,this.c=new Map,this.a=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,r,a,h){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:a,extension:s}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(s),r,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(s)}),new R.Disposable(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(s,r,a,h,c){const d=this.b.get(r);if(!d)throw new Error(`No view provider found for '${r}'`);const{provider:n,extension:l}=d,p=this.d.createNewWebview(s,{},l),A=new E(s,this.a,r,a,p,!0);this.c.set(s,A),await n.resolveWebviewView(A,{state:h},c)}async $onDidChangeWebviewViewVisibility(s,r){this.e(s)._setVisible(r)}async $disposeWebviewView(s){const r=this.e(s);this.c.delete(s),r.dispose(),this.d.deleteWebview(s)}e(s){const r=this.c.get(s);if(!r)throw new Error("No webview found");return r}}e.ExtHostWebviewViews=b}),define(De[100],Ce([1,0,4,5,2,13,10,3,14]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class nn{get state(){return this.d}constructor(I){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=nn.a,this.b=I.getProxy(k.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(I){I!==this.d.focused&&(this.d={...this.d,focused:I},this.c.fire(this.d))}openUri(I,m){let v;if(typeof I=="string"){v=I;try{I=y.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,C.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this.b.$openUri(I,v,m)}async asExternalUri(I,m){if((0,C.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(I,m);return y.URI.from(v)}};T.a={focused:!0},T=qe([Ve(0,w.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(De[231],Ce([1,0,200,27,14]),function(te,e,i,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends i.AbstractExtHostConsoleForwarder{constructor(R,w){super(R,w)}f(R,w,T){w.apply(console,T)}};M=qe([Ve(0,y.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(De[232],Ce([1,0,15,24,20,11,4,7,122,194,43]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(A,L){try{return JSON.stringify(A,L)}catch{return"null"}}const v="$$ref$$",f={[v]:-1};class t{constructor(L,q){this.jsonString=L,this.referencedBuffers=q}}function o(A,L=null,q=!1){const K=[];return{jsonString:(q?m:JSON.stringify)(A,(P,N)=>{if(typeof N>"u")return f;if(typeof N=="object"){if(N instanceof k.VSBuffer){const F=K.push(N)-1;return{[v]:F}}if(L)return L(P,N)}return N}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=o;function u(A,L,q){return JSON.parse(A,(K,j)=>{if(j){const P=j[v];if(typeof P=="number")return L[P];if(q&&j.$mid===1)return q.transformIncoming(j)}return j})}e.parseJsonAndRestoreBufferRefs=u;function g(A,L){return JSON.stringify(A,L)}function E(A){return A?(L,q)=>q&&q.$mid===1?A.transformOutgoing(q):q:null}var b;(function(A){A[A.LocalSide=0]="LocalSide",A[A.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(A){A[A.Responsive=0]="Responsive",A[A.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},r=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class h extends R.Disposable{constructor(L,q=null,K=null){super(),this[I]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=q,this.g=K,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let j=0,P=O.ProxyIdentifier.count;j<P;j++)this.k[j]=null,this.l[j]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.D(),1e3)),this.c.onMessage(j=>this.H(j))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+h.a),this.u++,this.w.isScheduled()||this.w.schedule()}C(L){this.v=Date.now()+h.a,this.u--,this.u===0&&this.w.cancel(),this.F(0)}D(){this.u!==0&&(Date.now()>this.v?this.F(1):this.w.schedule())}F(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,w.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:q,sid:K}=L;return this.l[q]||(this.l[q]=this.G(q,K)),this.l[q]}G(L,q){const K={get:(j,P)=>(typeof P=="string"&&!j[P]&&P.charCodeAt(0)===36&&(j[P]=(...N)=>this.P(L,P,N)),P===a?q:j[P])};return new Proxy(Object.create(null),K)}set(L,q){return this.k[L.nid]=q,q}assertRegistered(L){for(let q=0,K=L.length;q<K;q++){const j=L[q];if(!this.k[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}H(L){if(this.j)return;const q=L.byteLength,K=c.read(L,0),j=K.readUInt8(),P=K.readUInt32();switch(j){case 1:case 2:{let{rpcId:N,method:F,args:$}=n.deserializeRequestJSONArgs(K);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.I(q,P,N,F,$,j===2);break}case 3:case 4:{let{rpcId:N,method:F,args:$}=n.deserializeRequestMixedArgs(K);this.g&&($=(0,w.transformIncomingURIs)($,this.g)),this.I(q,P,N,F,$,j===4);break}case 5:{this.f?.logIncoming(q,P,0,"ack"),this.C(P);break}case 6:{this.J(q,P);break}case 7:{this.L(q,P,void 0);break}case 9:{let N=n.deserializeReplyOKJSON(K);this.g&&(N=(0,w.transformIncomingURIs)(N,this.g)),this.L(q,P,N);break}case 10:{const N=n.deserializeReplyOKJSONWithBuffers(K,this.g);this.L(q,P,N);break}case 8:{const N=n.deserializeReplyOKVSBuffer(K);this.L(q,P,N);break}case 11:{let N=n.deserializeReplyErrError(K);this.g&&(N=(0,w.transformIncomingURIs)(N,this.g)),this.M(q,P,N);break}case 12:{this.M(q,P,void 0);break}default:console.error("received unexpected message"),console.error(L)}}I(L,q,K,j,P,N){this.f?.logIncoming(L,q,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(K)}.${j}(`,P);const F=String(q);let $,z;if(N){const X=new y.CancellationTokenSource;P.push(X.token),$=this.N(K,j,P),z=()=>X.cancel()}else $=this.N(K,j,P),z=s;this.p[F]=z;const V=n.serializeAcknowledged(q);this.f?.logOutgoing(V.byteLength,q,1,"ack"),this.c.send(V),$.then(X=>{delete this.p[F];const ee=n.serializeReplyOK(q,X,this.h);this.f?.logOutgoing(ee.byteLength,q,1,"reply:",X),this.c.send(ee)},X=>{delete this.p[F];const ee=n.serializeReplyErr(q,X);this.f?.logOutgoing(ee.byteLength,q,1,"replyErr:",X),this.c.send(ee)})}J(L,q){this.f?.logIncoming(L,q,1,"receiveCancel");const K=String(q);this.p[K]?.()}L(L,q,K){this.f?.logIncoming(L,q,0,"receiveReply:",K);const j=String(q);if(!this.s.hasOwnProperty(j))return;const P=this.s[j];delete this.s[j],P.resolveOk(K)}M(L,q,K){this.f?.logIncoming(L,q,0,"receiveReplyErr:",K);const j=String(q);if(!this.s.hasOwnProperty(j))return;const P=this.s[j];delete this.s[j];let N;K&&(K.$isError?(N=new Error,N.name=K.name,N.message=K.message,N.stack=K.stack):N=K),P.resolveErr(N)}N(L,q,K){try{return Promise.resolve(this.O(L,q,K))}catch(j){return Promise.reject(j)}}O(L,q,K){const j=this.k[L];if(!j)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(L));const P=j[q];if(typeof P!="function")throw new Error("Unknown method "+q+" on actor "+(0,O.getStringIdentifierForProxy)(L));return P.apply(j,K)}P(L,q,K){if(this.j)return new T.CanceledLazyPromise;let j=null;if(K.length>0&&y.CancellationToken.isCancellationToken(K[K.length-1])&&(j=K.pop()),j&&j.isCancellationRequested)return Promise.reject(M.canceled());const P=n.serializeRequestArguments(K,this.h),N=++this.m,F=String(N),$=new T.LazyPromise;j&&j.onCancellationRequested(()=>{const V=n.serializeCancel(N);this.f?.logOutgoing(V.byteLength,N,0,"cancel"),this.c.send(n.serializeCancel(N))}),this.s[F]=$,this.y(N);const z=n.serializeRequest(N,L,q,P,!!j);return this.f?.logOutgoing(z.byteLength,N,0,`request: ${(0,O.getStringIdentifierForProxy)(L)}.${q}(`,K),this.c.send(z),$}}e.RPCProtocol=h,I=r,h.a=3*1e3;class c{static alloc(L,q,K){const j=new c(k.VSBuffer.alloc(K+1+4),0);return j.writeUInt8(L),j.writeUInt32(q),j}static read(L,q){return new c(L,q)}get buffer(){return this.a}constructor(L,q){this.a=L,this.b=q}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+L).toString();return this.b+=L,K}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+L);return this.b+=L,q}static sizeMixedArray(L){let q=0;q+=1;for(let K=0,j=L.length;K<j;K++){const P=L[K];switch(q+=1,P.type){case 1:q+=this.sizeLongString(P.value);break;case 2:q+=this.sizeVSBuffer(P.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(P.value);for(let N=0;N<P.buffers.length;++N)q+=this.sizeVSBuffer(P.buffers[N]);break;case 4:break}}return q}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let q=0,K=L.length;q<K;q++){const j=L[q];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let P=0;P<j.buffers.length;++P)this.writeBuffer(j.buffers[P]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const q=new Array(L);for(let K=0;K<L;K++)switch(this.readUInt8()){case 1:q[K]=this.readLongString();break;case 2:q[K]=this.readVSBuffer();break;case 3:{const P=this.readUInt32(),N=this.readLongString(),F=[];for(let $=0;$<P;++$)F.push(this.readVSBuffer());q[K]=new O.SerializableObjectWithBuffers(u(N,F,null));break}case 4:q[K]=void 0;break}return q}}c.sizeUInt32=4;var d;(function(A){A[A.Simple=0]="Simple",A[A.Mixed=1]="Mixed"})(d||(d={}));class n{static a(L){for(let q=0,K=L.length;q<K;q++)if(L[q]instanceof k.VSBuffer||L[q]instanceof O.SerializableObjectWithBuffers||typeof L[q]>"u")return!0;return!1}static serializeRequestArguments(L,q){if(this.a(L)){const K=[];for(let j=0,P=L.length;j<P;j++){const N=L[j];if(N instanceof k.VSBuffer)K[j]={type:2,value:N};else if(typeof N>"u")K[j]={type:4};else if(N instanceof O.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:$}=o(N.value,q);K[j]={type:3,value:k.VSBuffer.fromString(F),buffers:$}}else K[j]={type:1,value:k.VSBuffer.fromString(g(N,q))}}return{type:1,args:K}}return{type:0,args:g(L,q)}}static serializeRequest(L,q,K,j,P){switch(j.type){case 0:return this.b(L,q,K,j.args,P);case 1:return this.c(L,q,K,j.args,P)}}static b(L,q,K,j,P){const N=k.VSBuffer.fromString(K),F=k.VSBuffer.fromString(j);let $=0;$+=c.sizeUInt8(),$+=c.sizeShortString(N),$+=c.sizeLongString(F);const z=c.alloc(P?2:1,L,$);return z.writeUInt8(q),z.writeShortString(N),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(L){const q=L.readUInt8(),K=L.readShortString(),j=L.readLongString();return{rpcId:q,method:K,args:JSON.parse(j)}}static c(L,q,K,j,P){const N=k.VSBuffer.fromString(K);let F=0;F+=c.sizeUInt8(),F+=c.sizeShortString(N),F+=c.sizeMixedArray(j);const $=c.alloc(P?4:3,L,F);return $.writeUInt8(q),$.writeShortString(N),$.writeMixedArray(j),$.buffer}static deserializeRequestMixedArgs(L){const q=L.readUInt8(),K=L.readShortString(),j=L.readMixedArray(),P=new Array(j.length);for(let N=0,F=j.length;N<F;N++){const $=j[N];typeof $=="string"?P[N]=JSON.parse($):P[N]=$}return{rpcId:q,method:K,args:P}}static serializeAcknowledged(L){return c.alloc(5,L,0).buffer}static serializeCancel(L){return c.alloc(6,L,0).buffer}static serializeReplyOK(L,q,K){if(typeof q>"u")return this.d(L);if(q instanceof k.VSBuffer)return this.e(L,q);if(q instanceof O.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:P}=o(q.value,K,!0);return this.g(L,j,P)}else return this.f(L,m(q,K))}static d(L){return c.alloc(7,L,0).buffer}static e(L,q){let K=0;K+=c.sizeVSBuffer(q);const j=c.alloc(8,L,K);return j.writeVSBuffer(q),j.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,q){const K=k.VSBuffer.fromString(q);let j=0;j+=c.sizeLongString(K);const P=c.alloc(9,L,j);return P.writeLongString(K),P.buffer}static g(L,q,K){const j=k.VSBuffer.fromString(q);let P=0;P+=c.sizeUInt32,P+=c.sizeLongString(j);for(const F of K)P+=c.sizeVSBuffer(F);const N=c.alloc(10,L,P);N.writeUInt32(K.length),N.writeLongString(j);for(const F of K)N.writeBuffer(F);return N.buffer}static deserializeReplyOKJSON(L){const q=L.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(L,q){const K=L.readUInt32(),j=L.readLongString(),P=[];for(let N=0;N<K;++N)P.push(L.readVSBuffer());return new O.SerializableObjectWithBuffers(u(j,P,q))}static serializeReplyErr(L,q){const K=q?m(M.transformErrorForSerialization(q),null):void 0;if(typeof K!="string")return this.h(L);const j=k.VSBuffer.fromString(K);let P=0;P+=c.sizeLongString(j);const N=c.alloc(11,L,P);return N.writeLongString(j),N.buffer}static deserializeReplyErrError(L){const q=L.readLongString();return JSON.parse(q)}static h(L){return c.alloc(12,L,0).buffer}}var l;(function(A){A[A.RequestJSONArgs=1]="RequestJSONArgs",A[A.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",A[A.RequestMixedArgs=3]="RequestMixedArgs",A[A.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",A[A.Acknowledged=5]="Acknowledged",A[A.Cancel=6]="Cancel",A[A.ReplyOKEmpty=7]="ReplyOKEmpty",A[A.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",A[A.ReplyOKJSON=9]="ReplyOKJSON",A[A.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",A[A.ReplyErrError=11]="ReplyErrError",A[A.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var p;(function(A){A[A.String=1]="String",A[A.VSBuffer=2]="VSBuffer",A[A.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",A[A.Undefined=4]="Undefined"})(p||(p={}))}),define(De[233],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(M){const C=R=>{self.removeEventListener("message",C);const w=R.data;Object.defineProperties(self,{postMessage:{value(T,O){w.postMessage(T,O)}},onmessage:{get(){return w.onmessage},set(T){w.onmessage=T}}}),w.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),w.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",C)}.toString();class k extends EventTarget{constructor(M,C,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const w=`((${i})('${C}'))`,T=new Blob([w],{type:"application/javascript"}),O=URL.createObjectURL(T),I=new MessageChannel,m=O,v={type:"_newWorker",id:m,port:I.port2,url:O,options:R};M(v,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(f){I.port1.onmessage=f}},onmessageerror:{get(){return I.port1.onmessageerror},set(f){I.port1.onmessageerror=f}}}),I.port1.addEventListener("messageerror",f=>{const t=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(t)}),I.port1.addEventListener("message",f=>{const t=new MessageEvent("message",{data:f.data});this.dispatchEvent(t)}),I.port1.start()}}e.NestedWorker=k}),define(De[234],Ce([1,0,4,30,41,3,36,11,15]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var T;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(T=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(t=>f.push(t)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}k.Registry.add(e.Extensions.OutputChannels,new O);function I(v,f,t,o,u){return(0,w.createCancelablePromise)(async g=>{await(0,C.whenProviderRegistered)(t,o);const E=k.Registry.as(e.Extensions.OutputChannels);try{await m(t,1,o,u,g),E.registerChannel({id:v,label:f,file:t,log:!0})}catch(b){(0,R.isCancellationError)(b)||u.error("Error while registering log channel",t.toString(),(0,R.getErrorMessage)(b))}})}e.registerLogChannel=I;async function m(v,f,t,o,u){if(!await t.exists(v)){if(u.isCancellationRequested)throw new R.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",v.toString()),await(0,w.timeout)(1e3,u),await m(v,f+1,t,o,u)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(De[101],Ce([1,0,5,3,14,26,12,234,56,27,37,115,24,9,36,4,7]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends C.AbstractMessageLogger{get disposed(){return this.k}constructor(S,s,r,a,h){super(),this.id=S,this.name=s,this.l=r,this.m=a,this.extension=h,this.j=0,this.k=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(S){this.append(S+`
`)}append(S){this.info(S)}clear(){const S=this.j;this.l.flush(),this.m.$update(this.id,R.OutputChannelUpdateMode.Clear,S)}replace(S){const s=this.j;this.info(S),this.m.$update(this.id,R.OutputChannelUpdateMode.Replace,s),this.visible&&this.l.flush()}show(S,s){this.l.flush(),this.m.$reveal(this.id,!!(typeof S=="boolean"?S:s))}hide(){this.m.$close(this.id)}f(S,s){this.j+=m.VSBuffer.fromString(s).byteLength,(0,C.log)(this.l,S,s),this.visible&&(this.l.flush(),this.m.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.k||(this.m.$dispose(this.id),this.k=!0)}}class g extends u{appendLine(S){this.append(S)}}let E=class{constructor(S,s,r,a,h,c){this.i=s,this.j=r,this.k=a,this.l=h,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=S.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(S){this.h=S;for(const[s,r]of this.g)r.visible=s===this.h}createOutputChannel(S,s,r){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const a=typeof s=="object"&&s.log,h=(0,v.isString)(s)?s:void 0;if((0,v.isString)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const d=this.i.environment.extensionLogLevel?.find(([l])=>M.ExtensionIdentifier.equals(r.identifier,l))?.[1];d&&(c=(0,C.parseLogLevel)(d));const n=a?this.o(S,c,r):this.n(S,h,r);return n.then(l=>{this.g.set(l.id,l),l.visible=l.id===this.h}),a?this.r(S,c??this.m.getLevel(),n):this.q(S,n)}async n(S,s,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,h=this.k.extUri.joinPath(a,`${this.f++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.a.$register(S,h,!1,s,r.identifier.value);return new u(d,S,c,this.a,r)}async o(S,s,r){const a=await this.p(r),h=this.k.extUri.joinPath(a,`${S.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(h,{name:S},s),d=await this.a.$register(S,h,!0,void 0,r.identifier.value);return new g(d,S,c,this.a,r)}p(S){let s=this.d.get(S.identifier.value);if(!s){const r=this.k.extUri.joinPath(this.i.logsLocation,S.identifier.value);this.d.set(S.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(r)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return r})())}return s}q(S,s){let r=!1;const a=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return S},append(h){a(),s.then(c=>c.append(h))},appendLine(h){a(),s.then(c=>c.appendLine(h))},clear(){a(),s.then(h=>h.clear())},replace(h){a(),s.then(c=>c.replace(h))},show(h,c){a(),s.then(d=>d.show(h,c))},hide(){a(),s.then(h=>h.hide())},dispose(){r=!0,s.then(h=>h.dispose())}}}r(S,s,r){const a=new o.DisposableStore,h=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new t.Emitter);return r.then(d=>{a.add(d),a.add(d.onDidChangeLogLevel(n=>{s=n,c.fire(n)}))}),{...this.q(S,r),get logLevel(){return s},onDidChangeLogLevel:c.event,trace(d,...n){h(),r.then(l=>l.trace(d,...n))},debug(d,...n){h(),r.then(l=>l.debug(d,...n))},info(d,...n){h(),r.then(l=>l.info(d,...n))},warn(d,...n){h(),r.then(l=>l.warn(d,...n))},error(d,...n){h(),r.then(l=>l.error(d,...n))},dispose(){a.dispose()}}}};E=qe([Ve(0,y.IExtHostRpcService),Ve(1,T.IExtHostInitDataService),Ve(2,w.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,C.ILoggerService),Ve(5,C.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(De[235],Ce([1,0,3]),function(te,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(De[236],Ce([1,0,39,13,19,21,22,2,3,165,49,180,235]),function(te,e,i,k,y,M,C,R,w,T,O,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let v=class rn{constructor(t,o,u,g){this.d=t,this.e=o,this.f=u,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,o,u){return typeof o=="string"||typeof o>"u"?this.a.then(g=>this.h(t,g,o)):this.h(t,o,u)}h(t,o,u){return t.scheme===k.Schemas.file||t.scheme===k.Schemas.vscodeRemote?(0,i.isValidBasename)(u??(0,C.basename)(t),o===1):!0}get defaultUriScheme(){return rn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,o){if(t.remoteAuthority)return k.Schemas.vscodeRemote;const u=(0,T.getVirtualWorkspaceScheme)(o.getWorkspace());if(u)return u;const g=o.getWorkspace().folders[0];if(g)return g.uri.scheme;const E=o.getWorkspace().configuration;return E?E.scheme:k.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?y.win32:y.posix)}async fileURI(t){let o="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const g=t.indexOf("/",2);g===-1?(o=t.substring(2),t="/"):(o=t.substring(2,g),t=t.substring(g)||"/")}return R.URI.from({scheme:k.Schemas.file,authority:o,path:t,query:"",fragment:""})}};v=qe([Ve(1,m.IRemoteAgentService),Ve(2,I.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],v),e.AbstractPathService=v}),define(De[102],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(C,R){this.line=C,this.character=R}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,R){return new i(0,0)}with(C){return new i(0,0)}}e.Position=i;class k{constructor(C,R,w,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(C,R),this.end=new i(w,T)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new k(0,0,0,0)}with(C){return new k(0,0,0,0)}}e.Range=k;var y;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[44],Ce([1,0,16,35,23,39,10,3,19,11,102,15]),function(te,e,i,k,y,M,C,R,w,T,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",f=(m.length+v.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var t;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function u(oe){return!!oe.preview}e.resultIsMatch=u;function g(oe){return!!oe.resource}e.isFileMatch=g;function E(oe){return!!oe.message}e.isProgressMessage=E;var b;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=S;class s{constructor(ue,ce,he){this.ranges=ce;const Y=Array.isArray(ce)?ce:[ce];if(he&&he.matchLines===1&&r(Y)){ue=(0,C.getNLines)(ue,he.matchLines);let ge="",Se=0,Fe=0;const ze=Math.floor(he.charsPerLine/5),_e=[];for(const ke of Y){const Ie=Math.max(ke.startColumn-ze,0),Te=ke.startColumn+he.charsPerLine;if(Ie>Fe+ze+f){const re=m+(Ie-Fe)+v;ge+=re+ue.slice(Ie,Te),Se+=Ie-(Fe+re.length)}else ge+=ue.slice(Fe,Te);_e.push(new h(0,ke.startColumn-Se,ke.endColumn-Se)),Fe=Te}this.preview={text:ge,matches:Array.isArray(this.ranges)?_e:_e[0]}}else{const ge=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:ue,matches:(0,i.mapArrayOrNot)(ce,Se=>new a(Se.startLineNumber-ge,Se.startColumn,Se.endLineNumber-ge,Se.endColumn))}}}}e.TextSearchMatch=s;function r(oe){const ue=oe[0].startLineNumber;for(const ce of oe)if(ce.startLineNumber!==ue||ce.endLineNumber!==ue)return!1;return!0}class a{constructor(ue,ce,he,Y){this.startLineNumber=ue,this.startColumn=ce,this.endLineNumber=he,this.endColumn=Y}}e.SearchRange=a;class h extends a{constructor(ue,ce,he){super(ue,ce,ue,he)}}e.OneLineRange=h;var c;(function(oe){oe.List="list",oe.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var d;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function n(oe,ue=!0){const ce=oe&&oe.files&&oe.files.exclude,he=ue&&oe&&oe.search&&oe.search.exclude;if(!ce&&!he)return;if(!ce||!he)return ce||he;let Y=Object.create(null);return Y=y.mixin(Y,y.deepClone(ce)),Y=y.mixin(Y,y.deepClone(he),!0),Y}e.getExcludes=n;function l(oe,ue){return oe.excludePattern&&k.match(oe.excludePattern,ue)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&k.match(oe.includePattern,ue)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ce=>{const he=ce.folder.fsPath;if(M.isEqualOrParent(ue,he)){const Y=w.relative(he,ue);return!ce.includePattern||!!k.match(ce.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var p;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(ue,ce){super(ue),this.code=ce}}e.SearchError=A;function L(oe){const ue=oe.message;if((0,T.isCancellationError)(oe))return new A(ue,p.canceled);try{const ce=JSON.parse(ue);return new A(ce.message,ce.code)}catch{return new A(ue,p.other)}}e.deserializeSearchError=L;function q(oe){const ue={message:oe.message,code:oe.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=q;function K(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=K;function j(oe){return oe.type==="success"}e.isSerializedSearchSuccess=j;function P(oe){return!!oe.path}e.isSerializedFileMatch=P;function N(oe,ue){const ce=oe.searchPath?oe.searchPath:oe.relativePath;return(0,C.fuzzyContains)(ce,ue)}e.isFilePatternMatch=N;class F{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function $(oe,ue){const ce={...oe||{},...ue||{}};return Object.keys(ce).filter(he=>{const Y=ce[he];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=$;class z{constructor(ue,ce){this.c=null,this.a={...ue.excludePattern||{},...ce.excludePattern||{}},this.b=k.parse(this.a);let he=ue.includePattern;ce.includePattern&&(he?he={...he,...ce.includePattern}:he=ce.includePattern),he&&(this.c=k.parse(he))}matchesExcludesSync(ue,ce,he){return!!(this.b&&this.b(ue,ce,he))}includedInQuerySync(ue,ce,he){return!(this.b&&this.b(ue,ce,he)||this.c&&!this.c(ue,ce,he))}includedInQuery(ue,ce,he){const Y=this.b(ue,ce,he),ge=()=>this.c?!!this.c(ue,ce,he):!0;return(0,I.isThenable)(Y)?Y.then(Se=>Se?!1:ge()):ge()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=z;function V(oe){for(const ue in oe)if(typeof oe[ue]!="boolean")return!0;return!1}function X(oe){if(!oe)return;let ue;return ce=>(ue||(ue=(oe()||Promise.resolve([])).then(he=>he?fe(he):{})),ue.then(he=>!!he[ce]))}e.hasSiblingPromiseFn=X;function ee(oe){if(!oe)return;let ue;return ce=>{if(!ue){const he=oe();ue=he?fe(he):{}}return!!ue[ce]}}e.hasSiblingFn=ee;function fe(oe){const ue={};for(const ce of oe)ue[ce]=!0;return ue}}),define(De[31],Ce([1,0,16,15,20,4,7,46,13,109,22,10,9,2,139,3,12,154,49,37,27,14,8,6,51,44,5]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b,S,s,r,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(j,P,N){return new O.ExtUri(F=>A(F,N)).isEqual(j,P)}function n(j,P,N){return d(j.uri,P.uri,N)?0:(0,I.compare)(j.uri.toString(),P.uri.toString())}function l(j,P,N){return j.index!==P.index?j.index<P.index?-1:1:d(j.uri,P.uri,N)?(0,I.compare)(j.name,P.name):(0,I.compare)(j.uri.toString(),P.uri.toString())}function p(j,P,N,F){const $=j.slice(0).sort((V,X)=>N(V,X,F)),z=P.slice(0).sort((V,X)=>N(V,X,F));return(0,i.delta)($,z,(V,X)=>N(V,X,F))}function A(j,P){const N=P.getCapabilities(j.scheme);return!(N&&N&1024)}class L extends g.Workspace{static toExtHostWorkspace(P,N,F,$){if(!P)return{workspace:null,added:[],removed:[]};const{id:z,name:V,folders:X,configuration:ee,transient:fe,isUntitled:oe}=P,ue=[],ce=N;N?X.forEach((Se,Fe)=>{const ze=v.URI.revive(Se.uri),_e=L.e(F||N,ze,$);_e?(_e.name=Se.name,_e.index=Se.index,ue.push(_e)):ue.push({uri:ze,name:Se.name,index:Fe})}):ue.push(...X.map(({uri:Se,name:Fe,index:ze})=>({uri:v.URI.revive(Se),name:Fe,index:ze}))),ue.sort((Se,Fe)=>Se.index<Fe.index?-1:1);const he=new L(z,V,ue,!!fe,ee?v.URI.revive(ee):null,!!oe,Se=>A(Se,$)),{added:Y,removed:ge}=p(ce?ce.workspaceFolders:[],he.workspaceFolders,n,$);return{workspace:he,added:Y,removed:ge}}static e(P,N,F){for(let $=0;$<P.folders.length;$++){const z=P.workspaceFolders[$];if(d(z.uri,N,F))return z}}constructor(P,N,F,$,z,V,X){super(P,F.map(ee=>new g.WorkspaceFolder(ee)),$,z,X),this.s=N,this.t=V,this.o=[],this.q=R.TernarySearchTree.forUris(X),F.forEach(ee=>{this.o.push(ee),this.q.set(ee.uri,ee)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(P,N){return N&&this.q.get(P)&&(P=(0,O.dirname)(P)),this.q.findSubstr(P)}resolveWorkspaceFolder(P){return this.q.get(P)}}let q=class{constructor(P,N,F,$,z){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new M.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=$,this.q=F,this.s=z,this.h=new T.Counter,this.j=new k.Barrier,this.n=P.getProxy(c.MainContext.MainThreadWorkspace),this.o=P.getProxy(c.MainContext.MainThreadMessageService);const V=N.workspace;this.k=V?new L(V.id,V.name,[],!!V.transient,V.configuration?v.URI.revive(V.configuration):null,!!V.isUntitled,X=>A(X,F)):void 0}$initializeWorkspace(P,N){this.u=N,this.$acceptWorkspaceData(P),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?v.URI.from({scheme:w.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(P,N,F,...$){const z=[];if(Array.isArray($)&&$.forEach(oe=>{v.URI.isUri(oe.uri)&&!z.some(ue=>d(ue.uri,oe.uri,this.q))&&z.push({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri)})}),this.l||[N,F].some(oe=>typeof oe!="number"||oe<0)||F===0&&z.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(N+F>V.length)return!1;const X=V.slice(0);X.splice(N,F,...z.map(oe=>({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<X.length;oe++){const ue=X[oe];if(X.some((ce,he)=>he!==oe&&d(ue.uri,ce.uri,this.q)))return!1}X.forEach((oe,ue)=>oe.index=ue);const{added:ee,removed:fe}=p(V,X,l,this.q);if(ee.length===0&&fe.length===0)return!1;if(this.n){const oe=P.displayName||P.name;this.n.$updateWorkspaceFolders(oe,N,F,z).then(void 0,ue=>{this.l=void 0;const ce={source:{identifier:P.identifier,label:P.displayName||P.name}};this.o.$showMessage(u.Severity.Error,(0,f.localize)(0,null,oe,ue.toString()),ce,[])})}return this.x(X),!0}getWorkspaceFolder(P,N){if(!!this.w)return this.w.getWorkspaceFolder(P,N)}async getWorkspaceFolder2(P,N){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(P,N)}async resolveWorkspaceFolder(P){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(P)}getPath(){if(!this.w)return;const{folders:P}=this.w;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,N){let F,$="";if(typeof P=="string"?(F=v.URI.file(P),$=P):typeof P<"u"&&(F=P,$=P.fsPath),!F)return $;const z=this.getWorkspaceFolder(F,!0);if(!z)return $;typeof N>"u"&&this.w&&(N=this.w.folders.length>1);let V=(0,O.relativePath)(z.uri,F);return N&&z.name&&(V=`${z.name}/${V}`),V}x(P){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:P,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:N,added:F,removed:$}=L.toExtHostWorkspace(P,this.k,this.l,this.q);this.k=N||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:$}))}findFiles(P,N,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let V;if(N===null?V=!1:N&&(typeof N=="string"?V=N:V=N.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:ee}=K(s.GlobPattern.from(P));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(X),(0,m.withUndefinedAsNull)(ee),(0,m.withUndefinedAsNull)(V),(0,m.withUndefinedAsNull)(F),z).then(fe=>Array.isArray(fe)?fe.map(oe=>v.URI.revive(oe)):[])}async findTextInFiles(P,N,F,$,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),X=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:ee,folder:fe}=K(s.GlobPattern.from(N.include)),oe=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ue={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:X,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:ee,excludePattern:oe},ce=!1;if(this.t[V]=he=>{if(ce)return;const Y=v.URI.revive(he.resource);he.results.forEach(ge=>{(0,h.resultIsMatch)(ge)?F({uri:Y,preview:{text:ge.preview.text,matches:(0,i.mapArrayOrNot)(ge.preview.matches,Se=>new r.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,i.mapArrayOrNot)(ge.ranges,Se=>new r.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):F({uri:Y,text:ge.text,lineNumber:ge.lineNumber})})},z.isCancellationRequested)return{};try{const he=await this.n.$startTextSearch(P,(0,m.withUndefinedAsNull)(fe),ue,V,z);return delete this.t[V],he||{}}catch(he){throw delete this.t[V],he}}$handleTextSearchResult(P,N){this.t[N]?.(P)}saveAll(P){return this.n.$saveAll(P)}resolveProxy(P){return this.n.$resolveProxy(P)}get trusted(){return this.u}requestWorkspaceTrust(P){return this.n.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(P,N){if(this.v.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this.v.set(P,N);const F=this.s.transformOutgoingScheme(P),$=this.y++;return this.n.$registerEditSessionIdentityProvider($,F),(0,C.toDisposable)(()=>{this.v.delete(P),this.n.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(P,N){this.g.info("Getting edit session identifier for workspaceFolder",P);const F=await this.resolveWorkspaceFolder(v.URI.revive(P));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const $=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!$),!$)return;const z=await $.provideEditSessionIdentity(F,N);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(P,N,F,$){this.g.info("Getting edit session identifier for workspaceFolder",P);const z=await this.resolveWorkspaceFolder(v.URI.revive(P));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const V=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!V),!V)return;const X=await V.provideEditSessionIdentityMatch?.(N,F,$);if(this.g.info("Provider returned edit session identifier match result: ",X),!!X)return X}};q=qe([Ve(0,S.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,o.ILogService),Ve(4,a.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function K(j){let P,N;return j&&(typeof j=="string"?P=j:(P=j.pattern,N=v.URI.revive(j.baseUri))),{includePattern:P,folder:N}}}),define(De[32],Ce([1,0,23,4,31,5,6,157,89,9,15,3,14,12,2]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(r,a){if(a){const h=a.split(".");let c=r;for(let d=0;c&&d<h.length;d++)c=c[h[d]];return c}}function o(r){return r instanceof f.URI}function u(r){return r&&r.uri instanceof f.URI&&r.languageId&&typeof r.languageId=="string"}function g(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&r.uri instanceof f.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function b(r){if(o(r))return{resource:r};if(u(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(g(r))return{overrideIdentifier:r.languageId};if(E(r))return{resource:r.uri};if(r===null)return{resource:null}}let S=class{constructor(a,h,c){this.a=a.getProxy(M.MainContext.MainThreadConfiguration),this.c=h,this.b=c,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,h){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,h))}};S=qe([Ve(0,m.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,v.ILogService)],S),e.ExtHostConfiguration=S;class s{constructor(a,h,c,d){this.a=new k.Emitter,this.b=a,this.f=d,this.c=h,this.e=R.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,h){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(h,c))}getConfiguration(a,h,c){const d=b(h)||{},n=this.g(a?t(this.e.getValue(void 0,d,this.c.workspace),a):this.e.getValue(void 0,d,this.c.workspace));a&&this.h(a,d,c?.identifier);function l(A){if(A==null)return null;if(typeof A=="boolean")return A?2:5;switch(A){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(A){return typeof t(n,A)<"u"},get:(A,L)=>{this.h(a?`${a}.${A}`:A,d,c?.identifier);let q=t(n,A);if(typeof q>"u")q=L;else{let K;const j=(P,N)=>{let F;const $=()=>{K=K||(0,i.deepClone)(n),F=F||t(K,N)};return(0,T.isObject)(P)?new Proxy(P,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return $(),()=>F;if(K)return F=F||t(K,N),F[V];const X=z[V];return typeof V=="string"?j(X,`${N}.${V}`):X},set:(z,V,X)=>($(),F&&(F[V]=X),!0),deleteProperty:(z,V)=>($(),F&&delete F[V],!0),defineProperty:(z,V,X)=>($(),F&&Object.defineProperty(F,V,X),!0)}):P};q=j(q,A)}return q},update:(A,L,q,K)=>{A=a?`${a}.${A}`:A;const j=l(q);return L!==void 0?this.b.$updateConfigurationOption(j,A,L,d,K):this.b.$removeConfigurationOption(j,A,d,K)},inspect:A=>{A=a?`${a}.${A}`:A;const L=this.e.inspect(A,d,this.c.workspace);if(L)return{key:A,defaultValue:(0,i.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,i.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,i.deepClone)(L.workspace?.value),workspaceFolderValue:(0,i.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(L.default?.override),globalLanguageValue:(0,i.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,i.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(L.workspaceFolder?.override),languageIds:(0,i.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(p,n,!1),Object.freeze(p)}g(a){const h=c=>(0,T.isObject)(c)?new Proxy(c,{get:(d,n)=>h(d[n]),set:(d,n,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(d,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(d,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return h(a)}h(a,h,c){const d=w.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=c?`[${c.value}] `:"";if(d===4){typeof h?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){h?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,h){const c=new R.ConfigurationChangeEvent(a,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,n)=>c.affectsConfiguration(d,b(n))})}k(a){return a.reduce((h,c)=>(h.set(c[0],c[1]),h),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[103],Ce([1,0,2,15,4,5,6,31,54,32,20,57,14,27,3,13,21,12,72,193,11]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(P){function N($){if($!=null)return $}P.from=N;function F($){if($!=null)return $}P.to=F})(s||(s={}));var r;(function(P){function N($){if($!=null)return $}P.from=N;function F($){if($!=null)return $}P.to=F})(r||(r={}));var a;(function(P){function N($){if($!=null)return $}P.from=N;function F($){if($!=null)return $}P.to=F})(a||(a={}));var h;(function(P){function N(z){if(z){const V=z;return V&&!!V.process}else return!1}P.is=N;function F(z){if(z==null)return;const V={process:z.process,args:z.args};return z.options&&(V.options=a.from(z.options)),V}P.from=F;function $(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}P.to=$})(h||(h={}));var c;(function(P){function N($){if($!=null)return $}P.from=N;function F($){if($!=null)return $}P.to=F})(c||(c={}));var d;(function(P){function N(z){if(z){const V=z;return V&&(!!V.commandLine||!!V.command)}else return!1}P.is=N;function F(z){if(z==null)return;const V={};return z.commandLine!==void 0?V.commandLine=z.commandLine:(V.command=z.command,V.args=z.args),z.options&&(V.options=c.from(z.options)),V}P.from=F;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}P.to=$})(d||(d={}));var n;(function(P){function N(z){if(z){const V=z;return V&&V.customExecution==="customExecution"}else return!1}P.is=N;function F(z){return{customExecution:"customExecution"}}P.from=F;function $(z,V){return V.get(z)}P.to=$})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(P){function N(F,$){let z;return F.scope!==void 0&&typeof F.scope!="number"?z=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=E.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:z}}P.from=N})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(P){function N(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}P.from=N})(p||(p={}));var A;(function(P){function N(z,V){if(z==null)return[];const X=[];for(const ee of z){const fe=F(ee,V);fe&&X.push(fe)}return X}P.fromMany=N;function F(z,V){if(z==null)return;let X;z.execution instanceof C.ProcessExecution?X=h.from(z.execution):z.execution instanceof C.ShellExecution?X=d.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(X=n.from(z.execution));const ee=s.from(z.definition);let fe;return z.scope?typeof z.scope=="number"?fe=z.scope:fe=z.scope.uri:fe=C.TaskScope.Workspace,!ee||!fe?void 0:{_id:z._id,definition:ee,name:z.name,source:{extensionId:V.identifier.value,label:z.source,scope:fe},execution:X,isBackground:z.isBackground,group:p.from(z.group),presentationOptions:r.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}P.from=F;async function $(z,V,X){if(z==null)return;let ee;h.is(z.execution)?ee=h.to(z.execution):d.is(z.execution)?ee=d.to(z.execution):n.is(z.execution)&&(ee=n.to(z._id,X));const fe=s.to(z.definition);let oe;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?oe=z.source.scope:oe=await V.resolveWorkspaceFolder(i.URI.revive(z.source.scope)):oe=C.TaskScope.Workspace),!fe||!oe)return;const ue=new C.Task(fe,oe,z.name,z.source.label,ee,z.problemMatchers);return z.isBackground!==void 0&&(ue.isBackground=z.isBackground),z.group!==void 0&&(ue.group=C.TaskGroup.from(z.group._id),ue.group&&z.group.isDefault&&(ue.group=new C.TaskGroup(ue.group.id,ue.group.label),z.group.isDefault===!0&&(ue.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ue.presentationOptions=r.to(z.presentationOptions)),z._id&&(ue._id=z._id),z.detail&&(ue.detail=z.detail),ue}P.to=$})(A=e.TaskDTO||(e.TaskDTO={}));var L;(function(P){function N($){return $}P.from=N;function F($){if(!!$)return Object.assign(Object.create(null),$)}P.to=F})(L||(L={}));class q{constructor(N,F,$){this._id=F,this.a=$,S.set(this,void 0),Je(this,S,N,"f")}get task(){return this.a}terminate(){Re(this,S,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}S=new WeakMap;let K=class{constructor(N,F,$,z,V,X,ee,fe){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=N.getProxy(M.MainContext.MainThreadTask),this.b=$,this.c=z,this.d=V,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=fe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,F,$){if(!$)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:F,provider:$,extension:N}),this.a.$registerTaskProvider(z,F),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(N,F){this.a.$registerTaskSystem(N,F)}fetchTasks(N){return this.a.$fetchTasks(L.from(N)).then(async F=>{const $=[];for(const z of F){const V=await A.to(z,this.b,this.m);V&&$.push(V)}return $})}get taskExecutions(){const N=[];return this.k.forEach(F=>N.push(F)),N}terminateTask(N){if(!(N instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,F,$){const z=this.m.get(N.id);z&&(this.o.set(N.id,z),this.e.attachPtyToTerminal(F,await z.callback($))),this.p=N.id,this.q.fire({execution:await this.y(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){const F=await this.y(N);this.l.delete(N.id),this.k.delete(N.id),this.B(N),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const F=await this.y(N.id);this.s.fire({execution:F,processId:N.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(N){const F=await this.y(N.id);this.t.fire({execution:F,exitCode:N.exitCode})}$provideTasks(N,F){const $=this.j.get(N);if(!$)return Promise.reject(new Error("no handler found"));const z=[],V=(0,k.asPromise)(()=>$.provider.provideTasks(O.CancellationToken.None)).then(X=>this.u(F,z,$,X));return new Promise(X=>{V.then(ee=>{Promise.all(z).then(()=>{X(ee)})})})}async $resolveTask(N,F){const $=this.j.get(N);if(!$)return Promise.reject(new Error("no handler found"));if(F.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await A.to(F,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const V=await $.provider.resolveTask(z,O.CancellationToken.None);if(!V)return;this.A(V,$);const X=A.from(V,$.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(X.execution)&&await this.x(X,V,!0),await this.v(X)}w(){return this.h++}async x(N,F,$){const z=await this.a.$createTaskId(N);!$&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,F.execution)),this.m.set(z,F.execution)}async y(N,F){if(typeof N=="string"){const V=this.l.get(N);if(!V)throw new b.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const $=this.l.get(N.id);if($)return $;const z=new Promise((V,X)=>{function ee(fe,oe,ue){ue?V(new q(fe,oe.id,ue)):X("Unexpected: Task does not exist.")}F?ee(this,N,F):A.to(N.task,this.b,this.m).then(fe=>ee(this,N,fe))});return this.l.set(N.id,z),z.then(V=>(this.k.set(N.id,V),V),V=>Promise.reject(V))}A(N,F){N._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const $=this.n.values();let z=$.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=$.next()}};K=qe([Ve(0,m.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,T.IExtHostConfiguration),Ve(5,I.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,g.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let j=class extends K{constructor(N,F,$,z,V,X,ee,fe){super(N,F,$,z,V,X,ee,fe),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(N,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const $=A.from(F,N);if($===void 0)throw new Error("Task is not valid");if(n.is($.execution))await this.x($,F,!1);else throw new b.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution($),F);return this.a.$executeTask($).catch(V=>{throw new Error(V)}),z}u(N,F,$,z){const V=[];if(z)for(const X of z){this.A(X,$),(!X.definition||!N[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const ee=A.from(X,$.extension);ee&&n.is(ee.execution)?(V.push(ee),F.push(this.x(ee,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:$.extension}}async v(N){if(n.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,F,$){}};j=qe([Ve(0,m.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,w.IExtHostDocumentsAndEditors),Ve(4,T.IExtHostConfiguration),Ve(5,I.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,g.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(De[237],Ce([1,0,19,20,45,35,22,211,44]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(m,v,f){this.k=m,this.l=v,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&M.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((f,t)=>{const o=u=>{this.f++,m(u)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const g=u.toString(),E=i.basename(g);this.j&&this.j(g,E)||this.v(o,{base:u,basename:E})}),Promise.all(v.map(u=>this.p(u,o))).then(u=>{f({limitHit:this.e,stats:u[0]||void 0})},u=>{t(new Error((0,y.toErrorMessage)(u)))})})}async p(m,v){const f=new k.CancellationTokenSource,t=this.q(m),o=this.r(),u=new w.QueryGlobTester(this.k,m),g=!u.hasSiblingExcludeClauses();let E;try{this.h.add(f),E=R.StopWatch.create();const b=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},t,f.token),S=E.elapsed(),s=R.StopWatch.create();return this.g&&!this.e||(b&&b.forEach(r=>{const a=i.posix.relative(m.folder.path,r.path);if(g){const h=i.basename(r.path);this.v(v,{base:m.folder,relativePath:a,basename:h});return}this.s(o,m.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,u,v),{providerTime:S,postProcessTime:s.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const v=(0,w.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,w.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,f,t){if(f===this.a){const u=i.basename(this.a);this.v(t,{base:v,relativePath:this.a,basename:u})}function o(u){const g=i.basename(u),E=i.dirname(u);let b=m[E];b||(b=m[E]=[],o(E)),b.push({base:v,relativePath:u,basename:g})}o(f)}u({rootEntries:m,pathToEntries:v},f,t){const o=this,u=this.a;function g(E){const b=(0,w.hasSiblingFn)(()=>E.map(S=>S.basename));for(let S=0,s=E.length;S<s;S++){const r=E[S],{relativePath:a,basename:h}=r;if(f.matchesExcludesSync(a,h,u!==h?b:void 0))continue;const c=v[a];if(c)g(c);else{if(a===u)continue;o.v(t,r)}if(o.e)break}}g(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class O{constructor(){this.b=new Map}fileSearch(m,v,f,t){const o=this.c(m.cacheKey),u=new T(m,v,o&&o.token);let g=0;const E=b=>{g+=b.length,f(b.map(S=>this.d(S)))};return this.e(u,O.a,E,t).then(b=>({limitHit:b.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:b.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new k.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:C.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,v,f,t){t.onCancellationRequested(()=>{m.cancel()});const o=g=>{g&&(u.push(g),v>0&&u.length>=v&&(f(u),u=[]))};let u=[];return m.search(o).then(g=>(u.length&&f(u),g),g=>(u.length&&f(u),Promise.reject(g)))}}e.FileSearchManager=O,O.a=512}),define(De[238],Ce([1,0,16,78,35,82,28,13,19,22,10,9,2,254,147,40,12,49,94,236,44]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let S=class{constructor(p,A,L,q,K){this.a=p,this.b=A,this.c=L,this.d=q,this.e=K}text(p,A,L={}){p=this.f(p,L);const q=this.a.getValue(),K=A&&A.some(P=>!this.a.getValue({resource:P}).search.useRipgrep);return{...this.h(A?.map(u.toWorkspaceFolder),L),type:2,contentPattern:p,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:q.search.usePCRE2||K||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(p,A){const L=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const q={...p,wordSeparators:L.editor.wordSeparators};return this.j(p,A)&&(q.isCaseSensitive=!0),this.k(p)&&(q.isMultiline=!0),q}file(p,A={}){return{...this.h(p,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}g(p,A){return p?(p=Array.isArray(p)?p.map(c):c(p),A?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],A={}){const L=this.g(A.includePattern,A.expandPatterns),q=this.g(A.excludePattern,A.expandPatterns),K=p.length>1,j=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,A,q)):p.map(F=>this.r(F,A,q,K))).filter(F=>!!F),P={_reason:A._reason,folderQueries:j,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:q.pattern,includePattern:L.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const F=i.coalesce(i.flatten(this.c.groups.map(V=>V.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const $=F.filter(V=>(0,b.pathIncludedInQuery)(P,V.fsPath)),z=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...P,...z}}const N=A.extraFileResources&&A.extraFileResources.filter(F=>(0,b.pathIncludedInQuery)(P,F.fsPath));return P.extraFileResources=N&&N.length?N:void 0,P}i(p){const A=[],L=new C.ResourceMap,q={};let K=!1;return p.forEach(j=>{if(j.scheme===R.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(j)){const N=this.b.getWorkspaceFolder(j)?.uri??j.with({path:w.dirname(j.fsPath)});let F=L.get(N);F||(K=!0,F={folder:N,includePattern:{}},A.push(F),L.set(N,F));const $=w.relative(N.fsPath,j.fsPath);(0,I.assertIsDefined)(F.includePattern)[$.replace(/\\/g,"/")]=!0}else j.fsPath&&(K=!0,q[j.fsPath]=!0)}),{folderQueries:A,includePattern:q,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(p,A){if(A.isSmartCase){if(p.isRegExp){if(O.containsUppercaseCharacter(p.pattern,!0))return!0}else if(O.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const A=z=>w.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),q=(Array.isArray(p)?p:a(p)).map(z=>{const V=this.e.resolvedUserHome;return V?(0,M.untildify)(z,V.scheme===R.Schemas.file?V.fsPath:V.path):z}),K=k.groupBy(q,z=>A(z)?"searchPaths":"exprSegments"),j=(K.exprSegments||[]).map(z=>O.rtrim(z,"/")).map(z=>O.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),h(z))),P={},N=this.m(K.searchPaths||[]);N&&N.length&&(P.searchPaths=N);const F=i.flatten(j),$=r(...F);return $&&(P.pattern=$),P}l(p,A){return A.disregardExcludeSettings?void 0:(0,b.getExcludes)(p,!A.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const A=i.flatten(p.map(q=>{let{pathPortion:K,globPortion:j}=s(q);j&&(j=d(j));const P=this.n(K);return i.flatten(P.map(N=>this.o(N,j)))})),L=new Map;return A.forEach(q=>{const K=q.searchPath.toString(),j=L.get(K);j?q.pattern&&(j.pattern=j.pattern||{},j.pattern[q.pattern]=!0):L.set(K,{searchPath:q.searchPath,pattern:q.pattern?r(q.pattern):void 0})}),Array.from(L.values())}n(p){if(w.isAbsolute(p)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==R.Schemas.file?[{searchPath:A[0].uri.with({path:p})}]:[{searchPath:m.URI.file(w.normalize(p))}]}if(this.b.getWorkbenchState()===2){const A=this.b.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const q=w.posix.resolve(A.path,p);return[{searchPath:A.with({path:q})}]}const L=d(p);return[{searchPath:A,pattern:L}]}else{if(p==="./"||p===".\\")return[];{const A=p.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(K=>{const j=A.match(new RegExp(`^${O.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return j?{match:j,folder:K}:null}).filter(I.isDefined);if(q.length)return q.map(K=>{const j=K.match[1];return{searchPath:K.folder.uri,pattern:j&&d(j)}});{const K=p.match(/\.[\/\\](.+)[\/\\]?/),j=K?K[1]:p,P=f.localize(0,null,j);throw new Error(P)}}}}o(p,A){const L=p.pattern&&A?`${p.pattern}/${A}`:p.pattern||A,q=[{searchPath:p.searchPath,pattern:L}];return L&&!L.endsWith("**")&&q.push({searchPath:p.searchPath,pattern:L+"/**"}),q}q(p,A,L){const q=this.r((0,u.toWorkspaceFolder)(p.searchPath),A,L,!1);return q?{...q,includePattern:p.pattern}:null}r(p,A,L,q){let K;const j=m.URI.isUri(p)?p:p.uri;if(L.searchPaths){const z=L.searchPaths.filter(V=>(0,T.isEqual)(V.searchPath,j))[0];if(z&&!z.pattern)return null;z&&(K=z.pattern)}const P=this.a.getValue({resource:j}),F={...this.l(P,A)||{},...K||{}},$=m.URI.isUri(p)?(0,T.basename)(p):p.name;return{folder:j,folderName:q?$:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:P.files&&P.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!P.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!P.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!P.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!P.search.followSymlinks}}};S=qe([Ve(0,t.IConfigurationService),Ve(1,u.IWorkspaceContextService),Ve(2,g.IEditorGroupsService),Ve(3,o.ILogService),Ve(4,E.IPathService)],S),e.QueryBuilder=S;function s(l){const p=l.match(/[\*\{\}\(\)\[\]\?]/);if(p){const A=p.index,L=l.substr(0,A).match(/[/|\\][^/\\]*$/);if(L){let q=l.substr(0,L.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:l.substr((L.index||0)+1)}}}return{pathPortion:l}}function r(...l){return l.length?l.reduce((p,A)=>(p[A]=!0,p),Object.create(null)):void 0}function a(l){return y.splitGlobAware(l,",").map(p=>p.trim()).filter(p=>!!p.length)}function h(l){return[`**/${l}/**`,`**/${l}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function c(l){return l.replace(/\\/g,"/")}function d(l){return c(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(l,p){l=i.distinct(l,q=>q.toString());const A=[],L=p.getWorkspace();return l&&l.forEach(q=>{let K;if(p.getWorkbenchState()===2)K=(0,T.relativePath)(L.folders[0].uri,q),K&&K!=="."&&(K="./"+K);else{const j=p.getWorkspaceFolder(q);if(j){const P=j.name;if(L.folders.filter(F=>F.name===P).length===1){const F=(0,T.relativePath)(j.uri,q);F===""?K=`./${j.name}`:K=`./${j.name}/${F}`}else K=q.fsPath}}K&&A.push(K)}),A}e.resolveResourcesForSearchIncludes=n}),define(De[239],Ce([1,0,22,2,20,11,3,238,44,49]),function(te,e,i,k,y,M,C,R,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function I(t,o){const u=o.activationEvents;if(!u)return Promise.resolve(void 0);const g=[],E=[];for(const h of u)if(/^workspaceContains:/.test(h)){const c=h.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||t.forceUsingSearch?E.push(c):g.push(c)}if(g.length===0&&E.length===0)return Promise.resolve(void 0);let b;const S=new Promise((h,c)=>{b=h}),s=h=>b({activationEvent:h}),r=Promise.all(g.map(h=>m(t,h,s))).then(()=>{}),a=v(t,o.identifier,E,s);return Promise.all([r,a]).then(()=>{b(void 0)}),S}e.checkActivateWorkspaceContainsExtension=I;async function m(t,o,u){for(const g of t.folders)if(await t.exists(i.joinPath(k.URI.revive(g),o))){u(`workspaceContains:${o}`);return}}async function v(t,o,u,g){if(u.length===0)return Promise.resolve(void 0);const E=new y.CancellationTokenSource,b=t.checkExists(t.folders,u,E.token),S=setTimeout(async()=>{E.cancel(),t.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},O);let s=!1;try{s=await b}catch(r){M.isCancellationError(r)||M.onUnexpectedError(r)}E.dispose(),clearTimeout(S),s&&g(`workspaceContains:${u.join(",")}`)}function f(t,o,u,g){const E=t.get(C.IInstantiationService),b=t.get(w.ISearchService),s=E.createInstance(R.QueryBuilder).file(o.map(r=>(0,T.toWorkspaceFolder)(k.URI.revive(r))),{_reason:"checkExists",includePattern:u,exists:!0});return b.fileSearch(s,g).then(r=>!!r.limitHit,r=>M.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,i,k,y){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!y:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?y.call(te,i):y?y.value=i:e.set(te,i),i},Re=this&&this.__classPrivateFieldGet||function(te,e,i,k){if(i==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?k:i==="a"?k.call(te):k?k.value:e.get(te)};define(De[33],Ce([1,0,134,19,77,22,15,7,46,2,12,5,32,182,75,31,25,181,11,26,24,166,6,90,3,27,76,14,62,65,57,4,239,74,168,13,73]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b,S,s,r,a,h,c,d,n,l,p,A,L,q,K,j,P){"use strict";var N,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Ri extends R.Disposable{constructor(ce,he,Y,ge,Se,Fe,ze,_e,ke,Ie,Te){super(),this.a=this.B(new A.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=he,this.g=Y,this.f=ze,this.j=ge,this.k=Se,this.l=Fe,this.m=ke,this.p=Ie,this.s=Te,this.t=this.g.getProxy(I.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(I.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(I.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.C=new C.Barrier,this.D=new C.Barrier,this.G=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const re=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.F=new u.ExtensionDescriptionRegistry(ee(this.G,re)),this.H=new f.ExtHostStorage(this.g,this.l),this.I=new q.ExtHostSecretState(this.g),this.J=_e,this.h=ce.createChild(new n.ServiceCollection([f.IExtHostStorage,this.H],[q.IExtHostSecretState,this.I]));let ae=[],J=[];this.f.remote.isRemote&&(ae=this.f.allExtensions.filter(B=>!B.main&&!B.browser).map(B=>B.identifier),J=this.f.allExtensions.filter(B=>!re.has(E.ExtensionIdentifier.toKey(B.identifier.value))).filter(B=>(B.main||B.browser)&&B.api==="none").map(B=>B.identifier));const D=(0,o.extensionIdentifiersArrayToSet)(J);this.L=this.B(new v.ExtensionsActivator(this.F,ae,J,{onExtensionActivationError:(B,H,G)=>{this.v.$onExtensionActivationError(B,g.transformErrorForSerialization(H),G)},actualActivateExtension:async(B,H)=>{if(D.has(E.ExtensionIdentifier.toKey(B)))return await this.v.$activateExtension(B,H),new v.HostExtension;const G=this.F.getExtensionDescription(B);return this.ab(G,H)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.mb()}catch(ce){g.onUnexpectedError(ce)}}async R(){this.J.onWillDeactivateAll();let ce=[];try{ce=this.F.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this.Y(Se))}catch{}await Promise.all(ce)}terminate(ce,he=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${ce}`),this.l.flush(),this.p.dispose(),this.L.dispose(),g.setUnexpectedErrorHandler(ge=>{this.l.error(ge)}),this.g.dispose();const Y=this.R();Promise.race([(0,C.timeout)(5e3),Y]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${he}`):this.l.info(`Extension host exiting with code ${he}`),this.l.flush(),this.l.dispose(),this.c.exit(he)})}isActivated(ce){return this.C.isOpen()?this.L.isActivated(ce):!1}async getExtension(ce){const he=await this.v.$getExtension(ce);let Y;if(he?.browserNlsBundleUris){Y={};for(const ge of Object.keys(he.browserNlsBundleUris))Y[ge]=T.URI.revive(he.browserNlsBundleUris[ge])}return he&&{...he,identifier:new E.ExtensionIdentifier(he.identifier.value),extensionLocation:T.URI.revive(he.extensionLocation),browserNlsBundleUris:Y}}S(ce,he){return this.L.activateByEvent(ce,he)}U(ce,he){return this.L.activateById(ce,he)}activateByIdWithErrors(ce,he){return this.U(ce,he).then(()=>{const Y=this.L.getActivatedExtension(ce);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this.C.wait().then(ce=>this.F)}getExtensionExports(ce){return this.C.isOpen()?this.L.getActivatedExtension(ce).exports:null}async W(ce){if(ce.scheme!==j.Schemas.file)return ce;const he=await this.c.realpath(ce.fsPath);return T.URI.file(he)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(ce=>new oe(ce))),this.M}async X(ce){const he=w.TernarySearchTree.forUris(Y=>M.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ce.map(async Y=>{if(this.qb(Y)){const ge=await this.W(Y.extensionLocation);he.set(ge,Y)}})),he}Y(ce){let he=Promise.resolve(void 0);if(!this.C.isOpen()||!this.L.isActivated(ce))return he;const Y=this.L.getActivatedExtension(ce);if(!Y)return he;try{typeof Y.module.deactivate=="function"&&(he=Promise.resolve(Y.module.deactivate()).then(void 0,ge=>(this.l.error(ge),Promise.resolve(void 0))))}catch(ge){this.l.error(`An error occurred when deactivating the extension '${ce.value}':`),this.l.error(ge)}try{(0,R.dispose)(Y.subscriptions)}catch(ge){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ce.value}':`),this.l.error(ge)}return he}async ab(ce,he){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ce.identifier):await this.v.$onWillActivateExtension(ce.identifier),this.cb(ce,he).then(Y=>{const ge=Y.activationTimes;return this.v.$onDidActivateExtension(ce.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,he),this.bb(ce,he,"success",ge),Y},Y=>{throw this.bb(ce,he,"failure"),Y})}bb(ce,he,Y,ge){const Se=V(ce,he);this.u.$publicLog2("extensionActivationTimes",{...Se,...ge||{},outcome:Y})}cb(ce,he){const Y=V(ce,he);this.u.$publicLog2("activatePlugin",Y);const ge=this.qb(ce);if(!ge)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ce.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${ce.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this.l.flush();const Se=new v.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this.rb(ce,(0,M.joinPath)(ce.extensionLocation,ge),Se),this.db(ce)]).then(Fe=>(y.mark(`code/extHost/willActivateExtension/${ce.identifier.value}`),Ri.eb(this.l,ce.identifier,Fe[0],Fe[1],Se))).then(Fe=>(y.mark(`code/extHost/didActivateExtension/${ce.identifier.value}`),Fe))}db(ce){const he=new S.ExtensionGlobalMemento(ce,this.H),Y=new S.ExtensionMemento(ce.identifier.value,!1,this.H),ge=new K.ExtensionSecrets(ce,this.I),Se=ce.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Fe=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ce.identifier.value}`),Promise.all([he.whenReady,Y.whenReady,this.J.whenReady]).then(()=>{const ze=this;let _e,ke;const Ie=(0,o.isProposedApiEnabled)(ce,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(ce.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:Y,secrets:ge,subscriptions:[],get extensionUri(){return ce.extensionLocation},get extensionPath(){return ce.extensionLocation.fsPath},asAbsolutePath(Te){return k.join(ce.extensionLocation.fsPath,Te)},get storagePath(){return ze.J.workspaceValue(ce)?.fsPath},get globalStoragePath(){return ze.J.globalValue(ce).fsPath},get logPath(){return k.join(ze.f.logsLocation.fsPath,ce.identifier.value)},get logUri(){return T.URI.joinPath(ze.f.logsLocation,ce.identifier.value)},get storageUri(){return ze.J.workspaceValue(ce)},get globalStorageUri(){return ze.J.globalValue(ce)},get extensionMode(){return Se},get extension(){return _e===void 0&&(_e=new X(ze,ce.identifier,ce,Fe,!1)),_e},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(ce,"extensionRuntime"),ze.extensionRuntime},get environmentVariableCollection(){return ze.p.getEnvironmentVariableCollection(ce)},get messagePassingProtocol(){if(!ke){if(!Ie)return;const Te=A.Event.buffer(A.Event.fromDOMEventEmitter(Ie,"message",re=>re.data));Ie.start(),ke={onDidReceiveMessage:Te,postMessage:Ie.postMessage.bind(Ie)}}return ke}})})}static eb(ce,he,Y,ge,Se){return Y=Y||{activate:void 0,deactivate:void 0},this.fb(ce,he,Y,ge,Se).then(Fe=>new v.ActivatedExtension(!1,null,Se.build(),Y,Fe,ge.subscriptions))}static fb(ce,he,Y,ge,Se){if(typeof Y.activate=="function")try{Se.activateCallStart(),ce.trace(`ExtensionService#_callActivateOptional ${he.value}`);const Fe=typeof global=="object"?global:self,ze=Y.activate.apply(Fe,[ge]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(ze).then(_e=>(Se.activateResolveStop(),_e))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(Y)}gb(ce,he){this.U(ce.identifier,{startup:!1,extensionId:ce.identifier,activationEvent:he}).then(void 0,Y=>{this.l.error(Y)})}hb(){this.v.$setPerformanceMarks(y.getMarks());for(const ce of this.F.getAllExtensionDescriptions())if(ce.activationEvents)for(const he of ce.activationEvents)he==="onStartupFinished"&&this.gb(ce,he)}ib(){const ce=this.S("*",!0).then(void 0,Se=>{this.l.error(Se)});this.B(this.j.onDidChangeWorkspace(Se=>this.jb(Se.added)));const he=this.j.workspace?this.j.workspace.folders:[],Y=this.jb(he),ge=Promise.all([ce,Y]).then(()=>{});return Promise.race([ge,(0,C.timeout)(1e4)]).then(()=>{this.hb()}),ge}jb(ce){return ce.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(he=>this.kb(ce,he))).then(()=>{})}async kb(ce,he){if(this.isActivated(he.identifier))return;const Y=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.l,folders:ce.map(Fe=>Fe.uri),forceUsingSearch:Y,exists:Fe=>this.c.exists(Fe.fsPath),checkExists:(Fe,ze,_e)=>this.t.$checkExists(Fe,ze,_e)},Se=await(0,L.checkActivateWorkspaceContainsExtension)(ge,he);if(!!Se)return this.U(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:Se.activationEvent}).then(void 0,Fe=>this.l.error(Fe))}async $extensionTestsExecute(){await this.D.wait();try{return await this.lb()}catch(ce){throw console.error(ce),ce}}async lb(){const{extensionDevelopmentLocationURI:ce,extensionTestsLocationURI:he}=this.f.environment;if(!ce||!he)throw new Error(i.localize(0,null));const Y=await this.rb(null,he,new v.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(i.localize(1,null,he.toString()));return new Promise((ge,Se)=>{const Fe=(ke,Ie)=>{ke?Se(ke):ge(typeof Ie=="number"&&Ie>0?1:0)},ze=(0,M.originalFSPath)(he),_e=Y.run(ze,Fe);_e&&_e.then&&_e.then(()=>{ge(0)}).catch(ke=>{Se(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.C.open()).then(()=>this.ib()).then(()=>{this.D.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ce,he){return this.N[ce]=he,(0,R.toDisposable)(()=>{delete this.N[ce]})}async nb(ce){const he=ce.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const Y=ce.substr(0,he);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this.N[Y]}}async $resolveAuthority(ce,he){this.l.info(`$resolveAuthority invoked for authority (${fe(ce)})`);const{authorityPrefix:Y,resolver:ge}=await this.nb(ce);if(!ge)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(ge)),y.mark(`code/extHost/willResolveAuthority/${Y}`);const Se=await ge.resolve(ce,{resolveAttempt:he});y.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Fe={authority:ce,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},ze={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:ze,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(y.mark(`code/extHost/didResolveAuthorityError/${Y}`),Se instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(ce,he){this.l.info(`$getCanonicalURI invoked for authority (${fe(ce)})`);const{resolver:Y}=await this.nb(ce);if(!Y)return null;const ge=T.URI.revive(he);if(typeof Y.getCanonicalURI>"u")return ge;const Se=await(0,C.asPromise)(()=>Y.getCanonicalURI(ge));return Se||ge}static ob(ce,he,Y){const ge=new u.ExtensionDescriptionRegistry(ce.getAllExtensionDescriptions());ge.deltaExtensions(Y.toAdd,Y.toRemove);const Se=(0,o.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(ze=>ze.identifier));for(const ze of Y.myToRemove)Se.delete(E.ExtensionIdentifier.toKey(ze));for(const ze of Y.myToAdd)Se.add(E.ExtensionIdentifier.toKey(ze));const Fe=ee(ge,Se);return{globalRegistry:ge,myExtensions:Fe}}$startExtensionHost(ce){ce.toAdd.forEach(ge=>ge.extensionLocation=T.URI.revive(ge.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Ri.ob(this.G,this.F,ce);return this.G.set(he.getAllExtensionDescriptions()),this.F.set(Y),this.mb()}$activateByEvent(ce,he){return he===1?this.S(ce,!1):this.C.wait().then(Y=>this.S(ce,!1))}async $activate(ce,he){return await this.C.wait(),this.F.getExtensionDescription(ce)?(await this.U(ce,he),!0):!1}async $deltaExtensions(ce){ce.toAdd.forEach(Fe=>Fe.extensionLocation=T.URI.revive(Fe.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Ri.ob(this.G,this.F,ce),ge=await this.X(Y);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.G.set(he.getAllExtensionDescriptions()),this.F.set(Y),Promise.resolve(void 0)}async $test_latency(ce){return ce}async $test_up(ce){return ce.byteLength}async $test_down(ce){const he=b.VSBuffer.alloc(ce),Y=Math.random()%256;for(let ge=0;ge<ce;ge++)he.writeUInt8(Y,ge);return he}async $updateRemoteConnectionData(ce){this.Q=ce,this.a.fire()}};z=qe([Ve(0,a.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,d.IExtHostRpcService),Ve(3,t.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,h.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,l.IExtHostTunnelService),Ve(9,p.IExtHostTerminalService),Ve(10,P.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function V(ue,ce){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:ce.activationEvent,reasonId:ce.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class X{constructor(ce,he,Y,ge,Se){N.set(this,void 0),F.set(this,void 0),$.set(this,void 0),Je(this,N,ce,"f"),Je(this,F,he,"f"),Je(this,$,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=k.normalize((0,M.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ge,this.isFromDifferentExtensionHost=Se}get isActive(){return Re(this,N,"f").isActivated(Re(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,N,"f").getExtensionExports(Re(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,N,"f").activateByIdWithErrors(Re(this,$,"f"),{startup:!1,extensionId:Re(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=X,N=new WeakMap,F=new WeakMap,$=new WeakMap;function ee(ue,ce){return ue.getAllExtensionDescriptions().filter(he=>ce.has(E.ExtensionIdentifier.toKey(he.identifier)))}function fe(ue){const ce=ue.indexOf("+");return ce===-1?ue:ue.substring(0,ce)}class oe{constructor(ce){this.a=ce}setSearchTree(ce){this.a=ce}findSubstr(ce){return this.a.findSubstr(ce)}forEach(ce){return this.a.forEach(ce)}}e.ExtensionPaths=oe}),define(De[240],Ce([1,0,77,2,5,32,25,26,14,27,3,33,48,12,10]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(S,s,r,a,h,c,d){this.c=S,this.d=s,this.e=r,this.f=a,this.g=h,this.h=c,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const S=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new u(this.c,s,this.d,S,this.i)),this.register(this.e.createInstance(g,s)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,s,this.h.environment.appUriScheme))}register(S){if("nodeModuleName"in S)if(Array.isArray(S.nodeModuleName))for(const s of S.nodeModuleName)this.a.set(s,S);else this.a.set(S.nodeModuleName,S);typeof S.alternativeModuleName=="function"&&this.b.push(s=>S.alternativeModuleName(s))}};t=qe([Ve(2,O.IInstantiationService),Ve(3,M.IExtHostConfiguration),Ve(4,I.IExtHostExtensionService),Ve(5,T.IExtHostInitDataService),Ve(6,v.ILogService)],t),e.RequireInterceptor=t;let o=class Zi{constructor(S){if(S.environment.appRoot&&Zi.a.size){const s=(0,f.escapeRegExpCharacters)(this.c(S.environment.appRoot.fsPath)),r="[a-z0-9_.-]",a=`@${r}+\\/${r}+|${r}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${h}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(S){if(!this.b)return;const s=this.b.exec(this.c(S));if(!s)return;const[,r,a,h]=s,c=Zi.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),r+c+h}c(S){return S.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([Ve(0,T.IExtHostInitDataService)],o);class u{constructor(S,s,r,a,h){this.c=S,this.d=s,this.e=r,this.f=a,this.g=h,this.nodeModuleName="vscode",this.a=new Map}load(S,s){const r=this.d.findSubstr(s);if(r){let a=this.a.get(R.ExtensionIdentifier.toKey(r.identifier));return a||(a=this.c(r,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(r.identifier),a)),a}if(!this.b){let a="";this.d.forEach((h,c)=>a+=`	${c} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${a}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(S,s,r){this.d=S,this.nodeModuleName="keytar",this.a=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=r,h=s.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let c=a.appRoot.fsPath;m.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,d)=>h.$getPassword(c,d),setPassword:(c,d,n)=>h.$setPassword(c,d,n),deletePassword:(c,d)=>h.$deletePassword(c,d),findPassword:c=>h.$findPassword(c),findCredentials(c){return h.$findCredentials(c)}}}load(S,s){const r=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(S){const s=S.length;if(s<=7||!this.b)return;const r=s-7;if((S.charAt(r)==="/"||S.charAt(r)==="\\")&&S.endsWith("keytar")&&(S=S.replace(/\\/g,"/"),this.b.has(S)))return"keytar"}};g=qe([Ve(1,w.IExtHostRpcService),Ve(2,T.IExtHostInitDataService)],g);let E=class{constructor(S,s,r){this.e=S,this.f=s,this.nodeModuleName=["open","opn"],this.d=r.getProxy(y.MainContext.MainThreadTelemetry);const a=r.getProxy(y.MainContext.MainThreadWindow);this.c=(h,c)=>{const d=k.URI.parse(h);return c?this.g(h,c):d.scheme==="http"||d.scheme==="https"?a.$openUri(d,h,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?a.$openUri(d,h,{}):this.g(h,c)}}load(S,s,r){const a=this.e.findSubstr(s);return a&&(this.a=a.identifier.value,this.h()),this.b=r(S),this.c}g(S,s){return this.i(),this.b(S,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,w.IExtHostRpcService)],E)}),define(De[104],Ce([1,0,205,7,19,48,3,54,55,33,6,31,178,32]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(u,g,E,b,S,s,r){function a(){if(E){const h=E.activeEditor();if(h)return h.document.uri;const c=b.tabGroups.all.find(d=>d.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof O.TextDiffTabInput||c.input instanceof O.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof O.TextTabInput||c.input instanceof O.NotebookEditorTabInput||c.input instanceof O.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:h=>{const c=s.folders.filter(d=>d.name===h);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(h,c)=>S.getConfiguration(void 0,h).get(c),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=a();if(h)return y.normalize(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const h=a();if(h){const c=g.getWorkspaceFolder(h);if(c)return y.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(E){const h=E.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(E){const h=E.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>u.getExtension(h)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(M.env))}}let t=class extends k.Disposable{constructor(u,g,E,b,S){super(),this.b=u,this.c=g,this.g=E,this.h=b,this.i=S,this.a=new i.Lazy(async()=>{const s=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,s,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};t=qe([Ve(0,T.IExtHostExtensionService),Ve(1,I.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,v.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(De[105],Ce([1,0,15,4,9,2,3,5,55,33,14,6,31,170,172,32,104]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,h,c,d,n,l){this.E=h,this.F=c,this.G=d,this.H=n,this.I=l,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new k.Emitter,this.n=new k.Emitter,this.o=new k.Emitter,this.u=new k.Emitter,this.k=a.getProxy(R.MainContext.MainThreadDebugService),this.A=new k.Emitter({onWillAddFirstListener:()=>{this.U()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.F.getExtensionRegistry().then(p=>{p.onDidChange(A=>{this.J(p)}),this.J(p)})}asDebugSourceUri(a,h){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let d=`debug:${encodeURIComponent(c.path||"")}`,n="?";return h&&(d+=`${n}session=${encodeURIComponent(h.id)}`,n="&"),d+=`${n}ref=${c.sourceReference}`,M.URI.parse(d)}else{if(c.path)return M.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const h=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const d=c.contributes.debuggers;if(d&&d.length>0)for(const n of d)(0,f.isDebuggerMainContribution)(n)&&h.push(n.type)}this.k.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){this.U();const a=[];return this.w.forEach(h=>a.push(h)),a}addBreakpoints(a){this.U();const h=a.filter(n=>{const l=n.id;return this.w.has(l)?!1:(this.w.set(l,n),!0)});this.V(h,[],[]);const c=[],d=new Map;for(const n of h)if(n instanceof I.SourceBreakpoint){let l=d.get(n.location.uri.toString());l||(l={type:"sourceMulti",uri:n.location.uri,lines:[]},d.set(n.location.uri.toString(),l),c.push(l)),l.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof I.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){this.U();const h=a.filter(l=>this.w.delete(l.id));this.V([],h,[]);const c=h.filter(l=>l instanceof I.SourceBreakpoint).map(l=>l.id),d=h.filter(l=>l instanceof I.FunctionBreakpoint).map(l=>l.id),n=h.filter(l=>l instanceof I.DataBreakpoint).map(l=>l.id);return this.k.$unregisterBreakpoints(c,d,n)}startDebugging(a,h,c){return this.k.$startDebugging(a?a.uri:void 0,h,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,h,c){if(!h)return new I.Disposable(()=>{});const d=this.d++;return this.f.push({type:a,handle:d,provider:h}),this.k.$registerDebugConfigurationProvider(a,c,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,d),new I.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==h),this.k.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(a,h,c){if(!c)return new I.Disposable(()=>{});if(!this.Q(a,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.N(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this.g++;return this.h.push({type:h,handle:d,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(h,d),new I.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(a,h){if(!h)return new I.Disposable(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:h}),new I.Disposable(()=>{this.j=this.j.filter(d=>d.factory!==h)})}async $runInTerminal(a,h){return Promise.resolve(void 0)}async $substituteVariables(a,h){let c;const d=await this.X(a);return d&&(c={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(c,h)}K(a,h){if(a.type==="implementation")return new S(a.implementation)}L(){}async $startDASession(a,h){const c=this,d=await this.W(h);return this.S(this.N(d.type),d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const l=this.M(n),p=this.K(l,d);if(!p)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const A=p;return this.B.set(a,A),this.R(d).then(L=>(L&&this.C.set(a,L),A.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const K=q,j={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const P=await this.D.sign(K.arguments.value);j.body={signature:P},A.sendResponse(j)}else throw new Error("no signer")}catch(P){j.success=!1,j.message=P.message,A.sendResponse(j)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(q),q=(0,f.convertToVSCPaths)(q,!0),c.k.$acceptDAMessage(a,q)}),A.onError(q=>{L&&L.onError&&L.onError(q),this.k.$acceptDAError(a,q.name,q.message,q.stack)}),A.onExit(q=>{L&&L.onExit&&L.onExit((0,y.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(a,(0,y.withNullAsUndefined)(q),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),A.startSession()))})}$sendDAMessage(a,h){h=(0,f.convertToDAPaths)(h,!1);const c=this.C.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(h),this.B.get(a)?.sendMessage(h)}$stopDASession(a){const h=this.C.get(a);this.C.delete(a),h&&h.onWillStopSession&&h.onWillStopSession();const c=this.B.get(a);return this.B.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const h=[],c=[],d=[];if(a.added)for(const n of a.added){const l=n.id;if(l&&!this.w.has(l)){let p;if(n.type==="function")p=new I.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new I.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const A=M.URI.revive(n.uri);p=new I.SourceBreakpoint(new I.Location(A,new I.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=l,this.w.set(l,p),h.push(p)}}if(a.removed)for(const n of a.removed){const l=this.w.get(n);l&&(this.w.delete(n),c.push(l))}if(a.changed){for(const n of a.changed)if(n.id){const l=this.w.get(n.id);if(l){if(l instanceof I.FunctionBreakpoint&&n.type==="function"){const p=l;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(l instanceof I.SourceBreakpoint&&n.type==="source"){const p=l;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new I.Location(M.URI.revive(n.uri),new I.Position(n.line,n.character))}d.push(l)}}}this.V(h,c,d)}$provideDebugConfigurations(a,h,c){return(0,i.asPromise)(async()=>{const d=this.P(a);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.X(h);return d.provideDebugConfigurations(n,c)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(a,h,c,d){return(0,i.asPromise)(async()=>{const n=this.P(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.X(h);return n.resolveDebugConfiguration(l,c,d)})}$resolveDebugConfigurationWithSubstitutedVariables(a,h,c,d){return(0,i.asPromise)(async()=>{const n=this.P(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.X(h);return n.resolveDebugConfigurationWithSubstitutedVariables(l,c,d)})}async $provideDebugAdapter(a,h){const c=this.O(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.W(h);return this.S(c,d).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.M(n)})}async $acceptDebugSessionStarted(a){const h=await this.W(a);this.m.fire(h)}async $acceptDebugSessionTerminated(a){const h=await this.W(a);h&&(this.n.fire(h),this.l.delete(h.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.W(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,h){(await this.W(a))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(a,h){const d={session:await this.W(a),event:h.event,body:h.body};this.u.fire(d)}M(a){if(a instanceof I.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof I.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const h=this.h.filter(c=>c.type===a);if(h.length>0)return h[0].factory}O(a){const h=this.h.filter(c=>c.handle===a);if(h.length>0)return h[0].factory}P(a){const h=this.f.filter(c=>c.handle===a);if(h.length>0)return h[0].provider}Q(a,h){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const d of c)if(d.label&&d.type&&d.type===h)return!0}}return!1}R(a){const c=a.configuration.type,d=this.j.filter(n=>n.type===c||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(l=>l,l=>null));return Promise.race([Promise.all(d).then(n=>{const l=n.filter(p=>!!p);if(l.length>0)return new b(l)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async S(a,h){const c=h.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new I.DebugAdapterServer(c));if(a){const n=await this.F.getExtensionRegistry();return(0,i.asPromise)(()=>a.createDebugAdapterDescriptor(h,this.T(h,n))).then(l=>{if(l)return l})}const d=await this.F.getExtensionRegistry();return Promise.resolve(this.T(h,d))}T(a,h){}U(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}V(a,h,c){(a.length>0||h.length>0||c.length>0)&&this.A.fire(Object.freeze({added:a,removed:h,changed:c}))}async W(a){if(a)if(typeof a=="string"){const h=this.l.get(a);if(h)return h}else{let h=this.l.get(a.id);if(!h){const c=await this.X(a.folderUri),d=a.parent?this.l.get(a.parent):void 0;h=new g(this.k,a.id,a.type,a.name,c,a.configuration,d),this.l.set(h.id,h),this.k.$sessionCached(h.id)}return h}throw new Error("cannot find session")}X(a){if(a){const h=M.URI.revive(a);return this.E.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};u=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,T.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class g{constructor(a,h,c,d,n,l,p){this.d=a,this.f=h,this.g=c,this.h=d,this.i=n,this.j=l,this.k=p}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,h){return this.d.$customDebugAdapterRequest(this.f,a,h)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=g;class E{constructor(a){this.value=Object.freeze({append(h){a.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=E;class b{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(h=>h.onError?h.onError(a):void 0)}onExit(a,h){this.d.forEach(c=>c.onExit?c.onExit(a,h):void 0)}}class S extends v.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends u{constructor(a,h,c,d,n,l){super(a,h,c,d,n,l)}};s=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,T.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,w.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(De[241],Ce([1,0,11,77,2,5,232,12,61,62,27,152,14,51,33,70]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(E){const b=E.get(R.ILogService),s=E.get(m.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(r=>{b.error(r);const a=i.transformErrorForSerialization(r);s.$onUnexpectedError(a)})}static async installFullHandler(E){const b=E.get(R.ILogService),S=E.get(m.IExtHostRpcService),s=E.get(f.IExtHostExtensionService),r=E.get(t.IExtHostTelemetry),a=S.getProxy(M.MainContext.MainThreadExtensionService),h=S.getProxy(M.MainContext.MainThreadErrors),c=await s.getExtensionPathIndex(),d=new WeakMap;Error.prepareStackTrace=(n,l)=>{let p="",A,L;for(const q of l)p+=`
	at ${q.toString()}`,L=q.getFileName(),!A&&L&&(A=c.findSubstr(y.URI.file(L)));return d.set(n,A?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},i.setUnexpectedErrorHandler(n=>{b.error(n);const l=i.transformErrorForSerialization(n),p=d.get(n);if(!p){h.$onUnexpectedError(l);return}a.$onExtensionRuntimeError(p,l);const A=r.onExtensionError(p,n);b.trace("forwarded error to extension?",A,p)})}}Error.stackTraceLimit=100;class u{constructor(E,b,S,s,r){this.a=S,this.b=new C.RPCProtocol(E,null,s),b=u.e(b,this.b);const a=new T.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());a.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...b,messagePorts:r}),a.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),a.set(v.IURITransformerService,new v.URITransformerService(s)),a.set(f.IHostUtils,S);const h=new I.InstantiationService(a,!0);h.invokeFunction(o.installEarlyHandler),this.d=h.invokeFunction(c=>c.get(R.ILogService)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",b),this.c=h.invokeFunction(c=>c.get(f.IExtHostExtensionService)),this.c.initialize(),h.invokeFunction(o.installFullHandler)}async asBrowserUri(E){const b=this.b.getProxy(M.MainContext.MainThreadExtensionService);return y.URI.revive(await b.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,b){E.allExtensions.forEach(s=>{s.extensionLocation=y.URI.revive(b.transformIncomingURIs(s.extensionLocation));const r={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(a=>r[a]=y.URI.revive(b.transformIncomingURIs(s.browserNlsBundleUris[a]))),s.browserNlsBundleUris=r)}),E.environment.appRoot=y.URI.revive(b.transformIncomingURIs(E.environment.appRoot));const S=E.environment.extensionDevelopmentLocationURI;return S&&(E.environment.extensionDevelopmentLocationURI=S.map(s=>y.URI.revive(b.transformIncomingURIs(s)))),E.environment.extensionTestsLocationURI=y.URI.revive(b.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=y.URI.revive(b.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=y.URI.revive(b.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=y.URI.revive(b.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=y.URI.revive(b.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=y.URI.revive(b.transformIncomingURIs(E.logsLocation)),E.logFile=y.URI.revive(b.transformIncomingURIs(E.logFile)),E.workspace=b.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=u}),define(De[242],Ce([1,0,16,15,20,45,13,19,22,2,44]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(g,E,b,S){this.d=g,this.e=E,this.f=b,this.g=S,this.a=null,this.b=!1,this.c=0}search(g,E){const b=this.d.folderQueries||[],S=new y.CancellationTokenSource;return E.onCancellationRequested(()=>S.cancel()),new Promise((s,r)=>{this.a=new v(g);let a=!1;const h=(c,d)=>{if(!a&&!this.b){const n=this.h(c);t(c)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,S.cancel(),c=this.j(c,this.d.maxResults-this.c));const l=this.h(c);this.c+=l,(l>0||!t(c))&&this.a.add(c,d)}};Promise.all(b.map((c,d)=>this.k(c,n=>h(n,d),S.token))).then(c=>{S.dispose(),this.a.flush();const d=c.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||d,messages:(0,i.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},c=>{S.dispose();const d=(0,M.toErrorMessage)(c);r(new Error(d))})})}h(g){return t(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,E){const b=Array.isArray(g.ranges)?g.ranges:[g.ranges],S=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:b.slice(0,E),preview:{matches:S.slice(0,E),text:g.preview.text},uri:g.uri}}async k(g,E,b){const S=new O.QueryGlobTester(this.d,g),s=[],r={report:c=>{if(!this.l(c))return;const d=g.folder.scheme===C.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(w.dirname(c.uri))):void 0,n=w.relativePath(g.folder,c.uri);if(n){const l=S.includedInQuery(n,R.basename(n),d);(0,k.isThenable)(l)?s.push(l.then(p=>{p&&E(c)})):l&&E(c)}}},a=this.n(g),h=await this.e.provideTextSearchResults(m(this.d.contentPattern),a,r,b);return s.length&&await Promise.all(s),h}l(g){if(t(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const E=(0,O.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),b=(0,O.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),S={folder:T.URI.from(g.folder),excludes:b,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return S.usePCRE2=this.d.usePCRE2,S}}e.TextSearchManager=I;function m(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class v{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new o(512,E=>this.g(E))}add(g,E){this.d&&(this.b!==E||!w.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:g.uri,results:[]}),this.d.results.push(f(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=v;function f(u){return t(u)?{preview:{matches:(0,i.mapArrayOrNot)(u.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:u.preview.text},ranges:(0,i.mapArrayOrNot)(u.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function t(u){return!!u.preview}e.extensionResultIsMatch=t;class o{constructor(g,E){this.g=g,this.h=E,this.c=0,this.d=[],this.e=0}addItem(g,E){!g||this.j(g,E)}addItems(g,E){!g||this.k(g,E)}j(g,E){this.d.push(g),this.e+=E,this.l()}k(g,E){this.d=this.d.concat(g),this.e+=E,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(De[106],Ce([1,0,7,5,3,237,14,51,12,2,242]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let I=class{constructor(t,o,u){this.k=t,this.l=o,this.n=u,this.c=this.k.getProxy(k.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(t){return this.l.transformOutgoingScheme(t)}registerTextSearchProvider(t,o){if(this.g.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this.g.add(t);const u=this.d++;return this.e.set(u,o),this.c.$registerTextSearchProvider(u,this.o(t)),(0,i.toDisposable)(()=>{this.g.delete(t),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(t,o){if(this.i.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this.i.add(t);const u=this.d++;return this.h.set(u,o),this.c.$registerFileSearchProvider(u,this.o(t)),(0,i.toDisposable)(()=>{this.i.delete(t),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(t,o,u,g){const E=m(u),b=this.h.get(t);if(b)return this.j.fileSearch(E,b,S=>{this.c.$handleFileMatch(t,o,S.map(s=>s.resource))},g);throw new Error("unknown provider: "+t)}$clearCache(t){return this.j.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,o,u,g){const E=this.e.get(t);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const b=m(u);return this.q(b,E).search(s=>this.c.$handleTextMatch(t,o,s),g)}$enableExtensionHostSearch(){}q(t,o){return new O.TextSearchManager(t,o,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};I=qe([Ve(0,C.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,w.ILogService)],I),e.ExtHostSearch=I;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(v),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>T.URI.revive(t))}}e.reviveQuery=m;function v(f){return{...f,folder:T.URI.revive(f.folder)}}}),define(De[243],Ce([1,0,61,101,31,99,32,38,54,57,103,105,106,75,65,72,100,56,37,74,70,55,213,12,183,104,73]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b,S,s,r,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,i.registerSingleton)(r.ILoggerService,s.ExtHostLoggerService,1),(0,i.registerSingleton)(r.ILogService,a.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,i.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,i.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,i.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,i.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,i.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,i.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,i.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,i.registerSingleton)(b.IExtHostTelemetry,b.ExtHostTelemetry,0),(0,i.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs,0),(0,i.registerSingleton)(h.IExtHostVariableResolverProvider,h.ExtHostVariableResolverProviderService,0)}),define(De[244],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const M=this.a.get(y);return this.a.delete(y),M}}addDragOperationTransfer(y,M){this.a.set(y,M)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,M){this.b.set(y,M)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=i}),define(De[245],Ce([1,0,138,6,22,2,4,7,15,6,9,16,8,20,244,25]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(E,b){if((0,O.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class u{constructor(b,S,s){this.d=b,this.e=S,this.f=s,this.a=new Map,this.b=new f.TreeviewsService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}S.registerArgumentProcessor({processArgument:a=>r(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(h=>r(h)?this.i(h):h):a})}registerTreeDataProvider(b,S,s){const r=this.createTreeView(b,{treeDataProvider:S},s);return{dispose:()=>r.dispose()}}createTreeView(b,S,s){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=S.dragAndDropController?.dropMimeTypes??[],a=S.dragAndDropController?.dragMimeTypes??[],h=!!S.dragAndDropController?.handleDrag,c=!!S.dragAndDropController?.handleDrop,d=this.h(b,S,s),n=this.d.$registerTreeViewDataProvider(b,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:h,hasHandleDrop:c});return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(s,"treeItemCheckbox"),d.onDidChangeCheckboxState},get message(){return d.message},set message(l){d.message=l},get title(){return d.title},set title(l){d.title=l},get description(){return d.description},set description(l){d.description=l},get badge(){return d.badge},set badge(l){l!==void 0&&T.ViewBadge.isViewBadge(l)?d.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(d.badge=void 0)},reveal:(l,p)=>d.reveal(l,p),dispose:async()=>{await n,this.a.delete(b),d.dispose()}}}$getChildren(b,S){const s=this.a.get(b);return s?s.getChildren(S):Promise.reject(new Error((0,i.localize)(0,null,b)))}async $handleDrop(b,S,s,r,a,h,c,d){const n=this.a.get(b);if(!n)return Promise.reject(new Error((0,i.localize)(1,null,b)));const l=m.DataTransfer.toDataTransfer(s,async p=>(await this.d.$resolveDropFileData(b,S,p)).buffer);return c===b&&d&&await this.g(l,n,d,a,h),n.onDrop(l,r,a)}async g(b,S,s,r,a){const h=this.b.removeDragOperationTransfer(a);if(h)(await h)?.forEach((c,d)=>{c&&b.set(d,c)});else if(a&&S.handleDrag){const c=S.handleDrag(s,b,r);this.b.addDragOperationTransfer(a,c),await c}return b}async $handleDrag(b,S,s,r){const a=this.a.get(b);if(!a)return Promise.reject(new Error((0,i.localize)(2,null,b)));const h=await this.g(new k.DataTransfer,a,S,r,s);if(!!h)return m.DataTransfer.toDataTransferDTO(h)}async $hasResolve(b){const S=this.a.get(b);if(!S)throw new Error((0,i.localize)(3,null,b));return S.hasResolve}$resolve(b,S,s){const r=this.a.get(b);if(!r)throw new Error((0,i.localize)(4,null,b));return r.resolveTreeItem(S,s)}$setExpanded(b,S,s){const r=this.a.get(b);if(!r)throw new Error((0,i.localize)(5,null,b));r.setExpanded(S,s)}$setSelection(b,S){const s=this.a.get(b);if(!s)throw new Error((0,i.localize)(6,null,b));s.setSelection(S)}$setFocus(b,S){const s=this.a.get(b);if(!s)throw new Error((0,i.localize)(7,null,b));s.setFocus(S)}$setVisible(b,S){const s=this.a.get(b);if(!s)throw new Error((0,i.localize)(8,null,b));s.setVisible(S)}$changeCheckboxState(b,S){const s=this.a.get(b);if(!s)throw new Error((0,i.localize)(9,null,b));s.setCheckboxState(S)}h(b,S,s){const r=new g(b,S,this.d,this.e.converter,this.f,s);return this.a.set(b,r),r}i(b){const S=this.a.get(b.$treeViewId);return S&&"$treeItemHandle"in b?S.getExtensionElement(b.$treeItemHandle):S&&"$focusedTreeItem"in b&&b.$focusedTreeItem?S.focusedElement:null}}e.ExtHostTreeViews=u;class g extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(b=>this.getExtensionElement(b)).filter(b=>!(0,O.isUndefinedOrNull)(b))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(b,S,s,r,a,h){if(super(),this.D=b,this.F=s,this.G=r,this.H=a,this.I=h,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new v.CancellationTokenSource,h.contributes&&h.contributes.views)for(const n in h.contributes.views)for(const l of h.contributes.views[n])l.id===b&&(this.L=l.name);this.f=S.treeDataProvider,this.g=S.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let c,d;this.B(C.Event.debounce(this.w.event,(n,l)=>(n||(n={message:!1,elements:[]}),l.element!==!1&&(c||(c=new Promise(p=>d=p),this.y=this.y.then(()=>c)),Array.isArray(l.element)?n.elements.push(...l.element):n.elements.push(l.element)),l.message&&(n.message=!0),n),200,!0)(({message:n,elements:l})=>{l.length&&(this.C=this.C.then(()=>{const p=d;return c=null,this.W(l).then(()=>p())})),n&&this.F.$setMessage(this.D,this.J)}))}async getChildren(b){const S=b?this.getExtensionElement(b):void 0;if(b&&!S)return this.H.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let s=this.R(b);return s||(s=await this.S(S)),s?s.map(r=>r.item):void 0}getExtensionElement(b){return this.i.get(b)}reveal(b,S){S=S||{select:!0,focus:!1};const s=(0,O.isUndefinedOrNull)(S.select)?!0:S.select,r=(0,O.isUndefinedOrNull)(S.focus)?!1:S.focus,a=(0,O.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.y.then(()=>this.O(b)).then(h=>this.Q(b,h[h.length-1]).then(c=>this.F.$reveal(this.D,{item:c.item,parentChain:h.map(d=>d.item)},{select:s,focus:r,expand:a})),h=>this.H.error(h)):this.F.$reveal(this.D,void 0,{select:s,focus:r,expand:a})}get message(){return this.J}set message(b){this.J=b,this.w.fire({message:!0,element:!1})}get title(){return this.L}set title(b){this.L=b,this.F.$setTitle(this.D,b,this.M)}get description(){return this.M}set description(b){this.M=b,this.F.$setTitle(this.D,this.L,b)}get badge(){return this.N}set badge(b){this.N?.value===b?.value&&this.N?.tooltip===b?.tooltip||(this.N=m.ViewBadge.from(b),this.F.$setBadge(this.D,b))}setExpanded(b,S){const s=this.getExtensionElement(b);s&&(S?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(b){(0,I.equals)(this.l,b)||(this.l=b,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(b){this.m=b}setVisible(b){b!==this.k&&(this.k=b,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(b){const S=(await Promise.all(b.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);S.forEach(s=>{s.treeItem.checkboxState=s.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}),this.v.fire({items:S.map(s=>[s.extensionItem,s.newState])})}async handleDrag(b,S,s){const r=[];for(const a of b){const h=this.getExtensionElement(a);h&&r.push(h)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,S,s),S}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,S,s){const r=S?this.getExtensionElement(S):void 0;if(!(!r&&S||!this.g?.handleDrop))return(0,w.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,b,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,S){if(!this.f.resolveTreeItem)return;const s=this.i.get(b);if(s){const r=this.j.get(s);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,s,S)??r.extensionItem;return this.fb(a),r.item.tooltip=this.cb(a.tooltip),r.item.command=this.db(r.disposableStore,a.command),r.item}}}O(b){return this.P(b).then(S=>S?this.O(S).then(s=>this.Q(S,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}P(b){const S=this.j.get(b);return S?Promise.resolve(S.parent?this.i.get(S.parent.item.handle):void 0):(0,w.asPromise)(()=>this.f.getParent(b))}Q(b,S){const s=this.j.get(b);return s?Promise.resolve(s):(0,w.asPromise)(()=>this.f.getTreeItem(b)).then(r=>this.ib(b,r,S,!0)).then(r=>this.getChildren(S?S.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const h=this.j.get(a);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}R(b){if(b){let S;if(typeof b=="string"){const s=this.getExtensionElement(b);S=s?this.j.get(s):void 0}else S=b;return S&&S.children||void 0}return this.h}async S(b){this.pb(b);const S=new v.CancellationTokenSource(this.U.token);try{const s=b?this.j.get(b):void 0,r=await this.f.getChildren(b);if(S.token.isCancellationRequested)return;const a=await Promise.all((0,I.coalesce)(r||[]).map(async h=>{const c=await this.f.getTreeItem(h);return c&&!S.token.isCancellationRequested?this.bb(h,c,s):null}));return S.token.isCancellationRequested?void 0:(0,I.coalesce)(a)}finally{S.dispose()}}W(b){if(b.some(s=>!s))return this.U.dispose(!0),this.U=new v.CancellationTokenSource,this.rb(),this.F.$refresh(this.D);{const s=this.X(b);if(s.length)return this.Y(s)}return Promise.resolve(void 0)}X(b){const S=new Set,s=b.map(a=>this.j.get(a));for(const a of s)if(a&&!S.has(a.item.handle)){let h=a;for(;h&&h.parent&&s.findIndex(c=>h&&h.parent&&c&&c.item.handle===h.parent.item.handle)===-1;){const c=this.i.get(h.parent.item.handle);h=c?this.j.get(c):void 0}h&&!h.parent&&S.add(a.item.handle)}const r=[];return S.forEach(a=>{const h=this.i.get(a);if(h){const c=this.j.get(h);c&&(!c.parent||!S.has(c.parent.item.handle))&&r.push(a)}}),r}Y(b){const S={};return Promise.all(b.map(s=>this.ab(s).then(r=>{r&&(S[s]=r.item)}))).then(()=>Object.keys(S).length?this.F.$refresh(this.D,S):void 0)}ab(b){const S=this.getExtensionElement(b);if(S){const s=this.j.get(S);if(s)return this.pb(S),(0,w.asPromise)(()=>this.f.getTreeItem(S)).then(r=>{if(r){const a=this.gb(S,r,s.parent);return this.nb(S,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}bb(b,S,s){const r=this.gb(b,S,s);if(S.id&&this.i.has(r.item.handle))throw new Error((0,i.localize)(10,null,S.id));return this.mb(b,r),this.ob(r,s),r}cb(b){return T.MarkdownString.isMarkdownString(b)?m.MarkdownString.from(b):b}db(b,S){return S?{...this.G.toInternal(S,b),originalId:S.command}:void 0}eb(b){if(!b.checkboxState)return;let S,s;return typeof b.checkboxState=="number"?S=b.checkboxState:(S=b.checkboxState.state,s=b.checkboxState.tooltip),{isChecked:S===T.TreeItemCheckboxState.Checked,tooltip:s}}fb(b){if(!T.TreeItem.isTreeItem(b,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}gb(b,S,s){this.fb(S);const r=new R.DisposableStore,a=this.ib(b,S,s),h=this.jb(S);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:o(S.label,this.I),description:S.description,resourceUri:S.resourceUri,tooltip:this.cb(S.tooltip),command:this.db(r,S.command),contextValue:S.contextValue,icon:h,iconDark:this.kb(S)||h,themeIcon:this.hb(S),collapsibleState:(0,O.isUndefinedOrNull)(S.collapsibleState)?T.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation,checkbox:this.eb(S)},extensionItem:S,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}hb(b){return b.iconPath instanceof T.ThemeIcon?b.iconPath:void 0}ib(b,{id:S,label:s,resourceUri:r},a,h){if(S)return`${g.b}/${S}`;const c=o(s,this.I),d=a?a.item.handle:g.a;let n=c?c.label:r?(0,y.basename)(r):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const l=this.j.has(b)?this.j.get(b).item.handle:void 0,p=this.R(a)||[];let A,L=0;do{if(A=`${d}/${L}:${n}`,h||!this.i.has(A)||l===A)break;L++}while(L<=p.length);return A}jb(b){if(b.iconPath&&!(b.iconPath instanceof T.ThemeIcon))return typeof b.iconPath=="string"||M.URI.isUri(b.iconPath)?this.lb(b.iconPath):this.lb(b.iconPath.light)}kb(b){if(b.iconPath&&!(b.iconPath instanceof T.ThemeIcon)&&b.iconPath.dark)return this.lb(b.iconPath.dark)}lb(b){return M.URI.isUri(b)?b:M.URI.file(b)}mb(b,S){this.i.set(S.item.handle,b),this.j.set(b,S)}nb(b,S,s,r){this.i.delete(S.item.handle),this.j.delete(b),S.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.mb(b,S);const a=this.R(r)||[],h=a.filter(c=>c.item.handle===s.item.handle)[0];h&&a.splice(a.indexOf(h),1,S)}ob(b,S){S?(S.children||(S.children=[]),S.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}pb(b){if(b){const S=this.j.get(b);if(S){if(S.children)for(const s of S.children){const r=this.i.get(s.item.handle);r&&this.qb(r)}S.children=void 0}}else this.rb()}qb(b){const S=this.j.get(b);if(S){if(S.children)for(const s of S.children){const r=this.i.get(s.item.handle);r&&this.qb(r)}this.j.delete(b),this.i.delete(S.item.handle),S.dispose()}}rb(){this.h=void 0,this.i.clear(),this.j.forEach(b=>b.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.rb(),this.F.$disposeTree(this.D)}}g.a="0",g.b="1"}),define(De[246],Ce([1,0,20,11,4,29,2,125,255,113,123,36,5,69,198,197,38,199,32,201,202,203,186,204,54,33,206,207,210,212,214,101,189,219,220,221,75,57,224,245,8,6,91,227,58,100,31,176,209,63,99,103,105,106,12,51,14,27,215,184,65,72,195,225,76,56,230,228,229,196,37,222,226,74,55,70,216,102,217,13,87,188,167,208,7,25,171,73,164,218]),function(te,e,i,k,y,M,C,R,w,T,O,I,m,v,f,t,o,u,g,E,b,S,s,r,a,h,c,d,n,l,p,A,L,q,K,j,P,N,F,$,z,V,X,ee,fe,oe,ue,ce,he,Y,ge,Se,Fe,ze,_e,ke,Ie,Te,re,ae,J,D,B,H,G,Z,le,be,se,we,ve,$e,He,et,xe,tt,nt,dt,Le,ot,Q,_,pe,Me,Be,je,Ye,it,bt,Dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function kt(lt){const at=lt.get(Te.IExtHostInitDataService),Bt=lt.get(ve.IExtHostFileSystemInfo),Rt=lt.get(Z.IExtHostConsumerFileSystem),Mt=lt.get(h.IExtHostExtensionService),ft=lt.get(ue.IExtHostWorkspace),St=lt.get(tt.IExtHostTelemetry),Pt=lt.get(g.IExtHostConfiguration),Nt=lt.get(ke.IURITransformerService),Ge=lt.get(Ie.IExtHostRpcService),Ot=lt.get(P.IExtHostStorage),Vt=lt.get(G.IExtensionStoragePaths),qt=lt.get(_e.ILoggerService),mt=lt.get(_e.ILogService),Ct=lt.get(J.IExtHostTunnelService),ye=lt.get(D.IExtHostApiDeprecationService),Pe=lt.get(oe.IExtHostWindow),me=lt.get(et.IExtHostSecretState),x=lt.get(xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Bt),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,qt),Ge.set(m.ExtHostContext.ExtHostWorkspace,ft),Ge.set(m.ExtHostContext.ExtHostConfiguration,Pt),Ge.set(m.ExtHostContext.ExtHostExtensionService,Mt),Ge.set(m.ExtHostContext.ExtHostStorage,Ot),Ge.set(m.ExtHostContext.ExtHostTunnelService,Ct),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,me),Ge.set(m.ExtHostContext.ExtHostTelemetry,St),Ge.set(m.ExtHostContext.ExtHostEditorTabs,x);const Ae=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(ge.IExtHostDecorations)),Ne=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(a.IExtHostDocumentsAndEditors)),Xe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(o.IExtHostCommands)),We=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get(N.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Fe.IExtHostDebugService)),yt=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(ze.IExtHostSearch)),pt=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(Se.IExtHostTask)),At=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(A.IExtHostOutputService)),Et=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(it.IExtHostLocalizationService)),wt=Ge.set(m.ExtHostContext.ExtHostUrls,new ee.ExtHostUrls(Ge)),ht=Ge.set(m.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Ge,Ne)),$t=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new S.ExtHostDocumentContentProvider(Ge,Ne,mt)),Jt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(mt,ht,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),vt=Ge.set(m.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(Ge,Xe,Ne,ht)),xt=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(vt)),ai=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new _.ExtHostNotebookEditors(mt,vt)),Ut=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new nt.ExtHostNotebookKernels(Ge,at,vt,Xe,mt)),gi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(Ge,vt)),Ft=Ge.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ge,Ne)),ci=Ge.set(m.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Xe,mt)),Zt=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),Ft,at.remote)),ei=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,mt,Bt,Ne)),ti=Ge.set(m.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Ge,ht,Xe.converter,Nt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ge,Nt,ht,Xe,ei,mt,ye,St)),pi=Ge.set(m.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ge,ct)),Kt=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Ge,mt,Ne)),_t=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(Ge,ft,Xe)),ui=Ge.set(m.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(Ge,Xe,mt)),vi=Ge.set(m.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ge,Xe,ht)),Ci=Ge.set(m.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),bi=Ge.set(m.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(Ge)),li=Ge.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ge)),ii=Ge.set(m.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ge)),Ei=Ge.set(m.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ge,Xe)),wi=Ge.set(m.ExtHostContext.ExtHostWebviews,new fe.ExtHostWebviews(Ge,at.remote,ft,mt,ye)),ni=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new se.ExtHostWebviewPanels(Ge,wi,ft)),Si=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new be.ExtHostCustomEditors(Ge,ht,Vt,wi,ni)),Oi=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new le.ExtHostWebviewViews(Ge,wi)),ri=Ge.set(m.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ge,Xe,Ne)),Fi=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Li=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new Dt.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,vt,Ne,Xe,mt));const Mi=Object.values(m.ExtHostContext);Ge.assertRegistered(Mi);const Ni=new we.ExtHostBulkEdits(Ge,Ne),yi=new t.ExtHostClipboard(Ge),si=new p.ExtHostMessageService(Ge,mt),ki=new b.ExtHostDialogs(Ge),Ti=new j.ExtHostStatusBar(Ge,Xe.converter);return f.ExtHostApiCommands.register(Xe),function(Ue,zt,Pi){const gt=function(){let ne=!Ue.isUnderDevelopment;function de(){ne||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")de();else{const It=rt;typeof It.scheme>"u"&&de(),typeof It.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),Ui={getSession(ne,de,Oe){return ii.getSession(Ue,ne,de,Oe)},async hasSession(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ne,de,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ne,de,Oe,rt){return ii.registerAuthenticationProvider(ne,de,Oe,rt)}},Bi={registerCommand(ne,de,Oe){return Xe.registerCommand(!0,ne,de,Oe,void 0,Ue)},registerTextEditorCommand(ne,de,Oe){return Xe.registerCommand(!0,ne,(...rt)=>{const It=Ft.getActiveTextEditor();if(!It){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return It.edit(Tt=>{de.apply(Oe,[It,Tt,...rt])}).then(Tt=>{Tt||mt.warn("Edits from command "+ne+" were not applied.")},Tt=>{mt.warn("An error occurred while running command "+ne,Tt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,de,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Xe.registerCommand(!0,ne,async(...rt)=>{const It=Ne.activeEditor(!0);if(!It){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(It.id);de.apply(Oe,[Tt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...de){return Xe.executeCommand(ne,...de)},getCommands(ne=!1){return Xe.getCommands(ne)}},di={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return We.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),We.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),St.instantiateLogger(Ue,ne)},openExternal(ne,de){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return wt.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(de){if((0,Q.matchesScheme)(ne,ot.Schemas.http)||(0,Q.matchesScheme)(ne,ot.Schemas.https))return ne;throw de}},get remoteName(){return(0,Y.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(di);const $i={createTestController(ne,de,Oe){return ri.createTestController(ne,de,Oe)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},Wt=at.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,hi={getExtension(ne,de){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(de=!1);const Oe=zt.mine.getExtensionDescription(ne);if(Oe)return new h.Extension(Mt,Ue.identifier,Oe,Wt,!1);if(de){const rt=zt.all.getExtensionDescription(ne);if(rt)return new h.Extension(Mt,Ue.identifier,rt,Wt,!0)}},get all(){const ne=[];for(const de of zt.mine.getAllExtensionDescriptions())ne.push(new h.Extension(Mt,Ue.identifier,de,Wt,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(zt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),de=[];for(const Oe of zt.all.getAllExtensionDescriptions()){const rt=!ne.has(Oe.identifier);de.push(new h.Extension(Mt,Ue.identifier,Oe,Wt,rt))}return de},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(zt.mine.onDidChange,zt.all.onDidChange):zt.mine.onDidChange}},zi={createDiagnosticCollection(ne){return ei.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:ne=>ei.getDiagnostics(ne),getLanguages(){return ti.getLanguages()},setTextDocumentLanguage(ne,de){return ti.changeLanguage(ne.uri,de)},match(ne,de){const Oe=ht.getDocumentData(de.uri)?.notebook;return(0,O.score)(z.LanguageSelector.from(ne),de.uri,de.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,de,Oe){return ct.registerCodeActionProvider(Ue,gt(ne),de,Oe)},registerDocumentPasteEditProvider(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,gt(ne),de,Oe)},registerCodeLensProvider(ne,de){return ct.registerCodeLensProvider(Ue,gt(ne),de)},registerDefinitionProvider(ne,de){return ct.registerDefinitionProvider(Ue,gt(ne),de)},registerDeclarationProvider(ne,de){return ct.registerDeclarationProvider(Ue,gt(ne),de)},registerImplementationProvider(ne,de){return ct.registerImplementationProvider(Ue,gt(ne),de)},registerTypeDefinitionProvider(ne,de){return ct.registerTypeDefinitionProvider(Ue,gt(ne),de)},registerHoverProvider(ne,de){return ct.registerHoverProvider(Ue,gt(ne),de,Ue.identifier)},registerEvaluatableExpressionProvider(ne,de){return ct.registerEvaluatableExpressionProvider(Ue,gt(ne),de,Ue.identifier)},registerInlineValuesProvider(ne,de){return ct.registerInlineValuesProvider(Ue,gt(ne),de,Ue.identifier)},registerDocumentHighlightProvider(ne,de){return ct.registerDocumentHighlightProvider(Ue,gt(ne),de)},registerLinkedEditingRangeProvider(ne,de){return ct.registerLinkedEditingRangeProvider(Ue,gt(ne),de)},registerReferenceProvider(ne,de){return ct.registerReferenceProvider(Ue,gt(ne),de)},registerRenameProvider(ne,de){return ct.registerRenameProvider(Ue,gt(ne),de)},registerDocumentSymbolProvider(ne,de,Oe){return ct.registerDocumentSymbolProvider(Ue,gt(ne),de,Oe)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,de){return ct.registerDocumentFormattingEditProvider(Ue,gt(ne),de)},registerDocumentRangeFormattingEditProvider(ne,de){return ct.registerDocumentRangeFormattingEditProvider(Ue,gt(ne),de)},registerOnTypeFormattingEditProvider(ne,de,Oe,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,gt(ne),de,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(ne,de,Oe){return ct.registerDocumentSemanticTokensProvider(Ue,gt(ne),de,Oe)},registerDocumentRangeSemanticTokensProvider(ne,de,Oe){return ct.registerDocumentRangeSemanticTokensProvider(Ue,gt(ne),de,Oe)},registerSignatureHelpProvider(ne,de,Oe,...rt){return typeof Oe=="object"?ct.registerSignatureHelpProvider(Ue,gt(ne),de,Oe):ct.registerSignatureHelpProvider(Ue,gt(ne),de,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(ne,de,...Oe){return ct.registerCompletionItemProvider(Ue,gt(ne),de,Oe)},registerInlineCompletionItemProvider(ne,de){return de.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,gt(ne),de)},registerDocumentLinkProvider(ne,de){return ct.registerDocumentLinkProvider(Ue,gt(ne),de)},registerColorProvider(ne,de){return ct.registerColorProvider(Ue,gt(ne),de)},registerFoldingRangeProvider(ne,de){return ct.registerFoldingRangeProvider(Ue,gt(ne),de)},registerSelectionRangeProvider(ne,de){return ct.registerSelectionRangeProvider(Ue,ne,de)},registerCallHierarchyProvider(ne,de){return ct.registerCallHierarchyProvider(Ue,ne,de)},registerTypeHierarchyProvider(ne,de){return ct.registerTypeHierarchyProvider(Ue,ne,de)},setLanguageConfiguration:(ne,de)=>ct.setLanguageConfiguration(Ue,ne,de),getTokenInformationAtPosition(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),ti.tokenAtPosition(ne,de)},registerInlayHintsProvider(ne,de){return ct.registerInlayHintsProvider(Ue,ne,de)},createLanguageStatusItem(ne,de){return ti.createLanguageStatusItem(Ue,ne,de)},registerDocumentDropEditProvider(ne,de){return ct.registerDocumentOnDropEditProvider(Ue,ne,de)}},Ht={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return We.activeTerminal},get terminals(){return We.terminals},async showTextDocument(ne,de,Oe){const rt=await(C.URI.isUri(ne)?Promise.resolve(oi.openTextDocument(ne)):Promise.resolve(ne));return Ft.showTextDocument(rt,de,Oe)},createTextEditorDecorationType(ne){return Ft.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,de,Oe){return Ft.onDidChangeActiveTextEditor(ne,de,Oe)},onDidChangeVisibleTextEditors(ne,de,Oe){return Ft.onDidChangeVisibleTextEditors(ne,de,Oe)},onDidChangeTextEditorSelection(ne,de,Oe){return Ft.onDidChangeTextEditorSelection(ne,de,Oe)},onDidChangeTextEditorOptions(ne,de,Oe){return Ft.onDidChangeTextEditorOptions(ne,de,Oe)},onDidChangeTextEditorVisibleRanges(ne,de,Oe){return Ft.onDidChangeTextEditorVisibleRanges(ne,de,Oe)},onDidChangeTextEditorViewColumn(ne,de,Oe){return Ft.onDidChangeTextEditorViewColumn(ne,de,Oe)},onDidCloseTerminal(ne,de,Oe){return We.onDidCloseTerminal(ne,de,Oe)},onDidOpenTerminal(ne,de,Oe){return We.onDidOpenTerminal(ne,de,Oe)},onDidChangeActiveTerminal(ne,de,Oe){return We.onDidChangeActiveTerminal(ne,de,Oe)},onDidChangeTerminalDimensions(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),We.onDidChangeTerminalDimensions(ne,de,Oe)},onDidChangeTerminalState(ne,de,Oe){return We.onDidChangeTerminalState(ne,de,Oe)},onDidWriteTerminalData(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),We.onDidWriteTerminalData(ne,de,Oe)},get state(){return Pe.state},onDidChangeWindowState(ne,de,Oe){return Pe.onDidChangeWindowState(ne,de,Oe)},showInformationMessage(ne,...de){return si.showMessage(Ue,M.default.Info,ne,de[0],de.slice(1))},showWarningMessage(ne,...de){return si.showMessage(Ue,M.default.Warning,ne,de[0],de.slice(1))},showErrorMessage(ne,...de){return si.showMessage(Ue,M.default.Error,ne,de[0],de.slice(1))},showQuickPick(ne,de,Oe){return _t.showQuickPick(ne,de,Oe)},showWorkspaceFolderPick(ne){return _t.showWorkspaceFolderPick(ne)},showInputBox(ne,de){return _t.showInput(ne,de)},showOpenDialog(ne){return ki.showOpenDialog(ne)},showSaveDialog(ne){return ki.showSaveDialog(ne)},createStatusBarItem(ne,de,Oe){let rt,It,Tt;return typeof ne=="string"?(rt=ne,It=de,Tt=Oe):(It=ne,Tt=de),Ti.createStatusBarEntry(Ue,rt,It,Tt)},setStatusBarMessage(ne,de){return Ti.setStatusBarMessage(ne,de)},withScmProgress(ne){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ci.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(de,Oe)=>ne({report(rt){}}))},withProgress(ne,de){return Ci.withProgress(Ue,ne,de)},createOutputChannel(ne,de){return At.createOutputChannel(ne,de,Ue)},createWebviewPanel(ne,de,Oe,rt){return ni.createWebviewPanel(Ue,ne,de,Oe,rt)},createWebviewTextEditorInset(ne,de,Oe,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),Zt.createWebviewEditorInset(ne,de,Oe,rt,Ue)},createTerminal(ne,de,Oe){return typeof ne=="object"?"pty"in ne?We.createExtensionTerminal(ne):We.createTerminalFromOptions(ne):We.createTerminal(ne,de,Oe)},registerTerminalLinkProvider(ne){return We.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,de){return We.registerProfileProvider(Ue,ne,de)},registerTreeDataProvider(ne,de){return ci.registerTreeDataProvider(ne,de,Ue)},createTreeView(ne,de){return ci.createTreeView(ne,de,Ue)},registerWebviewPanelSerializer:(ne,de)=>ni.registerWebviewPanelSerializer(Ue,ne,de),registerCustomEditorProvider:(ne,de,Oe={})=>Si.registerCustomEditorProvider(Ue,ne,de,Oe),registerFileDecorationProvider(ne){return Ae.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return wt.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return _t.createQuickPick(Ue)},createInputBox(){return _t.createInputBox(Ue)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(ne,de,Oe){return li.onDidChangeActiveColorTheme(ne,de,Oe)},registerWebviewViewProvider(ne,de,Oe){return Oi.registerWebviewViewProvider(Ue,ne,de,Oe?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,de,Oe){return vt.onDidChangeActiveNotebookEditor(ne,de,Oe)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,de,Oe){return ai.onDidChangeNotebookEditorSelection(ne,de,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,de,Oe){return ai.onDidChangeNotebookEditorVisibleRanges(ne,de,Oe)},showNotebookDocument(ne,de){return vt.showNotebookDocument(ne,de)},registerExternalUriOpener(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Fi.registerExternalUriOpener(Ue.identifier,ne,de,Oe)},registerProfileContentHandler(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Li.registrProfileContentHandler(Ue,ne,de)},get tabGroups(){return x.tabGroups}},oi={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw k.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw k.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw k.readonly()},updateWorkspaceFolders:(ne,de,...Oe)=>ft.updateWorkspaceFolders(Ue,ne,de||0,...Oe),onDidChangeWorkspaceFolders:function(ne,de,Oe){return ft.onDidChangeWorkspace(ne,de,Oe)},asRelativePath:(ne,de)=>ft.getRelativePath(ne,de),findFiles:(ne,de,Oe,rt)=>ft.findFiles(ne,de,Oe,Ue.identifier,rt),findTextInFiles:(ne,de,Oe,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let It,Tt;return typeof de=="object"?(It=de,Tt=Oe):(It={},Tt=de,rt=Oe),ft.findTextInFiles(ne,It||{},Tt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,de){return Ni.applyWorkspaceEdit(ne,Ue,de)},createFileSystemWatcher:(ne,de,Oe,rt)=>Kt.createFileSystemWatcher(ft,Ue,ne,de,Oe,rt),get textDocuments(){return ht.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw k.readonly()},openTextDocument(ne){let de;const Oe=ne;if(typeof ne=="string")de=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))de=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")de=ht.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>ht.ensureDocumentData(rt).then(It=>It.document))},onDidOpenTextDocument:(ne,de,Oe)=>ht.onDidAddDocument(ne,de,Oe),onDidCloseTextDocument:(ne,de,Oe)=>ht.onDidRemoveDocument(ne,de,Oe),onDidChangeTextDocument:(ne,de,Oe)=>ht.onDidChangeDocument(ne,de,Oe),onDidSaveTextDocument:(ne,de,Oe)=>ht.onDidSaveDocument(ne,de,Oe),onWillSaveTextDocument:(ne,de,Oe)=>Jt.getOnWillSaveTextDocumentEvent(Ue)(ne,de,Oe),get notebookDocuments(){return vt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,de){let Oe;if(C.URI.isUri(ne))Oe=ne,await vt.openNotebookDocument(ne);else if(typeof ne=="string")Oe=C.URI.revive(await vt.createNotebookDocument({viewType:ne,content:de}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,de,Oe){return xt.onDidSaveNotebookDocument(ne,de,Oe)},onDidChangeNotebookDocument(ne,de,Oe){return xt.onDidChangeNotebookDocument(ne,de,Oe)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,de,Oe,rt){return vt.registerNotebookSerializer(Ue,ne,de,Oe,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,de,Oe)=>Pi.onDidChangeConfiguration(ne,de,Oe),getConfiguration(ne,de){return de=arguments.length===1?void 0:de,Pi.getConfiguration(ne,de,Ue)},registerTextDocumentContentProvider(ne,de){return $t.registerTextDocumentContentProvider(ne,de)},registerTaskProvider:(ne,de)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Ue,ne,de)),registerFileSystemProvider(ne,de,Oe){return(0,Be.combinedDisposable)(pi.registerFileSystemProvider(Ue,ne,de,Oe),Rt.addFileSystemProvider(ne,de))},get fs(){return Rt.value},registerFileSearchProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),yt.registerFileSearchProvider(ne,de)),registerTextSearchProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),yt.registerTextSearchProvider(ne,de)),registerRemoteAuthorityResolver:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Mt.registerRemoteAuthorityResolver(ne,de)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),bi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,de,Oe)=>Kt.onDidCreateFile(ne,de,Oe),onDidDeleteFiles:(ne,de,Oe)=>Kt.onDidDeleteFile(ne,de,Oe),onDidRenameFiles:(ne,de,Oe)=>Kt.onDidRenameFile(ne,de,Oe),onWillCreateFiles:(ne,de,Oe)=>Kt.getOnWillCreateFileEvent(Ue)(ne,de,Oe),onWillDeleteFiles:(ne,de,Oe)=>Kt.getOnWillDeleteFileEvent(Ue)(ne,de,Oe),onWillRenameFiles:(ne,de,Oe)=>Kt.getOnWillRenameFileEvent(Ue)(ne,de,Oe),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),Ct.openTunnel(Ue,ne).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),Ct.getTunnels()},onDidChangeTunnels:(ne,de,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),Ct.onDidChangeTunnels(ne,de,Oe)),registerPortAttributesProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),Ct.registerPortsAttributesProvider(ne,de)),registerTimelineProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),Ei.registerTimelineProvider(ne,de,Ue.identifier,Xe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,de,Oe)=>ft.onDidGrantWorkspaceTrust(ne,de,Oe),registerEditSessionIdentityProvider:(ne,de)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,de))},Wi={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ui.getLastInputBox(Ue)},createSourceControl(ne,de,Oe){return ui.createSourceControl(Ue,ne,de,Oe)}},Hi={createCommentController(ne,de){return vi.createCommentController(Ue,ne,de)}},Vi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,de,Oe){return Ze.onDidStartDebugSession(ne,de,Oe)},onDidTerminateDebugSession(ne,de,Oe){return Ze.onDidTerminateDebugSession(ne,de,Oe)},onDidChangeActiveDebugSession(ne,de,Oe){return Ze.onDidChangeActiveDebugSession(ne,de,Oe)},onDidReceiveDebugSessionCustomEvent(ne,de,Oe){return Ze.onDidReceiveDebugSessionCustomEvent(ne,de,Oe)},onDidChangeBreakpoints(ne,de,Oe){return Ze.onDidChangeBreakpoints(ne,de,Oe)},registerDebugConfigurationProvider(ne,de,Oe){return Ze.registerDebugConfigurationProvider(ne,de,Oe||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,de){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,de)},registerDebugAdapterTrackerFactory(ne,de){return Ze.registerDebugAdapterTrackerFactory(ne,de)},startDebugging(ne,de,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Ze.startDebugging(ne,de,{parentSession:Oe}):Ze.startDebugging(ne,de,Oe||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,de){return Ze.asDebugSourceUri(ne,de)}},ji={registerTaskProvider:(ne,de)=>pt.registerTaskProvider(Ue,ne,de),fetchTasks:ne=>pt.fetchTasks(ne),executeTask:ne=>pt.executeTask(Ue,ne),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(ne,de,Oe)=>pt.onDidStartTask(ne,de,Oe),onDidEndTask:(ne,de,Oe)=>pt.onDidEndTask(ne,de,Oe),onDidStartTaskProcess:(ne,de,Oe)=>pt.onDidStartTaskProcess(ne,de,Oe),onDidEndTaskProcess:(ne,de,Oe)=>pt.onDidEndTaskProcess(ne,de,Oe)},qi={createNotebookController(ne,de,Oe,rt,It){return Ut.createNotebookController(Ue,ne,de,Oe,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ne,de)=>vt.registerNotebookCellStatusBarItemProvider(Ue,ne,de),createRendererMessaging(ne){return gi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Ut.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,de){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Ut.registerKernelSourceActionProvider(Ue,ne,de)},onDidChangeNotebookCellExecutionState(ne,de,Oe){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Ut.onDidChangeNotebookCellExecutionState(ne,de,Oe)}},Ki={t(...ne){if(typeof ne[0]=="string"){const de=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return Et.getMessage(Ue.identifier.value,{message:de,args:Oe})}return Et.getMessage(Ue.identifier.value,ne[0])},get bundle(){return Et.getBundle(Ue.identifier.value)},get uri(){return Et.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:Ui,commands:Bi,comments:Hi,debug:Vi,env:di,extensions:hi,l10n:Ki,languages:zi,notebooks:qi,scm:Wi,tasks:ji,tests:$i,window:Ht,workspace:oi,Breakpoint:V.Breakpoint,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:T.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:v.UIKind,Uri:C.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:X.TrustedTelemetryValue,TerminalExitReason:V.TerminalExitReason,LogLevel:_e.LogLevel,EditSessionIdentityMatch:bt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=kt}),define(De[247],Ce([1,0,246,33,2,240,6,15,231]),function(te,e,i,k,y,M,C,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends M.RequireInterceptor{j(){}getModule(v,f){for(const t of this.b){const o=t(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(w.ExtHostConsoleForwarder);const v=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(T,v,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(v){return v.browser}async rb(v,f,t){f=f.with({path:I(f.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const u=y.URI.revive(await this.v.$asBrowserUri(f)),g=await fetch(u.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),g.status!==200)throw new Error(g.statusText);const E=await g.text(),b=`${f.toString(!0)}#vscode-extension`,S=`${E}
//# sourceURL=${b}`;let s;try{s=new Function("module","exports","require",S)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${f.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}v&&await this.s.initializeLocalizedMessages(v);const r={},a={exports:r},h=c=>{const d=this.r.getModule(c,f);if(d===void 0)throw new Error(`Cannot load module '${c}'`);return d};try{return t.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),s(a,r,h),a.exports!==r?a.exports:r}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),t.codeLoadingStop()}}async $setRemoteEnvironment(v){}async vb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+v;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=O;function I(m,v){return m.endsWith(v)?m:m+v}}),define(De[248],Ce([1,0,61,33,76,247]),function(te,e,i,k,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(k.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,i.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(De[256],Ce([1,0,24,4,69,241,233,19,77,13,2,243,248]),function(te,e,i,k,y,M,C,R,w,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const I=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(s){return/^(file|vscode-remote):/i.test(s)}const f=fetch.bind(self);function t(s){self.fetch=async function(r,a){return r instanceof Request||v(String(r))&&(r=(await s(O.URI.parse(String(r)))).toString(!0)),f(r,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,a,h,c,d){(async()=>(v(a.toString())&&(a=(await s(O.URI.parse(a.toString()))).toString(!0)),super.open(r,a,h??!0,c,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(r,a){if(/^file:/i.test(r.toString()))r=T.FileAccess.uriToBrowserUri(O.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(p){function A(K){return typeof K=="string"||K instanceof URL?String(K).replace(/^file:\/\//i,"vscode-file://vscode-app"):K}const L=fetch.bind(self);self.fetch=function(K,j){return K instanceof Request?L(K,j):L(A(K),j)},self.XMLHttpRequest=class extends XMLHttpRequest{open(K,j,P,N,F){return super.open(K,A(j),P??!0,N,F)}};const q=importScripts.bind(self);self.importScripts=(...K)=>{q(...K.map(A))},q(p)}.toString()}('${r}'))`;a=a||{},a.name=a.name||R.basename(r.toString());const d=new Blob([c],{type:"application/javascript"}),n=URL.createObjectURL(d);return new s(n,a)}}else self.Worker=class extends C.NestedWorker{constructor(s,r){super(m,s,{name:R.basename(s.toString()),...r})}};const o=new class{constructor(){this.pid=void 0}exit(s){I()}async exists(s){return!0}async realpath(s){return s}};class u{constructor(){const r=new MessageChannel,a=new k.Emitter;let h=!1;m(r.port2,[r.port2]),r.port1.onmessage=c=>{const{data:d}=c;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const n=i.VSBuffer.wrap(new Uint8Array(d,0,d.byteLength));if((0,y.isMessageOfType)(n,2)){h=!0,E("received terminate message from renderer");return}a.fire(n)},this.protocol={onMessage:a.event,send:c=>{if(!h){const d=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);r.port1.postMessage(d,[d])}}}}}function g(s){return new Promise(r=>{const a=s.onMessage(h=>{a.dispose();const c=JSON.parse(h.toString());s.send((0,y.createMessageOfType)(0)),r({protocol:s,initData:c})});s.send((0,y.createMessageOfType)(1))})}let E=s=>I();function b(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function S(){w.mark("code/extHost/willConnectToRenderer");const s=new u;return{onmessage(r){!b(r)||g(s.protocol).then(a=>{w.mark("code/extHost/didWaitForInitData");const h=new M.ExtensionHostMain(a.protocol,a.initData,o,null,r.data);t(c=>h.asBrowserUri(c)),E=c=>h.terminate(c)})}}}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58e7c7b8865e3c3ea77055461ffb5d656a7a46af/core/vs/workbench/api/worker/extensionHostWorker.js.map
